// =============================================
// Program Name: DEEP 97
// Copyright (c) 1997
// Update for WIN32:
// =============================================

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "Deep.h" 						   // Original Dos Header File
#include "windeep.h"						   // Windows Specific Header File
#pragma  hdrstop

//#include "hdump.h"
#include <commctrl.h>						// For Status Bar
#include <commdlg.h>                   // file open projects
// file locking-----------
#include <io.h>           // sopen
#include <fcntl.h>        // RDONLY, etc defs
#include <sys\stat.h>     // S_IREAD
#include <share.h>        //SH_DENYNO
//--------------------------

        char    DeePVersion[128];      // filled in by szLoadString
static  LPCTSTR DeePId = DeePVersion;  //   1-23-97 << modify in DEEP.RC for each version  ="DeeP97 v9.04";


//#pragma warning (disable : 4100)
//#pragma warning (disable : 4068)

// The following 3 function pointers are used to point to the current
// mouse handling functons.  Different drawing types can each define a
// set of mouse functions.  When a new drawing mode is selected, these
// pointers are set to point to the correct functions for that mode.
// The main mouse message handlers then dereference these pointers to
// call the correct handlers.


//2-20-97 bk  Our Resource Handles for Button.wav
// a loaded resource. A wave file to play when clicking on buttons +other stuff

HRSRC   hRsc;
HGLOBAL hSoundWave       [10]= {0};
LPCSTR  SoundWaveResource[10]= {0};

int2 VertexSize 		= 4;					// Default size of Vertex for now
int2 Thingsize   		= 1;					// magnification of things - now set in Vertex routine

int4 ScrCenterX;
int4 ScrCenterY;
int4 ScrMaxX;
int4 ScrMaxY;
int4 OrigX;
int4 OrigY;

static int        LockHandle=-1;      // if locking file is found (DEEP.CHK)

static HINSTANCE 	hInstance;		     // Our global Instance of this Application
static AlreadyActive = FALSE;         //   1-23-97

static Bool NotBeenHere   = TRUE;     // to tell user
       int4 BackUpNumber  = 0;        // number of backups done
       int  AutoSaveTimer = 0;        // AutoSave Timer   8-1-97 moved so can be reset
       UINT DeepTimer     = 1;	     // Our timer for timer sensitve things

       Bool BackupActive  = FALSE;    // trying to see what is making seek error happen

//     UINT DeepSaveTimer = 2;			// AutoSave Every time this timer hits don't need

#define TIMERSECOND  1000             // 1 second    12-18-96
#define TIMERMINUTE  1000*60          // 1 minute

//#define TIMERMINUTE  1000*2          // 2 seconds testing ONLY

Bool Selecting    = FALSE;             // Currently Drawing a SelectBox ?
Bool MaxConstrain = FALSE;  	      	// Window Maximized and Cursor constrained for easy Mouse Movement moved here   12-13-96

Bool MoveCursor 			= FALSE;			// Is the cursor a MoveMap Cursor ?
Bool MouseConstrained	= FALSE;			// Is our mouse constrained to our window (triggered by MaxConstrain)

Bool MapCoords				=  TRUE;			// if x,y is in map coords or screen coords
Bool Browsing				=  FALSE;		// Are we browsing in a Map Mode, Texture Mode etc.
BOOL FirstTimeRun 	 	=	FALSE;		// First Time program being used

volatile Bool AutoSaveStop =  FALSE;	// control autosave   12-20-96 replaces Editing
volatile Bool SavingDataNow=  FALSE;   // safety lockout dual saves  and global stop via function
volatile int  ScreenSaverTimer = 0;    // ScreenSaver Timer

static   int2 BkpOldNumChanges = 0;    // check for auto backup
static   int2 ShrOldNumChanges = 0;    // check for shareware

Bool advanceInput       =  FALSE;		// Advance input for start of level

Bool AllSprites 			=  FALSE;		// Display All the Sprites in the SpriteBrowser
Bool DisplayPalette     =  FALSE;      // NEED a new key for this one !!

HBITMAP 		hVertexBmp;						// Scaled Vertex Bitmap
HBITMAP 		hMemBmp 		= NULL;
//HBITMAP 	hSaveBmp 	= NULL;        // global save screen only ONE can be used this way so made var
HACCEL		hAccel;							// from WinMain our DeepKeys Accelerator

char NoTexture[8]= "-\0\0\0\0\0\0\0";      // default "-"

GLOBALDATA 	gd 			= {0}; 			//global data, handles, DC's etc

//----------local funcs---------------------------------------------------------

static void Deep_OnDestroy(HWND hwnd);


//-------------------------------------------------------------------------//
//         global variables     from DOS DeeP + new ones
//-------------------------------------------------------------------------//
int4 MAPDirCount    = 12;           // 11 or 12 depending on HEXEN
int4 GameVersion    = 1;            // 1=DOOM, 2=DOOMII, 3=HERETIC, 4=HEXEN
int4 QuakeMode      = 1;            // 1 = QUAKE, 2 = HEXEN2
				    							// 5 = STRIFE, 6 = DUKE, 7=QUAKE
int4 oldGameVersion = 0;
int4 oldlastXloc;
int4 oldlastYloc;
int2 oldEpisode;
int2 oldMission;

Bool BatchFlag      = FALSE;        // must be TRUE start from batch file

//----------  checkpoint file ------------------------------------------------
int4 align1=1;                      // alignment only

char  CHKDeepHeader[4]  = "xCHK";   // header
int2  CHKDeepControl    = 0x9772;   // id for myself
int2  CHKDeepControlSize= 1270;     //   +2 pick up 'e' +2 3-1-96
int4  CHKChecksum       =  0;       // checksum to do...  // could do safety?
int2  CHKRegCounter     =  0;       // register  counter  // firstime
int2  CHKShareCounter   =  0;       // shareware counter
int4  CHKInUse          =  0;       // 1 = in use, safety   11-3-96

// this forces alignment
int4  fillerobs1     =   0 ;        // old timer, na
float ZoomScaleHigh  = 6.000;       // Zoom High scale value        was  2   8-1-97
float ZoomScaleLow   = 0.125;       // Zoom Low  scale value (1/8)
float ScaleHigh      = 8.000;       // + High scale value           was  4   8-1-97
float ScaleLow       = 0.05;        // - Low  scale value (1/8)
float ZoomLowInc     = 0.00;        // - Low  scale zoom increment <  1.00 was .05,use new 0.0 auto   12-15-96
float ZoomHighInc    = 0.50;        // - High scale zoom increment >= 1.00 (shows as 500) 200 better fast systems

char CHKNamePRJ[128]  = "\0";        //"C:\DeeP\DOOM2.PRJ";// last project file
//----------------------

Bool ShowTips         = TRUE;       // Show Startup Tip Window
int2 TipNum           = 1;          // Current Tip #
int2 AutoSaveTime		 = 0;				// 0 = off, else 5,10,20,30,60 minutes
Bool MoveUsingEdge    = FALSE;      // Button on edge moves map

Bool ShowNodeBuilder  = TRUE;       // show nodebuilder in action
Bool ShowNodeSee      = TRUE;       // ask to see results (if not show node builder)
Bool OldNodeBuilder   = FALSE;      // use old nodebuilder (not really, just a term)
int2 NodeType         = 1;          // 1= 2= 3=minsplit
int2 NodeSplit        = 8;          // nodebuilder split value
int2 NodeTurboSplit   = 0;          // 0=None, 1=Autodecide between -> 2=Vertical, 3=Horizon
Bool Node2Sided       = FALSE;      // ignore 2-sided lines in nodebuild (no texture, same sector)
int2 NodeMaxSectorTag = 0;          // 0 or 900 (for now)
int2 NodeMaxLineDefTag= 0;          // 0 or 900
int2 NodeMinLineLength= 4;          // 2 to 4 for node line length to split

int2 HighestDrive    = 0;           // <= 3 = don't limit, else highest drive (might use later)

int2 LineThickness   = 1;           // line thickness for MAP
int2 Range           = 10;          // range for selecting objects (1-100)
int2 DrawingRange    = 3;           // range for selecting object when drawing only 3-1-98
int2 GridScale       = 8;           // default grid size
int2 GridDot         = 2;           // Grid spacing between dots 2 - 10
Bool Maximized       = FALSE;  		// Window Maximized

Bool ThingPicture    = FALSE;       // show cross or picture in other modes  only in Win95 - TRUE in DOS
Bool ChkUpperMissing = TRUE;        // check if upper missing
Bool ChkNormalMissing= TRUE;        // check if normal missing
Bool ChkLowerMissing = TRUE;        // check if lower missing
Bool ChkXoffset      = TRUE;        // check x offsets
Bool ChkYoffset      = FALSE;       // check y offsets
Bool ChkPatches      = TRUE;        // check multi patches
Bool ChkClosed1      = TRUE;        // check sectors closed 1
Bool ChkClosed2      = TRUE;        // check sectors closed 2

Bool ChkThingSector  = TRUE;        // check if thing is in sector
Bool ChkThingOnTop   = TRUE;        // check if things on top each other
Bool ChkTags         = TRUE;        // check linedef/sector tags
Bool ChkKeys         = TRUE;        // option linedef/thing keys
Bool ChkShortLines   = TRUE;        // option check short lines              3-1-97
Bool ChkDupSideDef   = TRUE;        // option check duplicate sidedefs       5-1-97

Bool AutoMaxChk      = TRUE;        // shareware check file limits   12-12-96

Bool MapBorder       = TRUE;        // Show lines down the side for a border

Bool MoveUsingCursor  = TRUE;       // cursor keys move map
Bool SelectDash       = TRUE;       // dashed select box
Bool GridDash         = TRUE;       // dashed grid
Bool GridShown        = FALSE;      // show the grid
Bool GridSnap         = TRUE;       // snap the grid
Bool ShowDrawLength   = TRUE;       // show length when drawing

Bool FixVideo         = TRUE;       //  3-1-97 fix driver probs
Bool DecimalTypes     = TRUE;       //  3-1-98 show decimal or hex values in displays
Bool BOOMSupport      = FALSE;      //  3-1-98 do BOOM or not
Bool OPTSupport       = FALSE;      //  3-1-98 read OPT file

int2 ScreenSaver     =  10;         // 10 minutes = ScreenSaver activation make variable  
int2 HighGrid        =  512;        //  512
int2 LowGrid         =  2  ;        //  2
int2 ScrollSpeed     =  10;         // initial map scroll Multiplication Factor was 20
int2 VertexTolerance =  3;          // for tolerance vertex overlap check
int2 ShortestLine    =  2;          // shortest line to look for  (made 2    8-1-97)

int2 BrowseSpriteMag  = 1;          // default browser sprite  magnification
int2 BrowseTextureMag = 1;          // default browser texture magnification
int2 BrowseFlatMag    = 1;          // default browser flat    magnification
int2 BrowseMapMag     = 2;          // default browser Map     magnification was 4 too big 800x600   12-15-96

int2 RulerSize       = 512;         // circle size or ruler
int2 ScrollMapBorder = 10;				// HOT zone for cursor to scroll map   11-3-96
int2 ButtonDelay     = 250;         // delay double click button1
int2 ImageDragMax    = 15;          // max number show line lengths (3 to 100) 

Bool QuietSelect   = TRUE ;         // 1=sound object selection
Bool QuietError    = TRUE ;         // 1=sound error
Bool QuietSpeaker  = TRUE ;         // 1=sound speaker (0=pc speaker)
Bool View3D        = FALSE;         // = = small picture   6-1-97

int2 SoundClick1   = SOUNDCLICK1;
int2 SoundClick2   = SOUNDCLICK2;
int2 SoundClick3   = SOUNDCLICK3;
int2 SoundDrip     = SOUNDDRIP;
int2 SoundPhaser   = SOUNDPHASER;
int2 SoundSwish1   = SOUNDSWISH1;
int2 SoundSwish2   = SOUNDSWISH2;
int2 SoundGame     = SOUNDGAME;      //exit
int2 SoundTeleport = SOUNDTELEPORT;
int2 SoundSpare1   = SOUNDPHASER;

Bool ExpertMode    = FALSE;         // verify delete prompt, etc
Bool ToolContinue  = TRUE ;         // In tool mode keep going
Bool LengthOption  = TRUE ;         // show lengths in drag
Bool LengthOptionSector= TRUE;      // show lengths for sectors too 3-1-98

Bool Undo          = TRUE;          // undo enabled
Bool MoveThings    = TRUE;          // delete/move things with sectors
Bool DragThings    = TRUE;          // to drag things in sector mode
Bool DeleteJoin    = TRUE;          // Vertex delete default is join vertex
Bool SectorJoin    = FALSE;         // Vertex default is not Sector on overdraw
Bool SmartDraw     = TRUE;          // Smart LineDrawing IID
Bool ClearReject   = TRUE;          // Always clear reject
Bool GroupSave     = FALSE;         // Always save grouped PWADs

int2 EditMode      = OBJ_SECTORS;   // initial mode
Bool AutoSelect    = TRUE;          // autoobject selection
Bool AutoCenter    = TRUE;          // auto center with zoom
Bool InfoShown     = TRUE;          // should we display the info bar?
Bool OverLapCheck  = TRUE;          // should we check overlapping vert

// need this stuff any more ?, should just load everything anyway all the time
// it's so easy just to reset all the files anyway.
// change one of these to show the splash screen

Bool AutoLoadLevel = TRUE;          // auto load all info from last time
Bool AutoStart     = FALSE;         // auto start execution right away

Bool AutoCursor    = TRUE;          // auto follow cursor
Bool Select0       = TRUE;          // select object 0 by default when switching modes
Bool AdditiveSelBox= TRUE;          // additive selection box (made true 3-1-98)
Bool CacheTexture  = TRUE;          // cache textures
Bool ResponseMode  = TRUE;          // build response file (auto if heretic)
Bool VertexArrow   = TRUE;          // arrows in vertex mode

int2 DefaultSectorLight     =  128; // default sector light
int2 DefaultFloorHeight     =    0; //  default floor height
int2 DefaultCeilingHeight   =  128; //  default ceiling height
int2 DefaultHeightChange    =    8; //  default height change

int2 DefaultDoorSpeed       =   16; //  default HEXEN DOOR open speed
int2 DefaultDoorDelay       =  100; //  default HEXEN Door Delay

int2 DefaultLiftSpeed       =    8; //  default HEXEN Lift speed
int2 DefaultLiftDelay       =   50; //  default HEXEN Lift Delay

int2 XoffLow                = -255; //  limit for xoffset low
int2 XoffHigh               =  255; //  limit for xoffset high
int2 YoffLow                = -255; //  limit for yoffset low   -127
int2 YoffHigh               =  255; //  limit for yoffset high  +127

int2 PrintDarkness    = 2;          // higher makes it lighter   3-1-97

char CommonBatchFile1[128]= "*.bat";   //not used anywhere yet 3--1-98
char CommonBatchFile2[128]= "*.exe";   //not used
char EditExe         [128]= "";        //C:\\Windows\\Notepad.exe";// EDIT  editor   3-1-97

char QuakeBspFileName[128]= "C:\\QUAKE\\ID1\\MAPS";        //   3-1-97
char QuakeWadFileName[128]= "C:\\QUAKE\\GFX\\";            //
char QuakePakFileName[128]= "C:\\QUAKE\\ID1\\";            //

RECT rcWindPos       = {-1024,20,460,360};// Window Saved Screen Position (4 Longs) (not really used now) was above shownode 3-1-98
// Dialog Positions saved   B.K. Nov. 13, 1996
POINT pLineDlgPos         = {200,160};//{300,200}; these are 1024 res
POINT pSideDlgPos         = {200,160};//{300,200};//   12-16-96 def 800 x600 make smarter later
POINT pTextureDlgPos      = {430, 70};//{300,200};//   12-16-96 def 800 x600 make smarter later
POINT pTextureSelectDlgPos= {430,160};//{300,200};//   12-16-96 def 800 x600 make smarter later

POINT pSectDlgPos         = {100,160};//{300,200};
POINT pFloorDlgPos        = {347,160};//{300,200};//   12-16-96 def 800 x600 make smarter later
POINT pFloorSelectDlgPos  = {347,160};//{300,200};//   12-16-96 def 800 x600 make smarter later

POINT pThingDlgPos     = {200, 70};//{200,100};

int4  ColorDominance1  = 35;   // determine dominant color (size 4 for speed issues)
int4  ColorDominance2  = 10;   // determine dominant color
int4  ColorTolerance   = 30;   // 30 if 3 colors within this range and same color, consider same (not used keep a bit)

char CHKsafety1[2]     = "ff";      // end of .CHK

//-------------------- end of CHK file ------------------------------------------


//----------- different between DeeP/Heep/Hexen ---------------------------------

//   must stay together----------------------------------------------------------
int4 align2=2;                      // alignment only

char CFGDeepHeader[4]  = "xCFG";    // header
int2 CFGDeepControl    = 0x9400;    // id for myself
int2 CFGDeepControlSize= 178;       //   +2 pick up 'e'
int4 CFGChecksum       = 0;         // checksum to do....

int2 Transparent        = 251;        // DOOM actual color value   5-1-97
int2 DrawingColor       = 182;        //GameColors[RED];         // drawing color

// 3D walk through save settings belong with cfg really   6-1-97
int2 Base3Dlines        = 7;          // 7 = do lines every 7
int2 Base3Dmode         = 3;          // 1=ceil only, 2= floor only, 3=both, 0 = none
byte Base3D1            =159;         // 193 starting color, emperical value
byte Base3D2            = 95;         // line color
byte CeilingColor       = 128;        // lighttan
byte FloorColor         =  90;        // gray

int2 InfoBoxColor       = LIGHTGRAY;  // color info box on bottom   //  11-7-96
int2 InfoBoxColorEdgeT  = LIGHTERGRAY;// color info box edge left&top
int2 InfoBoxColorEdgeB  = DARKERGRAY; // color info box edge right&botm

int2 TextureBrowseColor = GRAY;       // color for browsing textures //  11-7-96

int2 MenuColor          = LIGHTGRAY;  // color of menus
int2 MenuColorText      = BLACK;      // color of menus text

int2 MenuSelectColor    = BLUE;       // color for menus
int2 MenuSelectColorText= WHITE;      // color for menus= WHITE;

int2 MenuInfoColor      = DARKGREEN;  //LIGHTYELLOW;// color of menu info Box
int2 MenuInfoColorText  = WHITE;      // color of menu info Box text

int2 MenuSubBoxColor    = LIGHTERGREEN;// color within a menu box Background LIGHTCYAN;
int2 MenuSubBoxColorText= BLACK;       // color within a menu box Text

int2 OtherInfoColor     = WHITE;       // color of top/botm line boxes and some menuinfo

int2 SelectColor        = CYAN;        // color for selection box
int2 DragColor          = RED;         // color for dragging
int2 InsVertexColor     = YELLOW;      // insert vertexes line color
int2 VertexColor        = LIGHTBLUE ;  // color for vertex LIGHTGREEN
int2 HiLightColor       = YELLOW;      // color of hilight active
int2 GridColor          = GRAY;        // color of grid was darkergray   11-3-96

int2 MapColor1          = LIGHTERGRAY; // color of default lines   2-sided  (was LIGHTGRAY 10-1-97)
int2 MapColor2          = WHITE;       // color of outline lines   1-sided

int2 MapBrowseColorMain     = WHITE    ;   // color browser main file
int2 MapBrowseColorMainLines= DARKGRAY ;   // color browser main lines on map
int2 MapBrowseColorPwad     = BLACK;       // color browser pwad files
int2 MapBrowseColorPwadLines= LIGHTERBLUE; // color browser pwad lines on map   12-2-96

int2 BackColor         = BLACK;       // color of default background
int2 SecretColor       = DARKMAGENTA; // secret area---------------------------
int2 InvisibleColor    = ORANGE;      // invisible lines
int2 BackThingColor    = LIGHTGRAY;   // color of default background things
int2 BackThingColorMap = BLACK;       // color of default lines if things shown
int2 MonsterBlockColor = DARKGREEN;   // monster can't pass
int2 SoundBlockColor   = DARKRED;     // sound can't pass
int2 TypeTagColor      = LIGHTGREEN;  // linehas with a type + a tag number
int2 LineTypeColor     = LIGHTMAGENTA;// linedef with a type (no tag)
int2 TagBadColor       = LIGHTRED;    // linedef has no type, but a tag is present
int2 SectorSpecialColor= LIGHTBLUE;   // LIGHTCYAN sector is "special" type
int2 TypeScriptColor   = LIGHTBLUE;   // LIGHTERBLUE line has script
int2 TypeTeleColor     = LIGHTERBLUE; // line has teleport
int2 TypeHeightColor   = LIGHTERRED;  // sector diff heights

int2 RulerColor        = LIGHTMAGENTA;// color of ruler

int2 ButtonColor       = LIGHTGRAY;   // color of buttons normal
int2 ButtonColorActive = LIGHTGRAY;   // color of buttons when pushed

int2 DoomPaletteNumber =  0;          // doom palette to use (not used)
uint2 GammaCorrect     =  8;          // gamma correction

int2 DialogBoxColor    = WHITE;       // dialog box file open
int2 DialogFocusColor  = LIGHTERGREEN;// dialog box file open active

//int2 MouseColor       = YELLOW;     // color of mouse 0-15 (but 0 is black n/a windows    11-7-96
//int2 MouseColorEdge   = BLACK;      // color of mouse 0-15 (edge)
//int2 MenuHiLite         = YELLOW;   // color of menu hilight char obs windows

//-------if add to colors be sure to change initialization--------------
//   colors are "soft" and are set by SetColor which indexes into table
//   and gets the actual color value

int2 GameColors[30] = {
0,   //Black       0 =
203, //Blue        1 =
122, //Green       2 =
196, //Cyan        3 =// lite blue sort of
182, //Red         4 =
253, //Magenta     5 =
74,  //Brown       6 =
98,  //LightGray   7 = 93
105, //DarkGray    8 =
197, //LightBlue   9 =
117, //LightGreen  10=
194, //LightCyan   11=
175, //LightRed    12=
252, //LightMagenta13=
231, //Yellow      14=
4,   //White       15=
100, // gray       16   96
108, // darkergray 17 111
186, // darkred    18
123, // darkgreen  19
205, // darkblue   20
254, // darkmagenta21
248, // orange     22
70,  // lightbrown 23
32,  // SALMON       1  24
227, // LIGHTYELLOW  2  25=
195, // LIGHTERBLUE  3  26= map browser mainlines
113, // LIGHTERGREEN 4  27= map browser pwads
172, // LIGHTERRED   5  28= map browser pwad lines
90,  // LIGHTERGRAY  6  29= menu hollow lines   was 92   11-11-96 need chk her/hex/strife too
};

char CFGsafety1[2]               = "ff";              // end of .CFG

//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
//                   PRJ options                                                 =
// 1 contains IWAD
// 2 files
// 3 texture default Name .TCF
//--------------------------------------------------------------------------------
int4 align3=3;                   // alignment only

char PRJDeepHeader[4]  = "xPRJ";    // header   (L = 12 )
int2 PRJDeepControl    = 0x9701;    // id for myself
int2 PRJDeepControlSize= 16342;     //   +2 pick up 'e'  +836
int4 PRJChecksum       = 0;         // checksum to do....

float Scale         = 0.125;        // L= 4  init scale (1/8) (align here)

int2 Episode        = 1;            // doom1 E#  HERETIC
int2 Mission        = 1;            // doom1 M#  DOOM2,HEXEN,STRIFE Mission
int4 LastXloc       =-32666;        // last active X location (reset for new level)
int4 LastYloc       =-32666;        // last active Y location

char SavedDoomOptions[80]  = " -skill 4 -nomonsters";  //

//!!!!!!!!! increased all of these to 128 10-10-96   !!!!!!!!!!!!!!!!!!!!!!!

char PRJNameTCF    [128] = "\0";     //"C:\DeeP\DOOM2.TCF";// last texture default
char PatchDir      [128] = "";       // Patch wadfile directory (27 max)
char PasteDir      [128] = "";       // Paste wadfile directory (27 max)

char MainName      [128] = "C:\\DOOM2\\DOOM2.WAD"; // Main wadfile
char MainExeName   [128] = "DOOM2.EXE";  // Main exe
char UserOptName   [128] = "DOOM2.OPT";  //

char ScriptFile    [128] = "*.ACS";  //
char ScriptFileObj [128] = "*.O";    //

char MapInfoFile   [128] = "*.INF";  //
char DeCompileFile [128] = "*.ACS";  //
char SndInfoFile   [128] = "*.SND";  //

//char PRJBatchFile1 [128] = "*.BAT";  //
//char PRJBatchFile2 [128] = "*.EXE";  //

char PRJFirstTime[2]         = "ee"; 		// for me to tell ok, now used for 1st time
SavedFiles SavedFileList[57] = {{{0}}};    //(10)extra all files (filenumber in WadFileList points into this table)

char PRJsafety1[2]          = "ff"; // for me to tell ok-----------------------

//--------------------------------------------------------------------------------
//                   PRJ options                                                 =
// 1 contains IWAD
// 2 files
// 3 texture default Name .TCF
//--------------------------------------------------------------------------------
int4 align4=4;                   // alignment only

char TCFDeepHeader[4]  = "xTCF";    // header  (L=12)
int2 TCFDeepControl    = 0x7600;    // id for myself
int2 TCFDeepControlSize= 300;       //   +2 pick up 'e'
int4 TCFChecksum       = 0;         // checksum to do....

char DefaultSetting[2]             = "ee";

uint2 DefaultThing                 = THING_TROOPER; //  default thing insert
char DefaultUpperTexture[10]       = "MARBGRAY";    //  ickwall2 upper wall texture
char DefaultWallTexture [10]       = "MARBLE1\0";   //  gray4    normal wall texture
char DefaultLowerTexture[10]       = "MARBGRAY";    //  gray1    lower wall texture

char DefaultFloorTexture[10]       = "FLOOR4_8";    //  floor0_3 floor texture
char DefaultCeilingTexture[10]     = "FLAT4\0\0\0"; //  FLAt18   ceiling texture

char DefaultDoorTexture[10]        = "BIGDOOR2";    //  default Door texture
char DefaultDoorTrakTexture[10]    = "DOORTRAK";    //  default Door track texture

char DefaultLiftTexture[10]        = "SHAWN2\0\0";  //  default Lift texture

char DefaultPoolTexture[10]        = "MFLR8_3\0";   //  default Pool bottom texture
char DefaultPoolSideTexture[10]    = "PIPES\0\0\0"; //  default pool side texture

char DefaultPedestalTexture[10]    = "FLAT17\0\0";  //  default Pedestal bottom texture
char DefaultPedestalSideTexture[10]= "SLADWALL";    //  default pedestal side texture

char DefaultLightTexture[10]       = "GRNLITE1";    //  default Light top/botm
char DefaultWindowTexture[10]      = "FLOOR7_2";    //  default window floor/ceil

char DefaultStairCeilTx[10]            ="FLAT4\0\0\0"; //
char DefaultStairFloorTx[10]           ="FLAT5_4\0";   //
char DefaultStairStepTx[10]            ="STONE4\0\0";  //
char DefaultStairSideTx[10]            ="STONE5\0\0";  //

char DefaultTeleportExitFloorTx[10]    ="GATE3\0\0\0"; //
char DefaultTeleportExitCeilTx [10]    ="TLITE6_5";    //
char DefaultTeleportSideTx     [10]    ="SUPPORT3";    // side
char DefaultTeleportEntranceFloorTx[10]="STEP1\0\0\0"; //
char DefaultTeleportEntranceCeilTx[10] ="GRNLITE1";    //

// hot key stuff
int2 DefaultHotThing                  = THING_TROOPER; //  default thing insert
char DefaultHotUpperTexture[10]       = "MARBGRAY";    //  ickwall2 upper wall texture
char DefaultHotWallTexture [10]       = "MARBLE1\0";   //  gray4    normal wall texture
char DefaultHotLowerTexture[10]       = "MARBGRAY";    //  gray1    lower wall texture

char DefaultHotFloorTexture[10]       = "FLOOR4_8";    //  floor0_3 floor texture
char DefaultHotCeilingTexture[10]     = "FLAT4\0\0\0"; //  FLAt18   ceiling texture

char TCFsafety1[2]                    = "ff";           // for me to tell ok

//------------------------------------------------------------------------

//-----------------------------------------------------------------------------------
//   doom defaults    (reset 10-1-97)
//-----------------------------------------------------------------------------------

char DMainName           []         = "C:\\DOOM\\DOOM.WAD"; // Main wadfile
char DExeName            []         = "DOOM.EXE";   // Main exe
char DUserOptName        []         = "DOOM2.OPT";  //

int4 align5=4;                   // alignment only
char DDefaultSetting[2]             = "ee";
int2 DDefaultThing                  = THING_TROOPER; // default thing insert

char DDefaultUpperTexture[10]       = "MARBLE3\0";   //  ickwall2 upper wall texture
char DDefaultWallTexture [10]       = "MARBLE1\0";   //  gray4    normal wall texture
char DDefaultLowerTexture[10]       = "MARBLE2\0";   //  gray1    lower wall texture

char DDefaultFloorTexture[10]       = "FLOOR4_8";    //  floor0_3 floor texture
char DDefaultCeilingTexture[10]     = "FLAT4\0\0\0"; //  FLAt18   ceiling texture

char DDefaultDoorTexture[10]        = "BIGDOOR2";    //  default Door texture
char DDefaultDoorTrakTexture[10]    = "DOORTRAK";    //  default Door track texture

char DDefaultLiftTexture[10]        = "SHAWN2\0\0";  //  default Lift texture

char DDefaultPoolTexture[10]        = "MFLR8_3\0";   //  default Pool bottom texture
char DDefaultPoolSideTexture[10]    = "DOORHI\0\0";  //  default pool side texture

char DDefaultPedestalTexture[10]    = "FLAT17\0\0";  //  default Pedestal bottom texture
char DDefaultPedestalSideTexture[10]= "SLADWALL";    //  default pedestal side texture

char DDefaultLightTexture[10]       = "CEIL1_2\0";   //  default Light top/botm
char DDefaultWindowTexture[10]      = "FLOOR7_2";    // default window floor/ceil

char DDefaultStairCeilTx[10]            ="FLAT4\0\0\0"; //
char DDefaultStairFloorTx[10]           ="FLAT5_4\0";   //
char DDefaultStairStepTx[10]            ="STONE2\0\0";  //
char DDefaultStairSideTx[10]            ="STONE2\0\0";  //

char DDefaultTeleportExitFloorTx[10]    ="GATE3\0\0\0"; //
char DDefaultTeleportExitCeilTx [10]    ="TLITE6_5";    //
char DDefaultTeleportSideTx     [10]    ="SUPPORT3";    // side
char DDefaultTeleportEntranceFloorTx[10]="STEP1\0\0\0"; //
char DDefaultTeleportEntranceCeilTx[10] ="TLITE6_5";    //

int2 DDefaultHotThing                  = THING_TROOPER; //  default thing insert
char DDefaultHotUpperTexture[10]       = "MARBLE3\0";    //  ickwall2 upper wall texture
char DDefaultHotWallTexture [10]       = "MARBLE1\0";   //  gray4    normal wall texture
char DDefaultHotLowerTexture[10]       = "MARBLE3\0";    //  gray1    lower wall texture

char DDefaultHotFloorTexture[10]       = "FLOOR4_8";    //  floor0_3 floor texture
char DDefaultHotCeilingTexture[10]     = "FLAT4\0\0\0"; //  FLAt18   ceiling texture

char Dsafety1[2]                       = "ff";           // for me to tell ok
//-----------------end DOOM defaults----------------------------------------------





//-----------------------------HERETIC stuff------------------------------

int2 HGameColors[30] = {
0,   //Black       0 =   0,  0
195, //Blue        1 = 202; 197
215, //Green       2 = 118; 216
203, //Cyan        3 = 194; 200  // lite blue sort of  WAS 181
154, //Red         4 = 180; 155  //183;
172, //Magenta     5 = 253; 172
76,  //Brown       6 =  70;  79  // 144 is light brown
17,  //LightGray   7 =  was 18   //
10,  //DarkGray    8 =  95   19  //vesa is different from 96 to 106
200, //LightBlue   9 = 196; 201  //193
218, //LightGreen  10 =114; 223 //112;
183, //LightCyan   11= 193; 184
160, //LightRed    12= 176; 161
175, //LightMagenta13= 250; 173
144, //Yellow      14= 231; 144
35,  //White       15= 4;    35

13,  // gray       16
 8,  // darkergray 17
151, // darkred    18
213, // darkgreen  19
191, // darkblue   20
170, // darkmagenta21		WAS 170
140, // orange     22
80,  // lightbrown 23

138, // SALMON       1  24
136, // LIGHTYELLOW  2 25=
201, // LIGHTERBLUE  3 26= map browser mainlines		WAS 183
222, // LIGHTERGREEN 4 27= map browser pwads
163, // LIGTHERRED   5 28= map browser pwad lines		WAS 164
23 , // LIGHTERGRAY  6  29= menu hollow lines
};


//-----------------------------HEXEN stuff------------------------------

int2 HXGameColors[30] = {
0,   //Black       0 =   0,  0
156, //Blue        1 = 202; 195
197, //Green       2 = 118; 215										WAS 194
221, //Cyan        3 = 194; 181  // lite blue sort of		WAS 79
178, //Red         4 = 180; 154;
235, //Magenta     5 = 253; 172										WAS 236
103, //Brown       6 =  70;  76  // 144 is light brown
20,  //LightGray   7 =  was 22   //
12,  //DarkGray    8 =  95   12  //vesa is different from 96 to 106
161, //LightBlue   9 = 196; 200  //193
212, //LightGreen  10 =114; 218 //112;								WAS 214
223, //LightCyan   11= 193; 183										WAS 80
181, //LightRed    12= 176; 160
237, //LightMagenta13= 250; 175			CHANGED FROM 238
230, //Yellow      14= 231; 144
255, //White       15

18,  // gray       16
 8,  // darkergray 17
175, // darkred    18
194, // darkgreen  19
155, // darkblue   20
233, // darkmagenta21
227, // orange     22													WAS 139
253, // lightbrown 23

203, // SALMON       1 24
145, // LIGHTYELLOW  2 25=
163, // LIGHTERBLUE  3 26=
216, // LIGHTERGREEN 4 27 (222 is a nice blue)
245, // LIGHTERRED     28
25 , // LIGHTERGRAY  6 29= menu hollow lines  was 26
};

//-----------------------------STRIFE stuff------------------------------

int2 SGameColors[30] = {
0,   //Black       0 =   0,  0
251, //Blue        1 =  
103, //Green       2 =
248, //Cyan        3 =  lite blue sort of was 118
67 , //Red         4 =
113, //Magenta     5 =  was 151 is green   6-1-97
175, //Brown       6 =
16,  //LightGray   7 =
20,  //DarkGray    8 =
250, //LightBlue   9 =
243, //LightGreen  10=
114, //LightCyan   11=
64 , //LightRed    12=
151, //LightMagenta13=
224, //Yellow      14=
1  , //White       15

18,  // gray       16
24,  // darkergray 17
72 , // darkred    18
105, // darkgreen  19
123, // darkblue   20
154, // darkmagenta21
229, // orange     22
169, // lightbrown 23

86 , // SALMON       1 24
144, // LIGHTYELLOW  2 25= (light green really)    was 150
249, // LIGHTERBLUE  3 26=
241, // LIGHTERGREEN 4 27
148, // LIGHTERRED     28
11 , // LIGHTERGRAY  6 29= menu hollow lines
};


//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
// variable first time project info for HERETIC
//----------------------------------------------------------------------------------

char HMainName           []         = "C:\\HERETIC\\HERETIC.WAD";    // Main wadfile
char HExeName            []         = "HERETIC.EXE";    // Main exe
char HUserOptName        []         = "HERETIC.OPT";  //

int4 align6 = 6;
char HDefaultSetting[2]             = "ee";
int2 HDefaultThing                  = THING_GOLEM;   // default thing insert

char HDefaultUpperTexture[10]       = "GRSTNPBV";    //  default upper wall texture
char HDefaultWallTexture [10]       = "GRSTNPB\0";   //  default normal wall texture
char HDefaultLowerTexture[10]       = "GRSTNPBW";    //  default lower wall texture

char HDefaultFloorTexture[10]       = "FLOOR19\0";   //  default floor texture
char HDefaultCeilingTexture[10]     = "FLOOR11\0";   //  default ceiling texture

char HDefaultDoorTexture[10]        = "DOORWOOD";    //  default door    texture
char HDefaultDoorTrakTexture[10]    = "WOODWL\0\0";  //  default doortraktexture

char HDefaultLiftTexture[10]        = "METL2\0\0\0"; //  default Lift texture

char HDefaultPoolTexture[10]        = "FLTWAWA1";    //  default Pool bottom texture
char HDefaultPoolSideTexture[10]    = "RCKSNMUD";    //  default pool side texture

char HDefaultPedestalTexture[10]    = "FLOOR08\0";   // default Pedestal bottom texture
char HDefaultPedestalSideTexture[10]= "GRSTNPBV";    // default pedestal side texture

char HDefaultLightTexture[10]       = "FLAT500\0";   // default Light top/botm
char HDefaultWindowTexture[10]      = "FLOOR03\0";   // default window floor/ceil

char HDefaultStairCeilTx[10]            ="FLAT509\0";   //
char HDefaultStairFloorTx[10]           ="FLOOR03\0";   //
char HDefaultStairStepTx [10]           ="LOOSERCK";    //
char HDefaultStairSideTx [10]           ="GRSTNPB\0";   //

char HDefaultTeleportExitFloorTx[10]    ="FLTTELE1";    //
char HDefaultTeleportExitCeilTx [10]    ="FLOOR08\0";   //
char HDefaultTeleportSideTx     [10]    ="SQPEB1\0\0";  // side
char HDefaultTeleportEntranceFloorTx[10]="FLOOR23\0";   //
char HDefaultTeleportEntranceCeilTx[10] ="FLOOR08\0";   //

int2 HDefaultHotThing                  = THING_GOLEM;    // default thing insert
char HDefaultHotUpperTexture[10]       = "GRSTNPBV";    //  default upper wall texture
char HDefaultHotWallTexture [10]       = "GRSTNPB\0";   //  default normal wall texture
char HDefaultHotLowerTexture[10]       = "GRSTNPBW";    //  default lower wall texture

char HDefaultHotFloorTexture[10]       = "FLOOR19\0";   //  default floor texture
char HDefaultHotCeilingTexture[10]     = "FLOOR11\0";   //  default ceiling texture

char Hsafety1[2]                       = "ee";           // for me to tell ok



//----------------------------------------------------------------------------------
// variable first time project info for HEXEN
//----------------------------------------------------------------------------------

char HXMainName           []         = "C:\\HEXEN\\HEXEN.WAD";        // Main wadfile
char HXExeName            []         = "HEXEN.EXE";        // Main exe
char HXUserOptName        []         = "HERETIC.OPT";  //

int4 align7 = 7;
char HXDefaultSetting[2]             = "ee";
int2 HXDefaultThing                  = 10030      ;   //  ETTIN default thing insert

char HXDefaultUpperTexture[10]       = "PRTL02\0\0";  //  default upper wall texture
char HXDefaultWallTexture [10]       = "PRTL02\0\0";  //  default normal wall texture
char HXDefaultLowerTexture[10]       = "PRTL02\0\0";  //  default lower wall texture

char HXDefaultFloorTexture[10]       = "F_047\0\0\0"; //  default floor texture
char HXDefaultCeilingTexture[10]     = "F_048\0\0\0"; //  default ceiling texture

char HXDefaultDoorTexture[10]        = "D_WD07\0\0";  //  default door    texture
char HXDefaultDoorTrakTexture[10]    = "D_ENDBR\0";   //  default doortraktexture

char HXDefaultLiftTexture[10]        = "STEEL05\0";   //  default Lift texture

char HXDefaultPoolTexture[10]        = "X_005\0\0\0"; //  default Pool bottom texture
char HXDefaultPoolSideTexture[10]    = "FOREST01";    //  default pool side texture

char HXDefaultPedestalTexture[10]    = "F_042\0\0\0"; // default Pedestal bottom texture
char HXDefaultPedestalSideTexture[10]= "PRTL04\0\0";  // default pedestal side texture

char HXDefaultLightTexture[10]       = "F_084\0\0\0"; // default Light top/botm
char HXDefaultWindowTexture[10]      = "F_033\0\0\0"; // default window floor/ceil

char HXDefaultStairCeilTx[10]            ="F_041\0\0\0"; //
char HXDefaultStairFloorTx[10]           ="F_078\0\0\0"; //
char HXDefaultStairStepTx [10]           ="T2_STEP\0";   //
char HXDefaultStairSideTx [10]           ="FIRE07\0\0";  //

char HXDefaultTeleportExitFloorTx[10]    ="F_061\0\0\0"; //
char HXDefaultTeleportExitCeilTx [10]    ="F_042\0\0\0"; //
char HXDefaultTeleportSideTx     [10]    ="T2_STEP\0";   // side
char HXDefaultTeleportEntranceFloorTx[10]="F_063\0\0\0"; //
char HXDefaultTeleportEntranceCeilTx[10] ="F_042\0\0\0"; //

int2 HXDefaultHotThing                  = THING_GOLEM;    // default thing insert
char HXDefaultHotUpperTexture[10]       = "PRTL02\0\0";  //  default upper wall texture
char HXDefaultHotWallTexture [10]       = "PRTL02\0\0";  //  default normal wall texture
char HXDefaultHotLowerTexture[10]       = "PRTL02\0\0";  //  default lower wall texture

char HXDefaultHotFloorTexture[10]       = "F_047\0\0\0"; //  default floor texture
char HXDefaultHotCeilingTexture[10]     = "F_048\0\0\0"; //  default ceiling texture

char HXsafety1[2]                       = "ee";           // for me to tell ok

//--------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
// variable first time project info for STRIFE
//----------------------------------------------------------------------------------

char SMainName           []         = "C:\\STRIFE\\STRIFE1.WAD";    // Main wadfile   12-13-96
char SExeName            []         = "STRIFE1.EXE";    // Main exe
char SUserOptName        []         = "STRIFE.OPT";  //

int4 align8 = 8;
char SDefaultSetting[2]             = "ee";
int2 SDefaultThing                  = 51         ;  //   default thing insert

char SDefaultUpperTexture[10]       = "CONCRT02";   //  default upper wall texture
char SDefaultWallTexture [10]       = "CONCRT01";   //  default normal wall texture
char SDefaultLowerTexture[10]       = "CONCRT04";   //  default lower wall texture

char SDefaultFloorTexture[10]       = "F_TECH01";   //  default floor texture
char SDefaultCeilingTexture[10]     = "F_BASHXL";      //  default ceiling texture

char SDefaultDoorTexture[10]        = "DORWS04\0";     //  default door    texture
char SDefaultDoorTrakTexture[10]    = "DORTRK01";      //  default doortraktexture

char SDefaultLiftTexture[10]        = "ELEVTR01";      //  default Lift texture

char SDefaultPoolTexture[10]        = "F_WATR01";      //  default Pool bottom texture
char SDefaultPoolSideTexture[10]    = "PIPWAL02";      //  default pool side texture

char SDefaultPedestalTexture[10]    = "F_PIPING";      // default Pedestal bottom texture
char SDefaultPedestalSideTexture[10]= "BOXMTL01";      // default pedestal side texture

char SDefaultLightTexture[10]       = "F_1ALTAR";      // default Light top/botm
char SDefaultWindowTexture[10]      = "F_DECK\0\0";    // default window floor/ceil

char SDefaultStairCeilTx[10]            ="F_TECH01";   //
char SDefaultStairFloorTx[10]           ="F_RSTDEK";   //
char SDefaultStairStepTx [10]           ="STAIR05\0";  //
char SDefaultStairSideTx [10]           ="IRON05\0\0"; //

char SDefaultTeleportExitFloorTx[10]    ="F_TELE1\0";  //
char SDefaultTeleportExitCeilTx [10]    ="F_TELE1\0";  //
char SDefaultTeleportSideTx     [10]    ="PLASTR08";   // side
char SDefaultTeleportEntranceFloorTx[10]="F_SHNMTL";   //
char SDefaultTeleportEntranceCeilTx[10] ="F_SHNMTL";   //

int2 SDefaultHotThing                  = 1;            // default thing insert
char SDefaultHotUpperTexture[10]       = "CONCRT02";   //  default upper wall texture
char SDefaultHotWallTexture [10]       = "CONCRT01";   //  default normal wall texture
char SDefaultHotLowerTexture[10]       = "CONCRT04";   //  default lower wall texture

char SDefaultHotFloorTexture[10]       = "F_TECH01";   //  default floor texture
char SDefaultHotCeilingTexture[10]     = "F_BASHXL";   //  default ceiling texture

char Ssafety1[2]                       = "ee";         // for me to tell ok



//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------

char HelpName[80] = "DEEP.HLP"; // help file
Bool HelpOpened   = FALSE;

int4 RootDrive;
char RootDir [260];              // current directory c:\tc3\exe   (27 max)
char CurrDir [260];              // current directory c:\tc3\exe   (27 max)

// 2-20-97 bk
char AssFileName [260] = {0};   // Associate File name - DBLCLK to start

char PlayNumber[4]= "   ";      // or 1 1 for DOOM 1  (to testdoom)
Bool ShowRulers   = FALSE;      // ruler box     command = R
Bool RulerHollow  = TRUE;       // filled in           command = !
Bool RulerRectangle=TRUE;       // rectangle or circle command = @
Bool Registered   = TRUE;       // DOOM registered or shareware game? */
Bool PRJStatus    = FALSE;      // project status
Bool TCFStatus    = FALSE;      // texture status

//  ----------------------------------------------------------------------
//   12-15-96 the reason the defines are here is that the shareware is
//              recompiled so it's impossible to patch the number of
//              files past the number compiled for it.
//---------------------------------------------------------------------------
// >> please note that defines for maxfiles have to be here, otherwise it's too big a pain to
// >> reset it. NOWHERE else is this used and it shouldn't be, so this also makes sure of that
//---------------------------------------------------------------------------

//#define maxfiles   6              // 5 +1 bak  -leave this stuff here
//Bool DeePRegistered= FALSE;       // not registered=FALSE

#define maxfiles   56               //  55 +(1 bak)  this has to be here to make it easy to change!
Bool DeePRegistered   = TRUE;       // registered=TRUE

int2 MaxSavedFileList = 57;         // number saved in header

#define totfiles   maxfiles+1       // +1 for work

#define maxmission 99               // maximum #of levels 3-1-98 was 80

int2 Demo32           = maxfiles;   // maximum number of files
int2 MaxMission       = maxmission; // maximum number of missions

// wadfiles is a list of all the wad files

WadFiles  WadFileMinus[1]          = {{0}};     //   12-20-96 I'm confused for a bit, need to check out IWAD indexes
WadFiles  WadFileList [totfiles+1] = {{0}};     // +1 for +1 for IWAD= 0  filenumber here = index into savedfilelist 0 to 56
int2                MissionCount = 0;           // number of active missions

// missionfiles contains a list of each level and what file# it is in

MissionFiles MissionFileList[maxmission] = {{{0}}};  // list of all the missions

LevelArea PasteData   = {0};
LevelArea UndoData    = {0};

LevelPtr  PasteBuffer = &PasteData; // last paste
LevelPtr  UndoBuffer  = &UndoData;  // keep copy of last action

WadFiles LevelWad     = {NULL};     // the current level file for quick access

//----------------------------------------------------------------------------------
char     TxtLevelName[10]= {0};             // the character name of the level
int4     MasterLimit    =  0;               // MasterWad number of entries (w room for 100 extra)
int4     MasterNum      =  0;               // MasterWad number of entries
WadPtr   MasterWad      = &WadFileList[0];  // the master  directory for quick access

char *LOKFileName = "DEEP.LOK";             // Temporary lock method till I find code again
char *CHKFileName = "DEEP.CHK\0\0\0\0";     // Deep.CHK  palette to use
char *CFGFileName = "DOOM2.CFG\0\0\0\0";    // DOOM1/DOOM2/HERETIC/HEXEN.CFG has basic options
char *PRJFileName = CHKNamePRJ;             // Doomx.PRJ  IWAD, textures and user files
char *TCFFileName = PRJNameTCF;             // Doomx.TCF  IWAD, textures and user files

//---------------------------------

//char **PatchWads = NULL;           // list of -f Pwad files temporary

char SkyTexture[] = "F_SKY1\0\0";  // texture for sky (HEXEN = F_SKY, STRIFE=F_SKY001

char RDOOM[]     = "DOOM";
char RHERETIC[]  = "HERETIC";
char RHEXEN[]    = "HEXEN";
char RSTRIFE[]   = "STRIFE";
char *TxtGameType= RDOOM;          // will contain RDOOM or RHERETIC

//char TxtBatName[]      = "DEEP.BAT";
//char TxtDoomRegister[] = "Please register %s to save your changes";

//--------------------------------------------------------------------------

int2 FGColor,BGColor;
int2 StopCode = 0;

//----------------------- stuff I moved here for global access -----------

//-------------------------------------------------------------------------
// Set DOOM values (first time create only)
//-------------------------------------------------------------------------
void SetDOOM1Values(void)
{  int4 TCFLen1;
   int4 TCFLen2;

   Transparent    = 251;        // DOOM actual color value   5-1-97
   DrawingColor   = 182;
   Base3D1        = 159;         // 193 starting color, emperical value
   Base3D2        =  95;         //   0
   CeilingColor   = 128;
   FloorColor     =  90;

   TCFLen1 = (char *)TCFsafety1 -(char*)DefaultSetting;
   TCFLen2 = (char *)Dsafety1   -(char*)DDefaultSetting;

   // code to make sure I don't make a mistake

   if (TCFLen1 != TCFLen2)
    ErrorMsg(gd.hMainWindow,  "ERROR, DOOM length mismatch %d,%d",TCFLen1,TCFLen2);

   strcpy (MainName,DMainName);                      // PRJ DOOM name
   strcpy (MainExeName,DExeName);                        // PRJ DOOM exe
   strcpy (UserOptName,DUserOptName);                // PRJ DOOM2.opt
   memcpy (DefaultSetting,DDefaultSetting,TCFLen1);  // TCF DOOM textures

}
//-------------------------------------------------------------------------
// Set Heretic values (first time create only)
//-------------------------------------------------------------------------
void SetHereticValues(void)
{  int4 TCFLen1;
   int4 TCFLen2;

   Transparent   = 172;                                // for drawing   5-1-97
   DrawingColor  = 154;
   Base3D1       = 159;         // 193 starting color, emperical value
   Base3D2       =  17;//125;         //   0
   CeilingColor  = 109;
   FloorColor    =  18;

   TCFLen1 = (char *)TCFsafety1 -(char*)DefaultSetting;
   TCFLen2 = (char *)Hsafety1   -(char*)HDefaultSetting;

   if (TCFLen1 != TCFLen2)
    ErrorMsg(gd.hMainWindow,  "ERROR, HERETIC length mismatch %d,%d",TCFLen1,TCFLen2);

   memcpy (GameColors,HGameColors,30*2);             // CFG heretic colors
   strcpy (MainName,HMainName);                      // PRJ heretic name
   strcpy (MainExeName,HExeName);                        // PRJ heretic exe
   strcpy (UserOptName,HUserOptName);                // PRJ HERETIC.opt
   memcpy (DefaultSetting,HDefaultSetting,TCFLen1);  // TCF heretic textures

}

//-------------------------------------------------------------------------
// Set HeXen values (first time create only)
//-------------------------------------------------------------------------
void SetHexenValues(void)
{  int4 TCFLen1;
   int4 TCFLen2;

   Transparent   = 236;                                 // for drawing   5-1-97
   DrawingColor  = 178;
   Base3D1       = 123;         // 193 starting color, emperical value
   Base3D2       =  16;          //131;         //   0
   CeilingColor  =  92;
   FloorColor    =  78;

   TCFLen1 = (char *)TCFsafety1 - (char*)DefaultSetting;
   TCFLen2 = (char *)HXsafety1  -(char*)HXDefaultSetting;

   if (TCFLen1 != TCFLen2)
    ErrorMsg(gd.hMainWindow,  "ERROR,HEXEN length mismatch %d,%d",TCFLen1,TCFLen2);

   memcpy (GameColors,HXGameColors,30*2);             // CFG hexen colors
   strcpy (MainName,HXMainName);                      // PRJ hexen name
   strcpy (MainExeName,HXExeName);                        // PRJ hexenexe
   strcpy (UserOptName,HXUserOptName);                // PRJ HEXEN.opt
   memcpy (DefaultSetting,HXDefaultSetting,TCFLen1);  // TCF hexen textures

}


//-------------------------------------------------------------------------
// Set STRIFE values (first time create only)
//-------------------------------------------------------------------------
void SetStrifeValues(void)
{  int4 TCFLen1;
   int4 TCFLen2;

   Transparent   = 151;                                // for drawing   5-1-97
   DrawingColor  =  67;
   Base3D1       = 159;         // 193 starting color, emperical value
   Base3D2       =  20;         //   0
   CeilingColor  = 164;
   FloorColor    = 195;

   TCFLen1 = (char *)TCFsafety1 - (char*)DefaultSetting;
   TCFLen2 = (char *)Ssafety1  -  (char*)SDefaultSetting;

   if (TCFLen1 != TCFLen2)
    ErrorMsg(gd.hMainWindow,  "ERROR, STRIFE length mismatch %d,%d",TCFLen1,TCFLen2);

   memcpy (GameColors,SGameColors,30*2);             // CFG strifecolors
   strcpy (MainName,SMainName);                      // PRJ strifename
   strcpy (MainExeName,SExeName);                        // PRJ strifeexe
   strcpy (UserOptName,SUserOptName);                // PRJ STRIFE.opt
   memcpy (DefaultSetting,SDefaultSetting,TCFLen1);  // TCF hexen textures

}

//==============================================================================
// frees any file that does not have any dir names in used any more
// this has to be used after all files have been loaded
// to get all names set.  Then call this
// Called here and levelio save
//==============================================================================

void FreeNotUsedFiles(void)
{
   Bool   active;
   int4   n;
   int2   fd;
   DirPtr dir;
   dir = MasterWad->directory;                          //Master Directory

   for (fd=1; fd < Demo32 ; fd++)
   {
       if (WadFileList[fd].type[0] != NULL)             // active file
       {  active = FALSE;
          for (n=0; n < MasterNum; n++)
	       {    if (dir[n].filenumber == fd)             // in use here
	            {   active = TRUE;
		             break;
	            }
	       }

	       // this file is not used anywhere-------------

         if  (!active)
         {   //NotifyMsg(NULL,"#%hd Free %s",fd,WadFileList[fd].filename);
	          if (WadFileList[fd].type[0] == 'O')
	          {   fclose ( WadFileList[fd].fileinfo);
	          }
	          FreeMemory( WadFileList[fd].directory);
             WadFileList[fd].fileinfo   = NULL;
	          WadFileList[fd].mission[0] = NULL;
	          WadFileList[fd].type[0]    = NULL;        // ok to use
	          WadFileList[fd].filenumber = 0;
	         *WadFileList[fd].filename   = NULL;        // show ok to use
	      }
       }
   }
}

//-------------------------------------------------------------------------
// shift all file names up to get rid of holes
// called here and levelio save
//-------------------------------------------------------------------------

void ShiftFilesDown(void)
{  int2 i,j,k;

  for (i=0; i< MaxSavedFileList; i++)              //57
  {
     if ( SavedFileList[i].filename[0] == '\0' )   // -empty slot-
     {  // not first one
        // shift all up

        for (j= i; j < MaxSavedFileList-1; j++)    //56
        {
	        // adjust file name address in WadFileList
	        // The name is shifted

 	        for (k= 1; k < Demo32; k++)            //56
           {
	           if (WadFileList[k].type[0] == NULL) continue;     // not used

	           if ( WadFileList[k].filename ==SavedFileList[j+1].filename)// this one
	           {
                   WadFileList[k].filename = SavedFileList[j].filename;  // will be shifted
		             WadFileList[k].filenumber = j;                        // new file number 7-7-95
		             //Trace(0,0,"%s shift filelist=%hd namelist=%hd", WadFileList[k].filename,k,j ); bioskey(0);
		             break;
	           }

	        }

	        // if this is for levelwad fix address

	        if (LevelWad.filename != NULL
	        &&  SavedFileList[j+1].filename == LevelWad.filename )      // this one
	        {   LevelWad.filename = SavedFileList[j].filename;          // new location
       	      LevelWad.filenumber = j;                                // new file number 7-7-95
               //NotifyMsg(NULL,"new levelname %s",LevelWad.filename);
           }

	        // now shift name down into empty slot

	        strcpy(SavedFileList[j].filename,SavedFileList[j+1].filename);
	    }

	    SavedFileList[MaxSavedFileList-1].filename[0] = '\0';     // 57 (last entry) always nulled

     }
  }

}

//-------------------------------------------------------------------------
// find a free slot in SavedFileList
// there is 1 extra work work when backing up
//-------------------------------------------------------------------------

char*FindFreeFile(void)
{  int2 i;

   // shift down the files

   //ShiftFilesDown();                    // don't do yet, keep files in same sequence after save/reload

   for (i=0; i< MaxSavedFileList; i++)    //57
   {
      if (SavedFileList[i].filename[0] == '\0' )
	  	{   return (SavedFileList[i].filename);
      }
   }
   ProgError("Maximum of %hd files exceeded",Demo32) ;

   return 0; 							// keep compiler happy
}



////////////////////////////////////////////////////////////////////////////////
//
//  	The WinMain function is the entry point for the program
//
// 2-20-97 bk Add gd.hMainWindow to bypass Accel. keystrokes when child window up
// this manifests itself in places like the Floor Browse window when you click
// on the bottom texture in the Info Window and browse then hit the ' F ' key
// the Find windows comes up from the MainWindow since its an Accelerator keystroke
/////////////////////////////////////////////////////////////////////////////////

#pragma argsused
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance,
						           LPSTR  lpszCmdParam, int nCmdShow)
{
  MSG  Msg;

  gd.hInst = hInst;		// save the INSTANCE of our handle in Global Vars
                			// since you can have multiple INSTANCES of your
					         // application running you have to check if you
				           	// are the first one or not
  //if (!hPrevInstance)  // hPrevInstance is always NULL for Win32 1-3-97 bk

  // Get filename passed
  
  if(lstrlen(lpszCmdParam) > 1)  //at least a Drive letter, colon and file!
  {  lstrcpy(AssFileName, lpszCmdParam);
  }

  if (!WindowRegister(hInst))
  {	return FALSE;
  }

  //  NotifyMsg(gd.hMainWindow,lpszCmdParam); //debug

  if(!WindowCreate(hInst, nCmdShow) )                 // create gd.hMainWindow
  {   return FALSE;                                   // can't create or already active
  }

  // Accelerators for keystroke shortcuts

  hAccel = LoadAccelerators(hInstance, "DEEPKEYS");   // this was already here   ??

  if (hAccel == NULL)
  {   ErrorMsg(gd.hMainWindow,"Can't Load AccTable\n\nNo Keyboard shortcuts available");
  }

  //	If we have a handle to an accelerator, translate it and pass
  //	that message on to the proper place rather than letting Win95
  // Post it to the MessageQueue. If it's a modeless msg pass it
  // on the proper proc.

  while (GetMessage(&Msg, NULL, 0, 0))
  {  //static Count = 0;

     //Trace(NULL,10,4,"msg=%d %d %d",Msg.message,Msg.wParam,Count++);  //  test what's being passed
     if(gd.hDlgModeless == 0
     || !IsDialogMessage(gd.hDlgModeless, &Msg))
     {
	  	  if (Msg.hwnd != gd.hMainWindow     // added bk 1-?-97
	  	  || !hAccel
        || !TranslateAccelerator(gd.hMainWindow, hAccel, &Msg))
	     {
           //Trace(NULL,10,4,"msg=%d %d %d",Msg.message,Msg.wParam,Count++);  //  test what's being passed
           if (Msg.message != WM_TIMER)                  // 275   not timer
           {  ScreenSaverTimer = 0;                      // reset screen saver timer each time
           }
		     TranslateMessage(&Msg);
		     DispatchMessage(&Msg);
	     }
     }
  }

  return Msg.wParam;
}

//============================================================================
// Register a class and tell where and what
// this should never happen, but it helps us if something goes wrong
// like I forgot to copy something
//===========================================================================
Bool RegisterClassAndCheckError(int id,WNDCLASS *wc)
{   DWORD Er;

    if( ! RegisterClass( wc ) )
    {   Er = GetLastError(); // 2 = notfound, 5=Access Denied
        ErrorMsg(gd.hMainWindow, "RegisterClass %d: Error %d\nCan't Start DeeP97",id,Er);
        return FALSE;
    }
    return TRUE;
}

////////////////////////////////////////////////////////////////////////////
// Register Window
////////////////////////////////////////////////////////////////////////////
BOOL WindowRegister(HINSTANCE hInst)
{
  WNDCLASS wc;
  LPCTSTR DeePIdTmp;                               //   1-23-97
                 
  ZeroMemory(&wc, sizeof(wc));
  DeePIdTmp = szLoadString(IDS_APPNAME);           //   1-23-97
  strcpy(DeePVersion,DeePIdTmp);

  // main processing loop    1-15-97 bk , Main Window Changes
  wc.style          = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;// | CS_SAVEBITS;
  wc.lpfnWndProc    = (WNDPROC)WndProc;
  wc.cbClsExtra     = 0;
  wc.cbWndExtra     = 0;
  wc.hInstance      = hInst;
  wc.hIcon          = LoadIcon(hInst, "Deep");
  wc.hCursor        = NULL;                        // bk 1-?-97
  //wc.hCursor      = LoadCursor(NULL, IDC_ARROW); bk 1-?-97
  wc.hbrBackground  = GetStockBrush(NULL_BRUSH);   // we will handle background
  wc.lpszMenuName   = szLoadString(IDS_MENUNAME);
  wc.lpszClassName  = DeePId;                      //szLoadString(IDS_APPNAME);   1-23-97

     if (!RegisterClassAndCheckError(1, &wc))      //if( ! RegisterClass( &wc ) )
      return( FALSE );                             //  Crawl in a hole and die if it fails

  // Pal reset
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS| CS_HREDRAW | CS_VREDRAW;   //  6-1-97 added redraws trying to fix video glitch
  wc.lpfnWndProc   = (WNDPROC)PalWndProc;   	    	// Located in Dialogs.CPP
  wc.cbClsExtra    = 0;                      	   // No per-class extra data.
  wc.cbWndExtra    = PAL_CBWNDEXTRA;             	// Per-window extra data.
  wc.hInstance     = hInst;               		   // Owner of this class
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);  // Cursor
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);    // Default color
  wc.lpszMenuName  = NULL;                       	// Menu name from .RC
  wc.lpszClassName = szLoadString(IDS_PALNAME);    // Name to register as

     if (!RegisterClassAndCheckError(2, &wc))      //if( ! RegisterClass( &wc ) )
      return( FALSE );

  // Preview
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)PreviewWndProc;      // Located in Dialogs.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);
  wc.lpszClassName = szLoadString(IDS_PREVNAME);

     if (!RegisterClassAndCheckError(3, &wc))
      return( FALSE );

  // About
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)AboutWndProc;        // Located in Dialogs.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_ABOUTNAME);

     if (!RegisterClassAndCheckError(4, &wc))
      return( FALSE );

  // Texture preview
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)TxtrPrevWndProc;     // Located in EditDlg.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_TXTRNAME);

     if (!RegisterClassAndCheckError(5, &wc))
      return( FALSE );

  // Color
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS |  CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)ColorWndProc;        // Located in PSheet.CPP
  wc.cbWndExtra    = PAL_CBWNDEXTRA;             	// Per-window extra data.
  wc.hCursor       = LoadCursor(NULL, "CURSOR_CLRPICK");
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_COLORNAME);

     if (!RegisterClassAndCheckError(6, &wc))
      return( FALSE );

  // Mapbrowser
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)MapBrowseWndProc;		// Located in NewGraph.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
  wc.lpszClassName = szLoadString(IDS_MAPBROWSENAME);

     if (!RegisterClassAndCheckError(7, &wc))
      return( FALSE );

  // Texture Browser
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)TxtrBrowseWndProc;	// Located in NewGraph.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
  wc.lpszClassName = szLoadString(IDS_TXTRBROWSENAME);

     if (!RegisterClassAndCheckError(8, &wc))
      return( FALSE );

  // Pname Texture Browser
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)PnameBrowseWndProc;        // Located in NewGraph.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
  wc.lpszClassName = szLoadString(IDS_PNAMEBROWSENAME);

     if (!RegisterClassAndCheckError(8, &wc))
      return( FALSE );

  // floor browser
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)FloorBrowseWndProc;	// Located in NewGraph.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
  wc.lpszClassName = szLoadString(IDS_FLOORBROWSENAME);

     if (!RegisterClassAndCheckError(9, &wc))
      return( FALSE );

  // Sprite Browser
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)SpriteBrowseWndProc;	// Located in NewGraph.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
  wc.lpszClassName = szLoadString(IDS_SPRITEBROWSENAME);

     if (!RegisterClassAndCheckError(10, &wc))
      return( FALSE );

  // Thing preview
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)TEditPrevWndProc;		// Located in Dialogs.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_THINGEDITNAME);

     if (!RegisterClassAndCheckError(11, &wc))
      return( FALSE );

  //	Sector Edit Preview Window Callbacks
  // displays a PREVIEW of the Floor and Ceiling Texture in
  // a modeless dialog box

  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)SEditCPrevWndProc;	// Located in Dialogs.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_SECTOREDITNAMEC);

     if (!RegisterClassAndCheckError(12, &wc))
      return( FALSE );

  // Sector edit
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)SEditFPrevWndProc;	// Located in Dialogs.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_SECTOREDITNAMEF);

     if (!RegisterClassAndCheckError(13, &wc))
         return( FALSE );

  // Line Edit Preview Window Callbacks
  // displays a PREVIEW of the Upper, Normal & Lower Txtr's in
  // a modeless dialog box

  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)LEditPrevWndProc;		// Located in Dialogs.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_LINEEDITNAME);

     if (!RegisterClassAndCheckError(14, &wc))
      return( FALSE );

  // texture alignment
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)AlignWndProc;             // In EditDlg.CPP
  wc.hCursor       = LoadCursor(NULL, "CURSOR_CLRPICK");// for compat. with the
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);         // other functions there
  wc.lpszClassName = szLoadString(IDS_ALIGNNAME);

     if (!RegisterClassAndCheckError(15, &wc))     //if( ! RegisterClass( &wc ) )
      return( FALSE );

  // tips
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)TipsWndProc;         // Located in Dialogs.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);
  wc.lpszClassName = szLoadString(IDS_TIPSNAME);

     if (!RegisterClassAndCheckError(16, &wc))
      return( FALSE );

  // TipsTutor
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)TipsTutorWndProc;    // Located in Dialogs.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);
  wc.lpszClassName = szLoadString(IDS_TIPSTUTORNAME);

     if (!RegisterClassAndCheckError(17, &wc))
      return( FALSE );

  // Lump export
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)LumpWndProc;		   // Located in Dialogs.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_LUMPNAME);

     if (!RegisterClassAndCheckError(18, &wc))
      return( FALSE );

  // composite texture edit
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)CompositeWndProc;    // Located in TEXEDIT.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_COMPOSITENAME); // class = CompositeClass

     if (!RegisterClassAndCheckError(19, &wc))
      return( FALSE );

  // composite ADD
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  8-1-97
  wc.lpfnWndProc   = (WNDPROC)CompositeWndProc;         // Located in TEXEDIT.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_COMPOSITENAMEADD);//class = CompositeAdd

     if (!RegisterClassAndCheckError(19, &wc))
      return( FALSE );

  // Sprite edit
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW; // 10-1-97
  wc.lpfnWndProc   = (WNDPROC)SpriteWndProc;             // Located in SPRITEDI.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_SPRITEEDITBROWSE); // class = SpriteEditClass

     if (!RegisterClassAndCheckError(20, &wc))
      return( FALSE );

// brad stuff================================================================

  // Quake Texture Viewer Window proc QViewClass  12-30-96 bk
  // located in the QView Dialog as viewer window
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)QViewWndProc;        // Located in QUAKE.CPP
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);    // NULL Brush SHOULD be FASTER !
  wc.lpszClassName = szLoadString(IDS_QVIEWNAME);

     if (!RegisterClassAndCheckError(21, &wc))
     {   return( FALSE );
     }

  // Quake Texture Browser  1-1-97 bk
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  //wc.cbWndExtra  = PAL_CBWNDEXTRA;         	   // Per-window extra data. ( 1 Long Pointer )
  wc.lpfnWndProc   = (WNDPROC)QBrowseWndProc;		// Located in Quake.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);    // thankyou, I'll do it
  wc.lpszClassName = szLoadString(IDS_QBROWSENAME);

     if (!RegisterClassAndCheckError(22, &wc))
      return( FALSE );


  // Our Graphic Editor  2-20-97 bk

  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)GFXWndProc;		      // Located in Drawing.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);    // thankyou, I'll do it
  wc.lpszClassName = szLoadString(IDS_GFXNAME);

     if (!RegisterClassAndCheckError(23, &wc))
      return( FALSE );

  // Our Graphic Editor Toolbar Window 2-20-97 bk

  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)ToolWndProc;		   // Located in Drawing.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);    // thankyou, I'll do it
  wc.lpszClassName = szLoadString(IDS_TOOLNAME);

     if (!RegisterClassAndCheckError(24, &wc))
      return( FALSE );

  // Our Editor Window 3-31-97 bk

  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)GFXEditWndProc;		// Located in Drawing.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);    // thankyou, I'll do it
  wc.lpszClassName = szLoadString(IDS_GFXEDITNAME);

     if (!RegisterClassAndCheckError(25, &wc))
      return( FALSE );

  // PasteLump  doom type image graphics import drawing   5-1-97

  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)PasteLumpWndProc;		// Located in Dialogs.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_PASTELUMPNAME);

     if (!RegisterClassAndCheckError(26, &wc))
      return( FALSE );

  // RenameLump
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;    //  6-1-97
  wc.lpfnWndProc   = (WNDPROC)RenameLumpWndProc;		   // Located in Dialogs.cpp
  wc.hInstance     = hInst;
  wc.hbrBackground = GetStockBrush(GRAY_BRUSH);
  wc.lpszClassName = szLoadString(IDS_RENAMELUMPNAME);

     if (!RegisterClassAndCheckError(27, &wc))
      return( FALSE );

  // help, info and error
  ZeroMemory(&wc, sizeof(wc));
  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
  wc.lpfnWndProc   = (WNDPROC)HelpWndProc;	     // Located in utils.cpp
  wc.hInstance     = hInst;
  wc.hCursor       = NULL;
  wc.hbrBackground = GetStockBrush(NULL_BRUSH);
  wc.lpszClassName = szLoadString(IDS_HELPNAME);

     if (!RegisterClassAndCheckError(28, &wc))
      return( FALSE );
  // Doom3DWALK  maybe later a different way

//  ZeroMemory(&wc, sizeof(wc));
//  wc.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ;
//  wc.lpfnWndProc   = (WNDPROC)Doom3DWndProc;	      // located in DOOM3D
//  wc.hInstance     = hInst;
//  wc.hbrBackground = GetStockBrush(GRAY,BRUSH);
//  wc.lpszClassName = szLoadString(IDS_DOOM3DNAME);
//
//     if (!RegisterClassAndCheckError(22, &wc))
//      return( FALSE );

    ZeroMemory(&wc, sizeof(wc));
    // Define the window class for this application.
    wc.style         = CS_DBLCLKS |CS_HREDRAW | CS_VREDRAW;
    wc.hInstance     = hInst;
    wc.lpfnWndProc   = (WNDPROC)HexDumpWndProc;
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
//  wc.hIcon         = LoadIcon(hInst, "HEXDUMP");//SetUpData.szAppName);
//  wc.lpszMenuName  = (LPSTR) SetUpData.szAppName;
//  wc.hIcon         = LoadIcon(hInst, "Deep");
//  wc.cbWndExtra    = DLGWINDOWEXTRA;             // for class if in dialog
    wc.hbrBackground = GetStockBrush(WHITE_BRUSH);
    wc.lpszClassName = "HexDump";//SetUpData.szAppName;

    // Register the class
     if (!RegisterClassAndCheckError(33, &wc))
          return( FALSE );

  return TRUE;
}



////////////////////////////////////////////////////////////////////////////////
//
//	Create the window and show it.
//	Called from above
//
////////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK DeePStartUpDlgProc(DIALOG_PARAMS);

Bool WindowCreate(HINSTANCE hInst, int nCmdShow)
{
  int4 n;

  hInstance = hInst;
  //   start 1-23-97
  HWND hwnd2;
  HWND hwnd1;

  if( (hwnd2 = FindWindow(DeePId,DeePId)) != NULL)     //   1-23-97
  {
       AlreadyActive = TRUE;

       if (!DialogBoxParam( gd.hInst, "DeePActive",0, DeePStartUpDlgProc,(LPARAM)0))  // can use same dlg
       {
           if ( (hwnd1 = GetLastActivePopup(hwnd2)) != NULL) // if a dialog etc. was up
           {    hwnd2 = hwnd1;                               // if so, set our handle
           }

           BringWindowToTop(hwnd2);                          // either way, bring it to top

           if(IsIconic(hwnd2))                               // if DeeP was minimized
           {  ShowWindow(hwnd2, SW_RESTORE);                 // bring it back up
           }

           return FALSE;
       }
  }
  //   end 1-23-97
  gd.hMainWindow = CreateWindow(szLoadString(IDS_APPNAME),
                                szLoadString(IDS_APPNAME),
                                WS_CLIPCHILDREN | WS_OVERLAPPEDWINDOW,
                                CW_USEDEFAULT,
                                CW_USEDEFAULT,
                                CW_USEDEFAULT,
                                CW_USEDEFAULT,
                                NULL,
                                NULL,
                                hInst,
                                NULL);

  if (!gd.hMainWindow)  return FALSE;

  // static was not set to -1 correctly

  for (n=0; n < IMAGEDRAGMAX; n++)
  {    ImageBuffer[n].imagenum = -1;       // reset
       ImageBuffer[n].hbm = NULL;
  }

  ShowWindow(gd.hMainWindow, nCmdShow);
  UpdateWindow(gd.hMainWindow);

  return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// Create Window
/////////////////////////////////////////////////////////////////////////////

#pragma argsused
BOOL Deep_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
   int  l,i;
   int4 filenamelen;                      // changed for compat Win95
   int2 filecount;

   //	Status Bar Window and Toolbar window are all part of
   //	Common controls and must be initialized first as below

   gd.OKDraw = 0;		      // Not OK to draw until we know our Splash Screen UP

	InitCommonControls();

   // Handle of our Status Bar on Bottom
	gd.hwndStatBar = CreateStatusWindow(
   	                   	WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | SBARS_SIZEGRIP,
                      		"", hwnd, IDSTAT);

	//  This loads all of our changing menus and stores their handles globally

	gd.hMainMenu 			= 	GetMenu(hwnd);  // SAVE Main menu globally
	gd.hMiscSectorMenu	=	LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUSECTOR));
	gd.hMiscThingMenu		=  LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUTHING));
	gd.hMiscLineMenu		=  LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENULINE));
	gd.hMiscVertexMenu	=  LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUVERTEX));

	//	Insert our CURRENT MISC MENU, default to SECTOR right now
	InsertMenu(gd.hMainMenu, 4, MF_BYPOSITION | MF_POPUP,
			  	  (UINT)gd.hMiscSectorMenu, (LPCTSTR) "M&isc");    //   6-1-97

   //fixup default data directories
   GetModuleFileName(gd.hInst, gd.szAppFileSpec, sizeof(gd.szAppFileSpec));

   _splitpath(gd.szAppFileSpec, 	//filespec
   gd.szExePath,  					//drive
   gd.szExeDir,    					//dir
   gd.szTemp1,  						//fname
   gd.szTemp2);  						//ext

	//path=drive+directory
	lstrcat(gd.szExePath, gd.szExeDir);

	SetCurrentDirectory((LPCTSTR)gd.szExePath);	// Make our Directory Current for future file I/O

 	//lstrcpy(gd.szSplashFile, gd.szExePath);      // not used anymore keep future splash
 	//lstrcat(gd.szSplashFile, "deeplogo.bmp");    //

//
//		Load Timers, Bmp's, Cursors, etc.  ===================================
//

   if (!SetTimer(hwnd, DeepTimer, TIMERMINUTE, NULL))       // every minute   12-18-96 that's enough
   {   //MessageBox(hwnd, szLoadString(IDS_NOTIMER), szLoadString(IDS_DEEPINFO), MB_OK);
       ErrorMsg(hwnd,"Can't Set TIMER?!");
       return FALSE;
   }

   hVertexBmp = LoadBitmap(hInstance, "VERTEX");
   if (!hVertexBmp)
   {   ErrorMsg(hwnd,"Vertex LoadBitMap failure\n\nF A T A L   E R R O R");
       //MessageBox(hwnd, szLoadString(IDS_NOBITMAP), szLoadString(IDS_FATAL), MB_OK);
       return FALSE;
   }

   // 2-20-97 bk
   //
   char WaveText[] = "WAVE_SOUNDx ";

   for (i=0; i< MAXSOUNDS; i++)
   {    itoa(i+1,&WaveText[10],10);
        hRsc          = FindResource(hInstance, WaveText, RT_RCDATA);
        if (!hRsc)
        {   ErrorMsg(NULL,"Sound Init fail %s",WaveText);
        }
        hSoundWave[i]       =         LoadResource(hInstance, hRsc);
        SoundWaveResource[i]= (LPCSTR)LockResource((LPVOID)hSoundWave[i]);
   }

   gd.hCursorMove 	 = LoadCursor(hInstance, "CURSOR_MOVE");
   gd.hCursorArrow 	 = LoadCursor(hInstance, "CURSOR_ARROW");
   gd.hCursorNo 		 = LoadCursor(hInstance, "CURSOR_NO");
   gd.hCursorSizeHorz = LoadCursor(hInstance, "CURSOR_SIZEHORZ");
   gd.hCursorSizeVert = LoadCursor(hInstance, "CURSOR_SIZEVERT");
   gd.hCursorHelp 	 = LoadCursor(hInstance, "CURSOR_HELP");
   gd.hCursorPatch 	 = LoadCursor(hInstance, "CURSOR_PATCH");
   gd.hCursorSelect 	 = LoadCursor(hInstance, "CURSOR_SELECT");

   gd.hCursorPan   	 = LoadCursor(hInstance, "CURSOR_PAN");   //11-5-96

//	Tried a font builder program and got the following
//	CreateFont(10,4,0,0,300,0,0,0,0,0,0,0,0,"BradsFont");

   MakeFonts();		// Makes our small, med and large fonts

	// Puts our number of panes in the status bar
	SizeStatusSections(gd.hwndStatBar);

	strcpy(CurrDir, gd.szExePath);
   strcpy(CHKNamePRJ,CurrDir);
   strcat(CHKNamePRJ,"DOOM2.PRJ");                  // c:\deep\doom2.prj

   //  read CHK file to get last PRJ file

   filecount = FileExists( CHKFileName ,"_CHK", FALSE ); // is .CHK online?
   if (filecount <=0) filecount = 0;
                                                    // not a .CHK file
   if (ReadCHKStatus()!= 1  || !filecount )         // read prior CHK
   {   SaveCHKStatus();                             // create .CHK file now
       FirstTimeRun=TRUE;
   }
   else
   if (!FileExists( CHKNamePRJ ,"_PRJ", FALSE ) > 0 ) // is .PRJ online?
   {   FirstTimeRun = TRUE;
   }

   LockHandle = sopen(LOKFileName, O_RDWR|O_BINARY,SH_DENYNONE,S_IREAD|S_IWRITE);  //O_RDONLY

   if (LockHandle < 0)
   {
       SaveANYStatus("LOK", LOKFileName,LOKFileName,strlen(LOKFileName) );
       LockHandle = sopen(LOKFileName, O_RDWR|O_BINARY,SH_DENYNONE,S_IREAD|S_IWRITE);  //O_RDONLY
       if (LockHandle < 0)
       {   ErrorMsg(NULL,"DEEP.LOK can't be created, AutoSave disabled");
       }
   }

   if (FirstTimeRun)
   {
     GetWindowsDirectory(EditExe, sizeof(EditExe) );  // windows directory
     strcat(EditExe,"\\NotePad.exe");                 // notepad should be here

     AutoStart    = FALSE;                // never autostart 1st time safety
     advanceInput = TRUE;                 //   12-13-96 for 1st time looks, Tip box comes up cleaner
                                          //              since level select box overlays Tip dialog

	  strcpy(PRJNameTCF,CurrDir);
	  strcat(PRJNameTCF,"DOOM2.TCF");   // texture default for project

	  SaveANYStatus("CFG", "DOOM2.CFG", CFGDeepHeader,CFGDeepControlSize);  // doom colors
	  SaveANYStatus("PRJ", "DOOM2.PRJ", PRJDeepHeader,PRJDeepControlSize);
	  SaveANYStatus("TCF", "DOOM2.TCF", TCFDeepHeader,TCFDeepControlSize);

     // FINAL DOOM Plutonia
     strcpy (MainName,"C:\\PLUTONIA\\PLUTONIA.WAD");                       // PRJ DOOM name
	  SaveANYStatus("CFG", "PLUTONIA.CFG",CFGDeepHeader,CFGDeepControlSize);// doom colors
	  SaveANYStatus("PRJ", "PLUTONIA.PRJ",PRJDeepHeader,PRJDeepControlSize);
	  SaveANYStatus("TCF", "PLUTONIA.TCF",TCFDeepHeader,TCFDeepControlSize);
     // FINAL DOOM TNT
     strcpy (MainName,"C:\\TNT\\TNT.WAD");                                 // PRJ DOOM name
	  SaveANYStatus("CFG", "TNT.CFG",   CFGDeepHeader,CFGDeepControlSize);  // doom colors
	  SaveANYStatus("PRJ", "TNT.PRJ",   PRJDeepHeader,PRJDeepControlSize);
	  SaveANYStatus("TCF", "TNT.TCF",   TCFDeepHeader,TCFDeepControlSize);

     //DOOM1
	  SetDOOM1Values();                  // set DOOM1 defaults
	  strcpy(PRJNameTCF,CurrDir);
	  strcat(PRJNameTCF,"DOOM1.TCF");    // texture default for project

	  SaveANYStatus("CFG", "DOOM1.CFG", CFGDeepHeader,CFGDeepControlSize);  // doom colors
	  SaveANYStatus("PRJ", "DOOM1.PRJ", PRJDeepHeader,PRJDeepControlSize);  // project
	  SaveANYStatus("TCF", "DOOM1.TCF", TCFDeepHeader,TCFDeepControlSize);  // texture

     // HERETIC
     SetHereticValues();                   // set HERETIC default values
	  strcpy(PRJNameTCF,CurrDir);
	  strcat(PRJNameTCF,"HERETIC.TCF");  // texture default for project

	  SaveANYStatus("CFG", "HERETIC.CFG", CFGDeepHeader,CFGDeepControlSize);
	  SaveANYStatus("PRJ", "HERETIC.PRJ", PRJDeepHeader,PRJDeepControlSize);
	  SaveANYStatus("TCF", "HERETIC.TCF", TCFDeepHeader,TCFDeepControlSize);

     // HEXEN
     SetHexenValues(); 			   	    // set HEXEN default values
	  strcpy(PRJNameTCF,CurrDir);
	  strcat(PRJNameTCF,"HEXEN.TCF");	 // texture default for project

	  SaveANYStatus("CFG", "HEXEN.CFG", CFGDeepHeader,CFGDeepControlSize);
	  SaveANYStatus("PRJ", "HEXEN.PRJ", PRJDeepHeader,PRJDeepControlSize);
	  SaveANYStatus("TCF", "HEXEN.TCF", TCFDeepHeader,TCFDeepControlSize);

     // STRIFE
     SetStrifeValues();				       // set STRIFE default values
	  strcpy(PRJNameTCF,CurrDir);
	  strcat(PRJNameTCF,"STRIFE.TCF");   // texture default for project

	  SaveANYStatus("CFG", "STRIFE.CFG", CFGDeepHeader,CFGDeepControlSize);
	  SaveANYStatus("PRJ", "STRIFE.PRJ", PRJDeepHeader,PRJDeepControlSize);
	  SaveANYStatus("TCF", "STRIFE.TCF", TCFDeepHeader,TCFDeepControlSize);

     // 1st time required since set options also save .CFG and it would be wrong

     ReadANYStatus("CFG", "DOOM2.CFG",   CFGDeepHeader,CFGDeepControlSize,CFGDeepControl);
     ReadANYStatus("PRJ", "DOOM2.PRJ",   PRJDeepHeader,PRJDeepControlSize,PRJDeepControl);
     ReadANYStatus("TCF", "DOOM2.TCF",   TCFDeepHeader,TCFDeepControlSize,TCFDeepControl);

     SetCurrentDirectory(CurrDir);
     HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,(DWORD)"First Time Installation");

   }		//  END of FIRSTIME

   //  PRJ name MUST end in PRJ

   filenamelen = strlen(CHKNamePRJ);
   if (filenamelen)
   {   l = filenamelen;
       for (i=0; i< filenamelen; i++)
       {
	        if (CHKNamePRJ[i] == '.')
	        {   l = i;
	            break;
	        }
       }

       if (l <= 123)                        // 124,125,126,127 // was <39  40 41 42 43 44
       {   strncpy(&CHKNamePRJ[l],".PRJ",5);
       }
   }

   // read project file from .CHK to get DOOMfile, and other user settings
   
   if (FileExists( CHKNamePRJ ,"_PRJ", FALSE ) > 0 ) // is .PRJ online?
   {
       PRJStatus = ReadPRJStatus();                  // read prior PRJ if any
   }

   if (PRJStatus != 1)
   {
       if (PRJStatus == -2) // old version
       {   if(!Confirm(hwnd,"The Project File is for a prior version\n\n"  //   12-13-96 changed to !
                     "If you want we can try to re-create this file\n"
                     "Click YES to try or No to exit out, then use\n"
                     "Explorer to Delete the DeeP.CHK file"))
           {
             return FALSE;   // Exit out
           }
       }
       else
       {   return FALSE;     // never recreate if not an old version
       }

       FirstTimeRun=TRUE;
       SavePRJStatus();                               // recreate PRJ if any
   }

   // now see if TCF file in PRJ is valid

   if (FileExists( PRJNameTCF ,"_TCF", FALSE ) > 0 )  // is .TCF online?
   {
       TCFStatus = ReadTCFStatus();                   // read prior TCF if any
   }

   if (TCFStatus != 1)
   {
       if (TCFStatus == -1)                           // not .TCF file
        { if(Confirm(hwnd,"    Error in your Texture File (TCF) - NOT VALID\n\n"
                     "If you want we can try to re-create this file\n"
                     "Click YES to try or No to exit out, then use\n"
                     "Explorer to Delete the DeeP.CHK file"))
           {
             FirstTimeRun=TRUE;                       // force project reselect
             SaveTCFStatus();                         // recreate TCF if any
           }
          else
           {
             return FALSE;   // Exit out
           }
        }

       //FirstTimeRun=TRUE;         Makes you re-select Project and IWAD if TRUE
       SaveTCFStatus();                            // recreate TCF if any
   }


   if (!AlreadyActive                      //   1-23-97 not active
   && CHKInUse)                            // see if someone was using file and not reset
   {
        if (!DialogBoxParam( gd.hInst, "DeePAborted",0, DeePStartUpDlgProc,(LPARAM)0))
        //NotifyMsg(NULL,"code = %hd",AlreadyActive);
        /*if (MsgInfoBox(hwnd, "!!!   WARNING   !!!",
                            "",
                            "",
                            "Last Execution Aborted",
                            "",
                            "Do you want to continue ?",
                            "",
                            "" )==FALSE) //   3-1-97 revised msginfobox*/

         {
            CHKInUse = 166;                   // prevent saving
            return FALSE; //Failed to create our process to our liking
         }
   }

   CHKInUse = 1;        //   11-3-96 set active
   SaveCHKStatus();     //   11-3-96 save  .CHK file now

   if (Maximized)  		    			  // Window Maximum Size possible with   12-13-96
	{											  // with scrolling allowed in CaptionBar
	    MaximizeWindow(hwnd,1);        // constrain cursor
   }
   else
   {   /*
       if(FirstTimeRun)						 // initialize Window Pos saved in .CHK
       {
			rcWindPos.left   = 0;
			rcWindPos.top    = 0;
			rcWindPos.right  = GetSystemMetrics(SM_CXSCREEN);
			rcWindPos.bottom = GetSystemMetrics(SM_CYSCREEN);
		   ShowWindow(hwnd, SW_MAXIMIZE);  // Make sure window knows its maximized
       } */
       
	    NormalizeWindow(hwnd);	 			// restore to normal position
   }

   SetCurrentDirectory(CurrDir);	// Make our Directory Current for future file I/O

   // open DEEP.CHK and use as a lock file

   if (FirstTimeRun)
   {   PostMessage(hwnd, WM_COMMAND, WM_FIRSTTIME, 0);	// Read in Prj & IWAD
   }
   else															   // then CreateContinue
  	{   PostMessage(hwnd, WM_COMMAND, WM_STARTUP, 0);	// Ordinary Startup
   }																   // then CreateContinue

  return TRUE;
}


/*  1-15-97 bk (  not used anywhere)
extern 	HANDLE  	hdib;		      // Our memory handle to our Splash Screen for GlobalFree
         HPALETTE hpalDib;			// Handle to Splash Screen Palette
         HBITMAP  hbmp;				// Our handle to our Deep Logo.bmp
*/

////////////////////////////////////////////////////////////////////////////////
//																				                  //
// Consolidate CFG load here   12-13-96                                     //
//	3-1-98 move Types address settings to Wadfile.cpp                          //
////////////////////////////////////////////////////////////////////////////////

void LoadAndSetCFGColors(HWND hwnd)
{

  if (GameVersion <= 2)
  {   //TypeSector  = &DoomSectorType [0];         //
	   //TypeLineDef = &DoomLineDefType[0];
	   //ThingNames  = &DoomThingNames [0];

	   MAPDirCount      = 11;
	   TxtGameType      = RDOOM;                  // DOOM

	   if (GameVersion == 2)
	   {   strcpy(CFGFileName,"DOOM2.CFG");       // DeeP.CFG file
	   }
	   else
	   {   strcpy(CFGFileName,"DOOM1.CFG");       // DeeP.CFG file
	   }
  }

  if (GameVersion == 4)
  {   TxtGameType  = RHEXEN;                 // HEXEN
	   strcpy(CFGFileName,"HEXEN.CFG");       // HEEPX.CFG
	   //TypeSector  = &HexenSectorType [0];
	   //TypeLineDef = &HexenLineDefType[0];
	   //ThingNames  = &HexenThingNames [0];
	   MAPDirCount = 12;
  }

  if (GameVersion == 3)
  {   TxtGameType      = RHERETIC;           // HERETIC
	   strcpy(CFGFileName,"HERETIC.CFG");     // HEEPH.CFG file
	   //TypeSector  = &HereticSectorType [0];  // HereticSectorType
	   //TypeLineDef = &HereticLineDefType[0];
	   //ThingNames  = &HereticThingNames [0];
	   MAPDirCount = 11;
  }

  if (GameVersion == 5)
  {   TxtGameType      = RSTRIFE;           // STRIFE
	   strcpy(CFGFileName,"STRIFE.CFG");     // STRIFE.CFG file
	   //TypeSector  = &StrifeSectorType [0];  //
	   //TypeLineDef = &StrifeLineDefType[0];
	   //ThingNames  = &StrifeThingNames [0];
	   MAPDirCount = 11;
  }

  SetCurrentDirectory(CurrDir);      //   12-13-96 obviously something is changing the current dir
                                     //              and that's why CFG fail to read in

  ReadTCFStatus();                   // texture defaults
  ReadCFGStatus();                   // palette stuff

  ForgetPens();					       // Pens and Palette
  MakePens(hwnd);				          // Load current palette in CFG file,
}

////////////////////////////////////////////////////////////////////////////////
// DeeP logo and background
////////////////////////////////////////////////////////////////////////////////

void ShowDeePLogo(HWND hwnd)
{
   HDC      hdc;
   HPALETTE hOldPal;

//-----------------------------------------------------------------------------

   hdc = GetDC(hwnd);

   hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE); // Select and realize our palette
   RealizePalette(hdc);

   ///IntroSelectScreen(hwnd,0,FALSE);                   // Get background only, not the screen saver

   //  DibFade(hdc);  //  just a reminder for me to look into this

   if (hOldPal) SelectPalette(hdc, hOldPal, FALSE);

   DialogBoxParam(gd.hInst,"About", hwnd, AboutDlgProc, (LPARAM)0);   // this does background

   //   12-18-96 like the about better for now and big .BMP can stay home

   /*
   if (DibLoadSplash())	                	// Load in our Splash Bitmap
   {
       rc.left   = ((GetSystemMetrics(SM_CXSCREEN) / 2) - 300);
       rc.top    = ((GetSystemMetrics(SM_CYSCREEN) / 2) - 150);
       rc.right  = rc.left + 600;
       rc.bottom = rc.top  + 300;

	    hpalDib	= 	DibCreatePalette(hdib);								// Create Pal from Dib
	    hbmp  	= 	DibCreateDDBitmap(hdc, hpalDib);			      // Create Bmp from Dib

		 DrawBitmap( hdc, hbmp, rc.left, rc.top, SRCCOPY);
   	 DrawEdge(hdc, &rc, EDGE_RAISED, BF_RECT | BF_SOFT);

       if (FirstTimeRun)
       {   Sleep(2000);     // 2 sec. delay just to see it
       }

       // mouse click or keyboard makes it go away

       for (i=0; i < 200; i++)
       {
            if (GetMouseCoords(hwnd,&msg,NULL,&PointerX,&PointerY,&MouseButton) //   12-13-96
            ||  MouseButton)
            {   break;
            }
            Sleep(10);
       }

	    if(hbmp) 		DeleteBitmap(hbmp); 						// Our startup splash DIB Handle
       if(hdib) 		GlobalFree(hdib);							// Free the memory for the Splash DIB
 	    if(hpalDib)	DeletePalette(hpalDib);
   } */
   ReleaseDC(hwnd, hdc);
}

////////////////////////////////////////////////////////////////////////////////
//																				                  //
// Return to here after Processing either FIRSTIME or STARTUP                 //
//   : from MENU.cpp as posted by start routines in Deep_OnCreate above     //
//																				                  //
////////////////////////////////////////////////////////////////////////////////
//  3-01-97 redone for loading files from Explorer + some things were wrong

Bool CreateContinue(HWND hwnd)
{
// HDC       hdc;
// HPALETTE hOldPal;

   int   d,i;

   FILE  *TempFile;
   int4  dirnum;
   int4  dirstart;
   char  DirName[10] = {0};
   char  WadId[4];

   char  msg1[90];
// char  msg2[90];
// char  msg3[90];

//----------------------------------------------------------------------------

   if(! OpenMainWad(FirstTimeRun) ) return FALSE;  // Main,  set DeePEditor type

   // 1-15-97 bk (already set earlier  )
   //gd.OKDraw = 0;                      // Not OK to draw until we know our Splash Screen GONE   12-18-96

   LoadAndSetCFGColors(hwnd);          // SetColors now

   SetGameMask();								// Set up the Game mask
   ChangeMiscMenu(EditMode);           // Make sure proper menu from save (in Menu.cpp)

   // open all file past and present and assign to right slots
   // save LastXloc, etc since --OpenPatchWad-- resets autocenter for map

   oldlastXloc = LastXloc;
   oldlastYloc = LastYloc;
   oldMission  = Mission;
   oldEpisode  = Episode;

   if(!FirstTimeRun || AutoStart) advanceInput = TRUE;  // always get last level worked on (was below)


   if(!AutoLoadLevel                             // not autoload
   || AssFileName[0]!='\0')                      // or a file was clicked on by Explorer
   {
      for (i=0; i < MaxSavedFileList; i++)       // 57 files reset
      {    SavedFileList[i].filename[0] = '\0';  // reset
      }

      oldlastXloc=-32666;                        // don't use old coordinates
      oldlastYloc=-32666;
      //
      //  load file pointed to in passed parm (Windows clicked in Explorer)
      //
      if (AssFileName[0]!='\0'                  // loaded by windows
      &&  strnicmp(AssFileName,"-n",2) )        // not just no load
      {
          strcpy(SavedFileList[0].filename,AssFileName);   // store name

          TempFile = FileOpen(AssFileName, "rb",OPENMISS); // open it
          AssFileName[0]='\0';                   // clear

          if (TempFile)
          {   // read in the WAD directory info
             advanceInput = TRUE;

             WadSeek( TempFile, 0);
             WadRead( TempFile, WadId,    4);        // skip WAD id
             if (!strncmp(WadId,"PWAD",4)
             ||  !strncmp(WadId,"IWAD",4) )          // or IWAD (HEXENDD)   3-1-97
             {
                 WadRead( TempFile, &dirnum,  4);    // #entries
                 WadRead( TempFile, &dirstart,4);    // offset

                 WadSeek( TempFile, dirstart);       // offset

                 // assume first entry is the right kind of level for now
                 for (d=0; d < dirnum ; d++)
                 {
                     WadRead( TempFile, DirName,8);  // offset and dirsize skip
                     WadRead( TempFile, DirName,8);  // 16 for total size
                     break;                          // just first one
                 }

	              // DooM I or HERETIC
	              if ( GameVersion == 1 || GameVersion == 3)
                 {   if (DirName[0] == 'E')
                     {   oldEpisode  = atoi(&DirName[1]);    //E#
		                   oldMission  = atoi(&DirName[3]);    //  M#
                     }
                     else
                     {   oldMission =1;
                         oldEpisode =1;
                     }
                	   wsprintf( TxtLevelName, "E%hdM%hd", oldEpisode, oldMission);
                  }
                  else
                  {   if (DirName[0] == 'M')
                      {   oldMission  = atoi(&DirName[3]);    //  MAP##
                      }
                      else
                      {   oldMission = 1;
                      }
	                   wsprintf( TxtLevelName, "MAP%02hd", oldMission);
                  }
             }
	 	       //NotifyMsg(gd.hMainWindow,  "Mission %s ",TxtLevelName); // debug
             fclose(TempFile);
          }
      }
      else
      {   oldEpisode = 1;
          oldMission = 1;                               // back to first map
          if (GameVersion == 1 || GameVersion == 3)
	       {   wsprintf( TxtLevelName, "E%hdM%hd", oldEpisode, oldMission);
	       }
	       else
	       {   wsprintf( TxtLevelName, "MAP0%hd", oldMission);
	       }

          advanceInput = FALSE;		                // user opens Edit level dialog
      }
   }
   else
   // autoload - get rid of holes now
   // ShiftFilesDown();   -0ld-                    // changes filename loc/value
   // autoload if any files are left to do
   {
       for (i=0; i < MaxSavedFileList; i++)               //56
       {
           if ( SavedFileList[i].filename[0] != '\0')
           {   //NotifyMsg(NULL,"load %d %s",i,SavedFileList[i].filename);
	             if( OpenPatchWad(SavedFileList[i].filename,CLOSE) <= 0 )
	            {   SavedFileList[i].filename[0] = '\0';    // failed-reset
               }
           }
       }
   }

   FreeNotUsedFiles();                                 // free any that somehow end up replacing one another
   ShiftFilesDown();                                   // changes filename loc/value

   LastXloc = oldlastXloc;
   LastYloc = oldlastYloc;
   Mission  = oldMission;
   Episode  = oldEpisode;

	// Set up our origins for scrolling the map

   OrigX  = LastXloc;
   OrigY  = LastYloc;

   //---------------------------------------------------------------------

   if (advanceInput)
   {
      if (GameVersion == 1 || GameVersion == 3)
	   {   wsprintf( TxtLevelName, "E%hdM%hd", Episode, Mission);
	   }
	   else
	   {   wsprintf( TxtLevelName, "MAP0%hd", Mission);
	   }
   }

   // not registered or not AutoStart    12-18-96

   MaximizeWindow(hwnd,2);              //   3-1-97 set size now

   if(!DeePRegistered                   // not registered  (shareware always shows)
   || !AutoStart                        // not autostart (normally true 1st time)
   ||  CHKRegCounter == FALSE )         // 1st time registered (just a reminder_
   {   if (DeePRegistered)              // 3-1-98 make reg users auto start after 1st time
       {   CHKRegCounter= TRUE;
           AutoStart    = TRUE;
       }
       ShowDeePLogo(hwnd);
   }

   if(FirstTimeRun|| !PatchDir[0])      // first time only, find some default directories
   {
     strcpy(PatchDir, CurrDir);         // We use it now for OpenWad
     strcpy(PasteDir, CurrDir);
   }

   if(ShowTips)
   {
      gd.hDlgTips = CreateDialogParam(gd.hInst, "Tips", hwnd, TipsDlgProc, 0 );
   }

   SetupGlobalData(hwnd);               // gd.rcClient, X max etc.

   if (!AutoStart )                     // not autostart
   {
       int4 MemoryLeftPhys;
       int4 MemoryLeftPage;
       int4 MemoryLoad;
       int4 MemoryTotalPhys;
       int4 MinContig = 500;          // contiguous memory Free  (was 2mb if > 16mb, too many questions so changed 3-1-98)

       MemoryAvailable(&MemoryLeftPhys,&MemoryLeftPage,&MemoryLoad,&MemoryTotalPhys);

       //if (MemoryTotalPhys < 16000) MinContig = 1000;    // less than 16MB

       if (MemoryTotalPhys < 16000    // less than 16MB
       &&  MemoryLeftPhys  < MinContig)
       {
           sprintf(msg1,"This system has %d Kb of Physical memory.",                   MemoryTotalPhys);
           //sprintf(msg2,"Currently there is  %d Kb of contiguous Physical Memory free",MemoryLeftPhys);

           //if (MemoryTotalPhys < 32000 )    // less than 32mb of memory
           //{
           //    sprintf(msg3,"If you have lots of programs open, we suggest closing them");
           //}
           //else
           //{
           //    sprintf(msg3,"this is not unusual after running Windows for a while. A system restart fixes.");
           //}

           HelpMsg(gd.hMainWindow,CENTER|HELPINFO,"Memory",
                                    msg1,                       // physical memory
                                    "",
                                    //msg2,                       // physical contig free
                                    //"",
                                    "A minimum of 16000 Kb is recommended to run DeeP97",
                                    "If you have lots of programs open, we suggest closing them",
                                    //msg3,
                                    "",
                                    //"A minimum of 2000 Kb is recommended to avoid excessive",
                                    //"Paging and resultant Windows 95 problems!",
                                    //"",
                                    "Texture Caching is disabled, reset using F5",
                                    ""
                                    "Select the option - Auto Start Program - (F5)",
                                    "to bypass this message the next time",
                                    NULL);

           CacheTexture = 0;
       }
       /*
       if (MemoryLeftPage < 16000)
       {
           sprintf(msg1,"There is only %d Kb of Page Memory free",MemoryLeftPage);
           HelpMsg(gd.hMainWindow,CENTER|HELPINFO,"Memory",
                                    msg1,
                                    "",
                                    "A minimum of 16000 Kb is recommended",
                                    "",
                                    "Select Auto Start Program to bypass this message (F5)",
                                    NULL);

       } */
   }

   return TRUE;
}


////////////////////////////////////////////////////////////////////////////
//	4 events that effect the visual display
//
//	1. WM_SIZE							Size changd
// 2. WM_DISPLAYCHANGE				Resolution changed
// 3. WM_PALETTE . . .				Palette changed
// 4. WM_ACTIVATEAPP					Activated or inactivated - tab, mouse etc.
/////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//
// Need to implement proper sizing of the status bar, info
// windows etc, and redo the mouse moving routine on edge of screen
//
//////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_OnSize(HWND hwnd, UINT state, int cx, int cy)
{
	RECT rc;
   HDC hdc;

   hdc = GetDC(hwnd);

   //Trace(NULL,100,4,"state %d",state);
	if (state == SIZE_MINIMIZED)
   {
   	//if(MaxConstrain)  ConstrainCursor(FALSE);
   	ConstrainCursor(FALSE);
   }
   else
   if (gd.hwndStatBar)                          // Handle of our Status Bar on Bottom
   {
       GetWindowRect(gd.hwndStatBar, &rc);
       MoveWindow(gd.hwndStatBar, 0,				// 0 position of Client
         			cy - (rc.bottom - rc.top),		// Height the same
                  cx,									// X position of the new SIZE
                  cy,									// Y position of the new SIZE
                  TRUE);

  		 SetupGlobalData(hwnd);
  		 if (MaxConstrain)   ConstrainCursor(TRUE);	// Hold cursor to window rect
       // ???   3-1-97
       // if (gd.OKDraw == 1) // this line in new but next is comment out, so should this
       //RedrawMap(hdc, &gd.rcClient, ERASEYES, FALSE);  // Erase Bk, No Palette

       if (LevelWad.filename != NULL)
       {   StatBarUpdate(EditMode, TxtLevelName, LevelWad.filename,Scale,GridScale,ScrollSpeed);
       }
   }
   ReleaseDC(hwnd, hdc);

   FORWARD_WM_SIZE(hwnd, state, cx, cy, Deep_DefProc);
}

////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_OnActivateApp(HWND hwnd, BOOL fActivate, DWORD dwThreadId)
{
	if(fActivate)		               // We are being re-activated - tab key, mouse, etc.
   {
  	   if (gd.OKDraw && !Browsing)   // Make sure not in the process of starting up, nor browsing
	   {
  		   SetupGlobalData(hwnd);
  		   if(MaxConstrain)  ConstrainCursor(TRUE);

         //KillMemBmp();  1-15-97 bk
         InvalidateRect(hwnd, NULL, TRUE);
         UpdateWindow(hwnd);
      }
   }
   else						// We are being De-Activated
   {
	    if(MaxConstrain) ConstrainCursor(FALSE);
   }
   FORWARD_WM_ACTIVATEAPP(hwnd, fActivate, dwThreadId, Deep_DefProc);
}



/////////////////////////////////////////////////////////////////////////////
//  User clicks on close button    WM_CLOSE
/////////////////////////////////////////////////////////////////////////////

void Deep_OnClose(HWND hwnd)
{
 // Query to save here
 
 SendMessage(hwnd, WM_COMMAND, CM_EXIT , 0);   // send to MENU.CPP exit process

 //FORWARD_WM_CLOSE(hwnd, Deep_DefProc);          //   3-1-97 can't cancel with this
}

////////////////////////////////////////////////////////////////////////////
//
//  PURPOSE: Calls QuerySaveChanges() in response to WM_QUERYENDSESSION.
//           User ends Windows or we send  ExitWindows function
//
//  RETURN VALUE:
//    TRUE  - continue session shutdown
//    FALSE - user wants to abort session shutdown
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL Deep_OnQueryEndSession(HWND hwnd)
{
    int nResult;
    int OkToQuit = FALSE;


    nResult = QuerySaveChanges(hwnd);
    if (nResult == IDOK)
    {   OkToQuit = TRUE;          // nothing was changes, ok to quit (  10-1-97)
    }
    else
    // want to cancel session shutdown
	 if (nResult == IDCANCEL)                   // cancel
    {   OkToQuit = FALSE;
    }
    else
    if (nResult == IDYES)                      // save changes
    {
       if (CheckZeroLengths(&LevelWad.level))  //  save with this error   3-1-97
       {   AutoSaveStop = TRUE;                //   12-20-96
           Browsing     = TRUE;

           CheckandSetSavingDataNow();         //   8-1-97
           SaveChanges(hwnd, TRUE);
           SavingDataNow = FALSE;              //

           OkToQuit = TRUE;                    // continue shut down
       }
       else
       {   OkToQuit = FALSE;                   // user wants to abort shutdown
       }
    }
    else
    if (nResult == IDNO)                       // don't save just quit
    {   OkToQuit = TRUE;
    }

    // save chkstatus as ended

    if (OkToQuit)
    {
       Deep_OnDestroy(hwnd);
    }

    return OkToQuit;
}


// The WM_QUERYNEWPALETTE message informs a window that it is about to
// receive input focus. In response, the window receiving focus should
// realize its palette as a foreground palette and update its client
// area. If the window realizes its palette, it should return TRUE;
// otherwise, it should return FALSE.
BOOL Deep_OnQueryNewPalette(HWND hwnd)
{
     HDC hdc;
     HPALETTE hOldPal;

     if (gd.hDoomPal)		// If we have a Palette
     {
         hdc = GetDC(hwnd);
         // Select and realize our palette
         hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);
         RealizePalette(hdc);

         // Redraw the entire client area
	      //KillMemBmp();								Receive after EVERY DIALOG !!!!
         //InvalidateRect(hwnd, NULL, TRUE);
         UpdateWindow(hwnd);
         if (hOldPal) SelectPalette(hdc, hOldPal, FALSE);

         ReleaseDC(hwnd, hdc);

         // Message processed, return TRUE
         return TRUE;
     }
     // Message not processed, return FALSE

     return FALSE;
}


////////////////////////////////////////////////////////////////////////////////
// The WM_PALETTECHANGED message informs all windows that the window with
// input focus has realized its logical palette, thereby changing the
// system palette. This message allows a window without input focus that
// uses a color palette to realize its logical palettes and update its
// client area.
//
// This message is sent to all windows, including the one that changed
// the system palette and caused this message to be sent. The wParam of
// this message contains the handle of the window that caused the system
// palette to change. To avoid an infinite loop, care must be taken to
// check that the wParam of this message does not match the window's
// handle.
////////////////////////////////////////////////////////////////////////////////
void Deep_OnPaletteChanged(HWND hwnd, HWND hwndPaletteChange)
{
     HDC hdc;
     HPALETTE hOldPal;


     if (gd.hDoomPal)
     {
         // If this application did not change the palette, select
         // and realize this application's palette
         if (hwnd != hwndPaletteChange)
         {
             hdc = GetDC(hwnd);

             // Select and realize our palette
             hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);
             RealizePalette(hdc);

             // WHen updating the colors for an inactive window,
             // UpdateColors can be called because it is faster than
             // redrawing the client area (even though the results are
             // not as good)
             //UpdateColors(hdc);  PRETTY SUCKY - maybe blit the bitmap ???

             // Clean up
             if (hOldPal) SelectPalette(hdc, hOldPal, FALSE);

             ReleaseDC(hwnd, hdc);
         }
     }

}

//////////////////////////////////////////////////////////////////////////////
//
//	When a WM_CLOSE is posted we get a WM_DESTROY (not any more   3-1-97)
//
// Gets WM_DESTROY from DestroyWindow() from MENU on Exit    (or ProgError)
//	Have to get rid of all of our
//	resources we allocated, MEM, Handles, Bitmaps, etc.
//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void Deep_OnDestroy(HWND hwnd)
{  int4 i;

   SetCurrentDirectory(CurrDir);

   DeePDestroyWindow(gd.hDlgTips);         // modeless Tips Dialog

   DeePDestroyWindow(gd.hDlgTipsTutor);    // modeless Tips Tutor Dialog

   GetWindowRect(hwnd, &rcWindPos);			// Save our window position for restart

	if (DeepTimer)         KillTimer(hwnd, DeepTimer);       // timer
	if (hVertexBmp)        DeleteBitmap(hVertexBmp);         // bitmap
   if (gd.hDoomPal)       DeletePalette(gd.hDoomPal);       // palette

	// Destroy all of our menus created with LoadMenu
	if(gd.hMiscSectorMenu) DestroyMenu(gd.hMiscSectorMenu);
	if(gd.hMiscThingMenu)  DestroyMenu(gd.hMiscThingMenu);
	if(gd.hMiscLineMenu)   DestroyMenu(gd.hMiscLineMenu);
	if(gd.hMiscVertexMenu) DestroyMenu(gd.hMiscVertexMenu);

	// Destroy all of our cursor's
	if(gd.hCursorMove 	 !=0)   DestroyCursor(gd.hCursorMove);
	if(gd.hCursorArrow 	 !=0)   DestroyCursor(gd.hCursorArrow);
	if(gd.hCursorHelp 	 !=0)   DestroyCursor(gd.hCursorHelp);
	if(gd.hCursorNo 		 !=0)   DestroyCursor(gd.hCursorNo);
	if(gd.hCursorSizeHorz !=0)   DestroyCursor(gd.hCursorSizeHorz);
	if(gd.hCursorSizeVert !=0)   DestroyCursor(gd.hCursorSizeVert);
	if(gd.hCursorPatch 	 !=0)   DestroyCursor(gd.hCursorPatch);
	if(gd.hCursorSelect 	 !=0)   DestroyCursor(gd.hCursorSelect);


   // Editor, Wad shutdown

   ForgetLevelData (UndoBuffer);
   ForgetLevelData (PasteBuffer);

   LastXloc = OrigX;
	LastYloc = OrigY;

   if (CHKInUse != 166)        // from create CHK routine   11-3-96
   {   CHKInUse = 0;           // reset in use
       CHKShareCounter++;      // #of times used
       SaveStatus();           // save  ALL ?? only need savechk originally??
   }

   //KillMemBmp();             // 1-15-97 bk
   ForgetFonts();
   ForgetPens();

   CloseWadFiles('X',FREEDIR,FREENAMENO);    // close all files

   ForgetLevelData(&LevelWad.level);         // free level

   ForgetTextureNames();                     // free texture

	ConstrainCursor(FALSE);

   if(HelpOpened)  WinHelp(hwnd, HelpName, HELP_QUIT, 0l);

   // to do
   if (hViewDibInfo) GlobalFree(hViewDibInfo);   // 3-31-97 bk Safety
                                                 // could also RemoveDIBSection
   for (i=0; i< MAXSOUNDS; i++)
   {    //UnlockResource(hSoundWave[i]);         // this is not a lock?   7-1-97
        UnlockResource(SoundWaveResource[i]);    //   7-1-97 Docs are contradictory about this
        FreeResource  (hSoundWave[i]);           //   7-1-97 depends where you read (even says win95 won't, but nt will)
   }

   if (LockHandle >=0) close(LockHandle);       // close locking resource

	// Tell the window to shut down !
	PostQuitMessage(0);
}



////////////////////////////////////////////////////////////////////////////////
// Handle WM_GetMinMaxInfo     req'd   3-1-97 get consistent window
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void Deep_OnGetMinMaxInfo(HWND hwnd, MINMAXINFO FAR* lpMinMaxInfo)
{
  int MaxX,MaxY;//,xScreen,yScreen;

  MaxX = GetSystemMetrics(SM_CXSCREEN);   //xScreen
  MaxY = GetSystemMetrics(SM_CYSCREEN);   //yScreen

  /*
  if(rcWindPos.left == -1024)								// .CHK not loaded yet
  {
    if (ReadCHKStatus()!= 1 )								// First time used ?
     {
      rcWindPos.left  = 20;								// Default values for first
      rcWindPos.top   = 20;
      rcWindPos.right = xScreen - 20;
      rcWindPos.bottom= yScreen - 20;
     }
    else															// Read CHK file in & use
     {
      if((rcWindPos.left < -4) || (rcWindPos.left > xScreen)) rcWindPos.left  = 20;
      if((rcWindPos.top  < -4) || (rcWindPos.top > yScreen) ) rcWindPos.top   = 20;
      if(rcWindPos.right > xScreen+4)                         rcWindPos.right = xScreen - 20;
      if(rcWindPos.bottom > yScreen+4)                        rcWindPos.bottom= yScreen - 20;
     }
   }

  MaxX = rcWindPos.right - rcWindPos.left;
  MaxY = rcWindPos.bottom - rcWindPos.top;

  if(MaxX < xScreen + 8 )		MaxX = xScreen + 8;
  if(MaxX < yScreen + 8 )		MaxY = yScreen + 8;
  */

  lpMinMaxInfo->ptMaxSize.x = MaxX;
  lpMinMaxInfo->ptMaxSize.y = MaxY;

  lpMinMaxInfo->ptMaxPosition.x =-4;//rcWindPos.left;
  lpMinMaxInfo->ptMaxPosition.y =-4;//rcWindPos.top;

  lpMinMaxInfo->ptMinTrackSize.x = MaxX/2;
  lpMinMaxInfo->ptMinTrackSize.y = MaxY/2;
  lpMinMaxInfo->ptMaxTrackSize.x = MaxX;
  lpMinMaxInfo->ptMaxTrackSize.y = MaxY;
}


////////////////////////////////////////////////////////////////////
// System sends when Prog needs to change Cursor, Child win etc.	//
////////////////////////////////////////////////////////////////////
#pragma argsused
static BOOL Deep_OnSetCursor(HWND hwnd, HWND hwndCursor, UINT codeHitTest, UINT msg)
{
 /* see Mouse.cpp since pan is disabled for now   12-13-96
 if((codeHitTest == HTCAPTION)
 &&  MaxConstrain  // constrained cursor
 && (!(msg == 0))) // msg = 0 if in a menu
 {
 		EnableCursor(hwnd, gd.hCursorMove);
  		return TRUE;
 }
  */
 FORWARD_WM_SETCURSOR(hwnd, hwndCursor, codeHitTest, msg, Deep_DefProc);
 return FALSE;
}



////////////////////////////////////////////////////////////////////////////////

//							START OF KEY PRESS ROUTINES										//

//	 	WM_KEYDOWN, 		Deep_OnKey);
//	 	WM_CHAR, 			Deep_OnChar);
//		WM_SYSKEYDOWN, 	Deep_OnSysKey);

////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Handle WM_KEYDOWN  detects keypresses
//
//    SHIFT key, CTRL KEY
//    virtkeys go to menu Deep_OnCommand
//	Used for function keys and arrow keys
//
////////////////////////////////////////////////////////////////////////////////
#define MAPSPEED 20

#pragma argsused
void Deep_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
  SHORT    keystate;
  RECT     rc;
  HDC      hdc, hMemDC;
  HBITMAP  hMemBmp, hMemOldBmp;
  int4     x,y;
  HPALETTE hOldPal;                                  //  12-2-96
  int      ElapsedTime;                              //   12-8-96

  hdc = GetDC(hwnd);
  GetClientRect(hwnd, &rc);

  //Trace(hwnd,100,4,"deeponkey %d",vk);

  //hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);  //   12-2-96
  //RealizePalette(hdc);                               //   12-2-96

  if (fDown)                                            // brad 12-8-96
  {
     if(vk == VK_SHIFT)   gd.ShiftDown = TRUE;          //   12-2-96
     if(vk == VK_CONTROL) gd.CtrlDown  = TRUE;          //   12-2-96
     if(vk == VK_MENU)    gd.AltDown   = TRUE;          //   12-2-96
  }

  hMemDC 	 = CreateCompatibleDC(hdc);
  hMemBmp 	 = CreateCompatibleBitmap( hdc, rc.right, rc.bottom);
  hMemOldBmp = SelectBitmap(hMemDC, hMemBmp);
  hOldPal    = SelectPalette(hMemDC, gd.hDoomPal, FALSE);     //  12-8-96 get colors not above duh
  //RealizePalette(hMemDC);  1-15-97   //    ..      fixes panning background thing mode
  FillRect(hMemDC, &rc, (HBRUSH)gd.hBrushes[BackColor]);

  switch(vk)	// Keys which ARE NOT Accelerator keystokes
  {
   case VK_F1:
    //if(!Selecting)  // Rectangle,Polygon, Linedraw, stairs etc has own help
    SetCurrentDirectory(CurrDir);      //   12-13-96 someone is resetting currdir sometimes
    HelpOpened = WinHelp(hwnd, HelpName, HELP_CONTENTS, 0l);
    break;
   case VK_F8:
    HandleMiscMenu(hwnd);
	 break;
   case VK_F4:
    HandleFindMenu(hwnd);
	 break;
   case VK_F9:
    HandleObjectMenu(hwnd);
	 break;
   case VK_LEFT:
    if(MoveUsingCursor && fDown) // not WM_KEYUP
	 {
      for(;;)
      {
        ElapsedTime = GetTickCount();           //   12-2-96 clock screen draw
		  if (ScrollMapRight(hMemDC, &rc))			// Scroll the map to the right   11-3-96
		  {   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
        }
        ElapsedTime = GetTickCount() - ElapsedTime;
        //if (ElapsedTime < 50) Sleep(25);              //  12-8-96 slow it down
        if (ElapsedTime < MAPSPEED) Sleep(MAPSPEED- ElapsedTime);   //  8-1-97 slow it down
        EatMouseData(hwnd);                             //   12-8-96 don't let the keys/buttons pile up

        keystate = GetAsyncKeyState(VK_LEFT);
        if(!(keystate & 0x8000)) break;
        //if (ScrollSpeed > 10) Sleep(ScrollSpeed/2);  //  11-11-96 slow it down

      }

      RedrawMap(hdc, &gd.rcClient, ERASENO, FALSE);// No Erase Bk, No Palette, this is OK
   }
	break;
  case VK_RIGHT:
	if(MoveUsingCursor && fDown)                  // not WM_KEYUP
	{

     for(;;)
      {
        ElapsedTime = GetTickCount();            // clock screen draw
		  if (ScrollMapLeft(hMemDC, &rc))			 // Scroll the map to the LEFT   11-3-96
		  {   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
        }
        ElapsedTime = GetTickCount() - ElapsedTime;
        //if (ElapsedTime < 50) Sleep(25);           //  12-8-96 slow it down
        if (ElapsedTime < MAPSPEED) Sleep(MAPSPEED-ElapsedTime); //   8-1-97 slow it down
        EatMouseData(hwnd);                          //  12-8-96 don't let the keys/buttons pile up

        keystate = GetAsyncKeyState(VK_RIGHT);
        if(!(keystate & 0x8000)) break;

      }

      RedrawMap(hdc, &gd.rcClient, ERASENO, FALSE);// no Erase Bk, No Palette, this is OK
   }
	break;
  case VK_UP:
	if(MoveUsingCursor && fDown) // not WM_KEYUP
	{
     for(;;)
      {
        ElapsedTime = GetTickCount();            // clock screen draw
		  if (ScrollMapDown(hMemDC, &rc))          //   11-3-96
		  {  BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
        }
        ElapsedTime = GetTickCount() - ElapsedTime;
        
        //if (ElapsedTime < 50) Sleep(25);        //  12-8-96 slow it down
        if (ElapsedTime < MAPSPEED) Sleep(MAPSPEED-ElapsedTime); //   8-1-97 slow it down
        EatMouseData(hwnd);                     //   12-8-96 don't let the keys/buttons pile up

        keystate = GetAsyncKeyState(VK_UP);
        if(!(keystate & 0x8000)) break;

      }

      RedrawMap(hdc, &gd.rcClient,ERASENO, FALSE); // no Erase Bk, No Palette, this is OK
   }
	break;

  case VK_DOWN:
	if(MoveUsingCursor && fDown) // not WM_KEYUP
	{
      for (;;)
      {
        ElapsedTime = GetTickCount();          // clock screen draw
		  if (ScrollMapUp(hMemDC,&rc))           // 11-3-96
		  {   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
        }
        ElapsedTime = GetTickCount() - ElapsedTime;
        //if (ElapsedTime < 50) Sleep(25);       //  12-8-96 slow it down
        if (ElapsedTime < MAPSPEED) Sleep(MAPSPEED-ElapsedTime); //   8-1-97 slow it down
        EatMouseData(hwnd);                    //   12-8-96 don't let the keys/buttons pile up

        keystate = GetAsyncKeyState(VK_DOWN);
        if(!(keystate & 0x8000)) break;
        //if (ScrollSpeed > 10) Sleep(ScrollSpeed/2);  //  11-11-96 slow it down

      }

      RedrawMap(hdc, &gd.rcClient, ERASENO, FALSE);//no Erase Bk, No Palette, this is OK
   }
	break;

  case VK_RETURN:
   GetCursorPos( &pOldCurPos );
   x = pOldCurPos.x;
   y = pOldCurPos.y;
   HandleRBUp(hwnd, x, y, flags);
   break;

  }
  SelectBitmap(hMemDC, hMemOldBmp);
  DeleteBitmap(hMemBmp);
  DeleteDC(hMemDC);
  if(hOldPal) SelectPalette(hdc, hOldPal, FALSE);     //   3-1-97 was after
  ReleaseDC(hwnd, hdc);
}

////////////////////////////////////////////////////////////////////////////////
//
// Our global variables for gd.ShiftDown etc. need to be reset upon
// the key being released. Thus...
//
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void Deep_OnKeyUp(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
 if(vk == VK_SHIFT)   gd.ShiftDown = FALSE;
 if(vk == VK_CONTROL) gd.CtrlDown  = FALSE;
 if(vk == VK_MENU)    gd.AltDown   = FALSE;

}
///////////////////////////////////////////////////////////////////////////////
//
//	Handle WM_CHAR keys  0-9, a-z etc.
//	Handle SCALE KEYS SO FAR
//	ADDED the Z key for zoom high & low
//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void Deep_OnChar(HWND hwnd, UINT ch, int cRepeat)
{
 LevelPtr level  = &LevelWad.level;
 int2 ThingDirection;
 SelPtr TempList = NULL;      // selection list temporary

//---------------------------------------------------------------------------

 if( ch == '<' || ch == ',' || ch == '>' || ch == '.' )
 {
    //HDC hdc = GetDC(hwnd);               //   12-8-96

    if ( EditMode == OBJ_THINGS)
    {    if (ch == '>' || ch == '.') ThingDirection = -1;
         else                        ThingDirection =  1;

         SelectTemp = FALSE;         //   12-8-96 fixes rotate clear, see where it should be reset?

         if (!SelectList)
         {   if (CurObject >= 0)
             {   SelectObject( &SelectList, CurObject);
                 // req'd to get erases to work correctly   11-11-96
                 HilightObject(hwnd, EditMode, CurObject, gd.hGreenPen);

                 RotateThings (hwnd, ThingDirection);// uses selectlist / builds it's own

                 ForgetSelection( &SelectList);      // get rid of old list
                 SelectTemp = FALSE;                 //   12-8-96
                 // req'd to get back to yellow again   11-11-96
                 HilightObject(hwnd, EditMode, CurObject, gd.hGreenPen);
	         }
         }
         else
         {    RotateThings (hwnd, ThingDirection);// uses selectlist / builds it's own
         }

         UpdateObjectInfo(hwnd, CurObject);

     }
     else
     {   //   11-5-96
     
         if  (SelectList)
         {    MiscOperations(hwnd, &SelectList, 1);
         }
         else
         {  if (CurObject >= 0)
  	         {   SelectObject( &TempList, CurObject);

                MiscOperations(hwnd, &TempList, 1);

	             ForgetSelection( &TempList);            // get rid of old list
	         }
         }
     }

 }
 else
 {    ProcessMapSizeCommands(hwnd, level, WM_CHAR,ch, TRUE,  FALSE);
 }
 
 XYUpdate(hwnd, PointerX,PointerY);       // update our position   3-1-97

}

/*         if(ch == 'p')	// Palette shown on screen
          {
          	if(DisplayPalette) DisplayPalette = FALSE;
            else DisplayPalette = TRUE;
			RedrawMap(hwnd, NULL, TRUE);
          }
 */

//////////////////////////////////////////////////////////////////
// This function is called whenever the ALT key is pressed.
//////////////////////////////////////////////////////////////////
#pragma argsused
static void Deep_OnSysKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{

	if (vk==VK_F10)				// F10 is also a system key  ( F10 CheckMenu
	   HandleCheckMenu(hwnd);

   FORWARD_WM_SYSKEYDOWN(hwnd, vk, cRepeat, flags, Deep_DefProc);
}


///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//		A timer !                                                              //
//    Timer1 = every minute                                                  //
//    //Timer2 = every savetime minutes NA, got rid of it
//
//    12-18-96 once screen saver starts, no more autosaves
//
///////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void Deep_OnTimer(HWND hwnd, UINT id)
{
static int    NotifyTimer      = 0;      // Notify Timer
static Bool   ScreenSaverHot   = FALSE;  // ScreenSaver Active safety, since it locks up sometimes??
static POINT  pOld;                      // Old Mouse Pos
static POINT  pNew;                      // New Mouse Pos made all static reduce overhead   12-18-96

//==============================================================================

  AutoSaveTimer ++;               // always increment

  //Trace(NULL,10,4,"timer %d",AutoSaveTimer);
  if (ScreenSaverHot) return;     //   12-18-96 not while screensaver
//if (AutoSaveStop  ) return;     //   8-1-97 not while savestop set (like when texture modifying) trying to get screensaver stop

  GetCursorPos(&pNew);            // Grab Cursor Pos

  //Trace(hwnd, 10, 26, "T%d Browse=%d, Save=%d, Select=%d, pOld=%d, pNew=%d, ScreenTime=%d, SaveTime=%d,File=%hd",
  //                    id,Browsing, AutoSaveStop, Selecting, pOld.x, pNew.x, ScreenSaverTimer,AutoSaveTimer,LevelWad.filenumber );

  if (DeepTimer==id 		          // it's the 1 minute timer
  || id == 0)                     // check file size
  {
	 if(gd.hwndStatBar)		       // If our status bar is in existance yet
  	 {
        if (ScreenSaver > 0       //   allow disable saver
        &&  id == 1               // ignore forced call by Medit   8-1-97
        //&& !AutoSaveStop        //   not stopping
        && !Browsing
        && !Selecting )
        {
           //   Screen Saver-- see if mouse has moved any

           if( (pNew.x == pOld.x)
            && (pNew.y == pOld.y) )
           {
             ScreenSaverTimer++;

             if(ScreenSaverTimer >= ScreenSaver )           //   12-18-96 was ==
             {
                //NotifyMsg(NULL,"id=%d timer=%d limit= %d",id,ScreenSaverTimer,ScreenSaver);
                if ( GetForegroundWindow()==gd.hMainWindow )  // make sure no dialogs up can cause lokups
                {    ScreenSaverHot=TRUE;                     //   12-18-96
                     IntroSelectScreen(hwnd,1, TRUE);         // The screen saver
                     RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
                     ScreenSaverHot=FALSE;
                }
                ScreenSaverTimer = 0;
             }
             return;  // don't bother checking for file size if just sitting there   12-18-96
           }
           else
           {  ScreenSaverTimer = 0;                        // reset if movement occurred
           }

           pOld.x = pNew.x;
           pOld.y = pNew.y;
        }
        //else
        //{
        //   ScreenSaverTimer = 0;                            // reset if doing something   8-1-97
        //}

        //----------------------------------------------------------------------
        //   Warn Shareware NumLineDefs, if screensaver kicks in never gets here
        //   this is triggered in Medit by call to this routine
        //----------------------------------------------------------------------

        if (!DeePRegistered && AutoMaxChk)                                                //   12-18-96
        {
             //NotifyMsg(NULL,"check %d",LevelWad.level.NumLineDefs);

             if( (LevelWad.level.NumLineDefs > 800)
              &&  LevelWad.fileinfo                                                       // a real file
              && (LevelWad.level.MadeChanges!= ShrOldNumChanges)// || AutoSaveTimer == 1 ) )    // level changes or 1st time
              &&  id == 0 )                                     // special check for size level just loaded
             {
                ShrOldNumChanges = LevelWad.level.MadeChanges;
                if(NotBeenHere)
                {  //MUST BE HERE ! and not later otherwise get another timer msg. !

                   NotBeenHere = FALSE;   // cause we have been here

                   OnlyRegBigSave();      //    12-18-96 share common msg, sets BeenNotified=TRUE until done

                   NotifyTimer = 0;       // now -0- counter
                }
                else // yes, we've been here but maybe a while ago
                {
                   NotifyTimer ++;           //   + minute

                   if( NotifyTimer >= 10 )   // over 10 minutes
                   {   if(BeenNotified)      // NotifyMsg Box gone (sets this flag)
                       {  NotBeenHere = TRUE ;
                           NotifyTimer = 0;   // now zero counter prevent too fast return
                       }
                   }

                }
             }  // Yes, over shareware limit
        }

        //}
        //}
        //else
        //------------------------------------------------------------
        //  Auto Save Timer Activated
        //------------------------------------------------------------
        //if (DeepSaveTimer==id)		//	If its our timer
        //{
        if (AutoSaveTime > 0
        &&  AutoSaveTimer >AutoSaveTime)
        {
           if ( BkpOldNumChanges != LevelWad.level.MadeChanges    //   3-1-97 now counts changes
           &&   LevelWad.filenumber >= 0        // ...    and    a real file, not IWAD
           &&   LockHandle >= 0)                // and we can lock ourselves
           {
             if( !Browsing
             &&  !AutoSaveStop
             &&  !SavingDataNow
             &&  !Selecting )
             {
                 // this is a little risky since async nature can reset these critters
                 // need exclusive locking code for these, I think you meant to not enter again?
                 // so I used ScreenSaverHot to loc out ...and added more LOCK code
                 // 12-28-96 bk
                 // actually all this should be on a seperate thread to solve that problem.
                 // but multi-threaded has its own nest of vipers which I don't feel like
                 // tackling yet.   SOON, though.

                 //   3-1-97 don't do it no changes
                 ///Trace(NULL,10,4,"old=%hd new =%hd",OldNumChanges, LevelWad.level.MadeChanges);

                 BkpOldNumChanges = LevelWad.level.MadeChanges;

                 if (BkpOldNumChanges > 0)    // have changes
                 {
                    ScreenSaverHot=TRUE;      //   12-20-96 lockout this timer routine

                    BackUpNumber++;
                    StatBarUpdate3(LevelWad.filename);  // display on bottom

                    SaveChanges(hwnd, FALSE); // this should be fast! -dedicated saver now (levelio.cpp)

                    AutoSaveTimer = 0;
                    ScreenSaverHot=FALSE;     //   12-20-96
                 }
                 else
                 {  BackUpNumber = 0;
                 }

                 //Trace(hwnd, 300, 6, "Save Timer=%d", AutoSaveTimer);
             }
           }
        }

    } // end stat bar is there
  }
}

/////////////////////////////////////////////////////////////////////////////
//               Deep  Paint
//  Windows Calls everytime a portion of our our screen is invalidated, either
//  by ourselves, or Windows ( not used much by us anymore )
//
// 1-15-97 bk minor mods
// 3-1-97   so startup select also clear screen if user moves open box
////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_OnPaint(HWND hwnd)
{ //static int FirstHere=TRUE; //   12-13-96 do earlier
  PAINTSTRUCT 	ps;
  HPALETTE		hPalOld;
//RECT         rcWindow;

 //Trace(hwnd,10,4,"DeePONPaint");

  BeginPaint(hwnd, &ps);

  // gd.hDoomPal	- Don't have a doom palette

  if(gd.hDoomPal)
  { // If our Splash BMP is gone
    //   3-1-97 (keep code in case something like this wanted later)
    //if (FirstTimeRun
    //&&  FirstHere)                    // don't do this every time   11-11-96
    //{   FirstHere = FALSE;
    //    hPalOld = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
    //    RealizePalette(ps.hdc);
    //    IntroSelectScreen(hwnd,1, FALSE); // not the screen saver
    //}

    // gd.OKDraw - some Dialog still up -OR- nodebuild not reloaded yet

    //static int Paint=0;
    //Trace(NULL,4,4,"paint %d ok=%d",Paint++,gd.OKDraw);

    // also can't paint while saving a level

    if (gd.OKDraw )                  // Either Map or About is active
    {                                // otherwise palette is different etc.
       hPalOld = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
       RealizePalette(ps.hdc);
       if (gd.OKDraw == 1)           // normal
       {                                 //NULL
           //InvalidateRect(NULL,&gd.rcClient, TRUE);  //force redraw some vid drivers don't refresh correctly
           RedrawMap(ps.hdc, &gd.rcClient, ERASEYES, FALSE|0x08000);//erase bg, no palette, no validate

           //static int painter;
           //Trace(NULL,410,34,"repaint %d",painter++);
       }
       else
       if (gd.OKDraw == 2)      // intro
       {  IntroSelectScreen(hwnd,0,FALSE);               // Get background only, not the screen saver
       }
       //else
       //if (gd.OKDraw == 3)      // open Main IWAD and anything else left over
       //{
          //FillRect(ps.hdc, &ps.rcPaint, gd.hBrushes[BackColor]); //1-?-97 bk
          // static int painter;
          // Trace(NULL,10,4,"leftoverrepaint %d",painter++);
       //}

       //   3-1-97 new does NOT have safety check
       if (hPalOld)  SelectPalette(ps.hdc, hPalOld, FALSE);  //   12-13-96
    }
    else
    { FillRect(ps.hdc, &ps.rcPaint, GetStockBrush(WHITE_BRUSH)); //
    }
 }
 else
 { FillRect(ps.hdc, &ps.rcPaint, GetStockBrush(WHITE_BRUSH)); //
 }

 EndPaint(hwnd, &ps);
}


///////////////////////////////////////////////////////////////////////
//																							//
//																							//
//				The Main Window Processing Loop									//
//																							//
//																							//
///////////////////////////////////////////////////////////////////////

static LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
//Trace(hwnd,10,4,"msg=%d   %d  %d",Message,wParam,lParam);

  switch(Message)
  {
		//cBitsPerPixel = wParam;		should check this value make sure palette etc.
		// cxScreen =  (LOWORD(lParam))
      // cyScreen =  (HIWORD(lParam))
	case WM_DISPLAYCHANGE:		// Make a message cracker for this - RESOLUTION HAS CHANGED
      //		SetMainWindowSize(hwnd);
      // Post a WM_SIZE Message ?????????
      if(!(hwnd == GetActiveWindow()))
      {   if(MaxConstrain)  ConstrainCursor(FALSE);
      }
      break;

    /*
   case WM_ERASEBKGND:
   #pragma argsused
   BOOL Deep_OnEraseBkgnd(HWND hwnd, HDC hdc)
   {
     HPALETTE		hPalOld;

     hPalOld = SelectPalette(hdc, gd.hDoomPal, FALSE);
  	  RealizePalette(hdc);

       if(EditMode != OBJ_THINGS)
                FillRect(hdc, &gd.rcClient, gd.hBrushes[BackColor] );
       else
        {
          if(PrevMode == EditMode)
                FillRect(hdc, &gd.rcClient, gd.hBrushes[BackThingColor] );
          else  FillRect(hdc, &gd.rcClient, gd.hBrushes[BackColor] );
        }

     SelectPalette(hdc, hPalOld, FALSE);

    return 0L;
     return TRUE;
   }
    */

	//	Message Crackers from windowsx.h
   //--- some of these need some lockouts so both can be going at the
   // same time  ???, eg, if mouse scroll, no keyboard input

	 HANDLE_MSG(hwnd, WM_CREATE, 			 Deep_OnCreate);
	 HANDLE_MSG(hwnd, WM_DESTROY, 		 Deep_OnDestroy);
	 HANDLE_MSG(hwnd, WM_COMMAND, 		 Deep_Command);

	 HANDLE_MSG(hwnd, WM_KEYDOWN, 		 Deep_OnKey);
	 HANDLE_MSG(hwnd, WM_KEYUP, 		    Deep_OnKeyUp);
	 HANDLE_MSG(hwnd, WM_CHAR, 			 Deep_OnChar);
	 HANDLE_MSG(hwnd, WM_SYSKEYDOWN, 	 Deep_OnSysKey);
	 HANDLE_MSG(hwnd, WM_SETCURSOR, 		 Deep_OnSetCursor);

	 HANDLE_MSG(hwnd, WM_PAINT, 			 Deep_OnPaint);

	 HANDLE_MSG(hwnd, WM_TIMER, 			 Deep_OnTimer);

	 //HANDLE_MSG(hwnd, WM_ERASEBKGND, 	 Deep_OnEraseBkgnd);
    HANDLE_MSG(hwnd, WM_GETMINMAXINFO,  Deep_OnGetMinMaxInfo);    //   3-1-97 activated
	 HANDLE_MSG(hwnd, WM_PALETTECHANGED, Deep_OnPaletteChanged);
	 HANDLE_MSG(hwnd, WM_QUERYNEWPALETTE,Deep_OnQueryNewPalette);
	 HANDLE_MSG(hwnd, WM_QUERYENDSESSION,Deep_OnQueryEndSession);  //WM_ENDSESSION
	 HANDLE_MSG(hwnd, WM_SIZE,				 Deep_OnSize);
	 HANDLE_MSG(hwnd, WM_ACTIVATEAPP,	 Deep_OnActivateApp);

	 HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, Deep_OnRButtonDown);
	 HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, Deep_OnLButtonDown);
	 HANDLE_MSG(hwnd, WM_RBUTTONDOWN, 	Deep_OnRButtonDown);
	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN, 	Deep_OnLButtonDown);
	 HANDLE_MSG(hwnd, WM_MOUSEMOVE, 		Deep_OnMouseMove);

    HANDLE_MSG(hwnd, WM_NCLBUTTONDOWN, Deep_OnNCLButtonDown);
    HANDLE_MSG(hwnd, WM_NCLBUTTONUP, 	Deep_OnNCLButtonUp);
    HANDLE_MSG(hwnd, WM_NCMOUSEMOVE, 	Deep_OnNCMouseMove);

    HANDLE_MSG(hwnd, WM_CLOSE, 	      Deep_OnClose);

    //HANDLE_MSG(hwnd, WM_DRAWITEM,      Deep_OnDrawItem);
    //HANDLE_MSG(hwnd, WM_MEASUREITEM,   Deep_OnMeasureItem);
	 default:
		return Deep_DefProc(hwnd, Message, wParam, lParam);
  }
  return Deep_DefProc(hwnd, Message, wParam, lParam);
}



///////////////////////////////////////////////////////////////////////
//
//									Edit Level
//
//	Called from Medit only
// Calls, Select Level, which in turn MAY call EditLevel Dialog
// to select a mission if advance is FALSE, indicating no advance
// level was selected, as in first time with no autostart etc. (that was turned off though, see note)
//
// READS ALL LEVEL DATA
//
///////////////////////////////////////////////////////////////////////
// Called here and also TEXTEDIT

#pragma argsused
void EditLevel(HWND hwnd, int2 episode, int2 mission, Bool newlevel, Bool advance)
{
   int2  oldmission;
   int2  oldepisode;

   AutoSaveStop = TRUE;                        // Stop AutoSaveTimer from activating   8-1-97

   Security();                                  // Registered or Shareware

   oldmission = Mission;
   oldepisode = Episode;

   SelectLevel ( &episode, &mission, advance);  // get mission

   FirstTimeRun = FALSE;

   if (episode > 0 && mission > 0)              // valid level entered
   {  if (oldepisode != episode || oldmission != mission)   //   11-3-96 restored
      {   LastXloc = -32666;                                // force recenter
	       LastYloc = -32666;                                //
      }                                                     //

      // set global episode/mission
      Episode = episode;                        // global in DeeP.c
      Mission = mission;

      CheckandSetSavingDataNow();               // checks and waits a bit   8-1-97
      ReadLevelData(&LevelWad.level,newlevel);  // closes all PWAD files and then reads new
      SavingDataNow = FALSE;

      BackUpNumber = 0;                         // reset backup number   8-1-97

      LevelWad.level.MadeChanges    = FALSE;    //   11-3-96
      LevelWad.level.MadeMapChanges = FALSE;    //   11-3-96

      BuildTextureBuffer();      // TEXTURE1/TEXTURE2
      BuildPnameBuffer();        // PNAME

      ReadWTextureNames();       // wall  textures
      ReadFTextureNames();       // floor textures

      // set to current location if not reset

      if (LastXloc != -32666 && LastXloc != -32666)   //   11-3-96 restored
      {   LastXloc = OrigX;                           //
	       LastYloc = OrigY;                           //
      }                                               //

      if (LastXloc == -32666                          //   11-3-96 restored
       && LastYloc == -32666
       || LevelWad.level.NumVertexes <=0 )
      {
          ExactMapFit();                              // recenter

          // reset location so new values will be stored
          LastXloc = 0;
          LastYloc = 0;
      }
      else
      {
          CalculateMinMax(&LevelWad.level);
          CenterMapAroundCoords( LastXloc,LastYloc );
      }
   }

   AutoSaveStop  = FALSE;        // restart AutoSaveTimer   8-1-97
}

//=========================================================================
// called from above to actually Select the level
//=========================================================================
Bool SelectLevel( int2 *episode, int2 *mission, Bool Advance)
{
	char 	**levelnames;     // array of names found for EditLevel
   int2  oldmission;
   int2  oldepisode;
   int2  m,f;
   Bool  SelectCode = TRUE;

   // default assign the LevelWAD to the main wad file info //
   CopyLevelInfo(&LevelWad, MasterWad);

   if (!MissionCount) ProgError("No Levels Found");

   levelnames = (char **)GetMemory( MissionCount * sizeof( char *));  // n pointers allocated

   for (m=0; m< MissionCount; m++)                  // the number of files
   {
       levelnames[m]=MissionFileList[m].mission;    // store addr name
   }

   // can have the list box autosort as well and junk this , whatever faster
   //qsort( levelnames, MissionCount, sizeof( char *), QsortName);

   oldmission= *mission;
   oldepisode= *episode;

   if (*mission < 1) *mission = 1;
   if (*episode < 1) *episode = 1;

   // create level name

   if (GameVersion == 1 || GameVersion == 3)                   // DOOM - HERETIC
   {   wsprintf( TxtLevelName, "E%hdM%hd", *episode, *mission);
   }
   else
   {   wsprintf( TxtLevelName, "MAP%02hd",*mission);
   }

   // see if this level name exists in list

   for (m=0; m< MissionCount; m++)                              // the number of files
   {
     	if (! strcmp(MissionFileList[m].mission,TxtLevelName) ) // store addr name
	   {
	       break;
	   }
   }

   // if mission not available- reset now
   if (m >=MissionCount)
   {
      strcpy(TxtLevelName,MissionFileList[0].mission);       // get first mission

      *mission = 1;
      *episode = 1;
      // decode current numbers
      if (GameVersion == 1 || GameVersion == 3)
      {  sscanf ( TxtLevelName, "E%hdM%hd",  episode,  mission);
      }
      else
      {  sscanf ( TxtLevelName, "MAP%hd",    mission);
      }
   }

   // create level name again (in case changed above)
   if (GameVersion == 1 || GameVersion == 3)                   // DOOM - HERETIC
   {   wsprintf( TxtLevelName, "E%hdM%hd", *episode, *mission);
       wsprintf( PlayNumber,   "%hd %hd" , *episode, *mission); // for testdoom
   }
   else
   {   wsprintf( TxtLevelName, "MAP%02hd",*mission);
       wsprintf( PlayNumber,   "%hd"   ,  *mission);           // for testdoom
   }

   // if no advance input, select level from user

   if(!Advance)
   {
       SelectCode= DialogBox(gd.hInst,"EditLevel", gd.hMainWindow, EditLevelDlgProc);// get TxtLevelName
       // decode current TxtLevelName as changed by dialog box above

       if (GameVersion == 1 || GameVersion == 3)
       {   sscanf ( TxtLevelName, "E%hdM%hd",  episode,  mission);
       }
       else
       {   sscanf ( TxtLevelName, "MAP%hd",    mission);
       }

       //    see if level selected is from a PWAD    //
       //    set LevelWad entries to correct file    //

       if (*episode > 0 && *mission > 0)
       {
           for (m=0; m< MissionCount; m++)                              // the number of files
           {
                if (! strcmp(MissionFileList[m].mission,TxtLevelName) )  // store addr name
	             {   f = MissionFileList[m].filenumber;

	                 CopyLevelInfo(&LevelWad, &WadFileList[f]);           // assign to levelwad
	                 break;
	             }
            }

            // this should NEVER happen - how could it ?
            if (m >=MissionCount)
            {
	 	          ErrorMsg(gd.hMainWindow,  "Mission %s not available",TxtLevelName);
	 		       *mission = 1;
	 	          *episode = 1;
            }
      }

  } // end of advance ( Edit Level Dialog Code to choose new level

   // reset location if different mission than last time (diff file in OpenWAD)

   if (oldepisode != *episode || oldmission != *mission)
   {   LastXloc = -32666;
       LastYloc = -32666;
   }

   FreeMemory(levelnames);

   //OldObject = -1;              //   3-1-97 looking for erase obj probs was not here before
   //CurObject = -1;              //

  //Trace(NULL,10,4,"%d,%d",LastXloc,LastYloc);
  return SelectCode;
}


///////////////////////////////////////////////////////////////////////
//
//	Entry Point for all Level Display Functions here and from MENU.CPP
//
//	Used to be part of the main loop, but now serves as the entry point
// to set up the textures, read the level data, handles editing levels
// via an EditLevel Dialog called on whether advance input is received
// on the level to display, sets up the palette, the MemDC, the Paste
// and Undo Buffer, then Invalidates the Main window to force a redraw
// with the new Level information.
//
///////////////////////////////////////////////////////////////////////

void Medit (HWND hwnd, Bool create)		// TRUE = new level FALSE = edit level
{
  int2 episode, mission;
  int4 i;

  AutoSaveStop = TRUE;                 //   12-18-96 stop autosave

  // open all file past and present and assign to right slots   12-13-96
  // save LastXloc, etc since OpenPatchWad resets locs/autocenter for map

  oldlastXloc = LastXloc;              // how we left it
  oldlastYloc = LastYloc;
  oldMission  = Mission;
  oldEpisode  = Episode;

  CloseWadFiles('O',FREEDIRNO,FREENAMENO);            // close all...   12-18-96

  // open all files past and present and assign to right slots

  for (i=0; i< MaxSavedFileList; i++)   //56
  {
      if ( SavedFileList[i].filename[0] != '\0')
      {    //NotifyMsg(NULL,"%d %s",i,SavedFileList[i].filename);
	        if( OpenPatchWad(SavedFileList[i].filename,CLOSE) <= 0 )
	        {   SavedFileList[i].filename[0] = '\0';    // failed-reset now
	        }
      }
  }

  FreeNotUsedFiles();                                 // free any that somehow end up replacing one another
  ShiftFilesDown();                                   // changes filename loc/value

  //NotifyMsg(NULL,"Medit");
  // restore where we should be        //   12-13-96

  LastXloc = oldlastXloc;
  LastYloc = oldlastYloc;
  Mission  = oldMission;
  Episode  = oldEpisode;

  // Set up our origins for scrolling the map   12-13-96

  OrigX  = LastXloc;
  OrigY  = LastYloc;

  // advanceInput = TRUE;	           // DONT open Edit level dialog

  ResetMapResident(gd.hMainWindow, TRUE,TRUE,TRUE);// reset selectlist, CurObject,OldObject

  SetGameMask();			              // Make sure to reset in case Doom - HEXEN

  LoadAndSetCFGColors(hwnd);          //   12-13-96

  InitializeLevel(UndoBuffer);

  episode        = Episode;
  mission        = Mission;

  oldGameVersion = GameVersion;      // current game
  oldMission     = Mission;
  oldEpisode     = Episode;

  EditLevel(hwnd, episode, mission, create , advanceInput);

  // see if autocenter new level

  if (OrigX == -32666)
      OrigX = (LevelWad.level.maxX + LevelWad.level.minX) / 2;
  if (OrigY == -32666)
      OrigY = (LevelWad.level.maxY + LevelWad.level.minY) / 2 - (16/Scale);

  EnableCursor(gd.hMainWindow, (HCURSOR)LoadCursor(0, IDC_ARROW));

  advanceInput = TRUE;                    // for next time when called from EditLevel

                   //1         2                3           4       5          6
  StatBarUpdate(EditMode, TxtLevelName, LevelWad.filename,Scale,GridScale,ScrollSpeed);

  SetVertexSize(Scale);							// Sets size of Vertex depending on scale

  /* prior   3-1-97
  if (!gd.hBmpWindow && !Browsing	)		// Splash Screen gone ?
  {													// Are we Browsing for a Level
  		gd.OKDraw = 1;
      HDC hdc = GetDC(hwnd);
      RedrawMap(hdc, &gd.rcClient, ERASEYES, FALSE);// Erase Bk, No Palette
      ReleaseDC(hwnd, hdc);

      NotBeenHere   = TRUE;            // force check now for size
      AutoSaveTimer = 0;               // reset autosave timer
      Deep_OnTimer(hwnd, 1);           // force level check now   12-18-96
  } */

  // bk modified 2-20-97

  AutoSaveTimer    =  0;                 // reset autosave timer
  ScreenSaverTimer =  0;                 // reset screensaver
  BkpOldNumChanges =  0;                 // for backup

  if (!Browsing)
  {												  // Are we Browsing for a Level
      NotBeenHere   = TRUE;              // force check now for size
      ShrOldNumChanges = -1;             // force check
      Deep_OnTimer(hwnd, 0);             // force level check now   12-18-96
  		gd.OKDraw = 1;

      InvalidateRect(hwnd, NULL, FALSE); // 2-20-97 bk Still Redrawing 2x
      UpdateWindow(hwnd);                // sometimes; this fixes it
  }

  AutoSaveStop  = FALSE;                 //   12-20-96

}


///////////////////////////////////////////////////////////////////////////////
// GetControlName;                                                            /
//   7-1-97 so we can create new projects                                   /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

char *GetControlName(HWND hwnd,char *szTitle, char * SaveName,int StringSize,  char * szfilter)
{
   int   flags;
   char  drive     [ 4]= {0};  // 2 'C:'  (+leading 03 for drive picture control)   3-1-97
   char  dir      [260]= {0};  // 31 (28)Includes leading, trailing backslashes (\)
   char  filename [260]= {0};  // 39 12345678 (260 win32)
   char  ext      [260]= {0};  // 43 .xxx     (260 win32)
   char  initDir  [260]= {0};  // 39 12345678 (260 win32)  +++ for long filenames

   OPENFILENAME ofn;
   char  szFile[260];
   UINT  i;
   char  chReplace;
   char  CurFilter[5]={0};
   char  szFilter[120];

   char  *dotp;                //   3-1-97
//   static char szCmpFile[260]; // bk 12-30-96

//-----------------------------------------------------------------------------

   //   3-1-97 stay in dir if that's where it came from

   flags = fnsplit(SaveName,drive,dir,filename,ext);

   if ((flags & DRIVE)
   &&  (flags & DIRECTORY))
   {
       _makepath(initDir,drive,dir,NULL,NULL);// create default dir

       strcpy(szFile,filename);
       strcat(szFile,ext);

   }
   else
   {   strcpy(initDir,PatchDir);             // use default dir
       strcpy(szFile,SaveName);
   }

   strcpy(szFilter, szfilter);			      // initialize the filter to our specs
//   strcpy(szCmpFile, SaveName);		         // Compare Save File Name too bk 12-30-96

   chReplace = szFilter[strlen(szFilter) - 1];
   for (i = 0; szFilter[i] != '\0'; i++)
   {
   	 if (szFilter[i] == chReplace)
	     szFilter[i] = '\0';
   }

   dotp = strchr( szFilter, '.');            // find . (reverse) in filter

   if (dotp)
   {   if (strlen(dotp) >=4)                 // has to have at least 4
       {   strncpy(CurFilter,dotp,4);        // filter is always .xxx
       }
   }

   memset(&ofn, 0, sizeof(OPENFILENAME));    // clear structur
   ofn.lStructSize     = sizeof(OPENFILENAME);
   ofn.hwndOwner       = hwnd;
   ofn.lpstrFilter     = szFilter;
   ofn.lpstrFile       = szFile;             // need to be careful here, not exceed callers   3-1-97
   ofn.nMaxFile        = StringSize;         // strsizeof(szFile);
   ofn.lpstrTitle      = szTitle;            // Heading

   ofn.lpstrInitialDir = initDir;            //PatchDir;   3-1-97
   ofn.Flags 		  	  = OFN_EXPLORER        // OFN_OVERWRITEPROMPT
                       | OFN_HIDEREADONLY
                       | OFN_NOCHANGEDIR
                       | OFN_PATHMUSTEXIST ; //   3-1-97+path

   if (GetSaveFileName(&ofn))               // 12-30-96 modified to NOT ask to write over if same name as entry name
   {
      // if extension, see if user supplied one, add it if missing   3-1-97

      if (CurFilter[0] != '\0')
      {
          dotp = strrchr( ofn.lpstrFile, '.'); // find . (reverse)

	       if (dotp == NULL)
          {  strcat( ofn.lpstrFile,CurFilter ); // add extension
          }
      }
      strcpy(SaveName, ofn.lpstrFile);
   }
   else
   {   SaveName[0] = '\0';
   }

   SetCurrentDirectory(CurrDir);           //   12-2-96 (safety)
   if (SaveName[0] == '\0') return NULL;   //   3-1-97
   return SaveName;
}

///////////////////////////////////////////////////////////////////////
//
//	READS New TEXTURES   -  ShortCut  Control - F6
//
///////////////////////////////////////////////////////////////////////
void ReadNewTexture(HWND hwnd)
{
   char tempname[260] = "\0";
   Bool openCode;

   if (! CheckChangesAndContinue(NULL) )  return;

   SaveStatus();                            // save  what we have
   strcpy(tempname,PRJNameTCF);             // save name

   // now get the new file name mod 12-25-96 bk
   /*
   if (GetFileName(hwnd,"Texture TCF control", tempname, 127, (char *)szLoadString(IDS_FILTERTCF), CurrDir)) //   12-13-97 len=127
   {
	   if (FileExists( tempname ,"_TCF", FALSE ) > 0 )    // is .TCF online?
	   {   strcpy(PRJNameTCF,tempname);     // store name
	       if (ReadTCFStatus() )
	       {   SavePRJStatus();             // save name in project file
	       }
	   }
	   else
      {   strcat( tempname, " is not a Valid Texture Group File" );
          ErrorMsg(hwnd,   tempname );

      }
   }*/
   if ( GetControlName(hwnd,"Texture TCF Control", tempname, 127, (char *)szLoadString(IDS_FILTERTCF) ) != NULL) //   7-1-97 any
   {
        openCode  =FileExists( tempname,"_TCF", FALSE );   // is it a .TCF (checks header) and bitches if bad

        if (openCode > 0)
	     {   strcpy(PRJNameTCF,tempname);     // store name
	         if (ReadTCFStatus() )
	         {   SavePRJStatus();             // save name in project file
	         }
	     }
	     else
        if (openCode == 0)
        {
            if (Confirm(hwnd,"!!  Texture control %s does not exist  !!\nDo you want to create a new Texture control using current settings?",tempname) )
            {
	             strcpy(PRJNameTCF,tempname);   // store name
                SaveTCFStatus();               // create new one
	             SavePRJStatus();               // save name in project file
	         }
       }
   }
}


////////////////////////////////////////////////////////////////////////////////
//
//	OPENS a New PROJECT  - used in DeeP and Menu redone   7-1-97 so we can create
//
////////////////////////////////////////////////////////////////////////////////
Bool OpenNewProject(HWND hwnd,char * szFile)
{
   HWND hDlgPRJHelp;                //   3-1-97
   Bool openCode;                   //   7-1-97

   hDlgPRJHelp = CreateDialogParam(gd.hInst, "InstructionPRJ", hwnd, InstructionPRJDlgProc, (DWORD)0); //   12-25-96

   //if ( (GetFileName(hwnd,"Game Project", szFile, 127, (char *)szLoadString(IDS_FILTERPROJECT), CurrDir) != NULL) //   7-1-97 any
 do
 {
   if ( GetControlName(hwnd,"Game Project", szFile, 127, (char *)szLoadString(IDS_FILTERPROJECT) ) != NULL) //   7-1-97 any
   {
     openCode  =FileExists( szFile,"_PRJ", FALSE );   // is it a .PRJ (checks header) and bitches if not right type

     if (openCode > 0)
     {
        DeePDestroyWindow(hDlgPRJHelp);               // get rid of the dialog
        ResetWadOpenDefaults();                       // 3-1-97   reset default numbers
        return TRUE;
     }
     else
     if (openCode == 0)
     {
        if (FirstTimeRun)
        {   NotifyMsg(NULL,"You have to select a valid project first");
            continue;
        }
        else
        if (Confirm(hwnd,"!!  Project %s does not exist  !!\nDo you want to create a new project using current settings?",szFile) )
        {
           strcpy(CHKNamePRJ,szFile);
           SavePRJStatus();                           // recreate PRJ if any
           SaveCHKStatus();                           // rewrite.CHK file now
           DeePDestroyWindow(hDlgPRJHelp);            // get rid of the dialog
           ResetWadOpenDefaults();                    // reset default numbers
           return TRUE;
        }

        DeePDestroyWindow(hDlgPRJHelp);               // get rid of the dialog
        return FALSE;
     }
     else
     {  // file exists but this is not a project type file, already told above
        // could overwrite but let's not for now
        DeePDestroyWindow(hDlgPRJHelp);               // get rid of the dialog
        return FALSE;
     }
   }
   else
   if (FirstTimeRun)
   {   if (Confirm(hwnd,"No Project choosen.\nDo you want to quit?") )
       {
           break;
       }
   }

 } while (FirstTimeRun);

 DeePDestroyWindow(hDlgPRJHelp);                    // get rid of the dialog
 return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	READS a New PROJECT   -  ShortCut  Control - F5
//
// 12-25-96 Rearranged to match DOS version - was losing SavedFileList
//  3-01-97   if loosing files ,this wasn't it (no real difference here)
//          since SaveStatus has to save it all.
//          problem was close "X" which reset it all again
//  3-1-97  Tell caller it's a bad project!
//////////////////////////////////////////////////////////////////////////////

  /*  debuggin stuff if reqd again
  for (i=0; i< MaxSavedFileList; i++)   //56
  {   if ( SavedFileList[i].filename[0] != '\0')
	   {   Trace(NULL,10,i*12+24,"reading %d %s",i, SavedFileList[i].filename);
      }
  } ++addwait
  */

#pragma argsused
void ReadNewProject(HWND hwnd)				// From Menu.cpp
{
   int i;

   char szbuf[260]         = "\0";
   char oldCHKNamePRJ[260] = "\0";

   if (! CheckChangesAndContinue(NULL) )  return;

   // 12-25-96   moved here
   LastXloc = OrigX;                     //   12-13-96 save where we are now
   LastYloc = OrigY;                     //  

   // This has to save all WAD files
   SaveStatus();                         //   12-13-96 save what we have CHK  +PRJ

   strcpy(szbuf, CHKNamePRJ);
   strcpy(oldCHKNamePRJ, CHKNamePRJ);    // save in case of IWAD probs   12-13-96

   if (OpenNewProject(hwnd,szbuf))       //   3-1-97
   {
       CloseWadFiles('X',FREEDIR,FREENAME);  // close all files   12-16-96 this scratches all file names!!!

       strcpy(CHKNamePRJ, szbuf);            // now set the new PRJ file name   12-13-96

       // 3-1-97 keep same check this first, can't be cause of save PRJ fails

       PRJStatus = ReadPRJStatus();          // read prior PRJ if any

       if (PRJStatus != 1)
       {   strcpy(CHKNamePRJ, oldCHKNamePRJ); // restore prior name   12-13-96
           ReadPRJStatus();                   // reread prior PRJ
           return ;                           // bad
       }

	    for (i=0; i < MissionCount; i++)      // reset all level file pointers
	    {   MissionFileList[i].filenumber = 0;// file its in is main
	    }

       // now make sure IWAD is there

       if (!OpenMainWad(FirstTimeRun) )              // bad main wad file (setsEdit game type if ok)
       {
           strcpy(CHKNamePRJ, oldCHKNamePRJ);        // restore prior name   12-13-96
           ReadPRJStatus();                          // reread prior
           if (!OpenMainWad(FirstTimeRun) ) return;  // main wad file, sets GAME type should be ok now, else bad banana
       }

       ForgetPens();							       // Pens and Palette
     	 ForgetLevelData (UndoBuffer);

       //   3-1-97
       OrigX  = LastXloc;                     // restore coord this level
       OrigY  = LastYloc;

       Medit(hwnd, FALSE);                    // edit level and opens all files in project

   }
}


///////////////////////////////////////////////////////////////////////
//
//	Resets all files back to Main Wad, NO PWADS active   Shift - F6
//
///////////////////////////////////////////////////////////////////////
#pragma argsused
void ResetAllFiles(HWND hwnd)
{
    int i;

	 CloseWadFiles('A',FREEDIR,FREENAME);  	// close wads and free memory+textures

	 for (i=0; i < MaxSavedFileList; i++)  	// 57 also do main (was 1)
	 {    SavedFileList[i].filename[0] = '\0';
	 }

    SavePRJStatus();                      	// save what we have (no files)

	 for (i=0; i < MissionCount; i++)       	// reset all level file pointers
	 {   MissionFileList[i].filenumber = 0; 	// file its in is main
	 }

    OpenMainWad(FirstTimeRun);               // main wad file, sets DeePEditor   12-13-96

    LastXloc = -32666;                       //   3-1-97
    LastYloc = -32666;
}

//////////////////////////////////////////////////////////////////////////////
//
//	Resets 1 file, shifts all other files up     Shift - F4
//  WARNING --- This resets LEVEL too-- so be sure to reload
//////////////////////////////////////////////////////////////////////////////
//  this is file number from LevelWad.filenumber
//  = number into  SavedFileList

void Reset1File(int2 filenumber)
{
    int2 file=filenumber;
    int4 i;

    //NotifyMsg(NULL,"reset filenumber = %hd",filenumber);

    CloseWadFiles('A',FREEDIR,FREENAMENO);       // close all wads/free mem/keep names

    for (i=0; i < MissionCount; i++)             // reset all level file pointers
    {   MissionFileList[i].filenumber = 0;       // file its in is main
    }

    if (file >= 0 && file < totfiles)
    {   SavedFileList[file].filename[0] = '\0';  // clear file name
        ShiftFilesDown();
    }

    OpenMainWad(FirstTimeRun );                  // reopen main wad file, sets DeePEditor   12-13-96

    // open all file past and present and assign to right slots

    for (i=0; i< MaxSavedFileList; i++)          //56
    {
         if ( SavedFileList[i].filename[0] != '\0')
         {    if ( OpenPatchWad(SavedFileList[i].filename,CLOSE) <= 0 ) // reset LastXloc/Yloc
              {    SavedFileList[i].filename[0] = '\0';    // failed-reset
              }
         }
    }

    LastXloc = -32666;                             //   3-1-97
    LastYloc = -32666;
}

//============================================================================
// after save, etc, Close all files, texture stuff too and IWAD, then redo
// 9-1-97 keep selected stuff selected
//============================================================================

void ReloadLevel(HWND hwnd)	// Save with NOdes or SaveAs, reload
{
   int i;
   SelPtr OldSelectList = SelectList;     // save old selection list 9-1-97
   int2 OldOldObject    = OldObject;      // ..
   int2 OldCurObject    = CurObject;      // ..
   HDC  hdc = GetDC(hwnd);

   SelectList = NULL;                     // temporary only

	CloseWadFiles('A',FREEDIR,FREENAMENO); // close all wads/free mem/keep names

	for (i=0; i < MissionCount; i++)       // reset all level file pointers
	{   MissionFileList[i].filenumber = 0; // file its in is main
	}

   ForgetPens();								   // Pens and Palette
   ForgetLevelData (UndoBuffer);
   //ForgetLevelData (PasteBuffer);

   OpenMainWad(FirstTimeRun );            // reopen main wad file, sets DeePEditor   12-13-96

   Medit(hwnd, FALSE);                    // not a new level

   // restore current select list

   SelectList = OldSelectList;        // save old selection list
   OldObject  = OldOldObject;         // ..
   CurObject  = OldCurObject;         // ..

   RedrawMap(hdc, &gd.rcClient, ERASEYES, FALSE);  // Erase Bk, No Palette
   ReleaseDC(hwnd, hdc);
}


//-------------------------------------------------------------------------
//   Store WadFile name in SavedFileList
//   sees if already have it or finds a new slot
//-------------------------------------------------------------------------

Bool StorePwad (char *filename)
{
     char *outname;
     char TempFileName[MAXFILENAME];		// 260 for Win95

     int4 i;
     int2 f;
     int4 filenumber;

     //NotifyMsg(NULL,"entry1 = %s (%s)",filename,LevelWad.filename);
     FreeNotUsedFiles();   //++
     ShiftFilesDown();     //++

     strcpy (TempFileName, filename);    // copy the name

     //  makes sure the name is not too long and make sure
     // the format is standard (that's the reason for the name) so you can compare file names
     // it's possible to create "non-standard" paths

     StandardFileName(TempFileName);

     // safety check to make sure that name is not already there
     // see where the name is now stored (if at all)

     for (i=0; i< MaxSavedFileList; i++)                     // search all
     {
          if (!stricmp(SavedFileList[i].filename,TempFileName) )
	       {   outname = SavedFileList[i].filename;           // old location
	           break;
	       }
     }

     // not found, get a new slot else we reuse the old slot

     if (i >=MaxSavedFileList)
     {   outname = FindFreeFile();        // get a new slot
	      strcpy(outname,TempFileName);
     }
     else
     //  find the wad file in the current wad file list        //
     //  close if open and set so this slot will be used again
     {
        for (filenumber=1; filenumber< Demo32 ; filenumber++)        // start with 1, 0=iwad
        {   if (WadFileList[filenumber].type[0] != NULL)
            {  if (!stricmp( TempFileName, WadFileList[filenumber].filename) )  //match
               {
                  if (WadFileList[filenumber].type[0] == 'O')
	               {   fclose ( WadFileList[filenumber].fileinfo);    // close
	               }
	               FreeMemory( WadFileList[filenumber].directory);
                  WadFileList[filenumber].directory  = NULL;
                  WadFileList[filenumber].fileinfo   = NULL;
	               WadFileList[filenumber].mission[0] = NULL;
	               WadFileList[filenumber].type[0]    = NULL;         // make available
     	            //*WadFileList[filenumber].filename   = NULL;      // show ok to use, leave name alone, since this is it
               }
            }
        }
     }

     f = OpenPatchWad( outname,CLOSE);

     if (f <=0 )                          // failed ??
     {   *outname = '\0';                 // reset back to free
     }

     //NotifyMsg(NULL,"file %hd stored = %s (%s)",f,outname,LevelWad.filename);
     return TRUE;
}

//-------------------------------------------------------------------------//
//   save the level status
//-------------------------------------------------------------------------//
Bool SaveCHKStatus(void)
{
   SaveANYStatus("CHK", CHKFileName,CHKDeepHeader,CHKDeepControlSize);
   return TRUE;
}

//-------------------------------------------------------------------------//
//   read the checkpoint status
//-------------------------------------------------------------------------//

Bool ReadCHKStatus(void)
{
   return ReadANYStatus("CHK",CHKFileName,CHKDeepHeader,CHKDeepControlSize,CHKDeepControl);
}

//-------------------------------------------------------------------------//
//   save the level status
//-------------------------------------------------------------------------//
Bool SaveStatus(void)
{
   SaveCHKStatus();        // basic options
// SaveCFGStatus();        // color palettes  !!!!!!!! somehow at startup time cfg can get Doom colors
   strncpy(PRJFirstTime,"ff",2);// indicate mainwad's been set   12-20-96
   SavePRJStatus();        // project files
// SaveTCFStatus();        // project textures   12-2-96 moved to psheet only
   return TRUE;
}

//-------------------------------------------------------------------------//
//   save the level status
//-------------------------------------------------------------------------//
Bool SaveCFGStatus(void)
{
   ////Trace(NULL,0,0,"CFGFile=%s ",CFGFileName);

   SaveANYStatus("CFG", CFGFileName,CFGDeepHeader,CFGDeepControlSize);
   return TRUE;
}

//-------------------------------------------------------------------------//
//   read the level status + space in outfile
//-------------------------------------------------------------------------//
Bool ReadCFGStatus(void)
{
   return ReadANYStatus("CFG",CFGFileName,CFGDeepHeader,CFGDeepControlSize,CFGDeepControl);
}

//-------------------------------------------------------------------------//
//   save the level status
//-------------------------------------------------------------------------//
Bool SavePRJStatus(void)
{
   return SaveANYStatus("PRJ", PRJFileName,PRJDeepHeader,PRJDeepControlSize);
}

//-------------------------------------------------------------------------//
//   save the level status
//-------------------------------------------------------------------------//
Bool SaveTCFStatus(void)
{
   SaveANYStatus("TCF", TCFFileName,TCFDeepHeader,TCFDeepControlSize);
   return TRUE;
}

//-------------------------------------------------------------------------//
//   read the level status + space in outfile
//-------------------------------------------------------------------------//

Bool ReadPRJStatus(void)
{
   return ReadANYStatus("PRJ",PRJFileName,PRJDeepHeader,PRJDeepControlSize,PRJDeepControl);
}
//-------------------------------------------------------------------------//
//   read the level status + space in outfile
//-------------------------------------------------------------------------//

Bool ReadTCFStatus(void)
{
   return ReadANYStatus("TCF",TCFFileName,TCFDeepHeader,TCFDeepControlSize,TCFDeepControl);
}

//----------------------------------------------------------------------------------
// save any status
//----------------------------------------------------------------------------------
#pragma argsused
Bool SaveANYStatus(char *FileType,char*AnyFileName,char*Header, int2 HeaderSize)
{
   FILE *FileANY;

   SetCurrentDirectory(CurrDir);	// Make our Directory Current

   //Trace(0,0,"Trace %s File=%s ",FileType,AnyFileName);bioskey(0);
   FileANY = fopen(AnyFileName, "w+b");              // and open
   if (!FileANY)
   {
      CHKInUse = 166;                               // prevent loop in error (makes CHK)  11-3-96
   	ProgError( "Create %s File=%s ,invalid name/path\ndelete DeeP.CHK to recreate",
      		   FileType,AnyFileName);

   }
   else
   {  fwrite( Header,HeaderSize,1, FileANY) ;           // write it all
      fclose (FileANY);                                 // close
   }
   return TRUE;
}

//----------------------------------------------------------------------------------
// read any status
//----------------------------------------------------------------------------------
Bool ReadANYStatus(char *FileType,char*AnyFileName,char*Header,int2 HeaderSize,int2 FileControl)
{
   FILE  *FileANY;

   static char temp1[4]; // | together
   static int2 temp2;    // | ...
   static int2 size;     // | ...

   int2   safety2 = 0x6666;    //  = "ff";              // for me to tell ok
   int2   status = 0;          // -1 = not right type,-2=oldversion, 0 = not found, 1=ok,

   //---------------------------------------------------------------------------------

   SetCurrentDirectory(CurrDir);	// Make our Directory Current new 1-?-97 bk???

   FileANY = fopen(AnyFileName, "r+b");                    // and open

   if (FileANY)
   {
      temp1[1] = 0;                                        // force bad

      int count = fread( &temp1, 8, 1, FileANY);           // read xCFG, version,size

      if (count !=1)
      {  temp1[1] = 0;
      }
      /*  I don't care if CHK is in use for now, a thought maybe? 
         if (!strncmp(FileType,"CHK",3))
         {
             if (!LockSaveStatus(LOCK)) // see if it's in use
             {   NotifyMsg(NULL,"DeeP.CHK is in use waiting for clear");

                 CheckandSetSavingDataNow();               // checks and waits for 30 secs
                 SavingDataNow = FALSE;
             }
             else
             {   LockSaveStatus(UNLOCK);
             }
         }
      }*/

      // first see if header matches
      // then check for last 2 bytes
      if ( !strncmp(&temp1[1],FileType,3) )                // xCHK, xCFG, xPRJ
      {
         status = -2;                                      // init to old version   6-1-97

      	if( temp2 == FileControl                          // version
	      && size  == HeaderSize)                           // size
	      {
	         fseek (FileANY,(int) HeaderSize -2, SEEK_SET); // file -2

	         fread( &temp2,2,1, FileANY);                   // read last 2
	         if (temp2 == safety2 )
	         {  status = 1;                                 //
	         }
	      }
      }
      else
      {  status = -1;         // wrong type of file
      }

      // see if DEEP/HEEP.PRJ file is ok

      if (status != 1)
      {
          if (status == -2)
          {
              if ( !strncmp(FileType,"CHK",3) )                // xCHK
              {   ErrorMsg(gd.hMainWindow,"!! File is Old Version !!\n\n"
                                  "%s\n\n"
                                  "All default control files will be reset to new version",AnyFileName);
              }
              else
              {   ErrorMsg(gd.hMainWindow,"!! File is Old Version !!\n\n"
                                  "%s\n\n"
                                  "Delete DEEP.CHK file to fix",AnyFileName);
              }
          }
          else
          {    ErrorMsg(gd.hMainWindow,"?? Invalid File, not for DeeP97 ??\n\n"
                                  "%s\n\n"
                                  "VERIFY and Delete DEEP.CHK file to fix",AnyFileName);
          }
 		    //MessageBox(gd.hMainWindow, szLoadString(IDS_FILEINVALID), szLoadString(IDS_DELETECHK), MB_OK);
      }
      else
      {   fseek (FileANY, 0, SEEK_SET);               // bof
          fread( Header,(int)HeaderSize,1, FileANY);  // read it all
      }

      fclose(FileANY);                                // close
   }
   return status;
}


//==========================================================================
// EnableCursor utility function
//==========================================================================
HCURSOR EnableCursor(HWND hwnd, HCURSOR Cursor)
{
  SetClassLong(hwnd, GCL_HCURSOR, (LONG)Cursor);
  return SetCursor(Cursor);
}

//==========================================================================
#pragma argsused
static void SetupGlobalData(HWND hwnd)
{
   RECT rc;

	gd.CaptionHeight = GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYCAPTION);

   //GetWindowRect(gd.hwndStatBar, &rc);
   //gd.StatusHeight = (rc.bottom - rc.top);
   GetClientRect(gd.hwndStatBar, &rc);  //   3-1-97
   gd.StatusHeight = rc.bottom;         // actual height

   GetClientRect(hwnd, &rc);
	gd.rcClient.top    = 0;
	gd.rcClient.left   = 0;
	gd.rcClient.right  = rc.right - 1;    // adjust to coordinate value
   gd.rcClient.bottom = rc.bottom -1 - (gd.StatusHeight); // -1 added   3-1-97

	ScrMaxX     = gd.rcClient.right+1;    //   3-1-97
   ScrMaxY     = gd.rcClient.bottom+1;
	ScrCenterX  = ScrMaxX /2;
   ScrCenterY  = ScrMaxY /2;
}


////////////////////////////////////////////////////////////////////////////////
// For already active or aborted
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK DeePStartUpDlgProc(DIALOG_PARAMS)
{
  AutoSaveTimer    = 0;                     // reset autosave timer   8-1-97
  ScreenSaverTimer = 0;                     // reset screen save timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
      CenterDlgPos(hDlg,-40);               //   12-18-96 keep it in the center
      return FALSE;

    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97
      break;
    //   6-1-97    this is ok I guess 7-1-97
    case WM_LBUTTONUP:
     PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
     break;

    case WM_COMMAND:
      switch LOWORD(wParam) 							// handle of the control
      {
         case IDOK:
            EndDialog( hDlg, TRUE );
            return TRUE;
         case IDCANCEL:
            EndDialog( hDlg, FALSE );
            return TRUE;
	   }
      break;
  }
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//  Lock file for exclusive save stuff
//  there's another routine but I forgot what the name was
//  ran across it and should have written it down, with it you can
//  use a memory address for same feature
//
//  (CreateMutex, WaitForSingeObject, ReleaseMutex ) sort of but that's thread oriented ?
//  I'm assuming save function can be doing it's thing while editing? maybe not?
//  Maybe I don't need this at all if only 1 func at a time can be going?
//  This is if msg comes from queue, it has to be processed before next one come in?
//
//  return status= 0 = failed
//                 1 = did it
/////////////////////////////////////////////////////////////////////////////

int LockSaveStatus(int4 locktype)
{
   int  status;

   if (LockHandle < 0) return 0;   // not opened

   if (locktype == LOCK)
   {
       status = lock(LockHandle,0,1);
       if (status == 0) return 1;
       return 0;
       // debugging stuff to help test lock, don't delete
       /*
       if (status == 0)
       {   NotifyMsg(NULL,"lock succeeded");  // when this is active start 2nd copy of deep to test stuff
            return 1;
       }
       else
       {   NotifyMsg(NULL,"lock failed");
            return 0;
       } */
   }
   else
   {   status = unlock(LockHandle,0,1);
       if (status == 0) return 1;
       return 0;
       /* more debug stuff
       if (status == 0)
       {   NotifyMsg(NULL,"unlock succeeded");
             return 1;
       }
       else
       {   NotifyMsg(NULL,"unlock failed");
             return 0;
       } */
   }
}

//-------------------------------------------------------------------------//
//                        /* end of file */
//===========================================================================

