//////////////////////////////////////
//  Program Name: MENU.CPP
//  Collection of assorted MENU routines
//////////////////////////////////////

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "deep.h"
#include "windeep.h"
#pragma hdrstop

#include <dlgs.h>

//#pragma warning (disable: 4068)
//
//	Contains the following Routines:
//
//void ChangeMiscMenu(int NewEditMode);
//void TurnOffMenuItem(HWND hwnd, UINT menuid);
//void HandleFindMenu(HWND hwnd);
//void HandleMiscMenu(HWND hwnd);
//void HandleObjectMenu(HWND hwnd);
//void HandleCheckMenu(HWND hwnd);
//void HandleModeMenu(HWND hwnd, int x, int y);

// HandlePopupMenu(hwnd, ID, p )           Generic handle menu proc
// void DisplayPopMenu(HWND hwnd, POINT pMenu, Bool setpos, POPupListPtr PopList, int2 select)

//void Deep_Command(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
// handles all Menu commands

void InitGFXWindow(HWND hwnd);                     // in Drawing.cpp 2-20-97 bk
void Doom3Dview(HWND hwnd, LevelPtr level);        // in 3DVIEW.CPP
void Doom3DWalk(HWND hwnd, LevelPtr level);        // in DOOM3D.CPP
void ViewImage (HWND hwnd);                        // in Drawing.cpp 1-10-97 bk

extern char   MapLevel[10];          // in Preview on Hook Dlg,  map viewed in WAD   3-1-97

extern int  InfoboxXs, InfoboxXe, InfoboxYs, InfoboxYe;

extern HBITMAP hMemBmp;
extern char    SpriteName[9];
extern char    TxtrName[9];   // in Dialogs
extern char    FloorName[9];  // in Dialogs
extern Bool    PopupMenu;     // True=Popup Menu displayed
// Stair values
static int2 Sfloorh;
static int2 Sceilh;
static int2 Sstepnum;
static int2 Sstepheight;
static int2 Sstepwidth;
static int2 Sstepdepth;
// Polygon value
static int2 Snumsides;
static int2 Sradius;
static int2 Spdepth;
// rectangle values
static int2 Swidth;
static int2 Slength;
static int2 Srdepth;
static int2 Srangle=0;

int PropReturn;

HMENU hTEmenu;									// A global menu handle for current EditThing
HMENU hMenu;									// A Global menu handle for other editing

Bool ShowThingPic;

LevelPtr level = &LevelWad.level;
SelPtr	sel;									// Global selection list for menus
int2		num;									// various

TPtr  TempThing;
SDPtr TempSide;

char 	szText[60];                      // Storage for strings passed to input

static int   nResult;
static Bool  createNewLevel = FALSE;      //   12-18-96
//static char  szPwad[MAXFILENAME];			// for Open Wad File
//static char  *PwadName = szPwad;
       char  PwadName[MAXFILENAME];			// for Open Wad File


////////////////////////////////////////////////////////////////
//
//  Handles tidying up for :
//  shiftF2 edit a new level
//  shiftF3 create a new level
//  shiftF4 reset  all levels
//  shiftF5 read   a PWAD
//  shiftF6 reset  1 level
//
//////////////////////////////////////////////////////////////

void EditDone(HWND hwnd, int id)
{
  createNewLevel = FALSE;               // don't make a new level   12-18-96

  if (id == CM_RESET1FILE)
  {
      //Reset1File(LevelWad.filenumber);  // current file for current level
  }
  if (id == CM_RESETALLFILES)
  {   ResetAllFiles(hwnd);              // In Deep.cpp
  }
  if (id == CM_NEWLEVEL)
  {   createNewLevel = TRUE;
  }
  if (id == CM_OPENPWAD)
  {
      StorePwad(PwadName);              // stores name in savedfilelist
      CurObject = 0;                    // and checks if ok
      OldObject = 0;                    //
  }
}

//------------------------------------------------------------------------------
// process floor height commands directly
//
//  TempList MUST have a valid selection before calling
//------------------------------------------------------------------------------
void ProcessThingCmd(int2 direction)
{
   LevelPtr level= &LevelWad.level;
   int2 heightvalue = int2(direction * DefaultHeightChange);
   SelPtr cur;

    //-------------------------------------------------------------------

    for (cur = TempList; cur; cur = cur->next)
    {
	      level->Things[ cur->objnum].height += heightvalue;
         level->MadeChanges++;
    }

}

///////////////////////////////////////////////////////////////////////////////
//
//	These are all of our menu commands and the
//	Accelerator short cuts come here if they
//	are associated with a menu item too.
//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_Command(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
extern int2 	HighGrid;
extern int2 	LowGrid;
extern Bool		GridShown;
extern int2		GridScale;
extern Bool		advanceInput;	      // for EditLevel pass thru
extern Bool 	PRJStatus;       		// project status

DLG2OPTS  d2;								// our structure for passing info to dialogs
DLGSELECT DlgSel;		  					// our Selectlist struct for passing info

LevelPtr level = &LevelWad.level;

TypeThingPtr TempType;

SelPtr  obj = NULL;
SelPtr  cur = NULL;
int2    ObjectCount;

int2    type = 0;
int4 	  x,y;								// CenterMapAroundCoords, Xloc etc.
int2    mode, direction;
int2    num;

  //Trace(hwnd,100,4,"deepcmd %d",id);
  ScreenSaverTimer = 0;             // reset screensaver timer   8-1-97

  switch(id)
  {


////////////////////////////////////////////////////////////////////////
//
//		User defined Window Messages - start at WM_USER + 0x0100 ( 0500 )
//
////////////////////////////////////////////////////////////////////////

  //////////////////////////////////////////////////////////////////////////////
  //                                                                          //
  // If we are here it means we are just starting up the prog.                //
  // load in the level and draw it.                                           //
  //                                                                          //
  // 12-25-96 bk  Added check to Project load here, exit out if not valid     //
  //////////////////////////////////////////////////////////////////////////////

   case WM_STARTUP:
     if( CreateContinue(hwnd) )	// Finish start up init.
     {   Medit(hwnd, FALSE);		// Edit a level
     }
     else
     if (OpenNewProject(hwnd,CHKNamePRJ))              //   3-1-97
     {
         PRJStatus = ReadPRJStatus();                  // read prior PRJ if any

         if (PRJStatus == 1)
         {   if( CreateContinue(hwnd) )
             {   Medit(hwnd, FALSE);	                //  Edit a level
             }
         }
         else
         {   DeePDestroyWindow(hwnd);                  //   3-1-97 extra safety, shld not occur
         }
     }
     else
     {   DeePDestroyWindow(hwnd);                      //12-25-96
         //SendMessage(gd.hMainWindow, WM_CLOSE, 0, 0);
     }
     break;

  /////////////////////////////////////////////////////////////////////////////
  //                                                                         //
  // Have to post ourselves another message to make sure the main window is  //
  // up by the time we bring up our Open File Common Dialogs so it looks OK  //
  //                                                                         //
  // ONLY ON FIRST TIME RUN
  //
  // 12-25-96 bk  Added check to Project load here, exit out if not valid     //
  /////////////////////////////////////////////////////////////////////////////
	case WM_FIRSTTIME:
     // Check for Cancel Button ?  YUP

     if (OpenNewProject(hwnd,CHKNamePRJ)) //   3-1-97
     {
       	PRJStatus = ReadPRJStatus();     // read prior PRJ if any

         if (PRJStatus == 1)
         {   AutoStart = FALSE;
             if( CreateContinue(hwnd) )
             {   Medit(hwnd, FALSE);		//  Edit a level
             }
         }
         else
         {  DeePDestroyWindow(hwnd);      //   3-1-97 extra safety, shld not occur
         }
     }
     else
     {   DeePDestroyWindow(hwnd);         // 12-25-96
     }
     break;


  //////////////////////////////////////////////////////////////////////////////
  //                                                                          //
  // Close the Modeless Dialog - Tips   Post us a Msg when Close Button Chosen//
  //                                                                          //
  //////////////////////////////////////////////////////////////////////////////
   case WM_CLOSETIPS:
     DeePDestroyWindow(gd.hDlgTips);      // modeless Tips Dialog
     gd.hDlgTips = NULL;

     DeePDestroyWindow(gd.hDlgTipsTutor); // modeless Tips Dialog
     gd.hDlgTipsTutor = NULL;

     break;

   /////////////////////////////////////////////////////////////////////////////
   //                                                                         //
   //  As in dialog.cpp after browsing in the Browse Window program control   //
   //  is returned to WM_Browse_Back posted to the parent window of gd.hParent//
   //                                                                         //
   //  In Sprites is called by clicking on the picture on the bottom info win.//
   //                                                                         //
   /////////////////////////////////////////////////////////////////////////////
   case WM_BROWSE_BACK:
    // Prob called from Pic on bottom clicked on or View All Sprites
    if(BrowseMode == SPRITES) // && MENU ???? stop from selecting into curobject
    {
       if (SelectList)             obj = SelectList;
       else if(CurObject >= 0)     SelectObject(&obj, CurObject);

       TempType = ThingNames;     //&DoomThingNames[0];

       //for (;  TempType->thingname != NULL ; TempType+=1)
       for (;  TempType->type != 0xffff ; TempType+=1)
       {
          if(!strcmp(TempType->picname, SpriteName) )
          {  type = TempType->type;
             break;
          }
       }

       for(cur=obj; cur; cur=cur->next)
       { level->Things[cur->objnum].type = type;
       }

       if(!SelectList)   ForgetSelection(&obj);

       SetCursorPos(pOldCurPos.x, pOldCurPos.y);// + gd.CaptionHeight);
       PointerX = pOldCurPos.x;
       PointerY = pOldCurPos.y-gd.CaptionHeight;  // adjust for top menu bar   11-11-96

       //        hdc , RECT    , Erase Bk, Palette in
       RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);

    }
    else
    if(BrowseMode == TEXTURES)// Returning after browsing WALL txtr's
    {
       SetCursorPos(pOldCurPos.x, pOldCurPos.y);// + gd.CaptionHeight);
       PointerX = pOldCurPos.x;
       PointerY = pOldCurPos.y-gd.CaptionHeight;  // adjust for top menu bar   11-11-96
       UpdateObjectInfo(hwnd, CurObject);
    }
    else
    if(BrowseMode == FLOORS)    // Returning after browsing floor txtr's
    {
       gd.hFloorBrowseWindow = 0; //2-20-97 bk

       if (SelectList)             obj = SelectList;
       else if(CurObject >= 0)     SelectObject(&obj, CurObject);

       if(pOldCurPos.x > SecboxX1e)         // saved click position
       {  for(cur=obj; cur; cur=cur->next)
              strncpy(level->Sectors[cur->objnum].floort, FloorName, 8);
       }
       else
       {  for(cur=obj; cur; cur=cur->next)
              strncpy(level->Sectors[cur->objnum].ceilt, FloorName, 8);
       }

       if(!SelectList)   ForgetSelection(&obj);

       SetCursorPos(pOldCurPos.x, pOldCurPos.y);// + gd.CaptionHeight);
       PointerX = pOldCurPos.x;
       PointerY = pOldCurPos.y-gd.CaptionHeight;  // adjust for top menu bar   11-11-96

       //        hdc , RECT    , Erase Bk, Palette in
       RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
       //UpdateObjectInfo(hwnd, CurObject);
    }

    InstructionsOff(); //   3-1-97 reshow bottom
    break;

////////////////////////////////////////////////////////////////////////
//
//		M E N U   Window Messages
//
////////////////////////////////////////////////////////////////////////

//
//Shift+M  	Maximize the working window
//
   case CM_MAXIMIZE:
    if (Maximized)
    {   if(MouseConstrained) NormalizeWindow(hwnd);   // Min it
        else                 MaximizeWindow(hwnd,1);  // Max it
    }
    else
    {   if(MouseConstrained) NormalizeWindow(hwnd);   // Min it
        else                 MaximizeWindow(hwnd,2);  // Max it
    }
    /*
    if (Maximized)
    {   if(MaxConstrain)    NormalizeWindow(hwnd);   // Min it
7        else                MaximizeWindow(hwnd,1);  // Max it
    }
    else
    {   if(MaxConstrain)    NormalizeWindow(hwnd);   // Min it
        else                MaximizeWindow(hwnd,2);  // Max it
    } */
    break;              //   12-13-96 missing ???

//
//	Ctrl+P  Fix the System Palette -
//
   case CM_FIXPALETTE:      // windows screwed up the palette
    ClearSystemPalette();
    break;

//
//	 Ctrl+T  Manually choose the other tag object
//
   case CM_AUTOTAG:
    AutoTag(hwnd);
    break;

//	Shift+Ctrl+G   Change Grid to desired ...  -
//NOTE: can change to generic depending on input required
//
   case CM_GRIDCHANGE:
	 strcpy(d2.sz3, "New Grid Size");

    d2.high1 = 4096;
    d2.low1  = 0;
    d2.i1    = GridScale;
    d2.sz4[0]='\0';

    if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE( Input1 ), hwnd,
   	                  Input1NumberDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
     {
      	GridScale = d2.i1;
         StatBarUpdate5(GridScale);	// Update our Status bar with new value
         if(GridShown && GridScale)
		   {
           //        hdc , RECT    , Erase Bk, Palette in
           RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
         }
     }
     break;

//
//	View Active files - shows dialog with list of loaded PWADS and IWAD
//
   case CM_VIEWACTIVEFILES:
    strcpy(d2.sz3,"");    // used default heading
    DialogBoxParam( gd.hInst, "Wadlist", hwnd, WadListDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) ;
    break;

//
//	Shift+H  Change Floor & Ceiling Height to Desired ...  -
//
   case CM_CHANGEHEIGHTC:              // Ceiling Height   1
   case CM_CHANGEHEIGHTF:              // Floor Height     2
   case CM_CHANGEHEIGHT:               // BOTH             3
     if (EditMode != OBJ_SECTORS)  break;  // only for these 8-1-98

     ForgetSelection( &TempList);            // safety

     if  (SelectList)
     {    TempList = SelectList;
     }
     else
     if (CurObject >= 0)
     {   SelectObject( &TempList, CurObject);
     }

     ObjectCount = 0;

     for (obj=TempList; obj; obj=obj->next)
     {    ObjectCount++;
     }

     // num = 3 Both, 1 Ceil, 2 Flr,              TRUE = From Dialog  Direction to change
	  ChangeSectorHeight(hwnd, int2(id - CM_CHANGEHEIGHTC + 1), TempList, ObjectCount, FALSE, 0);

     if  (!SelectList)
     {    ForgetSelection( &TempList); // get rid of old list
     }
     else
     {    TempList = NULL;             // reset since this is Selectlist
     }
     break;


 ////////////////////////////////////////////
 //  SHIFT - Page Up   Sector Ceiling Up   //
 //  SHIFT - Page Dn   Sector Ceiling Down //
 //  SHIFT - Home      Sector Floor Up     //
 //  SHIFT - End       Sector Floor Down   //
 //
 //  SHIFT - cursor up   BOTH Floor and Ceiling up     8-1-97
 //  SHIFT - cursor down BOTH Floor and Ceiling down   8-1-97
 ////////////////////////////////////////////
	case CM_SECTORCUP:
	case CM_SECTORCDOWN:
	case CM_SECTORFUP:
	case CM_SECTORFDOWN:

	case CM_SECTORBOTHUP:
	case CM_SECTORBOTHDOWN:
     if (EditMode != OBJ_SECTORS
     &&  EditMode != OBJ_THINGS ) break;   // only for these 8-1-97

     switch(id - CM_SECTORCUP + 1)
     {
       case(1):           // ceiling up
        mode = 1;
        direction = 1;
        break;
       case(2):           // ceiling down
        mode = 1;
        direction = -1;
        break;
       case(3):           // floor up
        mode = 2;
        direction = 1;
        break;
       case(4):           // floor down
        mode = 2;
        direction = -1;
        break;
       case(5):           // ceiling/floor up
        mode = 3;
        direction = 1;
        break;
       case(6):           // ceiling/floor down
        mode = 3;
        direction = -1;
        break;
     }

     ForgetSelection( &TempList);            // safety

     if (SelectList)
     {   TempList = SelectList;
     }
     else
     if (CurObject >= 0)
     {   SelectObject( &TempList, CurObject);
     }

     if (EditMode == OBJ_SECTORS)
     {   // mode = 1 Ceil, 2 Flr, Count = 0, FALSE ! From Dialog, Up or Down
	      ChangeSectorHeight(hwnd, mode, TempList, 0, FALSE, direction);
     }
     else
     if (EditMode == OBJ_THINGS)
     {
         ProcessThingCmd( direction);
     }


     if  (!SelectList)
     {
          ForgetSelection( &TempList); // get rid of old list
     }
     else
     {    TempList = NULL;             // reset since this is Selectlist
     }

     //  UpdateObjectInfo(hwnd, CurObject);    // info on bottom for sectors   3-1-97 done already

     break;

//
//	Alt+X  Center Map on Screen
//
   case CM_CENTERMAP:

	  CalculateMinMax(level);// make sure coordinates up to date

     x = (level->maxX + level->minX) / 2;	// Find the center of our Map
     y = (level->maxY + level->minY) / 2 - (16/Scale);	// Coordinates

     CenterMapAroundCoords(x, y);
     //        hdc , RECT    , Erase Bk, Palette in
     RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
     InstructionsOff(); //   3-1-97 reshow bottom
     break;


//
//	Alt+Z - Exact Fit Map on Screen
//
   case CM_FITMAP:
	  ExactMapFit();                   // in utils.cpp
     //        hdc , RECT    , Erase Bk, Palette in
     RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
     InstructionsOff(); //   3-1-97 reshow bottom
     break;
//
//	 [-Slower  ] Change Map Scroll Delay Speed ...
//
   case CM_DELAYDOWN:
	  if(ScrollSpeed > 1)
     ScrollSpeed --;
	  StatBarUpdate6(ScrollSpeed);
     SoundBeep(SOUNDCLICK1);
     break;
   case CM_DELAYUP:
	  if(ScrollSpeed < 50)
     ScrollSpeed ++;
	  StatBarUpdate6(ScrollSpeed);
     SoundBeep(SoundClick1);
     break;


//
//	ReTag renumber all tags
//
   case CM_RETAG:
     RenumberTags(hwnd);
     //        hdc , RECT    , Erase Bk, Palette in
     RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
     InstructionsOff(); //   3-1-97 reshow bottom
     break;
///////////////////////////////////////////////////////////////////////
//	Help Menu
///////////////////////////////////////////////////////////////////////

//
//	Display the About Box
//
   case CM_HELPABOUT:
	  DialogBoxParam(gd.hInst,"About", hwnd, AboutDlgProc, (LPARAM)1);
	  break;
//
//	HELP INDEX
//
	case CM_HELPINDEX:
     HelpOpened = WinHelp(hwnd, HelpName, HELP_INDEX, 0l); // suppose to use HELP_FINDER, leave it this way looks better
	  break;
//
// Help keyboard
//
	case CM_HELPKEYBOARD:
     HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,(DWORD)"Keyboard and Mouse Command Summary");//CONTEXT, 20);  //2
	  break;
//
//	HELP COMMANDS
//
   case CM_HELPCOMMANDS:
     HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,(DWORD)"Overview of ALL commands");//CONTEXT, 6);  //3
	  break;
//
//	Help Tutorial
//
   case CM_HELPTUTORIALLEVEL:
     HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,(DWORD)"Tutorial Levels");//CONTEXT, 23);  //
	  break;
//
// Help Quick Start
//
   case CM_HELPTUTORIALQUICK:
     HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,(DWORD)"Tutorial Quick Start");//CONTEXT, 23);  //
	  break;
//
// Help order
//
	case CM_HELPPRINTORDER:
     HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,(DWORD)"Registration");//CONTEXT, 20);  //2
	  break;
//
// Tips of the Day
//
   case CM_TIPCOMMAND:
     DeePDestroyWindow(gd.hDlgTips); // modeless Tips Dialog made before, should be gone though
     gd.hDlgTips = CreateDialogParam(gd.hInst, "Tips", hwnd, TipsDlgProc, 0 ); // store pointer for destruction
	  break;
//
// Tutorial Tips
//
   case CM_TIPTUTORCOMMAND:
     DeePDestroyWindow(gd.hDlgTipsTutor); // modeless Tips Dialog made before, should be gone though

     gd.hDlgTipsTutor = CreateDialogParam(gd.hInst, "TipsTutor", hwnd, TipsTutorDlgProc, 0 ); // store pointer for destruction
	  break;

// Under the Help Menu, ScreenSaver

   case CM_SCREENSAVER:
     IntroSelectScreen(hwnd,1, TRUE);       //  the screen saver
     //        hdc , RECT    , Erase Bk, Palette in
     RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
	  break;

// Under the Help Menu

   case CM_DEEP97BENCH:
     Deep97BenchMark();
	  break;

// F5 - 	Display the OPTIONS DIALOG

   case CM_OPTIONSMENU:
	  PropReturn = CreateOptionsSheet(hwnd, gd.hInst);
     //Trace(hwnd, 500,8,"PropRtn %d, Line %d - Map %d",PropReturn,MapBrowseColorPwadLines,MapBrowseColorPwad);
     //        hdc , RECT    , Erase Bk, Palette in
     RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
	  // if(!MaxConstrain) ConstrainCursor(FALSE);
	  break;

///////////////////////////////////////////////////////////////////////
//	Exit Program   -   If changes made, request confirmation
// Alt+F4, or Menu choice or Post from WM_CLOSE in DEEP.CPP
///////////////////////////////////////////////////////////////////////

	case CM_EXIT:
     nResult = QuerySaveChanges(hwnd);

	  if (nResult == IDCANCEL)
     {   break;                       // cancel out of exit
     }
     else
     if (nResult == IDNO              // do not save changes but  exit
     ||  nResult == IDOK)             // nothing to save     just exit
     {   DeePDestroyWindow(hwnd);
     }
     else
     if (nResult == IDYES)            // save changes
     {
         if (CheckZeroLengths(level)) //  save with this error   3-1-97
         {
           AutoSaveStop = TRUE;       // stop AutoSaveTimer from activating   12-20-96
           Browsing     = TRUE;
           SaveChanges(hwnd, TRUE);   //Save what we have
           DeePDestroyWindow(hwnd);
         }
     }
     break;


//////////////////////////////////////////////////////////////////////////
//																								//
//					  Edit , Open, Reset  												//
//																								//
//////////////////////////////////////////////////////////////////////////


//    case (0x5500):     // shiftF2 edit a new level
//    case (0x5600):     // shiftF3 create a new level
//    case (0x5700):     // shiftF4 reset  all levels
//    case (0x5800):     // shiftF5 read   a PWAD
//    case (0x5900):     // shiftF6 reset  1 level

	case CM_RESET1FILE:
    if (!CheckChangesAndContinue(NULL) ) break; // check for changes
    // now get the file to reset
    strcpy(d2.sz3,"Select File to Reset");
    if( DialogBoxParam( gd.hInst, "Wadlist", hwnd, WadListDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
    {
        // d2.i1 = filenumber passed back
        if (d2.i1 >=0)
        {
            Reset1File(d2.i1);//LevelWad.filenumber);  // current file for current level
            advanceInput = FALSE;
	 	    	Medit(hwnd, FALSE);          // also sets editing/timer
        }
    }
    break;

	case CM_NEWLEVEL:
	case CM_EDITLEVEL:
   case CM_OPENPWAD:
	case CM_RESETALLFILES:
    int2     episode, mission;                  // temp wrk
    WadFiles SaveLevelWad;                      //

    if (!CheckChangesAndContinue(NULL) ) break; // check for changes

    AutoSaveStop = TRUE;                        // stop AutoSaveTimer from activating   12-20-96
    AutoSaveTimer = 0;                          // reset autosave timer

	 episode = Episode;
    mission = Mission;

  	 // save current level info, since SelectLevel changes it  //
    Browsing = TRUE;

	 CopyLevelInfo(&SaveLevelWad, &LevelWad);

    advanceInput = TRUE;
    //------------------------
    // NEW, EDIT, RESETS
    //------------------------
    if (id != CM_OPENPWAD)                    // not openwad
    {   Bool SelectCode;

        LastXloc = OrigX;                     //   3-1-97 save where we are now
        LastYloc = OrigY;                     //          in case same

        SelectCode = SelectLevel( &episode, &mission, FALSE);      // this changes LevelWad
        if (!SelectCode)                              // cancelled 10-1-97
        {   id = CM_EDITLEVEL;
        }

   	  if (GameVersion == 1 || GameVersion == 3)     // DOOM - HERETIC
   	  {   sprintf( TxtLevelName, "E%hdM%hd", episode, mission);
   	  }
   	  else
   	  {   sprintf( TxtLevelName, "MAP%02hd",mission);
   	  }

        OrigX = LastXloc;                      // if reset for new level
        OrigY = LastXloc;

        Mission = mission;
        Episode = episode;
    }
    else
  	 if (!GetWadName(hwnd, "Open PWAD",PwadName, 259, IDS_FILTERWAD, PatchDir) )
	 {    mission = 0;
         advanceInput = FALSE;
    }
    else
    {   //   3-1-97 pick up the new mission
        strncpy(TxtLevelName,MapLevel,8);        //   3-1-97 get level in file
        // decode current numbers
        if (GameVersion == 1 || GameVersion == 3)
        {  sscanf ( TxtLevelName, "E%hdM%hd",  &Episode,  &Mission);
        }
        else
        {  sscanf ( TxtLevelName, "MAP%hd",    &Mission);
        }

        mission = Mission;
        episode = Episode;
        OrigX == -32666;                         //   3-1-97 autosize
        OrigY == -32666;

        GetCursorPos(&pOldCurPos);               //   12-1-97 keep cursor same after open
    }

	 CopyLevelInfo(&LevelWad, &SaveLevelWad);   // back to this level

    Browsing = FALSE;

	 if (episode > 0 && mission > 0)
    {
		   ForgetLevelData (UndoBuffer);	        // reinitialized for each level ?
    		ForgetPens();								  // Have to because of re-read of CFG

         LastXloc = OrigX;                     //   3-1-97 save where we are now
         LastYloc = OrigY;                     //          in case same

         EditDone(hwnd, id);                   // read or reset level

	 	 	Medit(hwnd, createNewLevel);          // also sets editing/timer
    }

    AutoSaveTimer = 0;                          // reset autosave timer
    AutoSaveStop  = FALSE;                      // start AutoSaveTimer   12-20-96

    // keep mouse same loc

    if (id == CM_OPENPWAD)                      // openwad
    {
        SetCursorPos(pOldCurPos.x, pOldCurPos.y); //   12-1-97 keep same pos
    }

    break;

//	Shift+F1 Test the Level (all files)

	case CM_TESTLEVEL:
      if (DeePRegistered)
      {   TestDoom(hwnd, FALSE);
          Sleep(200);
          SetForegroundWindow(hwnd);
      }
      else
      {   OnlyRegistered();
          break;
      }
      break;

//	Ctrl+F1  Test the Level

	case CM_TESTALLLEVELS:
      if (DeePRegistered)
      {   TestDoom(hwnd, TRUE);// TRUE - Test all levels loaded
          Sleep(200);
          SetForegroundWindow(hwnd);
      }
      else
      {   OnlyRegistered();
          break;
      }
      break;

// Ctrl+B	View The Clipboard

	case CM_VIEWCLIPBOARD:
    ViewClipboard(hwnd);
    break;

//	Ctrl+F7  View PCX / BMP

	case CM_VIEWPCX:
    ViewImage(hwnd);     // In Drawing.cpp, calls ReadImage(Bmp/PCX)
    break;
	case CM_VIEWWAV:
    ViewWAVE(hwnd);      // In Drawing.cpp just to keep them together
    break;
	case CM_VIEWMID:
    ViewMIDI(hwnd);      // In
    break;
	case CM_VIEWCD:
    ViewCD(hwnd);        // In
    break;

//////////////////////////////////////////////////////////////////////////
//																								//
//						F I L E    S T U F F												//
//																								//
//////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////
//
//	Read a PWAD into a Paste Buffer
//
///////////////////////////////////////////////////////////////////////
	case CM_OPENCLIPBOARD:
    ForgetLevelData (PasteBuffer);
    ReadIntoPasteBuffer(hwnd, PasteBuffer);    // In Levelio.cpp
    break;

///////////////////////////////////////////////////////////////////////
//	Save a Lump in a File as *.LMP only need 1 now   3-1-97
///////////////////////////////////////////////////////////////////////

// also done is GRAPHICS MENU, kept here for general stuff   5-1-97
	case CM_SAVELUMPINAFILE:
     memset(d2.sz1, 0,8);             // name start
     d2.b1 = 0;                       // unsorted option

     SoundBeep(SoundSwish2);

     DialogBoxParam( gd.hInst, "Lump", hwnd, LumpDlgProc, (LPARAM)(LPDLG2OPTS)&d2 );   // unsorted  0
     break;

	case CM_SAVELUMPINAFILESORTED:
     memset(d2.sz1, 0,8);             // name start
     d2.b1 = 1;                       // sorted option

     SoundBeep(SoundSwish2);

     DialogBoxParam( gd.hInst, "Lump", hwnd, LumpDlgProc, (LPARAM)(LPDLG2OPTS)&d2 );   // sorted  1
     break;
/////////////////////////////////////////////////////////////////////
// pack and center
/////////////////////////////////////////////////////////////////////
  case CM_PACKSIDEDEFS:             //   5-1-97
     PackSideDefs( hwnd);
     break;
  case CM_PACKSECTORS:              //
     PackSectors( hwnd);
     break;
  case CM_UNPACKSIDEDEFS:           //
     UnPackSideDefs( hwnd);
     break;
  case CM_CENTERMAPCOORD:           //   6-1-97
     CenterMapCoord( hwnd);
     break;

///////////////////////////////////////////////////////////////////////
//
//	Save and Group all Pwads loaded into one large PWAD
//
///////////////////////////////////////////////////////////////////////
	case CM_SAVEANDGROUPFILES:
      if (CheckChangesAndContinue("Group") )
      {
	       GroupFiles(hwnd);        // Save and group
      }
      break;


///////////////////////////////////////////////////////////////////////
//	Save and UnGroup all Pwads loaded into one large PWAD
///////////////////////////////////////////////////////////////////////
	case CM_SAVEANDUNGROUPFILES:
      if (CheckChangesAndContinue("UnGroup") )
      {
	       UnGroupFiles(hwnd);      // Save and Ungroup
      }
      break;

//////////////////////////////////////////////////////////////////////////
//																								//
//						S A V E   O P T I O N S											//
//																								//
//////////////////////////////////////////////////////////////////////////
			   //  3D00 = save AS			- Changes Name
			   //  BA00 buildnodes as

				//  3C00 = SAVE
			   //  6F00 reject option
			   //  6900 save build nodes

				//  		HEXEN
            //  6000 = save BEHAVIOR
			   //  6100 = save MAPINFO
			   //  6500        SNDINFO


//	F2 - Save Level  -

	case CM_SAVELEVEL:
	if(SaveWadFile(0x3C00) == 7) ReloadLevel(hwnd); // in case nodes built
   break;

//	F3 - Save As New Level  -

	case CM_SAVEAS:
	if(SaveWadFile(0x3D00) == 7) ReloadLevel(hwnd);
	break;

//	Alt+F2 Build Nodes  -

   case CM_BUILDNODE:
	if(SaveWadFile(0x6900) == 7) ReloadLevel(hwnd);
   break;

//	Build Nodes AS a new map -  Menu ShortCut  - ???

   case CM_BUILDNODEAS:
	if(SaveWadFile(0xBA00) == 7) ReloadLevel(hwnd);
   break;

//	Save with a new Reject

	case CM_SAVENEWREJECTMASK:
	if(SaveWadFile(0x6F00) == 7) ReloadLevel(hwnd);
	break;

//	  Project Read New -  Menu ShortCut  CONTROL-F5

	case CM_READPROJECT:
   ReadNewProject(hwnd);		// In Deep.cpp
	break;

//	  Texture Read New -  Menu ShortCut  CONTROL-F6

	case CM_READTEXTURE:
    ReadNewTexture(hwnd);		// In Deep.cpp
	break;

//	Browse through all the available sprites
/*
   case CM_VIEWSPRITES:
    AllSprites = TRUE;
    //gd.hParent = hwnd;
    BrowseMode = SPRITES; // Sprite Browse located in Newgraph.cpp - ALL CODE
//    DialogBoxParam( gd.hInst, "SpriteBrowse", hwnd, SpriteBrowseDlgProc,(LPARAM)0);
    DialogBoxParam(gd.hInst,"SpriteEdit",hwnd, SpriteEditDlgProc,(LPARAM)0);
    RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  // since if user ignored changes, redo old one
    break;
*/
  // Sprite Editing is for external sprites only (file changes ok, since save copies from old modified one)
  case CM_SPRITEEDIT:
    //if (!CheckChangesAndContinue(NULL) ) break;      // check for changes

    DialogBoxParam(gd.hInst,"SpriteEdit",hwnd, SpriteEditDlgProc,(LPARAM)0);
    RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE); 
    break;


///////////////////////////////////////////////////////////////////////
//
//	MODES - V, S, T, L, Ctrl-R, Ctrl-D, Ctrl-A, Ctrl-P
//
//		Called either from a regular menu item
//		Or a pop up double right click menu item
//		Or just by the v, s, l, and t keys etc.
///////////////////////////////////////////////////////////////////////
//
//    Tools come from Popup tool menu only
//
	case CM_STAIRTOOL:
      Selecting = TRUE;
		SoundBeep(SoundClick1);
      MergeTool(level,0);                   // save current # linedefs now
    	StairTool(hwnd,level,0,&Sfloorh,     &Sceilh,     &Sstepnum,
                             &Sstepheight, &Sstepwidth, &Sstepdepth);
      MergeTool(level,1);                   // merge all lines
      Selecting = FALSE;                    // was before
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
		break;
	case CM_LINEDRAWTOOl:
      Selecting = TRUE;
		SoundBeep(SoundClick1);

      MergeTool(level,0);                   // save current # linedefs now
      DrawingTool(hwnd, level);
      MergeTool(level,1);                   // merge all lines

      Selecting = FALSE;
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
		break;
	case CM_POLYGONTOOL:
      Selecting = TRUE;
		SoundBeep(SoundClick1);
      MergeTool(level,0);                   // save current # linedefs now
	   PolygonTool (hwnd,  level,0,&Snumsides,&Sradius,&Spdepth );
      MergeTool(level,1);                   // merge all lines
      Selecting = FALSE;
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
      break;
	case CM_RECTANGLETOOL:
      //NotifyMsg(NULL,"rectangle");
		SoundBeep(SoundClick1);
      Selecting = TRUE;
      MergeTool(level,0);                   // save current # linedefs now
	   RectangleTool(hwnd, level,0,&Swidth, &Slength, &Srdepth, &Srangle );
      MergeTool(level,1);                   // merge all lines
      Selecting = FALSE;
		//ResetMapResident(hwnd, TRUE,RESETOBJ,RESETSELECT);// reset objects and select list   3-1-97
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
	break;

	case CM_VERTEXES:
   
       PrevMode = EditMode;
       EditMode = OBJ_VERTEXES;
       TabProcess(hwnd);
       break;
   case CM_LINEDEFSSIDEDEFS:
       PrevMode = EditMode;
       EditMode = OBJ_LINEDEFS;
       TabProcess(hwnd);
       break;
   case CM_SECTORS:
       PrevMode = EditMode;
       EditMode = OBJ_SECTORS;
       TabProcess(hwnd);
       break;
   case CM_THINGS:
       if (EditMode == OBJ_THINGS) ShowThingPic  = !ShowThingPic;
       PrevMode = EditMode;
       EditMode = OBJ_THINGS;
       TabProcess(hwnd);
       break;
   case CM_NEXTMODE:                         //   3-1-97
   case CM_LASTMODE:
       ProcessMapSizeCommands(hwnd, level, WM_CHAR,id, TRUE,  FALSE);
       break;

//////////////////////////////////////////////
//                                          //
//	Move Using Edge ?   Shift + F10          //
//                                          //
//////////////////////////////////////////////
   case CM_EDGEMOVE:     // shift+F10 set edgmove
      MoveUsingEdge = !MoveUsingEdge;
   break;


 ////////////////////////////////////////////
 //  ENTER KEY                             //
 ////////////////////////////////////////////
	 case CM_ENTER:
      HandleRBUp(hwnd, PointerX, PointerY, 0);
      break;

 ////////////////////////////////////////////
 //  DELETE KEY         12-12-96 bk        //
 ////////////////////////////////////////////
	 case CM_DELETE:
      if(Browsing) break;
      Delete(hwnd, CurObject, 1); // 0
      break;
 ////////////////////////////////////////////
 //  SHIFT  DELETE KEY                     //
 ////////////////////////////////////////////
	 case CM_SHIFTDELETE:
      Delete(hwnd, CurObject, 4); // 4 = shift del
      break;
  ////////////////////////////////////////////
  //  MOUSE DELETE KEY                      //
  ////////////////////////////////////////////
	 case CM_MOUSEDELETE:
      Delete(hwnd, CurObject, 3); // 3
      break;
 ////////////////////////////////////////////
 //  INS                                   //
 //  INS+SHIFT                             //
 ////////////////////////////////////////////
	 case CM_ADD:
      if(Browsing)  break;
      Insert(hwnd, CurObject, 0);  // mode 0 = normal  1=shift left button
      break;
 ////////////////////////////////////////////
 //  A KEY                                 //
 ////////////////////////////////////////////
    case CM_CALCULATOR:
      Calculator (hwnd,NULL);
      break;
 ////////////////////////////////////////////
 //	shift+A  - Align LineDef              /
 ////////////////////////////////////////////
	case CM_LINEDEFALIGN:
       if (EditMode == OBJ_LINEDEFS
       &&  CurObject >= 0)
       {   AlignLineDef(CurObject,0);         // align both
       }
       break;
 ////////////////////////////////////////////
 //  B   KEY                               //
 ////////////////////////////////////////////
   case CM_JUMPHEX:
      JumpTidLid(hwnd);   // Located in Ojbects.cpp
      break;
 ////////////////////////////////////////////
 //  C KEY                                 //
 ////////////////////////////////////////////
 	 case CM_CLEAR:
	   ResetMapResident(hwnd, TRUE, FALSE, TRUE);// reset pics on bottom and selectlists
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
      InstructionsOff();                       // list all of status bar
      break;
 ////////////////////////////////////////////
 //	D - Is GRID DASHED or SOLID           /
 ////////////////////////////////////////////
   case CM_GRIDDASHED:
      GridDash = !GridDash;
      if(GridShown)
  	   { //        hdc ,  RECT    , Erase Bk, Palette in
        RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
      }
      break;
 ////////////////////////////////////////////
 //	E  - Clone Things,SideDefsor Sector   /
 ////////////////////////////////////////////
   case CM_CLONE:
      CloneObject(hwnd,NULL);
      break;
 ////////////////////////////////////////////
 //	G - Grid DOWN                         /
 ////////////////////////////////////////////
	case CM_GRIDDOWN:
		if (GridScale == LowGrid)
			GridScale = HighGrid;
		else
      if (GridScale > LowGrid)
			GridScale /= 2;
		else
			GridScale = LowGrid;

		StatBarUpdate5(GridScale);
		SoundBeep(SoundClick1);

		if(GridShown)
         //        hdc , RECT    , Erase Bk, Palette in
         RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
	   break;

 ////////////////////////////////////////////
 //	shift+G  - Grid UP  			           /
 ////////////////////////////////////////////
	case CM_GRIDUP:
		if (GridScale == HighGrid)
			GridScale = LowGrid;
		else if (GridScale < HighGrid)
			GridScale *= 2;
		else
			GridScale = HighGrid;

		StatBarUpdate5(GridScale);
		SoundBeep(SoundClick1);

		if(GridShown)
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
	   break;
 ////////////////////////////////////////////
 //	H - Hide the Grid
 ////////////////////////////////////////////
   case CM_GRIDHIDE:
     GridShown = !GridShown;    //   3-1-97

     //        hdc , RECT    , Erase Bk, Palette in
     RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);

 	  break;
 ////////////////////////////////////////////
 // I -   Toggle Bottom INFO Window
 ////////////////////////////////////////////
	case CM_INFOOFFON:
     InfoShown = !InfoShown;                     //   3-1-97

     ResetMapResident(hwnd, TRUE,FALSE,FALSE) ; //   11-5-96 reset res pics
     //        hdc , RECT    , Erase Bk, Palette in  1-15-97 bk
     RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
     break;

 ////////////////////////////////////////////
 //  J   KEY                               //
 ////////////////////////////////////////////
	 case CM_JUMPTOOBJECT:
      OldObject = InputObjectNumber( hwnd, EditMode, CurObject);

      if (OldObject >= 0)
      {  HilightObject(hwnd, EditMode, CurObject, gd.hHiLightPen);
         CurObject = OldObject;
	      GoToObject( EditMode, CurObject,FALSE);
      }
      else
      {  OldObject = CurObject;
      }
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
      break;

 ////////////////////////////////////////////
 //	K - Display the Thing Filter Dialog Box
 ////////////////////////////////////////////
   case CM_THINGFILTERMASK:
	   DialogBoxParam(gd.hInst,"ThingMask", hwnd, ThingMaskDlgProc, (LPARAM)0);
	   break;

 ////////////////////////////////////////////
 // M - 	Mark or Unmark one object or LeftClick with mouse
 ////////////////////////////////////////////
   case CM_MARK:
      MarkObject(hwnd);
      break;

 ////////////////////////////////////////////
 //  N   KEY                               //
 ////////////////////////////////////////////
	 case CM_NEXTOBJECT:
      if (CurObject < GetMaxObjectNum( EditMode)) CurObject++;
      else if (GetMaxObjectNum( EditMode) >= 0)   CurObject = 0;
      else                                        CurObject = -1;

      if (CurObject >= 0)
      {  HilightObject(hwnd, EditMode, CurObject, gd.hHiLightPen);
         GoToObject( EditMode, CurObject, FALSE);
      }
      OldObject = CurObject;
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
      break;

 ////////////////////////////////////////////
 //  P  KEY                                //
 ////////////////////////////////////////////
	 case CM_PREVOBJECT:
      if (CurObject > 0)   CurObject--;
      else                 CurObject = GetMaxObjectNum( EditMode);

      if (CurObject >= 0)
      {  HilightObject(hwnd, EditMode, CurObject, gd.hHiLightPen);
         GoToObject( EditMode, CurObject, FALSE);
      }
      OldObject = CurObject;
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
      break;
 ////////////////////////////////////////////
 //  Read  a File into the PASTER BUffer   //
 ////////////////////////////////////////////
   case CM_READINTOPASTE:
       ReadIntoPasteBuffer(hwnd, PasteBuffer);
       break;
 ////////////////////////////////////////////
 //  "  KEY   (was shift+A)                //
 ////////////////////////////////////////////
	case CM_AUTOSELECT:
      AutoSelect = !AutoSelect;
      StatBarUpdate8();     // 12-30-96 bk
      SoundBeep(SoundClick1);
      break;
 ////////////////////////////////////////////
 // ^ - Show X Y as Map Coordinates or Screen Coords
 ////////////////////////////////////////////
	case CM_MAPCOORDS:
      MapCoords = !MapCoords;
    	break;
 ////////////////////////////////////////////
 //  \   KEY                               //
 ////////////////////////////////////////////
	case CM_AUTOCENTER:
      AutoCenter = !AutoCenter;
      StatBarUpdate11();     //   3-1-97
      SoundBeep(SoundClick1);
      break;
 ////////////////////////////////////////////
 //  /   KEY   SnapToGrid                  //
 ////////////////////////////////////////////
	case CM_GRIDSNAP:
      GridSnap     = !GridSnap;
      StatBarUpdate7();     //   3-1-97
      SoundBeep(SoundClick1);
      break;
 ////////////////////////////////////////////
 //  @  KEY        Ruler Hollow            //
 ////////////////////////////////////////////
	case CM_RULERCIRCLE:
      RulerRectangle = !RulerRectangle;

      if (ShowRulers)                  // and do it new way
      {
         RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
         DrawRuler(hwnd, PointerX, PointerY);
      }
      break;
 ////////////////////////////////////////////
 //  !  KEY        Ruler Hollow            //
 ////////////////////////////////////////////
	case CM_RULERHOLLOW:
      RulerHollow = !RulerHollow;      // ruler box hollow

      if (ShowRulers)                  // and do it new way
      {
         RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
         DrawRuler(hwnd, PointerX, PointerY);
      }
      break;
 ////////////////////////////////////////////
 //   R   KEY   Ruler                      //
 ////////////////////////////////////////////
	case CM_RULER:
      ShowRulers = !ShowRulers;      // ruler box

      if (ShowRulers)
      {  
          RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
          DrawRuler(hwnd, PointerX, PointerY);
      }
      break;
 ////////////////////////////////////////////
 //  SHIFT - R   KEY  Redraw map           //
 ////////////////////////////////////////////
	case CM_REDRAWMAP:
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
      InstructionsOff(); //   3-1-97 reshow bottom
      break;
 ////////////////////////////////////////////
 //  SHIFT - X   KEY                       //
 ////////////////////////////////////////////
	case CM_ALIGNXSHIFT:
     PostMessage(hwnd, WM_COMMAND, CM_AX3, 0);
     break;
 ////////////////////////////////////////////
 //  SHIFT - Y   KEY                       //
 ////////////////////////////////////////////
	case CM_ALIGNYSHIFT:
     PostMessage(hwnd, WM_COMMAND, CM_AY2, 0);
     break;
 ////////////////////////////////////////////
 //  X   KEY                               //
 ////////////////////////////////////////////
	case CM_ALIGNXNORMAL:
     PostMessage(hwnd, WM_COMMAND, CM_AX1, 0);
     break;
 ////////////////////////////////////////////
 //  Y   KEY                               //
 ////////////////////////////////////////////
	case CM_ALIGNYNORMAL:
     PostMessage(hwnd, WM_COMMAND, CM_AY1, 0);
     break;
 ////////////////////////////////////////////
 //  F7   KEY    S T A T U S               //
 ////////////////////////////////////////////
	case CM_STATMENU:
     HandleStatMenu(hwnd);
     break;

 ////////////////////////////////////////////
 //                                        //
 //         Control KEYS                   //
 //                                        //
 ////////////////////////////////////////////


	case CM_MIRRORMENU:
     HelpMsg(hwnd,CENTER|HELPHELP,"Mirror Help",
                 "Position the Mouse at the location",
                 "you want to Mirror an object",
                 "and then use the Ctrl+M keyboard command",
                 NULL);
     break;
 ////////////////////////////////////////////
 //  Ctrl - M    Mirror                    //
 ////////////////////////////////////////////
	case CM_MIRROR:
     if (EditMode == OBJ_LINEDEFS ||  EditMode == OBJ_SECTORS )
     {
	     if (SelectList != NULL || CurObject >= 0)
	     {   if (SelectList == NULL)
	         {   SelectObject( &SelectList, CurObject);
		          SelectTemp = TRUE;
	         }

	       // mirror always makes a LineDef "Select" list of the new objects

	       Instructions("Mirroring Objects to Cursor Position");

	       SetNumberObjects(level,1);              // set original number objects

	       if (MirrorObjects (hwnd, SelectList) )  // mirror could be cancelled
	       {
		        SetNumberObjects(level,2);          // make a new select list
	       }
	       else
	       {   if (SelectTemp)
              {   ForgetSelection(&SelectList);
                  SelectTemp = FALSE;
              }
	       }

	       CancelMove();                            // cancel any move in progress - in Object
	       DrawingVertex = FALSE;

	       CalculateMinMax(level);//&LevelWad.level);   //
          InstructionsOff();
          //        hdc , RECT    , Erase Bk, Palette in
          RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
	     }
     }
     else
     {    HelpMsg(hwnd,CENTER|HELPHELP,"Mirror Help",
                 "Mirror LineDef/Sector only",
                 "",
                 "Select the Sectors or",
                 "LineDefs to mirror and",
                 "then use this command.",NULL);
     }
     break;

 ////////////////////////////////////////////
 //  Ctrl - F       FLIP                   //
 ////////////////////////////////////////////
	 case CM_FLIP:
      if (EditMode != OBJ_LINEDEFS) break;    //   8-1-97

	   if (SelectList)
	   {   FlipLineDefs( SelectList, 0 );      // just vertex, 2=sidedef+vertices
	   }
	   else
	   {   if (CurObject >=0 )
	        {   SelectObject ( &TempList, CurObject);
		         FlipLineDefs( TempList, 0 );   // just vertex 2=sidedef+vertices
		         ForgetSelection( &TempList);   // get rid of old list
	        }
	   }
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
      break;

 ////////////////////////////////////////////
 //  Ctrl - S       SWAP                   //
 ////////////////////////////////////////////
	 case CM_SWAP:
      if (EditMode != OBJ_LINEDEFS) break;          //   8-1-97

	   if (SelectList)
	   {   FlipLineDefs( SelectList, 1 );            // just sidedef
	   }
	   else
	   {  if (CurObject >=0 )
	       {   SelectObject ( &TempList, CurObject);
	           FlipLineDefs( TempList, 1 );          // just sidedef
	           ForgetSelection( &TempList);          // get rid of old list
	       }
	   }
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
    break;

/*          FIND NEW CM_????
 ////////////////////////////////////////////
 //  Flip & Swap LineDef                   //
 ////////////////////////////////////////////
	 case CM_FLIPVERTEX:
	  if (SelectList)
	   {   FlipLineDefs( SelectList, 2 );        // Both
	   }
	  else
	   {  if (CurObject >=0 )
	       {   SelectObject ( &TempList, CurObject);
	           FlipLineDefs( TempList, 2 );          // Both
	           ForgetSelection( &TempList);          // get rid of old list
	       }
	   }
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(NULL, &gd.rcClient, TRUE, FALSE);
    break;

*/
 ////////////////////////////////////////////
 //  Ctrl - C   COPY                       //
 ////////////////////////////////////////////
	 case CM_COPY:
      if (SelectList != NULL || CurObject >= 0)
      { if (SelectList == NULL)
	      {   SelectObject( &SelectList, CurObject);
	          SelectTemp = TRUE;
	      }

	     Instructions("Copying Objects to Paste Buffer");
	     LevelCopy(PasteBuffer, level, EditMode, SelectList, FALSE);     // copy things too!
	     if (SelectTemp)
        {   ForgetSelection(&SelectList);
            SelectTemp = FALSE;
        }
        InstructionsOff();
      }
      break;

 ////////////////////////////////////////////
 //  Ctrl - X   CUT                        //
 ////////////////////////////////////////////
	 case CM_CUT:
      Delete(hwnd, CurObject, 1); // 1 = Ctrl-X or Del
      break;

	 case CM_PASTEMENU:
     HelpMsg(hwnd,CENTER|HELPHELP,"Paste Help",
                 "Position the Mouse at the location",
                 "you want to Paste an object",
                 "and then use the Ctrl+V keyboard command",
                 NULL);
     break;
 ////////////////////////////////////////////
 //  Ctrl - V   PASTE                      //
 ////////////////////////////////////////////
	 case CM_PASTE:
      if  ( (EditMode == OBJ_THINGS && !PasteBuffer->NumThings )
       ||   (EditMode != OBJ_THINGS && !PasteBuffer->NumVertexes ))
      {    OnlyRegPaste();  // message is nothing to paste for registered
      }
      else
      {  Instructions("Pasting Objects to Current Cursor Position");
	      CheckPointLevel(UndoBuffer, level);
	      SetNumberObjects(level,1);               // set original number objects
	      PasteObjects(level);
	      SetNumberObjects(level,2);               // reselect pasted objs
	      CalculateMinMax(level);
         InstructionsOff();
         //        hdc , RECT    , Erase Bk, Palette in
         RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
      }
      break;

 ////////////////////////////////////////////
 //  Ctrl - Z  UNDO                        //
 ////////////////////////////////////////////
	 case CM_UNDO:
	   if  (!UndoBuffer->NumVertexes )
	   {
	     if (!Undo)
	     {
            HelpMsg(hwnd,CENTER|HELPINFO,"Undo Option not set",
                                         "Undo Option Not Set!",
                                         NULL);
            //NotifyMsg(hwnd, "Undo Option Not Set!");//,szLoadString(IDS_DEEPINFO), MB_OK);
	     }
	     else
	     {
            HelpMsg(hwnd,CENTER|HELPINFO,"Undo",
                                         "Nothing to Undo!",
                                         NULL);
            //NotifyMsg(hwnd,"Nothing to Undo!");     //,szLoadString(IDS_DEEPINFO), MB_OK);
	     }
	   }
	   else
	   {
	      UndoLevel(&level, &UndoBuffer);
	      CalculateMinMax(level);                // make sure coordinates up to date
	      ResetMapResident(hwnd, TRUE,RESETOBJ,RESETSELECT);// reset objects and select list
         //        hdc , RECT    , Erase Bk, Palette in
         RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
     	}
      break; //   3-1-97 missing
//////////////////////////////////////////////
//                                          //
//	NORMALIZE  -  Menu ShortCut  CTRL - N    //
//                                          //
//////////////////////////////////////////////
   case CM_NORMALIZE:
	  Normalize(hwnd);                   // in object.cpp
     break;

//////////////////////////////////////////////
//                                          //
//	Edit SideDef 1 & 2  ShortCut  Alt - 1    //
//                               Alt - 2    //
//////////////////////////////////////////////
   case CM_EDITSIDE1:
   case CM_EDITSIDE2:
     if(EditMode != OBJ_LINEDEFS) break;
     //{   HelpMsg(hwnd,CENTER|HELPINFO,
     //            "    NOTICE    ",
     //            "",
     //           "You Should be in LineDef"  ,
     //           "Mode to edit the SideDefs" ,
     //           "Right DblClk and choose"   ,
     //           "LineDef Mode or press L "  ,
     //           "Then Alt-1 or Alt-2 to edit",NULL);
     //   return;
     //}

     GetCursorPos(&pOldCurPos);// sidedef 1, no postings, ! from info
     CallSideDefDlg(hwnd, 0, int2(id - CM_EDITSIDE1), FALSE, FALSE);
     break;

///////////////////////////////////////////////////////////////////////
//
//	Display the FIND Menu    MenuShortCut  - F4
//
///////////////////////////////////////////////////////////////////////
   case CM_FIND:
     HandleFindMenu(hwnd);
     break;

 ////////////////////////////////////////////
 //                                        //
 //            F4    Find                  //
 //                                        //
 // Located in Object.cpp                  //
 //                                        //
 ////////////////////////////////////////////
   case CM_FLTYPE:     // Line Type              310
   case CM_FLTAG:      // Line Tag
   case CM_FSTYPE:     // Sector Type
   case CM_FSTAG:      // Sector Tag
   case CM_FTHING:     // Find Thing
   case CM_FTID:       // Find TID
   case CM_FPOLY:      // Find Poly
   case CM_FTIDLID:    // Find TID LineID
   case CM_FFLOOR:     // Find Floor

   case CM_FWALL:      // Find Wall
   case CM_FWALLT:     // Find Wall top
   case CM_FWALLM:     // Find Wall middle
   case CM_FWALLB:     // Find Wall bottom

   case CM_RTHING:     // Replace Thing
   case CM_RFLOOR:     // Replace Floor

   case CM_RWALL:      // Replace Wall
   case CM_RWALLT:     // Replace Wall top
   case CM_RWALLM:     // Replace Wall middle
   case CM_RWALLB:     // Replace Wall bottom

   case CM_RFLOORCON:  // Replace Floor convert
   case CM_RWALLCON:   // Replace Wall
   case CM_FARGS:      // Find Args                325

     FindCommand(hwnd, (id-CM_FLTYPE+1) );
     InstructionsOff();                    // Resets status bar
     break;

 ////////////////////////////////////////////
 //  F   KEY                               //
 ////////////////////////////////////////////
	case CM_REPEATLASTFIND:
     FindCommand(hwnd, NULL);
     InstructionsOff();                    // Resets status bar
     break;

 ////////////////////////////////////////////
 //                                        //
 //            F10   CHECK                 //
 //                                        //
 // Located in checks.cpp                  //
 //                                        //
 ////////////////////////////////////////////
   case CM_LEVELSTATISTICS:                       // 801
   case CM_CHECKSECTORSCLOSED:
   case CM_CHECKXREF:
   case CM_CHECKMISSING:
   case CM_CHECKINVALID:
   case CM_CHECKTHING:
   case CM_CHECKLINEDEFSTAGS:
   case CM_CHECKSECTORTAGS:
   case CM_CHECK5678:
   case CM_CHECK234:
   case CM_CHECKALL:
   case CM_CHECK23456:
   case CM_CHECKNOTREQUIRED:
   case CM_CHECKAUTOFIXMISSING:
   case CM_AUTOFIXOFFSETS:
   case CM_AUTOREMOVE:                           // 815
     CheckLevel(hwnd, int2(id - CM_LEVELSTATISTICS) );
     RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);      // 8-1-97 changed CheckLevel Save
     break;
   case CM_SETCHECKINGOPTIONS:                   // 816
     DialogBoxParam( gd.hInst, "CheckOpt", hwnd, CheckOptDlgProc, (LPARAM)0);
     break;

 ////////////////////////////////////////////
 // shift+S  Split Line                    //    3-1-97
 ////////////////////////////////////////////
   case CM_SPLITLINE2  :// 	    	550
 ////////////////////////////////////////////
 // shift+Z  Split sector                  //    3-1-97
 ////////////////////////////////////////////
   case CM_SPLITSECTOR2://				551
     id = CM_SPLITLINE + (id-CM_SPLITLINE2);
     if(EditMode == OBJ_LINEDEFS)
     {  if   (SelectList == NULL && CurObject >= 0)  SelectObject(&SelectList, CurObject);

        MiscOperations(hwnd, &SelectList, int2(id - CM_RANDSCALELINE+1) );
     }
     break;

 ////////////////////////////////////////////
 //                                        //
 //            F8  Misc. Menu              //
 //                                        //
 // Located in Object.cpp mostly under     //
 // MiscOperations                         //
 ////////////////////////////////////////////

   case CM_ROTATEANDSCALE://        501            // These MUST all be in
   case CM_FIRSTFREE://					502            // Sequence
   case CM_MAKELIFTSECTOR:// 			503
   case CM_MAKEDOORSECTOR:// 			504
   case CM_DISTSECTORFLOORS:// 		505
   case CM_DISTSECTORCEILINGS://		506
   case CM_DISTSECTORLIGHTING:// 	507
   case CM_MERGESECTORS:// 			508
   // Misc Menu  ( Line menu )
   case CM_RANDSCALELINE://         510
   case CM_FIRSTFREELINE://         511
   case CM_SPLITLINE:// 				512
   case CM_SPLITSECTOR://				513
   case CM_DELETEJOINSECTORS:// 		514
   case CM_FLIPVERTEX:// 				515
   case CM_SWAPSIDEDEFS:// 			516                // Same as CM_SWAP
   case CM_FLIPONLY:// 				   517                // Same as CM_FLIP
//   case CM_ALIGNY:// 					518        Moved to CM_AX1-8 & CM_AY1-2
//   case CM_ALIGNX:// 					519
   case CM_MAKEDOORLINE:// 			518
   case CM_MAKESTAIRLINE:// 			519
   // Misc Menu  ( thing menu )
   case CM_RANDSCALET://            525
   case CM_FIRSTFREET://            526
   case CM_DISTTHING:// 				527
   // Misc Menu ( Vertex )
   case CM_RANDSCALEV://            530
   case CM_FIRSTFREEV://            531
   case CM_DELETEVERTEX:// 			532
   case CM_MERGEVERTICES:// 			533
   case CM_ADDLINEDEF:// 				534

     if   (SelectList == NULL && CurObject >= 0)  SelectObject(&SelectList, CurObject);

          if(EditMode == OBJ_SECTORS)  MiscOperations(hwnd, &SelectList, int2(id - CM_ROTATEANDSCALE+1) );
     else if(EditMode == OBJ_LINEDEFS) MiscOperations(hwnd, &SelectList, int2(id - CM_RANDSCALELINE+1) );
     else if(EditMode == OBJ_THINGS)   MiscOperations(hwnd, &SelectList, int2(id - CM_RANDSCALET+1) );
     else if(EditMode == OBJ_VERTEXES) MiscOperations(hwnd, &SelectList, int2(id - CM_RANDSCALEV+1) );

     //if(SelectList)    ForgetSelection(&SelectList);

     SetCursorPos(pOldCurPos.x, pOldCurPos.y);
     break;

   case CM_AY1:
   case CM_AY2:

 	  if(SelectList == NULL)   SelectObject(&cur, CurObject);// Select CurObject
     else                     cur = SelectList;             // Use existing Select

     AlignTexturesY(hwnd,&cur,int2(id - CM_AY1+1) );          // + 1 to get 1 -

     if(SelectList == NULL)  ForgetSelection(&cur);
     break;

   case CM_AX1:    // align Textures X, Y , same side etc.
   case CM_AX2:
   case CM_AX3:
   case CM_AX4:
   case CM_AX5:
   case CM_AX6:
   case CM_AX7:
   case CM_AX8:

 	  if(SelectList == NULL)   SelectObject(&cur, CurObject);// Select CurObject
     else                     cur = SelectList;             // Use existing Select

     AlignTexturesX(hwnd,&cur,int2(id - CM_AX1+1) );          //  1 - 8

     if(SelectList == NULL)  ForgetSelection(&cur);
     break;


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//             F9 Insert Standard Objects  Popup                              //
////////////////////////////////////////////////////////////////////////////////
	case CM_INSERTOBJECT:
     HandleObjectMenu(hwnd);      // Grab menu item then goes to stuff below
     break;

  // process Pop-Up object commands

   case CM_OBJ1:  // Rectangle Room
   case CM_OBJ2:  // Rectangle Object
   case CM_OBJ3:  // Polygon Room
   case CM_OBJ4:  // Polygon Object
   case CM_OBJ5:  // Stair Room
   case CM_OBJ6:  // Stair Object
   case CM_OBJ7:  // Door
     GetCursorPos(&pOldCurPos);                 // for standard object was below   7-1-97

     SetCursorPos(ScrMaxX/2-100,ScrMaxY/2-100); // incase in menu top bar
     
     InsertStandardObject(hwnd, int2(id - CM_OBJ1+1) );  // 1 - 7
     break;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//            F6  H E X E N  Development                                      //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
//	HEXEN Development Menu F6

	case CM_SAVECOMPILEHEXEN:
    //if(GameVersion != 4)   MessageBox(hwnd, szLoadString(IDS_NOTHEXEN), szLoadString(IDS_DEEPINFO), MB_OK);
    if(GameVersion != 4)
    {
        HelpMsg(hwnd,CENTER|HELPINFO,"Not HEXEN",
                       "This is for HEXEN projects only!",
                       "",
                       "Press Ctrl+F5 to select HEXEN project",
                       NULL);
        //ErrorMsg(hwnd, "This is for HEXEN projects only!\n\n",
        //               "Press Ctrl+F5 to select");
    }
	 else
    {   HandleHexenMenu(hwnd);
    }
   break;
   //
   // ----from HandleHexenMenu --
   //
   case CM_HXS1:// Compile Script
   case CM_HXS2:// Edit Script
   case CM_HXS3:// Edit & Compile Script
   case CM_HXS4:// DeCompile Script
   case CM_HXS5:// Edit MAPINFO
   case CM_HXS6:// Save MAPINFO
   case CM_HXS7:// Edit SNDINFO
   case CM_HXS8:// Save SNDINFO
	case CM_HXS9:// save BEHAVIOR:
   case CM_HXS10://save MAPINFO
   case CM_HXS11://save SNDPINFO
     HexenDevelopment(hwnd, pOldCurPos, int2(id - CM_HXS1+1) );  // 1 - 8
     break;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//              Q U A K E  Development                                        //
//                                                                            //
// 12-30-96 bk                                                                //
// 2-20-97 bk Added option to STAY in the menu                                //
////////////////////////////////////////////////////////////////////////////////

   case CM_QM1: // Set Sort Options
   case CM_QM2: // Wad
   case CM_QM3: // Pak
   case CM_QM4: // Bsp
   case CM_QM5: // =wad hex dump only
   case CM_QM6: //  pak
   case CM_QM7: //  bsp
   case CM_QM8: // exit
   //case CM_QM5: // =Palette viewer= to do
     LastPicXloc = -1;        // first time   3-1-97

     QuakeDevelopment(hwnd, pOldCurPos, int2(id - CM_QM1+1) );  // 1 - 8
     //if((id - CM_QM1+1) == 6)
     if (id == CM_QM6)
     {   RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  // 1-1-97 bk  Redraw after
     }
     break;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//              F7, Status Returns                                            //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

   case CM_STAT1:// Grid Snap
   case CM_STAT2:// Auto Center
   case CM_STAT3:// Auto Select
   case CM_STAT4:// Made Changes
   case CM_STAT5:// Made Map Changes
   case CM_STAT6://
   case CM_STAT7://

     num = int2((id - CM_STAT1)); // should give me zero - 6

     switch(num)
     {
      case 0:   //  /  KEY  GridSnap
       GridSnap = !GridSnap;
       break;
      case 1:  //  \   KEY  AutoCenter
       AutoCenter = !AutoCenter;
       break;
      case 2:  //  "   KEY  AutoSelect as cursor moves
       AutoSelect = !AutoSelect;
       break;
	   default:
		 break;
     }
     InstructionsOff(); //   3-1-97 reshow bottom
     break;

//===========================================================================
// Edit directly
//===========================================================================

   case CM_EDITTYPE: //  Edit Directly
    ZeroMemory(&DlgSel, sizeof(DlgSel));
    gd.hParent = hwnd;
    AutoSaveStop = TRUE;
    //Browsing = TRUE;

    if(SelectList != NULL)
     {   DlgSel.sel = SelectList;
         DlgSel.obj = -1;
     }
    else
     {   if(CurObject < 0 ) return;
         DlgSel.sel = NULL;
         DlgSel.obj = CurObject;
     }

    DlgSel.b2  = TRUE;                // advance command

    switch(EditMode)
    {
      case OBJ_SECTORS:
       DlgSel.post = psh1;            // message to post to the dialog
       DialogBoxParam(gd.hInst,"EditSector",hwnd, EditSectorDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);
       break;

      case OBJ_THINGS:
       DlgSel.post = IDD_CHANGETYPE;  // message to post to the dialog
       DialogBoxParam(gd.hInst,"ThingEdit",hwnd, EditThingDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);
       break;

      case OBJ_LINEDEFS:
       DlgSel.post = psh2;            // message to post to the dialog
       DialogBoxParam(gd.hInst,"EditLineDef",hwnd, EditLineDefDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);
       break;

      case OBJ_VERTEXES:
       break;
	   default:
		 break;
    }
    DlgSel.sel = NULL;   //  MAKE SURE !
    //UpdateObjectInfo(hwnd, CurObject);                   // show stuff on bottom already done
    //StatBarUpdate9();                                    //   3-1-97

    //Browsing = FALSE;
    AutoSaveStop = FALSE;
    break;
 // exports all formats here===================================
 // 2-20-97 bk  MOVED to Drawing.cpp
 // case CM_EXPORTTXTR:
 //   ExportTexture(hwnd);
 // break;
 // case CM_EXPORTFLAT:
 //   ExportFlats(hwnd);
 //   break;
 // case CM_EXPORTSPRITE:
 //   ExportSprites(hwnd);
 //   break;

 //------------------------------------------------------------

  case CM_3DVIEW:
    Doom3Dview(hwnd, level);
    //        hdc , RECT    , Erase Bk, Palette in
    RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
    break;
  case CM_3DWALK:          //   6-1-97
    Doom3DWalk(hwnd,level);
    RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
    break;

  case CM_RENAMELUMP:
    DialogBoxParam(gd.hInst,"RenameLump",hwnd, RenameLumpDlgProc,(LPARAM)0);
    RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);
    break;
  // Texture Editing now
  case CM_TEXTUREEDIT: //COMPINFO:
    if (!CheckChangesAndContinue(NULL) ) break;      // check for changes since this reloads levels, etc

    DialogBoxParam(gd.hInst,"Composite",hwnd, CompositeDlgProc,(LPARAM)0);

    RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  // since if user ignored changes, redo old one
    break;

  case CM_VIEWLUMP:
    DialogBoxParam(gd.hInst,"ViewLump",hwnd, ViewDumpDirDlgProc,(LPARAM)0);
    break;

  case CM_NODEVIEWER:
   nodenav(hwnd);
   break;

  case CM_PRINTMAP:
   PrintMap(hwnd);// 12-28-96 bk
   Sleep(500);    // just a slight delay to make sure everything is gone - NEEDED
   SetForegroundWindow(hwnd);
   break;

  case CM_PRINTSETUP:
   PrintSetup(hwnd);
   break;

  case CM_PAGESETUP:
   PageSetup(hwnd);
   break;

  case CM_QUAKE:  // 12-30-96 bk
   HandleQuakeMenu(hwnd);
   break;

  case CM_HEXEN2:  // 8-1-97  
   HandleHexen2Menu(hwnd);
   break;
///////////////////////////////////////////////////////////////////////
//
//	Makes a new IWAD
//
///////////////////////////////////////////////////////////////////////
	case CM_SAVEMAKEIWAD:
     if (CheckChangesAndContinue("Group") )
     {
	      BuildIWAD(hwnd);      // Save and group
     }
     break;

   case CM_CONVERTTOPWAD:
     InsertRawFile(hwnd);
     break;
   case CM_CONVERTWAVTOPWAD:
     InsertWavFile(hwnd);
     break;
   case CM_INSERTLUMPINPWAD:
     InsertLump(hwnd);
     break;

   case CM_GRAPHICEDITOR:     // 2-20-97 bk
     gd.hParent = hwnd;       // save our Parent handle so Graphics can talk to
     InitGFXWindow(hwnd);
     break;
     
	default:
     SoundError();
	  Deep_NotYet(hwnd);

  }
}


/////////////////////////////////////////////////////////////////////
// Set Up Menu Misc. one
// -------------
//
//	Called from various parts most s, l, v, t to change the main misc. menu
//
////////////////////////////////////////////////////////////////////
void ChangeMiscMenu(int NewEditMode)
{
	UINT MenuID;
	switch ( NewEditMode )
	{
		case OBJ_THINGS:
			MenuID = (UINT)gd.hMiscThingMenu;
			break;
		case OBJ_LINEDEFS:
			MenuID = (UINT)gd.hMiscLineMenu;
			break;
		case OBJ_VERTEXES:
			MenuID = (UINT)gd.hMiscVertexMenu;
			break;
		default:	// OBJ_SECTORS:
			MenuID = (UINT)gd.hMiscSectorMenu;
	}

   RemoveMenu(gd.hMainMenu,  4, MF_BYPOSITION | MF_POPUP );
   InsertMenu(gd.hMainMenu,  4, MF_BYPOSITION | MF_POPUP, MenuID, (LPCTSTR) "M&isc"); //   6-1-97
   DrawMenuBar(gd.hMainWindow);	// Redraw Menu after modifying
}



////////////////////////////////////////////////////////////////////////////////
//
//   Handle to a menu and a menu item ID CM_????
//
////////////////////////////////////////////////////////////////////////////////
void TurnOffMenuItem(HWND hwnd, UINT menuid)
{
  HMENU hMenu = GetMenu(hwnd);
  EnableMenuItem(hMenu, menuid, MF_BYCOMMAND | MF_GRAYED);
}


////////////////////////////////////////////////////////////////////////////
// make my own sub-popup menus for main ones too   3-1-98
////////////////////////////////////////////////////////////////////////////

void DisplayPopMenu(HWND hwnd, POINT pMenu, Bool setpos, POPupListPtr PopList, int2 select)
{
   HMENU hPopMenu;
   POINT pMouse;

   int4  startY;
   int4  menusize;
   int4  TotalHeight;
   int4  MenuYloc;
   int4  menuEntries=0;
   int4  ActiveEntries=0;
   int4  yMax;
   int4  xMax;
   POINT PriorCurPos;

//===============================================================================

   GetCursorPos( &PriorCurPos );   // get cursor back to where it came from

   menusize = GetSystemMetrics(SM_CYMENUSIZE) -1;
   yMax     = GetSystemMetrics(SM_CYSCREEN);
   xMax     = GetSystemMetrics(SM_CXSCREEN);
   MenuYloc = menusize / 2;                       // 1/2 way down menu
   startY   = menusize / 2;                       // 1/2 way down menu

   PopupMenu = TRUE;
   hPopMenu  = CreatePopupMenu();
   //Trace(NULL,10,4,"select = %hd (%d,%d)",select,pMenu.x,pMenu.y);

   for ( ;PopList->name; PopList++)
   {
         if (PopList->type == TypeSEPARATOR)
         {
             AppendMenu(hPopMenu, MF_SEPARATOR, PopList->commandID, PopList->name);
             if ( select == ActiveEntries)
             {   startY = MenuYloc;
             }
             ActiveEntries++;
             MenuYloc += (menusize-7);
         }
         else
         {   if (PopList->name[5] != 'x')           // don't do if not filled in by OPT file
             {   AppendMenu(hPopMenu, MF_STRING,    PopList->commandID, PopList->name);

                 if ( select == ActiveEntries)
                 {   startY = MenuYloc;
                 }
                 MenuYloc +=  menusize;
                 ActiveEntries++;
             }
         }

         menuEntries++;
   }


   TotalHeight = menusize * (menuEntries+1);//((num-CM_1)+1);  height of popup   3-1-98

   if ( (pMenu.y +TotalHeight) >= yMax )    // 3-1-98
   {     pMenu.y = yMax - TotalHeight;
         if (pMenu.y < 0) pMenu.y = 0;
   }
   if( pMenu.x+300  > xMax) pMenu.x =xMax-300;
   if( pMenu.x      < 0) pMenu.x = 0;

   if (setpos)                              // position cursor
   {   /*
       if (EditMode == OBJ_THINGS)          // menu divider
       {   start = menusize  + (menusize / 2) + (menusize / 2);
       }
       else
       {   start = menusize / 2;
       }
       */
       pMouse.x = pMenu.x + 12;        //init center pos. + height of line  * olditem
       pMouse.y = pMenu.y + startY;    // + (menusize * select);
       SetCursorPos( pMouse.x, pMouse.y);
       //Trace(NULL,10,24,"set = (%d,%d)",pMouse.x, pMouse.y);
   }

   TrackPopupMenu(hPopMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
                  pMenu.x,pMenu.y,
                  0, hwnd, NULL);

   DestroyMenu(hPopMenu);
   PopupMenu = FALSE;          // Popup Menu Gone

   SetCursorPos( PriorCurPos.x, PriorCurPos.y );
}


////////////////////////////////////////////////////////////////////////////////
//
//			All of our Menu Tracking Routines
//
//			These handle the following Menus called from various points
//	Find Menu     (F4)
// Misc Menu     (F8  -  Changes with EditMode)
// Mode Menu     (RButtonDBLClick)
// Object Menu   (F9)
// Check Menu    (F10)
// LineEdit Menu (Right Click on Line in EDIT MODE )
// Hexen Menu	  (F6)
//
////////////////////////////////////////////////////////////////////////////////

	//	Grab all of our Sub Menu Handles to display on our
	//	Function keys F8, F9, F10 etc., just displays them as Floating Pop Ups!

void HandleFindMenu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100; //   3-1-97
   INT MenuY = ScrMaxY/2-100;

   GetCursorPos(&pOldCurPos);
   PopupMenu = TRUE;           //   12-16-96

	HMENU hFindMenu	 = LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUFIND));
   HMENU hFindSubMenu = GetSubMenu(hFindMenu, 0);

   SetCursorPos( MenuX+10,MenuY+10);
	TrackPopupMenu(hFindSubMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX,MenuY, 0, hwnd, NULL);
   DestroyMenu(hFindMenu);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;           //   12-16-96
}

//=====================F8=====================================================

void HandleMiscMenu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100;                    //   3-1-97
   INT MenuY = ScrMaxY/2-100;

   GetCursorPos(&pOldCurPos);
   PopupMenu = TRUE;

	HMENU hMiscMenu = GetSubMenu(gd.hMainMenu, 4);

   SetCursorPos( MenuX+10,MenuY+10);
	TrackPopupMenu(hMiscMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX,MenuY, 0, hwnd, NULL);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;
}

//==========================================================================
// switch modes
//==========================================================================
void HandleModeMenu(HWND hwnd, int x, int y)
{
   PopupMenu = TRUE;

   GetCursorPos(&pOldCurPos);

	HMENU hModeMenu =	GetSubMenu(gd.hMainMenu, 3);

   SetCursorPos( x , y +gd.CaptionHeight);  // adjust for top menu bar   11-10-96
	TrackPopupMenu(hModeMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, x-30, y, 0, hwnd, NULL);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;

}
//===================F9=======================================================
void HandleObjectMenu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100;
   INT MenuY = ScrMaxY/2-100;

   GetCursorPos(&pOldCurPos);  //   3-1-97
   PopupMenu = TRUE;           //   12-16-96

	HMENU hObjectMenu	=	GetSubMenu(gd.hMainMenu, 5);

   SetCursorPos( MenuX, MenuY);
	TrackPopupMenu(hObjectMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX -10, MenuY -10, 0, hwnd, NULL);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;                           //   12-16-96
}
//==================F10========================================================
void HandleCheckMenu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100;   //   3-1-97
   INT MenuY = ScrMaxY/2-100;

   GetCursorPos(&pOldCurPos);   // sidedef 1,                no postings, ! from info
   PopupMenu = TRUE;            //   12-16-96

	HMENU hCheckMenu 	=	GetSubMenu(gd.hMainMenu, 6);

   SetCursorPos( MenuX+10,MenuY+10);
	TrackPopupMenu(hCheckMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX,MenuY, 0, hwnd, NULL);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;                            //   12-16-96
}

//==========================================================================
// Hexen only submenu F6
//==========================================================================
void HandleHexenMenu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100;   //   3-1-97
   INT MenuY = ScrMaxY/2-100;

   GetCursorPos(&pOldCurPos);   // sidedef 1,                no postings, ! from info
   PopupMenu = TRUE;            //   12-16-96

	HMENU hHexenMenu =  LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUHEXEN));
	HMENU hHexenSubMenu = GetSubMenu(hHexenMenu, 0);

   SetCursorPos( MenuX+10,MenuY+10);
	TrackPopupMenu(hHexenSubMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX,MenuY, 0, hwnd, NULL);
   DestroyMenu(hHexenMenu);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;           //   12-16-96
}

//==========================================================================
// 12-30-96 bk Quake
//==========================================================================
void HandleQuakeMenu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100; //   3-1-97
   INT MenuY = ScrMaxY/2-100;

   GetCursorPos(&pOldCurPos);
   PopupMenu = TRUE;

   QuakeMode = 1;

	HMENU hQuakeMenu =  LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUQUAKE));
	HMENU hQuakeSubMenu = GetSubMenu(hQuakeMenu, 0);

   SetCursorPos( MenuX+10,MenuY+10);
	TrackPopupMenu(hQuakeSubMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX,MenuY, 0, hwnd, NULL);
   DestroyMenu(hQuakeMenu);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;
}

//==========================================================================
//  8-1-97   HexenII more a placeholder now
//==========================================================================
void HandleHexen2Menu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100; //   3-1-97
   INT MenuY = ScrMaxY/2-100;

   GetCursorPos(&pOldCurPos);
   PopupMenu = TRUE;

   QuakeMode = 2;

	HMENU hQuakeMenu =  LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUQUAKE));
	HMENU hQuakeSubMenu = GetSubMenu(hQuakeMenu, 0);

   SetCursorPos( MenuX+10,MenuY+10);
	TrackPopupMenu(hQuakeSubMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX,MenuY, 0, hwnd, NULL);
   DestroyMenu(hQuakeMenu);

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;
}

//==========================================================================
void HandleStatMenu(HWND hwnd)
{
   INT MenuX = ScrMaxX/2-100; //   3-1-97
   INT MenuY = ScrMaxY/2-100;

   LevelPtr level = &LevelWad.level;

   GetCursorPos(&pOldCurPos);
   PopupMenu = TRUE;           //   12-16-96

	HMENU hSMenu =  LoadMenu(gd.hInst, (LPCTSTR)szLoadString(IDS_MENUSTATUS));
	HMENU hSSubMenu = GetSubMenu(hSMenu, 0);

   if(GridSnap)
    CheckMenuItem(hSSubMenu, CM_STAT1, MF_BYCOMMAND | MF_CHECKED);
   if(AutoCenter)
    CheckMenuItem(hSSubMenu, CM_STAT2, MF_BYCOMMAND | MF_CHECKED);
   if(AutoSelect)
    CheckMenuItem(hSSubMenu, CM_STAT3, MF_BYCOMMAND | MF_CHECKED);
   if(level->MadeChanges)
    CheckMenuItem(hSSubMenu, CM_STAT4, MF_BYCOMMAND | MF_CHECKED);
   if(level->MadeMapChanges)
    CheckMenuItem(hSSubMenu, CM_STAT5, MF_BYCOMMAND | MF_CHECKED);

   SetCursorPos( MenuX+10,MenuY+10);
	TrackPopupMenu(hSSubMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, MenuX,MenuY, 0, hwnd, NULL);
   DestroyMenu(hSMenu); // returns to CM_STAT1 - CM_STAT6

   SetCursorPos( pOldCurPos.x, pOldCurPos.y );   //   3-1-97
   PopupMenu = FALSE;                            //   12-16-96
}

//==========================================================================
//  Program control resumes at the appropriate MenuID in the hwnd
//  if setpos is TRUE set the cursor over and down a bit on the menu
//==========================================================================
//
void HandlePopupMenu(HWND hwnd, int ID, POINT pMenu, Bool setpos, int2 select)
{
  POINT pMouse;
  HMENU hMenu, hSubMenu;
  int2  start;
  int2  menusize;
  POINT PriorCurPos;              //   12-2-96
  int4  yMax;
  int4  xMax;
  //  int4  TotalHeight;
  //  RECT  rc;

  GetCursorPos( &PriorCurPos );   //   12-2-96 trying to get cursor back to where it came from
  // rough approx till all converted to new displaypopup
  menusize = GetSystemMetrics(SM_CYMENUSIZE) -1;
  yMax   = GetSystemMetrics(SM_CYSCREEN);
  xMax   = GetSystemMetrics(SM_CXSCREEN);
  if( pMenu.y+400  > yMax) pMenu.y =yMax-400;
  if( pMenu.x      < 0) pMenu.x = 0;
  if( pMenu.x+300  > xMax) pMenu.x =xMax-300;
  if( pMenu.x      < 0) pMenu.x = 0;
  //Trace(NULL,10,44,"select = %hd (%d,%d)",select,pMenu.x,pMenu.y);

  PopupMenu = TRUE;

  hMenu	  = LoadMenu(gd.hInst, (LPCTSTR)szLoadString(ID) );
  hSubMenu = GetSubMenu(hMenu, 0);          // Grabs the actual menu

  if (setpos)                       // position cursor
  {
       if (EditMode == OBJ_THINGS)  // menu divider
       {   start = menusize + 1;    //(menusize / 2) + (menusize / 2);
       }
       else
       {   start = menusize / 2;
       }

       // need some safety later to keep it up from the bottom, top, etc   note.............
       // don't know how to get size of this one yet
       // make sure popup doesn't go below the bottom, otherwise cursor pos is off
  	    //GetWindowRect(GetDlgItem(hwnd, hMenu), &rc);
       //
       //TotalHeight = rc.bottom-rc.top+10;     // height of popup   12-16-96
       //
       //if ( (pMenu.y + TotalHeight) >= yMax)
       //{     pMenu.y = yMax - TotalHeight;
       //}

       pMouse.x = pMenu.x + 12;               //init center pos. + height of line  * olditem
       pMouse.y = pMenu.y + start + (menusize * select);
       SetCursorPos( pMouse.x, pMouse.y);
  }

  TrackPopupMenu(hSubMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pMenu.x, pMenu.y, 0, hwnd, NULL);
  DestroyMenu(hMenu);

  PopupMenu = FALSE;

  SetCursorPos( PriorCurPos.x, PriorCurPos.y );   //   12-2-96

}

//////////////////////////////////////////////////////////////////////////
//																			               //
//    Handle Right Button Up Messages for ordinary Editing              //
//                                                                      //
//		Called from Mouse.cpp - WM_RBUTTONUP                              //
//                                                                      //
//		Accelerator VK_ENTER																//
//																								//
//////////////////////////////////////////////////////////////////////////
//   12-18-96 note Brad that the dialogs these call already save/restore
//              the cursor, so no need to do it here

// 1-1-97 bk Added edit Vertex
#pragma argsused
void HandleRBUp(HWND hwnd, int x, int y, UINT flags)
{
DLGSELECT DlgSel;								// our Selectlist struct for passing info
LevelPtr level = &LevelWad.level;
int2 xpos, ypos;                       // position of Vertex's

//==============================================================================

    if(Browsing)  return;

    ZeroMemory(&DlgSel, sizeof(DlgSel));			// bye bye, due to the way mem works

    switch(EditMode)
    {
      case OBJ_LINEDEFS:
		 BrowseMode = TEXTURES;    // for choosing new Floor/Ceiling Texture - needed for
                                 // Browse only since some routines are shared
       DlgSel.b2  = FALSE;       // no advance command
       DialogBoxParam(gd.hInst,"EditLineDef",hwnd,EditLineDefDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);
       break;

     case OBJ_THINGS:
		 BrowseMode = SPRITES;     // MAKE SURE !
                                 // DIALOG does this now with TempList
       DlgSel.b2  = FALSE;       // no advance command
       DialogBoxParam(gd.hInst,"ThingEdit",hwnd, EditThingDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);
       break;

     case OBJ_SECTORS:
		 BrowseMode = FLOORS;

       DlgSel.b2  = FALSE;       // no advance command
       DialogBoxParam(gd.hInst,"EditSector",hwnd, EditSectorDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);
       break;

     case OBJ_VERTEXES:
	    xpos = level->Vertexes[CurObject].x;
	    ypos = level->Vertexes[CurObject].y;

       if(Input2Numbers(hwnd, "Set Vertex Position","X pos","Y pos",
                       -32000,32000,&xpos,-32000,32000,&ypos))
       {
	        level->Vertexes[CurObject].x = xpos;
	        level->Vertexes[CurObject].y = ypos;
           RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  // 1-1-97 bk  Redraw after
       }

       break;
    }
}
/////////////////////////////////   end    ////////////////////////////////////
