//////////////////////////////////////
//  Program Name: Mouse.CPP
//
//	Handles L Button Down
// Handles L Button Up
// Handles Mouse Move
//	Handles R Button Down
// Handles R Button Up
// Handles NCMouseMove
//
// Handles them all for the following Modes :
//
//    CheckActivity   moved from Utils since its really a mouse thing
//
//	1.	Rectangle
//	2.	Polygon
//	3. Bounding Rectangle  Used to hightlight an area
// 4. Edit Object
// 5. Mark Object
// 6. Scroll map
// 7. Click on Flag Button on Info Bar
// 8. Click on Picture to Edit on Info Bar
//////////////////////////////////////

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "deep.h"
#include "windeep.h"
#pragma hdrstop

#include <dlgs.h>
extern Bool  MouseConstrain;  //  12-13-96

//#pragma warning (disable: 4068)
///--------global ---------------------------------------------------------
int4   PointerX;
int4   PointerY;
int2   MouseButton = 0;


Bool   SelectTemp  = FALSE;     // undo temp selected once moved

int4   SelectCount = 0;         // number activie in SelectList

SelPtr SelectList  = NULL;      // selection list clicked
SelPtr TempList    = NULL;      // selection list temporary
SelPtr SLineDefList= NULL;      // selection list Sectors = linedefs for sectors
SelPtr LineDefList = NULL;      // selection list with linedefs for sectors/linedefs
SelPtr VertexList  = NULL;      // selection list for all the vertexes
SelPtr OldVertexList;           // selection list of old vertex numbers for drag
SelPtr OldVertexXY  ;           // selection list of old vertex x,y values for drag

POINT  pOldCurPos;              // Global Cursor Position on entry to various...

//------------------------------------------------------------------------
extern int  InfoboxXs, InfoboxXe, InfoboxYs, InfoboxYe;

extern Bool  PopupMenu;     // True=Popup Menu displayed

extern int2  NewObject;     // Selecting a new Hilighted Object

static Bool InInfo = FALSE;

static Bool Thing1 = FALSE;
static Bool Thing2 = FALSE;

static void InfoMouseMove(HWND hwnd, int x, int y, UINT keyFlags);
static void InfoLBDown   (HWND hwnd, int x, int y, UINT keyFlags);

//void  (*pfnLBDown)   (HWND, int, int, UINT);// current mouse handler
//void  (*pfnLBUp)     (HWND, int, int, UINT);// functions for Scrolling, Highlighting
//void  (*pfnMouseMove)(HWND, int, int, UINT);// Flag button, Pic Select, Drawing etc.

//static  LevelPtr level = &LevelWad.level;	    // Grab MaxX, MaxY, MinX...

static  int2 skillval[16] = {0};
static  int2 lineval [16] = {0};


////////////////////////////////////////////////////////////////////////////////
//		WM_RBUTTONDBLCLK, Deep_OnRButtonDown);
//		WM_LBUTTONDBLCLK, Deep_OnLButtonDown);
//		WM_RBUTTONDOWN, 	Deep_OnRButtonDown);
//		WM_LBUTTONDOWN, 	Deep_OnLButtonDown);
//		WM_MOUSEMOVE, 		Deep_OnMouseMove);
//		WM_NCLBUTTONDOWN, Deep_OnNCLButtonDown);
//		WM_NCLBUTTONUP, 	Deep_OnNCLButtonUp);
//		WM_NCMOUSEMOVE, 	Deep_OnNCMouseMove);
////////////////////////////////////////////////////////////////////////////////

//-----------------------------------------------------------------------//
//   see if mouse has moved using cursor compares                        //
//-----------------------------------------------------------------------//

Bool MouseMove(void)
{
    int4 CurPointerX;
    int4 CurPointerY;

    CurPointerX = PointerX;              // current (prior) location
    CurPointerY = PointerY;

    GetCursorPos(&pOldCurPos);

    PointerX = pOldCurPos.x;
    PointerY = pOldCurPos.y-gd.CaptionHeight;  // adjust for top menu bar

      /* just a noted for similar function if need later
      if (PointerY <= TopBarSize           //16  ht*2) at the top of screen
      &&  PointerY > 0 )
      {  TopBarHot=TRUE;
      }
      else
      {  TopBarHot=FALSE;
      }*/

    if (CurPointerX != PointerX || CurPointerY != PointerY)
    {   return TRUE;
    }
    else
    {  return FALSE;
    }
}

/////////////////////////////////////////////////////////////////////////////
//  see if shift,control,alt key is down
/////////////////////////////////////////////////////////////////////////////
void CheckKeyState(void)
{
static int state;
   // 8000 or 8001
   state = GetAsyncKeyState(VK_SHIFT);
   if (state) gd.ShiftDown = state&0x8000;

   state = GetAsyncKeyState(VK_MENU);
   if (state) gd.AltDown = state&0x8000;

   state = GetAsyncKeyState(VK_CONTROL);
   if (state) gd.CtrlDown = state&0x8000;
}

/////////////////////////////////////////////////////////////////////////////
//  see if shift,control,alt key is down , mouse first
/////////////////////////////////////////////////////////////////////////////
void CheckShiftKey(MSG *msg)
{
         // ctrl/shift down
         if (msg->message == WM_KEYDOWN)
         {   if (msg->wParam == VK_SHIFT)
             {   gd.ShiftDown = 0x8000;
                 msg->message = 0;               // turn off so not processed
             }

             if (msg->wParam == VK_CONTROL)
             {   gd.CtrlDown  = 0x8000;
                 msg->message = 0;
             }

             if (msg->wParam == VK_MENU)
             {   gd.AltDown  = 0x8000;
                 msg->message = 0;
             }                                  // turn off so not processed
         }
         else
         // ctrl/shift up
         if (msg->message == WM_KEYUP)
         {   if (msg->wParam == 0x8000)
             {   gd.ShiftDown =  0;
                 msg->message = 0;              // turn off so not processed
             }

             if (msg->wParam == VK_CONTROL)
             {   gd.CtrlDown  = 0;
                 msg->message = 0;              // turn off so not processed
             }

             if (msg->wParam == VK_MENU)
             {   gd.AltDown  =  0;
                 msg->message = 0;
             }                                  // turn off so not processed
         }
         else
         {  CheckKeyState();
         }
}

////////////////////////////////////////////////////////////////////////////
// clear windows queue so we don't get behind
////////////////////////////////////////////////////////////////////////////
void EatMouseData(HWND hwnd)
{ static MSG msg;

  while( PeekMessage(&msg, hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE) )
  { if (TranslateMessage(&msg) )           // put a msg into queue if translated
    {   PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE); // remove again
    }
        if (msg.message == WM_LBUTTONDOWN)
        {   MouseButton |= 1;
        }
        else
        if (msg.message == WM_RBUTTONDOWN)
        {   MouseButton |= 2;
        }
        else
        if (msg.message == WM_MBUTTONDOWN)
        {   MouseButton = 3;
        }
        else
        if (msg.message == WM_MBUTTONUP)    //   12-8-96
        {   MouseButton = 0;
        }
        else
        // button ups
        if (msg.message == WM_LBUTTONUP)
        {   MouseButton &= 2;
        }
        else
        if (msg.message == WM_RBUTTONUP)
        {   MouseButton &= 1;
        }
        else
        if (msg.message == WM_MBUTTONUP)
        {   MouseButton = 0;
        }
        else
        {   CheckShiftKey(&msg);
        }
  }
}

////////////////////////////////////////////////////////////////////////////////
// for browsers see if a key or a button
////////////////////////////////////////////////////////////////////////////////

Bool CheckForKeyOrButtonPressed(HWND hwnd)
{
   MSG msg;
   //  Look for a message        between   Keydown to Keydown and remove it from Q

   if (PeekMessage(&msg, hwnd, WM_KEYDOWN, WM_KEYDOWN, PM_REMOVE))
   {

      if (msg.message == WM_KEYDOWN)
      {
        if (msg.wParam == VK_SHIFT)
        {   gd.ShiftDown = 0x8000;
            return FALSE;               //   5-1-97
        }

        if (msg.wParam == VK_CONTROL)
        {   gd.CtrlDown  = 0x8000;
            return FALSE;
        }

        if (msg.wParam == VK_MENU)
        {   gd.AltDown  = 0x8000;
            return FALSE;
        }
       }

       return TRUE;
   }

   if (PeekMessage(&msg, hwnd, WM_LBUTTONDOWN, WM_LBUTTONDOWN, PM_REMOVE))
       return TRUE;

   if (PeekMessage(&msg, hwnd, WM_RBUTTONDOWN, WM_RBUTTONDOWN, PM_REMOVE))
       return TRUE;

   return FALSE;
}

////////////////////////////////////////////////////////////////////////////
//   Wait for Release of button - sort of ?? --
//    5-1-97 looks like left button down exits, left as is for now
//
////////////////////////////////////////////////////////////////////////////
void ReleaseMouseButton(HWND hwnd)
{ static MSG msg;
  int    Active = TRUE;

  while (Active)
  {
     WaitMessage();   //   8-1-97

     while( PeekMessage(&msg, hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE) )
     {  if (TranslateMessage(&msg) )           // put a msg into queue if translated
        {   PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE); // remove again
        }
        if (msg.message == WM_LBUTTONDOWN)
        {   MouseButton |= 1;
            Active = FALSE;                   //exit   5-1-97 ? how come, this will "stick" if not done so I left it
        }
        else
        if (msg.message == WM_RBUTTONDOWN)
        {   MouseButton |= 2;
        }
        else
        if (msg.message == WM_MBUTTONDOWN)
        {   MouseButton = 3;
        }
        else
        if (msg.message == WM_MBUTTONUP)    // exit
        {   MouseButton = 0;
            Active = FALSE;
        }
        else
        // button ups
        if (msg.message == WM_LBUTTONUP)   // exit
        {   MouseButton &= 2;
            Active = FALSE;
        }
        else
        if (msg.message == WM_RBUTTONUP)   // exit
        {   MouseButton &= 1;
            Active = FALSE;                // added   5-1-97
        }
        else
        if (msg.message == WM_MBUTTONUP)
        {   MouseButton = 0;
        }
        else
        {   CheckShiftKey(&msg);
        }

     }
  }
}

////////////////////////////////////////////////////////////////////////////
// clear windows keyboard only queue so we don't get behind   12-8-96
////////////////////////////////////////////////////////////////////////////
void EatKeyData(HWND hwnd)
{ static MSG msg;

  while( PeekMessage(&msg, hwnd,WM_KEYFIRST,WM_KEYLAST,PM_REMOVE) )
  {     if (TranslateMessage(&msg) )           // put a msg into queue if translated
        {   PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_KEYLAST,PM_REMOVE); // remove again
        }
        CheckShiftKey(&msg);
  }
}

////////////////////////////////////////////////////////////////////////////////
//
//  Reads the current keyboard status globally - ANY WINDOW
//
////////////////////////////////////////////////////////////////////////////////

int2 CheckActivity(int2 *Button, Bool WaitKey) // look for any action (exits if no WAIT -not used anywhere)
{
  MSG msg ={0};
  Bool wait;
  int2 key = -1;

  wait = WaitKey;

  //   3-1-97 was wrong

  do
  {
       if (WaitKey
       &&  msg.message != 0)
       {   WaitMessage();    //   8-1-97
       }

       if (!PeekMessage(&msg, 0, WM_KEYFIRST, WM_MOUSELAST, PM_REMOVE)) continue;

       //CheckShiftKey(&msg); // causes probs 8-1-97 not needed for now

       //       if (TranslateMessage(&msg) )           // put a msg into queue if translated   6-1-97 experiment can't use!
       //       {   PeekMessage(&msg,NULL,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE); // remove again
       //       }

       if (msg.message == WM_KEYDOWN)// wm_char does not work right
       {   key = msg.wParam;
           if (key) wait = NOWAIT;   // key can be -0-   6-1-97
       }
       if (msg.message == WM_LBUTTONUP && WaitKey == WAIT)  // was DOWN
       {  key  = 1;//0x000d;
          wait = NOWAIT;
          MouseButton = 0;
       }
       if (msg.message == WM_RBUTTONUP && WaitKey == WAIT)  // was DOWN
       {  key  = 2;//0x001b
          wait = NOWAIT;
          MouseButton = 0;
       }
   } while(wait) ;

   if(Button != NULL)
   { *Button = key;
   }

   //   8-1-97 let the mouse be released, prevent exits where mouse activity
   // posts again
   /*
   if (WaitKey   // don't need this anymore since above changed to UP
   &&  key ==1 || key == 2)
   {
       for (;;)
       {
          WaitMessage();     //   8-1-97
          PeekMessage(&msg, 0, WM_KEYFIRST, WM_MOUSELAST, PM_REMOVE);
          CheckShiftKey(&msg);
          if (msg.message == WM_LBUTTONUP
          ||  msg.message == WM_RBUTTONUP)
          {   break;
          }
        }

   } */
   return key;
}
/////////////////////////////////////////////////////////////////////////////
//   11-5-96 return Button and if a character key in msg area
//     11-8-96 actually, translating all the keys to a 256 range makes
// life a lot simpler and would mimic the DOS style exactly
// I don't know what they were thinking of, but I disagree so far?
// much simpler having unique same keycodes + the control states
// makes code much easier having exclusive keycodes...maybe later
//
// 1-1-97 bk Added support for LBUTTONDBLCLK
// 3-31-97 bk USED hwnd as parameter, can still pass NULL if you want
//
/////////////////////////////////////////////////////////////////////////////
#pragma argsused                         //*MouseStatus
UINT GetMouseCoords(HWND hwnd, MSG *msg, Bool RawKey, int4 *xnew, int4 *ynew,int2 *Button)
{
//static  POINTS pt;
static  UINT   keycode = 0;

//========================

  // always store in global PointerX and Y too

  keycode = 0;

  GetCursorPos(&pOldCurPos);
  PointerX = pOldCurPos.x;
  PointerY = pOldCurPos.y -gd.CaptionHeight;  // adjust for top menu bar

  msg->message = 0;          // be sure to reset what user sees

  // need to eat all queued up messages that are too old??   11-10-96

  //if  (PeekMessage(msg,NULL,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE))
  if  (PeekMessage(msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE))
  {
      if (!RawKey)  //   7-1-97 new option so can get raw keys, no virt stuff
      {
          if (TranslateMessage(msg) )           // put a msg into queue if translated
          {   PeekMessage(msg,NULL,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE); // remove again
          }
      }

      if (msg->message >= WM_MOUSEFIRST
       && msg->message <= WM_MOUSELAST  )
      {
         if (msg->message == WM_MOUSEMOVE)
         {  //pt = MAKEPOINTS(msg->lParam);
            //pOldCurPos.x = pt.x;
            //pOldCurPos.y = pt.y;
            //PointerX = pOldCurPos.x;
            //PointerY = pOldCurPos.y;
         }
         else
         if (Button)        // slight problem since all code not ORring yet
         {  // botton downs
           if (msg->message == WM_LBUTTONDOWN)
           {   *Button |= 1;
           }
           else
           if (msg->message == WM_RBUTTONDOWN)
           {   *Button |= 2;
           }
           else
           if (msg->message == WM_MBUTTONDOWN)
           {   *Button = 3;
           }
           else
           if (msg->message == WM_MBUTTONUP)    //   12-8-96
           {   *Button = 0;
           }
           else
           // button ups
           if (msg->message == WM_LBUTTONUP)
           {   *Button &= 2;
           }
           else
           if (msg->message == WM_RBUTTONUP)
           {   *Button &= 1;
           }
           else
           if (msg->message == WM_MBUTTONUP)
           {   *Button = 0;
           }
           else
           if (msg->message == WM_LBUTTONDBLCLK)  // 1-1-97 bk added DblClk
           {   *Button |= 4;
           }
         }
      }
      else
	   if(msg->message >= WM_KEYDOWN  && msg->message <= WM_DEADCHAR)
      {  //keycode = (UINT)msg->wParam;
         if (msg->message == WM_CHAR)
             keycode = toupper((UINT)msg->wParam);
         else
         if (msg->message == WM_KEYDOWN)     // checkshift gets this next
             keycode = (UINT)msg->wParam;

         CheckShiftKey(msg);
      }
          // debug stuff, leave for future questions
          /*
          if (msg->message == WM_TIMER)
          {
              Trace(hwnd,200,4, "msg=%d, Button =na" ,(UINT)msg->message);
          }
          else
          if (Button)
          {   Trace(hwnd,10, 4, "msg=%d, Button =%hd",(UINT)msg->message,*Button);
          }
          else
          {   Trace(hwnd,10, 4, "msg=%d, Button =na" ,(UINT)msg->message);
          }

          if (keycode)
          {   Trace(hwnd,10,24, "msg=%d, key%d" ,(UINT)msg->message,keycode);
          } */

  }
  else
  {   // 8000 or 8001
      CheckKeyState();              // check just keyboard
   }

  if (xnew)  *xnew = PointerX;
  if (ynew)  *ynew = PointerY;

  //Trace(hwnd,200,24, "shift%d, ctrl=%d,alt=%d" ,gd.ShiftDown,gd.CtrlDown,gd.AltDown);
  return keycode;
}

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//          S T A R T  of  TIMING  Routines for mouse                         //
//                                                                            //
//                                                                            //


/////////////////////////////////////////////////////////
//  At entry mouse button 1 is down                    //
//  Returns one of three responses                     //
//  0 :  no other button pressed                       //
//  1 :  left button was released                      //
//  2 :  left button was clicked twice                 //
// -1 :  went from left to right button
//                                                     //
// All events have to happen with the system           //
// Double Click time recorded in Control Pnl           //
// so if double click time is too fast this won't work //
/////////////////////////////////////////////////////////
static Bool WaitForLeft(HWND hwnd)
{
  DWORD  future;
  MSG    msg;
//  POINTS pt;

  Bool  Up = 0; // no other mouse event was recorded within the DblClk time

#define DeltaMinimumL  4                  // minimum movement is 4 pixels

  int   oldX = pOldCurPos.x;
  int   oldY = pOldCurPos.y;

//===========================

  if (gd.ShiftDown || gd.CtrlDown )       //   11-5-96
  {   return 0;                           // start zoom or panning mode
  }

  // GetTickCount is accurate to millisecs

  future = GetTickCount() + ButtonDelay;   // add dblclk time

  //  while( future > GetTickCount())      // return after DblClk time
  for (;;)                                 //   3-1-97
  {

    //if (!PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE)) continue; // nothing's going on
    if (PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE))    // activity
    {
      if (TranslateMessage(&msg) )           // put a msg into queue if translated
      {   PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE); // remove again
      }

      if (msg.message == WM_LBUTTONUP)
      {   Up = 1;                         // DON'T BREAK ! , have to wait DClkTime
      }
      else
      if (msg.message == WM_LBUTTONDBLCLK)
      {   Up = 2;
          break;
      }
      else
      // permit early exit if moved enough
      if (msg.message == WM_MOUSEMOVE)  // if user moves permit early exit
      {   GetCursorPos(&pOldCurPos);
          if (abs(pOldCurPos.x-oldX) > DeltaMinimumL) break;
          if (abs(pOldCurPos.y-oldY) > DeltaMinimumL) break;
      }
      else
      // user can change mind, can't they
      if (msg.message == WM_RBUTTONDOWN)   //   11-5-96
      {   Up = -1;
          break;
      }
      else
      {   CheckShiftKey(&msg);
      }
    }
    //   3-1-97 so does not deselect so easy
    // still no buttons
    // if no movement, extend the time
    if (!Up)
    {   future = GetTickCount() + ButtonDelay;   // extend the time
    }

    if( future <= GetTickCount() ) break;          //time expired return after DblClk time

  }

  return Up;
}

////////////////////////////////////////////////////////////////////////////////
//  Mouse button 2 is down on entry          //
//  Returns one of three responses           //
//  0 : false, no other button pressed       //
//  1 : true , left button was released      //
//  2 : TWO  , button was clicked twice      //
//                                           //
// All events have to happen with the system //
// Double Click time recorded in Control Pnl //
////////////////////////////////////////////////////////////////////////////////
Bool WaitForRight(HWND hwnd)
{
  DWORD future;
  MSG   msg;
//POINTS pt;
  Bool  Up = 0; // no other mouse event was recorded within the DblClk time

//#define DeltaMinimumR  4                  // minimum movement is 4 pixels
//  int   oldX = pOldCurPos.x;
//  int   oldY = pOldCurPos.y;

//===========================

 if (gd.ShiftDown || gd.CtrlDown )       //   11-5-96
 {   return 0;                           // start zoom or panning mode
 }

 //  GetTickCount is accurate to millisecs

 future = GetTickCount() + ButtonDelay;  // add dblclk time

 while( future > GetTickCount())         // return after DblClk time
  {                          //WM_MOUSEFIRST
     if (!PeekMessage(&msg,hwnd,WM_KEYFIRST, WM_MOUSELAST,PM_REMOVE))continue;

     if (TranslateMessage(&msg) )           // put a msg into queue if translated
     {   PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE); // remove again
     }

     if (msg.message == WM_RBUTTONUP)
     {  if(Up == 2)   break;
           Up = 1;                         // DON'T BREAK !
     }
     else
     if (msg.message == WM_RBUTTONDBLCLK)
     {   Up = 2;
         //break;    12-12-96 bk frickin DblClk is generated BEFORE RButtonUP
     }
     else
     // user can change mind, can't they
     if (msg.message == WM_LBUTTONDOWN)   //   11-5-96
     {   Up = -1;
         break;
     }
     else
     // permit early exit if moved enough
     //   11-11-96 causes problems with dragging so turned it off
     if (msg.message == WM_MOUSEMOVE)  // if user moves permit early exit
     {
         GetCursorPos(&pOldCurPos);      //   3-1-97 for actual coordinates
         //pt = MAKEPOINTS(msg.lParam);  // but this is always relative to window, look into later
         //pOldCurPos.x = pt.x;          // since other code could rely on this, but I don't think so
         //pOldCurPos.y = pt.y;

         //if (abs(pOldCurPos.x-oldX) > DeltaMinimumR) break;
         //if (abs(pOldCurPos.y-oldY) > DeltaMinimumR) break;
     }
     else
     {   CheckShiftKey(&msg);
     }
  }
  return Up;
}

/////////////////////////////////////////////////////////////////////////////
//							Handle  Map  Y  scrolling	 UP ONLY							//
//							Implemented from Cursor over Caption Bar					//
/////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
// Mouse just hits the edge, NO button needs to be pushed
//
//	Handles Mouse Movements, Displays x & y
// and changes the cursor depending on the mode
//    11-11-96 revised
//  this also gets mouse messages from the bottom AREA !!!   11-11-96
///////////////////////////////////////////////////////////////////////////////
#define MAPSPEED 20       //   8-1-97

#pragma argsused
void ScrollMouseMove(HWND hwnd, int x, int y, UINT keyFlags)
{
  HDC      hdc, hMemDC;
  HBITMAP  hMemBmp, hMemOldBmp;
  HPALETTE hOldPal;
  RECT     rc;
  MSG      msg;
  int4     Elapsed;
//POINTS   pt;
//-----------------------------------------------------------------

  CheckKeyState();

  // cursor is in a valid scroll area
  GetClientRect(hwnd, &rc);
  //Trace(hwnd,10,4,"1 %d,%d %d,%d",x,y,rc.right, rc.bottom);

  hdc = GetDC(hwnd);

  msg.message = 0;

  // Create a bitmap big enough to hold the window's image

  hMemDC 	 = CreateCompatibleDC(hdc);
  hMemBmp 	 = CreateCompatibleBitmap( hdc, rc.right, rc.bottom);
  hMemOldBmp = SelectBitmap(hMemDC, hMemBmp);
  hOldPal    = SelectPalette(hMemDC, gd.hDoomPal, FALSE);     //  11-3-96 get colors
  RealizePalette(hMemDC);                                     //    ..

  // set PointerX,PointerY

  MouseMove();  //   11-11-96 set actual coordinates,ones passed belong to diff areaa

  for (;;)
  {                           // WM_MOUSEMOVE WM_MOUSEMOVE
     if (PeekMessage(&msg, hwnd, WM_KEYFIRST, WM_MOUSELAST, PM_REMOVE))
     {
        if (TranslateMessage(&msg) )           // put a msg into queue if translated
        {   PeekMessage(&msg,hwnd,WM_KEYFIRST,WM_MOUSELAST,PM_REMOVE); // remove again
        }

        if(msg.message == WM_MOUSEMOVE)
        {
           MouseMove();
        }
        else
        {  CheckShiftKey(&msg);
        }
     }
     // within the map

     // left side
     if(PointerX < ScrollMapBorder)
 	  {
		 if (ScrollMapRight(hMemDC,&rc) )
		 {   TimerGetTickCount(1);
           BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY); //   12-8-96 ask about this
		     GdiFlush();                    // Make sure it process's right away - TIME IT
           Elapsed = TimerGetTickCount(3);
           if (Elapsed < MAPSPEED) Sleep(MAPSPEED-Elapsed);
       }
	  }
     // right side
     else
     if(PointerX > (gd.rcClient.right - ScrollMapBorder))
 	  {
		 if (ScrollMapLeft(hMemDC, &rc))
		 {   TimerGetTickCount(1);
		     BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
		     GdiFlush();                     //   11-10-96 ? is this for sure neededothrplaces don;t have it
           Elapsed = TimerGetTickCount(3);
           if (Elapsed < MAPSPEED) Sleep(MAPSPEED-Elapsed);
       }
	  }
     // top
     else
     if(PointerY < ScrollMapBorder)
 	  {
		 if (ScrollMapDown(hMemDC, &rc))
		 {   TimerGetTickCount(1);
		     BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
		     GdiFlush();	                  // Make sure it process's right away - TIME IT
           Elapsed = TimerGetTickCount(3);
           if (Elapsed < MAPSPEED) Sleep(MAPSPEED-Elapsed);
           //Trace(hwnd,10,24,"2 %d,%d %d,%d",PointerX,PointerY,rc.right, rc.bottom);
       }
	  }
     // bottom
     else
     if(PointerY > (gd.rcClient.bottom - ScrollMapBorder))
 	  {
	  	 if (ScrollMapUp(hMemDC,&rc))
		 {   TimerGetTickCount(1);
		     BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
		     GdiFlush();
           Elapsed = TimerGetTickCount(3);
           if (Elapsed < MAPSPEED) Sleep(MAPSPEED-Elapsed);
       }
	  }
     // Not at any edge
     else
     {  break;
     }

   } // END while(OkToScroll)

   SelectBitmap(hMemDC, hMemOldBmp);
   SelectPalette(hMemDC, hOldPal, FALSE);  // 1-15-97 bk
   DeleteBitmap(hMemBmp);
   DeleteDC(hMemDC);

   //        hdc , RECT   , Erase Bk, Palette in
   RedrawMap(hdc, &gd.rcClient, ERASEYES, FALSE);
   ////SelectPalette(hdc, hOldPal, FALSE);            //   11-3-96
   ReleaseDC(hwnd, hdc);

   EnableCursor(hwnd, (HCURSOR)LoadCursor(0, IDC_ARROW));
   MoveCursor = FALSE;

   //if(!gd.ShiftDown)    ResetMapResident(hwnd, FALSE, TRUE, FALSE); // Reset all objects
}

////////////////////////////////////////////////////////////////////////////////
// Ruler start
////////////////////////////////////////////////////////////////////////////////

int4 RulerPointerX =-1;    // coordinates of last ruler
int4 RulerPointerY;

static void RulerIO(HDC hdc,int4 WPointerX, int4 WPointerY)
{
static int4  r;

      if (RulerSize > 4)
      {
          r = (RulerSize*Scale);

          if (RulerRectangle)
          {  // DrawRectangle(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
             // r >>=1;
             // DrawRectangle(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
             // r >>=1;
             // DrawRectangle(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
             Rectangle(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
             r >>=1;
             Rectangle(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
             r >>=1;
             Rectangle(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
          }
          else
          {  // alternate with filled in center

             Ellipse(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
             r >>=1;
             Ellipse(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
             r >>=1;
             Ellipse(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
          }

          // filled circles not too useful
          // Ellipse(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
          // r >>=1;
          // Ellipse(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
          // r >>=1;
          // Ellipse(hdc,WPointerX- r, WPointerY- r, WPointerX +r, WPointerY +r);
      }
      // big cross-hair
      DrawLine(hdc, 1         ,WPointerY, ScrMaxX-1, WPointerY );
      DrawLine(hdc, WPointerX ,1        , WPointerX, ScrMaxY-2 );
}

///////////////////////////////////////////////////////////////////////////////
// draw the Ruler
///////////////////////////////////////////////////////////////////////////////
void DrawRuler(HWND hwnd, int4 CurrentX, int4 CurrentY)
{
        static int4     WPointerX;
        static int4     WPointerY;
        static HDC 	   hdc;
        static HPEN     hOldPen;
        static HBRUSH   hOldBrush;
        static HPALETTE hOldPal;
        //static int	   OldROP;
        //static counter;
        //Trace(NULL,10,4,"ruler %d",counter++);
        //((HBRUSH)SelectObject((hdc), (HGDIOBJ)(HBRUSH)(hbr)))
        ShowCursor(FALSE);                //   4-1-97
        hdc = GetDC(hwnd);
        hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);
        RealizePalette(hdc);
	     hOldPen  = SelectPen(hdc, gd.hPens[RulerColor]);  // Magenta
        if (RulerHollow)
        {   hOldBrush= SelectBrush(hdc, gd.hBrushes[BLACK]);  //nofill
        }
        else
        {   hOldBrush= SelectBrush(hdc, gd.hBrushes[WHITE]);  //fill
        }

	     SetROP2(hdc, R2_XORPEN);  // use XOR ROP : drawing any line twice erases it

        //DrawBigMap sets RulerPointerX =-1 if new screen

        if (RulerPointerX != -1)                         // erase prior
        {   RulerIO(hdc,RulerPointerX,RulerPointerY);
        }

        WPointerX= CurrentX;
        WPointerY= CurrentY;
        RulerIO(hdc,WPointerX,WPointerY);

        RulerPointerX = WPointerX;      	// save for erase
        RulerPointerY = WPointerY;      	// save for erase

        SelectPalette(hdc, hOldPal, FALSE);
        SelectBrush  (hdc, hOldBrush);
        //SetROP2(hdc, OldROP);
        SetROP2(hdc, R2_COPYPEN);
        ReleaseDC(hwnd, hdc);
        ShowCursor(TRUE);                 //   4-1-97
}

////////////////////////////////////////////////////////////////////////////////
//
//	The Main Mouse Move Handler  Displays x & y
// and changes the cursor depending on the mode
//
// Check to See whether mouse is constrained and if shift key is down - don't
// highlight anything and/or release the mouse constraining to our screen
///////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags)
{

  CheckKeyState();

  if (gd.ShiftDown )
  {   if (MouseConstrained)   ConstrainCursor(FALSE);//Release Mouse Constraint
  }
  else
  {   if((!MouseConstrained)                         // not contrained yet
      && (MaxConstrain))     ConstrainCursor(TRUE);  // but constrain desired
  }

  //Trace(hwnd,10,4,"OnMouseMOve %d,%d",x,y);

  PointerX =	x;        // Update our Pointers
  PointerY =	y;        //   11-10-96 already adjust by CaptionHeight

  XYUpdate(hwnd,x, y);        // update our position

  //---------------------------------------------------------

  if(gd.CaptionHit)	    // We're out of the caption if we are receiving MouseMove's
  {
		EnableCursor(hwnd, (HCURSOR)LoadCursor(0, IDC_ARROW));// So, change our cursor back to normal
   	gd.CaptionHit = FALSE;
  }

  // this is main scrolling code normally entered when hitting edges   11-11-96 was below

  if( x <  ScrollMapBorder
   || x > (gd.rcClient.right - ScrollMapBorder)
   || y <  ScrollMapBorder
   || y > (gd.rcClient.bottom - ScrollMapBorder))
  {
    	 if( !gd.ShiftDown)           //   11-11-96 not if left button down
       {  MoveCursor = TRUE;
    	    EnableCursor(hwnd, gd.hCursorMove);

          // if no button movement required do it now, otherwise let button get it
          if (MoveUsingEdge) ScrollMouseMove(hwnd, x, y, keyFlags);
       }
       return;
  }

  // need common routine to keep trak of which cursor is active   11-11-96

  if(MoveCursor)
  {  MoveCursor = FALSE;
     EnableCursor(hwnd, (HCURSOR)LoadCursor(0, IDC_ARROW));
  }

//---------------------------------------------------------

 // check and see if we are in the INFO windows FIRST

 if (InfoShown                            // info's are active
 && x >= InfoboxXs                        // within box
 && x < InfoboxXe
 && y > InfoboxYs
 && y < InfoboxYe )
 {
    InInfo = TRUE;
    InfoMouseMove(hwnd, x, y, keyFlags); // PointerX & Y already set if needed
 }
 else // NOT in the Info Windows - but in the Scroll Area
 {
    if (InInfo)
    {   InInfo = FALSE;     // Not in any more
        Thing1 = FALSE;
        Thing2 = FALSE;
        UpdateObjectInfo(hwnd, CurObject);
    }

  	 //if(!Editing)// && gd.hCursorPatch == GetCursor())) // If edit Window ! up
    // {
    //   if(MoveCursor)     MoveCursor = FALSE;
    //   EnableCursor(hwnd, (HCURSOR)LoadCursor(0, IDC_ARROW));
    // }

	 //OldObject = CurObject;

	 if (AutoSelect && !gd.ShiftDown )//&& !InTheBox() ) // not in bottom info windows
    {
        if(EditMode == OBJ_THINGS)   NewObject = LookForObject(EditMode, int2(Range * 2));
	     else                         NewObject = LookForObject(EditMode, Range);  //4

    }

    if( (CurObject != NewObject) && (NewObject != -1) )
    {

        CurObject = NewObject;

	     if (CurObject < 0)
        {  CurObject = OldObject;  // none selected
           OldObject = CurObject;
        }

        if ( (CurObject < 0) && (Select0 == TRUE) )
        {  CurObject = 0;
           OldObject = 0;
        }

        //------------------------------------------------------------
        // any current object must be first in select list
        //------------------------------------------------------------
        if (SelectList != NULL && IsSelected (SelectList, CurObject)   // see if in list
         && SelectList->objnum != CurObject )                          // yes, not first
        {   UnSelectObject( &SelectList, CurObject);
	 	    	SelectObject  ( &SelectList, CurObject);
        }

 		  HilightObject(hwnd, EditMode, OldObject, gd.hHiLightPen);
 		  HilightObject(hwnd, EditMode, CurObject, gd.hHiLightPen);
        UpdateObjectInfo(hwnd, CurObject);
        //Trace(hwnd, 300, 8, "old %d, new%d", OldObject, CurObject);
        SoundBeep(SoundClick1);
        OldObject = CurObject;
    }
    //
    //  Ruler boxes
    //
    if (ShowRulers)
    {
        DrawRuler(hwnd,PointerX,PointerY);
    }
 }  // NOT in the Info Windows
                                                //>>>>> L O O K <<<<<<<<<
/////////   FORWARD_WM_MOUSEMOVE(hwnd, x, y, keyFlags, Deep_DefProc); // 1-15-97 bk testing    need to verify myself is ok

   // NOT even in the routine anymore !
}
//----------------------------------------------------------------------------
// Called from LineFlagLBDown & LineHXFlagLBDown
// just initializes all skill flags
//----------------------------------------------------------------------------
static void SetupLineVal(int2 objnum)
{
	 lineval[0] = GetLineDefFlag( objnum, 1);   // Impassble
	 lineval[1] = GetLineDefFlag( objnum, 2);   // Block Enemy
	 lineval[2] = GetLineDefFlag( objnum, 3);   // 2 Sided
	 lineval[3] = GetLineDefFlag( objnum, 4);   // Upper Unpegged
	 lineval[4] = GetLineDefFlag( objnum, 5);   // Lower Unpegged
	 lineval[5] = GetLineDefFlag( objnum, 6);   // Secret
	 lineval[6] = GetLineDefFlag( objnum, 7);   // Block Sound
	 lineval[7] = GetLineDefFlag( objnum, 8);   // Invisible
	 lineval[8] = GetLineDefFlag( objnum, 9);   // Automap

    if ( GameVersion == 4 )         // HEXEN
    {
        lineval[9] = GetLineDefFlag( objnum,10);   // 10  repeatable
    }
    else
    {
        if ( GameVersion <= 2
        &&   BOOMSupport)
        {
            lineval[9] = GetLineDefFlag( objnum,10);   // 10  BOOM Use Wrks
        }
        else
        {   lineval[9] =-1;
        }
        lineval[10]= 0;//-1; 3-1-98 was -1 ?
        lineval[11]= 0;//-1;
        lineval[12]= 0;//-1;
        lineval[13]= 0;//-1;
        lineval[14]= 0;//-1;
        lineval[15]= 0;//-1;
    }
}

/////////////////////////////////////////////////////////////////////////////
//	Adjust the new settings accordingly
/////////////////////////////////////////////////////////////////////////////
static uint2 SetNewLineVal(uint2 NewFlag)
{
   int2 	n;

   if ( GameVersion == 4 )               // HEXEN
   {

       NewFlag = int2( lineval[11]   + lineval[12]*2 + lineval[13]*3 + lineval[14]*4 + lineval[15]*5 );

       if (NewFlag > 5) NewFlag = 5;

       NewFlag <<= 10;

	    for (n=0; n< 10; n++)
       {   if (lineval[n])
	        {   NewFlag  = uint2( NewFlag ^ (0x01 << n));
		     }
       }
   }
   else
   {
       for (n=0; n< 10; n++)   // was 9
       {   if (lineval[n])
	        {   NewFlag  = uint2( NewFlag ^ (0x01 << n));
		     }
       }
   }
   return NewFlag;
}

/////////////////////////////////////////////////////////////////////////////
// Called from LineFlagLBDown & LineHXFlagLBDown
// just initializes all skill flags
/////////////////////////////////////////////////////////////////////////////
static void SetupSkillVal(int2 objnum)
{
     skillval[0] = GetSkillFlag( objnum, 1);      // 1  0 1/2
     skillval[1] = GetSkillFlag( objnum, 2);      // 2  1 3
     skillval[2] = GetSkillFlag( objnum, 3);      // 3  2 4/5
     skillval[3] = GetSkillFlag( objnum, 4);      // 4  3 deaf
     skillval[4] = GetSkillFlag( objnum, 5);      // 5  4 multi(dormant)

     skillval[5]  = -1;
     skillval[6]  = -1;
     skillval[7]  = -1;
     skillval[8]  = -1;
     skillval[9]  = -1;
     skillval[10] = -1;

     if (GameVersion <=2
     &&  BOOMSupport)
     {
         skillval[5]  = GetSkillFlag( objnum, 6);   // 6  5 BOOM NotDM
         skillval[6]  = GetSkillFlag( objnum, 7);   // 7  6 BOOM NotCOOP
     }

     if ( GameVersion == 4 )        // HEXEN
     {
         skillval[5]  = GetSkillFlag( objnum, 6);   // 6  5 fighter)
         skillval[6]  = GetSkillFlag( objnum, 7);   // 7  6 cleric
         skillval[7]  = GetSkillFlag( objnum, 8);   // 8  7 Mage

         skillval[8]  = GetSkillFlag( objnum, 9);   // 1  8 single
         skillval[9]  = GetSkillFlag( objnum,10);   // 2  9 coop
         skillval[10] = GetSkillFlag( objnum,11);   // 3  10 deathmatch
     }
}

//////////////////////////////////////////////////////////////////////////////
//	Adjust the new settings accordingly
//////////////////////////////////////////////////////////////////////////////
static uint2 SetNewSkillVal(int2 num, uint2 NewFlag)
{
	int2 	n;

   for (n=0; n< num; n++)		// 5 for Doom,7 BOOM, 16 for Hexen
   {   if (skillval[n])
	    {   NewFlag  =uint2( NewFlag ^ (0x01 << n));
	    }
   }
   return NewFlag;
}

//----------------------------------------------------------------------------
// set Thing flags for screen box routine below
//----------------------------------------------------------------------------

static void SetThingFlags(int2 when, SelPtr objlist)
{
   LevelPtr level = &LevelWad.level;
   SelPtr cur;

   for (cur = objlist; cur; cur = cur->next)
   {   level->Things[cur->objnum].when = when;              //new flag
   }
   level->MadeChanges++;
}

//----------------------------------------------------------------------------
// set LineDef flags for screen box routine below
//----------------------------------------------------------------------------
static void SetLineDefFlags(int2 flag, SelPtr objlist)
{
   LevelPtr level = &LevelWad.level;
   SelPtr cur;

   for (cur = objlist; cur; cur = cur->next)
   {    level->LineDefs[cur->objnum].flags = flag;           //new flag
   }
   level->MadeChanges++;
}
////////////////////////////////////////////////////////////////////
//																						//
//		INFO THING WINDOW FLAG Left Button Down  Routine				//
//																						//
//	Handles LBDown for clicking Flag buttons for THING Attrib. 		//
//																						//
////////////////////////////////////////////////////////////////////
#pragma argsused
static void InfoThingFlagLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
   HDC 		hdc = GetDC(hwnd);
   RECT 		rc;
   uint2		NewFlag;

   CopyRect(&rc, &rcEasy);

	SetTextType(hdc, 3);		// For Flagbutton

   if(SelectList) SetupSkillVal(SelectList->objnum);
   else  			SetupSkillVal(CurObject);

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[0] = !skillval[0];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[0], IDS_EASY1, &rc);
   }

	rc.top   += (ht2+1);
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[1] = !skillval[1];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[1], IDS_MEDIUM1, &rc);
   }
	rc.top += (ht2+1);
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) &&  (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[2] = !skillval[2];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[2], IDS_HARD1, &rc);
   }
   rc.top += ht2+1;
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[3] = !skillval[3];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[3], IDS_DEAF1, &rc);
   }
	rc.top   += ht2+1;
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[4] = !skillval[4];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[4], IDS_NETWORK1, &rc);
   }

   //==================================

	NewFlag = 0;
	NewFlag = SetNewSkillVal(5, NewFlag); // Doom flags

	if (SelectList)
	{   SetThingFlags(NewFlag, SelectList);
	}
	else
	{   SelectObject ( &TempList, CurObject);
	    SetThingFlags( NewFlag, TempList );
	    ForgetSelection( &TempList);          // get rid of old list
	}
   ReleaseDC(hwnd, hdc);
}



////////////////////////////////////////////////////////////////////
//																						//
//		INFO BOOM THING WINDOW FLAG Left Button Down  Routine	    	//
//																						//
//	Handles LBDown for clicking Flag buttons for THING Attrib. 		//
//																						//
////////////////////////////////////////////////////////////////////
#pragma argsused
static void InfoThingBOOMFlagLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
   uint2 NewFlag;              // all bits to set

   HDC			hdc = GetDC(hwnd);
   RECT			rc;

   CopyRect(&rc, &rcEasy);

   if(SelectList) SetupSkillVal(SelectList->objnum);
   else  			SetupSkillVal(CurObject);

   SetTextType(hdc, 3);	           // For Flagbutton

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[0] = !skillval[0];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[0], IDS_EASY1, &rc);
   }
   rc.top   += (ht2+1);
  	rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[1] = !skillval[1];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[1], IDS_MEDIUM1, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[2] = !skillval[2];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[2], IDS_HARD1, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[3] = !skillval[3];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[3], IDS_DEAF1, &rc);
   }

   //////////////////////////////////////////////////////
	// Now, Second Row of Thing Buttons over a little bit
   //////////////////////////////////////////////////////

	CopyRect(&rc, &rcEasy);
	rc.left  += 62;
   rc.right += 62;
   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[4] = !skillval[4];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[4], IDS_NETWORK1, &rc);
   }

	rc.top += (ht2+1);
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) &&  (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[5] = !skillval[5];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[5], IDS_NOTDM1, &rc);
      //Trace(NULL,10,4,"notdm %hd",skillval[5]);
   }

	rc.top += (ht2+1);
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[6] = !skillval[6];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[6], IDS_NOTCOOP1, &rc);
      //Trace(NULL,10,34,"notcoop %hd",skillval[6]);
   }
   //==================================

	NewFlag = 0;
	NewFlag = SetNewSkillVal(7, NewFlag);

	if (SelectList)
	{   SetThingFlags(NewFlag, SelectList);
	}
	else
	{   SelectObject ( &TempList, CurObject);
	    SetThingFlags( NewFlag, TempList );
 	    ForgetSelection( &TempList);          // get rid of old list
	}

   ReleaseDC(hwnd, hdc);

}


////////////////////////////////////////////////////////////////////
//																						//
//		INFO THING WINDOW FLAG Left Button Down  Routine				//
//																						//
//	Handles LBDown for clicking Flag buttons for THING Attrib. 		//
//																						//
////////////////////////////////////////////////////////////////////
#pragma argsused
static void InfoThingHXFlagLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
   uint2 NewFlag;              // all bits to set

   HDC			hdc = GetDC(hwnd);
   RECT			rc;

   CopyRect(&rc, &rcEasy);

   if(SelectList) SetupSkillVal(SelectList->objnum);
   else  			SetupSkillVal(CurObject);

   SetTextType(hdc, 3);		// For Flagbutton

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[0] = !skillval[0];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[0], IDS_EASY, &rc);
   }
   rc.top   += (ht2+1);
  	rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[1] = !skillval[1];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[1], IDS_MEDIUM, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[2] = !skillval[2];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[2], IDS_HARD, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[3] = !skillval[3];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[3], IDS_DEAF, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[4] = !skillval[4];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[4], IDS_DORMANT, &rc);
   }

   //////////////////////////////////////////////////////
	// Now, Second Row of Thing Buttons over a little bit
   //////////////////////////////////////////////////////

	CopyRect(&rc, &rcEasy);
	rc.left  += 48;
   rc.right += 48;

   if( (x>rc.left) && (x<rc.right) &&  (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[5] = !skillval[5];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[5], IDS_FIGHTER, &rc);
   }

	rc.top += (ht2+1);
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[6] = !skillval[6];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[6], IDS_CLERIC, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;
   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[7] = !skillval[7];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[7], IDS_MAGE, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;
   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[8] = !skillval[8];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[8], IDS_SINGLE, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;
   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[9] = !skillval[9];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[9], IDS_COOP, &rc);
   }
	rc.top += ht2+1;
   rc.bottom = rc.top + ht2;
   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
      skillval[10] = !skillval[10];   // toggle bit flag
		SoundBeep(SoundClick1);
		DrawFlagButton(hdc, skillval[10], IDS_DEATH, &rc);
   }

	NewFlag = 0;
	NewFlag = SetNewSkillVal(16, NewFlag);

	if (SelectList)
	{   SetThingFlags(NewFlag, SelectList);
	}
	else
	{  SelectObject ( &TempList, CurObject);
	   SetThingFlags( NewFlag, TempList );
	  ForgetSelection( &TempList);          // get rid of old list
	}

   ReleaseDC(hwnd, hdc);

}


////////////////////////////////////////////////////////////////////
//																						//
//		INFO THING WINDOW Type Menu Left Button Down  Routine			//
//																						//
////////////////////////////////////////////////////////////////////
#pragma argsused
static void	InfoThingTypeLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
DLGSELECT DlgSel;								// our Selectlist struct for passing info

 ZeroMemory(&DlgSel, sizeof(DlgSel));

 BrowseMode = SPRITES;  // MAKE SURE !

 if(SelectList != NULL)   DlgSel.sel = SelectList;
 else                     DlgSel.sel = NULL;

 DlgSel.obj = CurObject;
 DlgSel.b2  = TRUE;              // advance command
 DlgSel.post = IDD_CHANGETYPE;   // message to post

 DialogBoxParam(gd.hInst,"ThingEdit",hwnd, EditThingDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);

 DlgSel.sel = NULL;   //  MAKE SURE !

 UpdateObjectInfo(hwnd, CurObject);                   // show stuff on bottom
}



////////////////////////////////////////////////////////////////////
//																						//
//		INFO THING WINDOW Hexen Args Left Button Down  Routine				//
//																						//
////////////////////////////////////////////////////////////////////
#pragma argsused
static void	InfoThingArgsLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
  LevelPtr level = &LevelWad.level;

  if (SelectList)
	{ InitThingCommand(SelectList, level);// init special, type etc.
     EditThingCommand(hwnd, level, SelectList,1);
	}
  else
	{ SelectObject ( &TempList, CurObject);
	  InitThingCommand(TempList, level);// init special, type etc.
     EditThingCommand(hwnd, level, SelectList,1);
     ForgetSelection( &TempList);          // get rid of old list
	}

  UpdateObjectInfo(hwnd, CurObject);                   // show stuff on bottom
}



////////////////////////////////////////////////////////////////////
//																						//
//		INFO LINE WINDOW FLAG Left Button Down  Routine					//
//																						//
//			Handles   H E X E N   Flags  as  well now.					//
//																						//
//	handles LBDown for clicking Flag buttons for Line Attrib. 		//
//																						//
////////////////////////////////////////////////////////////////////
#pragma argsused
static void InfoLineFlagLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
   uint2		NewFlag;
   HDC 		hdc = GetDC(hwnd);
   RECT 		rc;

   CopyRect(&rc, &rcImpassable);

   SetTextType(hdc, 3);		// For Flagbutton

   SetupLineVal(CurObject);

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
		SoundBeep(SoundClick1);
      lineval[0] = !lineval[0];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[0], IDS_IMPASSABLE, &rc);
      else		DrawFlagButton(hdc, lineval[0], IDS_IMPASSABLE1, &rc);
   }

	rc.top += (ht2+1);
   rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
		SoundBeep(SoundClick1);
      lineval[2] = !lineval[2];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[2], IDS_2SIDED, &rc);
      else		DrawFlagButton(hdc, lineval[2], IDS_2SIDED1, &rc);
   }
  	rc.top += ht2+1;
  	rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
		SoundBeep(SoundClick1);
      lineval[6] = !lineval[6];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[6], IDS_BLOCKSOUND, &rc);
      else		DrawFlagButton(hdc, lineval[6], IDS_BLOCKSOUND1, &rc);
   }
  	rc.top += ht2+1;
  	rc.bottom = rc.top + ht2;

   if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
   {
		SoundBeep(SoundClick1);
      lineval[1] = !lineval[1];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[1], IDS_BLOCKENEMY, &rc);
      else		DrawFlagButton(hdc, lineval[1], IDS_BLOCKENEMY1, &rc);
  }
  rc.top += ht2+1;
  rc.bottom = rc.top + ht2;

  if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
  {
		SoundBeep(SoundClick1);
      lineval[5] = !lineval[5];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[5], IDS_SECRET, &rc);
      else		DrawFlagButton(hdc, lineval[5], IDS_SECRET1, &rc);
  }

  // Now, Second Row of Line Buttons over a little bit

  CopyRect(&rc, &rcImpassable);

  if(GameVersion == 4)
  {  rc.left  += 50;
     rc.right += 50;
  }
  else
  {  rc.left  += 84;
     rc.right += 84;
  }

  if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
  {
		SoundBeep(SoundClick1);
      lineval[3] = !lineval[3];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[3], IDS_UPPERUNPEG, &rc);
      else		DrawFlagButton(hdc, lineval[3], IDS_UPPERUNPEG1, &rc);
  }
  rc.top += (ht2+1);
  rc.bottom = rc.top + ht2;

  if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
  {
		SoundBeep(SoundClick1);
      lineval[4] = !lineval[4];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[4], IDS_LOWERUNPEG, &rc);
      else		DrawFlagButton(hdc, lineval[4], IDS_LOWERUNPEG1, &rc);
  }
  rc.top += ht2+1;
  rc.bottom = rc.top + ht2;

  if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
  {
		SoundBeep(SoundClick1);
      lineval[7] = !lineval[7];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[7], IDS_INVISIBLE, &rc);
      else		DrawFlagButton(hdc, lineval[7], IDS_INVISIBLE1, &rc);
  }
  rc.top += ht2+1;
  rc.bottom = rc.top + ht2;

  if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
  {
		SoundBeep(SoundClick1);
      lineval[8] = !lineval[8];   // toggle bit flag
		if(GameVersion == 4)
					DrawFlagButton(hdc, lineval[8], IDS_AUTOMAP, &rc);
      else		DrawFlagButton(hdc, lineval[8], IDS_AUTOMAP1, &rc);
  }

  if(GameVersion <= 2						// ONLY  BOOM has Use Works thru
  && BOOMSupport)
  {
	  rc.top   += ht2+1;
     rc.bottom = rc.top + ht2;

     if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
     {
	   	SoundBeep(SoundClick1);
         lineval[9] = !lineval[9];   // toggle bit flag
	      DrawFlagButton(hdc, lineval[9], IDS_USEWORKS, &rc);
     }
  }


  if(GameVersion == 4)						// ONLY  HEXEN  has repeat flag
  {
	  rc.top   += ht2+1;
     rc.bottom = rc.top + ht2;

     if( (x>rc.left) && (x<rc.right) && (y>rc.top)	&& (y<rc.bottom) )
     {
	   	SoundBeep(SoundClick1);
         lineval[9] = !lineval[9];   // toggle bit flag
	      DrawFlagButton(hdc, lineval[9], IDS_REPEAT, &rc);
     }
  }

  NewFlag = 0;
  NewFlag = SetNewLineVal(NewFlag);

  if (SelectList)
  {   SetLineDefFlags(NewFlag, SelectList);
  }
  else
  {   SelectObject ( &TempList, CurObject);
  	   SetLineDefFlags( NewFlag, TempList );
  	   ForgetSelection( &TempList);          // get rid of old list
  }

  ReleaseDC(hwnd, hdc);           //   5-1-97
}

////////////////////////////////////////////////////////////////////////////////
//                                                                             /
//		Mouse is moved from/to Client area                                       /
//		Mouse is moved from/over/to Child window                                 /
//		Mouse is moved over menu                                                 /
//		Mouse is moved from/to/over Non-Client areas                             /
//                                                                             /
//		ONLY implemented when MaxConstrain is TRUE -                             /
//		the mouse is constrained to our windows when                             /
//		the window is maximized - allows quick mouse                             /
//		scrolling without hindering windows - still                              /
//		allows the user to hold the shift key to bypass                          /
////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////
//
//		Mouse is over the ~ClientArea (Caption Bar?) and moved
//
//		Deep_On Non Client Mouse Move    'NCMouseMove'
//
//////////////////////////////////////////////////
#pragma argsused
void Deep_OnNCMouseMove(HWND hwnd, int x, int y, UINT codeHitTest)
{
 if(MaxConstrain)
 {
	//MoveCursor = TRUE;            //   11-11-96 why is this here?

	if(codeHitTest == HTCAPTION)		// Moving in the Caption Area
	{   										// Change cursor let user know can scroll
		gd.CaptionHit = TRUE;			// If mouse over Caption Area ~menu, ~client

      //   12-13-96 in conjunction with disable top code below
      //EnableCursor(hwnd, gd.hCursorMove); //   11-11-96 is this what was wanted?,
   }
	else							// In client area but not caption
   {
	  if(gd.CaptionHit)		// Was in Caption but out now BUT still in system area
	   {
	   	gd.CaptionHit = FALSE;
         gd.hCursorCurrent = gd.hCursorArrow;
   		EnableCursor(hwnd, (HCURSOR)LoadCursor(0, IDC_ARROW));  //back to arrow
    	}
   }
  }		// end if (MaxConstrain)
}

///////////////////////////////////////////////////////
//
//		Mouse is over the ~ClientArea (Caption Bar?) and released
//
///////////////////////////////////////////////////////
#pragma argsused
void Deep_OnNCLButtonUp(HWND hwnd, int x, int y, UINT codeHitTest)
{
/*
 if(MaxConstrain)
  {
	if(codeHitTest == HTCAPTION)
    if(ScrollingDown)
 		{
			MoveCursor = FALSE;
      }
   else
    gd.CaptionHit = FALSE;
  }
*/
}

////////////////////////////////////////////////////////////////////
//																						//
//		Non Client Left Button Down  Routine								//
//																						//
//	handles LBDown on top of screen ( Non-client area ), only 		//
// one reason to be there, to scroll the map . . .						//
//																						//
////////////////////////////////////////////////////////////////////
//   12-13-96 this routine is not called now, change this comment if glitches solved
/*
#pragma argsused
void NonClientLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
   HDC hdc, hMemDC;
   HBITMAP hMemBmp, hMemOldBmp;
   HPALETTE hOldPal;
   RECT    rc;

   // next is safety, since shouldn't get here in the 1st place ( )
   // doesn't really work well

	if(MaxConstrain						// If Maximized Caption Scrolling Allowed
   && Maximized)                    // and user wanted maximized    12-13-96
   {
		SetCapture(hwnd);					//	Have to or will never receive NCLButtonUp
   	EnableCursor(hwnd, gd.hCursorMove);
 		hdc = GetDC(hwnd);
   	GetClientRect(hwnd, &rc);
   	rc.bottom -= gd.StatusHeight;	// take into account our status bar

   	hMemDC 			= CreateCompatibleDC(hdc);
		hMemBmp 			= CreateCompatibleBitmap( hdc, rc.right, rc.bottom);
   	hMemOldBmp		= SelectBitmap(hMemDC, hMemBmp);
      // stuff below   11-3-96 get colors correct
      hOldPal  = SelectPalette(hMemDC, gd.hDoomPal, FALSE);     //  11-3-96
      ////RealizePalette(hMemDC);                                   //    ..

		MSG  loopMsg;										// Stop on LButtonUp
		loopMsg.message = 0;

		while (loopMsg.message != WM_LBUTTONUP)	//	While our left button is down
		 {
			 if (!PeekMessage(&loopMsg, 0, 0, 0, PM_REMOVE))continue;

			 //   11-10-96
          if (TranslateMessage(&loopMsg) )      // put a msg into queue if translated
          {   PeekMessage(&loopMsg, 0, 0, 0, PM_REMOVE);
          }
          CheckShiftKey(&loopMsg);

			 if (ScrollMapDown(hMemDC, &rc))
			 {   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
			     GdiFlush();
          }
          else
			 {   DispatchMessage(&loopMsg);  //   11-13-96 only if not scrolling
          }

       }
      //		End of While Scrolling = 1

    	ReleaseCapture();

   	SelectBitmap(hMemDC, hMemOldBmp);
      SelectPalette(hMemDC, hOldPal, FALSE);//  1-15-97 bk
		DeleteBitmap(hMemBmp);
   	DeleteDC(hMemDC);

      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(hdc, &gd.rcClient, TRUE, FALSE);
      ////SelectPalette(hdc, hOldPal, FALSE);               //   11-3-96
		ReleaseDC(hwnd, hdc);
      EnableCursor(hwnd, (HCURSOR)LoadCursor(0, IDC_ARROW));
    }
}
*/
//////////////////////////////////////////////////////////////////////////////
//
//		Mouse is over the Caption Bar and clicked ???
//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_OnNCLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT codeHitTest)
{
   //doesn't work well   12-13-96
   /*
	if (gd.CaptionHit
   && (codeHitTest == HTCAPTION)
   && MaxConstrain
   && Maximized)      //   12-13-96
   {
      NonClientLBDown(hwnd, x, y, codeHitTest); 	// Captures & Peeks() until
   } */

   // Need to forward this for system to handle menu, close button etc.

   FORWARD_WM_NCLBUTTONDOWN(hwnd, fDoubleClick, x, y, codeHitTest, Deep_DefProc);

}


//////////////////////////////////////////////////////////////////////////////
//							Handle  Map  X  scrolling	 and    Y UP					//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
void ScrollingLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
   HDC hdc, hMemDC;
   HBITMAP  hMemBmp, hMemOldBmp;
   RECT     rc;
   HPALETTE hOldPal;


//----------------------------------------------------------------------------

	SetCapture(hwnd);							// Capture so we receive LButtonUp Msg.
	hdc	     =  GetDC(hwnd);
   GetClientRect(hwnd, &rc);
   rc.bottom -= gd.StatusHeight;

  // Pointer is on the edge of our valid client area but NOT over a button or Pic
  MouseMove();

  if ((PointerX < ScrollMapBorder)
   || (PointerX > (gd.rcClient.right - ScrollMapBorder))
   || (PointerY < ScrollMapBorder)
   || (PointerY > (gd.rcClient.bottom - ScrollMapBorder)))
   {
		MSG  loopMsg;

		loopMsg.message = 0;
     	EnableCursor(hwnd, gd.hCursorMove);

		// Create a bitmap big enough to hold the window's image
   	hMemDC 			= CreateCompatibleDC(hdc);
		hMemBmp 			= CreateCompatibleBitmap( hdc, rc.right, rc.bottom);
   	hMemOldBmp		= SelectBitmap(hMemDC, hMemBmp);

      // stuff below   11-3-96 get colors correct
      hOldPal  = SelectPalette(hMemDC, gd.hDoomPal, FALSE);     //  11-3-96
      RealizePalette(hMemDC);                                   //    ..
  		//FillRect(hMemDC, &rc, (HBRUSH)gd.hBrushes[clearcolor]);   //  11-3-96

		// This loop will still post our WM_LBUTTONUP Message to our Message Queue
		// Because of the implementation this way allows the user to freely move
      // about the screen with the left button down; only scrolling when reaching
      // the boundary of the screen described below

		while (loopMsg.message != WM_LBUTTONUP)	//	While our left button is down
		{
		   if (PeekMessage(&loopMsg, 0, 0, 0, PM_REMOVE))
			{   //   11-10-96
             if (TranslateMessage(&loopMsg) )      // put a msg into queue if translated
             {   PeekMessage(&loopMsg, 0, 0, 0, PM_REMOVE);
             }
             CheckShiftKey(&loopMsg);
             MouseMove();
			    //DispatchMessage(&loopMsg); //   11-13-96 remove, don't bother if scrolling
			}

         if(PointerX < ScrollMapBorder) 							  // Left Hand Edge of Screen
		    {
				if ( ScrollMapRight(hMemDC,&rc) )			  // Scroll the map to the right
				{    BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
			  	     GdiFlush();	// Make sure it process's right away - TIME IT
            }
		    }
			else if(PointerX > (gd.rcClient.right - ScrollMapBorder))	// Far Right hand side of screen
			 {
				if (ScrollMapLeft(hMemDC, &rc))					// Scroll the map to the Left
				{   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
			  	    GdiFlush();
            }
			 }
			else if(PointerY > (gd.rcClient.bottom - ScrollMapBorder))
			 {
				if (ScrollMapUp(hMemDC,&rc))                // Scroll the map up
				{   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
			  	    GdiFlush();
            }
			 }
			else if(PointerY < ScrollMapBorder)
			 {
				if (ScrollMapDown(hMemDC, &rc))                // Scroll the map down
				{   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
			  	    GdiFlush();
            }
			 }
      }   //		End of While Scrolling = 1

   	SelectBitmap(hMemDC, hMemOldBmp);
		DeleteBitmap(hMemBmp);
   	DeleteDC(hMemDC);

		EnableCursor(hwnd, (HCURSOR)LoadCursor(0, IDC_ARROW));
		MoveCursor = FALSE;

      //if(!gd.ShiftDown)   ResetMapResident(hwnd, FALSE, TRUE, FALSE); // Reset all objects
      //        hdc , RECT    , Erase Bk, Palette in
      RedrawMap(hdc, &gd.rcClient, ERASEYES, FALSE);

   }										// 	End of Else If within scrolling boundary
   SelectPalette(hdc, hOldPal, FALSE);       //   11-3-96
	ReleaseDC(hwnd, hdc);			//		Release our DC - standard procedure
	ReleaseCapture();

}



////////////////////////////////////////////////////////////////////////////////
//																										//
//		Scroll Map Left, Right, Up, Down Routines for Scrolling our Map			//
//																										//
//		Given a Handle to a device context will move the map the specified		//
//		amount the correct direction.  Background should be erased before 		//
//		Calling, if so desired.																	//
//																										//
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
bool ScrollMapRight(HDC hdc, RECT  *rc)    //  11-3-96
{

  if ( MAPX (ScrMaxX-48) <= LevelWad.level.minX)  return false;  //   11-3-96

  OrigX -= (ScrollSpeed * 2 / Scale);
  DrawBigMap(PARTIALYES, hdc,TRUE);    // Scroll Map
  return true;
}

//========================================
#pragma argsused
bool ScrollMapLeft(HDC hdc, RECT  *rc)    //  11-3-96
{

  if ( MAPX (48 ) >= LevelWad.level.maxX)  return false;         //   11-3-96

  OrigX += (ScrollSpeed * 2 / Scale);
  DrawBigMap(PARTIALYES, hdc,TRUE);	          	  //Scroll Map
  return true;
}

//======================================
#pragma argsused
bool ScrollMapUp(HDC hdc, RECT  *rc)    //  11-3-96
{

  if ( MAPY (64 ) <= LevelWad.level.minY)  return false;  //  at minimum

  OrigY -= (ScrollSpeed * 2 / Scale);
  DrawBigMap(PARTIALYES, hdc,TRUE);		//Scroll Map
  return true;
}
//========================================
#pragma argsused
bool ScrollMapDown(HDC hdc, RECT  *rc)    //  11-3-96
{

  if ( MAPY (ScrMaxY-64) >= LevelWad.level.maxY) return false;// at minimum

  OrigY += (ScrollSpeed * 2 / Scale);
  DrawBigMap(PARTIALYES, hdc,TRUE);		//Scroll Map
  return true;
}

////////////////////////////////////////////////////////////////////
//																						//
//	 Info Window LINE HotBox routines for quick access to :        //
//																						//
//LineType, LineTag, LineSideDef 1 & 2 / ADD, LineOffset, Line Arg//
//													                           //
////////////////////////////////////////////////////////////////////

#pragma argsused
void CallSideDefDlg(HWND hwnd, UINT keyFlags, int2 side, int2 postmsg, Bool frominfo)// 0/1
{
 DLGSELECT DlgSel;								// our Selectlist struct for passing info
// MSG msg;
 ZeroMemory(&DlgSel, sizeof(DlgSel));
 int2 test;

// msg.message = 0;

 if(frominfo)                                   // from bottom hot area
 {
    ReleaseMouseButton(hwnd);
 }

 if (side == 0)  test = LineSD1Ys;
 else            test = LineSD2Ys;

 if (test == 0)      // hack, means adding side1
 {   HDC hdc = GetDC(hwnd);

     HFONT hOldFont = SelectFont(hdc, gd.hLargeFont);
     HPALETTE hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);
     RealizePalette(hdc);
     SoundBeep(SoundClick1);

     if(side == 0)  Side1Button(hdc, UP);
     else           Side2Button(hdc, UP);

     SelectFont(hdc, hOldFont);
     SelectPalette(hdc, hOldPal, FALSE);
     ReleaseDC(hwnd, hdc);

 }

 BrowseMode = TEXTURES;
 gd.hParent = hwnd;

 DlgSel.b1  = side;	 // SideDef 1
 DlgSel.b2  = FALSE;  // advance command

 if (SelectList)
 {   DlgSel.sel = SelectList;
 }
 else
 {
    if(CurObject < 0 ) return;

    SelectObject ( &TempList, CurObject);
    DlgSel.sel = TempList;
 }

 // simulate button pushed

 if(postmsg)
 {
    DlgSel.b2   = TRUE;         // pretend it is from a button
    DlgSel.post = postmsg;
 }

 Browsing   = TRUE;            //   12-18-96 moved here

 DialogBoxParam(gd.hInst,"EditSideDef", hwnd,EditSideDefDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);

 DlgSel.sel = NULL;   //  MAKE SURE !

 if(!SelectList)  ForgetSelection( &TempList);    // get rid of old list

 if (FixVideo)
 {   RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  //  3-1-97 fix driver probs
 }
 else
 {   UpdateObjectInfo(hwnd, CurObject);                   // show stuff on bottom
 }
 Browsing = FALSE;
 SetCursorPos(pOldCurPos.x, pOldCurPos.y);// + gd.CaptionHeight);
}

//////////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
void CallLineDefDlg(HWND hwnd, int x, int y, UINT keyFlags, int2 postmsg)
{
 DLGSELECT DlgSel;								// our Selectlist struct for passing info
 ZeroMemory(&DlgSel, sizeof(DlgSel));


 ReleaseMouseButton(hwnd);

 BrowseMode = TEXTURES;
 gd.hParent = hwnd;

 if(SelectList != NULL)   DlgSel.sel = SelectList;
 else
  { DlgSel.sel = NULL;
    if(CurObject < 0)   return;
  }

 DlgSel.obj = CurObject;
 DlgSel.b2  = TRUE;            // advance command
 DlgSel.post = postmsg;        // message to post to the dialog

 Browsing = TRUE;              //   12-18-96 moved here

 DialogBoxParam(gd.hInst,"EditLineDef",hwnd,EditLineDefDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);

 DlgSel.sel = NULL;   //  MAKE SURE !

 if (FixVideo)
 {   RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  //  3-1-97 fix driver probs
 }
 else
 {   UpdateObjectInfo(hwnd, CurObject);                   // show stuff on bottom
 }

 Browsing = FALSE;
}

/////////////////////////////////////////////////////////////////////////////
void InfoLineTypeLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallLineDefDlg(hwnd, x, y, keyFlags, psh2);
}
/////////////////////////////////////////////////////////////////////////////
void InfoLineTagLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallLineDefDlg(hwnd, x, y, keyFlags, psh9);
}
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoLineSector1LBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallSideDefDlg(hwnd, keyFlags, 0, FALSE, TRUE);// sidedef 1, no postings, frominfo
}
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoLineSector2LBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallSideDefDlg(hwnd, keyFlags, 1, FALSE, TRUE);// sidedef 2
}
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoLineSD1LBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallSideDefDlg(hwnd, keyFlags, 0, psh4, TRUE);// Sector Ref # 1
}
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoLineSD2LBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallSideDefDlg(hwnd, keyFlags, 1, psh4, TRUE);// Sector Ref # 2
}
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoLineOffset1LBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallSideDefDlg(hwnd, keyFlags, 0, psh5, TRUE);// Offset Dlg # 1
}
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoLineOffset2LBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallSideDefDlg(hwnd, keyFlags, 1, psh5, TRUE);// Offset Dlg # 1
}
/////////////////////////////////////////////////////////////////////////////
void InfoLineArgLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{    CallLineDefDlg(hwnd, x, y, keyFlags, psh9);// ONLY HEXEN ARGS, same as Tag
}

/////////////////////////////////////////////////////////////////////////////
//    12-15-96
//  Edit just the texture for a sidedef, from bottom click
//  (basically same as stuff in Dialogs, put there eventually?
//    3-1-97 forgot brad changes 12-25-96
/////////////////////////////////////////////////////////////////////////////

void CallSideDefTextureDlg(HWND hwnd, int2 side, int2 postmsg)// 0/1
{

 int2   s1,s2,sd,sd1,sd2;       // sector, & sidedef's

 LevelPtr level = &LevelWad.level;

 char   ShowTexName1[9]="-";
 char   ShowTexName2[9]="-";
 char   ShowTexName3[9]="-";

 SelPtr objlist;    // 12-25-96 bk
 SelPtr sdlist = NULL;
 SelPtr cur    = NULL;

//==============================================================================
// msg.message = 0;

 ReleaseMouseButton(hwnd);

 BrowseMode = TEXTURES;

 if(CurObject < 0 ) return;

 Browsing   = TRUE;

 // set current sidedefs including those created above to Entry value

 sd1 = level->LineDefs[ CurObject].sidedef1;
 sd2 = level->LineDefs[ CurObject].sidedef2;

 if(side == 1) sd = sd2;        // Had to add since if -1, and had
 else          sd = sd1;        // to add side, sd was not initialized

 // set sectors active
 if (sd1 >= 0) s1 = level->SideDefs[ sd1].sector;
 else          s1 = -1;

 if (sd2 >= 0) s2 = level->SideDefs[ sd2].sector;
 else          s2 = -1;

 if (sd < 0 || sd >= level->NumSideDefs) return; // they should be able to tell

 // For ease of saving Select the CurObject into cur if NO SelectList
 if(SelectList == NULL)   SelectObject(&cur, CurObject);// Select 1 Line
 else                     cur = SelectList;             // Multiple Lines

 // Build our SideDef SelectList depending on which side

 if(side == 0)
 {  for (objlist=cur; objlist;  objlist=objlist->next)
    {   if (level->LineDefs[ objlist->objnum].sidedef1 >= 0)
        {   SelectObject( &sdlist, level->LineDefs[ objlist->objnum].sidedef1);
        }
    }
 }
 else
 {  for (objlist=cur; objlist;  objlist=objlist->next)
    {   if (level->LineDefs[ objlist->objnum].sidedef2 >= 0)
        {   SelectObject( &sdlist, level->LineDefs[ objlist->objnum].sidedef2);
        }
    }
 }

 // this is either sd1 or sd2

 strncpy( ShowTexName1, level->SideDefs[ sd].tex1, 8); // upper
 strncpy( ShowTexName2, level->SideDefs[ sd].tex2, 8); // lower
 strncpy( ShowTexName3, level->SideDefs[ sd].tex3, 8); // normal

 // SideDef1 --------------

 if (side == 0)
 {   // one-sided linedef
     if (s1 >= 0 && s2 < 0)
     {
         if (level->SideDefs[ sd1].tex3[ 0] == '-')
         {   strcpy (ShowTexName3,"missing");            // normal missing
         }
     }
     // side one exists always ---------------
     // see if 2 textures diff height => texture should exist
	  //  ceiling 1 > ceiling 2,           no side1 upper

	  if (s1 >= 0     // sector 1
     &&  s2 >= 0     // sector 2
     && level->Sectors[ s1].ceilh > level->Sectors[ s2].ceilh
	  && ShowTexName1[ 0] == '-'                               // side1 upper
	  && ( strncmp (level->Sectors[s1].ceilt,SkyTexture, 5)    // not sky1 see through
	  ||   strncmp (level->Sectors[s2].ceilt,SkyTexture, 5) ))
 	  {
	       strcpy(ShowTexName1,"missing");               // upper missing
     }

	  // two-sided floor1 < floor 2

	  if (s1 >= 0 && s2 >= 0
	  &&  level->Sectors[ s1].floorh < level->Sectors[ s2].floorh
	  &&  ShowTexName2[ 0] == '-')
	  {
         strcpy(ShowTexName2,"missing");   // lower missing
	  }
 }
 else
 // SideDef 2 exists
 if (sd2 >= 0)
 {
     // two-sided ceiling 1 < ceiling 2     2nd upper missing

	  if (s1 >= 0 && s2 >= 0
	  && level->Sectors[ s1].ceilh < level->Sectors[ s2].ceilh
	  && ShowTexName1[ 0] == '-'               // side 2 upper
	  && (strncmp(level->Sectors[ s1].ceilt,SkyTexture, 5)   // not see through
	  ||  strncmp(level->Sectors[ s2].ceilt,SkyTexture, 5)))
	  {
	      strcpy(ShowTexName1,"missing");   // upper missing
	  }
     // two sided floor 1 > floor 2          2nd lower missing

	  if (s1 >= 0 && s2 >= 0
	  && level->Sectors[ s1].floorh > level->Sectors[ s2].floorh
	  && ShowTexName2[ 0] == '-')
	  {
        strcpy(ShowTexName2,"missing");   // lower missing
	  }
  }

  // see which one of the textures

  switch (postmsg)
  {
    case psh1:// Upper Texture
	  	 if (GetNewTextureName(hwnd, ShowTexName1, "New UPPER Texture"))
       {
	        if (strlen(ShowTexName1) > 0)
           {
               for (objlist = sdlist; objlist; objlist = objlist->next)
               {  if (objlist->objnum >= 0)
		            {
		              if(strncmp( level->SideDefs[ objlist->objnum].tex1, ShowTexName1, 8))  //   3-1-97
		              {   strncpy( level->SideDefs[ objlist->objnum].tex1, ShowTexName1, 8);
	                     level->MadeChanges++;
                    }
                  }
               }

           }
	    }
       break;

    case psh2:// Normal Texture
	  	 if (GetNewTextureName(hwnd, ShowTexName3, "New NORMAL Texture"))
       {
	        if (strlen(ShowTexName3) > 0)
	        {
               for (objlist = sdlist; objlist; objlist = objlist->next)
               {  if (objlist->objnum >= 0)
		            {
		              if(strncmp( level->SideDefs[ objlist->objnum].tex3, ShowTexName3, 8))  //   3-1-97
		              {   strncpy( level->SideDefs[ objlist->objnum].tex3, ShowTexName3, 8);
	                     level->MadeChanges++;
                    }
                  }
               }
	        }
       }
       break;

 	case psh3:// Lower Texture
	    if (GetNewTextureName(hwnd, ShowTexName2, "New LOWER Texture"))
       {
	        if (strlen(ShowTexName2) > 0)
           {
               for (objlist = sdlist; objlist; objlist = objlist->next)
               {  if (objlist->objnum >= 0)
		            {
		              if(strncmp( level->SideDefs[ objlist->objnum].tex2, ShowTexName2, 8))  //   3-1-97
		              {   strncpy( level->SideDefs[ objlist->objnum].tex2, ShowTexName2, 8);
	                     level->MadeChanges++;
                    }
                  }
               }
           }
	    }
       break;
 }

 ForgetSelection(&sdlist);                         // Forget sides
 if(SelectList == NULL)  ForgetSelection(&cur);    // no Prev. selection

 Browsing = FALSE;
}



////////////////////////////////////////////////////////////////////
//																						//
//		Info Window Line Picture Chosen - browse for new Txtr.      //
//																						//
//    User clicked inside one of the textures SD1, U,N,L	 			//
//													 SD2 - Upper,Normal,Lower  //
////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoLinePicLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
  GetCursorPos(&pOldCurPos);

  if(x < LineboxX1s + 65)                // Must be Wall Upper
    CallSideDefTextureDlg(hwnd, 0, psh1);
  else if(x < LineboxX1s + 65 + 65)      // Must be Wall Normal
    CallSideDefTextureDlg(hwnd, 0, psh2);
  else if(x < LineboxX1s + 65 + 65 + 65) // Must be Wall Lower
    CallSideDefTextureDlg(hwnd, 0, psh3);
  else if(x < LineboxX2s + 65)           // Must be Wall Upper
    CallSideDefTextureDlg(hwnd, 1, psh1);
  else if(x < LineboxX2s + 65 + 65)      // Must be Wall Normal
    CallSideDefTextureDlg(hwnd, 1, psh2);
  else if(x < LineboxX2s + 65 + 65 + 65) // Must be Wall Lower
    CallSideDefTextureDlg(hwnd, 1, psh3);

 // 12-12-96 bk  -want to check and see if pics changed before update ?

 if (FixVideo)
 {   RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  //  3-1-97 fix driver probs
 }
 else
 {  UpdateObjectInfo(hwnd, CurObject);
 }

  SetCursorPos(pOldCurPos.x, pOldCurPos.y);
}


////////////////////////////////////////////////////////////////////
//																						//
//	 Info Window Sector Picture Chosen - browse for new Floor/Ceil //
//																						//
//    User clicked inside Floor Pic, or Ceiling Pic   	 			//
//													                           //
////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoSectorPicLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
 LevelPtr level = &LevelWad.level;

 pOldCurPos.x = x;  // save position so WM_BROWSE_BACK will know    ..needed??????? revise not actual coords
 pOldCurPos.y = y;  // if floor or ceiling texture clicked on

 BrowseMode = FLOORS;
 gd.hParent = hwnd;
 Browsing = TRUE;

 // Check if Floor or Ceiling Texture Clicked on
 if(x > SecboxX1e)  FloorBrowse(level->Sectors[CurObject].floort);
 else               FloorBrowse(level->Sectors[CurObject].ceilt);

 Browsing = FALSE;  // make sure it's reset   12-18-96
 // return at WM_BROWSE_BACK in menu.cpp
}

/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void InfoSectFlagLBDown(HWND hwnd, int x, int y, UINT keyFlags)// ALL Sector flags
{
 DLGSELECT DlgSel;								// our Selectlist struct for passing info
 int2 sectorcmd, Yvalue;

 ZeroMemory(&DlgSel, sizeof(DlgSel));

 ReleaseMouseButton(hwnd);

 BrowseMode = FLOORS;
 gd.hParent = hwnd;

 Yvalue = int2((y - SectorFlagYs) / SectorFlagYlen);
 //Trace(0,0," xval %hd  yval %hd",Xvalue,Yvalue);
 switch(Yvalue)
  {
		default:
		  return;
		case (0):
		case (1):
		  sectorcmd = psh5;        // heights both
		  break;
		case (2):
		  sectorcmd = psh2;        // ceiling tex
		  break;
		case (3):
		  sectorcmd = psh3;        // floor tex
		  break;
		case (4):
		  sectorcmd = psh4;        // light level
		  break;
		case (5):
		  sectorcmd = psh8;        // tag
		  break;
  }

  if (SelectList != NULL)
  {   DlgSel.sel = SelectList;
      DlgSel.obj = -1;
  }
  else
  {   if(CurObject < 0 )      return;
      DlgSel.sel = NULL;
      DlgSel.obj = CurObject;
  }


 DlgSel.b2  = TRUE;            // advance command
 DlgSel.post = sectorcmd;      // message to post to the dialog

 Browsing = TRUE;              //   12-18-96 moved here

 DialogBoxParam(gd.hInst,"EditSector",hwnd, EditSectorDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);

 DlgSel.sel = NULL;   //  MAKE SURE !

 UpdateObjectInfo(hwnd, CurObject);                   // show stuff on bottom

 Browsing = FALSE;

}

/////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////

#pragma argsused
void InfoSectTypeLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
 DLGSELECT DlgSel;								// our Selectlist struct for passing info

 ZeroMemory(&DlgSel, sizeof(DlgSel));

 ReleaseMouseButton(hwnd);

 BrowseMode = FLOORS;
 gd.hParent = hwnd;

 if (SelectList != NULL)
 {   DlgSel.sel = SelectList;
     DlgSel.obj = -1;
 }
 else
 {   if(CurObject < 0 )      return;
     DlgSel.sel = NULL;
     DlgSel.obj = CurObject;
 }

 DlgSel.b2  = TRUE;         // advance command
 DlgSel.post = psh1;        // message to post to the dialog

 Browsing = TRUE;              //   12-18-96 moved here

 DialogBoxParam(gd.hInst,"EditSector",hwnd, EditSectorDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);

 DlgSel.sel = NULL;         //  MAKE SURE !

 UpdateObjectInfo(hwnd, CurObject);                   // show stuff on bottom

 Browsing = FALSE;
}
////////////////////////////////////////////////////////////////////
//																						//
//	 Info Window Thing Picture Chosen - browse for a new Thing     //
//																						//
//    User clicked inside Thing Picture on bottom     	 			//
//													                           //
////////////////////////////////////////////////////////////////////
//   12-18-96 no cursor restore required, thingdlg saves/restores

#pragma argsused
void InfoThingPicLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{
  DLGSELECT DlgSel;	 //our Selectlist struct for passing info for DefaultThing

  //pOldCurPos.x = x;  // save position so WM_BROWSE_BACK will know
  //pOldCurPos.y = y;  // if floor or ceiling texture clicked on

  gd.hParent = hwnd;
  BrowseMode = SPRITES;  // MAKE SURE !
  //AllSprites = FALSE;		// just the unique ones for now - ALL from Menu

  ZeroMemory(&DlgSel, sizeof(DlgSel));

  DlgSel.b2  = TRUE;                             // Advance command
  DlgSel.post = IDD_CHANGETYPE;

  Browsing = TRUE;              //   12-18-96 moved here

  DialogBoxParam(gd.hInst,"ThingEdit",hwnd, EditThingDlgProc,(LPARAM)(LPDLGSELECT)&DlgSel);

  //if (SelectList)         tname = GetThingPicName( level->Things[SelectList->objnum].type);
  //else if(CurObject >= 0) tname = GetThingPicName( level->Things[CurObject].type);
  //if(tname)
  // SpriteBrowse(tname);    // returns name in SpriteName either old or new
                            // Program control continues in Menu.cpp under
                            // WM_BROWSE_BACK
  Browsing = FALSE;           //   12-18-96 was missing
}

// In edit with DisplayObjectInfo

void InfoShowThingPic(HWND hwnd); // shows highlighted Thing Picture
void InfoShowType(HWND hwnd); // shows different colored text highlight

/////////////////////////////////////////////////////
//
//	Handles Info Windows Mouse Movement; highlighting
// available hot spots as the mouse passes over !
//
//////////////////////////////////////////////////////

#pragma argsused
static void InfoMouseMove(HWND hwnd, int x, int y, UINT keyFlags)
{
     switch(EditMode)
     {

       case OBJ_THINGS:
          if (   (x > ThingboxXs)
              && (x < ThingboxXe)
              && (y > (gd.rcClient.bottom - (ThingboxYe - ThingboxYs) )) )
  	        { if(!Thing1)
              { UpdateObjectInfo(hwnd, CurObject);
                InfoShowThingPic(hwnd); // shows highlighted Thing Picture
                Thing1= TRUE;
                Thing2 = FALSE;
              }
  	        }
          else if (y > ThingTypeYs
               &&  y < ThingTypeYe
               &&  x > ThingTypeXs
               &&  x < ThingTypeXe)
  		     { if(!Thing2)
              {  UpdateObjectInfo(hwnd, CurObject);
                 InfoShowType(hwnd); // shows different colored text highlight
                  Thing2 = TRUE;
                  Thing1= FALSE;
              }
  		     }
          break;

       case OBJ_SECTORS:
         break;

       case OBJ_LINEDEFS:
         break;
     }
}

//////////////////////////////////////////////////////////////////////////////
//
//	Handles Mouse Movements, Displays x & y
// and changes the cursor depending on the mode
//
///////////////////////////////////////////////////////////////////////////////

#pragma argsused
static void InfoLBDown(HWND hwnd, int x, int y, UINT keyFlags)
{

 switch(EditMode)
 {
   case OBJ_THINGS:
     if (   (x > ThingboxXs)
         && (x < ThingboxXe)
         && (y > (gd.rcClient.bottom - (ThingboxYe - ThingboxYs) )) )
  	  {
         InfoThingPicLBDown(hwnd, x, y, keyFlags);
  	  }
     else 					//       Not Pic, must be flag, type or Args
     {
       if (y > ThingTypeYs
       &&  y < ThingTypeYe
       &&  x > ThingTypeXs
       &&  x < ThingTypeXe)
  		 {
            InfoThingTypeLBDown(hwnd, x, y, keyFlags);
  		 }

       if(GameVersion==4) //		  	HEXEN  THING   STUFF
       {
         if ( (x > rcEasy.left)
           && (x < (((rcEasy.right - rcEasy.left)*2) + rcEasy.left))
    	     && (y > rcEasy.top) )
  	      {
            InfoThingHXFlagLBDown(hwnd, x, y, keyFlags);
  		   }
         else
         if (y > ThingArgYs
         &&  y < ThingArgYe
         &&  x > ThingArgXs
         &&  x < ThingArgXe)
  		   {
            InfoThingArgsLBDown(hwnd, x, y, keyFlags);
  		    }
       }
       else					// 		DOOM  FLAGS  CHOSEN
       {
         if (GameVersion <=2
         &&  BOOMSupport)
         {
            if ( (x > rcEasy.left)
              && (x < (((rcEasy.right - rcEasy.left)*2) + rcEasy.left))
      	     && (y > rcEasy.top ) )
            {   InfoThingBOOMFlagLBDown(hwnd, x, y, keyFlags);
            }
         }
         else
         {
            if ( (x > rcEasy.left)
              && (x < rcEasy.right)
      	     && (y > rcEasy.top ) )
  		      {
               InfoThingFlagLBDown(hwnd, x, y, keyFlags);
            }
  		   }
       }

     } // END Else ~ Thing Box Pic
     break;

   case OBJ_SECTORS:
     if ( (x > SecboxX1s)
       && (x < SecboxX2e)
       && (y > gd.rcClient.bottom - (SecboxY1e - SecboxY1s) ) )
     {
          InfoSectorPicLBDown(hwnd, x, y, keyFlags); // continues at WM_BROWSE_BACK in menu.cpp
     }
     else if (  (x > SectorFlagXs)
          && (x < SectorFlagXe)
          && (y > SectorFlagYs)
          && (y < SectorFlagYe) )
     {
          InfoSectFlagLBDown(hwnd, x, y, keyFlags);// ALL Sector flags
     }
     else if (  (x > SectorTypeXs)
          && (x < SectorTypeXe)
          && (y > SectorTypeYs)
          && (y < SectorTypeYe) )
     {
          InfoSectTypeLBDown(hwnd, x, y, keyFlags);  // ALL Sector flags
     }
     break;

 case OBJ_LINEDEFS:
    if ( (x > rcImpassable.left)
      && (x < (((rcImpassable.right - rcImpassable.left)*2) + rcImpassable.left))
      && (y > rcImpassable.top)
      && (y < (((rcImpassable.bottom - rcImpassable.top)*5) + rcImpassable.top )) )
  	  {
          InfoLineFlagLBDown(hwnd, x, y, keyFlags);
  	  }    // User choosing a SideDef txtr to Edit Upper,Normal,Lower

     else
     if ( (x > LineboxX1s)
       && (x < LineboxX2e)
       && (y > LineboxY1s) && (y < LineboxY1e)  )
     {
          InfoLinePicLBDown(hwnd, x, y, keyFlags);
     }
     else
     if ( (x > LineTypeXs)
       && (x < LineTypeXe)
       && (y > LineTypeYs)
       && (y < LineTypeYe)  )
     {
          InfoLineTypeLBDown(hwnd, x, y, keyFlags);   // Line Type
     }
     else
     if ( (x > LineTagXs)
       && (x < LineTagXe)
       && (y > LineTagYs)
       && (y < LineTagYe)  )
     {
          InfoLineTagLBDown(hwnd, x, y, keyFlags);    // Line Tag
     }
     else
     if ( (x > LineSector1Xs)
       && (x < LineSector1Xe)
       && (y > LineSector1Ys)
       && (y < LineSector1Ye)  )
     {
          InfoLineSector1LBDown(hwnd, x, y, keyFlags);//Edit SideDef 1
     }
     else
     if ( (x > LineSector2Xs)
       && (x < LineSector2Xe)
       && (y > LineSector2Ys)
       && (y < LineSector2Ye)  )
     {
          InfoLineSector2LBDown(hwnd, x, y, keyFlags);//Edit SideDef 2
     }
     else
     if ( (x > LineSD1Xs)
       && (x < LineSD1Xe)
       && (y > LineSD1Ys)
       && (y < LineSD1Ye)  )
     {
          InfoLineSD1LBDown(hwnd, x, y, keyFlags);    //Edit SideDef Ref
     }
     else
     if ( (x > LineSD2Xs)
       && (x < LineSD2Xe)
       && (y > LineSD2Ys)
       && (y < LineSD2Ye)  )
     {
          InfoLineSD2LBDown(hwnd, x, y, keyFlags);    //Edit SideDef Ref
     }
     else
     if ( (x > LineOffset1Xs)
       && (x < LineOffset1Xe)
       && (y > LineOffset1Ys)
       && (y < LineOffset1Ye)  )
     {
          InfoLineOffset1LBDown(hwnd, x, y, keyFlags);//Edit SideDef1 offset
     }
     else
     if ( (x > LineOffset2Xs)
       && (x < LineOffset2Xe)
       && (y > LineOffset2Ys)
       && (y < LineOffset2Ye)  )
     {
          InfoLineOffset2LBDown(hwnd, x, y, keyFlags);//Edit SideDef2 offset
     }
     else
     if (GameVersion == 4)// Same as Tag
     {
         if ( (x > LineArgXs)
           && (x < LineArgXe)
           && (y > LineArgYs)
           && (y < LineArgYe)  )
         {
           InfoLineArgLBDown(hwnd, x, y, keyFlags);//Edit HEXEN Line Args
         }
     }
     break;

  default:
    break;

 }// END switch(EditMode)

}

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  This is the Main Left Button Down Handler                                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
  Bool  mclick;

  CheckKeyState();

  GetCursorPos(&pOldCurPos);

 //  Trace(NULL,10,4,"xy=%d,%d Infoxy=%d,%d",x,y,InfoboxXe,InfoboxYe);
 // if(Selecting == TRUE)  return;

 // boundary scrolling      //  11-11-96 put first, keep margin small users!

 if ((x < ScrollMapBorder)
  || (x > (gd.rcClient.right  - ScrollMapBorder))
  || (y < ScrollMapBorder)
  || (y > (gd.rcClient.bottom - ScrollMapBorder)) )
  {
      ScrollingLBDown(hwnd, x, y, keyFlags);
  }
 else
 // see if in info box area, but only if info boxes active
 if (InfoShown              //  11-5-96
 && x >= InfoboxXs          //  11-5-96
 && x <  InfoboxXe
 && y >  InfoboxYs
 && y <  InfoboxYe)
  {
      InfoLBDown(hwnd, x, y, keyFlags);
  }
 else // boundary scrolling was here
 {
      if (!fDoubleClick)
      {
          SetCapture(hwnd);		         // Have to or might never receive LButtonUp
          mclick = WaitForLeft(hwnd);
          ReleaseCapture();

          if (mclick == 1                 //   3-1-97 left button released
          &&  !AutoSelect)                //   3-1-97 if no autoselect get it
          {   AutoSelect=TRUE;
              Deep_OnMouseMove(hwnd, x, y, keyFlags);   // select any object
              AutoSelect=FALSE;
          }
      }
      else
      {   mclick = 2;                     // already double clicked by windows
      }

      // start :   11-5-96 modified to match current DeeP code

      if(mclick == 0 )                       // left button is still held down
      {  // shift + left button = zoom mode
         if (gd.ShiftDown)
         {   ZoomMap(hwnd,1);
         }
         else
         // ctrl + left button = pan mode
         if (gd.CtrlDown )
         {   DragMap(hwnd, 1);
         }
         else
         // long time down is just stretch start
         {   Selecting = TRUE;
             StretchTool(hwnd, x, y, keyFlags);  // StartSelectBox
             Selecting = FALSE;
         }
      }
      else
      if (mclick == -1)                     // right button too   3-1-97
      {
          DragMap(hwnd, 3);                  // mouse button = 3
      }
      else
      if(mclick == 1 )                       // left button was released
  	   {  MarkObject(hwnd);                   // mark the object
      }
      else
      if(mclick == 2 )                  // left button DblClicked
      {  // shift key is now ignored, too confusing, plus free's up panning
         if(!gd.ShiftDown)
         {
		     if ( (EditMode == OBJ_VERTEXES && SelectCount <= 2)
           ||   (EditMode == OBJ_THINGS ) )
           {    Insert(hwnd, CurObject, 0);   // mode 0 = normal
           }
           else
           if ( EditMode == OBJ_VERTEXES)
           {   Insert(hwnd, CurObject, 1);   // 1= split linedef
           }
         }
      }
      // 11-11-96 is this reqd???????????????? see to work ok without
      // else //   11-5-96
      // {  FORWARD_WM_LBUTTONDOWN(hwnd, fDoubleClick, x, y, keyFlags, Deep_DefProc); //   11-5-96
      // }
      // end :  11-5-96 modified to match current DeeP code
  }
}


///////////////////////////////////////////////////////////////////////////////
// WM_RBUTTONDOWN  -  check click right and dbl click right
///////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Deep_OnRButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
   Bool mclick;
   LevelPtr level = &LevelWad.level;

   CheckKeyState();

   GetCursorPos(&pOldCurPos);

// Trace(hwnd,10,4,"Rbutton, popup %hd, dclick%d shift%d,ctrl%d",PopupMenu,fDoubleClick,gd.ShiftDown, gd.CtrlDown );
// if(ZoomOrDrag == TRUE)  return;        // if we need this??

   if (!fDoubleClick)
   {
       SetCapture(hwnd);				 // Have to or might never receive RButtonUp
       mclick = WaitForRight(hwnd);
       ReleaseCapture();
       //Trace(hwnd,10,4,"Rbutton, popup %hd, dclick%d mclick%hd shift%d,ctrl%d",PopupMenu,fDoubleClick,mclick,gd.ShiftDown, gd.CtrlDown );
   }
   else
   {   mclick = 2;
   }

   if(!PopupMenu)                    // Make sure not DblClk and RClick out
   {
      if(mclick == 0 )               // Right button is still held down
      {  // shift + right button = zoom mode   11-5-96
         if (gd.ShiftDown)
         {   ZoomMap(hwnd,2);
         }
         else
         {   DragTool(hwnd, level);      // PointerX and Y must be set
         }
      }
      else
      if(mclick == 1 )
      {  HandleRBUp(hwnd, x, y, keyFlags);// RBtn released- process edit EditSector/EditLineDef/ etc dialogs
      }
      else
      if(mclick == 2 )                   //HandleModeMenu(hwnd, x, y); // RBtn DblClicked bdk 12-12-96 keep menu up
      {  EatMouseData(hwnd);             // 12-12-96
         Sleep(50);                      // 12-12-96
         HandleModeMenu(hwnd, x, y);     // RBtn DblClicked
      }

      //   11-11-96 forward stuff causes problems, like loosing shift state???
      // else FORWARD_WM_RBUTTONDOWN(hwnd, fDoubleClick, x, y, keyFlags, Deep_DefProc);//  11-5-96
   }

   // 11-11-96 forward stuff causes problems with shift state
   //else  //   11-5-96   ?? should only execute if not above???
   //{
   //   FORWARD_WM_RBUTTONDOWN(hwnd, fDoubleClick, x, y, keyFlags, Deep_DefProc);
   //}
}
//--------------------------- end ---------------------------------------------
