///////////////////////////////////////////////////////////////////////////////
//		NewGraph.cpp  - New Graphics
//
//		MapBrowser,SpriteBrowser,TextureBrowser etc.
//
//		Mostly stuff from TEXTURES.C
///////////////////////////////////////////////////////////////////////////////

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "deep.h"
#include "windeep.h"
#pragma hdrstop

#include <dlgs.h>					// header for control defines
#include <math.h>

#define SHOWSIZE 0x7fff       // to display picture x y size

// 1-1-97 bk
// :
// in dialog.cpp for updating static text on dialogs
extern char LViewMsg[128];    // Dialog Update Text from DisplayTex's

  int4   TextureBrowsing = 1;   // which browse texture=1 or pnames=2 (checked in TEXTEDIT)

  int4   GettingTexture = FALSE; // prevent double entry checked in editdlg sidedef & floor

//   FROM DRAWING.C
//--these all need to be global for drawing to work-----------------------------
//   put all together in one spot here, rather than split
   int2  DisplayMagnify;     // actually used in display
   int4  ImageXSize;         // X not 32 bit aligned
   int4  ImageYSize;

   int4  OrgXstart;          // Drawing box limits
   int4  OrgYstart;          //
   int4  OrgXend  ;          //
   int4  OrgYend  ;          //

// last picture displayed, so clear works ok

   int4  LastPicXloc;        // made 4   6-1-97 (goal is most stuff 4 bytes for speed)
   int4  LastPicYloc;
   int4  LastPicXsize;
   int4  LastPicYsize;

// Local global reference to current picture being edited
static DOOMGraphicHdr ImageHeader;

//static WadFiles FlatWad;      // the Flat file
//static WadFiles PicWad;       // the texture file

WadFiles GraphicWad;             // Global For Save in Drawing.cpp  3-31-97 bk
int4     GraphicDirsize;         //          ''                     was dirsize
int4     GraphicDirstart;        // offset  flat start in file      was dirstart

//static int4  dirstart;        // offset  flat start in file
static int2 oldfilenum=-1;    // track last filenumber, so not too many open
//static int4  dirsize;         //
static byte *PixelPtr;        //location of this pixel in raw buffer
static byte *Yorigin;         // area where offsets are
static int4 *Yoffsets;
static byte  YcolumnStart;
static byte  YdataBytes;

//HPALETTE 	hOldPal;

extern		char TxtrName  [9];  // in Dialogs
extern		char FloorName [9];  // in Dialogs
extern      char SpriteName[9];  // in Dialogs

static VOID **  	lpBits = NULL; // Global pointer to the bits in our DIBSECTION
static byte * 		tPtr;				// Temp Pointer to Dib Bits
//static byte * 		fPtr;				// Temp Pointer to Flats Dib Bits

       BITMAPINFO 	DibBitMapInfo;	 // DIB Bitmap Info Struct. used : here, INTRDEEP.CPP and TEXTEDIT.CPP


// Proto's
static PatchAreaList *ThingCache  (char * picname);

static void DisplayImageSize(HDC hdc, int2 xstart, int2 yend,   int2 xsize,int2 ysize);
//int2 DisplaySprite   ( int2 xstart, int2 ystart, int2 xend, int2 yend,
//                       int2 linesinlist, int2 currentline, char *picname);

//char * HelpTextureBrowser( int2 xstart, int2 ystart, int2 xend, int2 yend, char *picname);
//char * HelpFloorBrowser  ( int2 xstart, int2 ystart, int2 xend, int2 yend, char *picname);
/////char * SpriteBrowser     ( int2 xstart, int2 ystart, int2 xend, int2 yend, char *picname);

char* SetTextureSize(int2 hxstart, int2 hystart, int2 hxend, int2 hyend, char *texname);

// Global for Browsing by various routines here

extern Bool advanceInput; 		// for EditLevel pass thru

static char newname  [10]  = {0};
static char entryname[10]  = {0};
static char picname  [10]  = "12345678I";  // I so not recursive call from DrawWindowMap

static char * 		HotName;						// map level name chosen
static char **		levelnames;           	// array of names found

//static  Bool KeyPressed;
static Bool OKtoMapDraw = FALSE;		      // OK for Paint to Draw Maps
static int2 CurrentMagnify;//2;
static int2 Xacross;
static int2 FontSize = 16;
static int2 Ydown;
//static int4 OldScrMaxY, OldScrMaxX;    //   12-25-97 not reqd anymore
static int2 BrowseScrMaxX,BrowseScrMaxY; //   12-25-96
static int2 MaxMagnify;
static int2 HotXloc,HotYloc;
static int2 NumberPerScreen;
static int2 CurrYorg ;
static int2 CurrXorg;
static int2 CurrXloc;
static int2 CurrYloc;
static int2 Width;
static int2 Height;
static int2 oldmagnify;
static int2 FirstOrigin= 0;    // first on screen
static int2 LastOrigin ;       // last  on screen

   // all browsers
static Bool EndBrowse=FALSE;
static int2 FirstItemDrawn = 0; // the First Item drawn
static int2 CurrentActive;      // current active map or item
   // Texture Browser
static int2 oldPicMagnify;

	// Sprite Browser
static int2 xsize;         		// 2 width in pixels
static int2 ysize;         		// 2 height in pixels
static int2 xoffset;       		// 2 x offset for image itself
static int2 yoffset;       		// 2 y offset

//--------------------------------------------------------------------------

// for controlling STRIFE variables

int4  TcontrolSize = 22;        // 22 or 18 offset Texturename to first x/y size
int4  PcontrolSize = 10;        // 10 or 6 length each texture patch control
int4  PpatchNum    = 10;        // #patches  +16(strife) or +20(the rest)

//--------------------------------------------------------------------------------

int2 PicMagnify   = 1;          // set by Menu display function
int2 AnyMagnify   = 2;
int2 WallMagnify  = 1;
int2 CeilMagnify  = 2;

//static  int2          SpriteMagnify=3; // individual mags for each one
char        **SpriteList;
NameAreaList *SpriteListNames;
int2          SpriteCount;

//--------------------- -------------------------------------------------

 Bool  ThingCachingActive = TRUE;

 byte *FlatPixelPtr   =NULL;  // floor ceiling
 byte *FlatPixelBufr  =NULL;

 int2  Texture1File   =0;
 byte *Texture1Buffer =NULL;  // raw TEXTURE1 buffer
 int2  Texture2File   =0;
 byte *Texture2Buffer =NULL;  // raw TEXTURE2 buffer

 int4  TextureNum1  ;         // number of texture names in TEXTURE1 list
 int4  TextureNum2  ;         // number of texture names in TEXTURE2 list

 // Patch names

 int4           PnameCount       =  0;  // number of patch names
 PatchAreaList *PatchPnameBuffer =NULL; // list of all the PNAMEs

 int4           ThingCount       =  0;  // number of thing names
 PatchAreaList *ThingNameBuffer  =NULL; // list of all anything left over <


// for browse for texture name editing
static  int4            BrowsePnameCount;   // #of pnames passed
static  PatchAreaList * BrowsePnameBuffer;  // buffer loc of start of pnames (skips size)

static int4     FreedPnameSize   =  0;  // memory freed by routines
static int4     FreedThingSize   =  0;  // memory freed by routines

static WadFiles TextureWad1;   // the texture directory (usually MasterWad)
static WadFiles TextureWad2;   // the texture directory (usually MasterWad)

//--------------------------------------------------------------------
//  structures of DOOM TEXTURE, PNAME, and individual PATCH entries
//--------------------------------------------------------------------

struct DTextureDefinition             // length=22 DOOM
{  char  name[8];         //+0   = texture name
	int2  dummy1 ;         //+8   = 2 bytes unused
	int2  dummy2 ;         //---    2 ....  unused
	int2  xsize;           //+12  = X size
	int2  ysize;           //+14  = Y size
	int2  dummy3 ;         //+16  = 2 bytes unused
	int2  dummy4 ;         //---    2 bytes unused
	int2  numberofpatches; //+20  = # of wall patches
};

struct STextureDefinition             // length=18 strife
{  char  name[8];         //+0   = texture name
	int2  dummy1 ;         //+8   = 2 bytes unused
	int2  dummy2 ;         //---    2 ....  unused
	int2  xsize;           //+12  = X size
	int2  ysize;           //+14  = Y size
	int2  numberofpatches; //+16 = # of wall patches
};

struct DTexturePatchDefinition        // length =10 DOOM
{  int2  xofs;            //+0 = X offset
	int2  yofs;            //+2 = Y offset
	int2  pindex;          //+4 = index value of name in PNAMES
	int2  dummy1;          //+6 = 1
	int2  dummy2;          //+8 = 0
};

struct STexturePatchDefinition        // length = 6 strife
{  int2  xofs;            //+0 = X offset
	int2  yofs;            //+2 = Y offset
	int2  pindex;          //+4 = index value of name in PNAMES
};


//----------------------------------------------------------------------//
//   Verify Doom Graphic is really ok (replaces prior stuff all over)
//----------------------------------------------------------------------//
Bool DoomGraphicVerify(DOOMGraphicHdrPtr PicHeader, int4 filesize)
{
     if (filesize <=0) return FALSE;

     //if (PicHeader->xsize >  0   && PicHeader->xsize <= 1024
     // && PicHeader->ysize >  0   && PicHeader->ysize <= 200
     // && PicHeader->xoffs >= -320            // -PicHeader->xsize
     // && PicHeader->xoffs <=  320            //PicHeader->xsize
     // && PicHeader->yoffs >= -200            // -PicHeader->ysize
     // && PicHeader->yoffs <=  200            //PicHeader->ysize
     // && PicHeader->ystart >  PicHeader->xsize*4
     // && PicHeader->ystart <  filesize)
     // {  return TRUE;
     // }
     if (PicHeader->xsize >  0   && PicHeader->xsize <= 1024    // X 1 to 1024
      && PicHeader->ysize >  0   && PicHeader->ysize <= 512     // Y 1 to 512
      && PicHeader->xoffs >= -1023           // -PicHeader->xsize
      && PicHeader->xoffs <=  1023           //  PicHeader->xsize
      && PicHeader->yoffs >= -511            // -PicHeader->ysize
      && PicHeader->yoffs <=  511            //  PicHeader->ysize
      && PicHeader->ystart >  PicHeader->xsize*4
      && PicHeader->ystart <  filesize)
      {  return TRUE;
      }
      return FALSE;
}

//-----------------------------------------------------------------------------
// get the size of any patch, sprite, etc
//-----------------------------------------------------------------------------
Bool FindLumpPicSize(char * picname,
		      int2 *xsize,   int2 *ysize,
		      int2 *xoffset, int2 *yoffset)
{
static int2 oldfilenum=0;
static WadFiles PicWad;       // the sprite file

       DOOMGraphicHdr PicHeader;
       DirPtr dir;

//-------------------------------------------------------------------------------

    dir = FindMasterDir( MasterWad, picname,FALSE);

    if (dir)
    {
       if (dir->filenumber != 0 && dir->filenumber != oldfilenum)
       {   CloseWadFiles('O',FREEDIRNO,FREENAMENO);  // close all
	        oldfilenum = dir->filenumber;
       }

       SetActiveWad(&PicWad,dir->filenumber);

	    WadSeek( PicWad.fileinfo, dir->start   );     // seek start of entry
       WadRead( PicWad.fileinfo, &PicHeader,12);     // x width , y height, xoff,yoff
	    *xsize   = PicHeader.xsize;
	    *ysize   = PicHeader.ysize;
	    *xoffset = PicHeader.xoffs;
       *yoffset = PicHeader.yoffs;
	    return TRUE;
    }
    else
    {  return FALSE;
    }
}


//---------------------------------------------------------------------
// show the image size at the bottom of the picture
//---------------------------------------------------------------------
#pragma argsused
static void DisplayImageSize(HDC hdc, int2 xstart, int2 yend, int2 xsize, int2 ysize)
{
   // clear the box where the image size will be drawn -10 +10 for name /
   HFONT hOldFont;
   char size[8];

//    DrawScreenBox3D(hdc,xstart+wt2, yend+2, xstart+wt2*8, yend+ht2+4, gd.hBrushes[LIGHTGRAY]);
    SetBkMode(hdc, TRANSPARENT);
    SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK]));
    hOldFont = SelectFont(hdc, gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));
    wsprintf(size, "%hdx%hd", xsize, ysize);
    TextOut(hdc, xstart+wt2+4, yend+3, size, lstrlen(size));
    SelectFont(hdc, hOldFont);
}

//--------------------------------------------------------------------------------
//  read in the TEXTURE1/2
//--------------------------------------------------------------------------------
void BuildTextureBuffer(void)
{
   DirPtr dir;             // pointer in main directory to texname

   if (!Texture1Buffer)
   {
     dir = FindMasterDir( MasterWad, "TEXTURE1",TRUE);
     SetActiveWad(&TextureWad1,dir[0].filenumber);
     TextureWad1.dirstart =  dir[0].start;

     Texture1File   = dir->filenumber;
     Texture1Buffer = (byte *)GetMemory( dir[0].size );         // buffer for TEXTURE1

     WadSeek( TextureWad1.fileinfo, dir[0].start);
     WadRead( TextureWad1.fileinfo,Texture1Buffer,dir[0].size); // raw data of Texture1

     TextureNum1    =( (int4 *) Texture1Buffer )[0];            // number of entries
   }

   // if not found search for texname in texture2 names (only Doom1 reg)

   if (!Texture2Buffer)
   {
     dir = FindMasterDir( MasterWad, "TEXTURE2",FALSE);         // was TRUE

     if (dir)
     {  SetActiveWad(&TextureWad2,dir[0].filenumber);
	     TextureWad2.dirstart =  dir[0].start;

	     Texture2File   = dir->filenumber;
	     Texture2Buffer = (byte *)GetMemory( dir[0].size );            // buffer for TEXTURE1

        WadSeek( TextureWad2.fileinfo, dir[0].start);
	     WadRead( TextureWad2.fileinfo,Texture2Buffer,dir[0].size); // raw data of Texture1

	     TextureNum2    =( (int4 *) Texture2Buffer)[0];               // number of entries
	  }
   }

}

//--------------------------------------------------------------------------------
//  read in the PNAMES
//--------------------------------------------------------------------------------
void BuildPnameBuffer(void)
{
   int2      n;

   DirPtr    pdir;            // main directory pointer to the PNAMES entry
   WadFiles  PnameWad;        // the PNAME directory (usually MasterWad)

   byte     *PnameBufferLoc;  // index into PNAME buffer
   byte     *PnameBuffer;     // raw PNAME buffer

   PatchAreaList *PatchAreaWrk;    // list of resident texture names,x y, #pathes

//--------------------------------------------------------------------------------

   if (PatchPnameBuffer) return;                         // allready have it

   pdir = FindMasterDir( MasterWad, "PNAMES",TRUE);
   SetActiveWad(&PnameWad,pdir->filenumber);             // where location of PNAME

   PnameBuffer = (byte *)GetMemory( pdir->size );        // allocate PNAME buffer

   WadSeek( PnameWad.fileinfo, pdir->start);
   WadRead( PnameWad.fileinfo,PnameBuffer, pdir->size);  // raw data of PNAME

   PnameCount = ((int4*)PnameBuffer)[0];                 // number of entries

   PnameBufferLoc   = PnameBuffer+4;                     // skip size

   PatchPnameBuffer = (PatchAreaList *)GetMemory( PnameCount * sizeof(PatchAreaList) );

   PatchAreaWrk = PatchPnameBuffer;

   for (n = 0; n < PnameCount; n++)
   {
      strncpy((char *)PatchAreaWrk->name, (char *)PnameBufferLoc,8);     // name of patch
      PatchAreaWrk->loc = NULL;                         // where it will be stored
      PatchAreaWrk->size= 0;                            // size of patch init to 0
      PatchAreaWrk->filenum=0;                          // init file to Main for now

      PatchAreaWrk    = PatchAreaWrk+1;                 // next address store
      PnameBufferLoc += 8;                              // next address in
   }

   FreeMemory(PnameBuffer);

}


//--------------------------------------------------------------------------------
//  free Texture1 buffer
//--------------------------------------------------------------------------------
void FreeTexture1Buffer (int2 FileNumber)
{
   if (!Texture1Buffer) return;

   if (FileNumber==Texture1File
   ||  FileNumber < 0 )
   {
      FreeMemory( Texture1Buffer); //list of Names in TEXTURE1
      Texture1Buffer  = NULL;
      TextureNum1     = 0;         // number of texture names in TEXTURE1 list
   }
}

//--------------------------------------------------------------------------------
//  free Texture2 buffer
//--------------------------------------------------------------------------------
void FreeTexture2Buffer (int2 FileNumber)
{
   if (!Texture2Buffer) return;

   if (FileNumber==Texture2File
   ||  FileNumber < 0  )
   {
       FreeMemory( Texture2Buffer); //list of Names in TEXTURE1
       Texture2Buffer  = NULL;
       TextureNum2     = 0;         // number of texture names in TEXTURE1 list
   }
}

//--------------------------------------------------------------------------------
//  free THING in buffer
//--------------------------------------------------------------------------------
void FreeThingBuffer(Bool FreeAll)
{
   int4 n;

//------------------------------------------------------------------------------

   if (!ThingNameBuffer) return;

   for (n = 0; n < ThingCount; n++)
   {
      if (ThingNameBuffer[n].loc )
      {
	       FreedThingSize += ThingNameBuffer[n].size;   // count amount freed
	       FreeMemory(ThingNameBuffer[n].loc);          // free loc of patch
	       ThingNameBuffer[n].loc = NULL;
	   }

      ThingNameBuffer[n].size    = 0;
	   ThingNameBuffer[n].filenum = 0;
   }

   if  (FreeAll)
   {
       FreeMemory( ThingNameBuffer);   //list of Names in Thing
	    ThingNameBuffer = NULL;
   }

	ThingCount      = 0;

}


//--------------------------------------------------------------------------------
//  1. see if name is in PNAMEBUFFER
//  2. free memory and replace with new file number
//--------------------------------------------------------------------------------
void ResetPnameBuffer(DirPtr dir)                    // free any pname to this file
{
   int4 n;

   if (!PatchPnameBuffer) return;

   for (n = 0; n < PnameCount; n++)
   {
   	if (!strnicmp(PatchPnameBuffer[n].name,dir->name,8) )
	   {
	     if (PatchPnameBuffer[n].loc )
	     {
	       FreedPnameSize += PatchPnameBuffer[n].size;
	       FreeMemory(PatchPnameBuffer[n].loc);   // free loc of patch
	       PatchPnameBuffer[n].loc = NULL;
	     }

	     PatchPnameBuffer[n].size= 0;              // force recalc
	     PatchPnameBuffer[n].filenum = dir->filenumber;
	     break;
	   }
   }
}

//--------------------------------------------------------------------------------
//  1. see if name is in THINGBUFFER
//  2. free memory and replace with new file number
//--------------------------------------------------------------------------------
void ResetThingBuffer(DirPtr dir)                    // free any Thing to this file
{
   int4 n;

   if (!ThingNameBuffer) return;

   for (n = 0; n < ThingCount; n++)
   {
      if (!strnicmp(ThingNameBuffer[n].name,dir->name,8) )
	   {
	     if (ThingNameBuffer[n].loc )
	     {
	        FreedThingSize += ThingNameBuffer[n].size; // accum size freed
	        FreeMemory(ThingNameBuffer[n].loc);        // free loc of thing
	        ThingNameBuffer[n].loc = NULL;
	     }

	     ThingNameBuffer[n].size= 0;
	     ThingNameBuffer[n].filenum = dir->filenumber;
	     break;
    	}
   }

}

//--------------------------------------------------------------------------------
//  free PNAMES in buffer
//--------------------------------------------------------------------------------
void FreePnameBuffer(Bool FreeAll)
{
   int4 n;
//   DirPtr dir;
//   DirPtr dirmain;

//---------------------------------------------------------------------------------

   if (!PatchPnameBuffer) return;

   for (n = 0; n < PnameCount; n++)
   {
       if (PatchPnameBuffer[n].loc )
	    {
	       FreedPnameSize += PatchPnameBuffer[n].size;
	       FreeMemory(PatchPnameBuffer[n].loc);   // free loc of patch
	       PatchPnameBuffer[n].loc     = NULL;
       }

     	 PatchPnameBuffer[n].size    = 0;           // force reload
	    PatchPnameBuffer[n].filenum = 0;
   }

   if (FreeAll)
   {
       FreeMemory( PatchPnameBuffer);            //list of Names in Pnames
       PatchPnameBuffer= NULL;
       PnameCount      = 0;
   }
}


//----------------------------------------------------------------------//
//   function used by qsort to sort the sprite names
//----------------------------------------------------------------------//

int QsortName( const void *a, const void *b)
{
   return strncmp ( * ( (char **) a), *( (char **) b),8   );
}



//////////////////////////////////////////////////////////////
//																				//
//			START   OF   GRAPHICS  CODE  - Sprite display,		//
//													 Floor, Txtrs etc.	//
//////////////////////////////////////////////////////////////



//----------------------------------------------------------------------//
//   this is always the -------spritewad------
//   display a picture "picname" at coords xstart, ystart and not beyond xend, yend
//   no offsets , but show picture size (0x7fff)
//----------------------------------------------------------------------//

PatchAreaList * ThingCache(char * picname)
{
static int4 MaxThingCount=300;

   DirPtr    dir;                 // find the actual directory name of patch
   WadFiles  PicWad;              // the patch Texture directory (usually MasterWad)
   PatchAreaList *PatchAreaWrk;   // list of resident texture names,x y, #pathes

   int2      n;

//--------------------------------------------------------------------------------

   if (!ThingNameBuffer)               // build an area to hold ? 1mb
   {
       ThingNameBuffer = (PatchAreaList *)GetMemory(MaxThingCount * sizeof(PatchAreaList) );
   }

   // see if already resident

   PatchAreaWrk = ThingNameBuffer;

   for (n = 0; n < ThingCount; n++)
   {
      if (!strncmp(picname,PatchAreaWrk->name,8) )
      {
	       if (!PatchAreaWrk->size )break;                 // size of patch = 0
          SetActiveWad(&PicWad,PatchAreaWrk->filenum);    // where patch is for info   12-20-96
	       return PatchAreaWrk;                            // already have it
      }

      PatchAreaWrk    = PatchAreaWrk+1;                   // next address compare
   }

   // if no match found- store

   if (n >= ThingCount)
   {
       if (ThingCount >=MaxThingCount) return NULL;       // maxed out

       PatchAreaWrk = ThingNameBuffer+ThingCount;         // next available entry
       strncpy(PatchAreaWrk->name,picname,8);             // name of thing
   }

   PatchAreaWrk->loc = NULL;                              // where it will be stored
   PatchAreaWrk->size= 0;                                 // size

   dir = FindMasterDir( MasterWad, picname,FALSE);        // find this picture

   if (!(dir) ) return NULL;                              // not found

   SetActiveWad(&PicWad,dir->filenumber);                 // where patch is

   WadSeek( PicWad.fileinfo, dir->start);                 // start of patch
   WadRead( PicWad.fileinfo, &PatchAreaWrk->pic,12);      // x,y,xoff,yoff,ystart
   //--note offsets can be negative--------------------

   // round to 1 k value see if this help memallocs

   PatchAreaWrk->filenum= dir->filenumber;                // file of patch
   PatchAreaWrk->start  = dir->start;                     // file location start
   PatchAreaWrk->size   = dir->size;                      // size of patch

   ThingCount ++;

   if (ThingCachingActive)
   {
     if (dir->size < 16384 )                               // max size 16k
     {
         if (FreedThingSize > 0)
	      {   FreedThingSize -= PatchAreaWrk->size;         // decrement amount left
	      }

	      PatchAreaWrk->loc  = (char *)malloc(PatchAreaWrk->size );        // memory size of patch

	      if (PatchAreaWrk->loc)                                   // got it
	      {
	          WadSeek( PicWad.fileinfo, dir->start);                   // start of patch
	          WadRead( PicWad.fileinfo, PatchAreaWrk->loc,dir->size);  // the patch
	       }
     }
   }

   return PatchAreaWrk;   // where it is

}


//----------------------------------------------------------------------//
//   -- some hacking ----
//   display a picture "picname" at coords xstart, ystart and not beyond xend, yend
//
//   format of graphics
//                         x width    2
//                         y height   2
//                         x offset   2  (relative)
//                         y offset   2
//                         --list offsets to Y columns --
//                         there are X numbers containing offset in this entry
//                         first entry points to for example, is X=0
//                         ..
//                         ..
//                         Y entry (typical) there are X of these
//                           1st byte is Y origin of this column
//                           2nd byte is number of Y data bytes
//                           data bytes
//                           ...
//                           ...
//                           FF = last byte
//                           00 = null byte
//----------------------------------------------------------------------//

#pragma argsused
int2 DisplayPic(HDC hdc, int2  xstart,  int2 ystart,
                         int2  xend,    int2 yend,          // xsize and ysize if xstart = -1
                         char *PicBufr,                     // if picbufr : xstart,ystart = maxsize, xend,yend=picsize
                         char *picname,
                         int2  xoffset,  int2 yoffset,
                         int2  magnify,
                         int2  BackGround, Bool Center )
{

static char  notimagemsg[] = " not image ";
static char  nomemorymsg[] = "no memory";

// Image header---------------------

static DOOMGraphicHdr PicHeader;

//-----------------------------------------------------------------------

register i,k, x, y;
   int4  l, n;
   int2  xOrge,yOrge;

   int2  shrink     = 0;
   int2  shrinkSkipX= 0;
   int2  shrinkSkipY= 0;

   int4  magXalign;           // precalc actual image size (round even row) made 4 10-1-97  
   int4  magXadjust;          // precalc actual image size
   int4  magYadjust;

   int4  CurrentX;

   Bool  ResidentName=FALSE;
   Bool  IsApatchName=FALSE;   // is a texture patch name (else sprite)
   Bool  freebuffer  =FALSE;

   int4  oldleft;
   int4  newleft;

static byte *RawImageData;    //raw image data
static byte *Yorigin;         // area where offsets are
static int4 *Yoffsets;

static byte  YcolumnStart;
static byte  YdataBytes;

static byte *PixLocPtr;   //
static byte *PixLocWrk;   //

static byte *PixelPtr;    //
static byte  MagColor;    // store pixel here

static DirPtr         dir=NULL;    //
static WadFiles       PicWad;      // the texture directory (usually MasterWad)

static PatchAreaList *PatchAreaWrk;  // list of resident texture names,x y, #pathes

static int4 dirstart;
static int4 dirsize;

//-------------------------------------------------------------------------

static MEMORYSTATUS mst;

       HPEN 		  hOldPen;
       HDC 		     hdcMem;
       HBITMAP		  hOldBitmap=NULL;

//-------------------------------------------------------------------------

	//memset(&mst, 0, sizeof(mst)); not needed   8-1-97
	mst.dwLength = sizeof(mst);

  	GlobalMemoryStatus(&mst);

   wt2 = 8;
	ht2 = 8;

   // look for name in resident Patch Names------------------------------------

   if (PatchPnameBuffer)
   {
     PatchAreaWrk = PatchPnameBuffer;                    // set first address

     // find name in PatchPnameBuffer

     for (n = 0; n < PnameCount; n++, PatchAreaWrk+=1)
     {
       if (!strncmp(picname,PatchAreaWrk->name,8) )        // found name
       {
          IsApatchName=TRUE;                               // set to patch name

	       //  if this entry has never been read, set value now

	       if (!PatchAreaWrk->size)                                //no size value
	       {
	          dir = FindMasterDir( MasterWad, picname,FALSE);    // find this patch
	          if (!dir)
	          {   IsApatchName=FALSE;
		           break;                                         // not found!!!
	          }

	          PatchAreaWrk->filenum= dir->filenumber;            // file of patch
	          PatchAreaWrk->start  = dir->start;                 // start
	          PatchAreaWrk->size   = dir->size;                  // size of patch

	          SetActiveWad(&PicWad,PatchAreaWrk->filenum);       // where patch is
	          WadSeek( PicWad.fileinfo, PatchAreaWrk->start);    // start of patch
	          WadRead( PicWad.fileinfo,&PatchAreaWrk->pic,12);   // x,y,xoffs,yoffs
	          //--note offsets can be negative--------------------
	       }
          else
          {
	          SetActiveWad(&PicWad,PatchAreaWrk->filenum);          // where patch is   12-20-96
          }

	       if (CacheTexture)                                        // caching active
	       {
             if (!PatchAreaWrk->loc )                              // no patch read yet
	          {
	             if (mst.dwAvailPhys < 1500000                      // not enough physical left   8-1-97 + rearrange a bit
		          &&  FreedPnameSize < PatchAreaWrk->size) break;    // mem freed too little

	             if (PatchAreaWrk->size > 32768) break;             // max size 32k

		          oldleft = mst.dwAvailPhys;//+mst.dwAvailPageFile;

                if (FreedPnameSize > 0)
		          {   FreedPnameSize -= PatchAreaWrk->size;          // decrement
	             }
		          else
	           	 {   FreedPnameSize = 0;
	          	 }

		          // use malloc to catch error (win)
		          PatchAreaWrk->loc = (char *)malloc(PatchAreaWrk->size);       // size of patch

	             if (!PatchAreaWrk->loc)                               // not enough
		          {
                   hOldPen = SelectPen(hdc, gd.hPens[RED]);
		             MoveToEx(hdc, xstart+8, ystart+8, NULL);
                   LineTo(hdc, xstart+48, ystart+48);
		             MoveToEx(hdc, xstart+8, ystart+48, NULL);
                   LineTo(hdc, xstart+48, ystart+8);
		             TextOut(hdc,xstart+wt2,ystart+ht2,nomemorymsg,lstrlen(nomemorymsg));
                   SelectPen(hdc, hOldPen);
		             return PicWad.filenumber;;
		          }

                // a check that enough memory is available for this stuff

		          newleft = mst.dwAvailPhys;//+mst.dwAvailPageFile;      // mem left now

	             if ( oldleft != newleft)                             // used memory
	          	 {   if ( newleft <  1500000)                         // no room
		              {    FreeMemory(PatchAreaWrk->loc);              // give back
			                PatchAreaWrk->loc = NULL;
			                FreedPnameSize += PatchAreaWrk->size;       // released
			                freebuffer = TRUE;                          // release at exit
			                break;
		              }
		          }

                SetActiveWad(&PicWad,PatchAreaWrk->filenum);          // where patch is
		          WadSeek( PicWad.fileinfo, PatchAreaWrk->start);                 // start of patch
		          WadRead( PicWad.fileinfo, PatchAreaWrk->loc,PatchAreaWrk->size);// the patch
	          }

	          PicHeader.xsize = PatchAreaWrk->pic.xsize;   // x width
	          PicHeader.ysize = PatchAreaWrk->pic.ysize;   // y height
             PicHeader.ystart= PatchAreaWrk->pic.ystart;
	          RawImageData    = (byte *)PatchAreaWrk->loc; // data loc of patch
	          dirsize         = PatchAreaWrk->size;        // size of image
	          ResidentName = TRUE;                         // its resident
	       }
	       break;

       }
     }
   }

   // see if resident name------in general purpose cache and not a PNAME entry

   if (!ResidentName && !IsApatchName)
   {
       PatchAreaWrk = ThingCache(picname);   // look for it and save it if new

       if (PatchAreaWrk)
       {
           SetActiveWad(&PicWad,PatchAreaWrk->filenum);    //   12-20-96

	        if (PatchAreaWrk->loc)                          // buffer allocated
	        {
	           PicHeader.xsize = PatchAreaWrk->pic.xsize;   // x width
	           PicHeader.ysize = PatchAreaWrk->pic.ysize;   // y height
              PicHeader.ystart= PatchAreaWrk->pic.ystart;
	           RawImageData    = (byte *)PatchAreaWrk->loc; // data loc of patch
	           dirsize         = PatchAreaWrk->size;        // size of image
	           ResidentName = TRUE;
	        }
	        else
	        {   IsApatchName= TRUE;
	        }
       }
   }


   //--------------------------------------------------------------------

   if  (!ResidentName)
   {   // if not a PNAME, we need to find this entry as a LUMP name

       if (!IsApatchName)
       {   dir = FindMasterDir( MasterWad, picname,FALSE);
	        if (!dir)
	        {
		        return 0;        // nothing found yet (when scrolling for example)
	        }

	        dirstart = dir->start;                       // start of entry
	        dirsize  = dir->size;                        // size of whole image

	        SetActiveWad(&PicWad,dir->filenumber);

	        WadSeek( PicWad.fileinfo, dirstart  );       // seek start of entry
	        WadRead( PicWad.fileinfo, &PicHeader,12);    // x,y,xoff,yoff
	        //-- note offsets can be negative--------------------
       }
       else // PNAME info already found
       {   SetActiveWad(&PicWad,PatchAreaWrk->filenum); // file where patch is
	        dirstart       = PatchAreaWrk->start;        // file location
	        dirsize        = PatchAreaWrk->size;         // size of image
	        PicHeader.xsize= PatchAreaWrk->pic.xsize;    // x width
	        PicHeader.ysize= PatchAreaWrk->pic.ysize;    // y height
           PicHeader.ystart=PatchAreaWrk->pic.ystart;
	        PicHeader.xoffs= 0;                          // pnames are always ok
	        PicHeader.yoffs= 0;

       }

       // see if image is within specs ( 320x200?)
       if (!DoomGraphicVerify(&PicHeader,dirsize) )
       {
           hOldPen = SelectPen(hdc, gd.hPens[RED]);
		     MoveToEx(hdc, xstart+8,  ystart+8, NULL);
           LineTo  (hdc, xstart+48, ystart+48);
		     MoveToEx(hdc, xstart+8,  ystart+48, NULL);
           LineTo  (hdc, xstart+48, ystart+8);
		     TextOut(hdc,xstart+wt2,ystart+ht2,notimagemsg,lstrlen(notimagemsg));
           SelectPen(hdc, hOldPen);
	        return PicWad.filenumber;
       }

       // allocate memory needed

       RawImageData  = (byte *)malloc( dirsize );

       if (!RawImageData)                          // allocation failed
       {
           hOldPen = SelectPen(hdc, gd.hPens[RED]);
		     MoveToEx(hdc, xstart+8,  ystart+8, NULL);
           LineTo  (hdc, xstart+48, ystart+48);
		     MoveToEx(hdc, xstart+8,  ystart+48, NULL);
           LineTo  (hdc, xstart+48, ystart+8);
		     TextOut(hdc,xstart+wt2,ystart+ht2,nomemorymsg,lstrlen(nomemorymsg) );
           SelectPen(hdc, hOldPen);
	        return PicWad.filenumber;
       }

       WadSeek( PicWad.fileinfo, dirstart);
       WadRead( PicWad.fileinfo, RawImageData, dirsize);  //columndata
   }


   Yoffsets  = (int4 *)&RawImageData[0] + 2;        // address 1st Y offset start =+8

   if ( Yoffsets[0] < 12 || Yoffsets[0] > dirsize)
   {
        hOldPen = SelectPen(hdc, gd.hPens[RED]);
		  MoveToEx(hdc, xstart+8,  ystart+8, NULL);
        LineTo  (hdc, xstart+48, ystart+48);
		  MoveToEx(hdc, xstart+8,  ystart+48, NULL);
        LineTo  (hdc, xstart+48, ystart+8);
		  TextOut(hdc,xstart+wt2,ystart+ht2,notimagemsg,lstrlen(notimagemsg));
        
        SelectPen(hdc, hOldPen);
        if (!ResidentName)                           // just read it in
        {   FreeMemory(RawImageData);
            RawImageData = NULL;
        }
        return PicWad.filenumber;
   }


   // dynamic create size of image from xsize if auto-=center
   // get size of the buffer to store image in


   if (PicBufr) // MUST be a fully qualified DIB now !!!!
   {
       magXadjust   = DibBitMapInfo.bmiHeader.biWidth;          //   5-1-97
       magYadjust   = abs(DibBitMapInfo.bmiHeader.biHeight);    // Negative so turn Positive   5-1-97 safety
       magXalign  = ( magXadjust + 3 ) & ~3;                  //   5-1-97
       tPtr = (byte *)PicBufr;                                  // Pointer to Dib Bits
   }
   else
   {  //  see if dynamic picture size   (xend = -1)
      if (xend == -1)
      {   magXadjust = PicHeader.xsize;
	       magYadjust = PicHeader.ysize;
	       if (magnify >=1 )
	       {   magXadjust *= magnify;
	           magYadjust *= magnify;
	       }
      }
      else // size of picture is the dimension given
      {   magXadjust = (xend-xstart+1);
	  		 magYadjust = (yend-ystart+1);
      }

      if (magnify < 1 )
      {
	  		 shrink     = (-magnify+2);          // 0 =2, 1=3 etc
	  		 magXadjust = (magXadjust+shrink-1)/ shrink;
	  		 magYadjust = (magYadjust+shrink-1)/ shrink;
      }

      magXalign  =(magXadjust + 3 ) & ~3;        // windows quad alignment

    	// Set up a BITMAPINFO structure for use with CreateDIBSection()

    	ZeroMemory(&DibBitMapInfo, sizeof(BITMAPINFO));
    	DibBitMapInfo.bmiHeader.biSize       = sizeof(BITMAPINFOHEADER);
    	DibBitMapInfo.bmiHeader.biPlanes     = 1;
    	DibBitMapInfo.bmiHeader.biBitCount   = 8;
    	DibBitMapInfo.bmiHeader.biWidth      =  magXadjust;    // DWORD align the Size X
    	DibBitMapInfo.bmiHeader.biHeight     = -magYadjust;    // Negative for regular Up DIB
		DibBitMapInfo.bmiHeader.biSizeImage  = (magXalign *  magYadjust);  //   5-1-97 magXadjust using old stuff
    	DibBitMapInfo.bmiHeader.biCompression= BI_RGB;

    	// Create a DC to hold our DIBSECTION
    	hdcMem = CreateCompatibleDC(hdc);
    	// Create a DIBSECTION to draw into
    	gd.hDibbm = (HBITMAP)CreateDIBSection(hdc, &DibBitMapInfo, DIB_PAL_COLORS, (VOID **)&lpBits, NULL, 0L);
      if (gd.hDibbm )
    	{   hOldBitmap  = SelectBitmap(hdcMem, gd.hDibbm);  	// Select into our Memory Dc

	     	 SetDIBColorTable(hdcMem, 0, 256, dRGBquad);			// Palette indexes

    	    tPtr = (byte *)(VOID **)&*lpBits;	               // Grab pointer to the bits of our DIBSection

          FillMemory(tPtr, DibBitMapInfo.bmiHeader.biSizeImage, GameColors[BackGround]); // fill with background
      }
      else
      {   tPtr = NULL;
      }

   } // end of if(PicBufr)

   // show image size if xoffset is maxed out

   if (xoffset == SHOWSIZE)           //0x7fff)
   {   xoffset = 0;
       DisplayImageSize(hdc, xstart,yend+3,PicHeader.xsize,PicHeader.ysize);     // display image size
   }

   // check out magnify

   if (magnify < 1 )
   {
       shrink      = (-magnify+2);       // 0=2, 1=3 etc
       magnify     = 1;
       shrinkSkipX = shrink;
       shrinkSkipY = shrink;
   }

   // automatically center image

   if (Center)
   {
       xstart = xstart-magXadjust/2;  // center x
       ystart = ystart-magYadjust/2;  // center y
       if (xstart < 0) xstart = 0;
       if (ystart < 0) ystart = 0;
   }

   //  if xstart < 0, xend, yend have the image dimensions

   if (xstart < 0)
   {   if (magnify > 1)
       {  	xOrge= xend*magnify;      // xsize*mag
	  			yOrge= yend*magnify;      // ysize*mag
       }
       else
       {  	xOrge= xend;              // xsize
	  			yOrge= yend;              // ysize
       }

       //if ( xOrge > magXadjust || yOrge > magYadjust)
       //{    xOrge = magXadjust;
	    //		yOrge = magYadjust;
       //}
       if ( xOrge > magXadjust) xOrge = magXadjust;          //   8-1-97 split apart reqd
	    if ( yOrge > magYadjust) yOrge = magYadjust;
       
       xstart=0;                      // safety
       ystart=0;
   }
   else
   {
       xOrge = magXadjust;
       yOrge = magYadjust;
   }


   //-------------------------------------------------------------------
   // could store calculated image one time, then scale
   // for DOS takes too much memory, WIN might be OK to do
   // image is displayed for each Y column, then move to next X, etc.

   //xOrge +=(int2) 16; adjust for buffer offset compare later  DON"T DO IT !

 if (tPtr)
 {
   // Do X first -----------------------------------------------------------------

   for (CurrentX = 0; CurrentX < PicHeader.xsize ; CurrentX++)
   {
     if (shrink)
     {   shrinkSkipX--;
         if (shrinkSkipX) continue;
	      shrinkSkipX = shrink;

	      x = (xoffset +CurrentX)/shrink;         // only 1/2 size
     }
     else
     {   x = magnify*(CurrentX +xoffset);         // origin + current x loc
     }

     // display a line of pixels for height (xofs,yofs assembles composites)

     if ( x >= 0              // x >= left
     &&   x <  xOrge )        // x <  right side
     {
       Yorigin = (byte *) &RawImageData[0] + Yoffsets[CurrentX]; // start of column

       // we now have the needed (Y) column data - display it

       n            = 1;
       YcolumnStart = Yorigin[0];                       // y origin start

       while (YcolumnStart != 255 )
       {
          // resync Y origin

         if (shrink)
         {   y = (yoffset+YcolumnStart)/shrink;
	      }
	      else
	      {   y = magnify*(YcolumnStart+yoffset);        // set start of y
	      }

	      YdataBytes = Yorigin[n];       // # of vertical data bits (byte)

	      n += 2;                        // skip over 'null' pixel in data

	      PixelPtr = Yorigin+n;          // address 1st pixel color

	      // Y direction---------------------------------------------------------

	      for (i = 0; i < YdataBytes && y < yOrge; i++, PixelPtr++, y+=magnify)
	      {
	        if (shrink)
	        {   shrinkSkipY--;
		         if (shrinkSkipY)
		         {   y--;               // compensate for y adjust at end
		             continue;
		         }
		         shrinkSkipY = shrink;
	        }

	        if (y < 0) continue;     // can happen here with negative offsets

	        if (magnify == 1)
	        {
		         tPtr[(magXalign * y) + x] = *PixelPtr;   //   5-1-97 was magXadjust
	        }
	        else
	        {
		        MagColor = *PixelPtr;
              PixLocPtr = &tPtr[ (magXalign * y) + x ];//   5-1-97 was magXadjust

		        for (k=0; k< magnify; k++, PixLocPtr+=magXalign)  // //   5-1-97 was magXadjust!!!!!!!
		        {                                                   // Has to be 32 bit aligned
		            if  (y+k >= yOrge) break;

		            PixLocWrk = PixLocPtr;

		            for (l=0; l< magnify; l++)            //x
		            {
			             if ( (x+l) >= xOrge) break;

			             PixLocWrk++[0] = MagColor;
		            }
		        }
	        }
	      }

	      n += YdataBytes + 1;          // skip over written pixels, and the 'null' one

	      YcolumnStart = Yorigin[n++];  // next y origin

       }

       if (YcolumnStart != 255)        // this is an error
       {
			  TextOut(hdc,xstart+4,ystart+4,"NotIMAGE",8);
	        break;
       }
     }
   }
 }


   // free data buffer if temporarily allocated
   if (!ResidentName)     // just read it in
   {
       FreeMemory(RawImageData);
       RawImageData = NULL;
   }

   // free image buffer if temporarily allocated
   if (!PicBufr)
   {
 	   BitBlt(hdc, xstart, ystart, magXadjust, magYadjust, hdcMem, 0, 0, SRCCOPY);//   5-1-97was magXalign using old

      GdiFlush();   // Make sure we get this frame displayed now!
             		  // Have to call if working on the bits of the DIB
      if (gd.hDibbm)// If we need to, get rid of the old objects
      {
         if (hOldBitmap) SelectBitmap(hdcMem, hOldBitmap);
         DeleteBitmap(gd.hDibbm);
         gd.hDibbm 	= NULL;
         lpBits 		= NULL;
    	   DeleteDC(hdcMem);
      }
   }

   if ( freebuffer)                             // we used it up
   {    FreePnameBuffer(FALSE);                 // release
   }

   return PicWad.filenumber;
}


//--------------------------------------------------------------------------------
// display graphic -- buffer is allocated if not done yet
//
// If user supplied Dib pointer and Handle will return same to user
// after filling data buffer with graphic texture and NOT displaying
//
// Modified to only redraw selected area as well, much faster update
// with a LOT less flicker - thanks Jack.
// 1-1-97 bk
//
//--------------------------------------------------------------------------------
#pragma argsused
int2 DisplayGraphicFlat   (HWND hwnd, HDC hdc, Bool Master,
                           int2 xstart,int2 ystart,
                           int2 xend,  int2 yend,
                           int4 *RawSize,     // size of raw data
                           byte**RawData,     // addr of raw data buffer
                           int4 *ImageSize,   // addr where to store size
                           byte**ImageBufr,   // Pointer to Dib bits (DIBSECTION)
                           HBITMAP hDibbm,    // Handle of the Dib Bitmap
                           char *picname,
                           int2  magnify,
                           Bool  ShowInfo,
                           int2  fillcolor,  //not used, just for consistency
                           Bool  ShowImage)
{
   register k,l;                 //
   static WadFiles FlatWad;      // the Flat file
   static RECT  rc;
	static HDC 			hdcMem     = NULL;
	static HBITMAP		hOldBitmap = NULL;
	static HBITMAP		hDib       = NULL;
   static byte *     WrkPtr     = NULL; // used to be WrkPtr Pointer to Dib bits

   int4  m,n,x,y;         //
   int4  xwidth = (xend - xstart +1);
   int4  yheight= (yend - ystart +1);

   int4  FlatImageSize;      // size required to hold screen buffer
   int4  PixelOffset;
   // 3---31-97 bk
   //int4  WrkImageSize=-1;    // size required to hold screen buffer
   byte *WrkImagePtr;        // floor ceiling

   int2   filenum;
   DirPtr dir;                //

   byte  MagColor;            //
   int4  mag64;               // 64 * magnify precalc for expansion
   byte *RawWrkData = NULL;
   int4  RawWrkSize = -1;

   //--------------------------------------------------------------------
   // get old buffer if any

   if (RawData)
   {
       RawWrkData= *RawData;          //5-3-96 address of prior
       if (!RawWrkData)
       {   if ( RawSize)
           {   *RawSize = 0;         // none allocated
           }
       }
       else
       if (RawSize)
       {   RawWrkSize=  *RawSize;    //5-3-96 size of prior
       }
   }


   // get old image buffer if any
   if (ImageBufr)                // this better have a valid address!   8-1-97 (simplify code)
   {
       WrkPtr = *ImageBufr;	   // Grab pointer to the bits of our DIBSection
       hDib   =  hDibbm;         // Handle to the bitmap
   }

   dir = FindMasterDir( MasterWad, picname,FALSE);
   if (!dir) return 0;

   if (dir->size          <=  0 ) return 0;      // no size
   if (!Master)
   {   if (dir->filenumber == 0 ) return 0;      //  master wad
   }

   GraphicDirstart = dir->start;                 // start of entry
   filenum  = dir->filenumber;

   if (filenum != oldfilenum )
   {   CloseWadFiles('O',FREEDIRNO,FREENAMENO);  // close all
       oldfilenum = filenum;
   }

   SetActiveWad(&FlatWad,dir->filenumber);

   if (!RawWrkData || RawWrkSize != 4096)   // all 4096
   {
       RawWrkSize = 4096;                // size of whole image can't use dir->size cause of bad values
       if (RawSize)
       {   *RawSize = RawWrkSize;        //++
       }

       FreeMemory(RawWrkData);                              // free prior data buffer
       RawWrkData = (byte *)malloc( RawWrkSize);            // allocate memory needed
       if (RawData)
       {   *RawData = RawWrkData;        //++
       }

       if (!RawWrkData)
       {
           if (RawSize)
           {   *RawSize = 0;            //++
           }
           return -1;                                       // allocation failed
       }

       WadSeek( FlatWad.fileinfo, dir->start);              // start of entry
       WadRead( FlatWad.fileinfo, RawWrkData, RawWrkSize);  // all floors = 4k
   }

   // dynamic create size of image from xsize if auto-=center
   // get size of the buffer to store image in

   mag64 =  (magnify * 64);

   // now adjust so it fits in the window only if image is displayed

   if (ShowImage)
   {
       while (mag64 > xwidth || mag64 > yheight)
       {      magnify--;
	           mag64 = magnify * 64;
       }
   }

   if (magnify <= 0)
   {   magnify = 1;
   }

   //---------hack------------

   mag64 = magnify*64;

   if (ShowInfo)  // Post a message to the dialog to update the static text stc1
   {
       wsprintf(LViewMsg," 64 x 64  %-8s  Scale %2hd      %-46.46s",
                picname,magnify,FlatWad.filename);

       PostMessage(hwnd, WM_COMMAND, WM_CHANGE ,0);   // tell dialog
   }

   FlatImageSize = mag64 * mag64;

   ImageXSize = 64;  // global for SavePCX (assumes mag = 1)
   ImageYSize = 64;

   hdcMem = CreateCompatibleDC(hdc);

   // 3-31-97 bk Minor mods here and above
   if (ImageSize)
   {   *ImageSize = FlatImageSize;    //++
   }

   if (!ImageBufr)
   {
    	// Set up a BITMAPINFO structure for use with CreateDIBSection()
    	ZeroMemory(&DibBitMapInfo, sizeof(BITMAPINFO));
    	DibBitMapInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    	DibBitMapInfo.bmiHeader.biPlanes     = 1;
    	DibBitMapInfo.bmiHeader.biBitCount   = 8;
    	DibBitMapInfo.bmiHeader.biWidth      =  mag64;
    	DibBitMapInfo.bmiHeader.biHeight     = -mag64;   //   5-1-97
		DibBitMapInfo.bmiHeader.biSizeImage  = FlatImageSize;//((FlatImageSize + 3 ) & ~3); // DWORD align the Size x * y
    	DibBitMapInfo.bmiHeader.biCompression= BI_RGB;

    	// Create a DC to hold our DIBSECTION
    	hDib = (HBITMAP)CreateDIBSection(hdc, &DibBitMapInfo, DIB_PAL_COLORS, (VOID **)&lpBits, NULL, 0L);

      if (!hDib)                                 // not enough memory         1-10-97 bk
      {
         if (!RawData)  FreeMemory( RawWrkData ); // free data buffer if not allocated by caller   6-1-97
         ErrorMsg(hwnd, "DisplayFlat Unable to create a Valid DIBSECTION");
         DeleteDC(hdcMem);
         hDib 	 = NULL;
         lpBits = NULL;
         return -1;
      }

    	WrkPtr = (byte *)(VOID **)&*lpBits;	       // Grab pointer to the bits of our DIBSection
   }

   hOldBitmap  = SelectBitmap(hdcMem, hDib);	    // Select into our Memory Dc
   SetDIBColorTable(hdcMem, 0, 256, dRGBquad);	 // Palette indexes

/*      ...NOTE... I think original method might be easier               <<<<<<<<<<<<<<<<
       this code always allocates image and dib and passes back to user
       so then user doesn't have to do it.  Looks like a minor change, later...
   if (ImageBufr)
   {   *ImageBufr = WrkPtr;                // tell user where it is
   }

   if (!gd.hDibbm)                            // not enough memory
   {
        if (ImageSize)
        {   *ImageSize = 0;             //++
        }

        FreeMemory( RawWrkData );                   // free data buffer
        if (RawData)
        {  *RawData = NULL;
        }
        if (RawSize)
        {   *RawSize = 0;        //++
        }
	return -1;
   }
*/

   // automatically center image

   xstart = (xstart+ xwidth /2 - mag64/2);        // center x
   ystart = (ystart+ yheight/2 - mag64/2);        // center y

   if (xstart < 0) xstart = 0;
   if (ystart < 0) ystart = 0;

   // erase the last area used if it was active

   if ( (mag64 != LastPicXsize ||  mag64 != LastPicYsize)  // size differ
     &&  ShowImage                                         // show image
     && LastPicXloc != -1)                                 // not first time
   {
        SetRect(&rc, LastPicXloc, LastPicYloc, LastPicXloc+LastPicXsize, LastPicYloc+LastPicYsize);
        FillRect(hdc, &rc, gd.hBrushes[MenuColor]);//   5-1-97
   }

   // automatically center image
   y=0;

   for (k=0; k< 64; k++, y+=magnify)   // Y
   {
        WrkImagePtr = RawWrkData + k*64;  // current data loc
        PixelOffset = y*mag64;            // 16 buffr cntl +Y
        x = 0;
        for (l=0; l < 64; l++, x+=magnify,WrkImagePtr+=1)// X
        {    MagColor = *WrkImagePtr;
             for (m=0; m < magnify; m++)   //y expand
	          {   for (n=0; n< magnify; n++)//x expand
	              {
                   //  8-1-97 can't happen
	                //if( PixelOffset+ (m*mag64) +(x+n) >= (mag64*mag64)) break;
                   WrkPtr[ PixelOffset+ (m*mag64) +(x+n)]=MagColor;
	              }
	          }
        } // end x
   } //end y


   if (ShowImage)
   {
       OrgXstart = xstart;
       OrgYstart = ystart;
       OrgXend   = xstart+mag64 -1;
       OrgYend   = ystart+mag64 -1;

       LastPicXloc  = xstart;
       LastPicYloc  = ystart;
       LastPicXsize = mag64;
       LastPicYsize = mag64;
       DisplayMagnify = magnify;   //tell um what size used   6-1-97

 	    BitBlt(hdc, xstart, ystart, mag64, mag64, hdcMem, 0, 0, SRCCOPY);
  	    GdiFlush();
   }

   // free buffer data if user doesn't want
   if (!RawData)
   {   FreeMemory(RawWrkData);
       if (RawSize)
       {   *RawSize = 0;        //++
       }
   }

   // No supplied Dib - means we made our own, so free it up

   if (!ImageBufr)
   {
      if (hDib)
      {
        if(hOldBitmap)  SelectBitmap(hdcMem, hOldBitmap); //   note to myself has to be done here
        if(hdcMem)      DeleteDC(hdcMem);
        hOldBitmap = NULL;
        hdcMem     = NULL;

        DeleteBitmap(hDib);
        hDib 	    = NULL;
        lpBits 	 = NULL;
      }

      if (ImageSize)
      {   *ImageSize = 0;
      }
   }
   // SAFETY
   if(hOldBitmap)  SelectBitmap(hdcMem, hOldBitmap);
   if(hdcMem)      DeleteDC(hdcMem);
   hOldBitmap = NULL;
   hdcMem     = NULL;
   return TRUE;
}

//--------------------------------------------------------------------------------
// display graphic -- buffer is allocated if not done yet
//
// If user supplied Dib pointer and Handle will return same to user
// after filling data buffer with graphic texture and NOT displaying
//
// 1-1-97 bk
//
// 3-31-97 bk  mods to routine
// 4-1-97    changed global names slightly make it clearer
//   if (ImageBufr playing 8-1-97 didn't work
//   &&  hDibbm
//   &&  magnify == 1)  // temp way to override sizes for drawing change size   8-1-97
//   {
//       GetObject(hDibbm, sizeof(BITMAP), &bm);
//       xOrge = bm.bmWidth  ;
//       yOrge = bm.bmHeight ;
//   }
//   else
//--------------------------------------------------------------------------------
#pragma argsused
int2 DisplayGraphicTexture(HWND hwnd, HDC hdc, Bool Master,
                           int2  xstart,int2 ystart,
                           int2  xend,  int2 yend,
                           int4 *RawSize,
                           byte**RawData,
                           int4 *ImageSize,  // imagesize
                           byte**ImageBufr,  // Pointer to Dib bits
                           HBITMAP hDibbm,   // Handle to Dib Bitmap
                           char *picname,
                           int2  magnify,
                           Bool  ShowInfo,
                           int2  fillcolor,   // actual 0-255 color, not indexed   5-1-97
                           Bool  ShowImage)
{
register x,y;                 //
//static WadFiles       PicWad;      // the texture directory (usually MasterWad)

   int4  ThisImageSize;
   int4  n,i,k,l;         //
   int4  xwidth = (xend - xstart +1);
   int4  yheight= (yend - ystart +1);
   // 3-31-97 bk
   //int4  WrkImageSize=-1;    // size required to hold screen buffer
   int2   filenum;
   DirPtr dir;                //

   byte  MagColor;            //
   byte *RawWrkData = NULL;
   int4  RawWrkSize = -1;
   int4  PixLoc;              //
   int4  CurrentX;            // 2
   int4  xOrge,yOrge;         // 2
   int4  magXalign;         // precalc actual image size (round even row?)
   int4  magXadjust;          // precalc actual image size
   int4  magYadjust;

// BITMAP bm;

   static RECT  rc;
	static HDC 			hdcMem     = NULL;
	static HBITMAP		hOldBitmap = NULL;
	static HBITMAP		hDib       = NULL;
   static byte *     WrkPtr     = NULL; // used to be tPtr Pointer to Dib bits

   //--------------------------------------------------------------------
   // get old buffer if any

   if (RawData)
   {
      RawWrkData= *RawData;     //5-3-96 address of prior
      if (!RawWrkData)
       {   if ( RawSize)
           {   *RawSize = 0;         // none allocated
           }
       }
       else
       if (RawSize)
       {   RawWrkSize=  *RawSize;    //5-3-96 size of prior
       }
   }


   // get old image buffer if any
   if (ImageBufr)
   {
       WrkPtr = *ImageBufr;	 // Grab pointer to the bits of our DIBSection
       hDib = hDibbm;          // Handle to the bitmap
       //if (! WrkPtr)         // How could this be ? 1-1-97 bk (mistake by user, could happen   3-1-97++  8-1-97 we can't screw up
       //{   if (ImageSize)
       //    {   *ImageSize = 0;                   // none allocated
       //    }
       //}
       //else            3-31-97 bk
       //if (ImageSize)
       //{   WrkImageSize=  *ImageSize;            //size of prior negative if DIB
       //}
   }

   dir = FindMasterDir( MasterWad, picname,FALSE);
   if (!dir) return 0;

   if (dir->size          <=  0 ) return 0;      // no size
   if (!Master)
   {   if (dir->filenumber == 0 ) return 0;      //  master wad
   }

   GraphicDirstart = dir->start;                 // start of entry
   GraphicDirsize  = dir->size;
   filenum  = dir->filenumber;

   if (filenum != oldfilenum )
   {   CloseWadFiles('O',FREEDIRNO,FREENAMENO);  // close all
       oldfilenum = filenum;
   }

   SetActiveWad(&GraphicWad,dir->filenumber);    // was Picwad

   WadSeek( GraphicWad.fileinfo, GraphicDirstart  ); // seek start of entry
   WadRead( GraphicWad.fileinfo, &ImageHeader,12);   // x width, y height, xoff,yoff,1stYoffset

   // see if image is within specs

   if (!DoomGraphicVerify(&ImageHeader,GraphicDirsize) )
   {   return -2;
   }

   if (!RawWrkData || RawWrkSize != dir->size)   // all 4096
   {
       RawWrkSize = dir->size;           // size of whole image
       if (RawSize)
       {   *RawSize = RawWrkSize;        //++
       }

       FreeMemory(RawWrkData);                              // free prior data buffer
       RawWrkData = (byte *)malloc( RawWrkSize);                 // allocate memory needed
       if (RawData)
       {   *RawData = RawWrkData;        //++
       }

       if (!RawWrkData)
       {
           if (RawSize)
           {   *RawSize = 0;        //++
           }
           return -1;                         // allocation failed
       }

       WadSeek( GraphicWad.fileinfo, GraphicDirstart);
       WadRead( GraphicWad.fileinfo, RawWrkData, RawWrkSize); //columndata
   }

   // dynamic create size of image from xsize if auto-=center
   // get size of the buffer to store image in

   magXadjust = ImageHeader.xsize*magnify;
   magYadjust = ImageHeader.ysize*magnify;

   // now adjust so it fits in the window only if image is displayed

   if (ShowImage)
   {
       while (magXadjust > xwidth || magYadjust > yheight)
       {     magnify--;
	          magXadjust = ImageHeader.xsize*magnify;
	          magYadjust = ImageHeader.ysize*magnify;
       }
   }

   if (magnify <= 0)
   {   magnify = 1;
       magXadjust = xwidth;
       magYadjust = yheight;

       if (ImageHeader.xsize < xwidth)  magXadjust = ImageHeader.xsize;
       if (ImageHeader.ysize < yheight) magYadjust = ImageHeader.ysize;
   }

   //---------hack------------

   if (ShowInfo)  // Post a message to the dialog to update the static text
   {
       wsprintf(LViewMsg, "%4hd x %-4hd  %-8s  Scale %2hd   %-46.46s",
            			     ImageHeader.xsize,ImageHeader.ysize,picname, magnify,GraphicWad.filename);

       PostMessage(hwnd, WM_COMMAND, WM_CHANGE ,0);
   }

   ImageXSize = ImageHeader.xsize;      // global for SavePCX assumes mag = 1
   ImageYSize = ImageHeader.ysize;

   magXalign=( magXadjust + 3 ) & ~3; // DWORD Aligned

   ThisImageSize = magXalign * magYadjust;

   hdcMem = CreateCompatibleDC(hdc);

   // 3-31-97 bk  Minor mods here and above
   if (ImageSize)
   {   *ImageSize = ThisImageSize;    //++
   }

   // 3-31-97 bk

   if (!ImageBufr)
   {
    	// Set up a BITMAPINFO structure for use with CreateDIBSection()
    	ZeroMemory(&DibBitMapInfo, sizeof(BITMAPINFO));
    	DibBitMapInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    	DibBitMapInfo.bmiHeader.biPlanes     = 1;
    	DibBitMapInfo.bmiHeader.biBitCount   = 8;
    	DibBitMapInfo.bmiHeader.biWidth      =  magXadjust; //  5-1-97 magXalign;
    	DibBitMapInfo.bmiHeader.biHeight     = -magYadjust;
		DibBitMapInfo.bmiHeader.biSizeImage  =  magXalign * magYadjust;
    	DibBitMapInfo.bmiHeader.biCompression= BI_RGB;

    	// Create a DC to hold our DIBSECTION
    	hDib = (HBITMAP)CreateDIBSection(hdc, &DibBitMapInfo, DIB_PAL_COLORS, (VOID **)&lpBits, NULL, 0L);

      if (!hDib)                                   // not enough memory
      {
          if (!RawData)  FreeMemory( RawWrkData ); // free data buffer if not allocated by caller   6-1-97
          ErrorMsg(hwnd, "DisplayTexture Unable to create a Valid DIBSECTION");
          DeleteDC(hdcMem);
          hDib 	 = NULL;
          lpBits   = NULL;
          return  -1;
      }

    	WrkPtr = (byte *)(VOID **)&*lpBits;	         // Grab pointer to the bits of our DIBSection
   }


   hOldBitmap  = SelectBitmap(hdcMem, hDib);	      // Select into our Memory Dc
  	SetDIBColorTable(hdcMem, 0, 256, dRGBquad);	   // Palette indexes
   FillMemory(WrkPtr, ThisImageSize, fillcolor);   //   5-1-97 fill with background

   /*
   if (ImageBufr)
   {   *ImageBufr = WrkPtr;                // tell user where it is
   }

   if (!WrkPtr)                            // not enough memory
   {
        if (ImageSize)
        {   *ImageSize = 0;             //++
        }

        FreeMemory( RawWrkData );                   // free data buffer
        if (RawData)
        {  *RawData = NULL;
        }
        if (RawSize)
        {   *RawSize = 0;        //++
        }
        // 12-30-96 bk  Clean Up !
        if(hOldBitmap)  SelectBitmap(hdcMem, hOldBitmap);// just keep happy now
        hOldBitmap      = NULL;
        DeleteBitmap(hDib);
        hDib 	   = NULL;
        lpBits 		   = NULL;
        if(hdcMem)      DeleteDC(hdcMem);
        hdcMem          = NULL;

        return -1;
   }

*/

   // automatically center image

   xstart = xstart+xwidth /2 - magXadjust/2;         // center x
   ystart = ystart+yheight/2 - magYadjust/2;         // center y

   if (xstart < 0) xstart = 0;
   if (ystart < 0) ystart = 0;

   // erase the last area used if it was active
   // 2-20-97 bk
   if ( (magXadjust != LastPicXsize ||  magYadjust != LastPicYsize)   // sizes differ
     &&  ShowImage                                                    // show image
     &&  LastPicXloc != -1)                                           // not first time
   {
        //Trace(hwnd,10,10,"%hd,%hd",LastPicXsize,LastPicYsize);
        SetRect(&rc, LastPicXloc, LastPicYloc, LastPicXloc+LastPicXsize, LastPicYloc+LastPicYsize);
        FillRect(hdc, &rc, gd.hBrushes[MenuColor]);//   5-1-97
   }

   // automatically center image

   xOrge  = magXadjust;
   yOrge  = magYadjust;

   // image is displayed for each Y column, then move to next X, etc.

   Yoffsets      = (int4 *)&RawWrkData[0] + 2;                 // 1st Y offset start

   // Do X first -----------------------------------------------------------------

   for (CurrentX = 0; CurrentX < ImageHeader.xsize ; CurrentX++)
   {
     Yorigin  = (byte *) &RawWrkData[0] +  Yoffsets[CurrentX]; // start of column

     // we now have the needed (Y) column data - display it

     n            = 1;
     YcolumnStart = Yorigin[0];         // y origin start

     x = magnify*CurrentX;          // origin + current x loc

     // display a line of pixels for height (xofs,yofs assembles composites)
     // Y is not continous, can skip for transparent areas

     if ( x < xOrge )                   // x <  right side
     {
       while (YcolumnStart != 255 )
       {
          // resync Y origin

	       y = magnify*YcolumnStart;      // set start of y

	       YdataBytes = Yorigin[n];       // # of vertical data bits (byte)

	       n += 2;                        // skip over 'null' pixel in data

	       PixelPtr = Yorigin+n;          // address 1st pixel color

	       // Y direction---------------------------------------------------------

	       for (i = 0; i < YdataBytes && y < yOrge; i++, PixelPtr++, y+=magnify)
	       {
	          //if (y < 0) continue;    // can't happen
	          MagColor = *PixelPtr;                       // original data location

	          for (k=0; k< magnify; k++)             //y
	          {
		          if (y+k >= yOrge) break;

                //Trace(gd.hMainWindow, 300,6,"PixLoc=%d, Size=%d",PixLoc,ThisImageSize);
                PixLoc = (((y+k)*magXalign)+ x);

                for (l=0; l< magnify; l++)        //x
		          {
		             if ( (x+l) >= xOrge) break;

                   if(PixLoc > ThisImageSize)     break; // safety !

                   WrkPtr[PixLoc] = MagColor;
                   PixLoc ++;
		          }
	          }
	       }
	       n += YdataBytes + 1;          // skip over written pixels, and the 'null' one

	       YcolumnStart = Yorigin[n++];  // next y origin
       }
     }
   }


   if (ShowImage)
   {
       OrgXstart = xstart;
       OrgYstart = ystart;
       OrgXend   = xstart+magXadjust -1;
       OrgYend   = ystart+magYadjust -1;

       LastPicXloc  = xstart;
       LastPicYloc  = ystart;
       LastPicXsize = magXadjust;
       LastPicYsize = magYadjust;
       DisplayMagnify = magnify;   //tell um what size used   6-1-97

 	    BitBlt(hdc, xstart, ystart, magXadjust, magYadjust,hdcMem, 0, 0, SRCCOPY);
  	    GdiFlush();

     //  putimage(xstart,ystart,WrkImageBufr,COPY_PUT);
   }

   // free buffer data if user doesn't want
   if (!RawData)
   {   FreeMemory(RawWrkData);
       if (RawSize)
       {   *RawSize = 0;        //++
       }
   }

   // No supplied Dib - means we made our own, so free it up
   if (!ImageBufr)
   {
      if (hDib)
      {
        if(hOldBitmap)  SelectBitmap(hdcMem, hOldBitmap);  // has to be done first note to myself   6-1-97
        if(hdcMem)      DeleteDC(hdcMem);
        hOldBitmap = NULL;
        hdcMem     = NULL;

        DeleteBitmap(hDib);
        hDib 	    = NULL;
        lpBits 	 = NULL;
      }

      if (ImageSize)
      {   *ImageSize = 0;
      }
   }
   // SAFETY
   if(hOldBitmap)  SelectBitmap(hdcMem, hOldBitmap);
   if(hdcMem)      DeleteDC(hdcMem);
   hOldBitmap = NULL;
   hdcMem     = NULL;
   return TRUE;

}


//////////////////////////////////////////////////////////////////////
//
//		Called from Info window to show the Current thing
//
/////////////////////////////////////////////////////////////////////

#pragma argsused
void DisplayThingPic (HDC hdcThing, int2 xstart, int2 ystart, int2 xend, int2 yend,
							char *picname, int2 xoffset,int2 yoffset,int2 magnify)
{
static int2  xsize=0;
static int2  ysize=0;
static int2  showX;
static int2  showY;

static DirPtr   dir=NULL;    //
static WadFiles PicWad;      // the texture directory (usually MasterWad)

static PatchAreaList *PatchAreaWrk;  // list of resident texture names,x y, #pathes
//---------------------------------------------------------------------------------

   if (xend >=0)   // not self-centering
   {
     PatchAreaWrk = ThingCache(picname);   // look for it and save it if new

     if (PatchAreaWrk)
     {
         xsize = PatchAreaWrk->pic.xsize;                 // x width
	      ysize = PatchAreaWrk->pic.ysize;                 // y height
     }
     else
     {   dir = FindMasterDir( MasterWad, picname,FALSE);  // find this patch
	      if (dir)                                         // found!!!
	      {
	         SetActiveWad(&PicWad,dir->filenumber);        // where patch is
	         WadSeek( PicWad.fileinfo, dir->start);        // start of patch
	         WadRead( PicWad.fileinfo, &xsize,4);          // 4 x width , y height
	      }
	      else
	      {
	         return;                                       //?? not found
	      }
     }

     showX = (xend-xstart);              // X width
     showY = (yend-ystart);              // Y height

     xoffset =( (showX - (xsize*magnify) )/2 +xoffset )/ magnify;
     yoffset =( (showY - (ysize*magnify) )/2 +yoffset )/ magnify;

     if (yoffset < 0) yoffset = 0;
   }

   DisplayPic(hdcThing, xstart,  ystart,
                        xend, yend, NULL, picname,
	                     xoffset, yoffset, magnify,InfoBoxColor,NOCENTER); //  11-7-96

}


//----------------------------------------------------------------------//
//   ----FlatWad----
//   display a floor or ceiling texture at coords xstart, ystart and not beyond xend, yend
//----------------------------------------------------------------------//

int2 DisplayFloorTexture(HDC hdc, int2 xstart, int2 ystart, int2 xend, int2 yend, char *texname, int2 magnify)
{
    DirPtr dir;             // main directory pointer to the texture entry
    byte  *FlatPixels;      // array of pixels that hold the image
    byte  *FlatOrg;
    byte  *FlatAddr;
    int4   PixelOffset;

    int4   x,y;
    int4   mag64;           // 64 * magnify precalc for expansion

    byte    MagColor;          // store pixel here
    register m,n,k,l;


    HPEN		hOldPen;
    HDC		hdcMem;
    HBITMAP hOldBitmap;

static WadFiles FlatWad;

//--------------------------------------------------------------------------

   dir = FindMasterDir( MasterWad, texname,FALSE);

   if (dir == NULL)                     // nothing found
   {
     hOldPen = SelectPen(hdc, gd.hPens[RED]);
	  MoveToEx(hdc, xstart+2, ystart+2, NULL);
     LineTo(hdc, xend-2, yend-2);
	  MoveToEx(hdc, xstart+2, yend-2, NULL);
     LineTo(hdc, xend-2, ystart+2);
     SelectPen(hdc, hOldPen);
     return 0;
   }

   SetActiveWad(&FlatWad, dir->filenumber);

   WadSeek( FlatWad.fileinfo, dir[0].start);            // start of entry

   FlatPixels  = (byte *)GetMemory( 4096 * sizeof( char));      // 4096
   WadRead( FlatWad.fileinfo, FlatPixels, 4096);        // all floors <=4k

   mag64       = (magnify*64);

   ZeroMemory(&DibBitMapInfo, sizeof(BITMAPINFO));
   DibBitMapInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
   DibBitMapInfo.bmiHeader.biPlanes    = 1;
   DibBitMapInfo.bmiHeader.biBitCount  = 8;
   DibBitMapInfo.bmiHeader.biWidth     =  mag64;
   DibBitMapInfo.bmiHeader.biHeight    = -mag64;                   //   5-1-97
   DibBitMapInfo.bmiHeader.biSizeImage = (mag64 * mag64);
   DibBitMapInfo.bmiHeader.biCompression = BI_RGB;

   // Create a DC to hold our DIBSECTION
   hdcMem = CreateCompatibleDC(hdc);

   // Create a DIBSECTION to draw into
   gd.hDibbm = (HBITMAP)CreateDIBSection(hdc, &DibBitMapInfo, DIB_PAL_COLORS, (VOID **)&lpBits, NULL, 0L);
   if (gd.hDibbm)
   {
      tPtr = (byte *)(VOID **)&*lpBits;	// Grab pointer to the bits of our DIBSection

      hOldBitmap  = SelectBitmap(hdcMem, gd.hDibbm);   	// Select into our Memory Dc
    	SetDIBColorTable(hdcMem, 0, 256, dRGBquad);			// Palette indexes

      if (magnify == 1)
      {   memcpy(tPtr,FlatPixels,4096);
      }
      else
      {
         y=0;

         for (k=0; k< 64; k++, y+=magnify)                 // Y
         {
	         FlatPixelPtr = FlatPixels + k*64;             // current data loc
	         PixelOffset  = y*mag64;

            x = 0;
	         for (l=0; l < 64; l++, x+=magnify,FlatPixelPtr+=1)  // X
            {
	             MagColor = *FlatPixelPtr;
	             FlatOrg  =  tPtr+PixelOffset+x;   // stuff to speed up

	             for (m=0; m < magnify; m++)         //y expand
	             {   FlatAddr = FlatOrg + m*mag64;
	                 for (n=0; n< magnify; n++)       //x expand
	                 {
	                    //if( PixelOffset+ (m*mag64) +(x+n) >= (mag64*mag64))  break;  //   8-1-97 can't be
	                    FlatAddr++[0] = MagColor;
	                 }
	             } // end magnify

            } // end x
         }   //end y
      }

    	BitBlt(hdc, xstart, ystart, xend - xstart, yend - ystart, hdcMem, 0, 0, SRCCOPY);
    	GdiFlush();

    	if (hOldBitmap) SelectBitmap(hdcMem, hOldBitmap);
      DeleteBitmap(gd.hDibbm);
      gd.hDibbm 	= NULL;
      lpBits 		= NULL;
    	DeleteDC(hdcMem);
   }

   FreeMemory( FlatPixels);
   return dir->filenumber;
}


//----------------------------------------------------------------------//

void DisplayWallTexture(HDC hdc, int2 xstart, int2 ystart, int2 xend, int2 yend, char *texname)
{    DisplayATexture(hdc, xstart, ystart, xend, yend,0,0, texname, NULL);  // show size
}


//----------------------------------------------------------------------//
//   display a wall texture ("texture1" or "texture2" object) at coords xstart, ystart
//   if showsize = x07fff do not show texture size
//----------------------------------------------------------------------//

int2 DisplayATexture(HDC hdc,  int2 xstart, int2 ystart,
                               int2 xend,   int2 yend,
		                         int2 xoffset,int2 yoffset,
                               char *texname,char *showtext)
{
   int2     n;              // general counter
   int2     xoffset1=0;
   int2     xoffset2=0;
   int2     yoffset1=0;
   int2     yoffset2=0;

   int2     xofs;            // offset in texture space for the wall patch
   int2     yofs;            // offset .....
   int2     pnameind;        // patch name index in PNAMES table

static  WadFiles TextureWad;      // the texture directory (usually MasterWad)
   int2     xsize;           // width in pixels of texture
   int2     ysize;           // height in pixels of texture
   int2     patchnum;        // number of wall patches used to build this texture
   byte    *texofs;          // offset in the wad file to the texture data

   byte    *saveofs;         // offset in the wad file to the texture data

   char     picname[9] ={0}; // wall patch name

   int4     magXadjust, magXalign, magYadjust;

   int2     filenumber = 0;
//---------------------------------------------------------------------------

   HBITMAP  hOldBitmap;
   HFONT		hOldFont;
   HDC		hdcMem;
	int2		wt2 	= 8;		// text width & height  gd.LargeTextHeight etc. later
//   int2		ht2	= 10;

//---------------------------------------------------------------------------


   // get basic info on picture - also opens up TextureWad-------------------

   if ( !GetWallTextureSize( &TextureWad,
                             &xsize,    &ysize,
                  		     &patchnum, &texofs,texname) ) return 0;

   // adjust xoffset by max
//
   if (xoffset || yoffset)
   {
       xoffset1  = xoffset%xsize;

       if (xoffset1 < 0)
       {   xoffset1  = (xsize + xoffset1);    //++    width - offset
       }
       xoffset1  = (xsize - xoffset1);        //++    width - offset
       xoffset2  = (xoffset1-xsize);          // eg if x1 = 32, width = 128, x2 = -

       yoffset1  = (yoffset%ysize);           //++8-24-95 modulo
       if (yoffset1 < 0) yoffset1 += 128;
       yoffset1  =-(yoffset1%ysize);          //128 -
        //------------ yoffset1  =-yoffset; test

       if (yoffset1)
       {   yoffset1 += 128;
           yoffset1 %= ysize;
	        yoffset2  = (yoffset1-ysize);
       }
       else
       {   yoffset2 = 0;
       }
   }

   // adjust yoffset by max


   // show what size this image is (and first name)---------------------------

   if (showtext == NULL)
   {
       DisplayImageSize(hdc, xstart,(yend+1),xsize,ysize);

       // Only 1 patch is permitted on 2-sided textures... if see through really

       if (patchnum > 1)
       {   SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));  //RED]) ); too hard to see   12-16-96
           DrawScreenText(hdc, (xstart+wt2*18), (yend+3),"%hd patches", patchnum);
       }
       else
       {   SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));  //RED]) ); too hard to see   12-16-96
           DrawScreenText(hdc, (xstart+wt2*18), (yend+3),"TRANS for 2-Sided");
       }
   }
   else
   {   if (showtext[0] != '+')                    // special don't do anything
       {
  	        hOldFont = SelectFont(hdc, gd.hMedFont);
  	        SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));
	        TextOut(hdc, xstart, yend+11, showtext, lstrlen(showtext) );
		     SelectFont(hdc, hOldFont);
       }
   }

   // buffer dimensions required---------------------------

   magXadjust   =   (xend-xstart+1);
	magXalign  =   (magXadjust + 3) & ~3;
   magYadjust   =   (yend-ystart+1);

   ZeroMemory(&DibBitMapInfo, sizeof(BITMAPINFO));
   DibBitMapInfo.bmiHeader.biSize       = sizeof(BITMAPINFOHEADER);
 	DibBitMapInfo.bmiHeader.biPlanes     = 1;
 	DibBitMapInfo.bmiHeader.biBitCount   = 8;
 	DibBitMapInfo.bmiHeader.biWidth      =  magXadjust;//   5-1-97 magXalign;  // DWORD align the Size x * y
 	DibBitMapInfo.bmiHeader.biHeight     = -magYadjust;
   DibBitMapInfo.bmiHeader.biSizeImage  = (magXalign *  magYadjust); //   5-1-97 magXadjust (old was rounded)
   DibBitMapInfo.bmiHeader.biCompression= BI_RGB;

   // Create a DC to hold our DIBSECTION
   hdcMem = CreateCompatibleDC(hdc);

   // Create a DIBSECTION to draw into
   gd.hDibbm = (HBITMAP)CreateDIBSection(hdc, &DibBitMapInfo, DIB_PAL_COLORS, (VOID **)&lpBits, NULL, 0L);

   if (gd.hDibbm)
   {
      FillMemory(&*lpBits, DibBitMapInfo.bmiHeader.biSizeImage, GameColors[InfoBoxColor]);//DARKGRAY]);  11-7-96

      hOldBitmap  = SelectBitmap(hdcMem, gd.hDibbm);	// Select into our Memory Dc
	   SetDIBColorTable(hdcMem, 0, 256, dRGBquad);	  	// Palette indexes

      //--------------------------------------------------------------------
      // display the texture composite
      //--------------------------------------------------------------------

      // All Textures are in resident buffers Texture1/2
      // pick up all the patch names for this texture

      texofs += TcontrolSize;                    // skip name and control info 22 or 18
      saveofs = texofs;                          // remember

      // display with offset

      for (n = 0; n < patchnum; n++)
      {
	      xofs     = ((int2*)texofs)[0]+xoffset1; //   2-11-97
	      yofs     = ((int2*)texofs)[1]+yoffset1;
	      pnameind = ((int2*)texofs)[2];
         texofs  += PcontrolSize;                // each entry is 10 or 6

         strncpy(picname,PatchPnameBuffer[pnameind].name,8);

         filenumber = DisplayPic(hdc, -1,-1,
                                      xsize,ysize,
                                      (char *)lpBits,
                                      strupr( picname),
		                                xofs, yofs,
                                      PicMagnify,
                                      InfoBoxColor, NOCENTER);      // right iwad = -1 forgot

      }

      if (xoffset1 )                             // Bottom LEFT Quadrant
      {
         texofs = saveofs;                       // remember

         for (n = 0; n < patchnum; n++)
         {
	         xofs     = ((int2*)texofs)[0]+xoffset2;
	         yofs     = ((int2*)texofs)[1]+yoffset1;
	         pnameind = ((int2*)texofs)[2];
	         texofs  += PcontrolSize;             // each entry is 10 or 6

	         strncpy(picname,PatchPnameBuffer[pnameind].name,8);

	         DisplayPic(hdc, -1,-1,
                           xsize,ysize,
                           (char *)lpBits,
                           strupr( picname),
			                  xofs, yofs,
                           PicMagnify,
                           InfoBoxColor,NOCENTER);    //  11-7-96

         }
      }

      if (yoffset1 )
      {
         texofs = saveofs;                            // remember

         for (n = 0; n < patchnum; n++)               // Top Right Quadrant
         {
	         xofs     = ((int2*)texofs)[0]+xoffset1;
	         yofs     = ((int2*)texofs)[1]+yoffset2;
	         pnameind = ((int2*)texofs)[2];
	         texofs  += PcontrolSize;                  // each entry is 10 or 6

	         strncpy(picname,PatchPnameBuffer[pnameind].name,8);

	         DisplayPic(hdc, -1,-1,
                           xsize,ysize,
                           (char *)lpBits,
                           strupr( picname),
			                  xofs, yofs,
                           PicMagnify,
                           InfoBoxColor,NOCENTER);    //  11-7-96

          }

          texofs = saveofs;                   // remember

          for (n = 0; n < patchnum; n++)      // Top LEFT Quadrant
          {
	          xofs     = ((int2*)texofs)[0]+xoffset2;
	          yofs     = ((int2*)texofs)[1]+yoffset2;
	          pnameind = ((int2*)texofs)[2];
	          texofs  += PcontrolSize;         // each entry is 10 or 6

	          strncpy(picname,PatchPnameBuffer[pnameind].name,8);

	          DisplayPic(hdc, -1,-1,
                             xsize,ysize,
                             (char *)lpBits,
                             strupr( picname),
			                    xofs, yofs,
                             PicMagnify,
                             InfoBoxColor,NOCENTER);   //  11-7-96

          }
      }
//
    	BitBlt(hdc, xstart, ystart, magXadjust, magYadjust, hdcMem, 0, 0, SRCCOPY); //   5-1-97 magXalign
 	   GdiFlush();	// Make sure we get this frame displayed now!

    	if (hOldBitmap)SelectBitmap(hdcMem, hOldBitmap);
      DeleteBitmap(gd.hDibbm);
      gd.hDibbm 	= NULL;
      lpBits 		= NULL;
    	DeleteDC(hdcMem);
   }

   return filenumber;

}

//--------------------------------------------------------------------------
//  ShowWallTexture (for constant display on edit screen)
//--------------------------------------------------------------------------

void ShowWallTexture(HDC hdc, int2 xstart,int2 ystart,int2 tpicsize,char *texname,char *infotext)
{
	HFONT hOldFont;
	RECT rc;

   int2 oldMagnify = PicMagnify;

   PicMagnify = 0;                              // make it 1/2 size
   rc.left 	= xstart;
   rc.top	= ystart;
   rc.right = xstart+tpicsize+2;
   rc.bottom= ystart+tpicsize+2;

   DrawScreenBox3D(hdc, xstart, ystart, int2(xstart+tpicsize+4), int2(ystart+tpicsize+4),gd.hBrushes[InfoBoxColor]);//[MenuColor] );  11-7-96

   if  (texname != NULL && texname[0] != '-')
   {    DisplayATexture( hdc, (xstart+2),          (ystart+2),
                              (xstart+2+tpicsize),	(ystart+2+tpicsize),
                               0, 0, texname, "+");
   }
   else
   {
  		hOldFont = SelectFont(hdc, gd.hLargeFont);
  		SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));
      SetBkMode(hdc, TRANSPARENT);
		TextOut(hdc, xstart+16, ystart+tpicsize-14, infotext, lstrlen(infotext) );
		SelectFont(hdc, hOldFont);
   }

   PicMagnify = oldMagnify;
}

//----------------------------------------------------------------------//
//  Get the size of a wall texture
//
//  format of TEXTURE1     Number of offsets         4
//                         offset to texture name1   4 from start of TEXTURE1
//                         offset to texture name2   4
//                         ...... etc
//
//                         texturename1 8 (for a typical offset entry)
//                           ....       4
//                         x width      2 at +12
//                         y height     2 at +14
//                           ....       4
//                         #patches     2 at +20 total = 22  (at 16 for strife=+18)
//
//----------------------------------------------------------------------//

Bool GetWallTextureSize(WadFiles *WTextureWad,
                        int2 *Wxsize,  int2 *Wysize,
								int2 *Wpatch,  byte **Woffset,char *texname)
{
   int4 n;                 // general counter

   Bool Found=FALSE;

   char *TextureOffset;    // offset in TextureBuffer for start of Texture Name

//-------------------------------------------------------------------------


   // search for texname in texture1 names

   if  (texname[0] == '-') return FALSE;

   // if first time allocate the offsets

   if (!Texture1Buffer)   BuildTextureBuffer();
   if (!PatchPnameBuffer) BuildPnameBuffer();

   // search resident TEXTURE1 data for names

   for (n = 0; n < TextureNum1 ; n++)
   {
       TextureOffset  = (char *)Texture1Buffer +((int4*)Texture1Buffer)[n+1]; // where in buffer

       if (!strnicmp( TextureOffset, texname, 8))           // name found
       {
          Found=TRUE;
	      *Woffset =  (byte *)TextureOffset;
	      *Wxsize  = ((int2 *)TextureOffset)[6];            // X width      +12
	      *Wysize  = ((int2 *)TextureOffset)[7];            // Y height     +14
	      *Wpatch  = ((int2 *)TextureOffset)[PpatchNum];    // #patches     +16 or +20
	      CopyLevelInfo(WTextureWad, &TextureWad1);         // return assign to texturewad
	      break;
       }
   }

   // if not found search for texname in texture2 names (only Doom1 reg)

   if (!Found)
   {
      // search resident array for names

      if (Texture2Buffer)                                  // have Texture2
      {
        for (n = 0; n < TextureNum2 ; n++)
        {
	       TextureOffset = (char *)Texture2Buffer +((int4*)Texture2Buffer)[n+1];    // where in buffer

	       if (!strnicmp( TextureOffset, texname, 8))       // name found
	       {
		       Found=TRUE;
	          *Woffset =  (byte *)TextureOffset;
	          *Wxsize  = ((int2 *)TextureOffset)[6];        // X width      +12
	          *Wysize  = ((int2 *)TextureOffset)[7];        // Y height     +14
             *Wpatch  = ((int2 *)TextureOffset)[PpatchNum];// #patches     +16 or +20   1-10-97
		       CopyLevelInfo(WTextureWad, &TextureWad2);     // return assign to texturewad
		       break;
	       }
        }
      }
   }

   return Found;
}


//----------------------------------------------------------------------//
//  Get the size of a patch texture
//
//----------------------------------------------------------------------//

Bool GetPatchTextureSize(int2 *Wxsize,  int2 *Wysize,char *patchname)
{
  DirPtr dir;
  DOOMGraphicHdr PicHeader;
  WadFiles PicWad;            // the patch directory (usually MasterWad)

  dir = FindMasterDir( MasterWad, patchname,FALSE);        // find this patch

  if (!dir) return FALSE;

  SetActiveWad(&PicWad,dir->filenumber);    // where patch is
  WadSeek( PicWad.fileinfo, dir->start);    // start of patch
  WadRead( PicWad.fileinfo, &PicHeader,4);  // x width 2, y height 2

  *Wxsize = PicHeader.xsize;
  *Wysize = PicHeader.ysize;

   return TRUE;
}



//////////////////////////////////////////////////////////////
//																				//
//			START OF   MAP   BROWSER  CODE							//
//																				//
//////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////
//                                              //
// START  Common code to all Browse Windows     //
//                                              //
////////////////////////////////////////////////////////////////////////////////

static void BrowseLBDown(HWND hwnd, int2 xlocwidth, int2 hotwidth, int2 hotheight,
		                       int2 framecolor, int MouseX, int MouseY, int4 count)
{
  RECT rc;
  HDC hdc;
  int2 HitLoc, Xloc, Yloc;

  MouseX -=CurrXorg;         // -origin X
  MouseY -=CurrYorg;         // -origin Y

  if (MouseY >=0 && MouseX >=0)
  {
     Xloc =  MouseX / (Width +xlocwidth);
     Yloc =  MouseY / (Height+FontSize);

     if (Xloc >=0 && Xloc < Xacross          //  
     &&  Yloc >=0 && Yloc < Ydown)
     {
	     HitLoc =Xloc+  (Yloc*Xacross)+FirstOrigin;

	     if (HitLoc >= 0 && HitLoc < count )  //SpriteCount,NumWTexture
	     {									    		//NumFTexture,MissionCount
           hdc = GetDC(hwnd);

           CurrentActive  = HitLoc;

           rc.left 	= HotXloc-1;
           rc.top		= HotYloc;
           rc.right 	= HotXloc+Width+hotwidth;
           rc.bottom	= HotYloc+Height-hotheight;
           FrameRect(hdc, &rc, gd.hBrushes[BLACK]);

	        // First & LastOrigin contain the # of the 1st & Last Pic
           // on the page, so just need to find Xacross and Ydown
           HotXloc =  (Xloc * (Width+xlocwidth)   ) + CurrXorg;
           HotYloc =  (Yloc * (Height+FontSize)   ) + CurrYorg;

           rc.left 	= HotXloc-1;
           rc.top		= HotYloc;
           rc.right 	= HotXloc+Width+hotwidth;
           rc.bottom	= HotYloc+Height-hotheight;
           FrameRect(hdc, &rc, gd.hBrushes[framecolor]);

           //if(BrowseMode == TEXTURES)
           //{
              // Display composite information

           //}

           ReleaseDC(hwnd, hdc);
        }
     }
   }
}

//==========================================================================

static void BrowseDown(HWND hwnd, int2 xlocwidth, int2 hotheight, int2 framecolor)
{
  RECT rc;
  HDC hdc;

  hdc = GetDC(hwnd);

  if  (HotXloc)
  {
     rc.left 	= HotXloc-1;
     rc.top		= HotYloc;
     rc.right 	= HotXloc+Width+xlocwidth;
     rc.bottom	= HotYloc+Height-hotheight;
     FrameRect(hdc, &rc, gd.hBrushes[BLACK]);
  }
  else // nothing active yet, make it first one
  {
	  CurrentActive = FirstOrigin;      // make First active
	  HotXloc   = CurrXorg;
	  HotYloc   = CurrYorg;
  }
		   // has to be on this screen
  if ( CurrentActive +Xacross <= LastOrigin )
  {    CurrentActive  += Xacross;
		 HotYloc        += (Height+ FontSize);
  }

  rc.left 	= HotXloc-1;
  rc.top		= HotYloc;
  rc.right 	= HotXloc+Width+xlocwidth;
  rc.bottom	= HotYloc+Height-hotheight;
  FrameRect(hdc, &rc, gd.hBrushes[framecolor]);

  ReleaseDC(hwnd, hdc);

}

//=============================================================================
static void BrowseUp(HWND hwnd, int2 xlocwidth, int2 hotheight, int2 framecolor)
{
  RECT rc;
  HDC hdc;

  hdc = GetDC(hwnd);

  if  (HotXloc)
  {
     rc.left 	= HotXloc-1;
     rc.top		= HotYloc;
     rc.right 	= HotXloc+Width+xlocwidth;
     rc.bottom	= HotYloc+Height-hotheight;
     FrameRect(hdc, &rc, gd.hBrushes[BLACK]);
  }
  else // nothing active yet, make it first one
  {
	  CurrentActive = FirstOrigin;      // make First active
	  HotXloc   = CurrXorg;
	  HotYloc   = CurrYorg;
	}
		   // has to be on this screen
  if ( CurrentActive -Xacross >= FirstOrigin )
  {   CurrentActive -= Xacross;
	   HotYloc       -=(Height+FontSize );
  }

  rc.left 	= HotXloc-1;
  rc.top		= HotYloc;
  rc.right 	= HotXloc+Width+xlocwidth;
  rc.bottom	= HotYloc+Height-hotheight;
  FrameRect(hdc, &rc, gd.hBrushes[framecolor]);

  ReleaseDC(hwnd, hdc);

}

//==============================================================================

static void BrowseLeft(HWND hwnd, int2 xlocwidth, int2 hotwidth, int2 hotheight, int2 framecolor)
{
  RECT rc;
  HDC hdc;

  hdc = GetDC(hwnd);

  if  (HotXloc)
  {
     rc.left 	= HotXloc-1;
     rc.top		= HotYloc;
     rc.right 	= HotXloc+Width+xlocwidth;
     rc.bottom	= HotYloc+Height-hotheight;
     FrameRect(hdc, &rc, gd.hBrushes[BLACK]);
  }
  else // nothing active yet, make it first one
  {
	  CurrentActive = FirstOrigin;      // make First active
	  HotXloc   = CurrXorg;
	  HotYloc   = CurrYorg;
  }
		   // has to be on this screen
  if (CurrentActive -1  >= FirstOrigin )
  {   CurrentActive --;
		HotXloc -= int2(Width+hotwidth);
		if (HotXloc <  CurrXorg  )   //4
		{   HotXloc  = (Xacross-1)*(Width+hotwidth)+ CurrXorg;   //+4
		    HotYloc -= (Height+ FontSize); //+12
		}
  }

  rc.left 	= HotXloc-1;
  rc.top		= HotYloc;
  rc.right 	= HotXloc+Width+xlocwidth;
  rc.bottom	= HotYloc+Height-hotheight;
  FrameRect(hdc, &rc, gd.hBrushes[framecolor]);

  ReleaseDC(hwnd, hdc);

}

//=============================================================================

static void BrowseRight(HWND hwnd, int2 xlocwidth, int2 hotwidth, int2 hotheight, int2 framecolor)
{
  RECT rc;
  HDC hdc;

  hdc = GetDC(hwnd);

  if  (HotXloc)
  {
    rc.left 	= HotXloc-1;
    rc.top		= HotYloc;
    rc.right 	= HotXloc+Width+xlocwidth;
    rc.bottom	= HotYloc+Height-hotheight;
    FrameRect(hdc, &rc, gd.hBrushes[BLACK]);
  }
  else // nothing active yet, make it first one
  {
	  CurrentActive = FirstOrigin;      // make First active
	  HotXloc   = CurrXorg;
	  HotYloc   = CurrYorg;
  }

  if (CurrentActive+1 <= LastOrigin)
  {   CurrentActive ++;
  	   HotXloc += int2(Width+hotwidth);
		if (HotXloc+Width+hotwidth >= BrowseScrMaxX )
		{   HotXloc  = CurrXorg; //4;
		    HotYloc +=int2(Height+FontSize);  //+12a
		}
  }

  rc.left 	= HotXloc-1;
  rc.top		= HotYloc;
  rc.right 	= HotXloc+Width+xlocwidth;
  rc.bottom	= HotYloc+Height-hotheight;
  FrameRect(hdc, &rc, gd.hBrushes[framecolor]);

  ReleaseDC(hwnd, hdc);

}

////////////////////////////////////////////////////////////////////////////
//   3-1-97  this wraps from Top to Bottom
////////////////////////////////////////////////////////////////////////////
static void BrowsePgUp(HWND hwnd, int4 count)
{
    int2 oldFirst = FirstItemDrawn;

    FirstItemDrawn -= NumberPerScreen; // 12 per page +-

    if (FirstItemDrawn < 0)
    {   if (oldFirst >0)              // did not see 1st one yet
        {   FirstItemDrawn = 0;       // start there now
        }
        else
        {  FirstItemDrawn = (count -NumberPerScreen );//   3-1-97-1);
        }
    }

    if(FirstItemDrawn >=count) FirstItemDrawn=0;// safety stuff
    if (FirstItemDrawn < 0)    FirstItemDrawn=0;

    InvalidateRect(hwnd, NULL, TRUE);
    UpdateWindow(hwnd);

}
///////////////////////////////////////////////////////////////////////////
// this also wraps
//////////////////////////////////////////////////////////////////////////
static void BrowsePgDn(HWND hwnd, int4 count)
{

   FirstItemDrawn += NumberPerScreen;      // 12 per page +-
	if(FirstItemDrawn > count -1)
   {
      FirstItemDrawn = 0;                  // start over at the top
   }

   if (FirstItemDrawn < 0) FirstItemDrawn =0;//safety

   InvalidateRect(hwnd, NULL, TRUE);
   UpdateWindow(hwnd);
}
//////////////////////////////////////////////////////////////////////////
static void BrowseHome(HWND hwnd)
{
	if(FirstItemDrawn > 0)
   {
     FirstItemDrawn = 0;
     InvalidateRect(hwnd, NULL, TRUE);
     UpdateWindow(hwnd);
   }
}
//////////////////////////////////////////////////////////////////////////
static void BrowseEnd(HWND hwnd, int4 count)
{
	FirstItemDrawn = (count - NumberPerScreen);  // -1);

	if(FirstItemDrawn < 0    ) FirstItemDrawn = 0;
	if(FirstItemDrawn >=count) FirstItemDrawn = 0;//count-1;


// if(FirstItemDrawn > 0 && FirstItemDrawn < count)
   {
     InvalidateRect(hwnd, NULL, TRUE);
     UpdateWindow(hwnd);
   }
}

///////////////////////////////////////////////////////////////////
//
// called with keystroke and minimum magnification allowed
//
// Used by Browse Textures,Pnames, Floors, and Sprites to magnify and
// jump to a specific location with a-z keys
//
///////////////////////////////////////////////////////////////////
static void BrowseChar(HWND hwnd, UINT ch, int2 minmag)
{
  int2 n;

  //NotifyMsg(NULL,"char=%d",ch);
   // zoom +
	if (ch == '='
   ||  ch == '+' )
   {
	    if (CurrentMagnify < MaxMagnify) //3)
       {
          FirstItemDrawn = CurrentActive;    // makes current cursor pos the zoom pos. 10/7/96

	       CurrentMagnify++;
          InvalidateRect(hwnd, NULL, TRUE);
          UpdateWindow(hwnd);
	    }
   }
	else
   // zoom -
   if (ch == '-'
   ||  ch == '_' )   //  
	{
	    if (CurrentMagnify > minmag)
	    {
		     CurrentMagnify--;
           InvalidateRect(hwnd, NULL, TRUE);
           UpdateWindow(hwnd);
	    }
   }
	else
   //   3-1-97 also get upper case, numbers, etc that could be used
   if (isprint(ch))
   //if (ch >= 'a'
   //&&  ch <= 'z')
   {   char chartxt[2]= "";
	    FirstItemDrawn = 0;
       chartxt[0] = ch;

       strupr(chartxt);
       ch = chartxt[0];

       // textures
       if(BrowseMode == TEXTURES
       || BrowseMode == TEXTURECOMPOSITE)
       {  for (n=0; n< NumWTexture; n++)
		    { if (WTexture[n][0] == ch )// + ('A' - 'a'))
			   {   FirstItemDrawn = n;   //-1;
			        break;
			   }
			   else         //find closest so far
			   if (WTexture[n][0] < ch)  // + ('A' - 'a'))
			   {   FirstItemDrawn= n;    //-1;
			   }
          }
          if(FirstItemDrawn < 0 )  FirstItemDrawn = 0;
		 }
       else
       if (BrowseMode == TEXTUREPNAMES)
       {  for (n=0; n< BrowsePnameCount; n++)
		    { if (BrowsePnameBuffer[n].name[0] == ch )// + ('A' - 'a'))
			   {   FirstItemDrawn = n;   //-1;
			        break;
			   }
			   else         //find closest so far
			   if (BrowsePnameBuffer[n].name[0] < ch)  // + ('A' - 'a'))
			   {   FirstItemDrawn= n;    //-1;
			   }
          }
          if(FirstItemDrawn < 0 )  FirstItemDrawn = 0;
       }
       else
       // floors
       if(BrowseMode == FLOORS)
       {  for (n=0; n< NumFTexture; n++)
		    {  if (FTexture[n][0] == ch )//+ ('A' - 'a'))
			    {   FirstItemDrawn = n;   //-1;
				     break;
			    }
			    else         //find closest so far
			    if (FTexture[n][0] < ch)  // + ('A' - 'a'))
				 {   FirstItemDrawn= n;    //-1;
			    }
          }
          if(FirstItemDrawn < 0 )   FirstItemDrawn = 0;
		 }
       else
       // sprites
       if(BrowseMode == SPRITES)
       {  for (n=0; n< SpriteCount; n++)
		    {  if (SpriteList[n][0] == ch)// + ('A' - 'a'))
			    {   FirstItemDrawn = n;    //-1;
				     break;
			    }
			    else         //find closest so far
			    if (SpriteList[n][0] < ch)// + ('A' - 'a'))
				 {   FirstItemDrawn= n;//-1;
				 }
          }
          if(FirstItemDrawn < 0 )   FirstItemDrawn = 0;
		 }

       CurrentActive = FirstItemDrawn;
       InvalidateRect(hwnd, NULL, TRUE);
       UpdateWindow(hwnd);
	}

}

/////////////////////////////////////////////////////////////////////////////
// Handle WM_GetMinMaxInfo   (used Quake too)
//   3-1-97 reset dimensions
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Browse_OnGetMinMaxInfo(HWND hwnd, MINMAXINFO FAR* lpMinMaxInfo)
{
  lpMinMaxInfo->ptMaxSize.x     = GetSystemMetrics(SM_CXSCREEN);//-2;
  lpMinMaxInfo->ptMaxSize.y     = GetSystemMetrics(SM_CYSCREEN);//-2;
  // origin
  lpMinMaxInfo->ptMaxPosition.x = 0;//1;
  lpMinMaxInfo->ptMaxPosition.y = 0;//1;

  lpMinMaxInfo->ptMinTrackSize.x = lpMinMaxInfo->ptMaxSize.x ;//GetSystemMetrics(SM_CXSCREEN)-2;
  lpMinMaxInfo->ptMinTrackSize.y = lpMinMaxInfo->ptMaxSize.y ;//GetSystemMetrics(SM_CYSCREEN)-2;
  lpMinMaxInfo->ptMaxTrackSize.x = lpMinMaxInfo->ptMaxSize.x ;//GetSystemMetrics(SM_CXSCREEN)-2;
  lpMinMaxInfo->ptMaxTrackSize.y = lpMinMaxInfo->ptMaxSize.y ;//GetSystemMetrics(SM_CYSCREEN)-2;
}

//////////////////////////////////////////////////
//                                              //
// E N D  Common code to all Browse Windows     //
//                                              //
//////////////////////////////////////////////////




/////////////////////////////////////////////////////////////////////////////
// Actually does the drawing - DOS MapBrowser() mostly
// init. stuff in MapBrowser now only
/////////////////////////////////////////////////////////////////////////////
void DrawTheMaps(HDC hdc)
{
	RECT rc;							// for FrameRect
   // HFONT hOldFont;

   int2 i;

   Bool LastPicture;
   // MSG msg;

 for (i=FirstItemDrawn; i< MissionCount; i++)
 {
	if (oldmagnify != CurrentMagnify)
	{
       //FirstItemDrawn= 0;
	    Width   = 78;
	    Height  = 68;

	    FirstOrigin=i;
	    HotXloc    =0;

	    Width *=CurrentMagnify;  //1,2,3
	    Height*=CurrentMagnify;

	    oldmagnify = CurrentMagnify;

	    Xacross =  (BrowseScrMaxX - 2 )/ (Width+2)   ;          // how many acros (+2 for box)
	    Ydown   =  (BrowseScrMaxY - 4 )/ (Height+FontSize);     // how many down
	    NumberPerScreen = ( Xacross * Ydown );

	    CurrYorg  = (BrowseScrMaxY - Ydown  *(Height+FontSize) ) / 2 ;  //-17
	    CurrXorg  = (BrowseScrMaxX - Xacross*(Width+2)         ) / 2 ;
	    CurrXloc  = CurrXorg;
	    CurrYloc  = CurrYorg;
	}

	strncpy(picname,levelnames[i],8);

   //KeyPressed = CheckForKeyOrButtonPressed(gd.hMapBrowseWindow);
   //if(!KeyPressed)
   {    DrawWindowMap( hdc, (CurrXloc+1),       (CurrYloc+2),
   		                   (CurrXloc+Width-1), (CurrYloc+Height-18), picname, TRUE);
   }

   // SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK]));
   // hOldFont = SelectFont(hdc, GetStockFont(ANSI_FIXED_FONT));
   // hOldFont = SelectFont(hdc, GetStockFont(ANSI_VAR_FONT));    //   3-1-97
   // SetBkMode(hdc, OPAQUE);
   //	TextOut(hdc,CurrXloc,CurrYloc+Height,picname,lstrlen(picname) );

   ScreenColorText(hdc, CurrXloc,CurrYloc+Height, WHITE,picname);    //   3-1-97

	LastOrigin = i;

	// draw a rectangle around active one
	if  (i == CurrentActive)
	{
        rc.left 	= CurrXloc-1;
        rc. top	= CurrYloc;
        rc.right	= CurrXloc+Width+1;
        rc.bottom = CurrYloc+Height-1;

	     FrameRect(hdc, &rc, gd.hBrushes[YELLOW]);

	     HotXloc = CurrXloc;
	     HotYloc = CurrYloc;
	}

	CurrXloc+=(Width+2);

	if (i == MissionCount -1)
	{
       LastPicture = TRUE;
	}
	else
	{   LastPicture = FALSE;
	}


	if (CurrXloc+Width+2 >=BrowseScrMaxX  || LastPicture)
	{   CurrXloc  = CurrXorg;//4
	    CurrYloc += Height+FontSize ;//+8
       if (CurrYloc+Height+FontSize  >= BrowseScrMaxY || LastPicture)
	    { LastPicture = TRUE;
       }
   }

   if(LastPicture)
   {   //i=MissionCount;	 // EXIT our For Loop
	    oldmagnify =-1;  //  force change   12-8-96
       break;
   }

 }	// End of for (i=FirstItemDrawn; i< MissionCount; i++)

 BrowseMapMag = CurrentMagnify;
   // if(hOldFont) SelectFont(hdc, hOldFont);
   //KeyPressed = FALSE;
}


//----------------------------------------------------------------------//
//   show the Maps across the whole screen
//----------------------------------------------------------------------//
#pragma argsused
void MapBrowser ( char * MapLevelName )
{
  int2 m;
  int4 MaxMagnify1,MaxMagnify2;
  RECT rc;

  if (!MissionCount) return;                          //??

  levelnames = (char **)GetMemory( MissionCount * sizeof( char *));  // n pointers allocated

  for (m=0; m< MissionCount; m++)                    // the number of files
  {   levelnames[m]=MissionFileList[m].mission;      // store addr name
  }

  qsort( levelnames, MissionCount, sizeof( char *), QsortName);

  //------------------------------------------------------------------------------

  if (MapLevelName)
  {   strncpy(newname,MapLevelName,8);             // save entry name
      strncpy(entryname,MapLevelName,8);

      for (m=0; m< MissionCount; m++)
      {
           strncpy(picname,levelnames[m],8);
           if (!strcmp (picname,MapLevelName) )
           {
                FirstItemDrawn = m;        // start display with this one
                CurrentActive = m;
                break;
           }
      }
   }

   CurrentMagnify = BrowseMapMag;//2;
   Width   = 78;
   Height  = 68;
   oldmagnify = -2;
   //KeyPressed = FALSE;			    // No key waiting
   //OldScrMaxY = ScrMaxY;           //   12-25-96
   //OldScrMaxX = ScrMaxX;

   GetClientRect(gd.hMapBrowseWindow, &rc);
   BrowseScrMaxY = rc.bottom-12;  //-rc.top -24;   //   12-8-96
   BrowseScrMaxX = rc.right;      // - rc.left;

   MaxMagnify1 = BrowseScrMaxX / 80;
   MaxMagnify2 = BrowseScrMaxY / 84;    // +map name 68+14+2
   if (MaxMagnify1 < MaxMagnify2)
   {   MaxMagnify = MaxMagnify1;
   }
   else
   {   MaxMagnify = MaxMagnify2;
   }

 }

////////////////////////////////////////////////////////////////////////////////
// WM_CREATE
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
static BOOL MapBrowse_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
  PostMessage(hwnd, WM_BROWSE, 0, 0);
  // Give our window time to appear
   return TRUE;
}


////////////////////////////////////////////////////////////////////////////////
// Handle WM_PAINT: Paint
////////////////////////////////////////////////////////////////////////////////
static void MapBrowse_OnPaint(HWND hwnd)
{
 	PAINTSTRUCT ps;
   HPALETTE hOldPal;

	HDC hdc = BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

   if(OKtoMapDraw)
   {
       DrawTheMaps(hdc);
   }

   SelectPalette(ps.hdc, hOldPal, FALSE);
	EndPaint(hwnd, &ps);
}

//=============================================================================
// Our Finish Up Routine called on Esc, Enter, Left Button DblClick
//=============================================================================
#pragma argsused
static void MapBrowseEnd(HWND hwnd)
{
  OKtoMapDraw = FALSE;
  Browsing    = FALSE;

  if (CurrentActive >=0 && CurrentActive < MissionCount)
  {   strncpy(newname,levelnames[CurrentActive],8);
      newname[8] = '\0';
      HotName = newname;
  }
  else
  {   if (CurrentActive == -1)   // ESC
      {   newname[8] = 'E';
	  	    HotName = newname;
      }
      else
      {   HotName = entryname;
      }
  }

  strcpy(TxtLevelName, HotName);

  BrowseMapMag = CurrentMagnify;

  FreeMemory(levelnames);

  advanceInput = TRUE;

  DeePDestroyWindow(gd.hMapBrowseWindow);

  PostMessage(gd.hParent, WM_COMMAND, WM_BROWSE_BACK, 0);
}

//////////////////////////////////////////////////////////////////////////////
// enter key, - key, + key
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void MapBrowse_OnChar(HWND hwnd, UINT ch, int cRepeat)
{
	BrowseChar(hwnd, ch, 1);// minimum magnification 0 or 1

}
///////////////////////////////////////////////////////////////////////////////
// Arrow keys  (not sure this is ever used ?   3-1-97
///////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void MapBrowse_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
  HDC hdc;

  hdc = GetDC(hwnd);

  oldmagnify = -1;
//  NotifyMsg(NULL,"vk=%d",vk);

 switch(vk)	// Keys which ARE NOT Accelerator keystokes
 {
  case VK_END:
	BrowseEnd(hwnd, MissionCount);
   break;

  case VK_HOME:
	BrowseHome(hwnd);
   break;

  case VK_ESCAPE:
   CurrentActive = -1;
   MapBrowseEnd(hwnd);
   break;

  case VK_RETURN:
   MapBrowseEnd(hwnd);
   break;

  case VK_DOWN:
	BrowseDown(hwnd, 1, 1, YELLOW);//width + x, height - x, FrameColor
   break;

  case VK_UP:
	BrowseUp(hwnd, 1, 1, YELLOW);//width + x, height - x, FrameColor
   break;

  case VK_LEFT:
	BrowseLeft(hwnd, 1, 2, 1, YELLOW);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_RIGHT:
	BrowseRight(hwnd, 1, 2, 1, YELLOW);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_PRIOR:														// Page Up
	BrowsePgUp(hwnd, MissionCount);
	break;

  case VK_NEXT:														// Page Down
	BrowsePgDn(hwnd, MissionCount);
	break;

  case VK_F1:
   HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,
                               (DWORD)"Texture Browsing Commands");
   break;
 }

 ReleaseDC(hwnd, hdc);
}

//==============================================================================
#pragma argsused
static void MapBrowse_OnLBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
  BrowseLBDown(hwnd, 2, 1, 1, YELLOW, MouseX, MouseY, MissionCount);  //   12-25-96

  if (fDoubleClick)
  {
      CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
      MapBrowseEnd(hwnd);
      return;
  }

}

//==============================================================================
#pragma argsused
static void MapBrowse_OnRBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
     CurrentActive = -1;
     CheckActivity(NULL,WAIT);     //   8-1-97 trap button up
     MapBrowseEnd(hwnd);
     return;
}

////////////////////////////////////////////////////////////////////////////////
// Called from EditLevelDialog to Browse Maps
// hwnd = hDlg to EndDialog when done
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void MapBrowse(void)
{
	// Create our MAP BROWSE Window

   gd.hMapBrowseWindow = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW | WS_EX_DLGMODALFRAME,     //   12-8-96
                                        szLoadString(IDS_MAPBROWSENAME),
                                        szLoadString(IDS_MAPBROWSENAME),                  //   12-8-96
 	                                     WS_POPUP | WS_CAPTION ,
                                        0, 0,
                                        CW_USEDEFAULT,
                                        CW_USEDEFAULT,
                                        gd.hMainWindow,
                                        NULL,
                                        gd.hInst,
                                        NULL);

   ShowWindow(gd.hMapBrowseWindow, SW_MAXIMIZE);
   UpdateWindow(gd.hMapBrowseWindow);      // send paint msg

}

////////////////////////////////////////////////////////////////////////////////
// BrowseWndProc   = MAPS =
////////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK MapBrowseWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
	case WM_BROWSE:
     MapBrowser(TxtLevelName);		   // setup up levels etc.
     OKtoMapDraw = TRUE;
     InvalidateRect(hwnd, NULL, TRUE);
     UpdateWindow(hwnd);
     break;

   HANDLE_MSG(hwnd, WM_CREATE, 			MapBrowse_OnCreate);
   HANDLE_MSG(hwnd, WM_PAINT, 			MapBrowse_OnPaint);
   HANDLE_MSG(hwnd, WM_CHAR, 		    	MapBrowse_OnChar);  //SAME CODE
   HANDLE_MSG(hwnd, WM_KEYDOWN, 		   MapBrowse_OnKey);
   HANDLE_MSG(hwnd, WM_GETMINMAXINFO,  Browse_OnGetMinMaxInfo);
   HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK,	MapBrowse_OnLBDown);
   HANDLE_MSG(hwnd, WM_LBUTTONDOWN,	   MapBrowse_OnLBDown);

   HANDLE_MSG(hwnd, WM_RBUTTONDOWN,	   MapBrowse_OnRBDown); //   3-1-97
   default:
		return MapBrowse_DefProc(hwnd, msg, wParam,lParam);
  }
  return MapBrowse_DefProc(hwnd, msg, wParam,lParam);
}

//////////////////////////////////////////////////////////////
//																				//
//			END OF   MAP  BROWSER  CODE								//
//																				//
//////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////
//																				//
//			START OF WALL (Textures )  BROWSER  CODE 				//
//																				//
//////////////////////////////////////////////////////////////

static void DrawTheWalls(HDC hdc)
{
	RECT rc;							// for FrameRect
   HFONT hOldFont;

   int2 i;
   int2  filenumber;          //  

   Bool LastPicture;
// MSG msg;

 for (i=FirstItemDrawn; i< NumWTexture; i++)
 {
	if (oldmagnify != CurrentMagnify)
	{
//   	 FirstItemDrawn= 0;
	    Width   = 64;
	    Height  = 64;

	    FirstOrigin=i;
	    HotXloc    =0;

	    if (CurrentMagnify == 2)
	    {   Width *=(CurrentMagnify+2); //
           Height*=(CurrentMagnify+2); //
	    }
	    else
	    if (CurrentMagnify == 3)
	    {   Width *=(CurrentMagnify+6); //
           Height*=(CurrentMagnify+3); //
	    }
	    else
	    {   Width *=(CurrentMagnify+1); //
           Height*=(CurrentMagnify+1); //
	    }

	    oldmagnify = CurrentMagnify;
	    PicMagnify = CurrentMagnify;         // magnification

	    Xacross = (BrowseScrMaxX -4 ) / (Width + 8);
	    Ydown   = (BrowseScrMaxY    ) / (Height+FontSize);

	    NumberPerScreen = (Xacross * Ydown);
	    CurrXorg =  ( BrowseScrMaxX - Xacross*( Width+8  ) -4   )/2;
	    CurrYorg =  ( BrowseScrMaxY - Ydown  *( Height+FontSize))/2;
	    if (CurrYorg < 0) CurrYorg = 0;
	    if (CurrXorg < 0) CurrXorg = 0;
	    CurrYloc = CurrYorg;
	    CurrXloc = CurrXorg;
	}

	strncpy(newname,WTexture[i],8);

   //KeyPressed = CheckForKeyOrButtonPressed(gd.hMapBrowseWindow);

   //if(!KeyPressed)
   {    filenumber  = DisplayATexture(hdc, CurrXloc,           CurrYloc,
                                     (CurrXloc+Width+5),(CurrYloc+Height-1),
                                      0,0, newname,"+");//+ignore
   }

   if (filenumber== -1) // main IWAD - a bit better doc, that's all- so I don't forget
   {
      //if (CurrentMagnify == 0)                           //   12-20-96 changed my mind
	   //{   SetTextColor(hdc, PALETTEINDEX(GameColors[LIGHTGRAY]));
	   //}
	   //else
      {   SetTextColor(hdc, PALETTEINDEX(GameColors[WHITE]));
	   }
   }
   else
   {     SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));//RED]));
	}

   SetBkMode(hdc, OPAQUE);
   SetBkColor(hdc, PALETTEINDEX(GameColors[BLACK]));
   //SetTextColor(hdc, GetSysColor(COLOR_CAPTIONTEXT));
   //SetBkColor(hdc, GetSysColor(COLOR_ACTIVECAPTION));
   hOldFont = SelectFont(hdc, gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));
	TextOut(hdc,CurrXloc,CurrYloc+Height, newname,lstrlen(newname) );

	LastOrigin = i;

	// draw a rectangle around active one
	if  (i == CurrentActive)
	{
        rc.left 	= CurrXloc-1;
        rc. top	= CurrYloc;
        rc.right	= CurrXloc+Width+6;
        rc.bottom = CurrYloc+Height;

	     FrameRect(hdc, &rc, gd.hBrushes[WHITE]);

	     HotXloc = CurrXloc;
	     HotYloc = CurrYloc;
	}

 	if (i == NumWTexture -1)
	{   LastPicture = TRUE;
	}
	else
	{   LastPicture=FALSE;
	}

	CurrXloc+=(Width+8);//72

	if (CurrXloc+Width+8 >=BrowseScrMaxX || LastPicture )
	{   CurrXloc = CurrXorg;
	    CurrYloc = (CurrYloc+Height+FontSize);
	    if (CurrYloc+Height+FontSize > BrowseScrMaxY || LastPicture)
       {  LastPicture = TRUE;
       }
   }

   if (LastPicture)
   {  //  i= NumWTexture;	// EXIT our For Loop
	    oldmagnify =-1; //  force change   12-8-96
       break;
   }

 }	// End of for (i=FirstItemDrawn; i< MissionCount; i++)

  BrowseTextureMag = CurrentMagnify;
  if(hOldFont) SelectFont(hdc, hOldFont);
  //KeyPressed = FALSE;
}


//----------------------------------------------------------------------//
//   show Textures across the whole screen
//----------------------------------------------------------------------//
#pragma argsused
static void TextureBrowseDisplay ( char * WallName )
{
 int2 i;
 RECT rc;

   if (WallName)
   {
      strncpy(entryname,WallName,8);              // save entry name

       for (i=0; i < NumWTexture; i++)
       {
         strncpy(newname,WTexture[i],8);
	      if (!strcmp (newname,WallName) )
	      {
	         FirstItemDrawn = i;    // start display with this one
	         CurrentActive = i;
	         break;
	      }
      }
   }
   else
   {
    	FirstItemDrawn = 0;
		CurrentActive = 0;          // current active picture number
	}

  MaxMagnify     	= 3;
  CurrentMagnify 	= BrowseTextureMag;
  oldmagnify     	= -1;
  oldPicMagnify  	= PicMagnify;
  Width      		= 64;
  Height     		= 64;

  //KeyPressed 		= FALSE;			// No key waiting

  //OldScrMaxY 		= ScrMaxY;
  //OldScrMaxX 		= ScrMaxX;

  GetClientRect(gd.hTxtrBrowseWindow, &rc);

  BrowseScrMaxY = rc.bottom -12;// -rc.top -24;   //   12-8-96
  BrowseScrMaxX = rc.right;     // -rc.left;

}

//////////////////////////////////////
// WM_CREATE
//////////////////////////////////////
#pragma argsused
static BOOL TxtrBrowse_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
  PostMessage(hwnd, WM_BROWSE, 0, 0);
  // Give our window time to appear
   return TRUE;
}


//////////////////////////////////////
// Handle WM_PAINT: Paint
//////////////////////////////////////
static void TxtrBrowse_OnPaint(HWND hwnd)
{
 	PAINTSTRUCT ps;
   HPALETTE hOldPal;

	HDC hdc = BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

   if(OKtoMapDraw)
   {
      DrawTheWalls(hdc);
   }

   SelectPalette(ps.hdc, hOldPal, FALSE);
	EndPaint(hwnd, &ps);
}

///////////////////////////////////////////////////////////////////////
// Our Finish Up Routine called on Esc, Enter, Left Button DblClick
///////////////////////////////////////////////////////////////////////
static void TxtrBrowseEnd()
{
   OKtoMapDraw = FALSE;
   Browsing    = FALSE;

   BrowseTextureMag = CurrentMagnify;

   PicMagnify = oldPicMagnify;

   if (CurrentActive >=0 && CurrentActive < NumWTexture)
   {   strncpy(newname,WTexture[CurrentActive],8);
   }
   else
   {   strncpy(newname, entryname, 8);
   }

   strcpy(TxtrName, newname);

   //ScrMaxY = OldScrMaxY;
   //ScrMaxX = OldScrMaxX;

   DeePDestroyWindow(gd.hTxtrBrowseWindow);

   PostMessage(gd.hParent, WM_COMMAND, WM_BROWSE_BACK, 0);
}

//////////////////////////////////////
// enter key, - key, + key
//////////////////////////////////////
#pragma argsused
static void TxtrBrowse_OnChar(HWND hwnd, UINT ch, int cRepeat)
{
	BrowseChar(hwnd, ch, 0);//min magnify 0 or 1
}

//////////////////////////////////////
// Arrow keys
//////////////////////////////////////
#pragma argsused
static void TxtrBrowse_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
  HDC hdc;
  int2     xsize;           // width in pixels of texture
  int2     ysize;           // height in pixels of texture
  int2     patchnum;        // number of wall patches used to build this texture
  byte    *texofs;          // offset in the wad file to the texture data
  WadFiles TextureWad;      // the texture directory (usually MasterWad)

  hdc = GetDC(hwnd);

  oldmagnify = -1;
//  NotifyMsg(NULL,"vk=%d",vk);

 switch(vk)
 {
  case VK_END:
	BrowseEnd(hwnd, NumWTexture);
   break;

  case VK_HOME:
	BrowseHome(hwnd);
   break;

  case VK_ESCAPE:
   CurrentActive = -1;
   TxtrBrowseEnd();
   break;

  case VK_RETURN:
   TxtrBrowseEnd();
   break;

  case VK_DOWN:
	BrowseDown(hwnd, 6, 0, WHITE);//width + x, height - x, FrameColor
   break;

  case VK_UP:
	BrowseUp(hwnd, 6, 0, WHITE);//width + x, height - x, FrameColor
   break;

  case VK_LEFT:
	BrowseLeft(hwnd, 6, 8, 0, WHITE);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_RIGHT:
	BrowseRight(hwnd, 6, 8, 0, WHITE);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_PRIOR:														// Page Up
	BrowsePgUp(hwnd, NumWTexture);
	break;

  case VK_NEXT:														// Page Down
	BrowsePgDn(hwnd, NumWTexture);
	break;

  case VK_F1:
   HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,
                               (DWORD)"Texture Browsing Commands");
   break;
 }

 if(CurrentActive != -1 && CurrentActive < NumWTexture)//	Can happen on ESC then returns here
 {
	strncpy(newname,WTexture[CurrentActive],8);
   if (GetWallTextureSize( &TextureWad, &xsize, &ysize, &patchnum, &texofs, newname) )
	{
		 DisplayCaptionText(hwnd,300,5," %s , %hd x %hd , %hd patches ",newname, xsize, ysize,patchnum);
	}
 }
 ReleaseDC(hwnd, hdc);
}

///////////////////////////////////////////////////////////////////////////////

#pragma argsused
static void TxtrBrowse_OnLBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
  int2     patchnum;        // number of wall patches used to build this texture
  byte    *texofs;          // offset in the wad file to the texture data
  WadFiles TextureWad;      // the texture directory (usually MasterWad)

  BrowseLBDown(hwnd, 8, 6, 0, WHITE, MouseX, MouseY, NumWTexture);   //   12-25-96

  if (fDoubleClick)
  {
     CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
     TxtrBrowseEnd();
     return;
  }

  if(CurrentActive != -1 && CurrentActive < NumWTexture)//	Can happen on ESC then returns here
  {
    strncpy(newname,WTexture[CurrentActive],8);
    if (GetWallTextureSize( &TextureWad, &xsize, &ysize, &patchnum, &texofs, newname) )
    {
		 DisplayCaptionText(hwnd,300,5," %s , %hd x %hd , %hd patches ",newname, xsize, ysize,patchnum);
    }
  }
}
//////////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void TxtrBrowse_OnRBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
     CurrentActive = -1;
     CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
     TxtrBrowseEnd();
     return;
}
///////////////////////////////////////////////////////////////////
//
//		The Entry point which creates the window to Browse Textures
//
//////////////////////////////////////////////////////////////////
#pragma argsused
void TxtrBrowse(char * wallname)
{
  TextureBrowsing = 1;                   // which browse texture=1 or pnames=2
  strncpy(entryname, wallname, 8);

  // Create our BROWSE Window
  //gd.hTxtrBrowseWindow = CreateWindowEx(WS_EX_DLGMODALFRAME,

  gd.hTxtrBrowseWindow = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW | WS_EX_DLGMODALFRAME,                //   12-8-96
                                        szLoadString(IDS_TXTRBROWSENAME),
                                        szLoadString(IDS_TXTRBROWSENAME),
                                        WS_POPUP | WS_CAPTION,
                                        0, 0,
                                        CW_USEDEFAULT,
                                        CW_USEDEFAULT,
                                        gd.hMainWindow,
                                        NULL,
                                        gd.hInst,
                                        NULL);

  ShowWindow(gd.hTxtrBrowseWindow, SW_MAXIMIZE);
  UpdateWindow(gd.hTxtrBrowseWindow);
}

//////////////////////////////////////
// TxtrBrowseWndProc
//////////////////////////////////////
LRESULT CALLBACK TxtrBrowseWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
	case WM_BROWSE:
     TextureBrowseDisplay(entryname);		// pass our TextureName saved on call
     OKtoMapDraw = TRUE;
     InvalidateRect(hwnd, NULL, TRUE);
     UpdateWindow(hwnd);
     break;

	 HANDLE_MSG(hwnd, WM_CREATE, 			TxtrBrowse_OnCreate);
	 HANDLE_MSG(hwnd, WM_PAINT, 			TxtrBrowse_OnPaint);
	 HANDLE_MSG(hwnd, WM_CHAR, 			TxtrBrowse_OnChar);
	 HANDLE_MSG(hwnd, WM_KEYDOWN, 		TxtrBrowse_OnKey);
    HANDLE_MSG(hwnd, WM_GETMINMAXINFO, Browse_OnGetMinMaxInfo);  //   3-1-97
	 HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK,	TxtrBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN,	TxtrBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_RBUTTONDOWN,	TxtrBrowse_OnRBDown);
	 default:
		return TxtrBrowse_DefProc(hwnd, msg, wParam,lParam);
  }
  return TxtrBrowse_DefProc(hwnd, msg, wParam,lParam);
}

//////////////////////////////////////////////////////////////
//																				//
//			END OF TEXTURE BROWSER  CODE								//
//																				//
//////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////
//																				//
//			START OF FLOOR (Textures )  BROWSER  CODE 			//
//																				//
//////////////////////////////////////////////////////////////

static void FloorBrowseDisplay(HDC hdc)
{
	RECT rc;							// for FrameRect
   HFONT hOldFont;

   int2 i;
   int2 filenumber;
   Bool LastPicture;
// MSG msg;

//====================================================================

  for (i=FirstItemDrawn; i< NumFTexture; i++)
  {
     if (oldmagnify != CurrentMagnify)
	  {
	    Width   = 64;
	    Height  = 64;

	    FirstOrigin=i;
	    HotXloc    =0;

	    Width *=CurrentMagnify;
	    Height*=CurrentMagnify;

	    oldmagnify = CurrentMagnify;

	    Xacross = (BrowseScrMaxX -4 )/ (Width +2);
	    Ydown   = (BrowseScrMaxY    )/ (Height+FontSize);

	    NumberPerScreen = (Xacross * Ydown);
	    CurrXorg =  ( BrowseScrMaxX - Xacross*( Width+2  )-4    )/2;
	    CurrYorg =  ( BrowseScrMaxY - Ydown  *( Height+FontSize))/2;
	    if (CurrYorg < 0) CurrYorg = 0;
	    if (CurrXorg < 0) CurrXorg = 0;
	    CurrYloc = CurrYorg;
	    CurrXloc = CurrXorg;
	 }

	 strncpy(newname,FTexture[i],8);

  //  KeyPressed = CheckForKeyOrButtonPressed(gd.hMapBrowseWindow);

  //  if(!KeyPressed)
    {filenumber = DisplayFloorTexture(hdc, CurrXloc, CurrYloc,
                                 (CurrXloc+Width-1),
   	                    	      (CurrYloc+Height-1),newname,CurrentMagnify);
    }

    SetBkMode(hdc, OPAQUE);

    if (filenumber == 0)   // main iwad
    {   SetTextColor(hdc, PALETTEINDEX(GameColors[WHITE]));
    }
    else
    {   SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));
	 }

    //SetTextColor(hdc, GetSysColor(COLOR_CAPTIONTEXT));
    //SetBkColor(hdc, GetSysColor(COLOR_ACTIVECAPTION));
    SetBkColor(hdc, PALETTEINDEX(GameColors[BLACK]));
    hOldFont = SelectFont(hdc, gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));
	 TextOut(hdc,CurrXloc,CurrYloc+Height, newname,lstrlen(newname) );

	 LastOrigin = i;

	 // draw a rectangle around active one
	 if  (i == CurrentActive)
	 {
        rc.left 	= CurrXloc-1;
        rc. top	= CurrYloc;
        rc.right	= CurrXloc+Width;
        rc.bottom = CurrYloc+Height;

	     FrameRect(hdc, &rc, gd.hBrushes[WHITE]);

	     HotXloc = CurrXloc;
	     HotYloc = CurrYloc;
	 }

 	 if (i == NumFTexture -1)
	 {   LastPicture = TRUE;
	 }
	 else
	 {   LastPicture=FALSE;
	 }

	 CurrXloc+=int2(Width+2);//72


	 if (CurrXloc+Width+2 >=BrowseScrMaxX || LastPicture )
	 {  CurrXloc  = CurrXorg;
	    CurrYloc =int2(CurrYloc+Height+FontSize);
	    if (CurrYloc+Height+FontSize > BrowseScrMaxY || LastPicture)
       {  LastPicture = TRUE;
       }
    }

   if (LastPicture)
   {   //i=(NumFTexture);			// EXIT our For Loop
	    oldmagnify =-1; //  force change   12-8-96
       break;
   }

 }	// End of for (i=FirstItemDrawn; i< MissionCount; i++)

   BrowseFlatMag = CurrentMagnify;         //   7-1-97
   if(hOldFont) SelectFont(hdc, hOldFont);
   //KeyPressed = FALSE;
}


//----------------------------------------------------------------------//
//   show the Flats across the whole screen
//----------------------------------------------------------------------//
#pragma argsused
static void FloorBrowser ( char * floorname )
{
 int2 i;
 RECT rc;

 if (floorname)
 {
     strncpy(entryname,floorname,8);              // save entry name

     for (i=0; i < NumFTexture; i++)
     {
          strncpy(newname,FTexture[i],8);
	       if (!strcmp (newname,floorname) )
	       {
	          FirstItemDrawn = i;    // start display with this one
	          CurrentActive = i;
	          break;
	       }
     }
 }
 else
 {
     FirstItemDrawn = 0;
	  CurrentActive = 0;          // current active picture number
 }

 MaxMagnify     	= 6;
 CurrentMagnify 	= BrowseFlatMag;
 oldmagnify     	= -1;
 Width      		= 64;
 Height     		= 64;
 FirstOrigin		=  0;          // first on screen

 //KeyPressed 		= FALSE;			// No key waiting

 //OldScrMaxY 		= ScrMaxY;
 //OldScrMaxX 		= ScrMaxX;

 GetClientRect(gd.hFloorBrowseWindow, &rc);
 BrowseScrMaxY = rc.bottom-12;//-rc.top-24;    //   12-8-96
 BrowseScrMaxX = rc.right;    // -rc.left;

}

//////////////////////////////////////
// WM_CREATE
//////////////////////////////////////
#pragma argsused
static BOOL FloorBrowse_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
   PostMessage(hwnd, WM_BROWSE, 0, 0);
   // Give our window time to appear
   return TRUE;
}


////////////////////////////////////
// Handle WM_PAINT: Paint
//////////////////////////////////////
static void FloorBrowse_OnPaint(HWND hwnd)
{
 	PAINTSTRUCT ps;
   HPALETTE hOldPal;

	HDC hdc = BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

   if(OKtoMapDraw)
   {
      FloorBrowseDisplay(hdc);
   }

   SelectPalette(ps.hdc, hOldPal, FALSE);
	EndPaint(hwnd, &ps);
}

/////////////////////////////////////////////////////////////////////
// Our Finish Up Routine called on Esc, Enter, Left Button DblClick
/////////////////////////////////////////////////////////////////////
static void FloorBrowseEnd()
{
  OKtoMapDraw = FALSE;
  Browsing    = FALSE;

  BrowseFlatMag = CurrentMagnify;

  if (CurrentActive >=0 && CurrentActive < NumFTexture)
  {   strncpy(newname,FTexture[CurrentActive],8);
  }
  else
  {   strncpy(newname, entryname, 8);
  }

  strncpy(FloorName, newname, 8); // if called from another dialog

  //ScrMaxY = OldScrMaxY;
  //ScrMaxX = OldScrMaxX;

  DeePDestroyWindow(gd.hFloorBrowseWindow);

  PostMessage(gd.hParent, WM_COMMAND, WM_BROWSE_BACK, 0);

}

////////////////////////////////////////////////////////////////////////////////
// Arrow keys  FloorBrowser
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void FloorBrowse_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
  HDC hdc;
  hdc = GetDC(hwnd);
  oldmagnify = -1;

 switch(vk)
 {
  case VK_END:
	BrowseEnd(hwnd, NumFTexture);
   break;

  case VK_HOME:
  	BrowseHome(hwnd);
   break;

  case VK_ESCAPE:
   CurrentActive = -1;
   FloorBrowseEnd();
   break;

  case VK_RETURN:
   FloorBrowseEnd();
   break;

  case VK_DOWN:
	BrowseDown(hwnd, 0, 0, WHITE);//width + x, height - x, FrameColor
   break;

  case VK_UP:
	BrowseUp(hwnd, 0, 0, WHITE);//width + x, height - x, FrameColor
   break;

  case VK_LEFT:
	BrowseLeft(hwnd, 0, 2, 0, WHITE);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_RIGHT:
	BrowseRight(hwnd, 0, 2, 0, WHITE);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_PRIOR:														// Page Up
	BrowsePgUp(hwnd, NumFTexture);
	break;

  case VK_NEXT:														// Page Down
	BrowsePgDn(hwnd, NumFTexture);
	break;

  case VK_F1:
   HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,
                               (DWORD)"Texture Browsing Commands");
   break;
 }

 ReleaseDC(hwnd, hdc);
}
////////////////////////////////////////////////////////////////////////////

#pragma argsused
static void FloorBrowse_OnLBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{                  //2,0,1
  BrowseLBDown(hwnd, 2,0,0, WHITE, MouseX, MouseY, NumFTexture); //   3-2-97

  if (fDoubleClick)
  {
     CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
 	  FloorBrowseEnd();
     return;
  }
}
////////////////////////////////////////////////////////////////////////////

#pragma argsused
static void FloorBrowse_OnRBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
     CurrentActive = -1;
     CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
 	  FloorBrowseEnd();
     return;
}

///////////////////////////////////////////////////////////////////
//
//		The Entry point which creates the window to Browse Textures
//
//////////////////////////////////////////////////////////////////
#pragma argsused
void FloorBrowse(char * floorname)
{
   strncpy(entryname, floorname, 8);

	// Create our FLOOR BROWSE Window
   gd.hFloorBrowseWindow  = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW | WS_EX_DLGMODALFRAME,
                                           szLoadString(IDS_FLOORBROWSENAME),
                                           szLoadString(IDS_FLOORBROWSENAME),
                                           WS_POPUP | WS_CAPTION,
                                           0, 0,
                                           CW_USEDEFAULT,
                                           CW_USEDEFAULT,
                                           gd.hMainWindow,
                                           NULL,
                                           gd.hInst,
                                           NULL);

  ShowWindow(gd.hFloorBrowseWindow, SW_MAXIMIZE);
  UpdateWindow(gd.hFloorBrowseWindow);

}

//////////////////////////////////////
// FloorBrowseWndProc
//////////////////////////////////////
LRESULT CALLBACK FloorBrowseWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
	case WM_BROWSE:
     SetFocus(hwnd);  // get keyboard focus
     FloorBrowser(entryname);		// pass our TextureName saved on call
     OKtoMapDraw = TRUE;
     InvalidateRect(hwnd, NULL, TRUE);
     UpdateWindow(hwnd);
     break;

	 HANDLE_MSG(hwnd, WM_CREATE, 			FloorBrowse_OnCreate);
	 HANDLE_MSG(hwnd, WM_PAINT, 			FloorBrowse_OnPaint);
	 HANDLE_MSG(hwnd, WM_CHAR, 			MapBrowse_OnChar);        //SAME CODE
	 HANDLE_MSG(hwnd, WM_KEYDOWN, 		FloorBrowse_OnKey);
    HANDLE_MSG(hwnd, WM_GETMINMAXINFO, Browse_OnGetMinMaxInfo);  //   3-1-97
	 HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK,	FloorBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN,	FloorBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_RBUTTONDOWN,	FloorBrowse_OnRBDown);
	 default:
		return FloorBrowse_DefProc(hwnd, msg, wParam,lParam);
  }
  return FloorBrowse_DefProc(hwnd, msg, wParam,lParam);
}


//////////////////////////////////////////////////////////////
//																				//
//			END OF Floor BROWSER  CODE								//
//																				//
//////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////
//																				//
//			START OF Sprite (Textures )  BROWSER  CODE 			//
//																				//
//////////////////////////////////////////////////////////////


//----------------------------------------------------------------------//
//   Read in ONLY unique names so no duplicates !
//----------------------------------------------------------------------//

void SetupSprites()
{
 int2 i = 0;
 NameAreaList *listnamwrk;

  TypeThingPtr TempType = ThingNames;     //&DoomThingNames[0];

  for (;  TempType->thingname != NULL ; TempType+=1)
       i++;

  SpriteCount =  i;

  SpriteList = (char **)GetMemory( SpriteCount * sizeof( char *));  // n pointers allocated
  SpriteListNames = (NameAreaList *)GetMemory( (int4) SpriteCount * sizeof(NameAreaList));   //8
  listnamwrk= SpriteListNames;

  TempType = ThingNames;

  for (i = 0; i < SpriteCount; i++)
  {
      SpriteList[i] = (char*)listnamwrk;                            // address to store name
      strncpy( (char *) SpriteList[i], TempType->picname, 8);       // store name
      listnamwrk  = listnamwrk + 1;                                 // next address
		TempType		= TempType + 1;
   }
}

//----------------------------------------------------------------------//
//   Read in All Sprite Names
//----------------------------------------------------------------------//
void SetupAllSprites()
{
   DirPtr dir;
   DirPtr dirend;
   NameAreaList *listnamwrk;
   int4   n;
//-----------------------------------------------------------------------

   // count the names first to optimize getmemory

   dirend = FindMasterDir ( MasterWad, "S_END",TRUE);
   dir    = FindMasterDir ( MasterWad, "S_START",TRUE);
   dir    = dir +1;                             // skip beginning
   SpriteCount = int2(dirend - dir );

   SpriteList      = (char **)GetMemory( (int4) SpriteCount * sizeof( char *) );
   SpriteListNames = (NameAreaList *)GetMemory( (int4) SpriteCount * sizeof(NameAreaList));   //8
   listnamwrk= SpriteListNames;

   // get the names from master dir.            //

   for (n = 0; n < SpriteCount; n++)
   {
      SpriteList[n] = (char*)listnamwrk;                   // address to store name
      strncpy( (char *) SpriteList[n], dir[n].name, 8);    // store name
      listnamwrk  = listnamwrk+1;                          // next address
   }
   qsort( SpriteList, SpriteCount, sizeof( char *), QsortName);
}

/////////////////////////////////////////////////////////////////////////////
//  hdc added
/////////////////////////////////////////////////////////////////////////////
//void DrawTheSprites(HWND hwnd, HDC hdc)
static void DrawTheSprites(HDC hdc)
{
   int2  LocalMagnify;
   int2  magXadjust;
   int2  magYadjust;

	RECT  rc;							// for FrameRect
   HFONT hOldFont;

   int2  i;
   int2  filenumber;
   Bool  LastPicture;

//---------------------------------------------------------------------------

 for (i=FirstItemDrawn; i< SpriteCount; i++)
 {
	if (oldmagnify != CurrentMagnify)
	{
	    Width   = 160;
	    Height  = 128;

	    FirstOrigin=i;
	    HotXloc    =0;

	    Width *=CurrentMagnify;
	    Height*=CurrentMagnify;

	    PicMagnify = CurrentMagnify;       // magnification
	    oldmagnify = CurrentMagnify;

	    Xacross = (BrowseScrMaxX -4 )/ (Width +2);
	    Ydown   = (BrowseScrMaxY    )/ (Height+FontSize);

	    NumberPerScreen = (Xacross * Ydown);
	    CurrXorg =  ( BrowseScrMaxX - Xacross*( Width+8  )-4    )/2;
	    CurrYorg =  ( BrowseScrMaxY - Ydown  *( Height+FontSize))/2;
	    if (CurrYorg < 0) CurrYorg = 0;
	    if (CurrXorg < 0) CurrXorg = 0;
	    CurrYloc = CurrYorg;
	    CurrXloc = CurrXorg;
	}

	strncpy(newname,SpriteList[i],8);

   //KeyPressed = CheckForKeyOrButtonPressed(gd.hMapBrowseWindow);

   //if(!KeyPressed)
   //{
   filenumber = 0;

   if (FindLumpPicSize(newname,&xsize, &ysize, &xoffset,&yoffset) )
	{
	    LocalMagnify = 4*CurrentMagnify;

	    magXadjust = (xsize-5)* LocalMagnify;
	    magYadjust = (ysize-5)* LocalMagnify;

	    // now adjust so it fits in the window (min magnify = 1)

	    while (magXadjust > Width || magYadjust > Height)
	    {  LocalMagnify--;
		    if (LocalMagnify == 1) break;
		    magXadjust = (xsize-5)* LocalMagnify;
		    magYadjust = (ysize-5)* LocalMagnify;
	    }

	     filenumber =  DisplayPic (hdc, CurrXloc,           CurrYloc,
                                       (CurrXloc+Width+5),(CurrYloc+Height-1),
                                        NULL, newname, 0,0, LocalMagnify, InfoBoxColor,NOCENTER);  //   12-20-96
	}
   //}

   if (filenumber == -1)   // main iwad
   {   SetTextColor(hdc, PALETTEINDEX(GameColors[WHITE]));
   }
   else
   {   SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));
	}

   SetBkMode(hdc, OPAQUE);

   //SetTextColor(hdc, GetSysColor(COLOR_CAPTIONTEXT));
   //SetBkColor(hdc, GetSysColor(COLOR_ACTIVECAPTION));
   SetBkColor(hdc, PALETTEINDEX(GameColors[BLACK]));
   hOldFont = SelectFont(hdc, gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));
	TextOut(hdc,CurrXloc,CurrYloc+Height, newname,lstrlen(newname) );

	LastOrigin = i;

	// draw a rectangle around active one
	if  (i == CurrentActive)
	{
        rc.left 	= CurrXloc-1;
        rc. top	= CurrYloc;
        rc.right	= CurrXloc+Width+6;
        rc.bottom = CurrYloc+Height;

	     FrameRect(hdc, &rc, gd.hBrushes[WHITE]);

	     HotXloc = CurrXloc;
	     HotYloc = CurrYloc;
	}

 	if (i == SpriteCount -1)
	{   LastPicture = TRUE;
	}
	else
	{   LastPicture=FALSE;
	}

	CurrXloc+=int2(Width+8);//72


	if (CurrXloc+Width+8 >=BrowseScrMaxX || LastPicture )
	{   CurrXloc  = CurrXorg;
	    CurrYloc =int2(CurrYloc+Height+FontSize);
	    if (CurrYloc+Height+FontSize > BrowseScrMaxY || LastPicture)
       {  LastPicture = TRUE;
       }
   }

   if (LastPicture)
   {   //i=(SpriteCount);			// EXIT our For Loop
	    oldmagnify =-1; //  force change   12-8-96
       break;
   }

 }	// End of for (i=FirstItemDrawn; i< MissionCount; i++)

   BrowseSpriteMag = CurrentMagnify;          //   7-1-97
   if(hOldFont) SelectFont(hdc, hOldFont);
   //KeyPressed = FALSE;
}

//----------------------------------------------------------------------//
//   show the Sprites across the whole screen
//----------------------------------------------------------------------//

void SpriteBrowser ( char * SpriteNameStart )
{
   int2 i;
   RECT rc;

   if(AllSprites) SetupAllSprites();
   else 		      SetupSprites();

   FirstItemDrawn = 0;                // set default 1st   1-5-97
   CurrentActive  = 0;                // current active picture number

   if (SpriteNameStart)
   {
     strncpy(entryname,SpriteNameStart,8); // save entry name

     for (i=0; i < SpriteCount; i++)
     {
         strncpy(newname,SpriteList[i],8);
	      if (!strcmp (newname,SpriteNameStart) )
	      {
	         FirstItemDrawn = i;       // start display with this one
	         CurrentActive = i;
	         break;
         }
     }
   }

   MaxMagnify     	= 3;
   CurrentMagnify 	= BrowseSpriteMag;

   if (CurrentMagnify <= 0) CurrentMagnify = 1;

   oldmagnify     	= -1;
   oldPicMagnify  	= PicMagnify;
   Width      	      = 64;
   Height     	      = 64;
   FirstOrigin	      =  0;          // first on screen

   //KeyPressed 		= FALSE;			// No key waiting

   //OldScrMaxY 		= ScrMaxY;
   //OldScrMaxX 		= ScrMaxX;

   GetClientRect(gd.hSpriteBrowseWindow, &rc);

   BrowseScrMaxY = rc.bottom-12;// -rc.top -24;//   12-25-96
   BrowseScrMaxX = rc.right;    //  -rc.left;

 }

//////////////////////////////////////
// SPRITE BROWSE WM_CREATE
//////////////////////////////////////
#pragma argsused
static BOOL SpriteBrowse_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{

  PostMessage(hwnd, WM_BROWSE, 0, 0);
  // Give our window time to appear
   return TRUE;
}


////////////////////////////////////
// SPRITE BROWSE WM_PAINT: Paint
//////////////////////////////////////
static void SpriteBrowse_OnPaint(HWND hwnd)
{
 	PAINTSTRUCT ps;
   HPALETTE hOldPal;

	//HDC hdc = BeginPaint(hwnd, &ps);
	BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

   if(OKtoMapDraw)
   {
     DrawTheSprites(ps.hdc);
   }

   SelectPalette(ps.hdc, hOldPal, FALSE);
	EndPaint(hwnd, &ps);
}

////////////////////////////////////////////////////////////////////
// Our Finish Up Routine called on Esc, Enter, Left Button DblClick
////////////////////////////////////////////////////////////////////
static void SpriteBrowseEnd()
{
  BrowseSpriteMag = CurrentMagnify; // was commented out ?   7-1-97

  OKtoMapDraw = FALSE;
  Browsing    = FALSE;
  EndBrowse   = TRUE;

  if (CurrentActive >=0 && CurrentActive < SpriteCount)
  {   strncpy(newname,SpriteList[CurrentActive],8);
  }
  else strncpy(newname, entryname, 8);

  //ScrMaxY = OldScrMaxY;
  //ScrMaxX = OldScrMaxX;

  FreeMemory(SpriteListNames);
  FreeMemory(SpriteList);

  strcpy(SpriteName, newname);
  PostMessage(gd.hParent, WM_COMMAND, WM_BROWSE_BACK, 0);

  DeePDestroyWindow(gd.hSpriteBrowseWindow);

}

///////////////////////////////////////////////////////////////////////////////
// Arrow keys  Sprite Browser
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void SpriteBrowse_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
  HDC hdc;
  EndBrowse=FALSE;

  hdc = GetDC(hwnd);
  oldmagnify = -1;

 switch(vk)
 {
  case VK_END:
	BrowseEnd(hwnd, SpriteCount);
   break;

  case VK_HOME:
	BrowseHome(hwnd);
   break;

  case VK_ESCAPE:
   CurrentActive = -1;
   SpriteBrowseEnd();
   break;

  case VK_RETURN:
   SpriteBrowseEnd();
   break;


  case VK_DOWN:
	BrowseDown(hwnd, 6, 0, WHITE);    //width + x, height - x, FrameColor
   break;

  case VK_UP:
	BrowseUp  (hwnd, 6, 0, WHITE);    //width + x, height - x, FrameColor
   break;

  case VK_LEFT:
	BrowseLeft(hwnd, 6, 8, 0, WHITE); //width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_RIGHT:
	BrowseRight(hwnd, 6, 8, 0, WHITE);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_PRIOR:														// Page Up
	BrowsePgUp(hwnd, SpriteCount);
	break;

  case VK_NEXT:														// Page Down
	BrowsePgDn(hwnd, SpriteCount);
	break;

  case VK_F1:
   HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,
                               (DWORD)"Texture Browsing Commands");
   break;
 }

 if (!EndBrowse)    //  
 {
   if(CurrentActive != -1 && CurrentActive < SpriteCount)//	Can happen on ESC then returns here
   {
      strncpy(newname,SpriteList[CurrentActive],8);

      if (FindLumpPicSize(newname,&xsize,&ysize,&xoffset,&yoffset) )
      {
          DisplayCaptionText(hwnd,300,5," %s , %hd x %hd (offset %hd,%hd)",newname, xsize, ysize, xoffset, yoffset);
      }
   }
 }

 ReleaseDC(hwnd, hdc);
}

//==================================================================================

#pragma argsused
static void SpriteBrowse_OnLBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
  BrowseLBDown(hwnd, 8, 6, 0, WHITE, MouseX, MouseY, SpriteCount);  //   12-25-96

  if (fDoubleClick)
  {
      CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
      SpriteBrowseEnd();
      return;
  }
}

//==================================================================================

#pragma argsused
static void SpriteBrowse_OnRBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
     CurrentActive = -1;
     CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
     SpriteBrowseEnd();
     return;
}
///////////////////////////////////////////////////////////////////
//
//		The Entry point which creates the window to Browse Sprites
//
//////////////////////////////////////////////////////////////////
//#pragma argsused
void SpriteBrowseWindow(char * spritename)   // hav 1-5-97
{
   if (spritename)                            //   1-5-97
   {   strncpy(entryname, spritename, 8);
   }
   else
   {   entryname[0] = 0;                      //   1-5-97
   }

	// Create our SPRITE BROWSE Window
   gd.hSpriteBrowseWindow =	CreateWindowEx(WS_EX_OVERLAPPEDWINDOW | WS_EX_DLGMODALFRAME,
                                             szLoadString(IDS_SPRITEBROWSENAME),
                                             szLoadString(IDS_SPRITEBROWSENAME),
                                             WS_POPUP | WS_CAPTION,
                                             0, 0,            //origin
                                             CW_USEDEFAULT,   //width
                                             CW_USEDEFAULT,   //height
                                             gd.hMainWindow,
                                             NULL,
                                             gd.hInst,
                                             NULL);

  ShowWindow(gd.hSpriteBrowseWindow, SW_MAXIMIZE);
  UpdateWindow(gd.hSpriteBrowseWindow);

}

////////////////////////////////////////////////////////////////////////////////
// SpriteBrowseWndProc
////////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK SpriteBrowseWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
	case WM_BROWSE:                      // start
     SpriteBrowser(entryname);          // init the list of names
     OKtoMapDraw = TRUE;
     InvalidateRect(hwnd, NULL, TRUE);
     UpdateWindow(hwnd);
     break;

	 HANDLE_MSG(hwnd, WM_CREATE, 			SpriteBrowse_OnCreate);
	 HANDLE_MSG(hwnd, WM_PAINT, 			SpriteBrowse_OnPaint);
	 HANDLE_MSG(hwnd, WM_CHAR, 			MapBrowse_OnChar);        // SAME CODE
	 HANDLE_MSG(hwnd, WM_KEYDOWN, 		SpriteBrowse_OnKey);
    HANDLE_MSG(hwnd, WM_GETMINMAXINFO, Browse_OnGetMinMaxInfo);  //   3-1-97
	 HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK,	SpriteBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN,	SpriteBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_RBUTTONDOWN,	SpriteBrowse_OnRBDown);
	 default:
		return SpriteBrowse_DefProc(hwnd, msg, wParam,lParam);
  }
		return SpriteBrowse_DefProc(hwnd, msg, wParam,lParam);
}


//////////////////////////////////////////////////////////////
//																				//
//			END OF Sprite BROWSER  CODE								//
//																				//
//////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////
//																				//
//			START OF BROWSER CODE Entry Points						//
//																				//
//////////////////////////////////////////////////////////////
/*
MapBrowse()
TxtrBrowse(char * wallname)
FloorBrowse(char * floorname)
SpriteBrowse(char * spritename)
*/

//////////////////////////////////////////////////////////////////////////////
// get a new texture
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
LPSTR GetNewTextureName(HWND hwnd, LPSTR oldname, LPSTR heading)
{
   TXTR1 txtr;

   ZeroMemory(&txtr, sizeof(txtr));

   GettingTexture = TRUE;                // prevent double entry
	strncpy(txtr.Txtr1, oldname, 8);
   if(heading == NULL)  strcpy( txtr.Txtr2, "Choose Wall");
   else                 strcpy( txtr.Txtr2, heading);

	if( DialogBoxParam(gd.hInst, "ChooseTxtr", hwnd, ChooseTxtrDlgProc, (LPARAM)(LPSTR)&txtr) )
 	{
  	   strcpy(oldname, txtr.Txtr1);
      GettingTexture = FALSE;
  	   return oldname;
 	}

   GettingTexture = FALSE;
   return NULL;
}

//////////////////////////////////////////////////////////////////////////////
// get a new floor
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
LPSTR GetNewFloorName(HWND hwnd, LPSTR oldname, LPSTR heading)
{
  TXTR1 txtr;  	// just a char[10] inside a wrapper to add to later,  maybe . . .

  ZeroMemory(&txtr, sizeof(txtr));
  GettingTexture = TRUE;

  strncpy(txtr.Txtr1, oldname, 8);
  if(heading == NULL)  strcpy( txtr.Txtr2, "Choose Floor");
  else                 strcpy( txtr.Txtr2, heading);

  if( DialogBoxParam(gd.hInst, "ChooseFloor", hwnd, ChooseFloorDlgProc, (LPARAM)(LPSTR)&txtr) )
  {
      strcpy(oldname, txtr.Txtr1);
      GettingTexture = FALSE;
  	   return oldname;
  }
  GettingTexture = FALSE;
  return NULL;
}

//////////////////////////////////////////////////////////////////////////////
// get a new thing
//////////////////////////////////////////////////////////////////////////////
/* not used anywhere
#pragma argsused
LPSTR GetNewThingName(HWND hwnd, LPSTR oldname, LPSTR heading)
{
 TXTR1 txtr;  	// just a char[10] inside a wrapper to add to later,  maybe . . .

 AllSprites = FALSE;

	strcpy(txtr.Txtr1, oldname);
   if(heading == NULL)  strcpy( txtr.Txtr2, "New Thing");
   else                 strcpy( txtr.Txtr2, heading);

	if( DialogBoxParam(gd.hInst, "ChooseThing", hwnd, ChooseThingDlgProc, (LPARAM)(LPSTR)&txtr) )
 	{
  	 strcpy(oldname, txtr.Txtr1);
  	 return oldname;
 	}
  return NULL;

}
*/
//  Choose for Dos compat

//----------------------------------------------------------------------//
//   choose a wall texture
//----------------------------------------------------------------------//

// 12-30-96 bk Changed sequence of parms ( Reason Find and Check were not working )

Bool ChooseWallTexture(HWND hwnd, char *name, char *prompt)
{
   GetNewTextureName(hwnd, name, prompt);

   if (name  == NULL)
      return FALSE;
   else
      return TRUE;

}
//----------------------------------------------------------------------//
//   choose a Floor texture
//----------------------------------------------------------------------//

// 12-30-96 bk Changed sequence of parms ( Reason Find and Check were not working )

Bool ChooseFloorTexture(HWND hwnd, char *name, char *prompt)
{
   GetNewFloorName(hwnd, name, prompt);

   if (name  == NULL)
      return FALSE;
   else
      return TRUE;

}




///////////////////////////////////////////////////////////////////////////////////
//
//  save an ImageBuffer format and convert to PCX format
//  current Game palette is always used
//
//   MUST be in NEWGRAPH.CPP since it uses Bitmap Info structure for sizes !
//
// 1-1-97 bk modified to work now
// 3-1-97   this routine /graphics stuff should be redesigned to
//        work like DOS. allocate control structure, followed by image
//        Then image header stuff controls, not globals--someday...when the mood strikes

///////////////////////////////////////////////////////////////////////////////////

Bool SavePCX(HWND hwnd, char*pcxname,byte *imageBufr,byte *palBufr)
{
   Bool   DoSave  = FALSE;
   char   *dotp;
   char   TempName[260] = "";
//==============================================================================
   char  drive     [ 4]= {0};  // 2 'C:'  (+leading 03 for drive picture control)   5-1-97
   char  directory[260]= {0};  // 31 (28)Includes leading, trailing backslashes (\)
   char  filename [260]= {0};  // 39 12345678 (260 win32)
   char  ext      [260]= {0};  // 43 .xxx     (260 win32)

   int   flags;

static  char PriorDir[260]={0};  // track last dir used
//==============================================================================

   FILE  *FileANY;

   int4   x,y;
   int4   Xwidth  = ImageXSize;
   int4   Yheight = ImageYSize;          //   1-10-97 was minus, but changed other stuff
   int4   Xalign = (ImageXSize+3)&~3; // DWORD Aligned

   // this technique is much easier to maintain and more flexible

   //int2   Xwidth  = ((uint2 *) imageBufr)[0];       // width
   //int2   Yheight = ((uint2 *) imageBufr)[1];       // height
   //int2   Xalign = ((uint2 *) imageBufr)[5];       // row bytes

   byte   EndControl = 0x0c;                        // has to be at end of data
   byte   Num193     = 193;
   byte   WrkByte;

   int4   CumCount;                                 // count of repeats
   byte   PriorByte;                                // prior byte

   byte  *ImageBytePtr;                             // location in ImageBufr
   byte *imageBufr1;                                // SAVE old pointer since
   struct PCXHeaderType PCXHeader={0};              // GetSaveName trashes it

   //byte  *ColorPalette;                           //   3-1-97 simplify
   //DirPtr ColorDir;                               // current game palette

   //-----------------------------------------------------------------------
   if (!DeePRegistered)
   {  if (ImageXSize > 64
      ||  ImageYSize > 64)
      {
          OnlyRegBigGraphicSave();     // tell only registered this big
          return FALSE;
      }
   }

   PCXHeader.manufacturer    = 0x0A;
   PCXHeader.version         = 0x05;
   PCXHeader.encoding        = 0x01;
   PCXHeader.bits_per_pixel  = 0x08;
   PCXHeader.xend            = Xwidth -1;
   PCXHeader.yend            = Yheight-1;
   PCXHeader.xwidth          = Xwidth;
   PCXHeader.yheight         = Yheight;
   PCXHeader.num_color_planes= 0x01;
   PCXHeader.bytes_per_line  = Xalign;
   PCXHeader.palette_type    = 2;   //0x0201; stored as 0102

   //-----------------------------------------------------------------------------

   strcpy(TempName,PriorDir);       // prior drive:\dir +
   strcat(TempName,pcxname);
   dotp = strrchr( TempName, '.');  // find . (reverse)

   if (dotp == NULL)
   {  strcat( TempName, ".PCX");    // add .PCX
   }
   else
   {  strcpy( dotp, ".PCX");        // replace .any
   }

   imageBufr1 = imageBufr;    // same here since its global

   //GetSaveName(hwnd,"PCX name", TempName,256, (char *)szLoadString(IDS_FILTERPCX) ); // PCX FILTERLUMP1   3-1-97
   GetSaveName(hwnd,"PCX name", TempName,256, IDS_FILTERPCX ); // PCX FILTERLUMP1   3-1-97

   if(TempName[0] != '\0'
   && !FileIsInUse(TempName,TRUE,FALSE) )   // msg + no set TempName to '\0'   5-1-97
   {
      flags = fnsplit(TempName,drive,directory,filename,ext);  //   5-1-97

      // keep any dir info now set

      if ((flags & DRIVE)
      &&  (flags & DIRECTORY))
      {    _makepath(PriorDir,drive,directory,NULL,NULL);  // create default dir
      }

      FileANY = FileOpen(TempName, "w+b",OPENMISS);    // new open

	   if (FileANY)
      {   DoSave = TRUE;
	       // header
	       WriteBytes( FileANY, &PCXHeader, sizeof(struct PCXHeaderType) );

	       CumCount = 0; // repeat counter

	       for (y=0; y< Yheight; y++)                     // Y
	       {
		        ImageBytePtr = &imageBufr1[ y*Xalign];

		        for (x=0; x < Xalign; x++,ImageBytePtr+=1) // X
		        {
		          WrkByte = *ImageBytePtr;

		          if (CumCount == 0)                 // first time
		          {   CumCount  = 1;
			           PriorByte = WrkByte;           // save prior for compare
		          }
		          else
		          {   if (WrkByte == PriorByte)      // repeat
			           {   CumCount++;
			               if (CumCount >=63)         // 63 max
			               {   CumCount = (CumCount + 192);
				                WriteBytes( FileANY,&CumCount, 1); // repeat control
				                WriteBytes( FileANY,&PriorByte,1); // byte
				                CumCount = 0;                      // 0 now
			               }
			           }
			           else // different character, write out any same
			           {
			             if (CumCount > 0)                        // any accumulated
			             {  if (CumCount > 1)
				             {   CumCount = (CumCount + 192);
				                 WriteBytes( FileANY,&CumCount, 1); // repeat control
				                 WriteBytes( FileANY,&PriorByte,1); // byte
				             }
				             else // only 1 byte
				             {   if (PriorByte < 192)
				                 {   WriteBytes( FileANY,&PriorByte,1); // byte
				                 }
				                 else
				                 {  WriteBytes( FileANY,&Num193, 1);    // repeat control
					                 WriteBytes( FileANY,&PriorByte,1);  // byte
				                 }
				             }
				             CumCount = 1;                      // 1 now
			             }

			             PriorByte = WrkByte;
			           }
		            }
		        } // end of X

		        // flush out X last- write out any remaining-
		        // has to be done now, some programs have dumb logic to read PCX

		        if (CumCount > 0)
		        {   CumCount = (CumCount + 192);
		            WriteBytes( FileANY,&CumCount, 1); // repeat control
		            WriteBytes( FileANY,&PriorByte,1); // byte
		            CumCount = 0;
		        }
	       } // end of Y

	       WriteBytes( FileANY,&EndControl,1);       // byte 0x0c eof required

	       //------ write color palette last--------------
	       if (!palBufr)
	       {
		        //ColorPalette= (byte *)GetMemory(768);
		        //ColorDir = FindOnlyMaster("PLAYPAL", TRUE);     // search only main IWAD

		        //WadSeek( MasterWad->fileinfo, ColorDir->start);
		        //WadRead( MasterWad->fileinfo, ColorPalette, 768); // this game
		        //WriteBytes( FileANY,ColorPalette, 768);
		        //FreeMemory(ColorPalette);
		        WriteBytes( FileANY,DoomPalette, 768);     // always current game
	       }
	       else
	       {
		        WriteBytes( FileANY,palBufr, 768);
	       }
	       fclose(FileANY);

          //CreateDialogParam(gd.hInst,"Completion", hwnd, CompletionDlgProc, (LPARAM)(LPSTR)"PCX Saved Successfully");
          ShowStatus(hwnd,"PCX Saved Successfully");
	   }
	   else
	   {
	       DoSave = FALSE;
	   }
      //}
   }
   return DoSave;
}

//static UINT SpriteTimer	= 6;

////////////////////////////////////////////////////////////////////////////////
//  The Deep Sprite Browse HACK DLG  == called by MENU.CPP ==
//
// Since SpriteBrowse uses some of the same keystrokes as the MainWindow
// Loop we need to start the Browse Process from a source that does not.
// Thus a Dialog that launches the Windows Process and then returns after
// the user Esc's or chooses a new Thing
//
////////////////////////////////////////////////////////////////////////////////
/*
#pragma argsused
BOOL CALLBACK SpriteBrowseDlgProc(DIALOG_PARAMS)
{
//LevelPtr level = &LevelWad.level;
//
//TypeThingPtr TempType;
//
//SelPtr  obj = NULL;
//SelPtr  cur;
//int2    type = 0;
//static Bool teatime = TRUE;
static POINT EntryCurPos;                   //   12-16-96

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch(msg)
  {
	 case WM_INITDIALOG:
      GetCursorPos( &EntryCurPos );         //   12-20-96 remember location
      gd.hParent = hDlg;                    // save globally for SpriteBrowse
      SetTimer(hDlg, SpriteTimer, 1, NULL); // Quick as possible
	   return TRUE;                          // or FALSE if we set our own focus


	 case WM_TIMER:
    	if (SpriteTimer==wParam)		        //  12-20-96  has to check, it blows up +/1 after screensaver
     	{
         SpriteBrowseWindow("");            // start at beginning - no name
	      KillTimer(hDlg, SpriteTimer);
     	   return 0;                          // = message processed
      }
	   return 1;                             // = not processed

	 case WM_COMMAND:
		switch LOWORD(wParam)
      {
       // case IDOK:                   //   3-1-97 exit done at browse_back
		 // 	EndDialog(hDlg, IDOK);
		 //  return TRUE;

	     case WM_BROWSE_BACK:
         //
         SetCursorPos(EntryCurPos.x, EntryCurPos.y);
         PointerX = EntryCurPos.x;
         PointerY = EntryCurPos.y;
		  	EndDialog(hDlg, IDOK);   //   3-1-97 just end here
         break;
      }
	   break;
  }
  return FALSE;
}
*/

////////////////////////////////////////////////////////////////////////////////
//								                   												//
//			START OF PNAME  BROWSER  CODE 	                  	         		//
//																				                  //
////////////////////////////////////////////////////////////////////////////////

static void DrawThePnames(HDC hdc)
{
	RECT rc;							// for FrameRect
   HFONT hOldFont;

   int2 i;
   int2  filenumber;          //  

   Bool LastPicture;

 for (i=FirstItemDrawn; i< BrowsePnameCount; i++)
 {
	if (oldmagnify != CurrentMagnify)
	{
	    Width   = 64;
	    Height  = 64;

	    FirstOrigin=i;
	    HotXloc    =0;

	    if (CurrentMagnify == 2)
	    {   Width *=(CurrentMagnify+2); //
           Height*=(CurrentMagnify+2); //
	    }
	    else
	    if (CurrentMagnify == 3)
	    {   Width *=(CurrentMagnify+6); //
           Height*=(CurrentMagnify+3); //
	    }
	    else
	    {   Width *=(CurrentMagnify+1); //
           Height*=(CurrentMagnify+1); //
	    }

	    oldmagnify = CurrentMagnify;
	    PicMagnify = CurrentMagnify;         // magnification

	    Xacross = (BrowseScrMaxX -4 ) / (Width + 8);
	    Ydown   = (BrowseScrMaxY    ) / (Height+FontSize);

	    NumberPerScreen = (Xacross * Ydown);
	    CurrXorg =  ( BrowseScrMaxX - Xacross*( Width+8  ) -4   )/2;
	    CurrYorg =  ( BrowseScrMaxY - Ydown  *( Height+FontSize))/2;
	    if (CurrYorg < 0) CurrYorg = 0;
	    if (CurrXorg < 0) CurrXorg = 0;
	    CurrYloc = CurrYorg;
	    CurrXloc = CurrXorg;
	}

	strncpy(newname,BrowsePnameBuffer[i].name,8);

   // filenumber  = DisplayATexture(hdc, CurrXloc,           CurrYloc,
   //                              (CurrXloc+Width+5),(CurrYloc+Height-1),
   //                               0,0, newname,"+");//+ignore
   if (PicMagnify < 1) PicMagnify = 1;

   filenumber = DisplayPic(hdc, CurrXloc,  CurrYloc,
                               (CurrXloc+Width+5),(CurrYloc+Height-1),
                                NULL, newname,
                                0,0, PicMagnify,InfoBoxColor,NOCENTER);

   if (filenumber== -1) // main IWAD - a bit better doc, that's all- so I don't forget
   {
       SetTextColor(hdc, PALETTEINDEX(GameColors[WHITE]));
   }
   else
   {   SetTextColor(hdc, PALETTEINDEX(GameColors[YELLOW]));//RED]));
	}

   SetBkMode(hdc, OPAQUE);
   SetBkColor(hdc, PALETTEINDEX(GameColors[BLACK]));

   hOldFont = SelectFont(hdc, gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));
	TextOut(hdc,CurrXloc,CurrYloc+Height, newname,lstrlen(newname) );

	LastOrigin = i;

	// draw a rectangle around active one
	if  (i == CurrentActive)
	{
        rc.left 	= CurrXloc-1;
        rc. top	= CurrYloc;
        rc.right	= CurrXloc+Width+6;
        rc.bottom = CurrYloc+Height;

	     FrameRect(hdc, &rc, gd.hBrushes[WHITE]);

	     HotXloc = CurrXloc;
	     HotYloc = CurrYloc;
	}

 	if (i == BrowsePnameCount -1)
	{   LastPicture = TRUE;
	}
	else
	{   LastPicture=FALSE;
	}

	CurrXloc+=(Width+8);//72

	if (CurrXloc+Width+8 >=BrowseScrMaxX || LastPicture )
	{   CurrXloc = CurrXorg;
	    CurrYloc = (CurrYloc+Height+FontSize);
	    if (CurrYloc+Height+FontSize > BrowseScrMaxY || LastPicture)
       {  LastPicture = TRUE;
       }
   }

   if (LastPicture)
   {   oldmagnify =-1; //  force change   12-8-96
       break;
   }

 }	// End of for (i=FirstItemDrawn; i< MissionCount; i++)

  BrowseTextureMag = CurrentMagnify;
  if(hOldFont) SelectFont(hdc, hOldFont);
}


//----------------------------------------------------------------------//
//   show PNAMES across the whole screen
//----------------------------------------------------------------------//
#pragma argsused
static void PnameBrowseDisplay ( char * patchName )
{
 int2 i;
 RECT rc;

   if (patchName)
   {
      strncpy(entryname,patchName,8);              // save entry name

       for (i=0; i < BrowsePnameCount; i++)
       {
         strncpy(newname,BrowsePnameBuffer[i].name,8);
	      if (!strcmp (newname,patchName) )
	      {
	         FirstItemDrawn = i;    // start display with this one
	         CurrentActive = i;
	         break;
	      }
      }
   }
   else
   {
    	FirstItemDrawn = 0;
		CurrentActive = 0;          // current active picture number
	}

  MaxMagnify     	= 3;
  CurrentMagnify 	= BrowseTextureMag;
  oldmagnify     	= -1;
  oldPicMagnify  	= PicMagnify;
  Width      		= 64;
  Height     		= 64;

  GetClientRect(gd.hPnameBrowseWindow, &rc);

  BrowseScrMaxY = rc.bottom -12;// -rc.top -24;   //   12-8-96
  BrowseScrMaxX = rc.right;     // -rc.left;

}

//////////////////////////////////////
// WM_CREATE                         /
//////////////////////////////////////
#pragma argsused
static BOOL PnameBrowse_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
   PostMessage(hwnd, WM_BROWSE, 0, 0);
   // Give our window time to appear
   return TRUE;
}


//////////////////////////////////////
// Handle WM_PAINT: Paint            /
//////////////////////////////////////
static void PnameBrowse_OnPaint(HWND hwnd)
{
 	PAINTSTRUCT ps;
   HPALETTE hOldPal;

	HDC hdc = BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

   if(OKtoMapDraw)
   {
      DrawThePnames(hdc);
   }

   SelectPalette(ps.hdc, hOldPal, FALSE);
	EndPaint(hwnd, &ps);
}

///////////////////////////////////////////////////////////////////////
// Our Finish Up Routine called on Esc, Enter, Left Button DblClick   /
///////////////////////////////////////////////////////////////////////
static oldBrowseMode;

static void PnameBrowseEnd()
{
   OKtoMapDraw = FALSE;
   Browsing    = FALSE;

   BrowseTextureMag = CurrentMagnify;

   PicMagnify = oldPicMagnify;

   if (CurrentActive >=0 && CurrentActive < BrowsePnameCount)
   {   strncpy(newname,BrowsePnameBuffer[CurrentActive].name,8);
   }
   else
   {   strncpy(newname, entryname, 8);
   }

   strcpy(TxtrName, newname);

   FreeMemory(BrowsePnameBuffer);
   BrowsePnameBuffer = NULL;
   BrowsePnameCount  = 0;
   BrowseMode = oldBrowseMode;         // since always from there for now

   DeePDestroyWindow(gd.hPnameBrowseWindow);

   PostMessage(gd.hParent, WM_COMMAND, WM_BROWSE_BACK, 0);
}

//////////////////////////////////////
// enter key, - key, + key
//////////////////////////////////////
#pragma argsused
static void PnameBrowse_OnChar(HWND hwnd, UINT ch, int cRepeat)
{
	BrowseChar(hwnd, ch, 0);//min magnify 0 or 1
}

//////////////////////////////////////
// Arrow keys
//////////////////////////////////////
#pragma argsused
static void PnameBrowse_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
  HDC hdc;
//  int2     xsize;           // width in pixels of texture
//  int2     ysize;           // height in pixels of texture
//  int2     patchnum;        // number of wall patches used to build this texture
//  byte    *texofs;          // offset in the wad file to the texture data
//  WadFiles TextureWad;      // the texture directory (usually MasterWad)

  hdc = GetDC(hwnd);

  oldmagnify = -1;
//  NotifyMsg(NULL,"vk=%d",vk);

 switch(vk)
 {
  case VK_END:
	BrowseEnd(hwnd, BrowsePnameCount);
   break;

  case VK_HOME:
	BrowseHome(hwnd);
   break;

  case VK_ESCAPE:
   CurrentActive = -1;
   PnameBrowseEnd();
   break;

  case VK_RETURN:
   PnameBrowseEnd();
   break;

  case VK_DOWN:
	BrowseDown(hwnd, 6, 0, WHITE);    //width + x, height - x, FrameColor
   break;

  case VK_UP:
	BrowseUp(hwnd, 6, 0, WHITE);      //width + x, height - x, FrameColor
   break;

  case VK_LEFT:
	BrowseLeft(hwnd, 6, 8, 0, WHITE);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_RIGHT:
	BrowseRight(hwnd, 6, 8, 0, WHITE);//width + x, hotwidth + x, height - x, FrameColor
   break;

  case VK_PRIOR:														// Page Up
	BrowsePgUp(hwnd, BrowsePnameCount);
	break;

  case VK_NEXT:														// Page Down
	BrowsePgDn(hwnd, BrowsePnameCount);
	break;

  case VK_F1:
   HelpOpened = WinHelp(hwnd, HelpName, HELP_KEY,
                               (DWORD)"Texture Browsing Commands");
   break;
 }

 if(CurrentActive != -1 && CurrentActive < BrowsePnameCount)//	Can happen on ESC then returns here
 {
 	 strncpy(newname,BrowsePnameBuffer[CurrentActive].name,8);
    if (GetPatchTextureSize(&xsize, &ysize, newname) )
	 {
	     DisplayCaptionText(hwnd,300,5," %s , %hd x %hd ",newname, xsize, ysize);
	 }
 }
 ReleaseDC(hwnd, hdc);
}

///////////////////////////////////////////////////////////////////////////////

#pragma argsused
static void PnameBrowse_OnLBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
//  int2     patchnum;        // number of wall patches used to build this texture
//  byte    *texofs;          // offset in the wad file to the texture data
//  WadFiles TextureWad;      // the texture directory (usually MasterWad)

  BrowseLBDown(hwnd, 8, 6, 0, WHITE, MouseX, MouseY, BrowsePnameCount);   //   12-25-96

  if (fDoubleClick)
  {
     CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
     PnameBrowseEnd();
     return;
  }

  if(CurrentActive != -1 && CurrentActive < BrowsePnameCount)//	Can happen on ESC then returns here
  {
     strncpy(newname,BrowsePnameBuffer[CurrentActive].name,8);
     if (GetPatchTextureSize(&xsize, &ysize, newname) )
     {
	      DisplayCaptionText(hwnd,300,5," %s , %hd x %hd  ",newname, xsize, ysize);
     }
  }
}
//////////////////////////////////////////////////////////////////////////////////
#pragma argsused
static void PnameBrowse_OnRBDown(HWND hwnd, BOOL fDoubleClick, int MouseX, int MouseY, UINT kFlag)
{
     CurrentActive = -1;
     CheckActivity(NULL,WAIT);    //   8-1-97 trap button up
     PnameBrowseEnd();
     return;
}
////////////////////////////////////////////////////////////////////////////////
//                                                                             /
//		The Entry point which creates the window to Browse Textures Patches      /
//    8-1-97                                                                   /
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void PnameBrowse(char * patchName,int4 PnameCompositeCount,byte* PnameCompositeBuffer)
{
  int4 n;
  byte          *PnameBufferLoc;  // index into PNAME buffer
  PatchAreaList *PatchAreaWrk;    // list of resident texture names,x y, #pathes

  TextureBrowsing = 2;                   // which browse texture=1 or pnames=2
  oldBrowseMode = BrowseMode;            // save current mode
  BrowseMode    = TEXTUREPNAMES;         // signal for onchar

  strncpy(entryname, patchName, 8);

  BrowsePnameCount = PnameCompositeCount;
  BrowsePnameBuffer = (PatchAreaList *)GetMemory( BrowsePnameCount * sizeof(PatchAreaList) );

  PnameBufferLoc = PnameCompositeBuffer+4;                     // skip size
  PatchAreaWrk   = BrowsePnameBuffer;

  for (n = 0; n < BrowsePnameCount; n++,PnameBufferLoc +=8)
   {
      strncpy((char *)PatchAreaWrk->name, (char *)PnameBufferLoc,8);     // name of patch
      PatchAreaWrk->loc = NULL;                         // where it will be stored
      PatchAreaWrk->size= 0;                            // size of patch init to 0
      PatchAreaWrk->filenum=0;                          // init file to Main for now

      PatchAreaWrk    = PatchAreaWrk+1;                 // next address store
   }

  // Create our BROWSE Window

  gd.hPnameBrowseWindow = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW | WS_EX_DLGMODALFRAME,
                                        szLoadString(IDS_PNAMEBROWSENAME),              // class name
                                        szLoadString(IDS_PNAMEBROWSENAME),
                                        WS_POPUP | WS_CAPTION,
                                        0, 0,
                                        CW_USEDEFAULT,
                                        CW_USEDEFAULT,
                                        gd.hMainWindow,
                                        NULL,
                                        gd.hInst,
                                        NULL);

  ShowWindow(gd.hPnameBrowseWindow, SW_MAXIMIZE);
  UpdateWindow(gd.hPnameBrowseWindow);
}

//////////////////////////////////////
// PnameBrowseWndProc
//////////////////////////////////////
LRESULT CALLBACK PnameBrowseWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
	case WM_BROWSE:
     PnameBrowseDisplay(entryname);		// pass our TextureName saved on call
     OKtoMapDraw = TRUE;
     InvalidateRect(hwnd, NULL, TRUE);
     UpdateWindow(hwnd);
     break;

	 HANDLE_MSG(hwnd, WM_CREATE, 			PnameBrowse_OnCreate);
	 HANDLE_MSG(hwnd, WM_PAINT, 			PnameBrowse_OnPaint);
	 HANDLE_MSG(hwnd, WM_CHAR, 			PnameBrowse_OnChar);
	 HANDLE_MSG(hwnd, WM_KEYDOWN, 		PnameBrowse_OnKey);
    HANDLE_MSG(hwnd, WM_GETMINMAXINFO, Browse_OnGetMinMaxInfo);  //   3-1-97
	 HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK,	PnameBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN,	PnameBrowse_OnLBDown);
	 HANDLE_MSG(hwnd, WM_RBUTTONDOWN,	PnameBrowse_OnRBDown);
	 default:
		return PnameBrowse_DefProc(hwnd, msg, wParam,lParam);
  }
  return PnameBrowse_DefProc(hwnd, msg, wParam,lParam);
}

//////////////////////////////////////////////////////////////
//																				//
//			END OF PNAME   BROWSER  CODE								//
//																				//
//////////////////////////////////////////////////////////////



//////////////////////////////   end    ///////////////////////////////////////
