/////////////////////////////////////////////////////////////////////////
//		Utils.cpp
/////////////////////////////////////////////////////////////////////////

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "deep.h"
#include "windeep.h"
#pragma hdrstop

#include <dlgs.h>		      // header for control defines   6-1-97
#include <mmsystem.h>
#include <string.h>
#include <math.h>
#include <commctrl.h>      //PBM_SET

void SoundBeepError(int2 BeePType);   // for HelpMsg only for now


Bool BeenNotified = TRUE;

byte    DoomPalette[768];  	// doom pal array just allocate it permanent
RGBQUAD dRGBquad[257];

int2 ht;
int2 wt;
int2 ht2;
int2 wt2;
int2 ht12;
int2 wt12;		// Height, Height + 2, ( 1.5 * Height )

typedef struct                    	// used for Button only Dialogs
{
// int4       x0;
// int4       y0;
   int4       paint;        // count paint to see if buttons need to be done
   int4       type;         // 0=info, 1=info/button, 2=error, 2 buttons
   Bool       center;
   Bool       solid;
   int4       width;        // in pixels
   int4       height;
   char      *heading;
   ColorText *prompt;

} HelpInfo, *lpHelpInfo;


typedef struct                    	// used for Button only Dialogs
{  //RECT *rc;                        // rectange of where to put button
   HWND ownerhwnd;
   int2 option;                     // option CenterX, CenterY
   int4 xadj;                       // amt to move
   int4 yadj;                       // amt to move
   int2 ibutton;			   			// returns button value here
   char sz1[80];   						// button1 text
   char sz2[80];                    //       2
   char sz3[80];							//       3
   char sz4[80];                    //       4
} BUTTONCONTROL, *LPBUTTONCONTROL;


/*

	SetVertexSize
	LoadDoomPalette
	ClearSystemPalette
	ContrainCursor

	MakePens
   MakeFonts
   SetTextType
   ForgetPens
   ForgetFonts
   CheckAndDeletePen
   CheckAndDeleteBrush

	Deep_NotYet
	ReallyCancel
	Center Dialog
	Center Window
	EraseWindow
	szLoadString
   SoundBeep
	ProgError
   NotifyMsg  was notify   11-11-96
   ErrorMsg   like Notify, with stopicon   3-1-97
   Confirm
	MyMessageBox
	MaximizeWindow
   NormalizeWindow
	SetGameMask
	CenterMapAroundCoords
   CalculateMinMax(LevelPtr level)

    ScreenColorText(HDC hdc, int4 Xstart, int4 Ystart, int2 TColor, char *msg)
    ScreenBkText(HDC hdc, int4 Xstart, int4 Ystart, int2 TColor, int2 BkColor, char *msg)

    HBITMAP ScreenToMemDC(HWND hwnd,int4 Xleft,int4 Ytop,int4 Xright,int4 Ybottom)

	 DrawScreenText(HDC hdc, int2 Xstart, int2 Ystart, char *, ...);
	 DrawScreenTextOutline(HDC hdc, int2 Xstart,int2 Length,OutlineColor, char *msg, ...);
    DrawScreenTextOutlineScale(HDC hdc, int2 Xstart, int2 Ystart,int2 OutlineColor, char *msg, ...)
	 DrawScreenTextOutline3D(HDC hdc, int2 Xstart OutlineColor,char *msg, ...);
	 Draw3DRectangle(HDC PaintDC, RECT *rc);
	 Draw3DFrame(HDC PaintDC, RECT *rc);
	 Draw3DFrameIn(HDC PaintDC, RECT *rc);
	 DrawScreenBox3D(HDC PaintDC, int Left, int , HBRUSH hBrush );
    DrawScreenBox3DRaw(HDC hdc, int Left, int Top, int Right, int Bottom, int FillColor )
	 DrawScreenBox  (HDC PaintDC, int Left, int , HBRUSH hBrush );
    DrawMapArrow
    DrawMapVector
    DrawMapCross
	 DrawMapOutlineRect   For HighlightObject
    DrawButton(HDC hdc, Bool In, int StringID, RECT *rcButton)
    DrawFlagButton(HDC hdc, Bool In, int StringID, RECT *rcButton)

    ExactMapFit()

    InputNumbers( HWND hwnd, char* prompt, int2 min, int2 max, int2 *OldVal);
    InputNumbers1(HWND hwnd, char* prompt, char* prompt1, int2 min, int2 max, int2 OldVal)
    Input2Numbers(HWND hwnd, char * heading,
                  char* prompt1, char* prompt2,
                  int2 min1, int2 max1, int2 *OldVal1,
                  int2 min2, int2 max2, int2 *OldVal2);
    Input2Numbers4(HWND hwnd, char * heading,
                  char* prompt1, char* prompt2,
                  int4 min1, int4 max1, int4 *OldVal1,
                  int4 min2, int4 max2, int4 *OldVal2);
    InputObjectXRef(hwnd, objtype, Bool allownone, int2 curobj, SelPtr )
    InputTidLiDNumber(
    InputReplace(HWND hwnd,char *heading, char *find, int2 lf, int2 hf, int2 fobj,
                                           char *repl, int2 lr, int2 hr, int2 robj,
                                           char *perc, int2 pobj)
    InputUserText( HWND hwnd, char *prompt, int2 itemwidth, char *heading, char *data)
    InputArgs( "HWND hwnd, LineArgs (0=no search)",
		         "Arg1 0,11111",&SArg[0],  // tid,polyid, tag
		         "Arg2 0,255",  &SArg[1],  //
		         "Arg3 0,255",  &SArg[2],
		         "Arg4 0,255",  &SArg[3],
		         "Arg5 0,255",  &SArg[4]);

    Input3Numbers(
    Input4Numbers(
    InputObjectSpecs(HWND hwnd, char * heading, like 4, but for create object
                     char* prompt1, int2 min1, int2 max1, int2 *OldVal1,
                     char* prompt2, int2 min2, int2 max2, int2 *OldVal2,
                     char* prompt3, int2 min3, int2 max3, int2 *OldVal3,
                     char* prompt4, int2 min4, int2 max4, int2 *OldVal4)

    CheckChangesAndContinue(char *commandtype)

    OnlyDOOMRegistered()

    ChooseEditor
    ChooseUserOptFile
    ListFile

    int4 SpawnProcess(HWND hwnd,char*Directory,char* szCommandLine,WORD wShowWindow, Bool WaitState)

*/
//static void KillHelpWindow(void);


/////////////////////////////////////////////////////////////////
//																					//
//		ConstrainCursor(TRUE/FALSE) to Clip the Cursor				//
//																 					//
//		Constrains the cursor to above the Status Bar				//
//																					//
//		So we can change the cursor and scroll map easily			//
/////////////////////////////////////////////////////////////////
void ConstrainCursor(Bool Clip)
{
 RECT rcClip;
 if(Clip)
 {
  	rcClip.top 		= 0;
  	rcClip.left 	= 0;
  	rcClip.right 	= gd.rcClient.right;// + 1;     3-1-97 don't need +1
  	rcClip.bottom	= gd.rcClient.bottom + gd.CaptionHeight;
   ClipCursor(&rcClip);
   MouseConstrained = TRUE;
 }
 else
 { ClipCursor(NULL);
   MouseConstrained = FALSE;
 }

}
//==============================================================================
//
//==============================================================================
void OutOfMemoryMsg(HWND hwnd)
{
     ErrorMsg(hwnd, "Out of Memory, last code=%d",GetLastError());
}

///////////////////////////////////////////////////////////////////
//                                                               //
//		Clear System Palette                                       //
//                                                               //
//		Realizes an all Black Palette to ensure an application     //
//		Realizes all of the colors in its OWN Palette              //
//																					  //
///////////////////////////////////////////////////////////////////
void ClearSystemPalette()
{
    // A dummy palette setup
    struct
    {
        WORD Version;
        WORD NumberOfEntries;
        PALETTEENTRY aEntries[256];
    } Palette =
    {
        0x300,
        256
    };

	HPALETTE ScreenPalette;
	HDC ScreenDC;
	int n;

   //*** Reset everything in the system palette to black
	for (n = 0; n < 256; n++)
	{
			Palette.aEntries[n].peRed   = 0;
			Palette.aEntries[n].peGreen = 0;
			Palette.aEntries[n].peBlue  = 0;
			Palette.aEntries[n].peFlags = PC_NOCOLLAPSE;
	}

   // Create, select, realize, deselect, and delete the palette
   ScreenDC = GetDC(NULL);
   ScreenPalette = CreatePalette((LOGPALETTE *)&Palette);
   if (ScreenPalette)
   {
       ScreenPalette = SelectPalette(ScreenDC,ScreenPalette,FALSE);
       RealizePalette(ScreenDC);
       ScreenPalette = SelectPalette(ScreenDC,ScreenPalette,FALSE);
       DeleteObject(ScreenPalette);
   }

   ReleaseDC(NULL, ScreenDC);

   if(!ExpertMode)
   HelpMsg(gd.hMainWindow, CENTER|HELPINFO, "Help for Palette",
        "If you have problems with the palette not displaying",
        "properly and this does not work change your color depth",
        "from 256 colors to 16 bit or reload DeeP97",
        "",
        "Exit out, make sure no other applications are running,",
        "then run DeeP97 again to re-initialize the palette",
        "",
        "If this still doesn't work you should restart Win95 and",
        "Try again.  Failing that you might HAVE TO run in 16 bit mode",
        "or try to get updated video drivers.",
        "This Message NOT displayed in Expert Mode",NULL);

	ForgetLevelData (UndoBuffer);		// reinitialized for each level ?
   ForgetPens();							// Have to because of re-read of CFG
   //ForgetPens(gd.hMainWindow);		// Have to because of re-read of CFG   12-13-96
   Medit(gd.hMainWindow, FALSE);

   // Palette loaded in Medit
   //LoadDoomPalette(gd.hMainWindow, 0);		// Load our current palette as reflected

}



///////////////////////////////////////////////////////////
//                                                       //
//  Load a raw Doom palette into lpDoomPal        			//
//                                                       //
///////////////////////////////////////////////////////////
//   3-1-97 changes to make sure black is not modified
//            Caused bad drag with Grid on
//
// win95 has new LPLOGCOLORSPACE which has built-in gamma!!!!!!!!!!<<<<< need to play with this

#pragma argsused
void LoadDoomPalette(HWND hwnd, int2 playpalnum)
{
	DirPtr   		dir;
	int4       		n;

	// Locate the entry for 'PLAYPAL"
   dir = FindOnlyMaster("PLAYPAL", TRUE);  //has to find !!
	if (dir == NULL)
	{
		 NotifyMsg(gd.hMainWindow, "Couldn't locate DOOM palette \"PLAYPAL\" entry");
		 return;
	}

	// Read the palette number <playpalnum>

   WadSeek( MasterWad->fileinfo, dir->start);

	for (n = 0; n <= playpalnum; n++)
	{    WadRead( MasterWad->fileinfo, DoomPalette, 256*3 );
   }
   
   DoomPaletteNumber = playpalnum;

   MakeNewDoomPal(GammaCorrect);
}

//////////////////////////////////////////////////////////////////////////////
//
// Makes a new palette according to the new gamma setting
// moved here so they are together
/////////////////////////////////////////////////////////////////////////////
void MakeNewDoomPal(int2 newgamma)
{
	LPLOGPALETTE   lplp;						// pointer to our Logical Palette
	HANDLE 			hdpal;		         // handle for memory allocation
   int4           n;
   uint2          red,green,blue;
   uint2          LocalGammaCorrect;

   if(gd.hDoomPal)  DeletePalette(gd.hDoomPal);  // Better have
   gd.hDoomPal = NULL;

	hdpal = GlobalAlloc(GHND, sizeof(LOGPALETTE)+(256*sizeof(PALETTEENTRY)));

   if(hdpal)  								             // Got our Handle
   {
	   lplp = (LPLOGPALETTE)GlobalLock(hdpal);	 // Get our Memory Pointers
      memset(lplp,0,sizeof(LOGPALETTE)+(256*sizeof(PALETTEENTRY)) );  // clear

	   lplp->palVersion = PALVERSION;
	   lplp->palNumEntries = 256;

		// Initialize palette entries from saved Palette copy Global RGB Quad

      memset(dRGBquad,0,sizeof(dRGBquad));

		for (n = 0; n < 256; n++)
	   {
		   lplp->palPalEntry[n].peFlags = PC_EXPLICIT;  // this has to be for grid to work

         if (n == 0) continue;   // 0 is always black

         red  = DoomPalette[n*3 + 0];
         green= DoomPalette[n*3 + 1];
         blue = DoomPalette[n*3 + 2];
		   lplp->palPalEntry[n].peFlags = PC_NOCOLLAPSE;

	    	// Gamma Correct

         LocalGammaCorrect = newgamma;

         if ( (red+green+blue)== 0 ) // not black!
         {   LocalGammaCorrect = 0;
         }

		   lplp->palPalEntry[n].peRed   = (uint2) min (red  + LocalGammaCorrect, 255);
		   lplp->palPalEntry[n].peGreen = (uint2) min (green+ LocalGammaCorrect, 255);
		   lplp->palPalEntry[n].peBlue  = (uint2) min (blue + LocalGammaCorrect, 255);

         dRGBquad[n].rgbRed      = lplp->palPalEntry[n].peRed ;   // gamma adjusted
		   dRGBquad[n].rgbGreen    = lplp->palPalEntry[n].peGreen;
		   dRGBquad[n].rgbBlue     = lplp->palPalEntry[n].peBlue;
		   dRGBquad[n].rgbReserved = 0;
      }

		// Create our Doom Palette and store Globally
   	gd.hDoomPal = CreatePalette(lplp);

      // Free allocated memory
  	   GlobalUnlock(hdpal);
	   GlobalFree(hdpal);
   }
}


//////////////////////////////////////////////////////////////////////////////
// position button on the screen
// moves to bottom of rectangle passed (add x,y offsets later as reqd)
//////////////////////////////////////////////////////////////////////////////
                               // rc = window size we are displaying in
void PositionButton(HWND hDlg, HWND howner)//RECT *rc)
{
   RECT  rc        ;	   	           // size of owner  box
   RECT  rcRelative;	   	           // size of button box
   int4  Xtarget;
   int4  Ytarget;
   int4  width,height;

   GetWindowRect( howner, &rc);          // size of owner  window
   GetClientRect( hDlg,   &rcRelative);  // size of button window

   width  = rcRelative.right;
   height = rcRelative.bottom;

   Ytarget = rc.bottom-32;          // move to bottom for now

   Xtarget = rc.left + ( (rc.right - rc.left+1)- width )/2;

   MoveWindow(hDlg, Xtarget, Ytarget, width,height, FALSE );
}
//////////////////////////////////////////////////////////////////////////////
//  General Purpose 2 buttons
//////////////////////////////////////////////////////////////////////////////
//void AdjustDlgPos(HWND hDlg, int4 x, int4 y);
static HWND     hHelpWindow = NULL;
static HelpInfo HelpControl;

static HWND     hButtonDlg = NULL;  // currently active button

#pragma argsused
BOOL CALLBACK OneButtonDlg(DIALOG_PARAMS)
{
static LPBUTTONCONTROL lpd2;	// Our Long Pointer to Dialog Input Struct

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
	   //SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer
      hButtonDlg = hDlg;
      lpd2 = (LPBUTTONCONTROL)lParam;	         	// grab it for our use
      PositionButton(hDlg,lpd2->ownerhwnd);            // keep it in the center (temp, position later)

      //Static_SetText(GetDlgItem(hDlg, psh1), lpd2->sz1);
      return TRUE;
    case WM_PAINT:// temphack
      PositionButton(hButtonDlg,lpd2->ownerhwnd);   // keep it in the center (temp, position later)
      break;
    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh1,(WORD)GetWindowLong(hDlg, GWL_ID)), 0); // cancel = psh1
      break;
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh1,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

    case WM_COMMAND:
      //lpd2 = (LPBUTTONOPTS)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer
      switch LOWORD(wParam) 							// handle of the control
      {
         default:
         case IDOK:
         case IDCANCEL:
         case psh1:
            lpd2->ibutton = psh1;
            EndDialog( hDlg, TRUE);
            return TRUE;
		}
      //break;
  }
  return FALSE;
}

////////////////////////////////////////////////////////////////////////
//																					       //
//		GetOneButtons  -  give  1 strings to replace button contents     /
//    return  psh1 = button1                                           /
//																					       //
////////////////////////////////////////////////////////////////////////
#define BUT1        0x0401          // convert TEXTURES
#define BUT2        0x0402          // convert FLAT
#define BUT3        0x0403          // open
#define BUT4        0x0404          // export lump
                             //RECT *rc

static HWND hButton1;
static HWND hButton2;
static HWND hButton3;
static RECT rcButton1;     // actual screen location button1
static RECT rcButton2;     //                              2
static RECT rcButton3;     //                              2

void SetLocalButtonFont(HWND hButtonControl)
{
     SetWindowFont(hButtonControl,gd.hStockFont,TRUE);// GetStockFont(ANSI_VAR_FONT), TRUE)
}

void CreateButton(HWND hwnd,
                  HWND *hButton,
                  int4 focus,
                  HMENU buttonid,
                  char*buttontext,
                  int4 xloc,int4 yloc,int4 width, int4 height)
{
    if (focus)
    {
    *hButton = CreateWindow("button",                // registered class name
                            buttontext,              // window name
                            WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, // window style  default
                            xloc,                    // horiz position
                            yloc,                    // vert position
                            width,                   // width
                            height,                  // height
                            hwnd,                    // handle of owner window (msg posts to this window)
                            buttonid,                //(HMENU)(BUT1) handle of child id
                            gd.hInst, NULL);         // handle of app
    }
    else
    {
    *hButton = CreateWindow("button",                // registered class name
                            buttontext,              // window name
                            WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, // window style
                            xloc,                    // horiz position
                            yloc,                    // vert position
                            width,                   // width
                            height,                  // height
                            hwnd,                    // handle of owner window (msg posts to this window)
                            buttonid,                //(HMENU)(BUT1) handle of child id
                            gd.hInst, NULL);         // handle of app
   }

   ShowWindow(*hButton, SW_SHOW);
   SetLocalButtonFont(*hButton);  //   7-1-97

  /* another way might work just as well since above doesn't post for me anyway
  rc.left  = x0+ width/2 -24;
  rc.top   = y0+ height+5;
  rc.right = rc.left+48;
  rc.bottom= rc.top+24;
  DrawButton(hdc, FALSE, IDS_OK, &rc);     // button out
  //key = CheckActivity(NULL,WAIT);
  //ReleaseMouseButton(hwnd);                // required   7-1-97
  SelectPalette(hdc, hOldPal, FALSE);
  */
}

void DestroyButtons(void)
{
   DeePDestroyWindow(hButton1);
   hButton1 = NULL;
   DeePDestroyWindow(hButton2);
   hButton2 = NULL;
   DeePDestroyWindow(hButton3);
   hButton3 = NULL;
}


//=============================================================================

int2  GetOneButton(HWND hwnd,HWND ownerhwnd, int4 xadj, int4 yadj,LPCSTR msg1)
{
 BUTTONCONTROL d2;
 int2 key;

 ZeroMemory(&d2, sizeof(d2));			// bye bye, due to the way mem works
// d2.rc = rc;
 d2.ownerhwnd=ownerhwnd;
 d2.xadj=xadj;                      // amt to move
 d2.yadj=yadj;                      // amt to move
 strcpy(d2.sz1, msg1);

 DialogBoxParam( gd.hInst, "OneButton", hwnd, OneButtonDlg, (LPARAM)(LPDLG2OPTS)&d2 );

 key = d2.ibutton; // return 1 (psh1)

 return key;

}

////////////////////////////////////////////////////////////////////////
//		GetTwoButtons  -  give  2 strings to replace two button contents /
//    only this one is working for now                                 /
//    return  psh1 = button1                                           /
//            psh2 = button2                                           /
////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK TwoButtonsDlg(DIALOG_PARAMS)
{
static LPBUTTONCONTROL lpd2;	// Our Long Pointer to Dialog Input Struct
//     int2 key ;

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
      hButtonDlg = hDlg;
	   //SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer
      lpd2 = (LPBUTTONCONTROL)lParam;  	      	// grab it for our use

      PositionButton(hDlg,lpd2->ownerhwnd);//rc);            //

      //Static_SetText(GetDlgItem(hDlg, psh1), lpd2->sz1);
      //Static_SetText(GetDlgItem(hDlg, psh2), lpd2->sz2);
      //SetFocus  (lpd2->ownerhwnd);            // focus
//      key = CheckActivity(NULL,WAIT); // waits till all done
//      if (key==  2)   // cancel
//      {   //key = 0;     //+escape or N n
//          PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh2,(WORD)GetWindowLong(hDlg, GWL_ID)), 0); // cancel = psh2
//      }
//      else
//      {   //key = 1;
//          PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh1,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
//      }
      return TRUE;
    case WM_PAINT:
      PositionButton(hButtonDlg,lpd2->ownerhwnd);   // keep it in the center (temp, position later)
      break;
    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh2,(WORD)GetWindowLong(hDlg, GWL_ID)), 0); // cancel = psh2
      break;
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh1,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

    case WM_COMMAND:
      //lpd2 = (LPDLG2OPTS)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer
      switch LOWORD(wParam) 							// handle of the control
      {
         case IDOK:
         case psh1:
            lpd2->ibutton = psh1;
            EndDialog( hDlg, TRUE);
            return TRUE;
         case IDCANCEL:
         case psh2:
            lpd2->ibutton = psh2;
            EndDialog( hDlg, FALSE);
            return FALSE;
		}
      break;
  }
  return FALSE;
}

////////////////////////////////////////////////////////////////////////
//																					       //
//		GetTwoButtons  -  give  2 strings to replace two button contents /
//    rc = size of rectangle to place into
//    xadj,yadj how much to move it
//  -- for right now moves to bottom of rc and centers
//    return  psh1 = button1                                           /
//            psh2 = button2                                          //
//																					       //
////////////////////////////////////////////////////////////////////////
                         //RECT *rc
int2  GetTwoButtons(HWND hwnd,HWND ownerhwnd, int4 xadj, int4 yadj,LPCSTR msg1,LPCSTR msg2)
{
 BUTTONCONTROL d2;
 int2 key;

 ZeroMemory(&d2, sizeof(d2));			// bye bye, due to the way mem works
// d2.rc = rc;
 d2.ownerhwnd= ownerhwnd;
 d2.xadj=xadj;                      // amt to move
 d2.yadj=yadj;                      // amt to move

 strcpy(d2.sz1, msg1);
 strcpy(d2.sz2, msg2);

 DialogBoxParam( gd.hInst, "TwoButtons", hwnd, TwoButtonsDlg, (LPARAM)(LPBUTTONCONTROL)&d2 );

 key = d2.ibutton; // return 1 of 2 button clicks here (psh1, psh2)

 return key;
}

//////////////////////////////////////////////////////////////////////////////
//  General Purpose 3 buttons
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK ThreeButtonsDlg(DIALOG_PARAMS)
{
  LPDLG2OPTS lpd2;	// Our Long Pointer to Dialog Input Struct

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
	  SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer

     //PositionButton(hDlg);                        // keep it in the center (temp, position later)

     lpd2 = (LPDLG2OPTS)lParam;			      	// grab it for our use

     Static_SetText(GetDlgItem(hDlg, psh1), lpd2->sz3);
     Static_SetText(GetDlgItem(hDlg, psh2), lpd2->sz4);
     Static_SetText(GetDlgItem(hDlg, psh3), lpd2->sz5);
     return TRUE;

    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh3,(WORD)GetWindowLong(hDlg, GWL_ID)), 0); // cancel = psh3
      break;
    //   6-1-97
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(psh1,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

    case WM_COMMAND:
      lpd2 = (LPDLG2OPTS)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer
       switch LOWORD(wParam) 							// handle of the control
       {
         case IDOK:
         case psh1:
            lpd2->i1 = psh1;
            EndDialog( hDlg, TRUE);
            return TRUE;
         case IDCANCEL:
         case psh2:
            lpd2->i1 = psh2;
            EndDialog( hDlg, FALSE);
            return TRUE;
         case psh3:
            lpd2->i1 = psh3;
            EndDialog( hDlg, FALSE);
            return FALSE;
		 }
       break;
  }
  return FALSE;
}

////////////////////////////////////////////////////////////////////////
//																					       //
//		GetThreeButtons   give 3 strings to replace 3 button contents    /
//    return  psh1 = button1                                           /
//            psh2 = button2                                          //
//				  psh3 = button3 or cancel    							       //
////////////////////////////////////////////////////////////////////////
int2  GetThreeButtons(HWND hwnd,LPCSTR msg1,LPCSTR msg2,LPCSTR msg3)
{
 DLG2OPTS d2;
 int2 key;

 ZeroMemory(&d2, sizeof(d2));			// bye bye, due to the way mem works
 strcpy(d2.sz3, msg1);
 strcpy(d2.sz4, msg2);
 strcpy(d2.sz5, msg3);

 DialogBoxParam( gd.hInst, "ThreeButtons", hwnd, TwoButtonsDlg, (LPARAM)(LPDLG2OPTS)&d2 );

 key = d2.i1; // return 1 of 3 button clicks here (psh1, psh2,psh3)

 return key;
}

/////////////////////////////////////////////////////////////////
//																					//
//		MsgInfoBox  -  given 8 strings will display  				//
//    a Dialog Box and return a TRUE (OK) or FALSE (CANCEL)    //
//																					//
//Handy when you need more info displayed than in MessageBox	//
/////////////////////////////////////////////////////////////////
/*
Bool  MsgInfoBox(HWND hwnd,LPCSTR msg1,LPCSTR msg2,LPCSTR msg3,LPCSTR msg4,LPCSTR msg5,LPCSTR msg6,LPCSTR msg7,LPCSTR msg8)
{
 DLG2OPTS d2;

 ZeroMemory(&d2, sizeof(d2));			// bye bye, due to the way mem works
  strcpy(d2.sz3, msg1);
  strcpy(d2.sz4, msg2);
  strcpy(d2.sz5, msg3);
  strcpy(d2.sz6, msg4);
  strcpy(d2.sz7, msg5);
  strcpy(d2.sz8, msg6);
  strcpy(d2.sz9, msg7);
  strcpy(d2.sz10, msg8);
  // OK     = TRUE
  // CANCEL = FALSE
  return ( DialogBoxParam( gd.hInst, "Info", hwnd, InfoDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) );

} */

/////////////////////////////////////////////////////////////////
//																					//
//		MyMessageBox  -  given 2 strings will draw a					//
//		LtGray box in the center of the screen with 					//
//		the 2 strings centered and a caption on top					//
//																					//
//		Handy when you don't want user input from MessageBox		//
/////////////////////////////////////////////////////////////////
void MyMessageBox(HWND hwnd,  LPCSTR msg1,  LPCSTR msg2)
{
   HDC hdc;								// Our device context
	RECT rc;								// Our temporary Rect Structure
	int length1, length2;			// Length of our texts
   SIZE s1,s2,s3,s4;					// the size struct. for extents of text
   char szCapText[11]		= "PLEASE WAIT";	// Our caption text

   length1 	= 	strlen(msg1);		// find the length of our strings
	length2	=  strlen(msg2);

    hdc = GetDC(hwnd);				// Grab our device context

	GetTextExtentPoint32(hdc, msg1, length1, &s1);	// find the extents of our text
	GetTextExtentPoint32(hdc, msg2, length2, &s2);	// and fill in our Size Structs
	GetTextExtentPoint32(hdc, szCapText, 11, &s3);	// and fill in our Size Structs

   CopyRect(&rc, &gd.rcClient);							// Copy our client rect over

   s4.cx		=	(s1.cx > s2.cx) ? s1.cx : s2.cx;		// find our longest string

   rc.left	=	(rc.right / 2) - ((s4.cx / 2) + 10 );	// middle and then back 1/2 & 10
   rc.right	=	rc.left + (s4.cx + 20);						// a little buffer on each side
   rc.top	=	((rc.bottom / 2) - (s1.cy * 4));			// middle plus 4 lines up
   rc.bottom=	rc.top + (s1.cy * 8);						// 8 lines of equal text

	SetBkColor(hdc, RGB(132, 132, 132));
   SetTextColor(hdc, RGB(64, 64, 170));

	// Draw our caption text with the RECT struct color of background
   ExtTextOut	(hdc, rc.left +  (((rc.right - rc.left) - s3.cx ) / 2), // x pos.
    				rc.top + (s1.cy ), ETO_OPAQUE, &rc, szCapText, 11, NULL);

	// Put a nice 3d border around it
   DrawEdge(hdc, &rc, EDGE_RAISED, BF_RECT | BF_SOFT );

   SetTextColor(hdc, RGB(188, 32, 32));

	// now the other 2 text strings
	TextOut		(hdc, rc.left + (((rc.right - rc.left) - s1.cx ) / 2),
   				rc.top + (s1.cy * 4), msg1, length1);

	TextOut		(hdc, rc.left + (((rc.right - rc.left) - s2.cx ) / 2),
   				rc.top + (s1.cy * 6), msg2, length2);

   ReleaseDC(hwnd, hdc);
}

//
//---------------------------------------------------------------------------
// Terminate and Exit with error
//---------------------------------------------------------------------------
//
void ProgError( char *errstr, ...)
{
	char   msg[512];	// Safer than on stack undid static   3-1-97,if this is a prob, everything is toast
   char *pArgs;	   // Pointer to arguments

   pArgs = (char *) &errstr + sizeof (errstr);    // find it

	vsprintf(msg, errstr, pArgs);						  // format it

	MessageBox (0, msg, "FATAL ERROR", MB_OK | MB_ICONSTOP | MB_TASKMODAL);

   if (CHKInUse != 166)                           // from create CHK routine   11-3-96
   {   CHKInUse = 0;                              // reset in use
       SaveCHKStatus();                           // save  .CHK file too
   }

   // try to autosave first ?


   if (!gd.hMainWindow)
   {    MessageBox (0, "Not Started", "FATAL ERROR", MB_OK | MB_ICONSTOP | MB_TASKMODAL);
        ExitProcess(1);                           // appears to work ok   7-1-97
        //PostQuitMessage(0);                    // + this??
   }
   else
   {
        PostQuitMessage(0);                       // this works -most- of the time
        //ExitProcess(1);                         // testing   7-1-97
        //DeePDestroyWindow(gd.hMainWindow);      //    3-1-97   (old code)
   }

   //ForgetLevelData(&LevelWad.level);
   //ForgetTextureNames();
   //CloseWadFiles('A',FREEDIRNO,FREENAMENO);       // don't free mem if error
   //SendMessage(gd.hMainWindow, WM_CLOSE, 0, 0);	// Call Deep_OnDestroy
}

//---------------------------------------------------------------------------
// Ask to confirm a choice (message box)    Yes, No
//  (from help   8-1-97)
// If you create a message box while a dialog box is present,
// use the handle of the dialog box as the hWnd parameter.
// The hWnd parameter should not identify a child window, such as a control in a dialog box.
//---------------------------------------------------------------------------
BOOL Confirm(HWND hwnd, char *confstr, ...)
{
	char msg[1024]; 	// undid static+expand to 1024   3-1-97
   char *pArgs;	   // Pointer to arguments

   pArgs = (char *) &confstr + sizeof (confstr);    // find it

	vsprintf(msg, confstr, pArgs);						  // format it

	//int ans = MessageBox (hwnd, msg, "DeeP97 Confirm", MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL);
	int ans = MessageBox (hwnd, msg, "DeeP97 Confirm",
                         MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL | MB_APPLMODAL |MB_SETFOREGROUND);

	return ((ans == IDYES) ? TRUE : FALSE);
}

//---------------------------------------------------------------------------
// Continue                               Yes, No, Cancel
//---------------------------------------------------------------------------

BOOL Continue(HWND hwnd,char *confstr, ...)
{
	char    msg[512];	// Safer than on stack , undid static   3-1-97
   char   *pArgs;		// Pointer to arguments

   pArgs = (char *) &confstr + sizeof (confstr);    // find it

	vsprintf(msg, confstr, pArgs);						  // format it

	return MessageBox (hwnd, msg, "Deep97 Confirm", //MB_YESNOCANCEL | MB_ICONQUESTION | MB_TASKMODAL);
                         MB_YESNOCANCEL | MB_ICONQUESTION | MB_TASKMODAL | MB_APPLMODAL |MB_SETFOREGROUND);


}

//---------------------------------------------------------------------------
//	Notify the user of a message in a message box
//   11-11-96 name changed to NotifyMsg since Notify is a windows func too!
//    3-01-97 changed to ICONWARNING (maybe make a WarningMsg function)
//---------------------------------------------------------------------------
void NotifyMsg(HWND hwnd, char *notstr, ...)
{
	char msg[8096];         //  11-11-96 safety increase
   char *pArgs;				// Pointer to arguments

   BeenNotified = FALSE;                          // for any task that check on this

   pArgs = (char *) &notstr + sizeof (notstr);    // find it

	vsprintf( msg, notstr, pArgs);                 // convert

	MessageBox (hwnd, msg, "DeeP97 Information",
               MB_OK | MB_ICONWARNING |MB_APPLMODAL|MB_SETFOREGROUND);//   3-1-97 experiment getting it out for errors
               //MB_OK | MB_ICONINFORMATION |MB_APPLMODAL|MB_SETFOREGROUND);//   3-1-97 experiment getting it out for errors

   BeenNotified = TRUE;
}

//---------------------------------------------------------------------------
//	Notify the user of a message in a message box, with error graphic
//---------------------------------------------------------------------------
void ErrorMsg(HWND hwnd, char *notstr, ...)
{
	char msg[8096];         //  11-11-96 safety increase
   char *pArgs;				// Pointer to arguments

   BeenNotified = FALSE;                          // for any task that check on this

   pArgs = (char *) &notstr + sizeof (notstr);    // find it

	vsprintf( msg, notstr, pArgs);                 // convert

	MessageBox (hwnd, msg, "DeeP97 Error Information",
               MB_OK | MB_ICONSTOP |MB_APPLMODAL|MB_SETFOREGROUND);
               //MB_OK | MB_ICONSTOP |MB_APPLMODAL|MB_SETFOREGROUND);

   BeenNotified = TRUE;
}

//------------------------------------------------------------------------
//   display a list of messages   (no box drawn and coordinates exact)   /
//                                                                       /
//      -    width    --                                                 /
//      |    message1        |    4                                      /
//      |    message2        |    5                                      /
//      |    .........       |    6                                      /
//------------------------------------------------------------------------

static void MessageDisplay(HDC hdc, int4 x0, int4 y0,
                                    Bool      Center,
                                    int4      width,        // in pixels
                                    ColorText *Prompt)
{
   int4  xloc,yloc;
   int4  i=0;
   int4  j;
   SIZE  TxtSize;
   char  *msgwrk;
   char  *msgin;
   int4  msglen;
   int4  cumLength;
   int4  tabLoc;
// char hitext[80]={0};  later special stuff maybe?
#define TABSIZE 32      //32
//----------------------------------------------------------------------

  	SetBkMode(hdc, TRANSPARENT);  //	 dont want background

   yloc=y0+4;                    // +4 for border

   while ( i < 80 && Prompt[i].text != NULL )
   {
       msgwrk = Prompt[i].text;
       msglen = lstrlen(msgwrk);

       if (Center)
       {   msgin    = msgwrk;
           cumLength= 0;

           for (j=0; j< msglen; j++,msgin++)
           {
              if (msgin[0] == '\t')
              {
                 tabLoc = cumLength/TABSIZE;       // number of tabs req'd to get here each tab is 32
                 xloc   = x0+ (tabLoc+1)*TABSIZE;  // where tab is
                 cumLength = xloc - x0;            // current location
                 continue;
              }
              GetTextExtentPoint32(hdc,msgin,1,&TxtSize);
              cumLength+=TxtSize.cx;
           }
           xloc = x0+(width - cumLength)/2 +2;// +3;      // center textline
       }
       else
       {   xloc = x0+4;
       }

       SetTextColor(hdc, PALETTEINDEX(GameColors[Prompt[i].color] ));

       msgin     = msgwrk;
       cumLength = 0;

       for (j=0; j< msglen; j++,msgin++)
       {
           if (msgin[0] == '\t')                 // a tab
           {
               tabLoc = cumLength/TABSIZE;       // number of tabs req'd to get here each tab is 32
               xloc   = x0+ (tabLoc+1)*TABSIZE;  // where tab is
               cumLength = xloc - x0;            // current location
               continue;
           }
           GetTextExtentPoint32(hdc,msgin,1,&TxtSize);
           TextOut(hdc, xloc,yloc, msgin, 1 );  // 1 byte text
           xloc      +=TxtSize.cx;
           cumLength +=TxtSize.cx;
       }

       yloc +=14; // for now fixed height
       i++;
   }
}

///////////////////////////////////////////////////////////////////////////////
//
//  Help List Dialog Procedure
//
/////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//  This calls HelpWndProc below                                               /
//------------------------------------------------------------------------------

static void HelpMessageDisplay(HWND hwnd, int4 HelpType,
                                          int2 HelpSolid,
                                          int4 x0, int4 y0,
                                          int4 width,        // in pixels
                                          int4 height)       // in pixels
{

   DWORD  WindowStyle;

// WS_EX_OVERLAPPEDWINDOW:   (has windows logo on left of bar)
// Combines the WS_EX_CLIENTEDGE  sunken border
//           and WS_EX_WINDOWEDGE raised edge

// WS_EX_CONTEXTHELP looks same as tool,


   //  Caption and Border         (same as next, but might change)
   if (HelpType == HELPERROR
   ||  HelpType == HELPCONTINUE)
   {
      if (!HelpSolid)
      {
          WindowStyle =  WS_EX_TOOLWINDOW|WS_EX_CLIENTEDGE;
      }
      else
      {
          WindowStyle =  WS_EX_TOOLWINDOW|WS_EX_CLIENTEDGE;
      }
      hHelpWindow = CreateWindowEx(  WindowStyle ,//| WS_EX_OVERLAPPEDWINDOW, //WS_EX_STATICEDGE |
                                  //WS_EX_OVERLAPPEDWINDOW | WS_EX_DLGMODALFRAME ,
                                  szLoadString(IDS_HELPNAME),
                                  szLoadString(IDS_HELPNAME),
                                  WS_POPUPWINDOW|WS_CAPTION,//| WS_OVERLAPPEDWINDOW, //| WS_CAPTION,//|DS_SYSMODAL,// | WS_VISIBLE | WS_OVERLAPPEDWINDOW, // last optn draws edge & caption
                                  x0,y0,                               // origin
                                  width,
                                  height+20,         // make room for heading
                                  hwnd,              // parent
                                  NULL,              // HMENU menu or child window id
                                  gd.hInst, NULL);   // app instance, windows creation data
   }
   else
   //  Caption and Border
   if (HelpType == HELPYESNO
   ||  HelpType == HELPINFO
   ||  HelpType == HELPEDIT
   ||  HelpType == HELPYESNOCANCEL)
   {
                             // WS_EX_TOOLWINDOW|WS_EX_CLIENTEDGE ,     WS_OVERLAPPEDWINDOW | WS_VISIBLE ,
      if (!HelpSolid)
      {
          WindowStyle =  WS_EX_TOOLWINDOW|WS_EX_CLIENTEDGE;
      }
      else
      {
          WindowStyle =  WS_EX_TOOLWINDOW|WS_EX_CLIENTEDGE;
      }
      hHelpWindow = CreateWindowEx(  WindowStyle ,//|WS_EX_STATICEDGE ,//| WS_EX_OVERLAPPEDWINDOW, //WS_EX_STATICEDGE |
                                  szLoadString(IDS_HELPNAME),
                                  szLoadString(IDS_HELPNAME),
                                  WS_POPUPWINDOW|WS_CAPTION,//| WS_OVERLAPPEDWINDOW,      // must be popup!, edge and caption
                                  x0,y0,                                    // origin
                                  width,
                                  height+20,         // make room for heading
                                  hwnd,              // parent
                                  NULL,              // HMENU menu or child window id
                                  gd.hInst, NULL);   // app instance, windows creation data
   }
   else
   // HELP only, no caption, no border
   {
       hHelpWindow = CreateWindowEx( WS_EX_TOOLWINDOW	,//WS_EX_OVERLAPPEDWINDOW, //WS_EX_DLGMODALFRAME ,//| WS_EX_OVERLAPPEDWINDOW, //WS_EX_STATICEDGE |
                                  szLoadString(IDS_HELPNAME),
                                  szLoadString(IDS_HELPNAME),
                                  WS_POPUPWINDOW,//| WS_CAPTION,//|DS_SYSMODAL,// | WS_VISIBLE | WS_OVERLAPPEDWINDOW, // last optn draws edge & caption
                                  x0,y0,                                      // origin
                                  width,
                                  height,
                                  hwnd,              // parent
                                  NULL,              // HMENU menu or child window id
                                  gd.hInst, NULL);   // app instance, windows creation data
   }
   ShowWindow(hHelpWindow, SW_SHOW);
   UpdateWindow(hHelpWindow);
}

//------------------------------------------------------------------------------
//                                                                             /
//------------------------------------------------------------------------------
static void HelpScreenHollow(HDC hdc, int Left, int Top, int Right, int Bottom, HBRUSH hBrush  )
{
RECT rc;
      // normal square
      SetRect(&rc, Left+1, Top+1, Right-1, Bottom-1 );
      FillRect(hdc, &rc, hBrush);

      SelectPen(hdc, gd.hPens[LIGHTERGRAY]);
      DrawLine(hdc, Left+1, Top+1,  Right-1,  Top+1);        // top  inside
      DrawLine(hdc, Left+1, Top+1,  Left+1,Bottom-1  );      // left inside
      DrawLine(hdc, Left,   Bottom, Right, Bottom);	       // bottom outside
      // DrawLine(hdc, Right,  Top,    Right, Bottom);          // right  outside

      SelectPen(hdc, gd.hPens[DARKERGRAY]);

      DrawLine(hdc, Left,   Top,      Right,   Top);	       // top   outside
      DrawLine(hdc, Left,   Top,      Left,    Bottom);      // left outside
      DrawLine(hdc, Left+1, Bottom-1, Right-1, Bottom-1);    // bottom inside
      SelectPen(hdc, gd.hPens[WHITE]);
      //DrawLine(hdc, Right,  Top,     Right,    Bottom);    // right  outside
      //DrawLine(hdc, Right-1,Top+1,    Right-1, Bottom-1);    // right  inside
      DrawLine(hdc, Right-2,Top+1,    Right-2, Bottom-1);    // right  outside
      DrawLine(hdc, Right-3,Top+1,    Right-3, Bottom-1);    // right  outside

}

////////////////////////////////////////////////////////////////////////////////
//  Paint Routine  (non reentrant for now - since global is used for type)
////////////////////////////////////////////////////////////////////////////////
static void Help_OnPaint(HWND hwnd)
{
//static HelpPaint = 0;  // for resizable window

   PAINTSTRUCT ps;
   RECT        rc;
   RECT        rc2;

   HPEN        hOldPen;
   HFONT       hOldFont;
   HBRUSH      hBrush;
   HPALETTE    hOldPal;
   int4        Xloc;

   //--------------------------------------------------------------------------

   BeginPaint(hwnd, &ps);

   hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
   RealizePalette(ps.hdc);

   GetClientRect(hwnd, &rc);
   GetClientRect(hwnd, &rc2);

   FillRect(ps.hdc, &rc, GetStockBrush(LTGRAY_BRUSH));
   // fill in background

   if (HelpControl.type!= HELPHELP) // has edge and buttons
   {                                                           //GRAY
       //hBrush  = CreateSolidBrush(PALETTEINDEX(GameColors[LIGHTGRAY]));//MenuColor]));  //LIGHTYELLOW looks bad in others
       hBrush  = CreateSolidBrush(PALETTERGB(255,255,233));    //gray 220,220,220  (windows match has to be in case our colors gone)
       if (!HelpControl.solid)
       {
            HelpScreenHollow (ps.hdc, rc.left+4,rc.top+4,rc.right-4,rc.bottom-4,hBrush);
       }
   }
   else  // help info only
   {   hBrush = CreateSolidBrush(PALETTERGB(255, 255,233));    //255, 255,223 perfect for DOOM (very light yellow, light gray in rest)
       rc2.left+=1;
       rc2.top +=1;
       rc2.right-=1;
       rc2.bottom-=1;
       FillRect(ps.hdc, &rc2, hBrush);
   }

   //   FillRect(ps.hdc, &rc, hBrush);


   /*
   if (GameVersion <= 2)    // doom
   {   FillRect(ps.hdc, &rc, gd.hBrushes[LIGHTYELLOW]);
   }
   else                     // the rest
   {   FillRect(ps.hdc, &rc, gd.hBrushes[WHITE]); //GetStockBrush(LTGRAY_BRUSH)
   }*/
// here for info only if change mind
//   DrawScreenBox3D      (hdc, x0-8,y0-24,x0+width+8,y0+height+32 ,gd.hBrushes[MenuColor]);//GetStockBrush(LTGRAY_BRUSH)); test
//   DrawScreenLineHollow (hdc, x0  ,y0   ,x0+width  ,y0+height    ,gd.hBrushes[LIGHTYELLOW]);

   rcButton1.bottom = -1;                           // prevent getting it
   rcButton2.bottom = -1;                           // prevent getting it
   rcButton3.bottom = -1;                           // prevent getting it

   if (HelpControl.type != HELPHELP) // has edge and buttons
   {
       SetWindowText(hHelpWindow, HelpControl.heading);      //heading in caption

      // fill bottom with gray
       rc.top = rc.bottom -28;                               // backup a bit

       if (!HelpControl.solid)
       {    FillRect(ps.hdc, &rc, GetStockBrush(LTGRAY_BRUSH));
            hOldPen = SelectPen(ps.hdc, gd.hPens[WHITE]);         // top edge

            DrawLine( ps.hdc,rc.left+4,rc.top,rc.right-5,rc.top);     //  top line

            SelectPen(ps.hdc, hOldPen);
       }

       if (HelpControl.type == HELPINFO)
       {
           Xloc = (rc.right -35) /2;
           CreateButton(hHelpWindow,&hButton1,TRUE,(HMENU)BUT1,"OK",Xloc,rc.top+6,35,18);
           GetWindowRect(hButton1,&rcButton1);              // button loc

       }
       else
       if (HelpControl.type == HELPERROR
       ||  HelpControl.type == HELPCONTINUE)
       {
           Xloc = (rc.right -102) /2;   // buttons 50 each + 2 spacing
           CreateButton(hHelpWindow,&hButton1,TRUE, (HMENU)BUT1,"Continue",Xloc,    rc.top+6,50,18);
           CreateButton(hHelpWindow,&hButton2,FALSE,(HMENU)BUT2,"Cancel",  Xloc+52, rc.top+6,50,18);
           GetWindowRect(hButton1,&rcButton1);              // button loc
           GetWindowRect(hButton2,&rcButton2);              // button loc
       }
       else
       if (HelpControl.type == HELPEDIT)
       {
           Xloc = (rc.right -156) /2;   // buttons 50 each + 2 spacing
           CreateButton(hHelpWindow,&hButton1,TRUE ,(HMENU)BUT1,"Continue",Xloc,     rc.top+6,50,18);
           CreateButton(hHelpWindow,&hButton2,FALSE,(HMENU)BUT2,"Cancel",  Xloc+52,  rc.top+6,50,18);
           CreateButton(hHelpWindow,&hButton3,FALSE,(HMENU)BUT2,"Edit",    Xloc+104, rc.top+6,50,18);
           GetWindowRect(hButton1,&rcButton1);              // button loc
           GetWindowRect(hButton2,&rcButton2);              // button loc
           GetWindowRect(hButton3,&rcButton3);              // button loc
       }
       else
       if (HelpControl.type == HELPYESNOCANCEL)
       {
           Xloc = (rc.right -156) /2;   // buttons 50 each + 2 spacing
           CreateButton(hHelpWindow,&hButton1,TRUE, (HMENU)BUT1,"Yes",    Xloc,     rc.top+6,50,18);
           CreateButton(hHelpWindow,&hButton2,FALSE,(HMENU)BUT2,"Cancel", Xloc+52,  rc.top+6,50,18);
           CreateButton(hHelpWindow,&hButton3,FALSE,(HMENU)BUT2,"No",     Xloc+104, rc.top+6,50,18);
           GetWindowRect(hButton1,&rcButton1);              // button loc
           GetWindowRect(hButton2,&rcButton2);              // button loc
           GetWindowRect(hButton3,&rcButton3);              // button loc
       }
       else
       {
           Xloc = (rc.right -102) /2;   // buttons 50 each + 2 spacing
           CreateButton(hHelpWindow,&hButton1,TRUE, (HMENU)BUT1,"Yes",Xloc,    rc.top+6,50,18);
           CreateButton(hHelpWindow,&hButton2,FALSE,(HMENU)BUT2,"No", Xloc+52, rc.top+6,50,18);
           GetWindowRect(hButton1,&rcButton1);              // button loc
           GetWindowRect(hButton2,&rcButton2);              // button loc
       }

   }

   hOldFont = SelectFont(ps.hdc,gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));// Select a font

   MessageDisplay (ps.hdc, 8,8,
                        HelpControl.center,
                        HelpControl.width-16,
                        HelpControl.prompt);    // pass the list

   SelectFont(ps.hdc, hOldFont);
   DeleteBrush(hBrush);
   SelectPalette(ps.hdc, hOldPal, FALSE);

   EndPaint(hwnd, &ps);
}

////////////////////////////////////////////////////////////////////////////////
//  help handlers                                                             //
////////////////////////////////////////////////////////////////////////////////
/*
static void KillHelpWindow(UINT key)
{
  if (!hButtonDlg) return;

  switch(HelpControl.type)
  {
        case 0:  // help
          break;
        case 1:  // info
           PostMessage(hButtonDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hButtonDlg, GWL_ID)), 0);
           break;
        case 2:  // error
          if (key == 2       // button 2
          ||  key == 'N'     // no
          ||  key == 'E'     // exit
          ||  key == 0x001B) // escape
          {  PostMessage(hButtonDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hButtonDlg, GWL_ID)), 0); // cancel = psh2
          }
          else
          if (key == 1       // button 1
          ||  key =='Y')     // yes
          {   PostMessage(hButtonDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hButtonDlg, GWL_ID)), 0);
          }
          break;
  }
}  */

// Create Window
/*
#pragma argsused
//static BOOL Help_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
//{
//   SetCapture(hHelpWindow);
//}
// destroy

#pragma argsused
static void Help_OnDestroy(HWND hwnd)
{
    ///KillHelpWindow();
}
// close
#pragma argsused
static void Help_OnClose(HWND hwnd)
{
    KillHelpWindow();
}
*/
// left button
/*
#pragma argsused
static void Help_OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
    KillHelpWindow(1);
}
// right button
#pragma argsused
static void Help_OnRButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
    KillHelpWindow(2);
}
// Key pressed
#pragma argsused
static void Help_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
    KillHelpWindow(vk);
}
#pragma argsused
void Help_OnClose(HWND hwnd)
{
    KillHelpWindow(2);
} */
//#pragma argsused
//static void Help_OnKeyUp(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
//{
//    KillHelpWindow(vk);
//}
/*
#pragma argsused
static void Help_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    Trace(NULL,10,10,"command= %d",id);
     switch (id)
     {
         case BUT1:
            //KillHelpWindow(1);
            break;
         case BUT2:
            //KillHelpWindow(2);
            break;
         default:
            break;
     }

}
*/
//----------------------------------------------------------------------------

LRESULT CALLBACK HelpWndProc(WINDOWS_PARAMS)
{
//Trace(NULL,10,10,"msg=%d w=%hd",msg, LOWORD(wParam));// lParam);
  switch(msg)
  {
	 //  HANDLE_MSG(hwnd, WM_CREATE,       Help_OnCreate);
	 //  HANDLE_MSG(hwnd, WM_DESTROY, 		Help_OnDestroy);
	 //  HANDLE_MSG(hwnd, WM_COMMAND,     	Help_OnCommand);
    //  HANDLE_MSG(hwnd, WM_CLOSE, 	      Help_OnClose);
      HANDLE_MSG(hwnd, WM_PAINT,          Help_OnPaint);
    //  HANDLE_MSG(hwnd, WM_LBUTTONDOWN, 	Help_OnLButtonDown);
    //  HANDLE_MSG(hwnd, WM_RBUTTONDOWN, 	Help_OnRButtonDown);
	 //  HANDLE_MSG(hwnd, WM_KEYDOWN, 	   Help_OnKey);
	 //  HANDLE_MSG(hwnd, WM_KEYUP, 		   Help_OnKeyUp);
	 //  HANDLE_MSG(hwnd, WM_MOUSEMOVE,    Help_OnMouseMove);

	 default:
		return Deep_DefProc(hwnd, msg, wParam, lParam);
  }
}


//-------------------------------------------------------------------------
//  General Help msg,   11-11-96 , need to change the fonts
//  make it work from a dialog prototype later
//-------------------------------------------------------------------------
int2 HelpMsg(HWND hwnd,
             int2 Type,           // 0x0001 = center, 0x8000 = info only
             char*UserHeading,...)//then char*UserText,...)
{
  char     Heading[120];

  MSG      msg ={0};
  HDC      hdc;
  HFONT    hOldFont;
  HBITMAP  hMemBmp;     // for saving the screen
  RECT     localrc;

  int4     x0,y0;

  va_list  ap;
  char     *msgin;
  int4     msglen;
  int4     tabLoc;
  int4     cumLength;
  SIZE     TxtSize;

  int4     count=0;
  int4     i,j;
  int2     height ;            // height of box
  int2     width;              // width
  int2     Headingwidth;       // width

  ColorText Prompt[82];        // 80 max lines

  int4     HelpType;
  int2     Center;
  int2     Solid;

  int2     key;
  int4     ButtonWaiting = FALSE;  // get both sides of buttons prevent false triggers

//  HPALETTE hOldPal;
//  POINT    PriorCurPos;             //   3-1-97
//  HWND     hOldFocus   ;
//  HWND     hOldCapture ;
//  RECT     rc;
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------

  ShowCursor(TRUE);
//GetCursorPos( &PriorCurPos );         //   3-1-97 remember location(not useful here 8-1-97)

//////////////  hwnd = gd.hMainWindow; //just testing trying to get bmp correct and seeing what's going on, no success

  Center  = Type&CENTER;//HELPCENTER;
  Solid   = Type&SOLID;

  if (Type&HELPHELP)             // no edge, no button
  {   strcpy(Heading, " Help - ");
      HelpType = HELPHELP;
  }
  else
  if (Type&HELPINFO)             // thick edge + OK button)
  {   strcpy(Heading, " Info - ");
      strcat(Heading,UserHeading);
      HelpType = HELPINFO;
      SoundBeepError(SOUNDCLICK3);
  }
  else
  if (Type&HELPERROR)            // heading, edge and 2 buttons continue, cancel)
  {   strcpy(Heading, " Error - ");
      strcat(Heading,UserHeading);
      HelpType = HELPERROR;
      SoundError();
  }
  else
  if (Type&HELPCONTINUE)          // heading, edge, 2 buttons continue, cancel
  {
      strcpy(Heading,UserHeading);
      HelpType = HELPCONTINUE;
      SoundBeepError(SOUNDCLICK3);
  }
  else
  if (Type&HELPEDIT)          // heading, edge, 3 buttons continue, cancel, edit
  {
      strcpy(Heading,UserHeading);
      HelpType = HELPEDIT;
      SoundBeepError(SOUNDCLICK3);
  }
  else
  if (Type&HELPYESNOCANCEL)   // heading, edge, 3 buttons yes, cancel, no
  {
      strcpy(Heading,UserHeading);
      HelpType = HELPYESNOCANCEL;
      SoundBeepError(SOUNDCLICK3);
  }
  else
  {                              // heading , edge, 2 buttons  Yes, No
      strcpy(Heading,UserHeading);
      HelpType = HELPYESNO;
      SoundBeepError(SOUNDCLICK3);
  }

  // want to expand window to put our needs   11-11-96 <<<<<<<<<<<<<<<<<<<<

  GetWindowRect(hwnd, &localrc);        // actual window that called us

  hdc      = GetDC(hwnd);
  hOldFont = SelectFont(hdc,gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));// Select a font

//  hOldPal  = SelectPalette(hdc, gd.hDoomPal, FALSE);
//  RealizePalette(hdc);

  // for now fixed height stuff   11-11-96

  // get width of heading

  GetTextExtentPoint32(hdc,Heading,strlen(Heading),&TxtSize);

  Headingwidth = TxtSize.cx;
  width        = Headingwidth+32;      // start with heading

  va_start( ap, UserHeading);       // text follows

  while ( count < 80 )
  {
       msgin = va_arg (ap,char *);
       if (!msgin) break;

       Prompt[count].text = msgin;
       Prompt[count].color = BLACK;  // no hilite as used to be , later?
       count++;
  }
  va_end(ap);

  Prompt[count].text = NULL;     // terminate list

  for (i=0; i < count; i++)
  {
       msgin  = Prompt[i].text;
       msglen = strlen(msgin);
       cumLength = 0;

       for (j=0; j< msglen; j++,msgin++)
       {
           if (msgin[0] == '\t')           // a tab
           {   tabLoc   = cumLength/32;    // number of tabs req'd to get here each tab is 32
               cumLength= (tabLoc+1)*32;   // where tab is
               continue;
           }
           GetTextExtentPoint32(hdc,msgin,1,&TxtSize);
           cumLength+=TxtSize.cx;

       }
       if (cumLength > width) width = cumLength;
  }

  if (HelpType == HELPEDIT          // continue, cancel, edit
  ||  HelpType == HELPYESNOCANCEL)  // yes, cancel, no
  {   if (width < 156) width = 156; // 3 buttons  (150 old)
  }

  if (width < 102) width = 102;     // minimum for 2 buttons (also for 1 for looks)
  width  += 16;                     // margin of 8 pixels

  height  = (count+1)*14;           // height fixed for now
  if (height < 24) height = 24;     // height area + button  40

  // autocenter display for now

  x0 = localrc.left +(  (localrc.right - localrc.left) - width - 8 ) / 2;// - 8;
  y0 = localrc.top  + ( (localrc.bottom- localrc.top ) - height- 8 ) / 2;// -8;
  if (x0 < 0) x0 = 0;
  if (y0 < 0) y0 = 0;
  //if (x0 < localrc.left+8) x0 = localrc.left+8;
  //if (y0 < localrc.top+24) y0 = localrc.top+24;

  HelpControl.heading = Heading;
  HelpControl.type    = HelpType;
  HelpControl.width   = width ;
  HelpControl.height  = height;
  HelpControl.center  = Center;
  HelpControl.solid   = Solid ;
  HelpControl.width   = width;
  HelpControl.heading = Heading;
  HelpControl.prompt  = Prompt;

  // this is prob a bit too big
  //NotifyMsg(NULL,"caption = %d",gd.CaptionHeight);

  int4 Xleft  = x0-8;  //-8
  int4 Ytop   = y0-40-gd.CaptionHeight;           // - size of menubar which can be changed by user
  int4 Xright = x0+width+8+8;
  int4 Ybottom= y0+height+12+32+20+8;

  // slight prob still getting right windows to copy like in checks - sector checking
  // TO FIX LATER when I know how

  hMemBmp = ScreenToMemDC(hwnd,Xleft,Ytop,Xright,Ybottom);		// Save callers area to Memory DC (not perfect yet,can miss areas by getting wrong window?)

  if (HelpType == HELPHELP)         // no button, no edge
  {   HelpMessageDisplay(hwnd,  0,        0  , x0, y0,width+8,height+12);
  }
  else                              // the rest            //12
  {   HelpMessageDisplay(hwnd, HelpType,Solid, x0, y0,width+12,height+12+32);
  }

  //hOldCursor =
  EnableCursor(hHelpWindow,(HCURSOR)LoadCursor(0, IDC_ARROW));

  //--- not be needed
//  hOldCapture = GetCapture();
//  hOldFocus  = GetFocus();
//  SetCapture(hHelpWindow);
//  SetFocus  (hHelpWindow);           // focus
//  SetFocus  (hwnd);                  // focus back to original window
//  GetWindowRect(hHelpWindow, &rc);   // this is help window

  for (;;)
  {
      if (msg.message != 0)
      {   WaitMessage();
      }
                                               //WM_MOUSELAST
      GetCursorPos(&pOldCurPos);
      PointerX = pOldCurPos.x;
      PointerY = pOldCurPos.y -gd.CaptionHeight;  // adjust for top menu bar
                       //hHelpWindow     //BUT4
      if (!PeekMessage(&msg, NULL, WM_KEYFIRST, WM_MOUSELAST, PM_REMOVE)) continue;

      //CheckShiftKey(&msg); not needed causes probs

      if (msg.message == WM_KEYDOWN)// wm_char does not work right
      {   key = msg.wParam;
          if (key)
          {
              if (key == 0x001B)   // escape
              {   key = 0;         // CANCEL, NO
                  break;
              }

              if (key == 'N')      // N
              {   if (HelpType == HELPYESNOCANCEL)
                  {   key = 2;
                  }
                  else
                  {   key = 0;
                  }
                  break;
              }

              if (key == 0x000d    // enter
              ||  key == 0x0020    // space
              ||  key == 'Y')      // Y
              {   key = 1;         // YES, CONTINUE
                  break;
              }
          }
      }

      /*   isn't posting cause we are peeking around, change later
      if (msg.message == BUT1)
      {   key  = 1;
          NotifyMsg(NULL,"BUT1");
          break;
      }
      if (msg.message == BUT2)
      {   key  = 0;
          break;
      } */
      if (msg.message == WM_LBUTTONDOWN
      ||  msg.message == WM_RBUTTONDOWN)
      {   ButtonWaiting = TRUE;
      }
      else
      if (ButtonWaiting)
      {
          if (msg.message == WM_LBUTTONUP)     // continue = TRUE, YES = TRUE
          {   key  = 1;
              // see if over button 1 or button 2
              // only button 2 matters, since that is cancel
              if (pOldCurPos.x >= rcButton2.left
              &&  pOldCurPos.x <= rcButton2.right
              &&  pOldCurPos.y >= rcButton2.top
              &&  pOldCurPos.y <= rcButton2.bottom)
              {   key = 0;
              }
              if (pOldCurPos.x >= rcButton3.left
              &&  pOldCurPos.x <= rcButton3.right
              &&  pOldCurPos.y >= rcButton3.top
              &&  pOldCurPos.y <= rcButton3.bottom)
              {   key =2 ;                     // EDIT,
              }
              //MouseButton = 0;               // DO NOT DO THIS screws up Drawing clear global button, later
              break;
          }
          if (msg.message == WM_RBUTTONUP)     // cancel   = FALSE
          {   key  = 0;
              //MouseButton = 0;               // DO NOT DO THIS screws up Drawing clear global button, later
              break;
          }
      }
  }

//  ReleaseCapture();
//  if (hOldCapture) SetCapture(hOldCapture);
//  if (hOldFocus)   SetFocus(hOldFocus);

  DestroyButtons();
  DeePDestroyWindow(hHelpWindow);
  hHelpWindow = NULL;

  DrawBitmap(hdc, hMemBmp, Xleft,Ytop, SRCCOPY); //  Blast Memory back to Screen

  //DrawBitmap(hdc, hMemBmp, 0,0, SRCCOPY); //  Blast Memory back to Screen testing THIS SHOWS OK, what the hell
  //CheckActivity(NULL,WAIT); // testing

  //SelectPalette(hdc, hOldPal, FALSE);
  SelectFont(hdc, hOldFont);
  DeleteBitmap(hMemBmp);

  ReleaseDC(hwnd, hdc);

//if (hOldCursor) EnableCursor(hwnd,hOldCursor);
//SetCursorPos(PriorCurPos.x, PriorCurPos.y);//   3-1-97  (had to disable prevent jmping around

  ShowCursor(FALSE);
  return key ;

}

/* not used anywhere   8-1-97
//-------------------------------------------------------------------------
//  General Information msg,   12-15-96 , need to change the fonts
//  make it work from a dialog prototype later, no box to click
//-------------------------------------------------------------------------
void InformationMsg(HWND     hwnd,
                    int2     Type,           // 0x0001 = center, 0x8000 = info only
                    HBITMAP *hSaveBmp,       // for saving screen
                    char    *UserHeading,...)//then char*UserText,...)
{
  char     Heading[120];

  HPALETTE hOldPal;
  HDC      hdc;
  HFONT    hOldFont;
  RECT     localrc;

  int2     x0,y0;

  va_list  ap;
  char    *msg;
  char    *msgin;
  int4     msglen;
  int4     tabLoc;
  int4     cumLength;
  SIZE     TxtSize;

  int4     count=0;
  int2     xloc,yloc;
  int4     i,j;
  int2     height ;            // height of box
  int2     width;              // width
  int2     Headingwidth;       // width

  ColorText Prompt[82];        // 80 max lines

  int2     Center;
  int2     InfoOnly;

//-------------------------------------------------------------------------
//-------------------------------------------------------------------------


  Center  = Type&HELPCENTER;
  InfoOnly= Type&HELPINFO;

  if (InfoOnly)
  {   strcpy(Heading, "Info - ");
      strcat(Heading,UserHeading);     //info only
  }
  else
  {   strcpy(Heading, "Help - ");
      strcat(Heading,UserHeading);     //help only
  }

  // want to expand window to put our needs   11-11-96 <<<<<<<<<<<<<<<<<<<<
  GetClientRect(hwnd, &localrc);

  hdc      = GetDC(hwnd);
  hOldPal  = SelectPalette(hdc, gd.hDoomPal, FALSE);
  hOldFont = SelectFont(hdc,GetStockFont(ANSI_VAR_FONT));// Select a font //ANSI_FIXED_FONT

  RealizePalette(hdc);

  // for now fixed height stuff   11-11-96

  *hSaveBmp = ScreenToMemDC(hwnd);		// Save MAP area to Memory DC

  // get width of heading

  GetTextExtentPoint32(hdc,Heading,strlen(Heading),&TxtSize);

  Headingwidth = TxtSize.cx;
  width        = Headingwidth;      // start with heading

  va_start( ap, UserHeading);       // text follows

  while ( count < 80 )
  {
      msg = va_arg (ap,char *);
      if (!msg) break;

      Prompt[count].text = msg;
      Prompt[count].color = BLACK;  // no hilite as used to be , later?
      count++;
   }
   va_end(ap);

   Prompt[count].text = NULL;     // terminate list

   for (i=0; i < count; i++)
   {
        msgin  = Prompt[i].text;
        msglen = strlen(msgin);
        cumLength = 0;

        for (j=0; j< msglen; j++,msgin++)
        {
           if (msgin[0] == '\t')           // a tab
           {   tabLoc   = cumLength/32;    // number of tabs req'd to get here each tab is 32
               cumLength= (tabLoc+1)*32;   // where tab is
               continue;
           }
           GetTextExtentPoint32(hdc,msgin,1,&TxtSize);
           cumLength+=TxtSize.cx;

        }
        if (cumLength > width) width = cumLength;
   }

   width  += 16;       // margin of 8 pixels
   height  = (count+1)*14;//ht2     fixed for now


   // autocenter display for now

   x0 = localrc.left +(  (localrc.right - localrc.left) - width  ) / 2 - 8;
   y0 = localrc.top  + ( (localrc.bottom- localrc.top ) - height ) / 2 -24;
   if (x0 < localrc.left+8) x0 = localrc.left+8;
   if (y0 < localrc.top+24) y0 = localrc.top+24;


   // add amount for box surround

   DrawScreenBox3D      (hdc, x0-8,y0-24,x0+width+8,y0+height+32 ,gd.hBrushes[MenuColor]);
   DrawScreenLineHollow (hdc, x0  ,y0   ,x0+width  ,y0+height   ,gd.hBrushes[LIGHTYELLOW]);

   xloc =  (width - Headingwidth)/2 -4;         // center heading

   DrawScreenTextOutlineScale(hdc, x0+xloc,y0-20,MenuInfoColor,Heading); // heading

  //---------------------------------------------------------------

  xloc = x0+8;
  yloc = y0+4;

  MessageDisplay (hdc, xloc,yloc,Center,width-16,Prompt);    // pass the list

  SelectPalette(hdc, hOldPal, FALSE);
  SelectFont(hdc, hOldFont);
  ReleaseDC(hwnd, hdc);

  return ;

}
*/
//---------------------------------------------------------------------------
//	TRACE FUNCTION
//---------------------------------------------------------------------------
void Trace(HWND hwnd, int2 x, int2 y, char *notstr, ...)// x,y, str
{
	char   msg[512];
   char  *pArgs;				// Pointer to arguments
   RECT   rc;
   HDC    hdc;
   int    length;
   static SIZE sOld;
   SIZE   s;
   HFONT  hOldFont;

   pArgs = (char *) &notstr + sizeof (notstr);    // find it

	vsprintf( msg, notstr, pArgs);

   length = lstrlen(msg);

   if (hwnd)
   {   hdc = GetWindowDC(hwnd);                    // Get a DC for Window
   }
   else
   {   hdc = GetWindowDC(gd.hMainWindow);          // use current ?? causes probs?
   }

   hOldFont= SelectFont(hdc,gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));// Select a font

   GetTextExtentPoint32(hdc, msg, length, &s);	// find the extents of our text

   if(s.cx < sOld.cx) s.cx = sOld.cx;

   rc.left 		= x;
   rc.top 		= y;
   rc.right 	= x + s.cx;
   rc.bottom 	= y + s.cy;
	SetBkMode(hdc, OPAQUE);
   SetBkColor(hdc, RGB(255, 255, 255));
   SetTextColor(hdc, RGB(0, 0, 0));

   InflateRect(&rc, 1, 1);

   ExtTextOut	(hdc, rc.left, rc.top, ETO_OPAQUE, &rc, msg, lstrlen(msg), NULL);

   SelectFont(hdc, hOldFont);

   ReleaseDC(hwnd, hdc);

   sOld.cx = s.cx;
}


//---------------------------------------------------------------------------
//	Display a formatted series of TEXT in the Caption Bar of a supplied WND
// Used in NewGraph to Display patches in the Caption Bar
//---------------------------------------------------------------------------
//
void DisplayCaptionText(HWND hwnd, int2 x, int2 y, char *notstr, ...)// x,y, str
{
	char msg[128];
   char *pArgs;				// Pointer to arguments
   RECT rc;
   HDC hdc;
   int length;
   SIZE s;
   static SIZE sOld = {0,0};		// the old x TEXT length

   HFONT hOldFont;

   pArgs = (char *) &notstr + sizeof (notstr);    // find it

	vsprintf( msg, notstr, pArgs);

   length = lstrlen(msg);

   hdc = GetWindowDC(hwnd);                    // Get a DC for Window

   hOldFont= SelectFont(hdc,gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));// Select a font
   SetBkMode(hdc, OPAQUE);
   SetBkColor(hdc, GetSysColor(COLOR_ACTIVECAPTION));		// GetCaptionColor
   SetTextColor(hdc, GetSysColor(COLOR_CAPTIONTEXT));		// Set Text Color

   GetTextExtentPoint32(hdc, msg, length, &s);	// find the extents of our text

   if(s.cx < sOld.cx)  s.cx 	 =  sOld.cx;
   else                sOld.cx =  s.cx;

   rc.left 		= x;
   rc.top 		= y;
   rc.right 	= x + s.cx;		// make sure to wipe prev.
   rc.bottom 	= y + s.cy;

   ExtTextOut	(hdc, rc.left, rc.top, ETO_OPAQUE, &rc, msg, lstrlen(msg), NULL);

   SelectFont(hdc, hOldFont);
   ReleaseDC(hwnd, hdc);

}

//////////////////////////////////////////////////
//	A temp. dialog for information puroposes only /
//////////////////////////////////////////////////

void Deep_NotYet(HWND hwnd)
{
	//MessageBox(hwnd, szLoadString(IDS_REENTER), szLoadString(IDS_DEEPINFO), MB_OK);
   ErrorMsg(hwnd, "Please Choose Another");
}


//---------------------------------------------------------------------------
//	FUNCTION:	ReallyCancel
//
//	PURPOSE:	Displays a YES/NO MessageBox asking the user
//				if they *REALLY* want to cancel . If the
//				user replies NO, then the focus of the message
//				box is put on the IDOK button of the calling dialog.
//---------------------------------------------------------------------------
/*   3-1-97 not used anywhere
Bool ReallyCancel(HWND hDlg)
{
	Bool bRetVal;

	bRetVal = (IDYES == MessageBox(	hDlg,"Do you really want to Do this?",
									 "ARE YOU SURE ?", MB_ICONQUESTION | MB_YESNO ));
	if (!bRetVal)
		SetFocus(GetDlgItem(hDlg, IDOK));
	return bRetVal;
}

*/
//////////////////////////////////////////////////////////////////////
//  FUNCTION: QuerySaveChanges(HWND)
//
//  PURPOSE: Queries user to save changes
//
//  PARAMETERS:
//    hwnd      - The window handle.
//
//  RETURN VALUE:
//    IDOK    = nothing to save, just do it
//    IDYES   = user elects to save changes
//    IDNO    = user elects to abandon changes or there were no changes
//    IDCANCEL= user wants to abandon calling process
///////////////////////////////////////////////////////////////////////
#pragma argsused

int QuerySaveChanges(HWND hwnd)
{
    int nResult = IDOK;                   //this means no changes to worry about was IDNO default if no changes, just exit
    LevelPtr level = &LevelWad.level;

    if (level->MadeChanges || level->MadeMapChanges)
    {
       // IDYES, IDNO, IDCANCEL
       nResult = Continue(hwnd,"File has been modified. Save Changes?");
    }

    return nResult;
}




//--------------------------------------------------------------------------------
// see if changes made and return TRUE if user wants to continue anyway
//--------------------------------------------------------------------------------

Bool CheckChangesAndContinue(char *commandtype)
{
   LevelPtr level = &LevelWad.level;
   char msg[60];

   if (commandtype)
   {   sprintf(msg," You have unsaved Changes.  Continue with %s?",commandtype);
   }
   else
   {   strcpy(msg," You have unsaved Changes. Continue ?");
   }

   if (level->MadeChanges && !Confirm(0, msg))
   {   return FALSE;
   }
   else
   {   return TRUE;
   }

}



 		///////////////////////////
		//                       //
		//	Window routines :     //
		//	Center Dialog         //
		//	Center Window         //
		//	Erase Window          //
		// Find Coords           //
		///////////////////////////




////////////////////////////////////////////////////////////////
//
//	FUNCTION:	CenterWindow
//
//	PURPOSE:	Centers a Window on the screen
//
//	Caveat's:	If NULL is passed as 2nd parameter the window
//	is centered within the current resolution
//
/////////////////////////////////////////////////////////////////
VOID CenterWindow(HWND hwnd, HWND hwndParent)
{
  int   xWindow;
  int   yWindow;
  int   cxWindow;
  int   cyWindow;
  int   cxScreen;
  int   cyScreen;
  int   cxParent;
  int   cyParent;
  RECT  rcWindow;

  cxScreen = GetSystemMetrics(SM_CXSCREEN);
  cyScreen = GetSystemMetrics(SM_CYSCREEN);

  GetWindowRect(hwnd, (LPRECT)&rcWindow);

  //calculate Window size
  cxWindow = rcWindow.right - rcWindow.left;
  cyWindow = rcWindow.bottom - rcWindow.top;

  //calculate bounding rectangle
  if (hwndParent)
   {
	 //retrieve parent rectangle
	 GetWindowRect(hwndParent, (LPRECT)&rcWindow);

	 //calculate parent extents
	 cxParent = rcWindow.right - rcWindow.left;
	 cyParent = rcWindow.bottom - rcWindow.top;

	 //center within parent window
	 xWindow = rcWindow.left + ((cxParent - cxWindow)/2);
	 yWindow = rcWindow.top  + ((cyParent - cyWindow)/2);

	 //adjust Window x-location for screen size
	 if (xWindow+cxWindow > cxScreen)
		xWindow = cxScreen-cxWindow;

	 //adjust Window y-location for screen size
	 if (yWindow+cyWindow > cyScreen)
		yWindow = cyScreen-cyWindow;
  } else {
	 //center within entire screen
	 xWindow = (cxScreen - cxWindow) / 2;
	 yWindow = (cyScreen - cyWindow) / 2;
  }
  MoveWindow(hwnd,
	 (xWindow > 0) ? xWindow : 0,
	 (yWindow > 0) ? yWindow : 0,
	 cxWindow, cyWindow, TRUE);
}


//////////////////////////////////////////////////////////////////////
//
//	Erase a window by filling the client rect. specified brush
//
/////////////////////////////////////////////////////////////////////
//
void EraseWindow(HWND hwnd, int4 Color,int2 xstart, int2 ystart,int2 xend, int2 yend)
 {
	HDC hdc;
   RECT rc;

	hdc =		GetDC(hwnd);
   GetClientRect(hwnd, &rc);
   // no one was using this, just for info
   //if (EditMode == OBJ_THINGS && ShowThingPic)
   //{   FillRect(hdc, &rc, gd.hBrushes[BackThingColor]);
   //}
   //else
   //{   FillRect(hdc, &rc, gd.hBrushes[BackColor]);
   //}
   if (xstart >=0)
   {   SetRect(&rc, xstart,ystart, xend, yend);
   }
   FillRect(hdc, &rc, gd.hBrushes[Color]);

   ReleaseDC(hwnd, hdc);
}



/////////////////////////////////////////////////////////////////////////
//
//  szLoadString
//
//  Returns a pointer to a string copied from the stringtable.
//
//  iID  The ID of the item in the stringtable
//
//  Return Value
//
//  Pointer to the string
//
//  NOTE: You can only call this functin up to three times in a
//  singlefunction call.
//
/////////////////////////////////////////////////////////////////////////
LPCSTR szLoadString ( int iID )
{

  // These strings MUST be static so they don't live on the stack.  Since we
  // will be returning a pointer to one of these strings, we want the information
  // to be there once we exit this function
  // The number of strings in the circular buffer depends on how many times the
  // szLoadString function will be called in a single function call.  For
  // example, if you do this:
  //
  //   MessageBox ( NULL,
  //                szLoadString(IDS_ERROR1),
  //                szLoadString(IDS_MSGBOXTITLE),
  //                MB_OK );
  //
  // Then you will need at least two different buffers, since both strings need to be
  // loaded before the MessageBox function can be called.

  static int WhichString = 0;
  static char szLoadedString1[512];  //   3-1-97 too small for tutor
  static char szLoadedString2[512];
  static char szLoadedString3[512];
  //static char szLoadedString4[512];  //   8-1-97 had to add one more (redid file string settings)
  //static char szLoadedString5[512];  //   8-1-97 had to add one more

  // These are just normal local varaibles used for looping and return values
  // and string magic

  BOOL bKeepLoading;
  char *szLoadedString;
  char szLoadBuffer[512];

  // This implements a circular buffer through the three strings. This means that
  // the pointer you get back from szLoadString will have the correct string in
  // it until szLoadString has been called three more times.

  switch (WhichString)
  {
    case 0: szLoadedString = szLoadedString1; break;
    case 1: szLoadedString = szLoadedString2; break;
    case 2: szLoadedString = szLoadedString3; break;
    //case 3: szLoadedString = szLoadedString4; break;
    //case 4: szLoadedString = szLoadedString5; break;
  }

  WhichString++;
  if (3==WhichString) WhichString=0;
  //if (5==WhichString) WhichString=0;

  // This allows loading of strings greater than 255 characters. If the
  // first character of the string is an exclamation point, this means to
  // tack on the string with a value of ID+1.  This continues until
  // the next string does not exist or the first character is not an
  // exclamation point

  szLoadedString[0] = 0;  // Init the string to emptyville.

  do
  {
     bKeepLoading = FALSE;
	  if (LoadString ( gd.hInst, iID, szLoadBuffer, sizeof(szLoadBuffer)))
     {
	     if ('!' == *szLoadBuffer)   // Continuation character found. Keep the loop going
        {
           bKeepLoading = TRUE;

           // Assume next entry in string table is in numerical order
           iID++;

           lstrcat ( szLoadedString, szLoadBuffer+1 );
        }
        else
        {
           lstrcat ( szLoadedString, szLoadBuffer );
	     }
     }
  }
  while (bKeepLoading);

  return (LPSTR)szLoadedString;
}



//////////////////////////////////////////////////////////////////////////////
//
//		Creates our 30 brushes and Pens for drawing based on Doom Palette
//
//    Create HighLight Pens, MAGENTA,ORANGE,LIGHTRED,GREEN,HIGHLIGHTCOLOR
//    Added July 23/96
/////////////////////////////////////////////////////////////////////////////
void MakePens(HWND hwnd)
{
	HDC      hdc;
   HPALETTE hOldPal;
   LOGBRUSH lb1;                            
   LOGBRUSH lb2;

	//	ClearSystemPalette();

   LoadDoomPalette(hwnd, 0);		// Load our current palette as reflected

   hdc     = GetDC(hwnd);
   hOldPal = SelectPalette(hdc, gd.hDoomPal, TRUE);

   int i;

   // Make 30 Brushes and Pens with our 30 Game Colors

	for(i = 0;i < 30; i++)
   {
      if(i == 0)       // BLACK  is always 0,0,0 now, so this could be dropped
      {  gd.hPens[i]    = CreatePen(PS_SOLID, LineThickness, RGB(0,0,0));      //BLACK
         gd.hBrushes[i] = CreateSolidBrush(RGB(0,0,0));                        // ditto
            //gd.hPens[i] 	=  GetStockPen(BLACK_PEN);       //BLACK
            //gd.hBrushes[i] = GetStockBrush(BLACK_BRUSH);   // ditto
      }
      else
      if(i == 15) // WHITE
      {  gd.hPens[i]    = CreatePen(PS_SOLID, LineThickness, RGB(255,255,255));//WHITE
         gd.hBrushes[i] = CreateSolidBrush(RGB(255,255,255));                  // ditto
          //gd.hPens[i] 	=  GetStockPen(WHITE_PEN);       //WHITE
          //gd.hBrushes[i] =  GetStockBrush(WHITE_BRUSH);   // ditto
      }
      else
      {  gd.hPens[i]    = CreatePen(PS_SOLID, LineThickness, PALETTEINDEX(GameColors[i]));
         gd.hBrushes[i] = CreateSolidBrush(PALETTEINDEX(GameColors[i]));
      }

      if (gd.hBrushes[i] == NULL)
      {   NotifyMsg(NULL,"Brush %hd creation failure?",i);
      }
      if (gd.hPens[i] == NULL)
      {   NotifyMsg(NULL,"Pen %hd creation failure?",i);
      }
   }

  gd.hMagentaPen  = CreatePen(PS_SOLID, 3, PALETTEINDEX(GameColors[MAGENTA]));
  gd.hOrangePen   = CreatePen(PS_SOLID, 3, PALETTEINDEX(GameColors[ORANGE]));
  gd.hLightRedPen = CreatePen(PS_SOLID, 3, PALETTEINDEX(GameColors[LIGHTRED]));
  gd.hGreenPen    = CreatePen(PS_SOLID, 3, PALETTEINDEX(GameColors[GREEN]));
  gd.hHiLightPen  = CreatePen(PS_SOLID, 3, PALETTEINDEX(GameColors[HiLightColor]));
  gd.hDrawPen     = CreatePen(PS_SOLID, 1, PALETTEINDEX(GameColors[InsVertexColor]));

  // normal select
  lb1.lbStyle = BS_SOLID;
  lb1.lbColor = PALETTEINDEX(GameColors[SelectColor]);
  lb1.lbHatch = 0;
  // Things and Thing picture select
  lb2.lbStyle = BS_SOLID;
  lb2.lbColor = PALETTEINDEX(GameColors[BackThingColor]);
  lb2.lbHatch = 0;

  if(SelectDash)
  {  gd.hSelectPen  = ExtCreatePen(PS_COSMETIC | PS_DOT   ,1,&lb1,0,NULL);
     gd.hSelectPenT = ExtCreatePen(PS_COSMETIC | PS_DOT   ,1,&lb2,0,NULL);
  }
  else
  {  gd.hSelectPen  = ExtCreatePen(PS_COSMETIC | PS_SOLID ,1,&lb1,0,NULL);
     gd.hSelectPenT = ExtCreatePen(PS_COSMETIC | PS_SOLID ,1,&lb2,0,NULL);
  }

  lb1.lbStyle  = BS_SOLID;                                               //  12-13-96
  lb1.lbColor  = PALETTEINDEX(GameColors[GridColor]);                    // Grid for normal
  lb1.lbHatch  = 0;
  gd.hGridPen  = ExtCreatePen(PS_COSMETIC | PS_DOT ,1,&lb1,0,NULL);      //   12-13-96 for grid

  lb1.lbColor  = PALETTEINDEX(GameColors[BackThingColorMap]);            // Grid for things+pictures
  gd.hGridPenT = ExtCreatePen(PS_COSMETIC | PS_DOT ,1,&lb1,0,NULL);      //   12-13-96 for grid

  if (hOldPal) SelectPalette(hdc, hOldPal, FALSE);  //   12-13-96 why does it have to be restored??

  ReleaseDC(hwnd, hdc);
}

//////////////////////////////////////////////////////////////////////////////
//		Make 3 fonts, small, med, and large
/*HFONT CreateFont(
    int  nHeight,      	       // logical height of font
    int  nWidth,	             // logical average character width
    int  nEscapement,	       // angle of escapement
    int  nOrientation,	       // base-line orientation angle
    int  fnWeight,     	       // font weight
    DWORD  fdwItalic,	       // italic attribute flag
    DWORD  fdwUnderline,       // underline attribute flag
    DWORD  fdwStrikeOut,       // strikeout attribute flag
    DWORD  fdwCharSet,	       // character set identifier
    DWORD  fdwOutputPrecision, // output precision
    DWORD  fdwClipPrecision,	 // clipping precision
    DWORD  fdwQuality,         // output quality
    DWORD  fdwPitchAndFamily,  // pitch and family
    LPCTSTR  lpszFace          // address of typeface name string
   );*/

//////////////////////////////////////////////////////////////////////////////
// NOTES:   when font size is changed for main screen by user like from
//          small to large fonts, it changes ALL the fonts, unless
//          it's NOT MS Sans Serif?
//////////////////////////////////////////////////////////////////////////////
void MakeFonts()
{
LOGFONT LogFontSmall ;
LOGFONT LogFontStock ;
LOGFONT LogFontMed   ;
LOGFONT LogFontLarge ;
LOGFONT LogFontTips  ;
LOGFONT DumpFont     ;

char  LogFontName[] = "Arial";//"MS Sans Serif"; <-- MS get's too big on large font option ?? why ??

   //	Make 4 system fonts for our use
  memset(&LogFontSmall, 0, sizeof(LOGFONT));
  LogFontSmall.lfHeight        = 10;
  LogFontSmall.lfWidth         = 6;
  LogFontSmall.lfWeight        = FW_MEDIUM;
  LogFontSmall.lfOutPrecision  = OUT_TT_PRECIS;
  LogFontSmall.lfClipPrecision = CLIP_STROKE_PRECIS;
  LogFontSmall.lfQuality       = PROOF_QUALITY;
  LogFontSmall.lfCharSet       = ANSI_CHARSET;
  strcpy(LogFontSmall.lfFaceName, LogFontName);
  LogFontSmall.lfPitchAndFamily = FF_SWISS| VARIABLE_PITCH;//| FIXED_PITCH; was fixed   8-1-97 ?

  if (gd.hSmallFont != 0) DeleteObject(gd.hSmallFont);
  gd.hSmallFont = CreateFontIndirect(&LogFontSmall);

  //-----------------------------------------------------
  // this replaces GetStockFont(ANSI_VAR_FONT) and DEFAULT_GUI_FONT)
  // so user settings dont mess stuff up

  memset(&LogFontStock, 0, sizeof(LOGFONT));
  LogFontStock.lfHeight        = 14;            // char height (not cell)
  LogFontStock.lfWidth         = 5;             // not auto
  LogFontStock.lfWeight        = FW_NORMAL;     //MEDIUM;
  LogFontStock.lfOutPrecision  = OUT_TT_PRECIS;
  LogFontStock.lfClipPrecision = CLIP_STROKE_PRECIS;
  LogFontStock.lfQuality       = PROOF_QUALITY;
  LogFontStock.lfCharSet       = ANSI_CHARSET;
  strcpy(LogFontStock.lfFaceName, LogFontName);
  LogFontStock.lfPitchAndFamily = FF_SWISS | VARIABLE_PITCH;

  if (gd.hStockFont != 0) DeleteObject(gd.hStockFont);
  gd.hStockFont = CreateFontIndirect(&LogFontStock);

  //------------------------------------------------------------
  memset(&LogFontMed, 0, sizeof(LOGFONT));
  LogFontMed.lfHeight        = 12;
  LogFontMed.lfWidth         =  5;        //???  3-1-97 no width given
  LogFontMed.lfWeight        = FW_MEDIUM; //  was BOLD;
  LogFontMed.lfOutPrecision  = OUT_STROKE_PRECIS;
  LogFontMed.lfClipPrecision = CLIP_STROKE_PRECIS;
  LogFontMed.lfQuality       = PROOF_QUALITY;;//DEFAULT_QUALITY;
  LogFontMed.lfCharSet       = ANSI_CHARSET;
  LogFontMed.lfPitchAndFamily = FF_SWISS | VARIABLE_PITCH;
  strcpy(LogFontMed.lfFaceName, LogFontName);

  if (gd.hMedFont != 0) DeleteObject(gd.hMedFont);
  gd.hMedFont = CreateFontIndirect(&LogFontMed);

  //------------------------------------------------------------
  // (used for texture names only- need tight spacing
  //-----------------------------------------------------------
  memset(&LogFontLarge, 0, sizeof(LOGFONT));
  LogFontLarge.lfHeight        = 13;
  LogFontLarge.lfWidth         =  4;
  LogFontLarge.lfWeight        = FW_MEDIUM;
  LogFontLarge.lfOutPrecision  = OUT_TT_PRECIS;
  LogFontLarge.lfClipPrecision = CLIP_STROKE_PRECIS;
  LogFontLarge.lfQuality       = PROOF_QUALITY;
  LogFontLarge.lfCharSet       = ANSI_CHARSET;
  LogFontLarge.lfPitchAndFamily = FF_SWISS | VARIABLE_PITCH;//FF_MODERN |FIXED_PITCH;//FF_SWISS | VARIABLE_PITCH;
  strcpy(LogFontLarge.lfFaceName, LogFontName);

  if (gd.hLargeFont != 0) DeleteObject(gd.hLargeFont);
  gd.hLargeFont = CreateFontIndirect(&LogFontLarge);

  //------------------------------------------------------------
  //   3-1-97 for tips
   memset(&LogFontTips, 0, sizeof(LOGFONT));
   LogFontTips.lfHeight        = 15;             //was 16/0
   LogFontTips.lfWidth         =  0; // auto size
   LogFontTips.lfWeight        = FW_MEDIUM;
   LogFontTips.lfOutPrecision  = OUT_TT_PRECIS;
   LogFontTips.lfClipPrecision = CLIP_STROKE_PRECIS;
   LogFontTips.lfQuality       = PROOF_QUALITY;
   LogFontTips.lfCharSet       = ANSI_CHARSET;
   LogFontTips.lfPitchAndFamily = FF_SWISS | VARIABLE_PITCH;    // this is ok
   strcpy(LogFontTips.lfFaceName, LogFontName);

   if (gd.hTipsFont != 0) DeleteObject(gd.hTipsFont);
   gd.hTipsFont = CreateFontIndirect(&LogFontTips);

   wt   = 7;		// Default Small Font
   ht   = 9;
   wt2  = 10;
   ht2  = 10;
   wt12 = 12;
   ht12 = 12;


   DumpFont.lfHeight         =  15; //14
   DumpFont.lfWidth          =  7;  //9;
   DumpFont.lfEscapement     =  0;
   DumpFont.lfOrientation    =  0;
   DumpFont.lfWeight         =  FW_NORMAL;
   DumpFont.lfItalic         =  FALSE;
   DumpFont.lfUnderline      =  FALSE;
   DumpFont.lfStrikeOut      =  FALSE;
   DumpFont.lfCharSet        =  ANSI_CHARSET;
   DumpFont.lfOutPrecision   =  OUT_DEFAULT_PRECIS;
   DumpFont.lfClipPrecision  =  CLIP_DEFAULT_PRECIS;
   DumpFont.lfQuality        =  DEFAULT_QUALITY;
   DumpFont.lfPitchAndFamily =  FIXED_PITCH | FF_DONTCARE;
   strcpy((char *)DumpFont.lfFaceName, "Courier New");//"System");

   if (gd.hHexDumpFont) DeleteObject(gd.hHexDumpFont);
   gd.hHexDumpFont = CreateFontIndirect(&DumpFont);

}
///////////////////////////////////////////////////////////////////////////
//  set text type-------------this must be changed for Window
//  allows positioning of text generically depending on font size
// in transition
//
//  Added 3 other fonts  - these are stock items and don't need to be removed
//
//	DEFAULT_GUI_FONT
// Ansi_Var_Font	variable
// Ansi_Fixed_Font
///////////////////////////////////////////////////////////////////////////
void SetTextType(HDC hdc, int2 type)
{
    CurrentTextType = type;

    if (type <= 1)
    {
    SelectFont(hdc, gd.hSmallFont);
        wt   = 6;  //6
        wt2  = 8;  //8
        wt12 = 10; //10
        if (type == 1)
        {   ht   = 12;
            ht2  = 13;
            ht12 = 14;
        }
        else
        if (type == 0) // 0 = keep same size horizontal spacing
        {   ht   = 8;
            ht2  = 10;
            ht12 = 12;
        }
        else           // -1 follow big font
        {   wt   = 8;
            wt2  = 10;
            wt12 = 12;
            ht   = 12;
            ht2  = 13;
            ht12 = 14;
        }

    }
    else if (type ==2)
    {
    	  SelectFont(hdc, gd.hMedFont);
        wt   = 8;
        wt2  = 10;
        wt12 = 12;

        ht   = 12;
        ht2  = 13;    //14
        ht12 = 14;    //12
    }
    else if (type ==3)
    {
    //SelectFont(hdc, GetStockFont(ANSI_VAR_FONT));
    SelectFont(hdc, gd.hStockFont);

        wt   = 8;
        wt2  = 10;
        wt12 = 12;

        ht   = 12;
        ht2  = 14;
        ht12 = 16;
    }
    else if (type ==4)   // was large, but notices size probs if user has diff fonts selected desktop
    {
    SelectFont(hdc, gd.hStockFont);//LargeFont);
        wt   = 8;
        wt2  = 10;
        wt12 = 12;

        ht   = 12;
        ht2  = 13;    //14
        ht12 = 14;    //12
    }
    else if (type ==5)
    {
//    SelectFont(hdc, GetStockFont(DEFAULT_GUI_FONT));
    SelectFont(hdc, gd.hStockFont);
        wt   = 8;
        wt2  = 10;
        wt12 = 12;

        ht   = 12;
        ht2  = 13;    //14
        ht12 = 14;    //12
    }
    else if (type ==6) // for AutoSize outline get width prediction closer
    {
    SelectFont(hdc, gd.hLargeFont);
        wt   = 6;
        wt2  = 7 ;
        wt12 = 9 ;

        ht   = 13;
        ht2  = 14;    //14
        ht12 = 15;    //12
    }
    else if (type == 7)    // new large font for texture names only maybe ?
    {
    SelectFont(hdc, gd.hLargeFont);
        wt   = 8;
        wt2  = 10;
        wt12 = 12;

        ht   = 12;
        ht2  = 13;    //14
        ht12 = 14;    //12
    }
}

/////////////////////////////////////////////////////////////////////////////
//   this was added to try to solve 1st time pen probs   12-13-96
/////////////////////////////////////////////////////////////////////////////
void CheckAndDeletePen(HPEN *userpen)
{
    if (*userpen)
    {   DeletePen  ( *userpen);
        //{ Trace(NULL,10,8,"deletePenfailed");    // but that means a DC still has it????
        //}
        *userpen = NULL;
    }
}

void CheckAndDeleteBrush(HBRUSH *userbrush)
{
    if (*userbrush)
    {   DeleteBrush  ( *userbrush);
        //{ Trace(NULL,160,8,"deletebrushfailed");
        //}
        *userbrush = NULL;
    }
}
////////////////////////////////////////////////////////////////////////////
//	Delete all of our pens and brushes (== DeleteObject ==  comment to myself)
//      ReleaseDC(hwnd,hdc);       for GetWindowDC, GetDC
//      DeleteDC                   for CreateDC and CreateCompatibleDC
////////////////////////////////////////////////////////////////////////////
//
void ForgetPens(void)
{

	for(int2 i = 0;i < 30; i++)
   {
       //DeletePen  ( gd.hPens[i] );          //   12-13-96
		 //DeleteBrush( gd.hBrushes[i]);        //
       CheckAndDeletePen  ( &gd.hPens[i] );   //
		 CheckAndDeleteBrush( &gd.hBrushes[i]); //
   }

   //DeletePen(gd.hMagentaPen);               //
   //DeletePen(gd.hOrangePen);
   //DeletePen(gd.hLightRedPen);
   //DeletePen(gd.hGreenPen);
   //DeletePen(gd.hHiLightPen);
   //DeletePen(gd.hSelectPen);
   //DeletePen(gd.hSelectPenT);
   //DeletePen(gd.hDrawPen);
   //DeletePen(gd.hGridPen);
   //DeletePen(gd.hGridPenT);

   CheckAndDeletePen(&gd.hMagentaPen);
   CheckAndDeletePen(&gd.hOrangePen);
   CheckAndDeletePen(&gd.hLightRedPen);
   CheckAndDeletePen(&gd.hGreenPen);
   CheckAndDeletePen(&gd.hHiLightPen);
   CheckAndDeletePen(&gd.hSelectPen);
   CheckAndDeletePen(&gd.hSelectPenT);
   CheckAndDeletePen(&gd.hDrawPen);        //   12-13-96
   CheckAndDeletePen(&gd.hGridPen);        //
   CheckAndDeletePen(&gd.hGridPenT);       //

   if(gd.hDoomPal)  DeletePalette(gd.hDoomPal);
   gd.hDoomPal = NULL;

}

////////////////////////////////////////////////////////////////////////////
void ForgetFonts()
{
	if (gd.hSmallFont !=0) 	DeleteFont(gd.hSmallFont);
	if (gd.hStockFont !=0) 	DeleteFont(gd.hStockFont);
	if (gd.hMedFont   !=0) 	DeleteFont(gd.hMedFont);
	if (gd.hLargeFont !=0) 	DeleteFont(gd.hLargeFont);
   if (gd.hTipsFont  != 0)  DeleteObject(gd.hTipsFont);
   if (gd.hHexDumpFont !=0) DeleteObject(gd.hHexDumpFont);
   // safety   11-7-96
	gd.hSmallFont=0;
	gd.hStockFont=0;
	gd.hMedFont  =0;
	gd.hLargeFont=0;
   gd.hTipsFont =0;
   gd.hHexDumpFont = 0;
}


////////////////////////////////////////////////////////////////////////////

void SoundBeep(int2 BeePType)
{
   static BOOL  DidSound;

	if (QuietSelect == TRUE)
	{  if (QuietSpeaker)
      {
          if (BeePType > 0 )
          {
            DidSound = PlaySound(SoundWaveResource[BeePType-1], gd.hInst, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);

            if (!DidSound)
            {    MessageBeep (-1);  // failed, use internal speaker
            }
          }
      }
      else
      {    MessageBeep (-1);  // just the internal speaker
      }
	}
}

////////////////////////////////////////////////////////////////////////////
void SoundBeepError(int2 BeePType)
{
   static BOOL  DidSound;

	if (QuietError)
	{  if (QuietSpeaker)
      {
          if (BeePType > 0 )
          {
            DidSound = PlaySound(SoundWaveResource[BeePType-1], gd.hInst, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);

            if (!DidSound)
            {    MessageBeep (-1);  // failed, use internal speaker
            }
          }
      }
      else
      {    MessageBeep (-1);  // just the internal speaker
      }
	}
}

////////////////////////////////////////////////////////////////////////////
void SoundError()
{
   static BOOL DidSound;

	if (QuietError)
	{
	   if (QuietSpeaker)
      {   DidSound = PlaySound(SoundWaveResource[SOUNDSWISH1-1], gd.hInst, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);
          if (!DidSound)
          {   MessageBeep(MB_OK);		// Use this if multimedia
          }
      }
      else
      {   MessageBeep(MB_OK);		      // Use this if multimedia
      }
	}
}
////////////////////////////////////////////////////////////////////////////
void SoundHelp()
{   static DidSound;

    if (QuietError)
	 {  if (QuietSpeaker)
       {   DidSound = PlaySound(SoundWaveResource[SOUNDDRIP-1], gd.hInst, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);
           if (!DidSound)
           {   MessageBeep(MB_OK);		// Use this if multimedia
           }
       }
       else
       {   MessageBeep(MB_OK);		      // Use this if multimedia
       }
    }
}

////////////////////////////////////////////////////////////////////////////
void SetVertexSize(float Scl)
{

  VertexSize = 11;                    //   12-2-96 was 14

  if(Scl <= 4.0)		VertexSize = 8;  //9  12-2-96 was 11
  if(Scl <= 2.0)		VertexSize = 6;  //7  12-2-96 was  9
  if(Scl <= 1.0)		VertexSize = 4;  //   12-2-96 was 5
  if(Scl <= .50)		VertexSize = 3;
  if(Scl <= .25)		VertexSize = 2;


  // this should be done 1 time in set scale routine

  Thingsize = 1;
  if( Scl >= 2.00 )  Thingsize  =  2;
  if( Scl >= 4.00 )  Thingsize  =  3;
  if( Scl >= 8.00 )  Thingsize  =  4;
  if( Scl <  1.00 )  Thingsize  =  0;   // 1/2
  if( Scl <  .5)     Thingsize  = -1;   // 1/3
  if( Scl <  .25)    Thingsize  = -2;   // 1/4
  if( Scl <  .125 )  Thingsize  = -3;   // 1/4
  if( Scl <  .065 )  Thingsize  = -4;   // 1/4
}


////////////////////////////////////////////////////////////////////////////
//		MaximizeWindow - Makes Window Full Screen & allows the user
//		to scroll the map by clicking on the caption bar etc
//		and just throwing the mouse to the 4 corners of the screen
////////////////////////////////////////////////////////////////////////////

void MaximizeWindow(HWND hwnd, int whichTime)
{

   int yScreen;                              //   12-13-96 so it's easier to tinker
   int xScreen;

   xScreen = GetSystemMetrics(SM_CXSCREEN);
   yScreen = GetSystemMetrics(SM_CYSCREEN);

// GetWindowRect(hwnd, &rcWindPos); // Save our old position
   MoveWindow(hwnd, 0, 0, xScreen+1,yScreen, TRUE);  //   12-13-96
	ShowWindow(hwnd, SW_MAXIMIZE);   // Make sure window knows its maximized

   if (whichTime == 1)              //   12-13-96 real maximize
   {  MaxConstrain = TRUE;
      ConstrainCursor(TRUE);		   // Hold cursor to window rect
   }
}

//
////////////////////////////////////////////////////////////////////////////
//		NormalizeWindow - brings the window back to its ordinary ( normal )
//		state; which allows the caption bar to be grabbed and the window
//		sized and moved around at will
////////////////////////////////////////////////////////////////////////////
//
void NormalizeWindow(HWND hwnd)
{
   ShowWindow(hwnd, SW_MAXIMIZE);
   /*
   int yScreen;
   int xScreen;

   xScreen = GetSystemMetrics(SM_CXSCREEN);
   yScreen = GetSystemMetrics(SM_CYSCREEN);

  // check our stored values and adjust if different or unrealistic
  // could have changed his resolution from 1024 to 640 after our last save

  if(rcWindPos.right > xScreen && rcWindPos.left < 0) // must be maximized ?
  {
     MoveWindow(hwnd, rcWindPos.left, rcWindPos.top, rcWindPos.right, rcWindPos.bottom, TRUE);
     ShowWindow(hwnd, SW_MAXIMIZE);
  }
  else
  {
     if((rcWindPos.left < -4)
     || (rcWindPos.left > xScreen))     rcWindPos.left  = 20;

     if((rcWindPos.top  < -4)
     || (rcWindPos.top > yScreen) )     rcWindPos.top   = 20;

     if (rcWindPos.right > xScreen+4)   rcWindPos.right = xScreen - 20;
     if (rcWindPos.bottom > yScreen+4)  rcWindPos.bottom= yScreen - 20;

     MoveWindow(hwnd, rcWindPos.left,                   rcWindPos.top,
                      rcWindPos.right - rcWindPos.left, rcWindPos.bottom - rcWindPos.top,TRUE);
   }
   */
   MaxConstrain = FALSE;
   ConstrainCursor(FALSE);			// Hold cursor to window rect - NO
}

//----------------------------------------------------------------------------
//  create the mask from the pieces
//----------------------------------------------------------------------------

void SetGameMask(void)
{
   if (GameVersion == 4)
   {
       Mask1 = int2( ThingMask1 | (ThingMask2 << 1) | (ThingMask3 << 2) | (ThingDeath << 10) );
       Mask2 = int2( (ThingMaskDeaf << 3) | (ThingMaskDormant<< 4) );
       Mask3 = int2( (ThingFighter  << 5) | (ThingCleric    << 6) | (ThingMage << 7 ) );
       Mask4 = int2( (ThingCoop     << 9) | (ThingSingle    << 8) );
   }
   else
   {
       Mask1 = int2(ThingMask1 | (ThingMask2 << 1) | (ThingMask3 << 2) | (ThingDeath << 4) );
       Mask2 = int2(ThingMaskDeaf << 3);  // deaf
   }
}
/*
HEXEN  Mask1 = ThingMask1             // skill 12    //       111 1111 1111
             | ThingMask2      << 1   //       3
             | ThingMask3      << 2   //       45
             | ThingDeath      << 10; // death     (skill does not matter)

       Mask2 = ThingMaskDeaf   << 3   // deaf
             | ThingMaskDormant<< 4;  // dormant

       Mask3 = ThingFighter    << 5   // fighter
             | ThingCleric     << 6   // cleric
             | ThingMage       << 7;  // Mage

       Mask4 = ThingCoop       << 9   // coop      (skill matters)
             | ThingSingle     << 8;  // single    (skill matters)

DOOM   Mask1 = ThingMask1             // skill 12    //       111 1111 1111
             | ThingMask2      << 1   //       3
             | ThingMask3      << 2   //       45
             | ThingDeath      << 4;  // network    skill does not matter
*/

void CenterMapAroundCoords( int4 xpos, int4 ypos)  //   3-1-97
{
	ScrMaxX    = gd.rcClient.right+1;  //   3-1-97
   ScrMaxY    = gd.rcClient.bottom+1;
   ScrCenterX = ScrMaxX / 2;
   ScrCenterY = ScrMaxY / 2;

   OrigX    = xpos;
   OrigY    = ypos;
   PointerX = SCREENX(xpos);
   PointerY = SCREENY(ypos);

   // Must not forget Windows has to add caption height to Y !
   SetCursorPos(PointerX, PointerY + gd.CaptionHeight);

}



//-----------------------------------------------------------------------//
//   make the map fit the screen exactly
//-----------------------------------------------------------------------//
void ExactMapFit(void)
{
  LevelPtr level = &LevelWad.level;
  double Scale2;

  CalculateMinMax(level);

  Scale  = 1.0;
  Scale2 = 1.0;

  if (level->NumVertexes > 0)
  {
     if (level->maxX != level->minX)
     {  Scale  =(double)(ScrMaxX-10) / (double)( level->maxX - level->minX) ;//
     }

     if (level->maxY != level->minY)
     {  Scale2 =(double)(ScrMaxY-50) / (double)( level->maxY - level->minY) ;//
     }

     if (Scale2 < Scale) Scale = Scale2;
     if (Scale < 0.01 ) Scale = 0.01;
     if (Scale > 16.0 ) Scale = 16.0;
  }
  else
  {  Scale = 0.5;
  }

  CenterMapAroundCoords( ((int4)level->maxX + (int4)level->minX)/ 2, ((int4)level->maxY + (int4)level->minY)/2 - (16/Scale)); //   3-1-97

  SetVertexSize(Scale);
}



//
// Updates the MODELESS dialog box that has a progress bar in it
//

//-----------------------------------------------------------------------//
//   calculate min/max X and Y for make the map fit the screen exactly
//-----------------------------------------------------------------------//
void CalculateMinMax(LevelPtr level)
{
  int2 NewMinX= 32767;
  int2 NewMaxX=-32767;
  int2 NewMinY= 32767;
  int2 NewMaxY=-32767;
  VPtr TempVertex;
  int2 n;

  if (level->NumVertexes > 0)
  {   TempVertex = level->Vertexes;

      for (n = 0; n < level->NumVertexes; n++, TempVertex +=1)
      {    if ( TempVertex->x  < NewMinX) NewMinX = TempVertex->x;
      	  if ( TempVertex->x  > NewMaxX) NewMaxX = TempVertex->x;
	        if ( TempVertex->y  < NewMinY) NewMinY = TempVertex->y;
	        if ( TempVertex->y  > NewMaxY) NewMaxY = TempVertex->y;
      }
  }
  else
  {
      NewMaxX =  100; //ScrMaxX/2;
      NewMinX = -100; //ScrMaxX/2;
      NewMaxY =  116; //ScrMaxY/2;
      NewMinY = -116; //ScrMaxY/2;
  }

  level->maxX = NewMaxX;
  level->minX = NewMinX;
  level->maxY = NewMaxY;
  level->minY = NewMinY;

}



//////////////////   TRANSLATED  DOS  SCREEN DRAW  ROUTINES   //////////////////
//                                                                            //
//                                                                            //
/*    7-1-97 not used anywhere
void ScreenBkText(HDC hdc, int4 Xstart, int4 Ystart, int2 TColor, int2 BkColor, char *msg)
{
   HBRUSH hOldBrush;
   HPEN	 hOldPen;
   HFONT  hOldFont;

   SetBkMode(hdc, TRANSPARENT);
	hOldPen 	=	SelectPen(hdc, gd.hPens[BkColor]);
	hOldBrush=  SelectBrush(hdc, gd.hBrushes[BkColor]);
	hOldFont =  SelectFont(hdc, GetStockFont(ANSI_VAR_FONT));

   Rectangle(hdc, Xstart,Ystart, Xstart+(strlen(msg)+1)*wt, Ystart+ht+2);

   SetTextColor(hdc, PALETTEINDEX(GameColors[TColor] ));
                     //==1
   TextOut(hdc, Xstart + wt / 2, Ystart + 1, msg, lstrlen(msg) );

   SelectPen  (hdc, hOldPen);
   SelectBrush(hdc, hOldBrush);
   SelectFont (hdc, hOldFont);
}  */
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------

void ScreenColorText(HDC hdc, int4 Xstart, int4 Ystart, int2 TColor, char *msg)
{
   HFONT  hOldFont;
   RECT   rc;
   SIZE   s;
   int    length;

	length	=  strlen(msg);
	GetTextExtentPoint32(hdc, msg, length, &s);	// find the extents of our text

   SetRect(&rc, Xstart, Ystart, Xstart + s.cx, Ystart + s.cy);
   SetBkMode(hdc, TRANSPARENT);
	hOldFont =  SelectFont(hdc, gd.hStockFont);//GetStockFont(ANSI_VAR_FONT));

   SetTextColor(hdc, PALETTEINDEX(GameColors[TColor] ));
   //TextOut(hdc, Xstart + wt / 2, Ystart + 1, msg, lstrlen(msg) );
	DrawText(hdc, msg, length, &rc, DT_LEFT | DT_NOCLIP | DT_EXPANDTABS	);

   SelectFont (hdc, hOldFont);
}
//------------------------------------------------------------------------//
//   write text to the screen
//  if xstart or ystart < 0 last value is used (y is auto incremented)
//------------------------------------------------------------------------//

void DrawScreenText(HDC hdc, int2 Xstart, int2 Ystart, char *msg, ...)
{
   static int2 lastX;
   static int2 lastY;

	char  buf[256];
   char *pArgs;			                    // Pointer to arguments

   pArgs = (char *) &msg + sizeof (msg);    // find it

	vsprintf(buf, msg, pArgs);		           // format it

   // continue from last location(s) set if < 0

   if (Xstart < 0) Xstart = lastX;	        // copy last loc
   if (Ystart < 0) Ystart = lastY;          // copy next loc

  	SetBkMode(hdc, TRANSPARENT);             // dont want background

	TextOut(hdc, Xstart, Ystart, buf, lstrlen(buf) );

   lastX = Xstart;
   lastY = int2(Ystart + ht2);
}

//------------------------------------------------------------------------//
//   write text to the screen fixed characters assumed
//   if xstart or ystart < 0 last value is used (y is auto incremented)
//   3-1-97   new for more flexibility
//   Rectangle outline is set by wt value
//   Text put out is limited by size available
//------------------------------------------------------------------------//

void DrawScreenTextOutline(HDC hdc, int2 Xstart, int2 Ystart,int2 Length,
                                    int2 OutlineColor, char *msg, ...)
{
   static int2 lastX;
   static int2 lastY;

   int    TxtOutLength;
//   int    Yoffset;
   int    Xwidth;
   SIZE   TxtSize;
   HBRUSH hOldBrush;
   HPEN	 hOldPen;
   char   buf[256];                             //   3-1-97 increase
   char  *pArgs;											// Pointer to arguments


   pArgs = (char *) &msg + sizeof (msg);    		// find it

	vsprintf(buf, msg, pArgs);						  	// format it

   // continue from last location(s) set if < 0
   if (Xstart < 0) Xstart = lastX;					// copy last loc
   if (Ystart < 0) Ystart = lastY;              // copy next loc

   SetBkMode(hdc, TRANSPARENT);  			      // dont want background
	hOldPen 	=	SelectPen(hdc, gd.hPens[BLACK]);
	hOldBrush=  SelectBrush(hdc, gd.hBrushes[OutlineColor]);

   GetTextExtentPoint32(hdc,buf,strlen(buf),&TxtSize);  // actual space taken up

   TxtOutLength = lstrlen(buf);
   Xwidth       = TxtOutLength+1;
   if (Length > 0)
   {   Xwidth = Length;    // in chars
   }
   Xwidth *=wt;            // times user defined width size

   // fixed size rectangle 16 high
   Rectangle(hdc, Xstart,Ystart, Xstart+Xwidth, Ystart+TxtSize.cy+3);  //4
   //Rectangle(hdc, Xstart,Ystart, Xstart+(strlen(buf)+1)*wt, Ystart+TxtSize.cy+3);  //4
   //Rectangle(hdc, Xstart,Ystart, Xstart+(strlen(buf)+1)*wt, Ystart+16);

   if (OutlineColor == MenuInfoColor)
   {   SetTextColor(hdc, PALETTEINDEX(GameColors[MenuInfoColorText] ));
   }
   else
   {   SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK]));
   }
                     //==1
//   if (CurrentTextType !=2)    				// smaller size needs 1 more added
//   {   Ystart+=(int2)1;
//   }
   /*
   for (TxtOutLength=lstrlen(buf); TxtOutLength > 1; TxtOutLength--)
   {
        if (buf[TxtOutLength-1] != ' ') break;
   } */


   for (;;)
   {
        if( TxtSize.cx   <= (Xwidth-wt/2)  ) break;  // within rectangle with 1/2 char adjust
        if (TxtOutLength <= 1) break;

        TxtOutLength--;
        buf[TxtOutLength] = '\0';
        GetTextExtentPoint32(hdc,buf,strlen(buf),&TxtSize);  // new space taken up

        //Trace(NULL,10,4,"cx=%d wt=%hd reduced %d to %d",TxtSize.cx,wt,lstrlen(buf),TxtOutLength);
   }

   // Yoffset = (16- TxtSize.cy)/2;
                                 //Ystart+1 Yoffset
   TextOut(hdc, Xstart + wt / 2, Ystart + 1, buf, TxtOutLength );

   lastX = Xstart;
   lastY = int2(Ystart + TxtSize.cy+6);  //4+2space
   //lastY = int2(Ystart + ht2);

   SelectPen(hdc, hOldPen);
   SelectBrush(hdc, hOldBrush);
}

//------------------------------------------------------------------------//
//   write text to the screen, adjusts to actual character width
//  if xstart or ystart < 0 last value is used (y is auto incremented)
//  Box Outline varies
//------------------------------------------------------------------------//

void DrawScreenTextOutlineScale(HDC hdc, int2 Xstart, int2 Ystart,int2 OutlineColor, char *msg, ...)
{
   static int2 lastX;
   static int2 lastY;
   SIZE   TxtSize;
   HBRUSH hOldBrush;
   HPEN	 hOldPen;
   char   buf[256];                             //   3-1-97 increase
   char  *pArgs;											// Pointer to arguments


   pArgs = (char *) &msg + sizeof (msg);    		// find it

	vsprintf(buf, msg, pArgs);						  	// format it

   // continue from last location(s) set if < 0
   if (Xstart < 0) Xstart = lastX;					// copy last loc
   if (Ystart < 0) Ystart = lastY;              // copy next loc

   SetBkMode(hdc, TRANSPARENT);  				//	 dont want background
	hOldPen 	=	SelectPen(hdc, gd.hPens[BLACK]);
	hOldBrush=  SelectBrush(hdc, gd.hBrushes[OutlineColor]);

   GetTextExtentPoint32(hdc,buf,strlen(buf),&TxtSize);

   // Height always 16 for now
   Rectangle(hdc, Xstart,Ystart, Xstart+TxtSize.cx+8, Ystart+TxtSize.cy+4);//16);

   if (OutlineColor == MenuInfoColor)
   { SetTextColor(hdc, PALETTEINDEX(GameColors[MenuInfoColorText] ));
   }
   else
   {   SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK]));
   }
                     //==1
   if (CurrentTextType !=2)    				// smaller size needs 1 more added
   {   Ystart+= 1;
   }

   TextOut(hdc, Xstart + wt / 2, Ystart + 1, buf, lstrlen(buf) );

   lastX = Xstart;
   lastY = Ystart+TxtSize.cy+4; //int2(Ystart + ht2); //+1?

   SelectPen(hdc, hOldPen);
   SelectBrush(hdc, hOldBrush);
}

//------------------------------------------------------------------------//
//   write text to the screen
//  if xstart or ystart < 0 last value is used (y is auto incremented)
//------------------------------------------------------------------------//
void DrawScreenTextOutline3D(HDC hdc, int2 Xstart,int2 Ystart,int2 OutlineColor,char *msg, ...)
{
   static int2 lastX;
   static int2 lastY;

   char   buf[256];                             //   3-1-97 increase
   char   *pArgs;											// Pointer to arguments


   pArgs = (char *) &msg + sizeof (msg);    		// find it

	vsprintf(buf, msg, pArgs);						  	// format it


   // continue from last location(s) set if < 0
   if (Xstart < 0) Xstart = lastX;		// copy last loc
   if (Ystart < 0) Ystart = lastY;              // copy next loc

   DrawScreenBox3D(hdc, Xstart-1, Ystart-1, Xstart+(strlen(buf)+1)*wt,
   							Ystart+18,gd.hBrushes[OutlineColor]);

   SetBkMode(hdc, TRANSPARENT);
   SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK]));

                     //==1
   if (CurrentTextType !=2)    				// smaller size needs 1 more added
   {   Ystart+=1;
   }
                               //+1
   TextOut(hdc, Xstart+ wt/2, Ystart, buf, lstrlen(buf) );

   lastX = Xstart;
   lastY = Ystart + ht2;//+1;
}

////////////////////////////////////////////////////////////////////////////
// replicate line function in DOS   11-5-96
////////////////////////////////////////////////////////////////////////////
void DrawLine(HDC hdc, int xstart, int ystart, int xend, int yend)
{
	MoveToEx(hdc, xstart, ystart, NULL);
   LineTo  (hdc, xend,   yend );
}

//------------------------------------------------------------------------//
//   draw a Rectangle on the screen as per DOS - outline Rect)
//     SCREENX convert map coordinates to screen coordinates */
//------------------------------------------------------------------------//
void DrawRectangle(HDC hdc, int4 xs, int4 ys, int4 xe, int4 ye)
{
	MoveToEx (hdc, xs, ys, NULL);
   LineTo	(hdc, xe, ys);
   LineTo	(hdc, xe, ye);
   LineTo	(hdc, xs, ye);
   LineTo	(hdc, xs, ys);
   // static RECT rc;
   // USE FrameRect instead ! or Even Rectangle with a NULL brush
   //rc.left 	= xs;
   //rc.top		= ys;
   //rc.right 	= xe;
   //rc.bottom	= ye;
   //FrameRect(hdc, &rc, gd.hBrushes[RulerColor]);
}


//----------------------------------------------------------------------------
//  draw a hollow line redid   3-1-97
//----------------------------------------------------------------------------
/*
#pragma argsused
void DrawScreenLineHollow(HDC PaintDC, int Left, int Top, int Right, int Bottom, HBRUSH hBrush  )
{
  RECT rc;
  rc.left   = Left;
  rc.right  = Right;
  rc.top    = Top;
  rc.bottom = Bottom;

  //PAINTSTRUCT ps;            NT won't reerase the background for coordinates
  //BeginPaint(gd.hMainWindow, &ps);   // prep for painting

  DrawEdge(PaintDC, &rc, EDGE_ETCHED, BF_RECT | BF_SOFT);  // this is new for NT, but not the prob

  // fill in center if a color brush
  if (hBrush)
  {
      SetRect(&rc, Left+1, Top+1, Right-1, Bottom-1 );
      FillRect(PaintDC, &rc, hBrush);

  }

  //EndPaint(gd.hMainWindow, &ps);
} */

#pragma argsused
void DrawScreenLineHollow(HDC hdc, int Left, int Top, int Right, int Bottom, HBRUSH hBrush  )
{
HPEN hOldPen; //, hDashPen;     // moved to gd   12-13-96
RECT rc;
int  Color;
//  rc.left   = Left;
//  rc.right  = Right;
//  rc.top    = Top;
//  rc.bottom = Bottom;
   // see if horizontal line

   hOldPen = SelectPen(hdc, gd.hPens[WHITE]);
   if (MenuColor == LIGHTGRAY)
   {   Color = DARKGRAY;
   }
   else
   {   Color = DARKERGRAY;
   }

   if (Top == Bottom )
   {
       SelectPen(hdc, gd.hPens[Color]);
       DrawLine(hdc, Left, Top,   Right, Top);      // top  outside

       SelectPen(hdc, gd.hPens[LIGHTERGRAY]);
       DrawLine(hdc, Left, Top+1, Right, Top+1);    // top  inside
   }
   else
   // see if vertical line
   if (Left == Right )
   {
       SelectPen(hdc, gd.hPens[Color]);

       DrawLine(hdc, Left, Top,   Right, Bottom);      // Left outside

       SelectPen(hdc, gd.hPens[LIGHTERGRAY]);
       DrawLine(hdc, Left+1, Top, Left+1,Bottom);   // Left inside
   }
   else
   {  // normal square

      SelectPen(hdc, gd.hPens[LIGHTERGRAY]);
      DrawLine(hdc, Left+1, Top+1, Right-1,  Top+1);        // top  inside
      DrawLine(hdc, Left+1, Top+1, Left+1,Bottom-1  );      // left inside
      DrawLine(hdc, Left, Bottom, Right, Bottom);		      // bottom outside
      DrawLine(hdc, Right, Top, Right, Bottom);             // right  outside

      SelectPen(hdc, gd.hPens[Color]);

      DrawLine(hdc, Left, Top, Right,   Top);	            // top   outside
      DrawLine(hdc, Left, Top, Left, Bottom);               // right outside
      DrawLine(hdc, Left+1, Bottom-1  , Right-1, Bottom-1); // bottom inside
      DrawLine(hdc, Right  -1, Top+1, Right-1, Bottom-1);   // right  inside

      if (hBrush)
      {
         SetRect(&rc, Left+1, Top+1, Right-1, Bottom-1 );
         FillRect(hdc, &rc, hBrush);

      }
   }

  	SelectPen(hdc, hOldPen);			// Restore Old Pen to DC
}

//----------------------------------------------------------------------------
// Called to Draw the Main Info Window 3D Look   11-5-96 control thickness
//----------------------------------------------------------------------------
#pragma argsused
void DrawScreenBox3D(HDC hdc, int Left, int Top, int Right, int Bottom, HBRUSH hBrush )
{
   RECT  rc;
   HPEN	hOldPen;
// int2  SurroundColor;

	SetRect(&rc, Left, Top, Right, Bottom );
	FillRect(hdc, &rc, hBrush);

   //DrawEdge(PaintDC, &rc, EDGE_RAISED, BF_RECT | BF_SOFT );

   hOldPen = SelectPen(hdc, gd.hPens[InfoBoxColorEdgeT]);//LIGHTERGRAY] );  //white surround  11-7-97

   DrawLine( hdc,Left,Top,Right,Top);        //  top line
   DrawLine( hdc,Left,Top,Left, Bottom);     //  left side

   //if (FillColor == DARKGRAY)        // original passed color of fill
   //{   SurroundColor = DARKERGRAY;   // hBrush need to do same later
   //}
   //else
   //{   SurroundColor = DARKGRAY;
   //}

   SelectPen(hdc, gd.hPens[InfoBoxColorEdgeB]);//SurroundColor]); //DARKGRAY   11-7-96

   DrawLine(hdc,Left, Bottom,Right,Bottom);  // Xstart, Yend, Xend, Yend);	// bottom line
   DrawLine(hdc,Right,Top,   Right,Bottom);  // Xend,  Ystart,Xend, Yend);     // right side

   SelectPen  (hdc, hOldPen);
}

//==============================================================================
//  pass color as value not brush, so can compare (a quickie for doom3d for now)
//==============================================================================
void DrawScreenBox3DRaw(HDC hdc, int Left, int Top, int Right, int Bottom, int FillColor )
{
   RECT  rc;
   HPEN	hOldPen;
   int2  SurroundColor;

	SetRect(&rc, Left, Top, Right, Bottom );
	FillRect(hdc, &rc, gd.hBrushes[FillColor]);

   //DrawEdge(hdc, &rc, EDGE_RAISED, BF_RECT | BF_SOFT );

   hOldPen = SelectPen(hdc, gd.hPens[WHITE]);//LIGHTERGRAY]);     // white surround  11-7-97

   DrawLine( hdc,Left,Top,Right,Top);        //  top line
   DrawLine( hdc,Left,Top,Left, Bottom);     //  left side

   if (FillColor == DARKGRAY)                // original passed color of fill
   {   SurroundColor = DARKERGRAY;           //
   }
   else
   {   SurroundColor = DARKGRAY;
   }

   SelectPen(hdc, gd.hPens[SurroundColor]);  // DARKGRAY   11-7-96

   DrawLine(hdc,Left, Bottom,Right,Bottom);  // bottom line
   DrawLine(hdc,Right,Top,   Right,Bottom);  // right side

   SelectPen  (hdc, hOldPen);

}

//----------------------------------------------------------------------------
// just a filled in area   11-11-96
//----------------------------------------------------------------------------
#pragma argsused
void DrawScreenBox(HDC hdc, int Left, int Top, int Right, int Bottom, HBRUSH hBrush )
{
   RECT  rc;
//   HPEN	hOldPen;

	SetRect(&rc, Left, Top, Right, Bottom );
	FillRect(hdc, &rc, hBrush);
   /*
   hOldPen = SelectPen(hdc, gd.hPens[InfoBoxColorEdgeT]);//LIGHTERGRAY] );  //white surround  11-7-97

   DrawLine( hdc,Left,Top,Right,Top);        //   Xstart, Ystart, Xend, Ystart);	// top line
   DrawLine( hdc,Left,Top,Left, Bottom);     //  Xstart, Ystart, Xstart, Yend); // left side

   SelectPen(hdc, gd.hPens[InfoBoxColorEdgeB]);//SurroundColor]); //DARKGRAY   11-7-96

   DrawLine(hdc,Left, Bottom,Right,Bottom);  // Xstart, Yend, Xend, Yend);	// bottom line
   DrawLine(hdc,Right,Top,   Right,Bottom);  // Xend,  Ystart,Xend, Yend);     // right side

   SelectPen  (hdc, hOldPen);*/
}

/*  not used 11-7-96
//----------------------------------------------------------------------------
//	Called to simulate 3d buttons for Line Flags & Thing Flags
//  3DFrame is the out button, unselected, and 3DFrame in is
//	The select, 'PUSHED' button
//----------------------------------------------------------------------------
void Draw3DFrame(HDC PaintDC, RECT *rc)
{
	FillRect(PaintDC, rc, (HBRUSH)GetStockObject(GRAY_BRUSH));
   DrawEdge(PaintDC, rc, EDGE_RAISED, BF_RECT | BF_SOFT);
}

//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
void Draw3DFrameIn(HDC PaintDC, RECT *rc)
{
   FillRect(PaintDC, rc, gd.hBrushes[GREEN]);
   DrawEdge(PaintDC, rc, EDGE_SUNKEN, BF_RECT | BF_SOFT);
}

*/

//------------------------------------------------------------------------//
//   draw an arrow on the screen from map coords and angle (0 - 65535)
//   (for Things only)
//------------------------------------------------------------------------//

void DrawMapArrow(HDC hdc, int4 mapXstart, int4 mapYstart, uint2 angle)
{
                                       //was 50* bigger makesline longer
   double Dangle    = (angle*182.0) / 10430.37835;
   int4   mapXend   = mapXstart + (int4) (45 * cos(Dangle));// / 10430.37835));
   int4   mapYend   = mapYstart + (int4) (45 * sin(Dangle));// / 10430.37835));

   int4   scrXstart = SCREENX (mapXstart);    // convert map to screen coordinates
   int4   scrYstart = SCREENY (mapYstart);    //
   int4   scrXend   = SCREENX (mapXend);      //
   int4   scrYend   = SCREENY (mapYend);      //

   double Xdist = scrXstart - scrXend;
   double Ydist = scrYstart - scrYend;
   double Z;

   int4 scrXoff;
   int4 scrYoff;

//---------------------------------------------------------------------------
   //Z  = hypot( Xdist, Ydist );                       // length of hypotenuse
   Z = sqrt( (Xdist*Xdist) + (Ydist*Ydist) );
   if ( Z <=1.0 ) Z = 1.0;   // <= .5

   // main line
	MoveToEx(hdc, scrXstart, scrYstart, NULL);
   LineTo(hdc, scrXend, scrYend );

   scrXoff =  ( Xdist * 12.0*Scale)/ Z  ;
   scrYoff =  ( Ydist * 12.0*Scale)/ Z ;
   scrXstart = scrXend +  scrXoff;
   scrYstart = scrYend +  scrYoff;

	MoveToEx(hdc, scrXstart-scrYoff, scrYstart+scrXoff, NULL);
   LineTo(hdc, scrXend, scrYend );

	MoveToEx(hdc, scrXstart+scrYoff, scrYstart-scrXoff, NULL);
   LineTo(hdc, scrXend, scrYend );
}

//------------------------------------------------------------------------//
//   draw a line with arrow - from map coords
//   used for Vertices and Hilights
//------------------------------------------------------------------------//

void DrawMapVector(HDC hdc, int4 mapXstart, int4 mapYstart, int4 mapXend, int4 mapYend,
					Bool DrawArrow, Bool ConvertCoord)
{
//static int2 oldHide;// = Hide;

static int4 scrXstart;// SCREENX( mapXstart);  // convert map to screen coordinates
static int4 scrYstart;// SCREENY( mapYstart);  //
static int4 scrXend  ;// SCREENX( mapXend  );  //
static int4 scrYend  ;// SCREENY( mapYend  );  //

static double Xdist;  // = (double)scrXstart - (double)scrXend;
static double Ydist;  // = (double)scrYstart - (double)scrYend;
static double Z;

static int4   scrXoff;
static int4   scrYoff;
static int4   midx,midy;
static int4   midXdist,midYdist;

static double AdjScale = 1.0;
static double Factor   = 14.0;
   //----------------------------------------------------------------------

//   oldHide   = Hide;
   AdjScale  = 1.0;
   Factor    = 14.0;

   if (ConvertCoord)
   {
       scrXstart = SCREENX( mapXstart);  // convert map to screen coordinates
       scrYstart = SCREENY( mapYstart);  //
       scrXend   = SCREENX( mapXend  );  //
       scrYend   = SCREENY( mapYend  );  //
   }
   else
   {
       scrXstart = mapXstart;  // no convert
       scrYstart = mapYstart;  //
       scrXend   = mapXend  ;  //
       scrYend   = mapYend  ;  //
   }

   Xdist     = (double)scrXstart - (double)scrXend;
   Ydist     = (double)scrYstart - (double)scrYend;

// if (!Hide) ShowCursor(FALSE);

   if (Scale < 1.0)
   {   AdjScale = Scale;
   }
   if (EditMode == OBJ_LINEDEFS)
   {   Factor = 18.0;
   }

   Z  = sqrt( (Xdist*Xdist) + (Ydist*Ydist) );       // length of hypotenuse faster
   if ( Z <=0.5 ) Z = .5;

   // middle of line in screen coordinates
   midx    = (scrXstart + scrXend) / 2;       // midway  X coord
   midy    = (scrYstart + scrYend) / 2;       // midway  Y coord
   midXdist= midx+( (double)(scrYstart- scrYend  )*Factor*AdjScale) /Z  ; // midway offset X
   midYdist= midy+( (double)(scrXend  - scrXstart)*Factor*AdjScale) /Z  ; // midway offset Y

   // draw direction line stub sticking out ------
	MoveToEx(hdc, midx, midy, NULL);
   LineTo(hdc, midXdist, midYdist);

   // the main line
   MoveToEx(hdc, scrXstart, scrYstart, NULL);
   LineTo(hdc, scrXend, scrYend);

   if (DrawArrow)
   {
      // calculate arrow
      Factor = 4.0;
      if (EditMode == OBJ_LINEDEFS)
      {   Factor = 6.0;
      }
      scrXoff =  ( Xdist  *  Factor * AdjScale) / Z  ;
      scrYoff =  ( Ydist  *  Factor * AdjScale) / Z ;

      scrXstart = scrXend +  scrXoff*2;
      scrYstart = scrYend +  scrYoff*2;

      // the arrow  (scaled adjusted)

		 	MoveToEx(hdc, scrXstart-scrYoff, scrYstart+scrXoff, NULL);
       	LineTo(hdc, scrXend, scrYend);

		 	MoveToEx(hdc, scrXstart+scrYoff, scrYstart-scrXoff, NULL);
       	LineTo(hdc, scrXend, scrYend);
   }

//   if (!oldHide) ShowCursor(TRUE);
}


//------------------------------------------------------------------------//
//   draw a cross on the screen from map coords
//   SCREENX convert map coordinates to screen coordinates
//------------------------------------------------------------------------//
                  //  ---center coordinartes   side
void DrawMapCross( HDC hdc, int4 mapX, int4 mapY, int2 size)
{
   MoveToEx	(hdc, SCREENX(mapX-size), SCREENY(mapY) , NULL);
   LineTo	(hdc, SCREENX(mapX+size), SCREENY(mapY));

   MoveToEx	(hdc, SCREENX(mapX ), SCREENY(mapY-size), NULL);
	LineTo	(hdc, SCREENX(mapX ), SCREENY(mapY+size));

}

//------------------------------------------------------------------------//
//   draw a rectangle line on the screen from map coords (between 2 points)
//     SCREENX convert map coordinates to screen coordinates
//------------------------------------------------------------------------//
                       //  left           top            right      bottom
void DrawMapRectangle(HDC hdc, int4 mapXstart, int4 mapYstart, int4 mapXend, int4 mapYend)
{

     Rectangle(hdc, SCREENX(mapXstart), SCREENY(mapYstart),
                    SCREENX(mapXend  ), SCREENY(mapYend));
}

//------------------------------------------------------------------------//
//   draw a line on the screen from map coords (between 2 points)
//     SCREENX convert map coordinates to screen coordinates */
//------------------------------------------------------------------------//

void DrawMapLine(HDC hdc, int4 mapXstart, int4 mapYstart, int4 mapXend, int4 mapYend)
{
   MoveToEx(hdc,  SCREENX(mapXstart), SCREENY(mapYstart), NULL);
   LineTo  (hdc,  SCREENX(mapXend  ), SCREENY(mapYend));
}

//------------------------------------------------------------------------//
//   draw a Rectangle on the screen as per DOS - outline Rect)
//     SCREENX convert map coordinates to screen coordinates */
//------------------------------------------------------------------------//
void DrawMapOutlineRect(HDC hdc, int2 xs, int2 ys, int2 xe, int2 ye)
{
	MoveToEx (hdc, SCREENX(xs), SCREENY(ys), NULL);
   LineTo	(hdc, SCREENX(xe), SCREENY(ys));
   LineTo	(hdc, SCREENX(xe), SCREENY(ye));
   LineTo	(hdc, SCREENX(xs), SCREENY(ye));
   LineTo	(hdc, SCREENX(xs), SCREENY(ys));

   // USE FrameRect instead ! or Even Rectangle with a NULL brush !
}


/////////////////////////////////////////////////////////////////////////////
//	  11-5-96 redid like DOS version for thinner lines                    //
//	Routines called from above and from Deep LButtonDown	                  //
//	To set the text and the box around it to reflect the	                  //
//	The status of the LineDef Flags							                     //
//															                              //
/////////////////////////////////////////////////////////////////////////////
void DrawFlagButton(HDC hdc, Bool In, int StringID, RECT *rcButton)
{
  RECT    rc;
  HBRUSH  hOldBrush;
  HPEN	 hOldPen;

  int4 Xstart, Ystart, Xend, Yend;

  int4 Xstartp1;
  int4 Ystartp1;
  int4 Xendm1  ;
  int4 Yendm1  ;

  //=======================================================================

  CopyRect(&rc, *&rcButton);  // copy our RECT struct to temp - NEEDED !

  Xstart = rc.left;
  Ystart = rc.top;
  Xend   = rc.right;
  Yend   = rc.bottom;

  Xstartp1 = Xstart+1;
  Ystartp1 = Ystart+1;
  Xendm1   = Xend-1;
  Yendm1   = Yend-1;

  SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK]));
  SetBkMode(hdc, TRANSPARENT);

  DrawLine(hdc, Xendm1,   Ystartp1, Xendm1, Yendm1);    // right side
  DrawLine(hdc, Xstartp1, Yendm1,   Xendm1, Yendm1 );   // bottom line

  //---------------------------------------------------------------------
  // fill the inside of the box
  // show the button

  if (!In)	// Button Out (up)
  {
      hOldBrush=  SelectBrush(hdc, gd.hBrushes[InfoBoxColor]);
      hOldPen   = SelectPen(hdc,   gd.hPens[InfoBoxColorEdgeB]);
      Rectangle(hdc, Xstart,  Ystart,   Xend,   Yend);          // outside square
      // more light
      SelectPen(hdc, gd.hPens[InfoBoxColorEdgeT] );             //white surround   11-7-96
      DrawLine(hdc, Xstart,Ystart, Xend,   Ystart);             // top line
      DrawLine(hdc, Xstart,Ystart, Xstart, Yend  );             // left side
//      rc.left += 4;
  }
  else	// Button In (down)
  {
      hOldPen  =  SelectPen(hdc, gd.hPens[DARKGRAY] );
      hOldBrush=  SelectBrush(hdc, gd.hBrushes[LIGHTGREEN]);
      Rectangle(hdc, Xstart,  Ystart,   Xend,   Yend);       // outside square
      //
      DrawLine(hdc, Xstart,Ystart, Xend,   Ystart);          // top line
      DrawLine(hdc, Xstart,Ystart, Xstart, Yend  );          // left side
      //
      //SelectPen(hdc, gd.hPens[LIGHTERGRAY] );
      SelectPen(hdc, gd.hPens[InfoBoxColorEdgeT] );          //white surround   11-7-96
      DrawLine(hdc, Xstart, Yendm1,  Xend, Yendm1);         	// bottom line
      DrawLine(hdc, Xendm1, Ystart,Xendm1, Yend);            // right side
//	   rc.left += 2;
  }
  //DrawText(hdc, szLoadString(StringID), -1, &rc, DT_LEFT | DT_NOCLIP);
  //   8-1-97 center (oops missed DT_CENTER option, so nxt not needed
  char *textAddr = (char*) szLoadString(StringID);
//  SIZE  TxtSize;
//
//  GetTextExtentPoint32(hdc,textAddr,strlen(textAddr),&TxtSize);
//
//  int4  outputloc = rc.left + ( rc.right-rc.left+1  -TxtSize.cx)/2;
//  rc.left = outputloc;

  DrawText(hdc, textAddr, -1, &rc, DT_NOCLIP |DT_VCENTER|DT_CENTER);

  SetBkMode(hdc, OPAQUE);
  SelectPen  (hdc, hOldPen);
  SelectBrush(hdc, hOldBrush);

}

/*
 	if(!In)
   {  //FillRect(hdc, &rc, (HBRUSH)GetStockObject(GRAY_BRUSH));
      //DrawEdge(hdc, &rc, EDGE_RAISED, BF_RECT | BF_SOFT);
      DrawScreenBox3D(hdc, rc.left,rc.top, rc.right,rc.bottom,
                          (HBRUSH)GetStockObject(GRAY_BRUSH));
	   rc.left += 4;
   }
   else
   {
      FillRect(hdc, &rc, gd.hBrushes[LIGHTGREEN]);
      DrawEdge(hdc, &rc, EDGE_SUNKEN, BF_RECT | BF_SOFT);
	   rc.left += 2;
   }
   DrawText(hdc, szLoadString(StringID), -1, &rc, DT_LEFT | DT_NOCLIP);
} */

//////////////////////////////////////////////////////////////////////////////
//		Draw a Big Button with Text sort of centered
//////////////////////////////////////////////////////////////////////////////

void DrawButton(HDC hdc, Bool In, int StringID, RECT *rcButton)
{
   RECT rc;
   HBRUSH hOldBrush;
   HPEN	 hOldPen;
   //HFONT  hOldFont;

   int4 Xstart, Ystart, Xend, Yend;

   int4 Xstartp1;
   int4 Ystartp1;
   int4 Xendm1  ;
   int4 Yendm1  ;


   //=======================================================================

   CopyRect(&rc, *&rcButton);  // copy our RECT struct to temp - NEEDED !

   Xstart = rc.left;
   Ystart = rc.top;
   Xend   = rc.right;
   Yend   = rc.bottom;

   Xstartp1 = Xstart+1;
   Ystartp1 = Ystart+1;
   Xendm1   = Xend-1;
   Yendm1   = Yend-1;

	SetBkMode(hdc, TRANSPARENT);
/*   SetTextColor(hdc, PALETTEINDEX(GameColors[LIGHTYELLOW]));

  if(!In)	// Button Out
  { //FillRect(hdc, &rc, (HBRUSH)GetStockObject(GRAY_BRUSH));
    //DrawEdge(hdc, &rc, EDGE_RAISED, BF_RECT | BF_SOFT);
    DrawScreenBox3D(hdc, rc.left,rc.top, rc.right,rc.bottom,
                          (HBRUSH)GetStockObject(GRAY_BRUSH));
	 rc.left += 12;
    rc.top  += 6;
  }
  else	// Button In
  { // FillRect(hdc, &rc, (HBRUSH)GetStockObject(GRAY_BRUSH));
    // DrawEdge(hdc, &rc, EDGE_SUNKEN, BF_RECT | BF_SOFT);
	  rc.left += 3;
     rc.top  += 4;
  }
  DrawText(hdc, szLoadString(StringID), -1, &rc, DT_LEFT | DT_NOCLIP);
  */

  //FillRect(hdc, &rc, (HBRUSH)GetStockObject(GRAY_BRUSH));  // outside square

  SetBkMode(hdc, TRANSPARENT);
  //hOldFont =  SelectFont(hdc, GetStockFont(ANSI_VAR_FONT)); // memo just in case

  //hOldBrush=  SelectBrush(hdc, (HBRUSH)GetStockObject(GRAY_BRUSH) );
  //hOldPen = SelectPen(hdc, gd.hPens[DARKERGRAY] );      //gray
  hOldBrush=  SelectBrush(hdc, gd.hBrushes[InfoBoxColor]);   //  11-7-96
  hOldPen   = SelectPen(hdc,   gd.hPens[InfoBoxColorEdgeB]); //  11-7-96
  Rectangle(hdc, Xstart,  Ystart,   Xend,   Yend);         // outside square

  DrawLine(hdc, Xendm1,   Ystartp1, Xendm1, Yendm1);       // right side
  DrawLine(hdc, Xstartp1, Yendm1,   Xendm1, Yendm1 );      // bottom line

  //---------------------------------------------------------------------
  // fill the inside of the box
  // show the button

  if(!In)	// Button Out (up)
  {  // more light
     SelectPen(hdc, gd.hPens[InfoBoxColorEdgeT]);  //LIGHTERGRAY] );       //white surround
     DrawLine(hdc, Xstart,Ystart, Xend,   Ystart); // top line
     DrawLine(hdc, Xstart,Ystart, Xstart, Yend  ); // left side
     //DrawLine(hdc, Xstartp1,Ystartp1, Xendm1,   Ystartp1); // top line
     //DrawLine(hdc, Xstartp1,Ystartp1, Xstartp1, Yendm1  ); // left side
	  //rc.left += 12;
     //rc.top  += 6;
     SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK])); //   11-7-96 LIGHTYELLOW]));
  }
  else	// Button In (down)
  {  //rc.left += 3;
     //rc.top  += 4;
     SelectPen(hdc, gd.hPens[DARKGRAY] );                // fixed for now
     DrawLine(hdc, Xstart,Ystart, Xend,   Ystart);            // top line
     DrawLine(hdc, Xstart,Ystart, Xstart, Yend  );            // left side
     DrawLine(hdc, Xstartp1,Ystartp1, Xendm1,   Ystartp1);    // top line
     DrawLine(hdc, Xstartp1,Ystartp1, Xstartp1, Yendm1  );    // left side
     SetTextColor(hdc, PALETTEINDEX(GameColors[BLACK]));//  11-7-96 DARKERGRAY]));
  }

  //   8-1-97 center (oops missed DT_CENTER option, so nxt not needed
  char *textAddr = (char*) szLoadString(StringID);
//  SIZE  TxtSize;
//
//  GetTextExtentPoint32(hdc,textAddr,strlen(textAddr),&TxtSize);
//
//  int4  outputloc = rc.left + ( rc.right-rc.left+1  -TxtSize.cx)/2;
//  rc.left = outputloc;
  rc.top  += 5;
  DrawText(hdc, textAddr, -1, &rc, DT_NOCLIP |DT_VCENTER|DT_CENTER);

//  DrawText(hdc, szLoadString(StringID), -1, &rc, DT_LEFT | DT_NOCLIP);

  SetBkMode(hdc, OPAQUE);
  SelectPen  (hdc, hOldPen);
  SelectBrush(hdc, hOldBrush);

}



//////////////////////////////////////////////////////////
//                                                      //
//  Input user string instead of numbers for a change   //
//                                                      //
//////////////////////////////////////////////////////////
Bool InputUserText( HWND hwnd, char *prompt, int2 itemwidth, char *heading, char *data,Bool UpperCase)
{
   DLG2OPTS d2;

   ZeroMemory(&d2, sizeof(d2));

   strcpy(d2.sz3, data);
   strcpy(d2.sz5, heading);
   strcpy(d2.sz6, prompt);

   d2.i1    = itemwidth;

   if( DialogBoxParam( gd.hInst, "InputTxt", hwnd, InputTxtDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {   strncpy(data, d2.sz3, itemwidth);    //   1-5-97
       data[itemwidth] = '\0';              //   7-1-97 force delim max length
       if (UpperCase) strupr(data);         //
       return TRUE;
   }
   return FALSE;
}

//////////////////////////////////////////////////////////////
//                                                          //
//  Input the 5 Hexen Args and Search for entries           //
//                                                          //
// used in Find                                             //
// uses the same EditHexenArgs Dialog as EditSide           //
//////////////////////////////////////////////////////////////

Bool InputHexenArgs(HWND hwnd, char *heading,
                               char *p1,int2 *arg1,
                               char *p2,int2 *arg2,
                               char *p3,int2 *arg3,
                               char *p4,int2 *arg4,
                               char *p5,int2 *arg5)
{
    DLG2OPTS d2;

    if (GameVersion != 4) return FALSE;   //   12-2-96 safety

    ZeroMemory(&d2, sizeof(d2));			// bye bye, due to the way mem works

    d2.i1    = *arg1;             // The 5 arguments
    d2.i2    = *arg2;
    d2.i3    = *arg3;
    d2.i4    = *arg4;
    d2.i5    = *arg5;

	 strcpy(d2.sz3, heading);     // Heading
    if(p1 != NULL) strcpy(d2.sz4, p1);
    if(p2 != NULL) strcpy(d2.sz5, p2);          // The 5 prompts
    if(p3 != NULL) strcpy(d2.sz6, p3);
    if(p4 != NULL) strcpy(d2.sz7, p4);
    if(p5 != NULL) strcpy(d2.sz8, p5);

    if( DialogBoxParam( gd.hInst, "EditHexenArgs", hwnd, EditHexenArgsDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
    {  *arg1 = d2.i1;
       *arg2 = d2.i2;
       *arg3 = d2.i3;
       *arg4 = d2.i4;
       *arg5 = d2.i5;
       return TRUE;
    }
    else
    {   return FALSE;  //   12-2-96 was -1 ??
    }
}

//-----------------------------------------------------------------------//
//   ask for an object number and display a warning message
//   no more -1 = delete, just a hangover, delete button is easier
//-----------------------------------------------------------------------//
#pragma argsused                              // allownone is obsolete
int2 InputObjectXRef(HWND hwnd, int2 objtype, Bool allownone, int2 curobj, SelPtr TheList)
{
  SelPtr   cur;
  int2     Count;
  int2     val;
  DLG2OPTS d2;	 				// our structure for passing info to dialogs
  int2     high;

  //-------------------------------------------------------------------------

   ZeroMemory(&d2, sizeof(d2));

   Count = 0;
   for (cur =TheList; cur; cur=cur->next)
   {    Count++;
   }

   high = GetMaxObjectNum( objtype);

   sprintf( d2.sz3, "%s value from  0 to %hd",GetObjectTypeName( objtype), high );

   //if (allownone)       strcpy(d2.sz4, "Enter -1 to Delete Object(s)");  //   12-18-96
   //else                 strcpy(d2.sz4, " ");

   //wsprintf ( d2.sz5, "%hd Objects will be changed", Count);

   sprintf ( d2.sz4, "%hd Objects will be changed", Count);

   d2.low1  = 0;                       //   12-18-96
   d2.high1 = GetMaxObjectNum(objtype);

   d2.i1 = curobj;
   val   = curobj;

   if( DialogBoxParam( gd.hInst, "XRef", hwnd, XRefDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
       if(d2.i1 <= high)  val=d2.i1;
       if (val < 0 || val > high) val = curobj; //   6-1-97 just extra safety
   }
   else
   {   val = -2;  // show cancelled   6-1-97
   }

   //if (val < 0 || val > high) val = -1;   //   12-2-96 just extra safety

   //if (val < 0 || val > high) val = curobj; //   12-18-96 just extra safety

   return val;   // later make it so can tell if not cancelled (done above)
}

//-----------------------------------------------------------------------//
//   used for Jump
//   ask for an object number and check for maximum valid number
//   (has special prompts)
//-----------------------------------------------------------------------//
#pragma argsused
int2 InputObjectNumber( HWND hwnd, int2 objtype, int2 curobj)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));			//clear

   sprintf( d2.sz3, "%s number", GetObjectTypeName( objtype));
   d2.low1  = 0;
   d2.high1 = GetMaxObjectNum(objtype);

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE( Input1 ), hwnd,
      					 Input1NumberDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {  return d2.i1;
   }
   else
   {   return -1;
   }
}

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input Numbers     - used in Find Menu mostly                    //
//                         also in Dialog.cpp EditThingCommand         //
/////////////////////////////////////////////////////////////////////////
#pragma argsused
uint2  InputSectorType( HWND hwnd, char* prompt,uint2 *OldVal,int2 xpos, int2 ypos)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, prompt);
	d2.i1    = *OldVal;

   d2.Int4A= pLineDlgPos.x+114;  // position of LineDef dialog
   d2.Int4B =pLineDlgPos.y+46;

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE( Input1 ), hwnd,
      					            InputSectorTypeDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {    *OldVal = (uint2)d2.i1;
         return TRUE;
   }
   else  return FALSE;
}

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input Numbers     - used in Find Menu mostly                    //
//                         also in Dialog.cpp EditThingCommand         //
/////////////////////////////////////////////////////////////////////////
#pragma argsused
uint2  InputBOOMSectorType( HWND hwnd, char* prompt,uint2 *OldVal,int2 xpos, int2 ypos)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, prompt);
	d2.i1    = *OldVal;

   d2.Int4A= pLineDlgPos.x;      // position of LineDef dialog
   d2.Int4B =pLineDlgPos.y;

   if( DialogBoxParam( gd.hInst, "EditSectorBOOM", hwnd,
      					            InputBOOMSectorDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {    *OldVal = (uint2)d2.i1;
         return TRUE;
   }
   else  return FALSE;
}
/////////////////////////////////////////////////////////////////////////
//     Input BOOM LineDefNumbers
/////////////////////////////////////////////////////////////////////////
#pragma argsused
uint2  InputBOOMLineDefType( HWND hwnd, char* prompt,uint2 *OldVal,int2 xpos, int2 ypos)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs
   //RECT rcw;

//-------------------------------------------------------------------------

   ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, prompt);     // prompt id
	(uint2)   d2.i1 = *OldVal;     // old value

   //GetWindowRect(hwnd, &rcw);     // real window we are displaying wasn't??
   //d2.Int4A = rcw.top;            // top
   //d2.Int4B = rcw.left;           // left
   d2.Int4A= pLineDlgPos.x+114;  // position of LineDef dialog
   d2.Int4B =pLineDlgPos.y+46;

   if ( DialogBoxParam(gd.hInst,"EditLineDefBOOM",hwnd,
                                InputBOOMLineDefTypeDlgProc,(LPARAM)(LPDLG2OPTS)&d2) )
   {    *OldVal = (uint2)d2.i1;
         return TRUE;
   }
   else  return FALSE;
}

/////////////////////////////////////////////////////////////////////////
//     Input LineDefNumbers
/////////////////////////////////////////////////////////////////////////
#pragma argsused
uint2  InputLineDefType( HWND hwnd, char* prompt,uint2 *OldVal,int2 xpos, int2 ypos)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));

   strcpy( d2.sz3, prompt);
	(uint2) d2.i1  = *OldVal;

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE( Input1 ), hwnd,
      					            InputLineDefTypeDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {    *OldVal = (uint2)d2.i1;
         return TRUE;
   }
   else  return FALSE;
}

/////////////////////////////////////////////////////////////////////////
//     Input Thing Type
/////////////////////////////////////////////////////////////////////////
#pragma argsused
uint2  InputThingType( HWND hwnd, char* prompt,uint2 *OldVal,int2 xpos, int2 ypos)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, prompt);
	(uint2)   d2.i1  = *OldVal;

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE( Input1 ), hwnd,
      					            InputThingTypeDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {    *OldVal = (uint2)d2.i1;
         return TRUE;
   }
   else  return FALSE;
}

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input Numbers     - used in Find Menu mostly                    //
//                         also in Dialog.cpp EditThingCommand         //
/////////////////////////////////////////////////////////////////////////
#pragma argsused
int2  InputNumbers( HWND hwnd, char* prompt, int2 min, int2 max, int2 *OldVal,
                                             int2 xpos, int2 ypos)
{
  DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, prompt);
   d2.low1  = min;
   d2.high1 = max;
	d2.i1    = *OldVal;

// d2.i2    = xpos;      // 12-12-96 position the dialog where we want // undo later, since I changed it 12-16-96
// d2.i3    = ypos;      // 12-16-96 I never used it anyway

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE( Input1 ), hwnd,
      					  Input1NumberDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {    *OldVal = d2.i1;
         return TRUE;
   }
   else  return FALSE;
}
/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input 2 Numbers     -  returns True or False, use passed address//
//                                                                     //
//     of variables and updates both before returning if not cancelled //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
Bool Input2Numbers(HWND hwnd, char *heading,
                              char *prompt1, char* prompt2,
                              int2  min1, int2 max1,
                              int2 *OldVal1,
                              int2  min2, int2 max2,
                              int2 *OldVal2)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz5, heading);
   strcpy  ( d2.sz3, prompt1);
   strcpy  ( d2.sz4, prompt2);

   d2.b1    = FALSE;      // do int2
   d2.b2    = FALSE;      // do decimal default
   d2.low1  = min1;
   d2.high1 = max1;
   d2.low2  = min2;
   d2.high2 = max2;

	d2.i1    = *OldVal1;
	d2.i2    = *OldVal2;

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE(Input2), hwnd, Input2NumbersDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
        *OldVal1 = d2.i1;
        *OldVal2 = d2.i2;
        return TRUE;
   }
   else return FALSE;
}

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input 2 Numbers int4-  returns True or False, use passed address//
//     HEX for now, can do extra parm later                            //
//     of variables and updates both before returning if not cancelled //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
Bool Input2Numbers4(HWND hwnd, char *heading,
                              char *prompt1, char* prompt2,
                              int4  min1, int4 max1,
                              int4 *OldVal1,
                              int4  min2, int4 max2,
                              int4 *OldVal2)
{
   DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
   ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz5, heading);
   strcpy  ( d2.sz3, prompt1);
   strcpy  ( d2.sz4, prompt2);

   d2.b1         = TRUE;      // do int4
   d2.b2         = TRUE;      // do hex  (temp override)
   d2.Int4AHigh  = max1;
   d2.Int4ALow   = min1;
   d2.Int4BLow   = min2;
   d2.Int4BHigh  = max2;

	d2.Int4A    = *OldVal1;
	d2.Int4B    = *OldVal2;

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE(Input2), hwnd, Input2NumbersDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
        *OldVal1 = d2.Int4A;
        *OldVal2 = d2.Int4B;
        return TRUE;
   }
   else return FALSE;
}

/////////////////////////////////////////////////////////////////
//                                                             //
// Mostly in Edit, a little different                          //
//                                                             //
// doesn't set the old value, just passes it back to the       //
// calling process    Also, has 2 prompts instead of one       //
/////////////////////////////////////////////////////////////////
int2 Input1Number(HWND hwnd, char* prompt1, char* prompt2, int2 min, int2 max, int2 OldVal) //was InputNumbers1
{
  DLG2OPTS d2;

    ZeroMemory(&d2, sizeof(d2));

    lstrcpy(d2.sz3, prompt1);
	 lstrcpy(d2.sz4, prompt2);

    d2.high1 = max;
    d2.low1  = min;
    d2.i1    = OldVal;

    if( DialogBoxParam( gd.hInst,
                        MAKEINTRESOURCE( Input1 ),
                        hwnd,
   					      Input1NumberDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
    {
       OldVal = d2.i1;
    }

    return OldVal;
}


/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     InputF&R  Find and Replace from Find Menu                       //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
int2 InputReplace(HWND hwnd,char *heading, char *find, uint2 *fobj,
                                           char *repl, uint2 *robj,
                                           char *perc, int2 *pobj)
{
  DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------

 ZeroMemory(&d2, sizeof(d2));			// bye bye, due to the way mem works

	strcpy  ( d2.sz3, heading);
   strcpy  ( d2.sz4, find);
   strcpy  ( d2.sz5, repl);
   if(perc == NULL)               // Not Registered, can't use percentage
    { strcpy  ( d2.sz6, " ");
      d2.b1 = TRUE;
    }
   else
    { strcpy  ( d2.sz6, perc);
      d2.b1 = FALSE;
    }
   //d2.low1  = lf;                 // Low & High Value for Find
   //d2.high1 = hf;
   //d2.low2  = lr;                 // Low & High Value for Replace
   //d2.high2 = hr;
   d2.i1    = *fobj;               // Find What Object
   d2.i2    = *robj;               // Replace with What Object
   if(perc == NULL)               // Not Registered, can't use percentage
    d2.i3    = 100;               // Percentage to replace
   else
    d2.i3    = *pobj;               // Percentage to replace

   if( DialogBoxParam( gd.hInst, "Replace", hwnd, ThingFindReplaceDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {   *fobj = d2.i1;
       *robj = d2.i2;
       *pobj = d2.i3;  // Will ALWAYS be 100% if not registered
       return TRUE;
   }
   else
   {   return FALSE;
   }

}

//-----------------------------------------------------------------------//
//   used for Jump TID LID
//   ask for an object number and check for maximum valid number
//-----------------------------------------------------------------------//
int2 InputTIDLIDNumber(HWND hwnd)
{
static int2 lastTid   =0;
static int2 lastLineID=0;

   DLG2OPTS d2;	 				// our structure for passing info to dialogs
   int2 highval;
   char *typeID;

 ZeroMemory(&d2, sizeof(d2));			// bye bye, due to the way mem works

//-------------------------------------------------------------------------
   if (GameVersion != 4) return -1;

   if (EditMode == OBJ_THINGS)
   {   typeID = "Thing ID";
       FindFreeTid();
       highval = HighTid;
   }
   else
   if (EditMode == OBJ_LINEDEFS)
   {   typeID = "Line ID";
       FindFreeLineId();
       highval = HighLineId;
   }
   else
   {   return -1;
   }

   sprintf( d2.sz3, "Enter %s number", typeID);

   d2.low1  = 0;
   d2.high1 = highval;

   if( DialogBoxParam( gd.hInst, MAKEINTRESOURCE( Input1 ), hwnd,
      					 Input1NumberDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {  if (EditMode == OBJ_THINGS)
      {   lastTid = d2.i1;
      }
      else
      {   lastLineID = d2.i1;
      }
      return d2.i1;
   }
   else
   {   return -1;
   }

}


/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input 3 Numbers     -  returns True or False, use passed address//
//                                                                     //
//     of variables and updates both before returning if not cancelled //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
Bool Input3Numbers(HWND hwnd, char * heading,
                     char* prompt1, int2 min1, int2 max1, int2 *OldVal1,
                     char* prompt2, int2 min2, int2 max2, int2 *OldVal2,
                     char* prompt3, int2 min3, int2 max3, int2 *OldVal3)
{
  DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
 ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, heading);
   strcpy  ( d2.sz4, prompt1);
   strcpy  ( d2.sz5, prompt2);
   strcpy  ( d2.sz6, prompt3);
   d2.low1  = min1;
   d2.high1 = max1;
   d2.low2  = min2;
   d2.high2 = max2;
   d2.low3  = min3;
   d2.high3 = max3;
	d2.i1    = *OldVal1;
	d2.i2    = *OldVal2;
	d2.i3    = *OldVal3;

   if( DialogBoxParam( gd.hInst, "Input3", hwnd, Input3NumbersDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
        *OldVal1 = d2.i1;
        *OldVal2 = d2.i2;
        *OldVal3 = d2.i3;
        return TRUE;
   }
   else return FALSE;
}

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input 4 Numbers  for Object   3-1-97
//     returns True or False, use passed address//
//                                                                     //
//     of variables and updates both before returning if not cancelled //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
Bool InputObjectSpecs(HWND hwnd, char * heading,
                     char* prompt1, int2 min1, int2 max1, int2 *OldVal1,
                     char* prompt2, int2 min2, int2 max2, int2 *OldVal2,
                     char* prompt3, int2 min3, int2 max3, int2 *OldVal3,
                     char* prompt4, int2 min4, int2 max4, int2 *OldVal4)
{
  DLG2OPTS d2;	 				// our structure for passing info to dialogs
  int4 cursx,cursy;        // ???? Backup our cursor pos so not trashed

//-------------------------------------------------------------------------

 cursx = pOldCurPos.x;
 cursy = pOldCurPos.y;

 ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, heading);
   strcpy  ( d2.sz4, prompt1);
   strcpy  ( d2.sz5, prompt2);
   strcpy  ( d2.sz6, prompt3);
   strcpy  ( d2.sz7, prompt4);
   d2.low1  = min1;
   d2.high1 = max1;
   d2.low2  = min2;
   d2.high2 = max2;
   d2.low3  = min3;
   d2.high3 = max3;
   d2.low4  = min4;
   d2.high4 = max4;
	d2.i1    = *OldVal1;
	d2.i2    = *OldVal2;
	d2.i3    = *OldVal3;
	d2.i4    = *OldVal4;

   //if( DialogBoxParam( gd.hInst, "Input4", hwnd, Input4DlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   if( DialogBoxParam( gd.hInst, "InputObjectSpecs", hwnd, Input4NumbersDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
        *OldVal1 = d2.i1;
        *OldVal2 = d2.i2;
        *OldVal3 = d2.i3;
        *OldVal4 = d2.i4;
        pOldCurPos.x = cursx;
        pOldCurPos.y = cursy;
        return TRUE;
   }
   else
    {   pOldCurPos.x = cursx;
        pOldCurPos.y = cursy;
        return FALSE;
    }
}
/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input 4 Numbers     -  returns True or False, use passed address//
//                                                                     //
//     of variables and updates both before returning if not cancelled //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
Bool Input4Numbers(HWND hwnd, char * heading,
                     char* prompt1, int2 min1, int2 max1, int2 *OldVal1,
                     char* prompt2, int2 min2, int2 max2, int2 *OldVal2,
                     char* prompt3, int2 min3, int2 max3, int2 *OldVal3,
                     char* prompt4, int2 min4, int2 max4, int2 *OldVal4)
{
  DLG2OPTS d2;	 				// our structure for passing info to dialogs
  int4 cursx,cursy;        // ???? Backup our cursor pos so not trashed

//-------------------------------------------------------------------------

 cursx = pOldCurPos.x;
 cursy = pOldCurPos.y;

 ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, heading);
   strcpy  ( d2.sz4, prompt1);
   strcpy  ( d2.sz5, prompt2);
   strcpy  ( d2.sz6, prompt3);
   strcpy  ( d2.sz7, prompt4);
   d2.low1  = min1;
   d2.high1 = max1;
   d2.low2  = min2;
   d2.high2 = max2;
   d2.low3  = min3;
   d2.high3 = max3;
   d2.low4  = min4;
   d2.high4 = max4;
	d2.i1    = *OldVal1;
	d2.i2    = *OldVal2;
	d2.i3    = *OldVal3;
	d2.i4    = *OldVal4;

   if( DialogBoxParam( gd.hInst, "Input4", hwnd, Input4NumbersDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
        *OldVal1 = d2.i1;
        *OldVal2 = d2.i2;
        *OldVal3 = d2.i3;
        *OldVal4 = d2.i4;
        pOldCurPos.x = cursx;
        pOldCurPos.y = cursy;
        return TRUE;
   }
   else
    {   pOldCurPos.x = cursx;
        pOldCurPos.y = cursy;
        return FALSE;
    }
}

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Input 6 Numbers     -  returns True or False, use passed address//
//                                                                     //
//     of variables and updates both before returning if not cancelled //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
Bool Input6Numbers(HWND hwnd, char * heading,
                     char* prompt1, int2 min1, int2 max1, int2 *OldVal1,
                     char* prompt2, int2 min2, int2 max2, int2 *OldVal2,
                     char* prompt3, int2 min3, int2 max3, int2 *OldVal3,
                     char* prompt4, int2 min4, int2 max4, int2 *OldVal4,
                     char* prompt5, int2 min5, int2 max5, int2 *OldVal5,
                     char* prompt6, int2 min6, int2 max6, int2 *OldVal6)
{
  DLG2OPTS d2;	 				// our structure for passing info to dialogs

//-------------------------------------------------------------------------
 ZeroMemory(&d2, sizeof(d2));

   strcpy  ( d2.sz3, heading);
   strcpy  ( d2.sz4, prompt1);
   strcpy  ( d2.sz5, prompt2);
   strcpy  ( d2.sz6, prompt3);
   strcpy  ( d2.sz7, prompt4);
   strcpy  ( d2.sz8, prompt5);
   strcpy  ( d2.sz9, prompt6);

   d2.low1  = min1;
   d2.high1 = max1;
   d2.low2  = min2;
   d2.high2 = max2;
   d2.low3  = min3;
   d2.high3 = max3;
   d2.low4  = min4;
   d2.high4 = max4;
   d2.low5  = min5;
   d2.high5 = max5;
   d2.low6  = min6;
   d2.high6 = max6;
   
	d2.i1    = *OldVal1;
	d2.i2    = *OldVal2;
	d2.i3    = *OldVal3;
	d2.i4    = *OldVal4;
	d2.i5    = *OldVal5;
	d2.i6    = *OldVal6;

   if( DialogBoxParam( gd.hInst, "Input6", hwnd, Input6NumbersDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
        *OldVal1 = d2.i1;
        *OldVal2 = d2.i2;
        *OldVal3 = d2.i3;
        *OldVal4 = d2.i4;
        *OldVal5 = d2.i5;
        *OldVal6 = d2.i6;
        return TRUE;
   }
   else return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
void OnlyDOOMRegistered()
{
	NotifyMsg(gd.hMainWindow,"!!!   PLEASE REGISTER   !!!\n\n"
                         "By Registering your software\n"
                         "you benefit in a number of ways\n"
                         "The list of features in the\n"
                         "Registered version is substantially\n"
                         "more than the shareware. New weapons,\n"
                         "new monsters, the ability to use editors\n"
                         "like this to create add on levels and\n"
                         "modify them !  ID has stated very\n"
                         "clearly they want no manipulation of the\n"
                         "shareware version of their games. Sorry.");
}


static char EditName[260];			// for Save Filename 260
static char szBuffer[260];			// for Save Filename 260
//static int  len;               //   3-1-97
//static int2 n;

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     choose user Option file   3-1-98                                //
//                                                                     //
/////////////////////////////////////////////////////////////////////////

Bool ChooseUserOptFile(HWND hwnd)
{
   int len,n ;

   Bool b = FALSE;  // No opt name chosen

   strcpy(EditName, UserOptName); // should always have something in it
   len = lstrlen(EditName);

   // Find our insertion point
   for(n = 0; n < len; n++)
   {  if( (EditName[len-n] == '\\' ) )
       break;
   }

   strncpy(szBuffer, EditName, len-n);
   szBuffer[len-n] = '\0';

   if(GetFileName(hwnd,"Game.OPT Types & Descriptions (see DOOM2.OPT & help)", (char *)&EditName, 127, IDS_FILTEROPT, szBuffer)) //   12-13-97 len=127
	{
       strcpy(UserOptName, EditName);
       b = TRUE;
   }
   return b;
}

/////////////////////////////////////////////////////////////////////////
//                                                                     //
//     Following 3 routines choose our Editor Name for editing scripts //
//                                                                     //
//     Which script to edit (*.acs) and which object file ( *.o )      //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
Bool ChooseEditor(HWND hwnd)
{
   int len,n ;       //   3-1-97

   Bool b = FALSE;  // No Editor name chosen

   strcpy(EditName, EditExe); // EditExe should always have something in it
   len = lstrlen(EditName);

   // Find our insertion point
   for(n = 0; n < len; n++)
   {  if( (EditName[len-n] == '\\' ) )
       break;
   }

    strncpy(szBuffer, EditName, len-n);
    szBuffer[len-n] = '\0';

   //if(GetFileName(hwnd,"Text Editor", (char *)&EditName, 127, (char *)szLoadString(IDS_FILTEREXE), szBuffer)) //   12-13-97 len=127
   if(GetFileName(hwnd,"Text Editor", (char *)&EditName, 127, IDS_FILTEREXE, szBuffer)) //   12-13-97 len=127
	{
       strcpy(EditExe, EditName);
       b = TRUE;
   }
   return b;
}

//////////////////////////////////////////////////////////////////////////////
//  Choose an ACS file to edit
//////////////////////////////////////////////////////////////////////////////
Bool ChooseACS(HWND hwnd)
{
   Bool b = FALSE;  // No Script File chosen

   strcpy(EditName, ScriptFile); // EditExe should always have something in it

   //if(GetFileName(hwnd,"ACS script file", (char *)&EditName, 127, (char *)szLoadString(IDS_FILTERACS), PatchDir)) //   12-13-97 len=127
   if(GetFileName(hwnd,"ACS script file", (char *)&EditName, 127, IDS_FILTERACS, PatchDir)) //   12-13-97 len=127
   {   strcpy(ScriptFile, EditName);
       b = TRUE;
    }

 return b;

}

/////////////////////////////////////////////////////////////////////////////

Bool ChooseObj(HWND hwnd)//       Choose the object file to use with level
{
   Bool b = FALSE;  // No File chosen

   strcpy(EditName, ScriptFileObj);

   //if (GetFileName(hwnd,"Script Object file", (char *)&EditName, 127, (char *)szLoadString(IDS_FILTERO), PatchDir)) //   3-1-97 filtero
   if (GetFileName(hwnd,"Script Object file", (char *)&EditName, 127, IDS_FILTERO, PatchDir)) //   3-1-97 filtero
   {   strcpy(ScriptFileObj, EditName);
       b = TRUE;
   }

 return b;

}

/////////////////////////////////////////////////////////////////////////////

Bool ChooseMapInfo(HWND hwnd)      // Choose MapInfoFile
{
   Bool b = FALSE;  // No File chosen

   strcpy(EditName, MapInfoFile);

   //if(GetFileName(hwnd,"MAPINFO file", (char *)&EditName, 127, (char *)szLoadString(IDS_FILTERINF), PatchDir)) //   3-1-97 filterinf
   if(GetFileName(hwnd,"MAPINFO file", (char *)&EditName, 127, IDS_FILTERINF, PatchDir)) //   3-1-97 filterinf
	 {   strcpy(MapInfoFile, EditName);
        b = TRUE;
     }

 return b;

}

/////////////////////////////////////////////////////////////////////////////
Bool ChooseSndInfo(HWND hwnd)        // Choose SndInfoFile
{
  Bool b = FALSE;  // No File chosen

   strcpy(EditName, SndInfoFile);

   //if(GetFileName(hwnd,"SNDINFO file", (char *)&EditName, 127, (char *)szLoadString(IDS_FILTERSND), PatchDir)) //   3-1-97 filersnd
   if(GetFileName(hwnd,"SNDINFO file", (char *)&EditName, 127, IDS_FILTERSND, PatchDir)) //   3-1-97 filersnd hexen
   {   strcpy(SndInfoFile, EditName);
       b = TRUE;
   }

   return b;
}

//12-12-96 bk
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Shows the ListFile Dialog with an Edit Control on it to show the           //
// content of any valid txt file                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
void ListFile(char* lpzFile)
{
 DLG2OPTS d2;
 ZeroMemory(&d2, sizeof(d2));
 strcpy(d2.sz3, lpzFile);            // sz3 is ONLY 128 chars
 DialogBoxParam( gd.hInst, "ListFile", gd.hMainWindow, ListFileDlgProc,(LPARAM)(LPDLG2OPTS)&d2);
}

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Shows the ListFile Dialog with an Edit Control on it to show the           //
// content of any valid txt file                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
void DeePDestroyWindow(HWND hwnd)
{
     if(hwnd) DestroyWindow(hwnd); // get rid of the dialog
}
/*
////////////////////////////////////////
//
//		PercentDone - called to step the progress bar by the specified amount
//
///////////////////////////////////////
#pragma argsused
void PercentDone(HWND hDlg, int4 curnum, int4 maxnum)
{
   if (!maxnum ) return;                // no divide by 0

	Progress_SetPos(GetDlgItem(hDlg, IDD_PROGRESS1), (curnum / 100));
   //HAVE TO / 100 for some reason worked ok on 28k up to 300k so far accurately
}

////////////////////////////////////////////////////////////////////////////////
//
//		PercentObject - called to initialize the Progress Bar
//
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void PercentObject(HWND hDlg, char * objmsg, int4 max)
{
  Progress_SetRange(GetDlgItem(hDlg, IDD_PROGRESS1), 0, (max/100) );
  Static_SetText(GetDlgItem(hDlg, stc1), objmsg); // "checking . . ."
}
*/

static HWND ProgressDlgModeless = NULL; // Handle of curent Modeless Dialog for progress only   6-1-97

//==============================================================================
////////////////////////////////////////////////////////////////////////////////
// get rid of progress box for save if any
////////////////////////////////////////////////////////////////////////////////
static void DestroyProgressWindow(void)
{
    DeePDestroyWindow(ProgressDlgModeless);
    ProgressDlgModeless = 0;
}

////////////////////////////////////////////////////////////////////////////////
//
//		PercentDone - called to step the progress bar by the specified amount
//
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void PercentDone(HWND hwnd, int4 curnum, int4 maxnum)
{
  if (ProgressDlgModeless)         //   6-1-97
  {
      Progress_SetPos(GetDlgItem(ProgressDlgModeless,IDD_PROGRESS1), (curnum / 100));

      if (curnum == 100 && maxnum == 100)
      {
         DestroyProgressWindow();
      }
  }
   //HAVE TO / 100 for some reason worked ok on 28k up to 300k so far accurately
}

////////////////////////////////////////////////////////////////////////////////
//
//		PercentObject - called to initialize and to destory the dialog
//
////////////////////////////////////////////////////////////////////////////////
void PercentObject(HWND hwnd, char * filename, int4 SaveOption, int4 max)
{

  if(SaveOption == 1)		// Save
  {  // Send "Saving Filename"  to dialog on CreateDialogParam
     //ProgressDlgModeless = CreateDialogParam(gd.hInst, (LPSTR)"Progress", gd.hMainWindow, ProgressDlgProc, (DWORD)(LPSTR)filename);
     DestroyProgressWindow();  // make sure not active
                                                                        //hwnd
     ProgressDlgModeless = CreateDialogParam(gd.hInst, (LPSTR)"Progress", hwnd, ProgressDlgProc, (DWORD)(LPSTR)filename);
	  Progress_SetRange(GetDlgItem(ProgressDlgModeless,IDD_PROGRESS1), 0, (max/100) );
  }

  if(SaveOption == 3)		// Restore ?? only know sent on end of saving so OK to destory dialog
  {
     DestroyProgressWindow();
  }
}

//============================================================================
// spawns anything   3-1-97
//   5-1-97 revisions, some systems? won't give right code completion?
//============================================================================

void Deep_OnPaint(HWND hwnd);              // in DEEP.CPP   3-1-97

int4 SpawnProcess(HWND hwnd,char*Directory,char* szCommandLine,WORD wShowWindow, Bool WaitState)
{
PROCESS_INFORMATION proci       ={(0)};       // For Launching Doom & testing level
STARTUPINFO         StartupInfo ={(0)};
DWORD               Code;                     // Return code for getexitcode
int                 SleepDelay = 500;
Bool                WaitDos    = WaitState&SPAWNDOS;
Bool                WaitIwad   = WaitState&SPAWNIWAD;
Bool                WaitGui    = WaitState&SPAWNGUI;

   //ZeroMemory(&StartupInfo, sizeof(STARTUPINFO));
   //  ZeroMemory(&d2, sizeof(d2));
   StartupInfo.cb 	       = sizeof(STARTUPINFO);  // size this control
   StartupInfo.lpReserved 	 = NULL;
   StartupInfo.lpTitle      = NULL;
   StartupInfo.dwFlags 	    = STARTF_USESHOWWINDOW;
//                             |STARTF_USEPOSITION;      // can't get this to work
//                             |STARTF_USECOUNTCHARS;
//   StartupInfo.dwX     	    = 100;  // start loc x
//   StartupInfo.dwY     	    = 100;  //           y
//   StartupInfo.dwXCountChars=  80;
//   StartupInfo.dwYCountChars=  79;

   StartupInfo.wShowWindow  = wShowWindow;//SW_SHOWDEFAULT;
   StartupInfo.cbReserved2  = 0;
   StartupInfo.lpReserved2  = NULL;

   if (! CreateProcess(
             NULL,              // pointer to name of executable module
             szCommandLine,	  // pointer to command line string
             NULL,	           // pointer to process security attributes
             NULL,	           // pointer to thread security attributes
             FALSE,	           // handle inheritance flag
             CREATE_DEFAULT_ERROR_MODE | NORMAL_PRIORITY_CLASS	,	// creation flags
             //CREATE_NEW_CONSOLE | NORMAL_PRIORITY_CLASS	,	// creation flags
             NULL,	           // pointer to new environment block
             Directory,         // pointer to current directory name HAVE TO HAVE !
             &StartupInfo,	     // pointer to STARTUPINFO
             &proci))           // pointer to PROCESS_INFORMATION
    {
             return -666;       // indicate failed to start
    }


    if (WaitIwad)
    {   SleepDelay = 1000;
    }

    // DOS
    if (WaitDos)
    {   //Sleep(500);
        //WaitForInputIdle(proci.hProcess, INFINITE); //GUI only
        WaitForSingleObjectEx(proci.hProcess, INFINITE, FALSE);  // this for DOS
        GetExitCodeProcess(proci.hProcess, &Code);

        //if (Code == STILL_ACTIVE) //just a safety, noticed weird stuff sometimes
        /*
        {
           do
           {   Sleep(SleepDelay);  //250
               GetExitCodeProcess(proci.hProcess, &Code);
               Deep_OnPaint(hwnd);
           }
           while(Code == STILL_ACTIVE);
        } */
    }
    else
    // WINDOWS if we wait in GUI, screen is not redrawn, e,g, notepad is dragged so I cheated a bit
    if (WaitGui)
    {
        WaitForInputIdle(proci.hProcess, INFINITE); //GUI only

        do
        {   Sleep(SleepDelay);
            GetExitCodeProcess(proci.hProcess, &Code);
            Deep_OnPaint(hwnd);
        }
        while(Code == STILL_ACTIVE);
    }

    return Code;         // successfull code = 0;
}
//============================================================================
//  save screen to memory
//============================================================================
HBITMAP ScreenToMemDC(HWND hwnd,int4 Xleft,int4 Ytop,int4 Xright,int4 Ybottom)
{
   //RECT    rect;
   HDC     hdc, hMemDC;
   HBITMAP hBmp, hOldBmp;

	//get source device context for the client area
	hdc = GetDC(hwnd);

	//get destination memory hdc compatible with client area
	hMemDC=CreateCompatibleDC(hdc);

	//create compatible bitmap for client area
	//GetClientRect(hwnd,&rect);      //.top & .left are both
   //	hBmp = CreateCompatibleBitmap(hdc,rect.right,rect.bottom);
   int4 width = Xright-Xleft+1;
   int4 height= Ybottom-Ytop+1;
	hBmp = CreateCompatibleBitmap(hdc,width,height);

	//select client area bitmap into device context so we can write on it
	hOldBmp=SelectBitmap(hMemDC, hBmp);     // setup target specs

	//and copy it to the new hMemDC
	//BitBlt( hMemDC,0,0,                   //destination (x,y)
   //              rect.right,rect.bottom, //width, height
	//              hdc,0,0,                //source (x,y)
	//              SRCCOPY);

  	BitBlt( hMemDC,0,0,                    //destination (x,y)
                  width,height,           //width, height
  	          hdc, Xleft,Ytop,             //source (x,y)
  	               SRCCOPY);

	SelectBitmap(hMemDC, hOldBmp);

   ReleaseDC(hwnd,hdc);
	DeleteDC(hMemDC);
   //NotifyMsg(hwnd,"dimen  x=%d,%d y=%d,%d",rect.left,rect.right,rect.top,rect.bottom);
	return(hBmp);
}

//==========================================================================
//void KillMemBmp()
//{
//    if (hMemBmp != NULL)
//    {
//       DeleteBitmap(hMemBmp);
//       hMemBmp = NULL;
//    }
//}

//==========================================================================
//void SaveScreen( HWND hwnd, HBITMAP *hSaveBmp)
//{
//    *hSaveBmp = ScreenToMemDC(hwnd);	         // Save MAP area to Memory DC
//}

//==========================================================================
//void RestoreScreen(HDC hdc, HBITMAP *hSaveBmp)
//{
//    if (*hSaveBmp != NULL)
//    {
//       DrawBitmap(hdc, *hSaveBmp, 0, 0, SRCCOPY); // Blast Memory to Screen
//       DeleteBitmap(*hSaveBmp);
//       *hSaveBmp = NULL;
//    }
//}

//---------------------------------------------------------------------------
//    Memory Physical and Page file size (returned in KB units)            //
//---------------------------------------------------------------------------
void MemoryAvailable(int4 *MemoryLeftPhy,int4 * MemoryLeftPage,int4*MemoryLoad, int4*MemoryTotalPhy)
{
     MEMORYSTATUS mst;

     // memset(&mst, 0, sizeof(mst));   8-1-97 not needed
	   mst.dwLength = sizeof(mst);

      GlobalMemoryStatus(&mst);

      if (MemoryLeftPhy ) *MemoryLeftPhy  = (mst.dwAvailPhys+511) / 1024;       // round to kb
		if (MemoryLeftPage) *MemoryLeftPage = (mst.dwAvailPageFile+511) / 1024;   // round to kb
		if (MemoryLoad    ) *MemoryLoad     =  mst.dwMemoryLoad;                  // 0 to 100
		if (MemoryTotalPhy) *MemoryTotalPhy = (mst.dwTotalPhys+511) / 1024;       // round to kb
}
//---------------------------------------------------------------------------
//    TimerTickCount set start/stop timer values and give elapsed in ms    //
//    QueryPerformanceCounter = very high res timer
//---------------------------------------------------------------------------

int4 TimerGetTickCount( int4 timecmd)
{
static uint4 begintime;
static uint4 endtime;
static uint4 elaptime;      // elapsed time

    switch(timecmd)
    {
    case 0:   			       	// reset
      elaptime = 0;
      return 0;
    case 1:  			       	// start (set beginning time)
      begintime = GetTickCount();
      return 0;
    case 2:  			       	// stop  (+ time up to now)
      endtime = GetTickCount();
      elaptime = elaptime + ( endtime - begintime);  // accumulated time
      return elaptime;
    case 3:  			       	// elapsed   only
      endtime = GetTickCount();
      elaptime = ( endtime - begintime);  //just elapsed
      return elaptime;
    }
    return 0;
}

//--------------------------------------------------------------------------
//  -- old code from 1st C program, only number formatting is used
//  1. i1 - convert int short and long as appropriate and copy to dest    //
//  2. cc - copy characters to dest for length                            //
//  3. z1 - like i, then zero fill leading blanks                         //
//  4. ,1 - like i, but edit with commas                                  //
//--------------------------------------------------------------------------
//          int type   |addr number| addr to   |length
//          i1/2/4 int | or chars  | store     | to format
//          z1/2/4 supz
//          z1/2/4
//          ,1/2/4 with ,
//          cc char
int2 Format(int2 type, char *data, char *dest, int2 copylen)
{
int2 i,j,k;
int2 digitlen;
int2 offset;
unsigned char ztype;

union short_long {
     int2 shortint;             // i (1byte)
     int2 normalint;            // i (2,bytes)
     int4 longint;              // l (4,bytes)
     char number;               //
     char intarray[4];          // c (copy into here)
} U;

char stringnum[33];
char stringedit[33];

     ztype = type;

     switch(type)
     {
     case ',4':
     case 'i4':                                      // long l
     case 'z4':
	for (i=0; i<4 ; i++) U.intarray[i]=data[i]; // copy number
	ltoa(U.longint,stringnum,10);               // convert long to string
	break;
     case ',2':
     case 'i2':                                      // short d
     case 'z2':
	for (i=0; i<2 ; i++) U.intarray[i]=data[i]; // copy number
	itoa(U.normalint,stringnum,10);             // convert int to string
	break;
     case ',1':
     case 'i1':                                      // short  i1
     case 'z1':
	for (i=0; i<1 ; i++) U.intarray[i]=data[i]; // copy number
	itoa(U.number,stringnum,10);                // convert int to string
	break;
//     case 'cc':                                           // string
//      for (i=0; i<copylen && data[i]!='\0'; i++) dest[i]=data[i];
//      if (i < copylen )
//         for (; i<copylen ; i++) dest[i]=' ';
//
//      return copylen;
     }

// --------- for numbers i and z only --(cc returned already)---------------

     for (j=0;j<33 && stringnum[j] != '\0';j++) // calculate copylen of number
	if (stringnum[j] == '\0')
	    break;
     digitlen=j;                                // number of digits

     if (ztype == ',')
     {  for (k=0, j=digitlen, i=0; k < digitlen; k++,j--)
	{    if (j > 2 && j != digitlen && !(j%3) )
		stringedit[i++] = ',';   // insert a comma

	     stringedit[i++] = stringnum[k];
	}
	digitlen = i;
	stringedit[i+1] = 0;
	strcpy(stringnum,stringedit);           // copy string
     }

     offset = int2(copylen-digitlen);                 // length wanted - actual length

     for (i=0,j=0; i < copylen; i++)
     {   if (i < offset)
	    dest[i] = ' ';
	 else
	 {  dest[i] = stringnum[j]; j++; }
     }

     if   (ztype == 'z')                          // zero fill
     {
	  for (i=0; i < copylen; i++)
	  {   if (dest[i] == ' ') dest[i] = '0';  // zero fill
	      else break;
	  }
     }

     return digitlen;
}

////////////////////////////////  end  ///////////////////////////////////////
