////////////////////////////////////////////////////////////////////////////////
//  Program Name: EDITDLG.CPP                                                 //
//  split from dialogs.cpp 8-1-97
////////////////////////////////////////////////////////////////////////////////


#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "Deep.h"
#include "windeep.h"
#pragma hdrstop

#include <dlgs.h>			        // header for control defines
#include <math.h>
#include <commctrl.h>
#include <commdlg.h>

 // special for composite when adding new stuff jav 8-1-97
extern int4  GettingTexture; // in NewGraph.cpp prevent double entry checked in editdlg sidedef & floor

int2 DisplayCompositeTexture(HDC hdc,  int2 xstart, int2 ystart, int2 xend, int2 yend,
		                         //int2 xoffset, int2 yoffset,
                               char *texname,char *showtext);

// new different to
static void DisplayThingsMenuX( HWND         hwnd,
                                POPupListPtr PopList,
                                uint4        commandID);
static void DisplayLineDefTypeMenuX( HWND  hwnd,
                                    int2  x0, int2 y0,
                                    int2  objnum,         // or Special from thing
                                    Bool  fromlinedef,
                                    POPupListPtr PopList,
                                    uint4        commandID);
//#pragma warning (disable: 4068)

/*

ChooseTxtrDlgProc					Choose a new Texture, called with txtr struct
										in LPARAM txtr.Txtr1 name of old Txtr and
                              txtr.Txtr2 string to display Upper etc. Can
                              pick button to browse full screen if required,
                              browse posts a WM_BROWSE_BACK after finished
                              Called from GetNewTextureName mostly since it sets it up.
ChooseFloorDlgProc				'' . . called from GetNewFloorName as above


EditHexenArgsDlgProc          Edit the 5 Hexen Args (nothing done, return values)

EditLevelDlgProc					EditLevel Dialog - calls, MapBrowse if required

EditLineDefDlgProc				Displays LineDef info

EditSectorDlgProc             Edit a Sector characteristics

EditSideDefDlgProc				Displays SideDef info with preview window active

EditThingDlgProc					Thing preview, change attributes, pick new thing

ThingFindReplaceDlgProc       Thing Search and Replace with Percent

HexenArgsDlgProc              Edit the 5 Hexen Args.

LineFlagDlgProc					Displays Flags for the line, allow to change

OffsetDlgProc						Displays Spinner control to interactively adjust
										the X,Y offset of textures - with preview

StairTypeDlgProc              To determine Straight of Curved Stairs to build

TestOptions                   User defined options for Launching the Doom Engine

ThingMaskDlgProc					Displays the thing flags for masking thing display
										Those not selected are not displayed on screen
SplitOptionsDlgProc           Split Option (Exit, Split Sector, 2-Sided)

XRefDlgProc                   Input a Number with WARNING "incorrect xref may . . .


                    MODELESS

AngleDlgProc                  help angle
LinePrevDlgProc					show textures
*/



///////////////////  Local Prototypes  /////////////////////////////////////////
//                                                                            //
static void MultiAlignShow(HWND hwnd, SelPtr ldlist, SelPtr sdlist,int2 whichside);
static void ShowTextureAlignBoth (HDC hdc,char *ShowTexName1,char *ShowTexName2,char *ShowTexName3,int2 xvalue, int2 yvalue);

static void ShowMouseAlignment(HWND hwnd);

//                                                                            //
///////////////////   END Protos     ///////////////////////////////////////////


int2  Mask1;                    // mask for skill levels
int2  Mask2;                    // mask for HEXEN  deaf/dormant
int2  Mask3;                    // mask for HEXEN  fighter++
int2  Mask4;                    // mask for HEXEN  single and coop only

int2  ThingMask1    = 1;        // 1 mask display easy things
int2  ThingMask2    = 1;        // 2 mask display medi things
int2  ThingMask3    = 1;        // 3 mask display hard things
int2  ThingMaskPoly = 1;        // HEXEN show polyobjects, 2=show numbers too
int2  ThingMaskSpots= 1;        // HEXEN show MapSpots     2=show numbers too
int2  ThingNumberIds= 0;        // mask number poly,map,tid

int2  ThingMaskDeaf   = 0;      // 4 deaf things  ONLY
int2  ThingMaskDormant= 0;      // 5 hexen dormantONLY

int2  ThingMaskPlayers   =1;    //
int2  ThingMaskKeys      =1;    //
int2  ThingMaskEquipment =1;    //
int2  ThingMaskWeapons   =1;    //
int2  ThingMaskAmmunition=1;    //
int2  ThingMaskEnemies   =1;    //
int2  ThingMaskOther     =1;    //

// hexen stuff
int2  ThingMaskPuzzle    =1;    //  puzzle type item
int2  ThingFighter       =1;    //  fighter
int2  ThingCleric        =1;    //  cleric
int2  ThingMage          =1;    //  mage
int2  ThingSingle        =1;    //  single player
int2  ThingCoop          =1;    //  cooperative
int2  ThingDeath         =1;    //  deathmatch  (network)

//------------------------------------------------------------------------------

static char    Unknown[]       = "Unknown\0\0";

       char   *oldBigThingName = Unknown;  // for displaying picture for thingmenu
       char   *BigThingName    = Unknown;

static char    EdTxt[10];//       = "\0";	    // EditText for name matching made 10 12-2-97 since text is 9 in?

extern char    TxtrName  [9];              // Current Texture pic names  (browse)

//     char    TxtrName  [9] = "\0";       // Current Texture pic names
       char    FloorName [9] = "\0";		 // Floor Name when Browsing for Floor/Ceiling
       char    SpriteName[9] = "\0";       // Sprite Name

static char    PrevFloorName[9]= "\0";     // Preview Floor Name
static char    PrevCeilName[9] = "\0";     // Ceiling Name


//-------------------------------------------------------------------------

static int2       hLine;           // Last LineDef Button chosen
static int2       hSide;           // Last SideDef Button chosen
static int2       hSect;           // Last Sector Button chosen

static HWND       hStatic;

static Bool       NameChange;       // = FALSE;  // for update listbox in Choose...

static HWND 		hEdit;            // easy to grab handles for controls
static HWND 		hList1;           // normally list with scroll bars on right
static HWND       hTxtrPrev;        // preview box IDD_CHOOSETXTRPREVIEW browser textures/flats

static LRESULT 	ListBoxIndex;     // index for grabbing List Box entries   12-25-96

//extern LRESULT 	CompIndex;        // index for grabbing Composite List TEXTURE Box entries
//extern LRESULT 	SubIndex;         // index for SubTxtrs in Composite list of sub textures
//extern LRESULT 	PnameCompIndex;   // index for grabbing Composite List PNAME Box entries

//static RECT     rcMenu;           // for menu pos in Dialog
static RECT       rcThingMenu;      // for Thing  menu pos in Dialog   3-1-97
static RECT       rcSectorMenu;     // for Sector menu pos in Dialog   12-2-96
static RECT       rcLineMenu;       // for LineDef menu pos in Dialog   12-2-96
static RECT       rcLineFlagMenu;   // for lineDef menu flags             12-16-96

//-------------------------------------------------------------------------


static char  ShowTexName1[9]="-";
static char  ShowTexName2[9]="-";
static char  ShowTexName3[9]="-";

static int2  Xoff, Yoff;            // access to offset for texture's   3-1-97 static

Bool   PopupMenu = FALSE;          // is a popup menu Displayed ?
                                   // otherwise right click can close

// for special stuff HEXEN linedefs and things===============================

static int2  special;              

static uint2 tspecial;             // these are all bytes in real structure
static int2  targ[5];              // changed to int from uint for conformity

static int2  OldPolyId;            //   12-15-96 was global
static int2  tid;                  // ... ........ ....

static uint2 ThingType;            // thing type      3-1-97 split apart from type
static uint2 SectorType;           // Sector Type
static uint2 LineType;             // linedef type  3-1-98 uint2
//static int2  OldThingType;  ++toDO++       // Old Type of xxxxx for menu browsing   3-1-97 any type???????????global
//static int2  OldLineType;        // Old Type of xxxxx for menu browsing   3-1-97 any type???????????global
static uint2 OldType;              // Old Type of xxxxx for menu browsing   3-1-97 any type???????????global

static uint2 ThingIds[41];         // store subset of Thing Ids here
static int2  thingmenuval = -1;    // need to access from various places
static int2  linemenuval  = -1;    // current line menu val
static int2  menuval2     = -1;    // the actual thing ID #

//static int2  menuvalold;           // Highlight the previous selection
//static TypeThingPtr  OldThingNames ;      // For saving Hexen Spawn Names - MUST be global

static int2   thingmagnify;            // = 2;

// LineDefType menu values  max 32 for now
// Sector Menu values
// ThingId's for things

   uint4  types   [32]; // was int2
   uint2  Ltag    [32];
   uint2  Larg1   [32];
   uint2  Larg2   [32];
   uint2  Larg3   [32];
   uint2  Larg4   [32];
   uint2  Larg5   [32];
   uint2  Lflag   [32];

           // for special stuff HEXEN linedefs and things
//   these are in Edit
//static char*  argdesc[5] = { "                   ",
//                      "                   ",
//                      "                   ",
//                      "                   ",
//                      "                   "};
static uint2  ltag;
static uint2  lspecial;            // these are all bytes in real structure
static int2   larg[5];             // 5 args for linedefs
static byte   lflag;               //

//static HBITMAP hAngleSaveBMP;      // save angle help bit map here

//////////////////////////////////////////////////////////////////////////
//              Local Protos

static void ShowThing (HWND hwnd,int2 menumode, int2 menuval);

static void ShowMenuSelect(HWND hDlg, int2 Id, Bool direct);
static Bool ThingSpawnSpecial(HWND hwnd, int2 x0,int2 y0, int2 special);

static void EditThingLineInfo(HWND hwnd, int2 x0, int2 y0, int2 objnum);

static void HandleLineTypeMenu  (HWND hwnd, int left, int top);
static void HandleSectorTypeMenu(HWND hwnd);


//---------------------------------------------------------------------
// submenu list for Things
//---------------------------------------------------------------------

POPupList DoomThingList[] =               //   6-1-97 renamed from deepthinglist
  {                        //1234567890123456789012
      { TypeNA,        "&1   Enter a Thing #",        CM_TM1 },  //1
      { TypeSEPARATOR, "separate",                        0 },  //2  just a separator
      { TypePlayer,    "&2   Player Start/Teleport ", CM_TM2 },  //3
      { TypeKeys,      "&3   Keys",                   CM_TM3 },  //4
      { TypeBonus,     "&4   Equipment",              CM_TM4 },  //5
      { TypeWeapon,    "&5   Weapons",                CM_TM5 },  //6
      { TypeSupplies,  "&6   Ammunition",             CM_TM6 },  //7
      { TypeEnemy,     "&7   Enemies",                CM_TM7 },  //8
      { TypeDecor1,    "&8   Decorations",            CM_TM8 },  //9
      { TypeDecor2,    "&9   Light Sources",          CM_TM9 },  //10
      { TypeDecor3,    "&A   Corpses",                CM_TM10},  //11
      { TypeDecor4,    "&B   Hanging Corpses",        CM_TM11},  //12
      { TypeSPARE1,    "&C   xxNew Things          ", CM_TM12},  //13   xx is required to not activate
      { NULL              ,NULL,                       NULL }
  };
/*
POPupList DoomThingList[] =               //   6-1-97 renamed from deepthinglist
   {
      {  TypePlayer,    "Player Start/Special"},     //3
      {  TypeKeys,      "Keys"},              //4
      {  TypeBonus,     "Equipment"},         //5
      {  TypeWeapon,    "Weapons"},           //6
      {  TypeSupplies,  "Ammunition"},        //7
      {  TypeEnemy,     "Enemies"},           //8
      {  TypeDecor1,    "Decorations"},       //9
      {  TypeDecor2,    "Light Sources"},     //10
      {  TypeDecor3,    "Corpses"},           //11
      {  TypeDecor4,    "Hanging Corpes"},    //12
      {  TypeSPARE1,    "New Things"},        //13  3-1-98   new
      {  NULL          ,NULL }
   }; */

static  POPupList HereticThingList[] =
   {
      {  TypePlayer,    "Player Start/Special"},     //3
      {  TypeKeys,      "Keys"},              //4
      {  TypeBonus,     "Equipment"},         //5
      {  TypeWeapon,    "Weapons"},           //6
      {  TypeSupplies,  "Ammunition"},        //7
      {  TypeEnemy,     "Enemies"},           //8
      {  TypeDecor1,    "Decorations"},       //9
      {  TypeDecor2,    "Light Sources"},     //10
      {  TypeDecor3,    "Corpses"},           //11
      {  TypeDecor4,    "Geology/Pods"},      //12
      {  TypeThingSound,"Sounds"},            //13
      {  NULL          ,NULL }
   };

static  POPupList HexenThingList[] =
   {
      {  TypePlayer,    "Player Start/Special"},     //3
      {  TypeKeys,      "Keys"},              //4
      {  TypeBonus,     "Artifacts"},         //5
      {  TypePuzzle,    "Puzzle Items"},      //6
      {  TypeWeapon,    "Weapons"},           //7
      {  TypeSupplies,  "Health/Armor"},      //8
      {  TypeEnemy,     "Enemies"},           //9
      {  TypeDecor1,    "Gargoyle Statues"},  //10
      {  TypeDecor2,    "Lights/Columns"},    //11
      {  TypeDecor6,    "Bell/Pots/Mugs"},     //11
      {  TypeDecor3,    "Corpses/Blood"},        //12
      {  TypeDecor4,    "Fog/Stalac's/Icicles"}, //13
      {  TypeDecor5,    "Rocks/Moss"},           //14
      {  TypeDecor7,    "Trees/Mushrooms"},      //15
      {  TypeThingSound,"Sounds"},               //16
      {  NULL          ,NULL }
   };

static  POPupList StrifeThingList[] =
   {
      {  TypePlayer,    "Player Start/Special"}, //2   // redone   6-1-97
      {  TypeKeys,      "Keys"},                 //3
      {  TypeBonus,     "Equipment"},            //4
      {  TypeBonus2,    "EquipmentQuest"},       //5
      {  TypeWeapon,    "Weapons"},              //6
      {  TypeSupplies,  "Ammunition"},           //7
      {  TypeEnemy,     "Enemies"},              //8
      {  TypeEnemy2,     "EnemiesAlien"},        //9
      {  TypeRebel,     "Rebels"},               //10
      {  TypeBeggar ,   "Beggars"},              //11
      {  TypePeasant,   "Peasants"},             //12
      {  TypeShopKeeper,"ShopKeeper"},           //13
      {  TypeDecor1,    "Decorations"},          //14
      {  TypeDecor2,    "Light Sources"},        //15
      {  TypeDecor3,    "Corpses"},              //16
      {  TypeDecor4,    "Geology"},              //17
      {  TypeDecor5,    "Trees"},                //18
      {  TypeDecor6,    "Pillars"},              //19
      {  TypeThingSound,"hints "},               //20
      {  NULL          ,NULL }
   };

static  POPupList HexenSpawnThingList[] =
   {
      {  TypeKeys,       "Keys"},              //3
      {  TypeBonus,      "Artifacts"},         //4
      {  TypePuzzle,     "Puzzle Items"},      //5
      {  TypeWeapon,     "Weapons"},           //6
      {  TypeSupplies,   "Health/Armor"},      //7
      {  TypeEnemy,      "Enemies"},           //8
      {  TypeGlassRock,  "Glass/Rocks"}  ,     //9
      {  TypeProjectile, "Projectiles"}  ,     //10
      {  TypeMisc      , "Flame/Misc"},        //11
      {  NULL          ,NULL }
   };


//----------------------------------------------------------------------
// submenu list for LineDefs (both the same)
//---------------------------------------------------------------------

POPupList DoomLineDefList[] =
{                              //1234567890123456789012
      { TypeNA,            "&1   Normal (no menu)      ",   CM_LM1},   //1
      { TypeDoorKey,       "&2   Door (keys)           ",   CM_LM2},   //2
      { TypeDoorOpen,      "&3   Door (open)           ",   CM_LM3},   //3
      { TypeDoorClose,     "&4   Door (close)          ",   CM_LM4},   //4
      { TypeCeilings,      "&5   Ceilings              ",   CM_LM5},   //5
      { TypeCrushers,      "&6   Crushers              ",   CM_LM6},   //6
      { TypeFloorRaiseCeil,"&7   Floor RaiseCeiling    ",   CM_LM7},   //7
      { TypeFloorRaiseFlr, "&8   Floor RaiseFloor      ",   CM_LM8},   //8
      { TypeFloorLower   , "&9   Floor Lower           ",   CM_LM9},   //9
      { TypeStairs,        "&A   Stairs                ",   CM_LM10},  //10
      { TypeLifts,         "&B   Lifts & Moving        ",   CM_LM11},  //11
      { TypeLights,        "&C   Lights                ",   CM_LM12},  //12
      { TypeSpecial,       "&D   Teleport/End/Special  ",   CM_LM13},  //13
      { TypeSEPARATOR,     "separate",            0     },           //14  just a separator

      { TypeLDextension1,  "&E   xxOM Floors           ",   CM_LM14},  //15  --BOOM only 3-1-98
      { TypeLDextension2,  "&F   xxOM Ceilings         ",   CM_LM15},  //16  ..
      { TypeLDextension3,  "&G   xxOM Doors            ",   CM_LM16},  //17  ..
      { TypeLDextension4,  "&H   xxOM Locked Doors     ",   CM_LM17},  //18  ..
      { TypeLDextension5,  "&I   xxOM Lifts            ",   CM_LM18},  //19  ..
      { TypeLDextension6,  "&J   xxOM Stairs           ",   CM_LM19},  //20  ..
      { TypeLDextension7,  "&K   xxOM Crushers         ",   CM_LM20},  //21  ..
      { TypeLDextension8,  "&L   xxOM spare 1          ",   CM_LM21},  //22  Anyone not matching TypeSpare1
      { TypeLDextension9,  "&M   xxOM spare 2          ",   CM_LM22},  //23  Anyone not matching TypeSpare2
      { TypeNA,            "&N   xxOM LineDef Menu     ",   CM_LM23 }, //24
      { TypeSEPARATOR,     "separate",            0     },           //25 just a separator

      { TypeNA,            "&X   LineDef Type #",         CM_LM24 },  //26
      { TypeNA,            "&Y   Sector Tag   ",          CM_LM25 },  //27

      { NULL              ,NULL,                       NULL }
   };

POPupList MenuLineDefListHeretic[] =        // 3-1-98
   {
      { TypeDoorKey,       "DoorKey"},               //3
      { TypeDoorOpen,      "DoorOpen"},              //4
      { TypeDoorClose,     "DoorClose"},             //5
      { TypeCeilings,      "Ceilings"},              //6
      { TypeCrushers,      "Crushers"},              //7
      { TypeFloorRaiseCeil,"FloorRaiseCeil"},        //8
      { TypeFloorRaiseFlr, "FloorRaiseFlr"},         //9
      { TypeFloorLower   , "FloorLower"},            //10
      { TypeStairs,        "Stairs"},                //11
      { TypeLifts,         "Lifts & Moving"},        //12
      { TypeLights,        "Lights"},                //13
      { TypeSpecial,       "Teleport/End/Special"},  //14
      { NULL          ,NULL }
   };

POPupList MenuLineDefListStrife[] =
   {
      { TypeDoorKey,       "DoorKey"},               //3
      { TypeDoorQuest,     "DoorQuest"},             //4
      { TypeDoorOpen,      "DoorOpen"},              //5
      { TypeDoorClose,     "DoorClose"},             //6
      { TypeCeilings,      "Ceilings"},              //7
      { TypeCrushers,      "Crushers"},              //8
      { TypeFloorRaiseCeil,"FloorRaiseCeil"},        //9
      { TypeFloorRaiseFlr, "FloorRaiseFlr"},         //10
      { TypeFloorLower   , "FloorLower"},            //11
      { TypeStairs,        "Stairs"},                //12
      { TypeLifts,         "Lifts & Moving"},        //13
      { TypeLights,        "Lights"},                //14
      { TypeSpecial,       "Teleport/End/Special"},  //15
      { NULL          ,NULL }
   };

POPupList MenuLineDefListHexen[] =
   {
      { TypeDOOR,          "All Doors"},             //3
      { TypeCeilings,      "Ceilings"},              //4
      { TypeCrushers,      "Crushers"},              //5
      { TypeFloorRaiseFlr ,"Floors Raise"},          //6
      { TypeFloorLower,    "Floors Lower"},          //7
      { TypeStairs       , "Stairs"},                //8
      { TypeLifts ,        "Lifts & Pillars"},       //9
      { TypeLights,        "Lights"},                //10
      { TypeSpecial,       "Teleport/End/Special"},  //11
      { TypePOLY,          "Poly Objects"},          //12
      { TypeLINETHING,     "Things"},                //13
      { TypeSCRIPTS,       "Scripts"},               //14
      { NULL          ,NULL }
   };

//----------------------------------------------------------------------
// submenu list for Sectors DOOM only for now
//---------------------------------------------------------------------

POPupList DoomSectorList[] =
   {                       //    1234567890123456789012
      { TypeNA,            "&1   None",                  CM_SEC1 }, // 1
      { TypeSectorLight,   "&2   Lights",                CM_SEC2 }, // 2
      { TypeHealth,        "&3   Health/Damage",         CM_SEC3 }, // 3
      { TypeOther,         "&4   Secret/Other",          CM_SEC4 }, // 4
      { TypeSPARE1,        "&5   xxnew Sector Types    ",CM_SEC5 }, // 5 xx is required to not activate
      { TypeNA,            "&6   xxOM Sector Types     ",CM_SEC7 }, // 6 xx is required to not activate
      { TypeSEPARATOR,     "separate",                       0 },   // 7
      { TypeNA,            "&7   Sector Type #  ",       CM_SEC6 }, // 8
      { NULL              ,NULL,              NULL }
 };



////////////////////////////////////////////////////////////////////////////////
//                                                     		                  //
//  The Deep EDIT Dialog Procedures , Enter on 					                  //
//	 Right Click or ENTER KEY											                  //
//									                                	                  //
//  Handles Sector Edit with preview of Floor & Ceiling Txtr                  //
//  and Line Edit with Preview of the 3 textures 				                  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


//
//   Update Height info from our 3 routines
//
static void UpdateHeights(HWND hwnd, SelPtr cur, int2 fh, int2 ch, int2 num)
{
  SelPtr list;
  char    msg1[80];
  char    msg2[80];

  LevelPtr level = &LevelWad.level;

  if(fh > ch)							// if floor is > ceiling
  {
      sprintf(msg1,"Ceiling Height= %hd",ch);
      sprintf(msg2,"Floor Height= %hd",fh);

      if  (HelpMsg(hwnd,CENTER|HELPYESNO, "Floor > ceiling",
                   msg1,  //"Ceiling Height 222",
                   "is less than the",
                   msg2,  //"Floor Height",
                   "",
                   "Ignore values ?",
                   "",
                   "(Reply N to accept values)",
                   NULL) )
      {
           return;
      }
  }

  // do it anyway

  if(num == 3)
  {  for (list=cur; list; list = list->next)
     {
           if(level->Sectors[ list->objnum].ceilh  != ch) //   3-1-97
           {  level->Sectors[ list->objnum].ceilh  = ch;
          	  level->MadeChanges++;
           }
   	     if(level->Sectors[ list->objnum].floorh != fh) //   3-1-97
   	     {  level->Sectors[ list->objnum].floorh = fh;
          	  level->MadeChanges++;
           }
     }
  }
  else
  if(num == 1)
  {  for (list=cur; list; list = list->next)
     {
           if(level->Sectors[ list->objnum].ceilh  != ch) //   3-1-97
           {  level->Sectors[ list->objnum].ceilh  = ch;
          	  level->MadeChanges++;
           }
        }
  }
  else
  {  for (list=cur; list; list = list->next)
     {
   	    if(level->Sectors[ list->objnum].floorh != fh) //   3-1-97
   	    {  level->Sectors[ list->objnum].floorh = fh;
             level->MadeChanges++;
          }
     }
  }

  if(EditMode == OBJ_SECTORS)
  {  UpdateObjectInfo(gd.hMainWindow, cur->objnum);  // Calls DisplayObjectInfo
     StatBarUpdate9();                               // level->MadeChanges
  }

}


//------------------------------------------------------------------------------
//
// process ceiling/floor height INCREMENT all by a fixed amount
//
//------------------------------------------------------------------------------
//                                      1=ceiling 2 = floor, 3 = both
#pragma argsused // no hwnd yet

static void IncrementUpdateHeights(HWND hwnd, int2 heightcmd, int2 direction, SelPtr cur)
{
   SelPtr   list;
   LevelPtr level = &LevelWad.level;
   int2     heightvalue = direction * DefaultHeightChange;

	 for (list = cur; list; list = list->next)
	 {
	      if (heightcmd == 1 || heightcmd == 3)  // ceiling
	      {   level->Sectors[ list->objnum].ceilh += heightvalue;
	      }
	      if (heightcmd == 2 || heightcmd == 3)  // floor
	      {   level->Sectors[ list->objnum].floorh += heightvalue;
	      }
	      level->MadeChanges++;
	 }

    UpdateObjectInfo(gd.hMainWindow, cur->objnum);  // Calls DisplayObjectInfo
    StatBarUpdate9();                               // level->MadeChanges
}

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//	Change the Ceiling & Floor Height for the current Sector                   //
// num       = 3 Both, 1 Ceil, 2 Flr, cur is a TempList                       //
// count     = number of sectors being changed                                //
// fromDlg   = TRUE called from Dialog, False from HotKey eg Shift-C, Shift F //
// direction = Direction to change the height in if Shift-PgUp, Shift-Home etc//
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

void ChangeSectorHeight(HWND hwnd, int2 num, SelPtr cur, int2 count, Bool fromDlg, int2 direction)
{
  LevelPtr  level = &LevelWad.level;
  char heading[32] = {0};

  static int2 ch;							// Ceiling Height
  static int2 fh;							// Floor Height
  char p1[24] = {0};
  char p2[24] = {0};

   ch = level->Sectors[cur->objnum].ceilh;   // Backup so don't have to compare to
   fh = level->Sectors[cur->objnum].floorh;  // transfer back later, just copy BOTH

 // if called from Shift-C, Shift-f, Shift-H, or Dialog
 if(!direction)
 {
	 if(num == 3)
    {  strcpy( p1, "Ceiling Height");         // our 2 prompts
		 strcpy( p2, "Floor   Height");
       strcpy( heading, "Ceiling/Floor Height");
    }
	 else if(num == 1)	strcpy( heading, "New Ceiling Height");
	 else if(num == 2)	strcpy( heading, "New Floor Height");

    if(num == 3)
    {  if (Input2Numbers(hwnd, heading, p1, p2, -32000, 32000, &ch, -32000, 32000, &fh))
		 {   UpdateHeights(hwnd, cur, fh, ch, num);
       }
    }
    else
    if (num == 1)                         // Ceiling Height
    {  if (InputNumbers(hwnd, heading, -32000, 32000, &ch, PointerX, PointerY))
    	 {   UpdateHeights(hwnd, cur, fh, ch, num);
       }
    }
    else
    if(num == 2)                          // Floor Height
    {  if (InputNumbers(hwnd, heading, -32000, 32000, &fh, PointerX, PointerY))
	    {   UpdateHeights(hwnd, cur, fh, ch, num);
       }
    }

    if(fromDlg)
    {
      // Update our Push Button Text 5,6,7 & the Heading

      sprintf( p1, "  &5.   %hd , %hd", level->Sectors[ cur->objnum].ceilh,
                                        level->Sectors[ cur->objnum].floorh);
      Static_SetText(GetDlgItem(hwnd, psh5), p1 );

      sprintf( p1, "  &6.   %d", level->Sectors[ cur->objnum].ceilh);
      Static_SetText(GetDlgItem(hwnd, psh6), p1 );

      sprintf( p1, "  &7.   %d", level->Sectors[ cur->objnum].floorh);
      Static_SetText(GetDlgItem(hwnd, psh7), p1 );

      if (count > 1)
      {  sprintf( heading, "Edit %hd Sectors (height=%hd)", count, (level->Sectors[ cur->objnum].ceilh -level->Sectors[ cur->objnum].floorh ));
      }
      else
      {  sprintf( heading, "Edit Sector (height=%hd)", (level->Sectors[ cur->objnum].ceilh -level->Sectors[ cur->objnum].floorh ));
      }
      Static_SetText(GetDlgItem(hwnd, IDD_ST), heading);
    }
 }     // if not Shift-PgUp, Shift-Home etc.
 else
 //
 // Shift-PgUp,PgDn,Home,End
 // Shift-cursor up/down
 //
 {
    IncrementUpdateHeights(hwnd, num,direction, cur);    //   8-1-97 wrong routine used
 }

}


//////////////////////////////////////////////////////////////////////////////
//  The Deep Edit Sector Dialog - from Right Button Up in Sector Mode
//////////////////////////////////////////////////////////////////////////////
static HWND hEditSectorDlg;

#pragma argsused
BOOL CALLBACK EditSectorDlgProc(DIALOG_PARAMS)
{
 LPDLGSELECT lpsel;	    // Our Long Pointer to Dialog Input Struct
 DLG2OPTS    d2;
 ZeroMemory(&d2, sizeof(d2));

 static   int2 light;      // sector light level
// static   int2 ceilh;      // sector ceiling
// static   int2 floorh;     // sector floor
//tatic   int2 special;
 static   uint2 tag;           // sector tag

 char     szTagTxt[32];        // formatted prompt for input tag
 char     Heading [36];        // Heading for the Dialog
 char     szTxtr  [9]   ={0};  // Pass our Floor/Ceiling Txtr to choose
 char     szPshTxt[20] = {0};
 static   char szCeilTxtr [9]={0};
 static   char szFloorTxtr[9]={0};
 SelPtr   objlist;
 LevelPtr level = &LevelWad.level;
 int2     Height, SectorCommand;
 RECT     rc;
//static int4 x,y;         // save Cursor Position since BROWSE screws it up !
 static int2 ObjectCount;  // How many Sectors to change

 // -doom sector menu ----
 uint4  Doom1Type   = TypeSectorLight;
 uint4  Doom2Type   = TypeHealth;
 uint4  Doom3Type   = TypeOther;
 uint4  DoomSPARE   = TypeSPARE1;
 // -heretic sector menu -
 uint4  Heretic1Type= TypeDamage;
 uint4  Heretic2Type= TypeScroll;
 uint4  Heretic3Type= TypeWind;
 // -hexen \sector menu ---
 uint4  Hexen1Type  = TypeDamage;
 uint4  Hexen2Type  = TypeStair;
 uint4  Hexen3Type  = TypeScroll;
 // -strife sector menu ----
 uint4  Strife1Type = TypeDamage;
 uint4  Strife2Type = TypeHealth;
 uint4  Strife3Type = TypeScroll;

static POINT EntryCurPos;       //   12-16-96
       POINT PriorCurPos;       //   12-2-96


//--------------------------------------------------------------------------


     if (GameVersion == 3) // HERETIC
     {   Doom1Type = Heretic1Type;
         Doom2Type = Heretic2Type;
         Doom3Type = Heretic3Type;
     }
     if (GameVersion == 4) // HEXEN
     {   Doom1Type = Hexen1Type;
         Doom2Type = Hexen2Type;
         Doom3Type = Hexen3Type;
     }
     if (GameVersion == 5) // STRIFE
     {   Doom1Type = Strife1Type;
         Doom2Type = Strife2Type;
         Doom3Type = Strife3Type;
     }

/////////////////////////////////////////////////////////////////////////////
  GetCursorPos( &PriorCurPos );         //   12-16-96 remember location
  //Trace(NULL,100,4,"secmsg %d",msg);
  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    default:
      break;
    case WM_INITDIALOG:
      hEditSectorDlg = hDlg;

      GetCursorPos( &EntryCurPos );         //   12-16-96 remember location

	   SetWindowLong(hDlg, DWL_USER, lParam);// store our Pointer

      lpsel = (LPDLGSELECT)lParam;			  // grab it for our use

      ZeroMemory(&d2, sizeof(d2));          // For passing to SectorPrev our
                                            // Texture Names, Location of dlg etc.
      ObjectCount = 0;

      ForgetSelection( &TempList);            // safety

      if  (SelectList)
      {    TempList = SelectList;
      }
      else
      {   if (CurObject >= 0)
          {   SelectObject( &TempList, CurObject);
          }
          else
          {   EndDialog( hDlg, FALSE );
              return FALSE; // No current object, no SelectList
          }
      }
      gd.DestroyModeless=TRUE;

      for (objlist=TempList; objlist; objlist=objlist->next)
           ObjectCount++;

      SectorType = level->Sectors[ TempList->objnum].special;  // initialize current value
      OldType    = SectorType;                                 // and our global menu select old type

      Height = int2(level->Sectors[ TempList->objnum].ceilh -level->Sectors[ TempList->objnum].floorh );

      if (ObjectCount > 1)
      {  sprintf( Heading, "Sector %hd (height=%hd) %hd Sectors ",TempList->objnum, Height,ObjectCount);
      }
      else
      {  sprintf( Heading, "Sector %hd (height=%hd)",TempList->objnum,Height);
      }

      Static_SetText(GetDlgItem(hDlg, IDD_ST), Heading);

      GetWindowRect(hDlg, &rc);
      MoveWindow(hDlg, pSectDlgPos.x,      pSectDlgPos.y,
                       rc.right - rc.left, rc.bottom - rc.top, FALSE);
      GetWindowRect(hDlg, &rc);

      // set coordinates for submenus   12-2-96

      rcSectorMenu.left = rc.left;
      rcSectorMenu.top  = rc.top;

      // Initialize our Sector Preview Modeless Dialog
      strncpy(d2.sz1, level->Sectors[CurObject].ceilt,  8);
      strncpy(d2.sz2, level->Sectors[CurObject].floort, 8);

      strncpy(szCeilTxtr,  level->Sectors[CurObject].ceilt,  8);
      strncpy(szFloorTxtr, level->Sectors[CurObject].floort, 8);

      d2.i1 = rc.left;            // x position for positioning Sector Prev
      d2.i2 = rc.top;             // y position
      d2.i3 = rc.right-rc.left;   // our width  here   12-16-96
      d2.i4 = rc.bottom-rc.top;   // our height here   12-16-96

      Static_SetText(GetDlgItem(hDlg, IDD_ST), Heading);

      if (DecimalTypes)
      {   sprintf( szPshTxt, "  &1.   %hu",level->Sectors[ TempList->objnum].special);
      }
      else
      {   sprintf( szPshTxt, "  &1.   %04X",level->Sectors[ TempList->objnum].special);
      }

      Static_SetText(GetDlgItem(hDlg, psh1), szPshTxt );

      sprintf( szPshTxt, "  &2.   %s", szCeilTxtr);
      Static_SetText(GetDlgItem(hDlg, psh2), szPshTxt);

      sprintf( szPshTxt, "  &3.   %s", szFloorTxtr);
      Static_SetText(GetDlgItem(hDlg, psh3), szPshTxt);

      sprintf( szPshTxt, "  &4.   %hd ", level->Sectors[ TempList->objnum].light);
      Static_SetText(GetDlgItem(hDlg, psh4), szPshTxt);

      sprintf( szPshTxt, "  &5.   %hd , %hd", level->Sectors[ TempList->objnum].ceilh,
                                              level->Sectors[ TempList->objnum].floorh);

      Static_SetText(GetDlgItem(hDlg, psh5), szPshTxt );

      sprintf( szPshTxt, "  &6.   %hd ", level->Sectors[ TempList->objnum].ceilh);
      Static_SetText(GetDlgItem(hDlg, psh6), szPshTxt );

      sprintf( szPshTxt, "  &7.   %hd ", level->Sectors[ TempList->objnum].floorh);
      Static_SetText(GetDlgItem(hDlg, psh7), szPshTxt );

      sprintf( szPshTxt, "  &8.   %hd ", level->Sectors[ TempList->objnum].tag);
      Static_SetText(GetDlgItem(hDlg, psh8), szPshTxt );

      sprintf( szPshTxt, "  &e.   Clone");
      Static_SetText(GetDlgItem(hDlg, psh10), szPshTxt );

      if(!gd.hDlgModeless)
		{ 	 gd.hDlgModeless = CreateDialogParam(gd.hInst, (LPSTR)"SectorPrev",
         						                   hDlg, SectorPrevDlgProc, (LPARAM)(LPSTR)&d2);
      }

      if(hSect)
      {  SetFocus(GetDlgItem(hDlg, hSect));    // Restore last selection
         Button_SetStyle(GetDlgItem(hDlg, hSect), BS_DEFPUSHBUTTON, TRUE);
      }
      else
      {  SetFocus(GetDlgItem(hDlg, psh1));     // Default Push Button 1
         hSect = psh1;                         // Store for recall next time
         Button_SetStyle(GetDlgItem(hDlg, hSect), BS_DEFPUSHBUTTON, TRUE);
      }

      GetWindowRect(GetDlgItem(hDlg, hSect), &rc);

      SetCursorPos(rc.left + 66, rc.top + 8);  // positon in main menu

      if(lpsel->b2) // called from mouse click
      {  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(lpsel->post,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      }
      return FALSE;
    // not any more ->stop dialog if Right button up via OK post since this will still save settings
    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97
      break;
    //   6-1-97   ok 7-1-97
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

    case WM_COMMAND:

       SectorCommand = LOWORD(wParam);
       switch (SectorCommand)                                         // handle of the control
       {
          /////////////////////////////////////////////////
          //	Edit Sector T Y P E                       //
          /////////////////////////////////////////////////
         case psh1:
           if (DecimalTypes)
           {   sprintf( szPshTxt,"  &1.   %hu",level->Sectors[ TempList->objnum].special); //3-1-98
           }
           else
           {   sprintf( szPshTxt,"  &1.   %04X",level->Sectors[ TempList->objnum].special); //3-1-98
           }

           Static_SetText(GetDlgItem(hDlg, psh1), szPshTxt );

           HandleSectorTypeMenu(hDlg); // returns CM_SEC1 - CM_SEC...  via POPUPS
           hSect = psh1;
           break;

          /////////////////////////////////////////////////
          //	Edit Sector Ceiling Texture					//
          /////////////////////////////////////////////////
         case psh2:
           strncpy(szTxtr, level->Sectors[TempList->objnum].ceilt, 8);

	        GetNewFloorName(hDlg, szTxtr, "Choose New Ceiling");

	        if(szTxtr)
           {  for (objlist = TempList; objlist; objlist = objlist->next)
              {   if (strncmp(level->Sectors[objlist->objnum].ceilt, szTxtr, 8))   //   3-1-97
                  {   strncpy(level->Sectors[objlist->objnum].ceilt, szTxtr, 8);
               	    level->MadeChanges++;
                  }
              }

              sprintf( szPshTxt, "  &2.   %8s", szTxtr);
              Static_SetText(GetDlgItem(hDlg, psh2), szPshTxt);

              strncpy(PrevCeilName, szTxtr, 8);
              InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_SECTORPREVC), NULL, TRUE); // update texture ceiling
    	        //UpdateObjectInfo(gd.hMainWindow, TempList->objnum);
              //StatBarUpdate9();                                   //   3-1-97
           }

           hSect = psh2;
           break;

          /////////////////////////////////////////////////
          //	Edit Sector Floor Texture						//
          /////////////////////////////////////////////////
         case psh3:
           strncpy(szTxtr, level->Sectors[TempList->objnum].floort, 8);

	        GetNewFloorName(hDlg, szTxtr, "Choose New Floor");

	        if(szTxtr)
           {  for (objlist = TempList; objlist; objlist = objlist->next)
              {
                  if (strncmp(level->Sectors[objlist->objnum].floort, szTxtr, 8)) //   3-1-96
                  {   strncpy(level->Sectors[objlist->objnum].floort, szTxtr, 8);
               	    level->MadeChanges++;
                  }
              }

              sprintf( szPshTxt, "  &3.   %8s", szTxtr);
              Static_SetText(GetDlgItem(hDlg, psh3), szPshTxt);

              strncpy(PrevFloorName, szTxtr, 8);
              InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_SECTORPREVF), NULL, TRUE); // update texture floor
   	        //UpdateObjectInfo(gd.hMainWindow, TempList->objnum);
              //StatBarUpdate9();                                   //   3-1-97
            }

            hSect = psh3;
            break;

          /////////////////////////////////////////////////
          //	Edit Sector Light Level							//
          /////////////////////////////////////////////////
         case psh4:
           light = level->Sectors[TempList->objnum].light;

		     if (InputNumbers(hDlg, "New Light Level", 0, 255, &light, PointerX, PointerY) )
           {   for (objlist = TempList; objlist; objlist = objlist->next)
               {    if (level->Sectors[objlist->objnum].light != light)  //   3-1-97
                    {   level->Sectors[objlist->objnum].light = light;
               	      level->MadeChanges++;
                    }
               }

   	         //UpdateObjectInfo(gd.hMainWindow, TempList->objnum); // change bottom information
               //StatBarUpdate9();                                   //   3-1-97
               sprintf( szPshTxt, "  &4.   %hd", level->Sectors[ TempList->objnum].light);
               Static_SetText(GetDlgItem(hDlg, psh4), szPshTxt);
           }
           hSect = psh4;
           break;

          /////////////////////////////////////////////////
          //	Edit Sector Ceiling & Floor Height        //
          /////////////////////////////////////////////////
         case psh5:
	        ChangeSectorHeight(hDlg, 3, TempList, ObjectCount, TRUE, 0); // num = 3 Both, 1 Ceil, 2 Flr
           hSect = psh5;
           break;
         case psh6:
           ChangeSectorHeight(hDlg, 1, TempList, ObjectCount, TRUE, 0); // num = 3 Both, 1 Ceil, 2 Flr
           hSect = psh6;
           break;
         case psh7:
           ChangeSectorHeight(hDlg, 2, TempList, ObjectCount, TRUE, 0); // num = 3 Both, 1 Ceil, 2 Flr
           hSect = psh7;
           break;

          /////////////////////////////////////////////////
          //	Edit Sector TAG                           //
          /////////////////////////////////////////////////
         case psh8:
	        sprintf( szTagTxt, "Free=%hd, Last=%hd",FindFreeTag(),LastTagUsed );

           tag = level->Sectors[TempList->objnum].tag;
                                               //9999
		     if (InputNumbers(hDlg, szTagTxt, 0, 32767, &(int2)tag, PointerX, PointerY) )  //   8-1-97
           {   for (objlist = TempList; objlist; objlist = objlist->next)
               {   if (level->Sectors[objlist->objnum].tag != tag)   //   3-1-97
                   {   level->Sectors[objlist->objnum].tag = tag;
               	     level->MadeChanges++;
                   }
               }

   	         //UpdateObjectInfo(gd.hMainWindow, TempList->objnum);
               //StatBarUpdate9();                                   //   3-1-97
               if (tag) LastTagUsed = tag;                         //   8-1-97 only > 0

               sprintf( szPshTxt, "  &8.   %hd", level->Sectors[ TempList->objnum].tag);
               Static_SetText(GetDlgItem(hDlg, psh8), szPshTxt );
           }
           hSect = psh8;
           break;

         /////////////////////////////////////////////////
         // clone sector to all other sectors selected   /
         /////////////////////////////////////////////////
        case psh10:
          hLine = psh10;
          if (ObjectCount > 1)
          {
              CloneObject(hDlg,TempList);
          }
          break;

         ////////////////////////////////////////////////////////////////////////
         //         Sector Type return menus                                   //
         ////////////////////////////////////////////////////////////////////////
        case CM_SEC1:                    // Normal
           for (objlist = TempList; objlist; objlist = objlist->next)
           {   if  (level->Sectors[objlist->objnum].special != 0)  //   3-1-97
               {    level->Sectors[objlist->objnum].special  = 0;
                    level->MadeChanges++;                          //   3-1-97
               }
           }

           OldType = 0;
           sprintf( szPshTxt,"  &1.   %hd", 0);
           Static_SetText(GetDlgItem(hDlg, psh1), szPshTxt );
           break;
        case CM_SEC2:
           DisplaySectorTypeMenu(hDlg, rcSectorMenu.left+44, rcSectorMenu.top+4, TempList->objnum, Doom1Type); //TypeSectorLight
           break;
        case CM_SEC3:
           DisplaySectorTypeMenu(hDlg, rcSectorMenu.left+44, rcSectorMenu.top+4, TempList->objnum, Doom2Type); //TypeHealth
           break;
        case CM_SEC4:
           DisplaySectorTypeMenu(hDlg, rcSectorMenu.left+44, rcSectorMenu.top+4, TempList->objnum, Doom3Type); //TypeOther
           break;
        case CM_SEC5:   //BOOM extras
           DisplaySectorTypeMenu(hDlg, rcSectorMenu.left+44, rcSectorMenu.top+4, TempList->objnum, DoomSPARE); //TypeHealth
           break;
        case CM_SEC7:   // BOOM special Sector
        case CM_SEC6:   // enter type manually
           SectorType = level->Sectors[ TempList->objnum].special;       // 3-1-98 was wrong
           if (SectorCommand == CM_SEC7)
           {   InputBOOMSectorType(hDlg, "Sector Type",&SectorType, rcSectorMenu.left+44, rcSectorMenu.top+4);
           }
           else
           {   InputSectorType(hDlg, "Sector Type",   &SectorType, PointerX, PointerY);
           }
           
           if (DecimalTypes)
           {   sprintf( szPshTxt,"  &1.   %hu",SectorType);                    // 3-1-98
           }
           else
           {   sprintf( szPshTxt,"  &1.   %04X",SectorType);                   // 3-1-98
           }
           
           OldType = SectorType;                                           // and our global menu select old type

           Static_SetText(GetDlgItem(hDlg, psh1), szPshTxt );

           for (objlist = TempList; objlist; objlist = objlist->next)
           {   if  (level->Sectors[objlist->objnum].special != SectorType)//   3-1-98
               {    level->Sectors[objlist->objnum].special  = SectorType;//
                    level->MadeChanges++;                                 //   3-1-97
               }
           }
           break;


        // 32 odd menu selections get sent here from the Windows Menu code
        // Update the menuval2 & break out

        case CM_1:                     // 2001 from choosing sub menu above
        case CM_2:
        case CM_3:
        case CM_4:
        case CM_5:
        case CM_6:
        case CM_7:
        case CM_8:
        case CM_9:
        case CM_10:
        case CM_11:
        case CM_12:
        case CM_13:
        case CM_14:
        case CM_15:
        case CM_16:
        case CM_17:
        case CM_18:
        case CM_19:
        case CM_20:
        case CM_21:
        case CM_22:
        case CM_23:
        case CM_24:
        case CM_25:
        case CM_26:
        case CM_27:
        case CM_28:
        case CM_29:
        case CM_30:
        case CM_31:
        case CM_32:
        case CM_33:

           menuval2 = types[(SectorCommand - CM_1)]; // types must be global since initiated
           //check 3-1-97 if (menuval2 >= 0)              // from DisplaySectorTypeMenu real type
           {
               for (objlist = TempList; objlist; objlist = objlist->next)
               {   if  (level->Sectors[objlist->objnum].special != menuval2)  //   3-1-97
                   {    level->Sectors[objlist->objnum].special  = menuval2;
                        level->MadeChanges++;
                   }
               }
               OldType = menuval2;                                           // and our global menu select old type

   	         //UpdateObjectInfo(gd.hMainWindow, TempList->objnum);
               //StatBarUpdate9();                                        //   3-1-97

               if (DecimalTypes)
               {   sprintf( szPshTxt,"  &1.   %hu",(uint2)menuval2);    //3-1-98
               }
               else
               {   sprintf( szPshTxt,"  &1.   %04X",(uint2)menuval2);   //3-1-98
               }

               Static_SetText(GetDlgItem(hDlg, psh1), szPshTxt );
           }
           break;

         case IDCANCEL:                     // So, all Cancel buttons are id IDABORT
         case IDOK:
           GetWindowRect(hDlg, &rc);
           pSectDlgPos.x = rc.left;
           pSectDlgPos.y = rc.top;
           //NotifyMsg(NULL,"%d,%d  %d,%d",rc.left,rc.top,rc.right,rc.bottom);

           if (!SelectList)
           {   ForgetSelection( &TempList); // get rid of old list
           }
           else
           {   TempList = NULL;             // reset since this is Selectlist
           }

   	     if(gd.hDlgModeless)
           {  DestroyWindow(gd.hDlgModeless);
   		     gd.hDlgModeless = 0;
      	  }
           gd.DestroyModeless=FALSE;
           hEditSectorDlg = NULL;

           EndDialog( hDlg, TRUE );

           if (FixVideo
           ||  ShowRulers) RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  //  3-1-97 fix driver probs

           SetCursorPos(EntryCurPos.x, EntryCurPos.y);                      //   12-2-96
           return TRUE;
         //   12-20-96 -------this is not active yet
         case IDHELP:
           HelpOpened = WinHelp(hDlg, HelpName, HELP_KEY,
                               (DWORD)"Edit Sector - Type and Tag");// index name in help needs changing
           break;
       }

       if (TempList)
       {   UpdateObjectInfo(gd.hMainWindow, TempList->objnum);  //   3-1-97
           StatBarUpdate9();                                    //   3-1-97 level->MadeChanges status only in 1024
       }
       break;
  }

  SetCursorPos(PriorCurPos.x, PriorCurPos.y);                   //   12-2-96
  return FALSE;                                                 // should be TRUE for all handled
}


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  Called from below to do the actual work of Deleting  SideDefs             //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
//revised   6-1-97 only does deletes now
//revised   7-1-97 for packed sidedef problems

//void DelSide(HWND hwnd, int2 menuwrk, int2 side, SelPtr objlist, int2 sd)
void DelSide(HWND hwnd, int2 side, SelPtr objlist)
{
LDPtr    TempLineDef;
LDPtr    CurrentLineDef;
SelPtr   cur;
LevelPtr level = &LevelWad.level;
int4     hits, n;
int2     sd;

   // if delete, make sure no one else is using this sidedef

   CheckPointLevel(UndoBuffer, level);    // ------ CHECKPOINT ---

    for (cur = objlist; cur; cur = cur->next)
    {
        CurrentLineDef = &level->LineDefs[cur->objnum];

        if (side == 1)
        {   sd = CurrentLineDef->sidedef1;
        }
        else
        {   sd = CurrentLineDef->sidedef2;
        }

        hits = 0;

	     if ( sd >=0 )                                            // Not -1
        {
            TempLineDef = level->LineDefs;

            for (n = 0; n < level->NumLineDefs; n++, TempLineDef+=1)
            {    if (n ==cur->objnum) continue;                  // not self 7-1-97
	              if (TempLineDef->sidedef1 == sd) hits++;        // yes, a linedef is using
	              if (TempLineDef->sidedef2 == sd) hits++;        // this sidedef
	         }

            if (side == 1)
            {   //level->LineDefs[cur->objnum].sidedef1 = -1;   // delete
                CurrentLineDef->sidedef1 = -1;
                Static_SetText(GetDlgItem(hwnd, psh3), "     -1" );
                Static_SetText(GetDlgItem(hwnd, stc1), "Add SideDef 1" );
            }
            else
            //if (side == 2)
            {   //level->LineDefs[cur->objnum].sidedef2 = -1;   // delete
                CurrentLineDef->sidedef2 = -1;
                Static_SetText(GetDlgItem(hwnd, psh4), "     -1" );
                Static_SetText(GetDlgItem(hwnd, stc2), "Add SideDef 2" );
            }

            // in all case mark linedef as 1-sided and impassible    7-1-97

            level->MadeMapChanges = TRUE;
            level->MadeChanges++;

            CurrentLineDef->flags &=0xfffB;             // make 1-sided    (not 0x0004)
            CurrentLineDef->flags |=0x0001;             // make impassible
            // if not used anywhere else, ok to delete

	         if (!hits)
            {
                 DeleteObject(level, OBJ_SIDEDEFS, sd);
            }
            //else  //   7-1-97 went overboard here, forgot
            //{    NotifyMsg(NULL,"SideDef %hd used in multiple LineDefs\nDelete ignored",sd);
            //}
        }
    }

    UpdateObjectInfo(gd.hMainWindow, TempList->objnum);
    StatBarUpdate9();                                                //   3-1-97
}


///////////////////////////////////////////////////////////////////////
//																							//
//  The Deep Edit Line Def Dialog 												//
//																							//
//	 Called from ENTER KEY or RButtonUp when editing in LineMode		//
//																							//
//  Calls the EditSideDefDlgProc if so required, 							//
//  Uses lpsel->sel for SelectList or lpsel->obj for CurObject			//
//                                                                   //
//  1-25-97 bk  grab this whole routine - modified mostly HEXEN      //
//																							//
///////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK EditLineDefDlgProc(DIALOG_PARAMS)
{

LPDLGSELECT lpsel;                         //Our Long Pointer to DlgSelectList

int2     test1;
uint2    flags;
int2     n;
int2     LineDefCommand;
int2     menuwrk;
int2     newtype;
uint2    wrkflag;
LevelPtr level = &LevelWad.level;

static   int2 sd1, sd2;                     //   12-2-96
static   int2 HxMode;                       // Don't ask; its been a rough day

SelPtr   objlist, sel;                      // local to find how many selected
int2     ObjectCount;

RECT     rc;                                // store coord's for SetCursorPos
RECT     rcRelative;                        // store coord's for SetCursorPos

char     msg1[40];
char     msg2[40];
char     szText[64] = {0};                  // all around buffer

static   POINT EntryCurPos;                 //   12-16-96
         POINT PriorCurPos;                 //   12-2-96

TypeThingPtr  OldThingNames ;               // For saving Hexen Spawn Names

//===========================================================================

 GetCursorPos( &PriorCurPos );          //   12-16-96

 ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97
  // This is main linedef menu

//Trace(NULL,100,4,"linemsg %d",msg);

  switch( msg )
  {
    default:
      break;
    case WM_INITDIALOG:
      menuval2 = -1;                         // init to NOT a linedef type
      GetCursorPos( &EntryCurPos );          //   12-16-96

      SetWindowLong(hDlg, DWL_USER, lParam); // store our Pointer

      lpsel = (LPDLGSELECT)lParam;           // grab it for our use

      ObjectCount = 0;

      ForgetSelection( &TempList);            // safety

      if (SelectList)
      {   TempList = SelectList;
      }
      else
      {  if(CurObject >= 0)
         {  SelectObject( &TempList, CurObject);
         }
         else
         {  EndDialog( hDlg, FALSE );
            return FALSE; // No current object, no SelectList
         }
      }

      for (objlist=TempList; objlist; objlist=objlist->next)
          ObjectCount++;


      LineType = level->LineDefs[ TempList->objnum].type;  // type
      OldType  = level->LineDefs[ TempList->objnum].type;  // type
      flags    = level->LineDefs[ TempList->objnum].flags; // flags
      larg[0]  = level->LineDefs[ TempList->objnum].tag ;  // arg1
      larg[1]  = level->LineDefs[ TempList->objnum].arg2;  //    2
      larg[2]  = level->LineDefs[ TempList->objnum].arg3;  //    3
      larg[3]  = level->LineDefs[ TempList->objnum].arg4;  //    4
      larg[4]  = level->LineDefs[ TempList->objnum].arg5;  //    5

      sd1 = level->LineDefs[ TempList->objnum].sidedef1;
      sd2 = level->LineDefs[ TempList->objnum].sidedef2;

      special = -1;

      if (ObjectCount > 1)
      {   sprintf(szText,"LineDef %hd (%hd LineDefs)",TempList->objnum,ObjectCount);//ObjectCount,TempList->objnum );
      }
      else
      {   sprintf(szText,"LineDef %hd",TempList->objnum );
      }

      // Our Caption Bar
      Static_SetText(GetDlgItem(hDlg, IDD_ST), szText ); // editing 1 or more ?

      // 9 Buttons, psh1 - psh9
      sprintf( szText,"  &1.   %04X", flags);
      Static_SetText(GetDlgItem(hDlg, psh1), szText );

      if (DecimalTypes)
      {   sprintf( szText,"  &2.   %hu", LineType);          //3-1-98
      }
      else
      {   sprintf( szText,"  &2.   %04X", LineType);          //3-1-98
      }

      Static_SetText(GetDlgItem(hDlg, psh2), szText );

      if (sd1 >=0)
      {   sprintf( szText,"  &3.   %hd", sd1);
          Static_SetText(GetDlgItem(hDlg, psh3), szText );
          Static_SetText(GetDlgItem(hDlg, stc1), "Edit SideDef 1" );
      }
      else
      {   Static_SetText(GetDlgItem(hDlg, psh3), "     -1" );
          Static_SetText(GetDlgItem(hDlg, stc1), "Add SideDef 1" );
      }

      if (sd2 >=0)
      {   sprintf( szText,"  &4.   %hd", sd2);
          Static_SetText(GetDlgItem(hDlg, psh4), szText );
          Static_SetText(GetDlgItem(hDlg, stc2), "Edit SideDef 2" );
      }
      else
      {   Static_SetText(GetDlgItem(hDlg, psh4), "     -1" );
          Static_SetText(GetDlgItem(hDlg, stc2), "Add SideDef 2" );
      }

      Static_SetText(GetDlgItem(hDlg, psh5), "  &5.   Side1    " );
      Static_SetText(GetDlgItem(hDlg, psh6), "  &6.   Side2    " );

      Static_SetText(GetDlgItem(hDlg, psh7), "  &7.   Delete" );
      Static_SetText(GetDlgItem(hDlg, psh8), "  &8.   Delete" );

      sprintf( szText,"Del: %hd", sd1);
      sprintf( szText,"Del: %hd", sd2);

      //larg[3]  = level->LineDefs[ TempList->objnum].arg4;  //    4

      if (GameVersion == 4)
      {
         Static_SetText(GetDlgItem(hDlg, psh9), "  &9.   E d i t" );
         Static_SetText(GetDlgItem(hDlg, stc3), "All HEXEN Args" );
         SetLineDefArgs  (LineType, larg[3]);                 // set argument names
         for (n=0; n < 5; n++)
         {   if (*argdesc[n] == '\0')
             {    sprintf(argdesc[n],"Arg%hd (na)",n+1);
             }
             sprintf( szText,"%-14.14s: %hd", argdesc[n],larg[n]); //??????
         }
      }
      else
      {   sprintf( szText,"  &9.   %hu", level->LineDefs[ TempList->objnum].tag); //3-1-98
          Static_SetText(GetDlgItem(hDlg, psh9), szText );
          Static_SetText(GetDlgItem(hDlg, stc3), "Sector Tag" );
      }

      if(hLine)
      {   SetFocus(GetDlgItem(hDlg, hLine));    // Restore last selection
          Button_SetStyle(GetDlgItem(hDlg, hLine), BS_DEFPUSHBUTTON, TRUE);
      }
      else
      {   SetFocus(GetDlgItem(hDlg, psh1));     // Default Push Button 1
          hLine = psh1;                         // Store for recall next time
          Button_SetStyle(GetDlgItem(hDlg, hLine), BS_DEFPUSHBUTTON, TRUE);
      }

      // move linedef menu box to last known position

      GetWindowRect(hDlg, &rc);
      MoveWindow(hDlg, pLineDlgPos.x, pLineDlgPos.y,  // restore to last position
                       rc.right  - rc.left+1,
                       rc.bottom - rc.top +1, FALSE); // +1   12-16-96

      // set coordinates for submenus             12-2-96 make it easier to tinker

      GetWindowRect(hDlg, &rcLineMenu);         //   12-16-96
      GetWindowRect(hDlg, &rcThingMenu);        //   3-1-97

      rcThingMenu.right = rcThingMenu.left;     // make it line up 3-1-97
      rcThingMenu.top  += 10;                   // make it line up 3-1-97

      // coordinates of line

      GetWindowRect(GetDlgItem(hDlg, hLine), &rcRelative);   //   12-2-96 was &rc

      SetCursorPos(rcRelative.left + 66, rcRelative.top + 8); //   12-2-96

      if(lpsel->b2) // called from mouse click
      {  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(lpsel->post,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      }
      return FALSE;

   case WM_RBUTTONUP:
      if(!PopupMenu)
      {   PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);  //   6-1-97 was OK
      }
      break;

   //   6-1-97
   case WM_LBUTTONUP:
      if (!PopupMenu)
      {   PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      }
      break;

  //=============================================
  // which linedefcommand button pushed
  //=============================================
  case WM_COMMAND:

     DLGSELECT selside;                   //To pass our SelectList to the SideDef
     ZeroMemory(&selside, sizeof(selside));

     LineDefCommand = LOWORD(wParam);

     switch(LineDefCommand)  						   // handle of the control
     {   // FLAGS
	      case psh1:
          selside.sel = TempList;
          DialogBoxParam(gd.hInst,"LineFlag", hDlg,LineFlagDlgProc,(LPARAM)(LPDLGSELECT)&selside);
          selside.sel = NULL;             // get rid of old list
          hLine = psh1;
          sprintf( szText,"  &1.   %04X", level->LineDefs[ TempList->objnum].flags);
          Static_SetText(GetDlgItem(hDlg, psh1), szText );
         break;
         // TYPE
	      case psh2:
          HxMode = 3;
		    HandleLineTypeMenu(hDlg, rcLineMenu.left+4  ,rcLineMenu.top+4);// Grabs the menu entries for the Current Game
          hLine = psh2;
          if (DecimalTypes)
          {   sprintf( szText,"  &2.   %hu", level->LineDefs[ TempList->objnum].type);  //3-1-98
          }
          else
          {   sprintf( szText,"  &2.   %04X", level->LineDefs[ TempList->objnum].type);  //3-1-98
          }

          Static_SetText(GetDlgItem(hDlg, psh2), szText );

          LineType = level->LineDefs[ TempList->objnum].type;   //   3-1-97 keep menu with new info
          OldType  = LineType;
          break;
        // Edit SideDef 1
        case psh3:
          selside.sel = TempList;
          selside.b1  = 0;	// SideDef 1
          DialogBoxParam(gd.hInst,"EditSideDef", hDlg,EditSideDefDlgProc,(LPARAM)(LPDLGSELECT)&selside);
          selside.sel = NULL;             // get rid of old list
          hLine = psh3;
          //   3-1-97 show any change
          if (level->LineDefs[ TempList->objnum].sidedef1 != sd1)
          {
              sd1 = level->LineDefs[ TempList->objnum].sidedef1;
              if (sd1 >=0)
              {   sprintf( szText,"  &3.   %hd", sd1);
                  Static_SetText(GetDlgItem(hDlg, psh3), szText );
                  Static_SetText(GetDlgItem(hDlg, stc1), "Edit SideDef 1" );
              }
              else
              {   Static_SetText(GetDlgItem(hDlg, psh3), "     -1" );
                  Static_SetText(GetDlgItem(hDlg, stc1), "Add SideDef 1" );
              }
          }
          break;
        // Edit SideDef 2
        case psh4:
          selside.sel = TempList;
          selside.b1  = 1;	// SideDef 2
          DialogBoxParam(gd.hInst,"EditSideDef", hDlg,EditSideDefDlgProc,(LPARAM)(LPDLGSELECT)&selside);
          selside.sel = NULL;             // get rid of old list
          hLine = psh4;
          //   3-1-97 show any change
          if (level->LineDefs[ TempList->objnum].sidedef2 != sd2)
          {
              sd2 = level->LineDefs[ TempList->objnum].sidedef2;
              if (sd2 >=0)
              {   sprintf( szText,"  &4.   %hd", sd2);
                  Static_SetText(GetDlgItem(hDlg, psh4), szText );
                  Static_SetText(GetDlgItem(hDlg, stc2), "Edit SideDef 2" );
              }
              else
              {   Static_SetText(GetDlgItem(hDlg, psh4), "     -1" );
                  Static_SetText(GetDlgItem(hDlg, stc2), "Add SideDef 2" );
              }

          }
          break;
        // Sidedef 1 Xref  (only change 1st one selected) revised   6-1-97
        case psh5:
          ///DelSide(hDlg, 0, 1, TempList,sd1);
          test1 =  InputObjectXRef(hDlg, OBJ_SIDEDEFS, FALSE, sd1, TempList);

          if(test1 >=0)
	       {  sd1 = test1;
             if (level->LineDefs[TempList->objnum].sidedef1 != test1)
             {   level->LineDefs[TempList->objnum].sidedef1 = test1;   // store new value
                 sprintf( szText,"  &3.   %hd", test1);
                 Static_SetText(GetDlgItem(hDlg, psh3), szText );
                 Static_SetText(GetDlgItem(hDlg, stc1), "Edit SideDef 1" );

                 level->MadeMapChanges = TRUE; // if a side was added
                 level->MadeChanges++;
            }
          }
          hLine = psh5;
	       break;
        // Sidedef 2 Xref  (only change 1st one selected) revised   6-1-97
        case psh6:
          //DelSide(hDlg, 0, 2, TempList,sd2);

          test1 =  InputObjectXRef(hDlg, OBJ_SIDEDEFS, FALSE, sd2, TempList);
          if(test1 >=0)
	       {  sd2 = test1;
             if (level->LineDefs[TempList->objnum].sidedef2 != test1)
             {   level->LineDefs[TempList->objnum].sidedef2 = test1 ;   // store new value
                 sprintf( szText,"  &3.   %hd", test1);
                 Static_SetText(GetDlgItem(hDlg, psh4), szText );
                 Static_SetText(GetDlgItem(hDlg, stc2), "Edit SideDef 2" );
                 
                 level->MadeMapChanges = TRUE; // if a side was added
                 level->MadeChanges++;
            }
          }
          hLine = psh6;
          break;
        // Delete Sidedef 1
        case psh7:
          DelSide(hDlg, 1, TempList);  //DelSide(hDlg, -1, 1, TempList,sd1);
          sd1 = -1;
          hLine = psh7;
          break;
        // Delete Sidedef 2
        case psh8:
          DelSide(hDlg, 2, TempList); //DelSide(hDlg, -1, 2, TempList,sd2);
          sd2 = -1;
          hLine = psh8;
          break;
        // Sector Tag / or Edit all Args
        case psh9:
          if (GameVersion != 4)
          {
    	       sprintf( szText, "Free=%hd, Last=%hd",FindFreeTag(),LastTagUsed );
                                          //9999
             if(InputNumbers(hDlg, szText, 0,32767, &larg[0], PointerX, PointerY)) // tag   8-1-97
	          {  if (larg[0]) LastTagUsed = larg[0];                                // only if > 0   8-1-97

	             for (sel = TempList; sel; sel = sel->next)
	             {
                   if(level->LineDefs[ sel->objnum].tag != larg[0])   //   3-1-97
                   {  level->LineDefs[ sel->objnum].tag = larg[0];
                      level->MadeChanges++;
                   }
	             }
                sprintf( szText,"  &9.   %hd", larg[0]);//LastTagUsed); 3-1-98
                Static_SetText(GetDlgItem(hDlg, psh9), szText );
 	             //UpdateObjectInfo(gd.hMainWindow, TempList->objnum);
                //StatBarUpdate9();                                   //   3-1-97
	          }
          }
          else
          {  selside.sel = TempList;
             DialogBoxParam( gd.hInst, "EditHexenArgs", hDlg, HexenArgsDlgProc,
                            (LPARAM)(LPDLG2OPTS)&selside );
             selside.sel = NULL;           // get rid of old list
          }
          hLine = psh9;
          break;

        case IDCANCEL:
        case IDOK:
          GetWindowRect(hDlg, &rc);             // save current position for next time
          pLineDlgPos.x = rc.left;
          pLineDlgPos.y = rc.top;

          // Removed redundant code here 1-25-97 bk
          // moved below to HXMODE = 2

          if (!SelectList)
          {   ForgetSelection( &TempList); // get rid of old list
          }
          else
          {   TempList = NULL;             // reset since this is Selectlist
          }

          EndDialog( hDlg, TRUE );

          if (FixVideo
          ||  ShowRulers) RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);  //  3-1-97 fix driver probs

          SetCursorPos(EntryCurPos.x, EntryCurPos.y);//   12-2-96
          return TRUE;

        //=====================================================================
        // commands from popup
        //=====================================================================
        // doom,2,heretic
        case CM_LM2:                    // Door (keys)
        case CM_LM3:                    // Door (open)
        case CM_LM4:                    // Door (close)
        case CM_LM5:                    // Ceilings
        case CM_LM6:                    // Crushers
        case CM_LM7:                    // Floor, raise c
        case CM_LM8:                    // Floor, raise f
        case CM_LM9:                    // Floor, lower
        case CM_LM10:                   // Stairs
        case CM_LM11:                   // Lifts
        case CM_LM12:                   // Lights
        case CM_LM13:                   // Teleport
        // extensions for BOOM
        case CM_LM14:                   // Floors
        case CM_LM15:                   // Ceilings
        case CM_LM16:                   // Doors
        case CM_LM17:                   // Locked Doors
        case CM_LM18:                   // Lifts
        case CM_LM19:                   // Stairs
        case CM_LM20:                   // Crushers
        case CM_LM21:                   // spare1s
        case CM_LM22:                   // spare2s

        // strife
        case CM_LMS2:                   // Door (keys)
        case CM_LMS3:                   // Door (Quest)
        case CM_LMS4:                   // Door (open)
        case CM_LMS5:                   // Door (close)
        case CM_LMS6:                   // Ceilings
        case CM_LMS7:                   // Crushers
        case CM_LMS8:                   // Floor, raise c
        case CM_LMS9:                   // Floor, raise f
        case CM_LMS10:                  // Floor, lower
        case CM_LMS11:                  // Stairs
        case CM_LMS12:                  // Lifts
        case CM_LMS13:                  // Lights
        case CM_LMS14:                  // Teleport
        // hexen
        case CM_LMHX2:                  // ALL Doors
        case CM_LMHX3:                  // Ceilings
        case CM_LMHX4:                  // Crushers
        case CM_LMHX5:                  // Floor raise
        case CM_LMHX6:                  // Floor lower
        case CM_LMHX7:                  // Stairs
        case CM_LMHX8:                  // Lifts
        case CM_LMHX9:                  // Lights
        case CM_LMHX10:                 // Teleport, end/
        case CM_LMHX11:                 // Poly Object
        case CM_LMHX12:                 // Thing Specials
        case CM_LMHX13:                 // Scripts
          HxMode = 2;                   //   3-1-97 always

          if (GameVersion == 4) // Hexen
          {
              DisplayLineDefTypeMenu(hDlg, rcLineMenu.left+4 ,rcLineMenu.top+4,
                                           TempList->objnum,
                                           TRUE,  MenuLineDefListHexen[LineDefCommand - CM_LMHX2].type);
          }
          else
          if (GameVersion == 5) // Strife
          {
              DisplayLineDefTypeMenu(hDlg, rcLineMenu.left+4 ,rcLineMenu.top+4,
                                           TempList->objnum,
                                           TRUE,  MenuLineDefListStrife[LineDefCommand - CM_LMS2].type);
          }
          else
          if (GameVersion == 3) // Heretic
          {
              DisplayLineDefTypeMenu(hDlg, rcLineMenu.left+4  ,rcLineMenu.top+4,
                                           TempList->objnum,
                                           TRUE,  MenuLineDefListHeretic[LineDefCommand - CM_LM2].type);
          }
          else                 // DOOM1/2
          {
              //DisplayLineDefTypeMenu(hDlg, rcLineMenu.left+4  ,rcLineMenu.top+4,
              //                             TempList->objnum,
              //                             TRUE,  DoomLineDefList[LineDefCommand - CM_LM2].type);
              DisplayLineDefTypeMenuX(hDlg, rcLineMenu.left+4  ,rcLineMenu.top+4, // 3-1-98 because new list has new entries
                                            TempList->objnum,
                                            TRUE,
                                            DoomLineDefList, LineDefCommand);      // match menu # to get type
          }
          break;

        case CM_LM1:                    // Normal  (reset)
        case CM_LMHX1:                  // Normal
          HxMode   = 3;
          menuval2 = 0;
          if (DecimalTypes)
          {   sprintf( szText,"  &2.   %hu", (uint2)menuval2); // 3-1-98
          }
          else
          {   sprintf( szText,"  &2.   %04X",(uint2) menuval2); // 3-1-98
          }

          Static_SetText(GetDlgItem(hDlg, psh2), szText );

          //   3-1-97
	       for (sel = TempList; sel; sel = sel->next)
          {
             if (level->LineDefs[ sel->objnum].type != 0  // type
              || level->LineDefs[ sel->objnum].tag  != 0  // arg1
              || level->LineDefs[ sel->objnum].arg2 != 0  // arg2
              || level->LineDefs[ sel->objnum].arg3 != 0  //    3
              || level->LineDefs[ sel->objnum].arg4 != 0  //    4
              || level->LineDefs[ sel->objnum].arg5 != 0)  //    5
             {   level->MadeChanges++;                    // 3-1-98
             }

             level->LineDefs[ sel->objnum].type = 0;  // type
             level->LineDefs[ sel->objnum].tag  = 0;  // arg1
             level->LineDefs[ sel->objnum].arg2 = 0;  // arg2
             level->LineDefs[ sel->objnum].arg3 = 0;  //    3
             level->LineDefs[ sel->objnum].arg4 = 0;  //    4
             level->LineDefs[ sel->objnum].arg5 = 0;  //    5
          }

          LineType = 0;                     //   3-1-97
          OldType =  0;
          break;

        // BOOM
        case CM_LM23:                   // Linedef type BOOM find out
        case CM_LM24:                   // Linedef type DOOM
        case CM_LMS15:                  // Linedef type STRIFE
        case CM_LMHX14:                 // Hexen
        case CM_LMH14:                  // Heretic
          menuval2 = level->LineDefs[ TempList->objnum].type;
          if (LineDefCommand != CM_LM23         // not BOOM
          ||  GameVersion > 2)          // not DOOM1/2
          {
              InputLineDefType    (hDlg, "LineDef Type",&(uint2)menuval2, PointerX, PointerY);
          }
          else                 // BOOM
          {
              InputBOOMLineDefType(hDlg, "LineDef Type",&(uint2)menuval2, PointerX, PointerY);
          }

          if (DecimalTypes)
          {   sprintf( szText,"  &2.   %hu", (uint2)menuval2); // 3-1-98
          }
          else
          {   sprintf( szText,"  &2.   %04X", (uint2)menuval2); // 3-1-98
          }

          Static_SetText(GetDlgItem(hDlg, psh2), szText );

          //   3-1-97
	       for (sel = TempList; sel; sel = sel->next)
          {  if (level->LineDefs[ sel->objnum].type!= menuval2)   // current value
             {   level->MadeChanges++;
                 level->LineDefs[ sel->objnum].type = menuval2;  // type
             }
          }

          LineType = (uint2)menuval2;              //   3-1-97
          OldType  = (uint2)menuval2;
          break;

        case CM_LM25:                   // Sector tag DOOM
        case CM_LMS16:                  // Sector tag STRIFE
        case CM_LMHX15:                 // Linedef Args Hexen (includes tag)
        case CM_LMH15:                  // Heretic
          if (GameVersion == 4)//      3         3-20
          {   //EditLineCommand(hDlg,level,obj); called from HxMode 1 below now

              HxMode = 1;

              lspecial = level->LineDefs[ TempList->objnum].type;  // special (linedef type)
              larg[0]  = level->LineDefs[ TempList->objnum].tag ;  // arg1
              larg[1]  = level->LineDefs[ TempList->objnum].arg2;  //    2
              larg[2]  = level->LineDefs[ TempList->objnum].arg3;  //    3
              larg[3]  = level->LineDefs[ TempList->objnum].arg4;  //    4
              larg[4]  = level->LineDefs[ TempList->objnum].arg5;  //    5

              SetLineDefArgs(lspecial, larg[3]);              // set arg names

              // edit linedef args if not a ThingSpawn

              if(ThingSpawnSpecial(hDlg, rcLineMenu.left+20,rcLineMenu.top+10, larg[1])  == -2)
              {
                 special  = -1;        // no spawn special else return above to HxMode 1 12-12-96 bk
                 menuval2 = OldType;
                 HxMode   = 3;

                 EditLineCommand(hDlg,level, TempList);
              }
              // else, will return to HxMode 1 below with proper spawn value
          }
          else
          {   menuwrk  = level->LineDefs[ TempList->objnum].tag;
    	        sprintf( msg1, "Tag (free %hd)",   FindFreeTag() );
	           sprintf( msg2, "Sector (last %hd)",LastTagUsed );
              menuwrk = Input1Number(hDlg, msg1, msg2,0,32767, menuwrk);//9999   8-1-97

              if (menuwrk)
	           {   LastTagUsed = menuwrk;
	               for (sel = TempList; sel; sel = sel->next)
	               {   if (level->LineDefs[ sel->objnum].tag != menuwrk)
                      {   level->LineDefs[ sel->objnum].tag = menuwrk;
         	              level->MadeChanges++;
                      }
	               }
	           }
          }
          break;

        // Spawn Menu H E X E N===============================

        case CM_SPAWN1:       //"None",                   // 2
          menuval2 = 0;
          break;

       case CM_SPAWN2:       //"Keys",                   // 3
       case CM_SPAWN3:       //"Artifacts",              // 4
       case CM_SPAWN4:       //"Puzzle Items",           // 5
       case CM_SPAWN5:       //"Weapons",                // 6
       case CM_SPAWN6:       //"Health/Armor",           // 7
       case CM_SPAWN7:       //"Enemies",                // 8
       case CM_SPAWN8:       //"Glass/Rocks",            // 9
       case CM_SPAWN9:       //"Projectiles"  ,          // 10
       case CM_SPAWN10:      //"Miscellaneous",          // 11
            //Trace(NULL,10,4,"val=%d",LineDefCommand - CM_SPAWN2);
            OldThingNames = ThingNames;             // save old name
            ThingNames = &HexenSpawnThingNames[0];  // switch to spawn names for FindWhichThing
	         DisplayThingsMenu(hDlg, HexenSpawnThingList[LineDefCommand - CM_SPAWN2].type);
            ThingNames = OldThingNames;             // restore save old name   3-1-97
            break;

        // 40 odd menu selections get sent here from the Windows Menu code
        // Update the thingmenuval & break out
        case CM_1:                     // 2001 from choosing sub menu above
        case CM_2:
        case CM_3:
        case CM_4:
        case CM_5:
        case CM_6:
        case CM_7:
        case CM_8:
        case CM_9:
        case CM_10:
        case CM_11:
        case CM_12:
        case CM_13:
        case CM_14:
        case CM_15:
        case CM_16:
        case CM_17:
        case CM_18:
        case CM_19:
        case CM_20:
        case CM_21:
        case CM_22:
        case CM_23:
        case CM_24:
        case CM_25:
        case CM_26:
        case CM_27:
        case CM_28:
        case CM_29:
        case CM_30:
        case CM_31:
        case CM_32:
        case CM_33:
            linemenuval = int2(LineDefCommand - CM_1); // a menu was chosen
            //Trace(NULL,10,4,"val=%hd",linemenuval);

            // After converting the case CM_1 - CM-41 to a proper 0 based number
            // check our various versions and update as neccessary
            // Most of this code is from EditThingCommand split up as required

            if(linemenuval >= 0)
            {
              if(HxMode == 1)                         // Called after ThingSpawnSpecial
              {
                special = ThingIds[linemenuval];      // return from ThingSpawnSpecial

                if(GameVersion == 4) // HEXEN
                {
                    EditLineCommand(hDlg, level, TempList);
                    //ThingNames =OldThingNames; // restore old name  ONLY from SpawnSpecial   3-1-97
                }
                HxMode = 3;
              }
              else
              if(HxMode == 2)    // Called from DisplayLineDefType Menu
              {
                 if ( GameVersion == 4 )               // HEXEN
                 {   ltag    = Ltag[linemenuval];
                     // larg[0] = Larg1[linemenuval];    TAG ???
                     larg[1] = Larg2[linemenuval];
                     larg[2] = Larg3[linemenuval];
                     larg[3] = Larg4[linemenuval];
                     larg[4] = Larg5[linemenuval];
                     lflag   = Lflag[linemenuval];

                     SetLineDefArgs(types[linemenuval],larg[3]);          // set arg names
                 }
                 else
                 {
                     lspecial = level->LineDefs[ TempList->objnum].type;  // special (linedef type)
                     larg[0]  = level->LineDefs[ TempList->objnum].tag ;  // arg1
                     larg[1]  = level->LineDefs[ TempList->objnum].arg2;  //    2
                     larg[2]  = level->LineDefs[ TempList->objnum].arg3;  //    3
                     larg[3]  = level->LineDefs[ TempList->objnum].arg4;  //    4
                     larg[4]  = level->LineDefs[ TempList->objnum].arg5;  //    5
                 }
                 // 1-25-97 bk

                 menuval2 = types[linemenuval];    // return from LineMenu here with the lineDef number created
                 lspecial = types[linemenuval];    // or thing special from built menu

                 SetLineDefArgs((uint2)menuval2, larg[3]);              // set arg names


                 // Code moved from above
                 // 1-25-97 bk

/// check 3-1-98 if (menuval2 >= 0)                    // valid line type menu selected
	              {  newtype = menuval2;

                    level->MadeChanges++;              //   11-11-96

	                 for (sel = TempList; sel; sel = sel->next)
                    {  OldType = level->LineDefs[ sel->objnum].type;   // current value
                       //if (OldType == menuval2) continue;              // 3-1-98
                       level->LineDefs[ sel->objnum].type = menuval2;  // new type
                       //level->MadeChanges++;                           //   3-1-98 can't do HEXEN keys

                       //----hexen---------- new
                       if (GameVersion == 4)
                       { // for keyed door stuff it
                         if (OldType == 13)
                         {   level->LineDefs[ sel->objnum].arg4 = larg[3]; // key value
                         }

                         if ( newtype != OldType)// type of linedef changed
                         {  level->LineDefs[ sel->objnum].arg2 = larg[1];  // arg2
                            level->LineDefs[ sel->objnum].arg3 = larg[2];  //    3
                            level->LineDefs[ sel->objnum].arg4 = larg[3];  //    4
                            level->LineDefs[ sel->objnum].arg5 = larg[4];  //    5

                            wrkflag = uint2(level->LineDefs[ sel->objnum].flags & 0xfe00);
                            if (wrkflag == 0)    // none set yet
                            {  wrkflag = lflag;
                               wrkflag = uint2(wrkflag << 8);
                               level->LineDefs[ sel->objnum].flags |= wrkflag;  //upper byte
                            }

                         }
                         else
                         {  if (newtype == 13)  // this is a door
                            {  level->LineDefs[ sel->objnum].arg4 = larg[3];  // key id arg4
                            }
                         }
                      }

                      // reset args if reset to -0-

                      if (newtype == 0 )  // -0- linedef
                      {
                         level->LineDefs[ sel->objnum].tag  = 0;  // arg1
                         level->LineDefs[ sel->objnum].arg2 = 0;  // arg2
                         level->LineDefs[ sel->objnum].arg3 = 0;  //    3
                         level->LineDefs[ sel->objnum].arg4 = 0;  //    4
                         level->LineDefs[ sel->objnum].arg5 = 0;  //    5
                      }
                    }

                    HxMode = 1;                 // loop through again for the Special

                    if(ThingSpawnSpecial(hDlg,rcLineMenu.left+20,rcLineMenu.top+10,larg[1]) == -2)
                    {
                       special = -1; // no spawn special else return above to HxMode 1-25-97 bk
                       HxMode  = 3;
                       if (GameVersion == 4 && newtype) // 12-12-96 bk Edit Line Args HERE
                       {    // select any args
                            EditLineCommand( hDlg, level, TempList);
                       }
                    }

                    if (DecimalTypes)
                    {   sprintf( szText,"  &2.   %hu", (uint2)menuval2);    //3-1-98
                    }
                    else
                    {   sprintf( szText,"  &2.   %04X", (uint2)menuval2);    //3-1-98
                    }

                    Static_SetText(GetDlgItem(hDlg, psh2), szText );
                    LineType = (uint2)menuval2;              //   3-1-97
                    OldType  = (uint2)menuval2;
	              }
              }     // hxmode = 1 or 2
            }       // end if(linemenuval >= 0 ) menu selection from linedef type
            break;

	  }     // end switch(LineDefCommand)

     if (TempList)
     {   UpdateObjectInfo(gd.hMainWindow, TempList->objnum);  //   3-1-97
         StatBarUpdate9();                                    //   3-1-97 level->MadeChanges status
     }
     break;
  }  // end switch(msg)


  SetCursorPos(PriorCurPos.x, PriorCurPos.y);//   12-2-96
  return FALSE;
}


///////////////////////////////////////////////////////////////////////
//																							//
//  The Deep Edit SideDef Dialog 												//
//																							//
//	 Called from our Line Edit Menu after right button or ENTER KEY	//
//  Opens the Line Edit Preview, then handles changing all attributes//
//	 for SideDef 1 or Side Def 2, depending on the status of d2.b1		//
//																							//
///////////////////////////////////////////////////////////////////////
static HWND hEditSideDefDlg;
#pragma argsused
BOOL CALLBACK EditSideDefDlgProc(DIALOG_PARAMS)
{
 LPDLGSELECT lpsel;                  //Our Long Pointer to DlgSelectList
 DLGSELECT   dsel;
 DLG2OPTS    d2;
 int2        test1;
 int4        ObjectCount;
 RECT        rc;
 int2        s1,s2;            // sector
 int2        sd,sd1,sd2;       // sidedef's
 int2        SideDefCommand;

 SelPtr objlist;

static int2   whichside;
static SelPtr sdlist = NULL;
static SelPtr cur    = NULL;

 int2 n;
 char 		szBuf[64] = {0};        // all around buffer

 LevelPtr level = &LevelWad.level;

static POINT EntryCurPos;             //   12-16-96
       POINT PriorCurPos;             //   12-2-96
       RECT  rcRelative;              // bdk 12-16-96
//===========================================================================

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  GetCursorPos( &PriorCurPos );          //   12-16-96

  switch( msg )
  {
    case WM_INITDIALOG:
     hEditSideDefDlg = hDlg;

     GetCursorPos( &EntryCurPos );                 //   12-16-96 remember location
     SetWindowLong(hDlg, DWL_USER, lParam);        // store our Pointer
     lpsel = (LPDLGSELECT)lParam;                  // grab it for our use

     cur   = lpsel->sel;                           // our selection list

     // Set our Heading Information

     sd1 = level->LineDefs[ cur->objnum].sidedef1;
     sd2 = level->LineDefs[ cur->objnum].sidedef2;

     if(lpsel->b1)
     {  //sprintf( szBuf, "SideDef2 # %hd", sd2);
        whichside = 2;
     }
     else
     {  //sprintf( szBuf, "SideDef1 # %hd", sd1);
        whichside = 1;
     }

     sprintf( szBuf, "SideDef%hd # %hd",whichside, sd1);
	  Static_SetText(GetDlgItem(hDlg, IDD_ST), szBuf);

     if (!lpsel->b1)  // edit 1st Sidedef
     { if (sd1 >= 0) // edit sidedef1
	    {  // build a new selection list with the first SideDefs
	       for (objlist=cur; objlist;  objlist=objlist->next)
	       {   if (level->LineDefs[ objlist->objnum].sidedef1 >= 0)
              {   SelectObject( &sdlist, level->LineDefs[ objlist->objnum].sidedef1);
              }
	       }
	    }
	    else
	    {  // Add a new first SideDef 1
	       for (objlist = cur; objlist; objlist = objlist->next)
	       {   if (level->LineDefs[ objlist->objnum].sidedef1 <= -1)
              {  InsertObject( level,OBJ_SIDEDEFS, -1, 0, 0);
		           level->LineDefs[ objlist->objnum].sidedef1 = int2(level->NumSideDefs - 1);
                 SelectObject( &sdlist, level->LineDefs[ objlist->objnum].sidedef1);  //addto list 10-30-94
              }
	       }
	     }
     }

     if (lpsel->b1==1)  // edit 2nd sidedef
     {
 	    if (sd2 >=0 )
	    {
	       // build a new selection list with the second SideDefs

	       for (objlist = cur; objlist; objlist = objlist->next)
	       {
              if (level->LineDefs[ objlist->objnum].sidedef2 >= 0)
              {   SelectObject( &sdlist, level->LineDefs[ objlist->objnum].sidedef2);
              }
	       }
	    }
	    else  // Add a new 2nd SideDef (add 1st if missing since always reqd)
	    {
	       for (objlist = cur; objlist; objlist = objlist->next)
          {
             // if no sidedef1, create 1 now first
             if (level->LineDefs[ objlist->objnum].sidedef1 <= -1)    // no sidedef1?
             {   // create sidedef1--------------------
                 InsertObject(level, OBJ_SIDEDEFS, -1, 0, 0);

                 level->LineDefs[ objlist->objnum].sidedef1 = int2(level->NumSideDefs - 1);
                 SelectObject( &sdlist, level->LineDefs[ objlist->objnum].sidedef1); // 10-30-94
             }
		       else // if no sidedef2, create---------------
		       if (level->LineDefs[ objlist->objnum].sidedef2 <= -1) // was ==
		       {   // create sidedef2
		           n = level->LineDefs[objlist->objnum].sidedef1;     // sidedef1
		           strncpy (level->SideDefs[ n ].tex3, NoTexture, 8); // force transparent 6-9-95

		           InsertObject(level,OBJ_SIDEDEFS, -1, 0, 0);    // sd2
		           // sd2 = copy info from sidedef1
                 strncpy (level->SideDefs[level-> NumSideDefs-1].tex3, NoTexture, 8); // override default normal
                 level->SideDefs[level->NumSideDefs-1].sector = level->SideDefs[n].sector;  // assign same as 1

                 level->LineDefs[objlist->objnum].sidedef2 = int2(level->NumSideDefs - 1);
                 level->LineDefs[objlist->objnum].flags = 4;

                 SelectObject( &sdlist, level->LineDefs[ objlist->objnum].sidedef2);//10-30-94
             }
          }
	    }  // continue to next and edit the ones selected
     }


     // set current sidedefs including those created above to Entry value

     sd1 = level->LineDefs[ cur->objnum].sidedef1;
     sd2 = level->LineDefs[ cur->objnum].sidedef2;

     if(lpsel->b1)  sd = sd2;        // Had to add since if -1, and had
     else           sd = sd1;        // to add side, sd was not initialized

     // set sectors active
     if (sd1 >= 0) s1 = level->SideDefs[ sd1].sector;
     else          s1 = -1;

     if (sd2 >= 0) s2 = level->SideDefs[ sd2].sector;
     else          s2 = -1;

     if (sd < 0 )
     {   ErrorMsg(hDlg, "SideDef is < 0, Can't Be !"); // they should be able to tell
         EndDialog( hDlg, FALSE);     // can't be--------
     }

     if ( IsSelected (sdlist, sd)    // see if in list
      &&  sdlist->objnum !=  sd )    // yes, not first
     {
        UnSelectObject( &sdlist, sd); // get rid of it
        SelectObject  ( &sdlist, sd); // this is now sidedef
     }


     // this is either sd1 or sd2

     strncpy( ShowTexName1, level->SideDefs[ sdlist->objnum].tex1, 8); // upper
     strncpy( ShowTexName2, level->SideDefs[ sdlist->objnum].tex2, 8); // lower
     strncpy( ShowTexName3, level->SideDefs[ sdlist->objnum].tex3, 8); // normal

     // SideDef1 --------------
     if (!lpsel->b1)
     {  // one-sided linedef
       if (s1 >= 0 && s2 < 0)
       {
          if (level->SideDefs[ sd1].tex3[ 0] == '-')
          {   strcpy (ShowTexName3,"missing");            // normal missing
          }
       }
       // side one exists always ---------------
       ////if (sd1 >= 0)
       //{
	    // see if 2 textures diff height => texture should exist
	    //  ceiling 1 > ceiling 2,           no side1 upper

	    if (s1 >= 0
       &&  s2 >= 0
       && level->Sectors[ s1].ceilh > level->Sectors[ s2].ceilh
	    && ShowTexName1[ 0] == '-'                               // side1 upper
	    && ( strncmp (level->Sectors[s1].ceilt,SkyTexture, 5)    // not sky1 see through
	    ||   strncmp (level->Sectors[s2].ceilt,SkyTexture, 5) ))
 	    {
	        strcpy(ShowTexName1,"missing");               // upper missing
       }

	    // two-sided floor1 < floor 2

	    if (s1 >= 0 && s2 >= 0
	    &&  level->Sectors[ s1].floorh < level->Sectors[ s2].floorh
	    &&  ShowTexName2[ 0] == '-')
	    {
           strcpy(ShowTexName2,"missing");   // lower missing
	    }
     }
     else
     // SideDef 2 exists
     if (sd2 >= 0)
     {
       // two-sided ceiling 1 < ceiling 2     2nd upper missing

	    if (s1 >= 0 && s2 >= 0
	    && level->Sectors[ s1].ceilh < level->Sectors[ s2].ceilh
	    && ShowTexName1[ 0] == '-'               // side 2 upper
	    && (strncmp(level->Sectors[ s1].ceilt,SkyTexture, 5)   // not see through
	    ||  strncmp(level->Sectors[ s2].ceilt,SkyTexture, 5)))
	    {
	        strcpy(ShowTexName1,"missing");   // upper missing
	    }
       // two sided floor 1 > floor 2          2nd lower missing

	    if (s1 >= 0 && s2 >= 0
	    && level->Sectors[ s1].floorh > level->Sectors[ s2].floorh
	    && ShowTexName2[ 0] == '-')
	    {
           strcpy(ShowTexName2,"missing");   // lower missing
	    }
     }
     // change pointer to proper SideDef
     // fill out our buttons
     if(sd >= 0)											     // valid SideDef
     {  sprintf(szBuf, "  &1.   %8s", ShowTexName1);  //Upper
        Static_SetText(GetDlgItem(hDlg, psh1), szBuf );
        sprintf(szBuf, "  &2.   %8s", ShowTexName3);  //Normal
        Static_SetText(GetDlgItem(hDlg, psh2), szBuf );
        sprintf(szBuf, "  &3.   %8s", ShowTexName2);  //Lower
        Static_SetText(GetDlgItem(hDlg, psh3), szBuf );

        sprintf(szBuf, "  &4.   %hd", level->SideDefs[sdlist->objnum].sector);
        Static_SetText(GetDlgItem(hDlg, psh4), szBuf );

        sprintf(szBuf, "  &5.   %hd , %hd", level->SideDefs[ sdlist->objnum].xoff, level->SideDefs[ sdlist->objnum].yoff);
        Static_SetText(GetDlgItem(hDlg, psh5), szBuf );

        sprintf(szBuf, "  &6.   %hd", level->SideDefs[sdlist->objnum].xoff);
        Static_SetText(GetDlgItem(hDlg, psh6), szBuf );

        sprintf(szBuf, "  &7.   %hd", level->SideDefs[sdlist->objnum].yoff);
        Static_SetText(GetDlgItem(hDlg, psh7), szBuf );

        sprintf(szBuf, "  &8.   %s", "Click Txtr");
        Static_SetText(GetDlgItem(hDlg, psh8), szBuf );

        sprintf(szBuf, "  &9.   Align");
        Static_SetText(GetDlgItem(hDlg, psh9), szBuf );

        sprintf(szBuf, "  &e.   Clone");
        Static_SetText(GetDlgItem(hDlg, psh10),szBuf );

        Xoff = level->SideDefs[sdlist->objnum].xoff;
        Yoff = level->SideDefs[sdlist->objnum].yoff;

        // Set up the structure for our preview dialog
        // to Preview the proper textures

        strncpy(d2.sz1, ShowTexName1,8);		// Upper Texture
        strncpy(d2.sz2, ShowTexName2,8);		// Lower Texture
        strncpy(d2.sz3, ShowTexName3,8);		// Normal Texture

        GetWindowRect(hDlg, &rc);     // For Positioning of Preview Windows
        MoveWindow(hDlg, pSideDlgPos.x,      pSideDlgPos.y,
                         rc.right - rc.left, rc.bottom - rc.top, FALSE);

        GetWindowRect(hDlg, &rc);     // For Positioning of Preview Windows

        d2.i1 = rc.left;               // x pos
        d2.i2 = rc.top;                // y pos of Dlg
        d2.i3 = rc.right  - rc.left;   // width  //   12-16-96 +1 ???
        d2.i4 = rc.bottom - rc.top ;   // height

        if(!gd.hDlgModeless)
		  {   gd.hDlgModeless = CreateDialogParam(gd.hInst, (LPSTR)"LinePrev", hDlg, LinePrevDlgProc, (LPARAM)(LPSTR)&d2);
        }
     }

     InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE);

     if(hSide)
     {  SetFocus(GetDlgItem(hDlg, hSide));    // Restore last selection
        Button_SetStyle(GetDlgItem(hDlg, hSide), BS_DEFPUSHBUTTON, TRUE);
     }
     else
     {  SetFocus(GetDlgItem(hDlg, psh1));     // Default Push Button 1
        hSide = psh1;                         // Store for recall next time
        Button_SetStyle(GetDlgItem(hDlg, hSide), BS_DEFPUSHBUTTON, TRUE);
     }

     GetWindowRect(GetDlgItem(hDlg,hSide),&rcRelative);  // bdk 12-16-96
     SetCursorPos(rcRelative.left+66,rcRelative.top+8);  // bdk 12-16-96

     gd.DestroyModeless=TRUE;

     if(lpsel->b2) // called from mouse click
     {  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(lpsel->post,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
     }

     return FALSE;

    ///====right button up =====================================
    case WM_RBUTTONUP:
     PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0); //   6-1-97 was OK
     break;

    //   6-1-97   ok 7-1-97
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;
    // ====command =============================================
    case WM_COMMAND:

       SideDefCommand =LOWORD(wParam);
       switch (SideDefCommand) 							// handle of the control
       { // Upper Texture
			case psh1:
	   	 GetNewTextureName(hDlg, ShowTexName1, "New UPPER Texture");  //choosetxtrdlg

          sprintf(szBuf, "  &1.   %8s", ShowTexName1);//Upper
          Static_SetText(GetDlgItem(hDlg, psh1), szBuf );

	       if (strlen(ShowTexName1) > 0)
	       {   for (objlist = sdlist; objlist; objlist = objlist->next)
	           {  if (objlist->objnum >= 0)
                 {
		              if(strncmp( level->SideDefs[ objlist->objnum].tex1, ShowTexName1, 8))  //   3-1-97
		              {   strncpy( level->SideDefs[ objlist->objnum].tex1, ShowTexName1, 8);
	                     level->MadeChanges++;
                    }
                 }
	           }
	       }

  			 if(gd.hDlgModeless)
        	 {  InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE); // update texture
          }
          hSide = psh1;
          break;
         // Normal Texture
			case psh2:
	   	 GetNewTextureName(hDlg, ShowTexName3, "New NORMAL Texture");
          sprintf(szBuf, "  &2.   %8s", ShowTexName3);//Normal
          Static_SetText(GetDlgItem(hDlg, psh2), szBuf );

	       if (strlen(ShowTexName3) > 0)
	       {  for (objlist = sdlist; objlist; objlist = objlist->next)
	          {    if (objlist->objnum >= 0)
		            {
                    if(strncmp( level->SideDefs[ objlist->objnum].tex3, ShowTexName3, 8))   //   3-1-97
                    {  strncpy( level->SideDefs[ objlist->objnum].tex3, ShowTexName3, 8);
	                    level->MadeChanges++;
                    }
                  }
	          }
	       }

			 if(gd.hDlgModeless)
      	 {  InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE);  // update texture
          }

          hSide = psh2;
          break;
         // Lower Texture
			case psh3:
	   	 GetNewTextureName(hDlg, ShowTexName2, "New LOWER Texture");
          sprintf(szBuf, "  &3.   %8s", ShowTexName2);//Lower
          Static_SetText(GetDlgItem(hDlg, psh3), szBuf );

	       if (strlen(ShowTexName2) > 0)
	       {   for (objlist = sdlist; objlist; objlist = objlist->next)
	           {   if (objlist->objnum >= 0)
		            {
                     if(strncmp( level->SideDefs[ objlist->objnum].tex2, ShowTexName2, 8)) //   3-1-97
                     {  strncpy( level->SideDefs[ objlist->objnum].tex2, ShowTexName2, 8);
	                     level->MadeChanges++;
                     }
                  }
	           }
	       }

			 if(gd.hDlgModeless)
      	 {  InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE); // update texture
          }

          hSide = psh3;
          break;
         // Sector Reference
			case psh4:
          test1 = InputObjectXRef(hDlg, OBJ_SECTORS, FALSE,                        // -2 is cancel   6-1-97
                                  level->SideDefs[ sdlist->objnum].sector, sdlist);

          if(test1 >= -1)
	       {
	         for (objlist = sdlist; objlist; objlist = objlist->next)
	         {   if (objlist->objnum >= 0)
                {
		             if (level->SideDefs[ objlist->objnum].sector != test1) //   3-1-97
                   {   level->SideDefs[ objlist->objnum].sector = test1;
	                    level->MadeChanges++;
                   }
                }
	         }
            sprintf(szBuf, "  &4.   %hd", test1);
            Static_SetText(GetDlgItem(hDlg, psh4), szBuf );
	       }
          hSide = psh4;
          break;

			case psh5:// X and Y
			 itoa(level->SideDefs[ sdlist->objnum].xoff, dsel.Txtr1, 10);		// X Offset
			 itoa(level->SideDefs[ sdlist->objnum].yoff, dsel.Txtr2, 10);		// Y Offset
          dsel.sel = sdlist;

    		  if( DialogBoxParam( gd.hInst, "Offset", hDlg, OffsetDlgProc,(LPARAM)(LPDLGSELECT)&dsel ) )
			  {   Xoff = (int2)atoi(dsel.Txtr1);
               Yoff = (int2)atoi(dsel.Txtr2);

               for (objlist = sdlist; objlist; objlist = objlist->next)
	            {
                   if (level->SideDefs[ objlist->objnum].xoff != Xoff)
                   {   level->SideDefs[ objlist->objnum].xoff = Xoff;
	                    level->MadeChanges++;
                   }

		             if (level->SideDefs[ objlist->objnum].yoff != Yoff)
                   {   level->SideDefs[ objlist->objnum].yoff = Yoff;
	                    level->MadeChanges++;
                   }
	            }

              sprintf(szBuf, "  &5.   %hd , %hd", level->SideDefs[sdlist->objnum].xoff, level->SideDefs[sdlist->objnum].yoff);
              Static_SetText(GetDlgItem(hDlg, psh5), szBuf );

              sprintf(szBuf, "  &6.   %hd", level->SideDefs[sdlist->objnum].xoff);
              Static_SetText(GetDlgItem(hDlg, psh6), szBuf );
              sprintf(szBuf, "  &7.   %hd", level->SideDefs[sdlist->objnum].yoff);
              Static_SetText(GetDlgItem(hDlg, psh7), szBuf );
      	  }
           hSide = psh5;
           break;

			case psh6:// X offset
           d2.i1    = level->SideDefs[ sdlist->objnum].xoff;
                                              // -255,255
           if(InputNumbers(hDlg, "New X Offset", XoffLow-1,XoffHigh+1, &d2.i1, PointerX, PointerY)) // x offset
			  {
               for (objlist = sdlist; objlist; objlist = objlist->next)
	            {  if(level->SideDefs[ objlist->objnum].xoff != d2.i1)  //   3-1-97
	               {  level->SideDefs[ objlist->objnum].xoff = d2.i1;
	                  level->MadeChanges++;
                  }
	            }

              sprintf(szBuf, "  &5.   %hd , %hd", level->SideDefs[sdlist->objnum].xoff, level->SideDefs[sdlist->objnum].yoff);
              Static_SetText(GetDlgItem(hDlg, psh5), szBuf );

              sprintf(szBuf, "  &6.   %hd", level->SideDefs[sdlist->objnum].xoff);
              Static_SetText(GetDlgItem(hDlg, psh6), szBuf );

              Xoff = level->SideDefs[sdlist->objnum].xoff;
              Yoff = level->SideDefs[sdlist->objnum].yoff;

    		     InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE); // show texture with new offset
      	  }
           hSide = psh6;
           break;

			case psh7:// Y offset
           d2.i1    = level->SideDefs[ sdlist->objnum].yoff;
                                                //-127,127,
           if(InputNumbers(hDlg, "New Y Offset", YoffLow-1,YoffHigh+1, &d2.i1, PointerX, PointerY)) // y offset
			  {   for (objlist = sdlist; objlist; objlist = objlist->next)
	            {  if(level->SideDefs[ objlist->objnum].yoff != d2.i1)  //   3-1-97
	               {  level->SideDefs[ objlist->objnum].yoff = d2.i1;
	                  level->MadeChanges++;
                  }
	            }

               sprintf(szBuf, "  &5.   %hd , %hd", level->SideDefs[sdlist->objnum].xoff, level->SideDefs[sdlist->objnum].yoff);
               Static_SetText(GetDlgItem(hDlg, psh5), szBuf );

               sprintf(szBuf, "  &7.   %hd", level->SideDefs[sdlist->objnum].yoff);
               Static_SetText(GetDlgItem(hDlg, psh7), szBuf );

               Xoff = level->SideDefs[sdlist->objnum].xoff;
               Yoff = level->SideDefs[sdlist->objnum].yoff;

       		   InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE); // show texture with new offset
      	  }
           hSide = psh7;
           break;

         case psh8:            // Multi_texture Align

            HelpMsg(hDlg,CENTER|HELPHELP,"MouseAlignment",
                   "Simply move the mouse over the",
                   "Texture Preview Window (on the right),",
                   "click the Left Mouse Button and",
                   "D R A G the texture to the desired",
                   "alignment. When done, release the",
                   "mouse button.",NULL);
                //szLoadString(IDS_DEEPINFO), MB_OK);
	       break;

         // Message posted here after LButton Up from LEdit Window
         case WM_MOUSEALIGN_BACK:
            for (objlist = sdlist; objlist; objlist = objlist->next)
	         {
                 if (level->SideDefs[ objlist->objnum].xoff != Xoff) //Xoff global   3-1-97
                 {   level->SideDefs[ objlist->objnum].xoff = Xoff;
	                  level->MadeChanges++;
                 }

		           if (level->SideDefs[ objlist->objnum].yoff != Yoff)  //Yoff global
                 {   level->SideDefs[ objlist->objnum].yoff = Yoff;
	                  level->MadeChanges++;
                 }
	         }

            sprintf(szBuf, "  &5.   %hd , %hd", level->SideDefs[sdlist->objnum].xoff, level->SideDefs[sdlist->objnum].yoff);
            Static_SetText(GetDlgItem(hDlg, psh5), szBuf );

            sprintf(szBuf, "  &6.   %hd", level->SideDefs[sdlist->objnum].xoff);
            Static_SetText(GetDlgItem(hDlg, psh6), szBuf );

            sprintf(szBuf, "  &7.   %hd", level->SideDefs[sdlist->objnum].yoff);
            Static_SetText(GetDlgItem(hDlg, psh7), szBuf );

            break;

         case psh9:                                 // Multi_texture Align
            MultiAlignShow(hDlg, cur, sdlist, (int2)whichside); // pass linedefs and sidedef list
            hLine = psh9;
	         break;
        //-------------
        // clone sidedef to all other linedefs selected
        //-------------
        case psh10:
          hLine = psh10;
          ObjectCount = 0;
          for (objlist = sdlist; objlist; objlist = objlist->next) ObjectCount++;
          if (ObjectCount > 1)
          {
             CloneObject(hDlg,sdlist);
          }
          break;


         case IDCANCEL:
         case IDOK:
            GetWindowRect(hDlg, &rc);
            pSideDlgPos.x = rc.left;
            pSideDlgPos.y = rc.top;
            // should have all been done above, didn't check 100 pct yet

   	 		if(gd.hDlgModeless)
            {  DestroyWindow(gd.hDlgModeless);
   		 	   gd.hDlgModeless = 0;
               ForgetSelection(&sdlist);
      		}

            gd.DestroyModeless=FALSE;
            hEditSideDefDlg=NULL;
            EndDialog( hDlg, TRUE );

            SetCursorPos( EntryCurPos.x,EntryCurPos.y );   //   12-2-96 trying to get cursor back to where it came from
            return TRUE;
		 }

       if (TempList)
       {   UpdateObjectInfo(gd.hMainWindow, TempList->objnum);  //   3-1-97
           StatBarUpdate9();
       }
       break;
  }
  SetCursorPos( PriorCurPos.x,PriorCurPos.y );   //   12-2-96 trying to get cursor back to where it came from
  return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
// 12-25-96 bk  Code Starts here for LineFlag mods
///////////////////////////////////////////////////////////////////////////////


static int2  lineval   [16] ={0};    // Global for following routines
static int2  oldlineval[16];         // original values

/////////////////////////////////////////////////////////
// WM_CTLCOLOR
/////////////////////////////////////////////////////////
#pragma argsused
HBRUSH Line_OnCtlColor(HWND hwnd, HDC hdc, HWND hwndChild, int type)
{

 switch (type)
  {
    //case CTLCOLOR_DLG:     // For The background on the dialog box
    //return GetStockBrush(LTGRAY_BRUSH);

   case CTLCOLOR_BTN:
   case CTLCOLOR_STATIC:

    SetTextColor(hdc, PALETTERGB(0, 0, 0));

    if(Button_GetCheck(GetDlgItem(hwnd, IDD_MYCHECKBOX)))// Set/Clear All Flags
    {
      SetBkMode(hdc, TRANSPARENT);

     if(hwndChild == GetDlgItem(hwnd, stc1) ) // Impass
      {      if(lineval[0]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[0]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[0]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
     if(hwndChild == GetDlgItem(hwnd, stc2) ) // Monster Block
      {      if(lineval[1]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[1]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[1]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
     if(hwndChild == GetDlgItem(hwnd, stc3) ) // 2-Sided
      {      if(lineval[2]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[2]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[2]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
     if(hwndChild == GetDlgItem(hwnd, stc4) ) // Upper U
      {      if(lineval[3]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[3]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[3]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
     if(hwndChild == GetDlgItem(hwnd, stc5) ) // Lower U
      {      if(lineval[4]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[4]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[4]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }

     if(hwndChild == GetDlgItem(hwnd, stc6) ) // Secret
      {      if(lineval[5]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[5]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[5]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
     if(hwndChild == GetDlgItem(hwnd, stc7) ) // Block Sound
      {      if(lineval[6]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[6]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[6]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
     if(hwndChild == GetDlgItem(hwnd, stc8) ) // Invisible
      {      if(lineval[7]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[7]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[7]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
     if(hwndChild == GetDlgItem(hwnd, stc9) ) // AutoMap
      {      if(lineval[8]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(lineval[8]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(lineval[8]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }

     if(GameVersion == 4)
     {
       if(hwndChild == GetDlgItem(hwnd, stc10) ) // Repeatable - only HEXEN
       {      if(lineval[9]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
         else if(lineval[9]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
         else if(lineval[9]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
       }
     }
     return GetStockBrush(NULL_BRUSH);

    }

    break;

  }  // type


 return NULL;
}

///////////////////////////////////////////////////////////////////////////////
// Updates the Check Box's for Line Flags
// Also, redraws Static Text by invalidating the bitmap
// and causing Windows to issue CTLCOLOR msg to the WinProc
///////////////////////////////////////////////////////////////////////////////

void SetLineCheck(HWND hDlg)
{
     if (lineval[0]) Button_SetCheck(GetDlgItem(hDlg, chx1), 1);//Impass.
     else            Button_SetCheck(GetDlgItem(hDlg, chx1), 0);
     if (lineval[1]) Button_SetCheck(GetDlgItem(hDlg, chx2), 1);//Monster block
     else            Button_SetCheck(GetDlgItem(hDlg, chx2), 0);
     if (lineval[2]) Button_SetCheck(GetDlgItem(hDlg, chx3), 1);//2 Sided
     else            Button_SetCheck(GetDlgItem(hDlg, chx3), 0);
     if (lineval[3]) Button_SetCheck(GetDlgItem(hDlg, chx4), 1);//Upper Unpeg
     else            Button_SetCheck(GetDlgItem(hDlg, chx4), 0);
     if (lineval[4]) Button_SetCheck(GetDlgItem(hDlg, chx5), 1);//Lower Unpeg
     else            Button_SetCheck(GetDlgItem(hDlg, chx5), 0);
     if (lineval[5]) Button_SetCheck(GetDlgItem(hDlg, chx6), 1);//Secret
     else            Button_SetCheck(GetDlgItem(hDlg, chx6), 0);
     if (lineval[6]) Button_SetCheck(GetDlgItem(hDlg, chx7), 1);//BlockSound
     else            Button_SetCheck(GetDlgItem(hDlg, chx7), 0);
     if (lineval[7]) Button_SetCheck(GetDlgItem(hDlg, chx8), 1);//Invisible
     else            Button_SetCheck(GetDlgItem(hDlg, chx8), 0);
     if (lineval[8]) Button_SetCheck(GetDlgItem(hDlg, chx9), 1);//AutoMap
     else            Button_SetCheck(GetDlgItem(hDlg, chx9), 0);

     if (GameVersion <=2
     &&  BOOMSupport)
     {   if (lineval[9]) Button_SetCheck(GetDlgItem(hDlg, chx10), 1);//Use Works Thru the line BOOM
         else            Button_SetCheck(GetDlgItem(hDlg, chx10), 0);
     }

     // This makes sure our Static Text get redrawn in Proper Colors
     InvalidateRect(GetDlgItem(hDlg, stc1), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc2), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc3), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc4), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc5), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc6), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc7), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc8), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc9), NULL, TRUE);

     if(GameVersion == 4)
     {
       if (lineval[9]) Button_SetCheck(GetDlgItem(hDlg, chx10), 1);//HEXEN
       else            Button_SetCheck(GetDlgItem(hDlg, chx10), 0);
       if (lineval[10]) Button_SetCheck(GetDlgItem(hDlg, chx11), 1);
       else            Button_SetCheck(GetDlgItem(hDlg, chx11), 0);
       if (lineval[11]) Button_SetCheck(GetDlgItem(hDlg, chx12), 1);
       else            Button_SetCheck(GetDlgItem(hDlg, chx12), 0);
       if (lineval[12]) Button_SetCheck(GetDlgItem(hDlg, chx13), 1);
       else            Button_SetCheck(GetDlgItem(hDlg, chx13), 0);
       if (lineval[13]) Button_SetCheck(GetDlgItem(hDlg, chx14), 1);
       else            Button_SetCheck(GetDlgItem(hDlg, chx14), 0);
       if (lineval[14]) Button_SetCheck(GetDlgItem(hDlg, chx15), 1);
       else            Button_SetCheck(GetDlgItem(hDlg, chx15), 0);
       if (lineval[15]) Button_SetCheck(GetDlgItem(hDlg, chx16), 1);
       else            Button_SetCheck(GetDlgItem(hDlg, chx16), 0);

       InvalidateRect(GetDlgItem(hDlg, stc10), NULL, TRUE); // Repeatable
    }
}

///////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////

void ReadLineCheckMarks(HWND hDlg, Bool hexen) // if read last parms
{

   if(hexen)
   {
    if ( Button_GetCheck(GetDlgItem(hDlg, chx11) ))//Player Crosses Line
         lineval[10] = 1;
    else lineval[10] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx12) ))//Player Uses Line w/u Key
         lineval[11] = 1;
    else lineval[11] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx13) ))//Monster Crosses Line
         lineval[12] = 1;
    else lineval[12] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx14) ))//Projectile Impacts wall
         lineval[13] = 1;
    else lineval[13] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx15) ))//Player Pushes Wall
         lineval[14] = 1;
    else lineval[14] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx16) ))//Projectile Crosses Line
         lineval[15] = 1;
    else lineval[15] = 0;

  } // Read last hexen parms on End Dialog
  else
  {
    if ( Button_GetCheck(GetDlgItem(hDlg, chx1) ))//Impass.
         lineval[0] = 1;
    else lineval[0] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx2) ))//Monster block
         lineval[1] = 1;
    else lineval[1] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx3) ))//2 Sided
         lineval[2] = 1;
    else lineval[2] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx4) ))//Upper Unpeg
         lineval[3] = 1;
    else lineval[3] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx5) ))//Lower Unpeg
         lineval[4] = 1;
    else lineval[4] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx6) ))//Secret
         lineval[5] = 1;
    else lineval[5] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx7) ))//BlockSound
         lineval[6] = 1;
    else lineval[6] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx8) ))//Invisible
         lineval[7] = 1;
    else lineval[7] = 0;
    if ( Button_GetCheck(GetDlgItem(hDlg, chx9) ))//AutoMap
         lineval[8] = 1;
    else lineval[8] = 0;

    if (GameVersion <=2
    &&  BOOMSupport)
    {
        if (Button_GetCheck(GetDlgItem(hDlg, chx10) ))//Use Works Thru the Line BOOM
             lineval[9] = 1;
        else lineval[9] = 0;
    }

    if(GameVersion == 4) // hexen used on enter to read parms
    {
         if ( Button_GetCheck(GetDlgItem(hDlg, chx10) ))//Repeatable
              lineval[9] = 1;
         else lineval[9] = 0;
         if ( Button_GetCheck(GetDlgItem(hDlg, chx11) ))//Player Crosses Line
              lineval[10] = 1;
         else lineval[10] = 0;
         if ( Button_GetCheck(GetDlgItem(hDlg, chx12) ))//Player Uses Line w/u Key
              lineval[11] = 1;
         else lineval[11] = 0;
         if ( Button_GetCheck(GetDlgItem(hDlg, chx13) ))//Monster Crosses Line
              lineval[12] = 1;
         else lineval[12] = 0;
         if ( Button_GetCheck(GetDlgItem(hDlg, chx14) ))//Projectile Impacts wall
              lineval[13] = 1;
         else lineval[13] = 0;
         if ( Button_GetCheck(GetDlgItem(hDlg, chx15) ))//Player Pushes Wall
              lineval[14] = 1;
         else lineval[14] = 0;
         if ( Button_GetCheck(GetDlgItem(hDlg, chx16) ))//Projectile Crosses Line
              lineval[15] = 1;
         else lineval[15] = 0;
    }

    } // end if (hexen)
}


///////////////////////////////////////////////////////////////////////////////
// Enables or disables the LineFlag Check Box's for activating the Text Colors
// by clicking on them - Set/Clear All Flags must be active to disable Box's
///////////////////////////////////////////////////////////////////////////////

void LineWindow(HWND hDlg, Bool state)
{

     EnableWindow(GetDlgItem(hDlg, chx1), state);//Impass
     EnableWindow(GetDlgItem(hDlg, chx2), state);//Monster Block
     EnableWindow(GetDlgItem(hDlg, chx3), state);//2-Sided
     EnableWindow(GetDlgItem(hDlg, chx4), state);//Upper U.
     EnableWindow(GetDlgItem(hDlg, chx5), state);//Lower U.
     EnableWindow(GetDlgItem(hDlg, chx6), state);//Secret
     EnableWindow(GetDlgItem(hDlg, chx7), state);//Block S.
     EnableWindow(GetDlgItem(hDlg, chx8), state);//Invisible
     EnableWindow(GetDlgItem(hDlg, chx9), state);//Automap


     if(!BOOMSupport         // not BOOM
     ||  GameVersion > 2)    // not DOOM
     {   state = FALSE;
     }

     EnableWindow(GetDlgItem(hDlg, chx10), state);//USE Wrks BOOM, Repeatable HEXEN

     if(GameVersion != 4)  state = FALSE;

     //EnableWindow(GetDlgItem(hDlg, chx10), state);//Repeatable
     EnableWindow(GetDlgItem(hDlg, chx11), state);//Player Crosses Line
     EnableWindow(GetDlgItem(hDlg, chx12), state);//Player Uses Line
     EnableWindow(GetDlgItem(hDlg, chx13), state);//Monster Crosses Line
     EnableWindow(GetDlgItem(hDlg, chx14), state);//Projectile Impacts wall
     EnableWindow(GetDlgItem(hDlg, chx15), state);//Player Pushes Wall
     EnableWindow(GetDlgItem(hDlg, chx16), state);//Projectile Crosses Line
}

///////////////////////////////////////////////////////////////////////
//																							//
//  The Deep Line Flag Dialog														//
//																							//
//	 Called from our menu's after right button or ENTER KEY				//
//  to change the setting of the currently selected line(s)				//
//																							//
///////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK LineFlagDlgProc(DIALOG_PARAMS)
{

static int2 setLineBits =0;     // all linedefs

 int2			i;
 int2       Activated;
 int2       n;
 int4       LineFlagCommand;             // id of the command  // 2-20-97 bk
 int2       tagwrk;

 RECT       rcRelative;
 LevelPtr 	level = &LevelWad.level;
 char       szDlgTxt[128] = "\0";			      // Dialog Text strings

 int2  newtype;
 uint2 wrkflag;
 uint2 clearflag;              // bits to clear
 uint2 setflag;                // bits to set
 uint2 NewFlag;                // all bits to set

 LPDLGSELECT lpsel;            //Our Long Pointer to DlgSelectList

 static SelPtr objlist;
 SelPtr sel;

 static int2 HxMode;               // Don't ask

 char msg1[40];
 char msg2[40];

 static UINT codeNotify;            // WM_COMMAND codes for our thing colors
 static HWND hwndCtl;               // control handle
 static HWND hLInstructDlg = NULL;  // Modeless Instruction Dlg explain rather esoteric ways of setting flags

 static POINT EntryCurPos;                   //   3-1-97
        POINT PriorCurPos;                   //   3-1-97

       TypeThingPtr  OldThingNames ;         // For saving Hexen Spawn Names
//===========================================================================

 ScreenSaverTimer = 0;                       // reset screensaver timer   8-1-97

 GetCursorPos( &PriorCurPos );               //   12-16-96

 switch(msg)
 {
    case WM_INITDIALOG:
      GetCursorPos( &EntryCurPos );          //   3-1-97

      SetWindowLong(hDlg, DWL_USER, lParam);        // store our Pointer

      lpsel = (LPDLGSELECT)lParam;                  // grab it for our use
      objlist = (SelPtr)lpsel->sel;                 // our selection list
      //   3-1-97
      LineType = level->LineDefs[ objlist->objnum].type;  // type
      OldType  = level->LineDefs[ objlist->objnum].type;  // type
      //flags    = level->LineDefs[ objlist->objnum].flags; // flags
      larg[0]  = level->LineDefs[ objlist->objnum].tag ;  // arg1
      larg[1]  = level->LineDefs[ objlist->objnum].arg2;  //    2
      larg[2]  = level->LineDefs[ objlist->objnum].arg3;  //    3
      larg[3]  = level->LineDefs[ objlist->objnum].arg4;  //    4
      larg[4]  = level->LineDefs[ objlist->objnum].arg5;  //    5
      
      if (GameVersion == 4)
      {
         SetLineDefArgs  (LineType, larg[3]);                 // set argument names
         for (n=0; n < 5; n++)
         {   if (*argdesc[n] == '\0')
             {    sprintf(argdesc[n],"Arg%hd (na)",n+1);
             }
             //wsprintf( szText,"%-14.14s: %hd", argdesc[n],larg[n]);
         }
      }

      EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXALLSKILL), 0);//just for now is ALL LINEDEF box

      lineval[0] = GetLineDefFlag( objlist->objnum, 1);   // 1
	   lineval[1] = GetLineDefFlag( objlist->objnum, 2);   // 2
      lineval[2] = GetLineDefFlag( objlist->objnum, 3);   // 3
      lineval[3] = GetLineDefFlag( objlist->objnum, 4);   // 4
	   lineval[4] = GetLineDefFlag( objlist->objnum, 5);   // 5
	   lineval[5] = GetLineDefFlag( objlist->objnum, 6);   // 6
      lineval[6] = GetLineDefFlag( objlist->objnum, 7);   // 7
      lineval[7] = GetLineDefFlag( objlist->objnum, 8);   // 8
	   lineval[8] = GetLineDefFlag( objlist->objnum, 9);   // 9

      lineval[ 9]=0;
      lineval[10]=0;
      lineval[11]=0;
      lineval[12]=0;
      lineval[13]=0;
      lineval[14]=0;
      lineval[15]=0;

      if ( GameVersion == 4 )         // HEXEN
      {
	       lineval[9] = GetLineDefFlag( objlist->objnum,10);   // 10  repeatable
	       lineval[10]= GetLineDefFlag( objlist->objnum,11);   // 11
	       lineval[11]= GetLineDefFlag( objlist->objnum,12);   // 12
	       lineval[12]= GetLineDefFlag( objlist->objnum,13);   // 13

          Activated = lineval[10] + lineval[11]*2 + lineval[12]*4;
          if (Activated > 5) Activated = 5;

          lineval[Activated+10] = 1;  // turns on one of the above
      }
      else
      {
          if (GameVersion <=2
          &&  BOOMSupport)
          {   lineval[9] = GetLineDefFlag( objlist->objnum,10);   // 10 Works Thru the Line
          }
          else
          {   EnableWindow(GetDlgItem(hDlg, chx10), 0);//Repeatable disable
          }

          // Disable Hexen stuff
          EnableWindow(GetDlgItem(hDlg, chx11), 0);//Player Crosses Line
          EnableWindow(GetDlgItem(hDlg, chx12), 0);//Player Uses Line
          EnableWindow(GetDlgItem(hDlg, chx13), 0);//Monster Crosses Line
          EnableWindow(GetDlgItem(hDlg, chx14), 0);//Projectile Impacts wall
          EnableWindow(GetDlgItem(hDlg, chx15), 0);//Player Pushes Wall
          EnableWindow(GetDlgItem(hDlg, chx16), 0);//Projectile Crosses Line
      }

      SetLineCheck(hDlg);  // Updates the Checkmarks according to lineval

      for (i=0; i < 16; i++)
      {    oldlineval[i]=lineval[i];
      }

      sprintf( szDlgTxt, "LineDef %hd %-16.16s", objlist->objnum,
                 GetLineDefTypeShortName(&level->LineDefs[objlist->objnum]));

      Static_SetText(GetDlgItem(hDlg, IDD_ST), szDlgTxt);

      GetWindowRect(hDlg, &rcLineFlagMenu);                           //   12-16-96
      GetWindowRect(GetDlgItem(hDlg, IDD_CHANGETYPE), &rcRelative);   //   12-16-96
      SetCursorPos(rcRelative.left + 66, rcRelative.top +12);         //   12-16-96

      if(lpsel->b2) // called from mouse click on bottom
      {  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(lpsel->post,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      }
      return TRUE; // or FALSE if we set our own focus

    case WM_RBUTTONUP:
      if(!PopupMenu)
   	{   PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
      }
      break;
    //   6-1-97          --------check more --
    case WM_LBUTTONUP:
      if (!PopupMenu && !setLineBits )    // to easy to do in FLAG mode
      {   PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      }
      break;

    case WM_CTLCOLORSTATIC:
      return HANDLE_WM_CTLCOLORBTN(hDlg, wParam, lParam, Line_OnCtlColor);

	 case WM_COMMAND:
      LineFlagCommand  = LOWORD(wParam);
      codeNotify = (UINT)HIWORD(wParam);
      hwndCtl    = (HWND)(lParam);

		switch (LineFlagCommand)
      {
          case stc1:
          case stc2:
          case stc3:
          case stc4:
          case stc5:
          case stc6:
          case stc7:
          case stc8:
          case stc9:
          case stc10:
            n = (LineFlagCommand - stc1); // stc1 == 440 in DLGS.H

            if(n == 10 && GameVersion != 4) break;

            if (!setLineBits)
            {   lineval[n] = !lineval[n];              // toggle bit flag
            }
            else
            {   lineval[n]++;                          // Dos was > 3
                if (lineval[n] > 2) lineval[n] = 0;
            }

            InvalidateRect(GetDlgItem(hDlg, (n + stc1)), NULL, TRUE); // Paint it
            break;


          // Clear/Set All Flags Check Box Clicked on

          case IDD_MYCHECKBOX:
            if (codeNotify == BN_CLICKED)              // clicked on Set/Clear ALL Flags
            {
                if(Button_GetCheck(hwndCtl))
                {  // Get Current Settings in case changed, Don't get notified when CheckBox's

                   if(!hLInstructDlg) // 2-20-97 bk
                   {   hLInstructDlg = CreateDialogParam(gd.hInst, "InstructionFlag", hDlg, InstructionFlagDlgProc, 0);//   3-1-97
                   }

                   ReadLineCheckMarks(hDlg, FALSE); // Clicked when MYCHECKBOX NOT active

                   // copy original settings
                   for (n=0; n < 10; n++)
                   {   oldlineval[n]=lineval[n];
                       lineval[n] = 2;                // No change for Colors
                   }

                   // Update the Checkmarks from linevars,  Update Text with proper Colors
                   SetLineCheck(hDlg);

                   LineWindow(hDlg, FALSE);           // Turns Checkmarks Active or Not, (GRAYED)

                   setLineBits = 1;
                }
                else
                {  if (hLInstructDlg)                  //   6-1-97 safety
                   {   DestroyWindow(hLInstructDlg);   // 2-20-97 bk
                       hLInstructDlg = NULL;
                   }

                   setLineBits = 0;
                   for (n=0; n < 11; n++)
                   {    if (lineval[n]== 2)  lineval[n] = oldlineval[n];
                        oldlineval[n] = lineval[n]; // copy as original
                   }

                   LineWindow(hDlg, TRUE);          // Turn check marks & text ON

                   SetLineCheck(hDlg);
                }
            }
            break;

          case IDOK:
            if (hLInstructDlg)                 //   6-1-97
            {   DestroyWindow(hLInstructDlg);
                hLInstructDlg = NULL;
            }

            level->MadeChanges++;

            // Update skillvar according to below
            if(setLineBits)            //  0 = Clear, 1 = Set,  2 = keep oldvalue
            {
               for(n=0;n<10;n++)       // Keep old - same so setflag / clearflag
               {  if(lineval[n] == 2)                       // 2 = keep
                     lineval[n] = oldlineval[n];            // doesn't change it
                   else
                   if(lineval[n] == 0 && oldlineval[n] == 0)// 0 = clear
                      oldlineval[n] = 1;
                   else
                   if(lineval[n] == 1 && oldlineval[n] == 1)// 1 = set
                      oldlineval[n] = 0;
                }
                ReadLineCheckMarks(hDlg, TRUE);  // JUST read Last Hexen parms
            }
            else
            // NOT set/clear AlL Flags
            {
                ReadLineCheckMarks(hDlg, FALSE); // sets lineval according to ChkBox
            }
	         NewFlag = 0;

            if ( GameVersion == 4 )               // HEXEN
            {
                NewFlag = int2( lineval[11]   + lineval[12]*2 +
                                lineval[13]*3 + lineval[14]*4 +
                                lineval[15]*5 );

                if (NewFlag > 5) NewFlag = 5;
                NewFlag <<= 10;

	             for (n=0; n< 10; n++)
   	          { if (lineval[n])
	               {   NewFlag  = int2(NewFlag ^ (0x01 << n));
		            }
                }
            }
            else
            {
	           for (n=0; n< 10; n++)     // was 9 made 10 for BOOM
   	        {   if (lineval[n])
	               {   NewFlag  = int2(NewFlag ^ (0x01 << n));
		            }
              }
	         }

            clearflag = 0xffff;
            setflag   = 0;

            for (n=0; n < 10; n++)
            {
                if (oldlineval[n] != lineval[n] )  // diff
                {
                    if (lineval[n] == 1)           // BLUE
                    {   setflag   = int2(setflag | (0x01 << n));    // set this bit
                    }
                    else                           // BLACK
                    {   clearflag =int2(clearflag ^ (0x01 << n));    // clear this bit
                    }
                }

            }

	         for (sel = objlist; sel; sel = sel->next)
	         {  if (!setLineBits)
		         {   level->LineDefs[ sel->objnum].flags = NewFlag;    // replace
               }
               else
		         {   level->LineDefs[ sel->objnum].flags |= setflag;   // set bit
		             level->LineDefs[ sel->objnum].flags &= clearflag; // clear bit
               }
	         }

            UpdateObjectInfo(gd.hMainWindow, objlist->objnum);
            SetCursorPos(EntryCurPos.x, EntryCurPos.y);//   3-1-97
            EndDialog(hDlg, TRUE);
		      return TRUE;


          case IDCANCEL:
            if (hLInstructDlg)                 //   6-1-97
            {   //gd.DestroyModeless=TRUE;
                DestroyWindow(hLInstructDlg);
                hLInstructDlg = NULL;
                //gd.DestroyModeless=FALSE;
            }

            SetCursorPos(EntryCurPos.x, EntryCurPos.y);//   3-1-97
		      EndDialog(hDlg, FALSE);
		      return FALSE;

          case IDHELP:
            HelpOpened = WinHelp(hDlg, HelpName, HELP_KEY,
                               (DWORD)"Edit LineDef - Type, Flags and Tags");
		      return FALSE;

          case IDD_CHANGETYPE:
            HxMode = 3;
		      HandleLineTypeMenu(hDlg,rcLineFlagMenu.left+4,rcLineFlagMenu.top+4);// FALSE);   // Grabs the menu entries for the current Game (from button)
            return TRUE;

          case CM_LM2:                    // Door (keys)
          case CM_LM3:                    // Door (open)
          case CM_LM4:                    // Door (close)
          case CM_LM5:                    // Ceilings
          case CM_LM6:                    // Crushers
          case CM_LM7:                    // Floor, raise c
          case CM_LM8:                    // Floor, raise f
          case CM_LM9:                    // Floor, lower
          case CM_LM10:                   // Stairs
          case CM_LM11:                   // Lifts
          case CM_LM12:                   // Lights
          case CM_LM13:                   // Teleport
          // extensions for BOOM
          case CM_LM14:                   // Floors
          case CM_LM15:                   // Ceilings
          case CM_LM16:                   // Doors
          case CM_LM17:                   // Locked Doors
          case CM_LM18:                   // Lifts
          case CM_LM19:                   // Stairs
          case CM_LM20:                   // Crushers
          case CM_LM21:                   // spare1s
          case CM_LM22:                   // spare2s

          case CM_LMHX2:                  // ALL Doors
          case CM_LMHX3:                  // Ceilings
          case CM_LMHX4:                  // Crushers
          case CM_LMHX5:                  // Floor raise
          case CM_LMHX6:                  // Floor lower
          case CM_LMHX7:                  // Stairs
          case CM_LMHX8:                  // Lifts
          case CM_LMHX9:                  // Lights
          case CM_LMHX10:                 // Teleport, end/
          case CM_LMHX11:                 // Poly Object
          case CM_LMHX12:                 // Thing Specials
          case CM_LMHX13:                 // Scripts
            HxMode = 2;                   //   3-1-97 always

            if (GameVersion == 4) // Hexen
            {
                DisplayLineDefTypeMenu(hDlg, rcLineFlagMenu.left+4 ,rcLineFlagMenu.top+4,
                                           objlist->objnum,
                                           TRUE,  MenuLineDefListHexen[LineFlagCommand - CM_LMHX2].type);
            }
            else
            if (GameVersion == 5) // Strife
            {
                DisplayLineDefTypeMenu(hDlg, rcLineFlagMenu.left+4 ,rcLineFlagMenu.top+4,
                                           objlist->objnum,
                                           TRUE,  MenuLineDefListStrife[LineFlagCommand - CM_LMS2].type);
            }
            else
            if (GameVersion == 3) // Heretic
            {
                DisplayLineDefTypeMenu(hDlg, rcLineFlagMenu.left+4  ,rcLineFlagMenu.top+4,
                                           objlist->objnum,
                                           TRUE,  MenuLineDefListHeretic[LineFlagCommand - CM_LM2].type);
            }
            else                 // DOOM1/2
            {
                //DisplayLineDefTypeMenu(hDlg, rcLineFlagMenu.left+4  ,rcLineFlagMenu.top+4,
                //                           objlist->objnum,
                //                           TRUE,  DoomLineDefList[LineFlagCommand - CM_LM2].type);
                DisplayLineDefTypeMenuX(hDlg, rcLineFlagMenu.left+4  ,rcLineFlagMenu.top+4, // 3-1-98 because new list has new entries
                                              objlist->objnum,
                                              TRUE,
                                              DoomLineDefList, LineFlagCommand);      // match menu # to get type
            }
            /*
            if (GameVersion != 4) // linemenuval = . . .
            {
	             DisplayLineDefTypeMenu(hDlg,rcLineFlagMenu.left+4,rcLineFlagMenu.top+4,
                                            objlist->objnum, //thingspecial,
                                            TRUE,  DoomLineDefList[LineFlagCommand - CM_LM2].type);
            }
            else
            {
	             DisplayLineDefTypeMenu(hDlg,rcLineFlagMenu.left+4,rcLineFlagMenu.top+4,
                                             objlist->objnum, //thingspecial,
                                             TRUE,  MenuLineDefListHexen[LineFlagCommand - CM_LMHX2].type);
            }*/
            break;

          case CM_LM1:                    // Normal (reset)
          case CM_LMHX1:                  // Normal
            HxMode   = 3;
            menuval2 = 0;

            level->LineDefs[objlist->objnum].type = 0;              //  3-1-97
            sprintf( szDlgTxt, "LineDef %hd %-16.16s", objlist->objnum,
            GetLineDefTypeShortName(&level->LineDefs[objlist->objnum]));
            Static_SetText(GetDlgItem(hDlg, IDD_ST), szDlgTxt);

            //   3-1-97
	         for (sel =objlist; sel; sel = sel->next)
            {
                 if (level->LineDefs[ sel->objnum].type != 0  // type
                  || level->LineDefs[ sel->objnum].tag  != 0  // arg1
                  || level->LineDefs[ sel->objnum].arg2 != 0  // arg2
                  || level->LineDefs[ sel->objnum].arg3 != 0  //    3
                  || level->LineDefs[ sel->objnum].arg4 != 0  //    4
                  || level->LineDefs[ sel->objnum].arg5 != 0)  //    5
                 {   level->MadeChanges++;                    // 3-1-98
                 }

                 level->LineDefs[ sel->objnum].type = 0;  // type
                 level->LineDefs[ sel->objnum].tag  = 0;  // arg1
                 level->LineDefs[ sel->objnum].arg2 = 0;  // arg2
                 level->LineDefs[ sel->objnum].arg3 = 0;  //    3
                 level->LineDefs[ sel->objnum].arg4 = 0;  //    4
                 level->LineDefs[ sel->objnum].arg5 = 0;  //    5
            }

            LineType = 0;                     //   3-1-97
            OldType  = 0;
            break;
          // explicit
          // BOOM
          case CM_LM23:                   // Linedef type BOOM find out
          case CM_LM24:                   // Linedef type DOOM
          case CM_LMS15:                  // Linedef type STRIFE
          case CM_LMHX14:                 // Hexen
          case CM_LMH14:                  // Heretic
	         menuval2 = level->LineDefs[ objlist->objnum].type;
	         //InputNumbers(hDlg, "LineDef Type", 0,9999,&menuval2, rcLineFlagMenu.left+4, rcLineFlagMenu.top+4);
	         //InputLineDefType(hDlg, "LineDef Type",&(uint2)menuval2, rcLineFlagMenu.left+4, rcLineFlagMenu.top+4);
             if (LineFlagCommand != CM_LM23      // not BOOM
             ||  GameVersion > 2)          // not DOOM1/2
             {
                 InputLineDefType(hDlg, "LineDef Type",&(uint2)menuval2, rcLineFlagMenu.left+4, rcLineFlagMenu.top+4);
             }
             else                          // BOOM
             {
                 InputBOOMLineDefType(hDlg, "LineDef Type",&(uint2)menuval2,rcLineFlagMenu.left+4, rcLineFlagMenu.top+4);
             }

            //OldType = level->LineDefs[objlist->objnum].type;
            level->LineDefs[objlist->objnum].type = menuval2;
            sprintf( szDlgTxt, "LineDef %hd %-16.16s", objlist->objnum,
            GetLineDefTypeShortName(&level->LineDefs[objlist->objnum]));
            Static_SetText(GetDlgItem(hDlg, IDD_ST), szDlgTxt);
            //level->LineDefs[objlist->objnum].type = OldType;

            //   3-1-97
	         for (sel = objlist; sel; sel = sel->next)
            {  if (level->LineDefs[ sel->objnum].type!=menuval2)   // current value
               {   level->MadeChanges++;
                   level->LineDefs[ sel->objnum].type = menuval2;  // type
               }
            }

            LineType = (uint2)menuval2;              //   3-1-97
            OldType  = (uint2)menuval2;
            break;

          case CM_LM25:                   // Sector tag DOOM
          case CM_LMS16:                  // Sector tag STRIFE
          case CM_LMHX15:                 // Linedef Args Hexen (includes tag)
          case CM_LMH15:                  // Heretic
            if (GameVersion == 4)//      3         3-20
            {   // called from HxMode 1 below now

                HxMode = 1;
                lspecial = level->LineDefs[ objlist->objnum].type;  // special (linedef type)
                larg[0]  = level->LineDefs[ objlist->objnum].tag ;  // arg1
                larg[1]  = level->LineDefs[ objlist->objnum].arg2;  //    2
                larg[2]  = level->LineDefs[ objlist->objnum].arg3;  //    3
                larg[3]  = level->LineDefs[ objlist->objnum].arg4;  //    4
                larg[4]  = level->LineDefs[ objlist->objnum].arg5;  //    5

                SetLineDefArgs(lspecial, larg[3]);                  // set arg names


                if(ThingSpawnSpecial(hDlg, rcLineFlagMenu.left+20, rcLineFlagMenu.top+10, larg[1])  == -2) //   3-1-97 only returns -2
                {
                   special  = -1;        // no spawn special else return above to HxMode
                   menuval2 = OldType;
                   HxMode = 3;
                   EditLineCommand(hDlg,level, objlist);
                }
                // else, will return to HxMode 1 below with proper spawn value
            }
            else
            {   tagwrk  = level->LineDefs[ objlist->objnum].tag;
    	          sprintf( msg1, "Tag (free %hd)",   FindFreeTag() );
	             sprintf( msg2, "Sector (last %hd)",LastTagUsed );
                tagwrk = Input1Number(hDlg, msg1, msg2,0,32767, tagwrk);//9999   8-1-97
                if (tagwrk)
	             {   LastTagUsed = tagwrk;
	                 for (sel = objlist; sel; sel = sel->next)
	                 {   if(level->LineDefs[ sel->objnum].tag != tagwrk)
	                     {  level->LineDefs[ sel->objnum].tag = tagwrk;
	                        level->MadeChanges++;
                        }
	                 }
	             }
            }
            break;

          // Spawn Menu H E X E N ==============================

          case CM_SPAWN1:       //"None",                   // 2
            menuval2 = 0;
            break;

          case CM_SPAWN2:       //"Keys",                   // 3
          case CM_SPAWN3:       //"Artifacts",              // 4
          case CM_SPAWN4:       //"Puzzle Items",           // 5
          case CM_SPAWN5:       //"Weapons",                // 6
          case CM_SPAWN6:       //"Health/Armor",           // 7
          case CM_SPAWN7:       //"Enemies",                // 8
          case CM_SPAWN8:       //"Glass/Rocks",            // 9
          case CM_SPAWN9:       //"Projectiles"  ,          // 10
          case CM_SPAWN10:      //"Miscellaneous",          // 11
            OldThingNames = ThingNames;             // save old name
            ThingNames = &HexenSpawnThingNames[0];  // switch to spawn names for FindWhichThing
	         DisplayThingsMenu(hDlg, HexenSpawnThingList[LineFlagCommand - CM_SPAWN2].type);
            ThingNames = OldThingNames;             // restore save old name   3-1-97
            break;

        // 40 odd menu selections get sent here from the Windows Menu code
        // Update the thingmenuval & break out
          case CM_1:                     // 2001 from choosing sub menu above
          case CM_2:
          case CM_3:
          case CM_4:
          case CM_5:
          case CM_6:
          case CM_7:
          case CM_8:
          case CM_9:
          case CM_10:
          case CM_11:
          case CM_12:
          case CM_13:
          case CM_14:
          case CM_15:
          case CM_16:
          case CM_17:
          case CM_18:
          case CM_19:
          case CM_20:
          case CM_21:
          case CM_22:
          case CM_23:
          case CM_24:
          case CM_25:
          case CM_26:
          case CM_27:
          case CM_28:
          case CM_29:
          case CM_30:
          case CM_31:
          case CM_32:
          case CM_33:

            linemenuval = int2(LineFlagCommand - CM_1); // a menu was chosen

            // After converting the case CM_1 - CM-41 to a proper 0 based number
            // check our various versions and update as neccessary
            // Most of this code is from EditThingCommand split up as required
            //   3-1-97 copied again since old code was still here
            if(linemenuval >= 0)
            {
              if(HxMode == 1)    // Called after ThingSpawnSpecial
              {
                special = ThingIds[linemenuval];        // return from ThingSpawnSpecial

                if(GameVersion == 4) // HEXEN
                {
                    EditLineCommand(hDlg, level, objlist);
                    //ThingNames =OldThingNames; // restore old name  ONLY from SpawnSpecial   3-1-97
                }
                HxMode = 3;
              }
              else
              if(HxMode == 2)    // Called from DisplayLineDefType Menu
              {
                  //1-25-97 bk
                 if ( GameVersion == 4 )               // HEXEN
                 {   ltag    = Ltag[linemenuval];
                     // larg[0] = Larg1[linemenuval];    TAG ???
                     larg[1] = Larg2[linemenuval];
                     larg[2] = Larg3[linemenuval];
                     larg[3] = Larg4[linemenuval];
                     larg[4] = Larg5[linemenuval];
                     lflag   = Lflag[linemenuval];

                     SetLineDefArgs(types[linemenuval],larg[3]);          // set arg names

                 }
                 else
                 {
                     lspecial = level->LineDefs[ objlist->objnum].type;  // special (linedef type)
                     larg[0]  = level->LineDefs[ objlist->objnum].tag ;  // arg1
                     larg[1]  = level->LineDefs[ objlist->objnum].arg2;  //    2
                     larg[2]  = level->LineDefs[ objlist->objnum].arg3;  //    3
                     larg[3]  = level->LineDefs[ objlist->objnum].arg4;  //    4
                     larg[4]  = level->LineDefs[ objlist->objnum].arg5;  //    5
                 }
                 // 1-25-97 bk

                 menuval2 = types[linemenuval];// return from LineMenu here with thing special
                 lspecial = types[linemenuval];

                 SetLineDefArgs((uint2)menuval2, larg[3]);              // set arg names

                 // Code moved from above
                 // 1-25-97 bk

//check 3-1-98   if (menuval2 >= 0)                    // valid line type menu selected
	              {  newtype = menuval2;

                    level->MadeChanges++;              //   11-11-96
                    //StatBarUpdate9();           // level->MadeChanges status only in 1024

	                 for (sel = TempList; sel; sel = sel->next)
                    {  OldType = level->LineDefs[ sel->objnum].type;   // current value
                       //if (OldType == newtype) continue;
                       level->LineDefs[ sel->objnum].type = newtype;  // type
                       ///level->MadeChanges++;                          //   3-1-98 NOT HERE hexen key problem

                       //----hexen---------- new
                       if (GameVersion == 4)
                       {   // for keyed door stuff it
                           if (OldType == 13)
                           {   level->LineDefs[ sel->objnum].arg4 = larg[3]; // key value
                           }

                           if ( newtype != OldType)// type of linedef changed
                           {    level->LineDefs[ sel->objnum].arg2 = larg[1];  // arg2
                                level->LineDefs[ sel->objnum].arg3 = larg[2];  //    3
                                level->LineDefs[ sel->objnum].arg4 = larg[3];  //    4
                                level->LineDefs[ sel->objnum].arg5 = larg[4];  //    5

                                wrkflag = uint2(level->LineDefs[ sel->objnum].flags & 0xfe00);
                                if (wrkflag == 0)    // none set yet
                                {   wrkflag = lflag;
                                    wrkflag = uint2(wrkflag << 8);
                                    level->LineDefs[ sel->objnum].flags |= wrkflag;  //upper byte
                                }
                           }
                           else
                           {    if (newtype == 13)  // this is a door
                                {  level->LineDefs[ sel->objnum].arg4 = larg[3];  // key id arg4
                                }
                           }
                       }

                       // reset args if reset to -0-
                       if (newtype == 0 )  // -0- linedef
                       {
                          level->LineDefs[ sel->objnum].tag  = 0;  // arg1
                          level->LineDefs[ sel->objnum].arg2 = 0;  // arg2
                          level->LineDefs[ sel->objnum].arg3 = 0;  //    3
                          level->LineDefs[ sel->objnum].arg4 = 0;  //    4
                          level->LineDefs[ sel->objnum].arg5 = 0;  //    5
                       }
                   }

                   HxMode = 1;                 // loop through again for the Special


                   if(ThingSpawnSpecial(hDlg,rcLineFlagMenu.left+20,rcLineFlagMenu.top+10,larg[1]) == -2)
                   {
                      special = -1; // no spawn special else return above to HxMode 1-25-97 bk
                      HxMode  = 3;
                      if (GameVersion == 4 && newtype) // 12-12-96 bk Edit Line Args HERE
                      {    // select any args now
                           EditLineCommand( hDlg, level, TempList);
                      }
                   }

                   LineType = (uint2)menuval2;              //   3-1-97
                   OldType  = (uint2)menuval2;
	              }
              }     // hxmode = 1 or 2
            }       // end if(linemenuval >= 0 ) menu selection from linedef type
            break;
            ////////////xxxxxxxxxxxxxxx
     }	// End switch(id -

     if (objlist)
     {   UpdateObjectInfo(gd.hMainWindow, objlist->objnum);  //   3-1-97
         StatBarUpdate9();                                   //   3-1-97 level->MadeChanges status only in 1024
     }
     break;
  }					// End switch(msg)

  SetCursorPos(PriorCurPos.x, PriorCurPos.y);                //   3-1-97
  return FALSE;                                              // ?? Should really be TRUE for all handled
}


///////////////////////////////////////////////////////////////////////
//																							//
//  The Deep  X , Y  Offset Dialog 												//
//																							//
//	 Called from our Line Edit Menu, Edit SideDef, Change X,Y offset 	//
//																							//
//	 Interactively changes X,Y offset with Preview of Texture			//
//																							//
///////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK OffsetDlgProc(DIALOG_PARAMS)
{
  LPDLGSELECT lpsel;
  LevelPtr level = &LevelWad.level;
  static   SelPtr sel;
  static   int2 Oldx, Oldy;
  static   Bool AnyChanges;
  int2     xpos, ypos, x1, y1;
  int2     lowX, highX, lowY, highY;
  int2     OffsetCommand;

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97
  
  switch(msg)
  {
	case WM_INITDIALOG:
    AnyChanges = FALSE;                          //   11-11-96
    SetWindowLong(hDlg, DWL_USER, lParam);	    // store our Pointer
    lpsel = (LPDLGSELECT)lParam;				       // grab it for our use

    CenterDialogAroundCursor(hDlg);              // center around cursor   12-16-96

    sel = lpsel->sel;

	 Oldx = level->SideDefs[ sel->objnum].xoff;
	 Oldy = level->SideDefs[ sel->objnum].yoff;

    lowX = XoffLow-1; //-256;
    lowY = YoffLow-1; //-128;
    highX= XoffHigh+1;// 256;
    highY= XoffHigh+1;// 128;

	 //Are these variable according to texture size ??? I would think so . . . CHECK

	 SendDlgItemMessage(hDlg, IDD_UPDOWNX, UDM_SETRANGE, (WPARAM)0, (LPARAM) MAKELONG((short) highX, (short) lowX));
	 SendDlgItemMessage(hDlg, IDD_UPDOWNY, UDM_SETRANGE, (WPARAM)0, (LPARAM) MAKELONG((short) highY, (short) lowY));

	 SendDlgItemMessage(hDlg, IDD_UPDOWNX, UDM_SETPOS, (WPARAM)0, (LPARAM) MAKELONG((short) Oldx, 0));
	 SendDlgItemMessage(hDlg, IDD_UPDOWNY, UDM_SETPOS, (WPARAM)0, (LPARAM) MAKELONG((short) Oldy, 0));

    Edit_SetText(GetDlgItem(hDlg, edt1), lpsel->Txtr1);	// set our edit controls
    Edit_SetText(GetDlgItem(hDlg, edt2), lpsel->Txtr2);	// to reflect x , y

    SetFocus(GetDlgItem(hDlg, edt1));
	 return FALSE; // or FALSE if we set our own focus

	case WM_VSCROLL:
    xpos = (int2)SendMessage(GetDlgItem(hDlg, IDD_UPDOWNX), UDM_GETPOS, 0, 0);
    ypos = (int2)SendMessage(GetDlgItem(hDlg, IDD_UPDOWNY), UDM_GETPOS, 0, 0);

    Xoff = xpos;
    Yoff = ypos;

	 level->SideDefs[ sel->objnum].xoff = xpos;
	 level->SideDefs[ sel->objnum].yoff = ypos;

	 InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, FALSE); // update textures with offset

    SetDlgItemInt(hDlg, edt1, xpos, TRUE);      // set our edit controls
    SetDlgItemInt(hDlg, edt2, ypos, TRUE);      // to reflect x , y
    AnyChanges = TRUE;                           //   11-11-96
    break;

   case WM_RBUTTONUP:
    PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
    break;
   //   6-1-97
   case WM_LBUTTONUP:
    PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
    break;

  case WM_COMMAND:
    lpsel = (LPDLGSELECT)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer

      OffsetCommand = LOWORD(wParam);
		switch (OffsetCommand)
       {
        case edt1:              // X setting
        case edt2:              // Y setting
          switch HIWORD(wParam) // the message
           {
             case EN_CHANGE:
               if (IsItCalculator(hDlg,edt1)) break;
               if (IsItCalculator(hDlg,edt2)) break;

               x1 = (int2)GetDlgItemInt(hDlg, edt1, NULL, TRUE); // New X,Y
               y1 = (int2)GetDlgItemInt(hDlg, edt2, NULL, TRUE);

	            SendDlgItemMessage(hDlg, IDD_UPDOWNX, UDM_SETPOS, (WPARAM)0, (LPARAM) MAKELONG((short) x1, 0));
	            SendDlgItemMessage(hDlg, IDD_UPDOWNY, UDM_SETPOS, (WPARAM)0, (LPARAM) MAKELONG((short) y1, 0));

	            level->SideDefs[ sel->objnum].xoff = x1; // adjust Preview wnd
	            level->SideDefs[ sel->objnum].yoff = y1;

               Xoff = x1; // global in Preview
               Yoff = y1;
               InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE); // show with offset
               AnyChanges = TRUE;                           //   11-11-96
             break;
           }
           break;


        case IDOK:
        case IDCANCEL:
         if (AnyChanges) level->MadeChanges++;             //   11-11-96

         Edit_GetText( GetDlgItem( hDlg, edt1 ), lpsel->Txtr1, 5 );   // 3-1-98 was 4
         Edit_GetText( GetDlgItem( hDlg, edt2 ), lpsel->Txtr2, 5 );
         Xoff = (int2)atoi(lpsel->Txtr1);
         Yoff = (int2)atoi(lpsel->Txtr2);
		  	EndDialog(hDlg, TRUE);                           //   6-1-97 shouldn't this be here?
		   return TRUE;

        case IDABORT:
         // Restore all old figures and show new positions on preview
	      level->SideDefs[ sel->objnum].xoff = Oldx;
         level->SideDefs[ sel->objnum].yoff = Oldy;
         Xoff = Oldx;
         Yoff = Oldy;
			InvalidateRect(GetDlgItem(gd.hDlgModeless, IDD_LINEPREV), NULL, TRUE); // update textures with old offset
		   EndDialog(hDlg, FALSE);
		  return FALSE;

        case IDHELP:     // not active yet in dialog
          HelpOpened = WinHelp(hDlg, HelpName, HELP_KEY,
                               (DWORD)"Texture - X/Y alignment");
		    return FALSE;
       }
	    break;
  }
  return FALSE;     // didn't handle the message
}

//////////////////////////////////////////////////////////////////////////////
//
//  The Deep Sector Edit Preview Window Code
//
//	 Handles painting the preview windows for Floor Texture
//  Ceiling Texture.
//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
void SEditC_OnPaint(HWND hwnd)
{
   PAINTSTRUCT ps;
   HPALETTE 	hOldPal;
   RECT 			rc;

   BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

	GetClientRect(hwnd, &rc);

   if(PrevCeilName)
   	DisplayFloorTexture(ps.hdc,int2(rc.left), int2(rc.top), int2(rc.right),
   	                        	int2(rc.bottom), PrevCeilName, 2);

	if(hOldPal) SelectPalette(ps.hdc, hOldPal, FALSE);
   EndPaint(hwnd, &ps);
}

//////////////////////////////////////////////////////////////////////////////
//  Floor Preview Paint proc
//////////////////////////////////////////////////////////////////////////////
void SEditF_OnPaint(HWND hwnd)
{
   PAINTSTRUCT ps;
   HPALETTE 	hOldPal;
   RECT 			rc;

   BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

	GetClientRect(hwnd, &rc);

   if(PrevFloorName)
   { 	DisplayFloorTexture(ps.hdc,rc.left,  rc.top,
                                 rc.right, rc.bottom, PrevFloorName, 2);
   }

	if(hOldPal) SelectPalette(ps.hdc, hOldPal, FALSE);
   EndPaint(hwnd, &ps);
}

//////////////////////////////////////////////////////////////////////////////
//                                                                           /
//  Modeless Floor & Ceiling Sector Preview Dialog Procedure                 /
//                                                                           /
//////////////////////////////////////////////////////////////////////////////

#pragma argsused
BOOL CALLBACK SectorPrevDlgProc(DIALOG_PARAMS)
{
  LPDLG2OPTS lpd2;				  // Our Long Pointer to  4 char strings
  RECT       rc;

  ScreenSaverTimer = 0;                         // reset screensaver timer   8-1-97

  switch (msg)
  {
   case WM_INITDIALOG:
		SetWindowLong(hDlg, DWL_USER, lParam);	   // store our Pointer

      lpd2 = (LPDLG2OPTS)lParam;			         // grab it for our use

		strncpy(PrevCeilName,  lpd2->sz1, 8); 		// store for the preview window
		strncpy(PrevFloorName, lpd2->sz2, 8);

      GetWindowRect(hDlg, &rc);
      MoveWindow(hDlg, pFloorDlgPos.x,     pFloorDlgPos.y,
                       rc.right - rc.left, rc.bottom - rc.top, FALSE);
      ///Trace(NULL,10,4,"%d,%d   %d,%d ",lpd2->i1,lpd2->i2, rc.right-rc.left+1, lpd2->i4 );

      InvalidateRect(GetDlgItem(hDlg, IDD_SECTORPREVC), NULL, TRUE);
      InvalidateRect(GetDlgItem(hDlg, IDD_SECTORPREVF), NULL, TRUE);
      return TRUE;

    /* only on the edges
   case WM_RBUTTONUP:
      //PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
      break;
   //   6-1-97
   case WM_LBUTTONUP:
      //PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;
   */
   case WM_DESTROY:
      GetWindowRect(hDlg, &rc);
      pFloorDlgPos.x = rc.left;
      pFloorDlgPos.y = rc.top;
      return TRUE;

   default:
      break;
  }
  return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//  sector preview special mouse clicks                                     /
/////////////////////////////////////////////////////////////////////////////

//-- double click left = edit picture ceiling
#pragma argsused
void SEditC_OnLButtonDBLCLK(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
   if (hEditSectorDlg
   && !GettingTexture)
   {   PostMessage(hEditSectorDlg,WM_COMMAND,MAKEWPARAM(psh2,(WORD)GetWindowLong(hEditSectorDlg, GWL_ID)), 0);
   }
}

//-- double click left = edit picture floor -
#pragma argsused
void SEditF_OnLButtonDBLCLK(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
   if (hEditSectorDlg
   && !GettingTexture)
   {   PostMessage(hEditSectorDlg,WM_COMMAND,MAKEWPARAM(psh3,(WORD)GetWindowLong(hEditSectorDlg, GWL_ID)), 0);
   }
}

//-- right button up in pictures is cancel  -
#pragma argsused
void SEdit_OnRButtonUp(HWND hwnd, int x, int y, UINT keyFlags)
{
   if (hEditSectorDlg)
   {   PostMessage(hEditSectorDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hEditSectorDlg, GWL_ID)), 0);
   }
}

/////////////////////////////////////////////////////////////////////////////
//
//  The Deep Sector Edit Preview Window Procedure
//
// These are the Callbacks that Win95 calls to
// paint the preview windows
//
// all we handle is WM_PAINT messages for now
//
/////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK SEditCPrevWndProc(WINDOWS_PARAMS)
{
  switch(msg)
  {
	 HANDLE_MSG(hwnd, WM_PAINT,         SEditC_OnPaint);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, SEditC_OnLButtonDBLCLK);
    HANDLE_MSG(hwnd, WM_RBUTTONUP,     SEdit_OnRButtonUp);
	 default:
		return SEdit_DefProc(hwnd, msg, wParam, lParam);
  }
}


//////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK SEditFPrevWndProc(WINDOWS_PARAMS)
{
  switch(msg)
  {
	 HANDLE_MSG(hwnd, WM_PAINT,       	SEditF_OnPaint);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, SEditF_OnLButtonDBLCLK);
    HANDLE_MSG(hwnd, WM_RBUTTONUP,     SEdit_OnRButtonUp);
	 default:
		return SEdit_DefProc(hwnd, msg, wParam, lParam);
  }
}

////////////////////////////////////////////////////////////////////////////////
//                                                                             /
//  Line Edit Preview Texture Dialog Procedure                                 /
//                                                                             /
////////////////////////////////////////////////////////////////////////////////

static HWND hLinePrevDlg = NULL;      // so title bar can show alignment
static Bool MouseAlign   = FALSE;
static int4 PriorX, PriorY, olddragx, olddragy, oldXalign, oldYalign, dragx, dragy;

#pragma argsused
BOOL CALLBACK LinePrevDlgProc(DIALOG_PARAMS)
{
 LPDLG2OPTS lpd2;				// Our Long Pointer to dialog struct.
 RECT       rc;

 ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

   switch (msg)
   {
    case WM_INITDIALOG:
      hLinePrevDlg = hDlg;                      // change caption

		SetWindowLong(hDlg, DWL_USER, lParam);	   // store our Pointer

      lpd2 = (LPDLG2OPTS)lParam;		        	   // grab it for our use

		strncpy(ShowTexName1, lpd2->sz1, 8); 		// store for the preview window
		strncpy(ShowTexName2, lpd2->sz2, 8);
		strncpy(ShowTexName3, lpd2->sz3, 8);


      GetWindowRect(hDlg, &rc);
      MoveWindow(hDlg, pTextureDlgPos.x,   pTextureDlgPos.y,
                       rc.right - rc.left, rc.bottom - rc.top, FALSE);
      ////Trace(NULL,10,4,"%d,%d   %d,%d ",lpd2->i1,lpd2->i2, rc.right-rc.left+1, lpd2->i4 );

      InvalidateRect(GetDlgItem(hDlg, IDD_LINEPREV), NULL, TRUE);
      return TRUE;
    /* only on the edges
    case WM_RBUTTONUP:
      Trace(NULL,10,10,"linedef rbuttonup");
       break;
    //   6-1-97
    case WM_LBUTTONUP:
      Trace(NULL,10,10,"linedef lbuttonup");
       break;
    */
    case WM_COMMAND:
		switch LOWORD(wParam)
      {
        case IDOK:
        case IDCANCEL:
          break;
      }
      break;
//   case WM_LBUTTONDBLCLK:
//      static int clicker;
//      Trace(NULL,10,10,"double %d",clicker++);
//      break;
   case WM_DESTROY:
      GetWindowRect(hDlg, &rc);
      pTextureDlgPos.x = rc.left;
      pTextureDlgPos.y = rc.top;
      hLinePrevDlg = NULL;
      return TRUE;

   default:
      break;
  }
  return FALSE;
}



//////////////////////////////////////////////////////////////////////////////
//
//  The Deep Line Edit Preview Window Code
//
//	 Handles painting the preview windows for the Upper , Normal
//  and Lower Textures, now takes into account offsets as well,
//  and fully buffers the screen writes to eliminate flicker
//
//////////////////////////////////////////////////////////////////////////////

//
//	Line Edit Texture Paint Proc.
//
void LEdit_OnPaint(HWND hwnd)
{
   PAINTSTRUCT ps;
   BeginPaint(hwnd, &ps);

   ShowMouseAlignment(hwnd);  // use same code   8-1-97

   EndPaint(hwnd, &ps);
}

/*
   HPALETTE 	hOldPal;
   RECT			rc;
   HFONT       hOldFont;
   HDC         hdc, hMemDC;
   HBITMAP     hMemBmp, hMemOldBmp;
   HPALETTE    hMemOldPal;
   char        szBuf[80];

   hdc = BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);
  	RealizePalette(hdc);

	GetClientRect(hwnd, &rc);

	// Create a bitmap big enough to hold the 3 Textures
   // We buffer this since the X,Y adjust by the mouse could
   // cause the Screen to flicker badly; this way will be smooth

   hMemDC 			= CreateCompatibleDC(hdc);
	hMemBmp 			= CreateCompatibleBitmap( hdc, rc.right, rc.bottom);
   hMemOldBmp		= SelectBitmap(hMemDC, hMemBmp);
   hMemOldPal		= SelectPalette(hMemDC, gd.hDoomPal, FALSE);

   hOldFont = SelectFont(hMemDC, gd.hMedFont);

   FillRect(hMemDC, &rc, gd.hBrushes[InfoBoxColor]); //so it always matches graphics   11-7-96

   ShowTextureAlignBoth (hMemDC, ShowTexName1, ShowTexName2,ShowTexName3, Xoff, Yoff);

   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
   GdiFlush();

//   if (MouseAlign)
   {   wsprintf(szBuf,"             Xoffset = %d , Yoffset = %d", Xoff, Yoff);
       SetWindowText(hLinePrevDlg, szBuf);               //   8-1-97 have to use hLineDlg
   }

	if(hOldPal) SelectPalette(hdc, hOldPal, FALSE);

   SelectFont(hMemDC, hOldFont);
   SelectBitmap(hMemDC, hMemOldBmp);
   SelectPalette(hMemDC, hMemOldPal, FALSE);
	DeleteBitmap(hMemBmp);
   DeleteDC(hMemDC);

   EndPaint(hwnd, &ps);
}
*/

//------------------------------------------------------------------------
//  for Texture Align function callback for both mouse and keyboard
//------------------------------------------------------------------------

static int2  FirstAlign;
static int2  FrameXlocS1 ;                // X-Y the same for all three boxes
static int2  FrameXlocE1 ;
static int2  FrameYlocS1 ;
static int2  FrameYlocE1 ;

static int2  FrameYlocS2 ;
static int2  FrameYlocE2 ;

static int2  FrameYlocS3 ;
static int2  FrameYlocE3 ;

static int2  XoffAlign;    // these are for global access here
static int2  YoffAlign;    //

static int2  oldXoffAlign;    // these are for global access here
static int2  oldYoffAlign;    //

//-----------------------------------------------------------------------------
// mouse align show
//-----------------------------------------------------------------------------

static void ShowMouseAlignment(HWND hwnd)
{
   HDC       hdc, hMemDC;
   HBITMAP   hMemBmp, hMemOldBmp;
   HPALETTE  hOldPal;
   HFONT     hOldFont;
   HPALETTE  hMemOldPal;

   RECT		 rc;
   char      szBuf[80] = {0};

   hdc = GetDC(hwnd);

  	hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);
  	RealizePalette(hdc);

	GetClientRect(hwnd, &rc);

	// Create a bitmap big enough to hold the window's image

   hMemDC 			= CreateCompatibleDC(hdc);
	hMemBmp 			= CreateCompatibleBitmap( hdc, rc.right, rc.bottom);
   hMemOldBmp		= SelectBitmap(hMemDC, hMemBmp);
   hMemOldPal		= SelectPalette(hMemDC, gd.hDoomPal, FALSE);
   //hOldFont     = SelectFont(hMemDC, gd.hLargeFont);
   hOldFont       = SelectFont(hMemDC, gd.hMedFont);

   FillRect(hMemDC, &rc, gd.hBrushes[InfoBoxColor]); //so it always matches graphics   11-7-96

   ShowTextureAlignBoth (hMemDC, ShowTexName1, ShowTexName2,ShowTexName3, Xoff, Yoff);
   SelectFont  (hMemDC, hOldFont);

   BitBlt(hdc, 0, 0, rc.right, rc.bottom, hMemDC, 0, 0, SRCCOPY);
   GdiFlush();

   if (hLinePrevDlg)
   {   //TextOut(hdc, 64, 2, szBuf, lstrlen(szBuf)); // was 16   8-1-97 changed font size
       sprintf(szBuf,"             Xoffset = %hd , Yoffset = %hd", Xoff, Yoff);
       SetWindowText(hLinePrevDlg, szBuf);               //   8-1-97 have to use hLineDlg
   }

	SelectPalette(hdc, hOldPal, FALSE);
   SelectBitmap(hMemDC, hMemOldBmp);
   SelectPalette(hMemDC, hMemOldPal, FALSE);
// SelectFont  (hdc, hOldFont);
	DeleteBitmap(hMemBmp);
   DeleteDC    (hMemDC);
   ReleaseDC   (hwnd, hdc);
}

////////////////////////////////////////////////////////////////////////////////
// WM_LBUTTONDBLCLK: Edit texture 1,2,3 according to cursor location          //
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void LEdit_OnLButtonDBLCLK(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
   RECT  rc;
   int4  textureIndex;
   //---------------------------------------------------------------------

   GetClientRect(hwnd,&rc);

   if (hEditSideDefDlg
    && !GettingTexture)
   {
       textureIndex = (y - rc.top )/146;    // each box is 128 + 18 spacing

       switch(textureIndex)
       {
         case 0:
           PostMessage(hEditSideDefDlg,WM_COMMAND,MAKEWPARAM(psh1,(WORD)GetWindowLong(hEditSideDefDlg, GWL_ID)), 0); // upper
           break;
         case 1:
           PostMessage(hEditSideDefDlg,WM_COMMAND,MAKEWPARAM(psh2,(WORD)GetWindowLong(hEditSideDefDlg, GWL_ID)), 0); // normal
           break;
         case 2:
           PostMessage(hEditSideDefDlg,WM_COMMAND,MAKEWPARAM(psh3,(WORD)GetWindowLong(hEditSideDefDlg, GWL_ID)), 0); // lower
           break;
         default:
           break;
       }
   }
}
//-- right button up in pictures is cancel
#pragma argsused
void LEdit_OnRButtonUp(HWND hwnd, int x, int y, UINT keyFlags)
{
   if (MouseAlign)
   {   ReleaseCapture();
       MouseAlign = FALSE;
   }

   if (hEditSideDefDlg)
   {   PostMessage(hEditSideDefDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hEditSideDefDlg, GWL_ID)), 0);
   }
}

////////////////////////////////////////////////////////////////////////////////
// This function is called when the mouse button is pressed                   //
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void LEdit_OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
  SetCapture(hwnd);
  MouseAlign = TRUE;
  PriorX = x;
  PriorY = y;
  olddragx=0;
  olddragy=0;
  oldXalign = Xoff;
  oldYalign = Yoff;
}

////////////////////////////////////////////////////////////////////////////////
// This function is called when the mouse button is released		            //
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void LEdit_OnLButtonUp(HWND hwnd, int x, int y, UINT keyFlags)
{
   ReleaseCapture();
   MouseAlign = FALSE;
   ShowMouseAlignment(hwnd);
   PostMessage(GetParent(GetParent(hwnd)), WM_COMMAND, WM_MOUSEALIGN_BACK, 0);
}
////////////////////////////////////////////////////////////////////////////////
//  Called when ever the mouse moves                                          //
////////////////////////////////////////////////////////////////////////////////
#pragma argsused
void LEdit_OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags)
{
  if(MouseAlign)
  {
     dragx = PriorX - x;          //xorg
     dragy = PriorY - y;          //yorg

     if (dragx!= olddragx || dragy!=olddragy)
     {
         Xoff=int2(oldXalign + dragx);
         Yoff=int2(oldYalign + dragy);

         //if(Xoff > 256)   Xoff = 256;
         //if(Xoff < -256)  Xoff = -256;
         //if(Yoff > 128)   Yoff = 128;
         //if(Yoff < -128)  Yoff = -128;
         // each texture can have different values so user has to decide on maxs (in F5 maps)
         if(Xoff > XoffHigh+1) Xoff = XoffHigh+1;
         if(Xoff < XoffLow -1) Xoff = XoffLow -1;
         if(Yoff > YoffHigh+1) Yoff = YoffHigh+1;
         if(Yoff < YoffLow -1) Yoff = YoffLow -1;

         olddragx = dragx;
         olddragy = dragy;

         ShowMouseAlignment(hwnd);
     }
  }
}

///////////////////////////////////////////////////////////////////////////////
//
//  The Deep Line Edit Preview Window Procedure
//
// all we handle is WM_PAINT messages for now
//
///////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK LEditPrevWndProc(WINDOWS_PARAMS)
{
  switch(msg)
  {
	 HANDLE_MSG(hwnd, WM_PAINT, 			LEdit_OnPaint);

    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, LEdit_OnLButtonDBLCLK);

	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN,   LEdit_OnLButtonDown);
	 HANDLE_MSG(hwnd, WM_LBUTTONUP,     LEdit_OnLButtonUp);

    HANDLE_MSG(hwnd, WM_RBUTTONUP,     LEdit_OnRButtonUp);

	 HANDLE_MSG(hwnd, WM_MOUSEMOVE,     LEdit_OnMouseMove);

	 default:
		return LEdit_DefProc(hwnd, msg, wParam, lParam);
  }
}


// 12-25-96 bk  Code Starts here for EditThing mods

 static int2   skillval   [16]   = {0};
 static int2   oldskillval[16]   = {0};   //   3-1-97 keep together easier ref

/////////////////////////////////////////////////////////
// WM_CTLCOLOR
/////////////////////////////////////////////////////////
#pragma argsused
HBRUSH Thing_OnCtlColor(HWND hwnd, HDC hdc, HWND hwndChild, int type)
{

 switch (type)
  {
    //case CTLCOLOR_DLG:     // For The background on the dialog box
    //return GetStockBrush(LTGRAY_BRUSH);

   case CTLCOLOR_BTN:
   case CTLCOLOR_STATIC:

    SetTextColor(hdc, PALETTERGB(0, 0, 0));

    if(Button_GetCheck(GetDlgItem(hwnd, IDD_THINGBOXALLSKILL)))   // Change All Skills is selected
    {
      SetBkMode(hdc, TRANSPARENT);

      if(hwndChild == GetDlgItem(hwnd, stc1) ) // Easy Text
      {      if(skillval[0]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(skillval[0]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(skillval[0]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
      if(hwndChild == GetDlgItem(hwnd, stc2) ) // Med Text
      {      if(skillval[1]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(skillval[1]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(skillval[1]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
      if(hwndChild == GetDlgItem(hwnd, stc3) ) // Hard Text
      {      if(skillval[2]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(skillval[2]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(skillval[2]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
      if(hwndChild == GetDlgItem(hwnd, stc4) ) // Deaf Text 3-1-98 was backwards with stc5
      {      if(skillval[3]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(skillval[3]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(skillval[3]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }
      if(hwndChild == GetDlgItem(hwnd, stc5) ) // Net Text
      {      if(skillval[4]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
        else if(skillval[4]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
        else if(skillval[4]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
      }

      if (GameVersion <=2
      &&  BOOMSupport)
      {
          if(hwndChild == GetDlgItem(hwnd, stc6 ) ) // NOT DM
          {  if     (skillval[5]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
             else if(skillval[5]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
             else if(skillval[5]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
          }
          if(hwndChild == GetDlgItem(hwnd, stc7 ) ) // NOT COOPText
          {  if     (skillval[6]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
             else if(skillval[6]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
             else if(skillval[6]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
          }
      }

      if(GameVersion == 4)  // HEXEN
      {
         if(hwndChild == GetDlgItem(hwnd, stc8) ) // Fighter
         {      if(skillval[5]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
           else if(skillval[5]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
           else if(skillval[5]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
         }
         if(hwndChild == GetDlgItem(hwnd, stc9) ) // Cleric
         {      if(skillval[6]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
           else if(skillval[6]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
           else if(skillval[6]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
         }
         if(hwndChild == GetDlgItem(hwnd, stc10) ) // Mage
         {      if(skillval[7]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
           else if(skillval[7]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
           else if(skillval[7]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
         }
         if(hwndChild == GetDlgItem(hwnd, stc11) ) // Single Player
         {      if(skillval[8]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
           else if(skillval[8]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
           else if(skillval[8]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
         }
         if(hwndChild == GetDlgItem(hwnd, stc12) ) // Cooperative
         {      if(skillval[9]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
           else if(skillval[9]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
           else if(skillval[9]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
         }
         if(hwndChild == GetDlgItem(hwnd, stc13) ) // Death match
         {      if(skillval[10]==0)    SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
           else if(skillval[10]==1)    SetTextColor(hdc, PALETTERGB(255, 0, 0)); // set
           else if(skillval[10]==2)    SetTextColor(hdc, PALETTERGB(0, 0, 0));   // No change
         }
      }

      return GetStockBrush(NULL_BRUSH);

    }
    break;

  }  // type

  return NULL;
}

//===========================================================================
// Turn the Skill Check Marks On or Off
//===========================================================================
void SetSkillCheck(HWND hDlg)
{
     if (skillval[0]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXEASY), 1);
     else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXEASY), 0);
     if (skillval[1]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXMED), 1);
     else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXMED), 0);
     if (skillval[2]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXHARD), 1);
     else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXHARD), 0);
     if (skillval[3]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXDEAF), 1);
     else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXDEAF), 0);
     if (skillval[4]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNET), 1);
     else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNET), 0);

     InvalidateRect(GetDlgItem(hDlg, stc1), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc2), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc3), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc4), NULL, TRUE);
     InvalidateRect(GetDlgItem(hDlg, stc5), NULL, TRUE);

     if (GameVersion <=2
     &&  BOOMSupport)
     {
         if (skillval[5]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNOTDM),  1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNOTDM),  0);
         if (skillval[6]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNOTCOOP),1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNOTCOOP),0);
         InvalidateRect(GetDlgItem(hDlg, stc6), NULL, TRUE);
         InvalidateRect(GetDlgItem(hDlg, stc7), NULL, TRUE);
     }

     if ( GameVersion == 4 )        // HEXEN
     {
         if (skillval[5]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXFIGHTER), 1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXFIGHTER), 0);
         if (skillval[6]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXCLERIC), 1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXCLERIC), 0);
         if (skillval[7]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXMAGE), 1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXMAGE), 0);
         if (skillval[8]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXSINGLE), 1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXSINGLE), 0);
         if (skillval[9]) Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXCOOP), 1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXCOOP), 0);
         if (skillval[10])Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXDEATH), 1);
         else             Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXDEATH), 0);

         InvalidateRect(GetDlgItem(hDlg, stc8), NULL, TRUE);
         InvalidateRect(GetDlgItem(hDlg, stc9), NULL, TRUE);
         InvalidateRect(GetDlgItem(hDlg, stc10), NULL, TRUE);
         InvalidateRect(GetDlgItem(hDlg, stc11), NULL, TRUE);
         InvalidateRect(GetDlgItem(hDlg, stc12), NULL, TRUE);
         InvalidateRect(GetDlgItem(hDlg, stc13), NULL, TRUE);
     }
}

//==========================================================================
// Turn the Skill window on and off
//==========================================================================
static void SkillWindow(HWND hDlg, Bool state)
{
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXEASY), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXMED), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXHARD), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXDEAF), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXNET), state);

   if(!BOOMSupport         // not BOOM
   ||  GameVersion > 2)    // not DOOM
   {    state = FALSE;
   }

   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXNOTDM  ), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXNOTCOOP), state);

   if(GameVersion != 4)  state = FALSE;

   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXFIGHTER), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXCLERIC), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXMAGE), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXSINGLE), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXCOOP), state);
   EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXDEATH), state);
}

//===========================================================================
// Fill Skillval array with Checkmark status  rename   3-1-97
//===========================================================================
void ReadSkillCheckMarks(HWND hDlg)
{
     if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXEASY) ))
          skillval[0] = 1;
     else skillval[0] = 0;
     if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXMED) ))
          skillval[1] = 1;
     else skillval[1] = 0;
     if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXHARD) ))
          skillval[2] = 1;
     else skillval[2] = 0;
     if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXDEAF) ))
          skillval[3] = 1;
     else skillval[3] = 0;
     if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXNET) ))
          skillval[4] = 1;
     else skillval[4] = 0;

     if (GameVersion <=2
     &&  BOOMSupport)
     {
         if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXNOTDM) ))
              skillval[5] = 1;
         else skillval[5] = 0;
         if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXNOTCOOP) ))
              skillval[6] = 1;
         else skillval[6] = 0;
     }

     if(GameVersion == 4)
     {
        if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXFIGHTER) ))
             skillval[5] = 1;
        else skillval[5] = 0;
        if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXCLERIC) ))
             skillval[6] = 1;
        else skillval[6] = 0;
        if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXMAGE) ))
             skillval[7] = 1;
        else skillval[7] = 0;
        if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXSINGLE) ))
             skillval[8] = 1;
        else skillval[8] = 0;
        if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXCOOP) ))
             skillval[9] = 1;
        else skillval[9] = 0;
        if(Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXDEATH) ))
             skillval[10] = 1;
        else skillval[10] = 0;

     }
}

//============================================================================
// get the skill flags as set in first thing in list   3-1-97
//============================================================================
void GetCurrentThingSkill (int2 objnum)
{
     skillval[0] = GetSkillFlag( objnum, 1);      // 1  0 1/2
     skillval[1] = GetSkillFlag( objnum, 2);      // 2  1 3
     skillval[2] = GetSkillFlag( objnum, 3);      // 3  2 4/5
     skillval[3] = GetSkillFlag( objnum, 4);      // 4  3 deaf
     skillval[4] = GetSkillFlag( objnum, 5);      // 5  4 multi  (dormant)

     skillval[5] =-1;  // -1 req'd for all box stuff
     skillval[6] =-1;
     skillval[7] =-1;
     skillval[8] =-1;
     skillval[9] =-1;
     skillval[10]=-1;

     if (GameVersion <=2
     &&  BOOMSupport)
     {   skillval[5] = GetSkillFlag( objnum, 6);      // 6  5 NOT DM  BOOM
         skillval[6] = GetSkillFlag( objnum, 7);      // 7  6 NOT COOP
     }

     if ( GameVersion == 4 )        // HEXEN
     {
         skillval[5]  = GetSkillFlag( objnum, 6);   // 6  5 fighter)
         skillval[6]  = GetSkillFlag( objnum, 7);   // 7  6 cleric
         skillval[7]  = GetSkillFlag( objnum, 8);   // 8  7 Mage

         skillval[8]  = GetSkillFlag( objnum, 9);   // 1  8 single
         skillval[9]  = GetSkillFlag( objnum,10);   // 2  9 coop
         skillval[10] = GetSkillFlag( objnum,11);   // 3  10 deathmatch

     }
}

///////////////////////////////////////////////////////////////////////////////
//
//  The Deep THING EDIT Dialog Procedure , Enter on Thing or Right Click
//
// 1-1-97 bk added coordinates for thing
///////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK EditThingDlgProc(DIALOG_PARAMS)
{
   LevelPtr level = &LevelWad.level;
   LPDLGSELECT lpsel;            //Our Long Pointer to DlgSelectList
   SelPtr cur;

   HMENU  hMenu;
   UINT   flags, item, Id;       // to determine Menu Selection
   int2   Id1;
   int2   newtype;
   int2   LowordThingCommand;

   char   szBuf[128];

static int2 changeallangles   = 1;  // all angles changed
static int2 oldchangeallangles= 1;  // all angles changed (by user here)
static int2 setSkillBits      = 0;  // all thing skills
static int2 OldHeight;
static Bool usedPolyId;          // if PolyId, don't set the angle field

   uint2  thingnum;               // manual input of thing #

   static int2   degree  [8];
   int2   angle, n;
   int2   NewDegree;
   int2   OldDegree;

   int2   NextFreeTid;
   int2   tid;
   char   prompt[60];

   uint2  clearflag;            // bits to clear
   uint2  setflag;              // bits to set
   uint2  NewFlag;              // all bits to set

   static int2 HxMode;         // Don't ask

   static UINT codeNotify;     // WM_COMMAND codes for our thing colors
   static HWND hwndCtl;
   static HWND hTInstructDlg = NULL;  // Instruction Thing Modeless Dlg.

   RECT   rc;

static POINT EntryCurPos;             //   12-16-96
       POINT PriorCurPos;             //   12-2-96

       int2  xpos, ypos;              // position of thing coords

       TypeThingPtr  OldThingNames ;  // For saving Hexen Spawn Names
//---------------------------------------------------------------------------

   ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

   GetCursorPos( &PriorCurPos );   //   12-16-96 remember

   switch( msg )
   {
      case WM_INITDIALOG:

       GetCursorPos( &EntryCurPos );   //   12-16-96 remember

       SetWindowLong(hDlg, DWL_USER, lParam);    // store our Pointer
       lpsel = (LPDLGSELECT)lParam;              // grab it for our use

       ForgetSelection( &TempList);            // safety

       if  (SelectList)
       {    TempList = SelectList;
       }
       else
       {   if(CurObject >= 0)
           {   SelectObject( &TempList, CurObject);
           }
           else
           { EndDialog( hDlg, FALSE );
             return FALSE; // No current object, no SelectList
           }
       }
       gd.DestroyModeless=TRUE;

       thingmenuval   =  -1;

       ThingType =  level->Things[ TempList->objnum].type;
       OldType   =  ThingType;
       OldHeight =  level->Things[ TempList->objnum].height;

       // for polyobjects-do not set the angle
       if (GameVersion == 4 && ( OldType >= 3000 && OldType <= 3002) )
       {   usedPolyId = TRUE;                                         // no angle change
           SetThingDefArgs(ThingType);  // set arg names for THING   3-1-97 trying to fix exception may not be needed
       }
       else
       {   usedPolyId = FALSE;                                        // angle change
       }

       // show thing in big thing box

       oldBigThingName = "";        // force showthing in big box
       if (TempList->objnum >=0)
       {
            ShowThing (GetDlgItem(hDlg, IDD_THINGEDITPREV), 2, level->Things[TempList->objnum].type);
       }

       GetCurrentThingSkill(TempList->objnum);                //   3-1-97 skill for 1st Thing
       if ( GameVersion != 4 )                                //   3-1-97 not HEXEN
       {   EnableWindow(GetDlgItem(hDlg, psh1), 0);
           EnableWindow(GetDlgItem(hDlg, psh2), 0);
       }

       SetSkillCheck(hDlg);    // Update our Checkmarks

       // copy original settings

       for (n=0; n < 11; n++)
       {    oldskillval[n] = skillval[n];
       }

       if (changeallangles == 1)           // All buttons Active
       {
           Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXALLANGLE), 1);
           SkillWindow(hDlg, TRUE);
           setSkillBits = 0;               //   3-1-97
       }
       else
       if (setSkillBits)                   //   3-1-97
       {
          for (n=0; n < 11; n++)
              skillval[n] = 2;             // No change for Colors

          Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXALLSKILL), 1);
          SkillWindow(hDlg, FALSE);
          changeallangles = 0;             // angles not active if skill bits set
       }

       oldchangeallangles = changeallangles;

       for (n=0; n< 8 ; n++)
       {    degree[n]=0;
       }

       // original value
       OldDegree = int2((level->Things[ TempList->objnum].angle )/45);    // show existing
       degree[OldDegree] = 1;

       if(degree[0] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXE), 1);
       if(degree[1] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNE), 1);
       if(degree[2] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXN), 1);
       if(degree[3] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXNW), 1);
       if(degree[4] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXW), 1);
       if(degree[5] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXSW), 1);
       if(degree[6] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXS), 1);
       if(degree[7] != 0)  Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXSE), 1);

       GetWindowRect(hDlg, &rc);
       MoveWindow(hDlg, pThingDlgPos.x, pThingDlgPos.y, rc.right - rc.left, rc.bottom - rc.top, FALSE);

       xpos = level->Things[ TempList->objnum].xpos;
       ypos = level->Things[ TempList->objnum].ypos;

       SetDlgItemInt(hDlg, edt1, xpos, TRUE);
       SetDlgItemInt(hDlg, edt2, ypos, TRUE);


       // store our position globally for menu positioning
 	  	 //GetWindowRect(GetDlgItem(hDlg, IDD_THINGEDITPREV), &rcMenu);
 	  	 GetWindowRect(GetDlgItem(hDlg, IDD_THINGEDITPREV), &rcThingMenu);

       if(lpsel->b2) // called from mouse click on bottom
       {  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(lpsel->post,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
          Sleep(20); // try not to pass LBUTTONDOWN MSG to dialog
       }
       else
       {
          GetWindowRect(GetDlgItem(hDlg, IDD_CHANGETYPE), &rc);
          SetCursorPos(rc.left + 32, rc.top + 16);   // 3-1-98
       }
       //  x = pOldCurPos.x;
       //  y = pOldCurPos.y;
       return TRUE;



      ///////////////////////////////////////////////////////////////
      // This works the same as Displaying Help text on the Status //
      // Bar, except we use the menu ID to display the correct Pic //
      ///////////////////////////////////////////////////////////////
      case WM_MENUSELECT:
       flags   = GET_WM_MENUSELECT_FLAGS(wParam, lParam) & 0xffff;
       item    = GET_WM_MENUSELECT_CMD(wParam, lParam);
       hMenu   = GET_WM_MENUSELECT_HMENU(wParam, lParam);

       Id = 0;

       if (flags == 0xffff && hMenu == NULL)// Menu has been closed
       {  Id = (UINT)-1;
       }
       else if (flags & MFT_SEPARATOR)      // Ignore separators
       {  Id = 0;
       }
       else if (flags & MF_POPUP)           // Popup menu
       {  if (flags & MF_SYSMENU)           // System menu
          {   Id = 0;
          }
       }  // for MF_POPUP
       else                                 // Must be a command item
       {   Id = item;                       // String ID == Command ID
       }

       Id1 = (int2)Id;                      // cast to int2 for < 0 comparison

       if( (Id1 -CM_1) >= 0 )               // -2001
       {                                    // valid pick from menu's
           if(HxMode == 3)
           ShowMenuSelect(hDlg, int2(Id1 -CM_1), FALSE);//False convert to thing id #
       }
       else//mode: 2=outside call, display existing  0/1 from menu call
       {
           // ShowThing (GetDlgItem(hDlg, IDD_THINGEDITPREV), 2, int2(Id-599) );
       }
       break;
      // right button is now cancel
      case WM_RBUTTONUP:
        if(!PopupMenu)
        {   PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
        }
        break;
      //   6-1-97
      // left button is OK
      case WM_LBUTTONUP:
        if (!PopupMenu && !setSkillBits)// too easy to do in flag mode
        {   PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
        }
        break;

      case WM_CTLCOLORSTATIC:
        return HANDLE_WM_CTLCOLORBTN(hDlg, wParam, lParam, Thing_OnCtlColor);
      //case WM_CTLCOLORDLG:
      //  return HANDLE_WM_CTLCOLORDLG(hDlg, wParam, lParam, Thing_OnCtlColor);

      case WM_COMMAND:

       LowordThingCommand = LOWORD(wParam);
       codeNotify = (UINT)HIWORD(wParam);
       hwndCtl    = (HWND)(lParam);

		 switch (LowordThingCommand)
       {
          case IDCANCEL:
            // if(menuval2 >= 0)
            // for(cur=TempList; cur; cur=cur->next)
            // level->Things[ cur->objnum].type = OldType;   // Restore Old Type
            if (hTInstructDlg)
            {   DestroyWindow(hTInstructDlg);   // 1-11-97 bk
                hTInstructDlg = NULL;
            }

            GetWindowRect(hDlg, &rc);
            pThingDlgPos.x = rc.left;
            pThingDlgPos.y = rc.top;

            if (!SelectList)
            {   ForgetSelection( &TempList); // get rid of old list
            }
            else
            {  TempList = NULL;             // reset since this is Selectlist
            }

            gd.DestroyModeless=FALSE;
            EndDialog( hDlg, FALSE );
            SetCursorPos(EntryCurPos.x, EntryCurPos.y);//   12-16-96
            return TRUE;

          case stc1:    // Easy
          case stc2:    // Med
          case stc3:    // Hard
          case stc4:    // Deaf
          case stc5:    // Net

          case stc6:    // NotDM   BOOM  3-1-98
          case stc7:    // notCOOP BOOM

          case stc8:    // Fighter, Cleric, Mage, S.P., Co-op, D.M.
          case stc9:
          case stc10:
          case stc11:
          case stc12:
          case stc13:
            n = (LowordThingCommand - stc1); // stc1 == 440 in DLGS.H

            //   3-1-97 made positive logic

            if (setSkillBits)                 // toggle set by bit is active
            {   skillval[n]++;                // Dos was > 3
                if (skillval[n] > 2) skillval[n] = 0;
            }
            else
            {   skillval[n] = !skillval[n];   // toggle bit flag
            }

            //InvalidateRect(GetDlgItem(hDlg, (n + stc1)), NULL, TRUE); // Paint it
            InvalidateRect(GetDlgItem(hDlg, LowordThingCommand), NULL, TRUE); // Paint it 3-1-98
          break;


          // Clear/Set All Skills Radio Button Clicked on

          case IDD_THINGBOXALLSKILL:
            if (codeNotify == BN_CLICKED)              // clicked on All Skills
            {   // 1-10-97 bk
                //EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXALLANGLE), FALSE);//just for now
                // 1-11-97 bk
                if(!hTInstructDlg)
                {   hTInstructDlg = CreateDialogParam(gd.hInst, "InstructionFlag", hDlg, InstructionFlagDlgProc, 0);//   3-1-97
                }

                //   3-1-97
                if(Button_GetCheck(hwndCtl)           // all skill checked, angles n/a
                && setSkillBits == 0)                 // turn bit toggle off   3-1-97
                {
                   //Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXALLSKILL), 1); // all skill on

                   //ReadSKillCheckMarks(hDlg); // Get Current Skill Settings in case changed
                                         // Don't get notified when CheckBox's
                                         // Clicked when Allangle active
                                         // so have to re-read to get current skill status

                   GetCurrentThingSkill(TempList->objnum); //   3-1-97 thing value, easier to follow

                   // copy original settings

                   for (n=0; n < 11; n++)
                   {    oldskillval[n]=skillval[n];
                        skillval[n] = 2;             // No change for Colors
                   }

                   SetSkillCheck(hDlg);  // Update the Checkmarks with skillvar
                                         // Update Text with proper Colors

                   SkillWindow(hDlg, FALSE); // Turns Checkmarks Active+text

                   changeallangles = 0;      //   3-1-97
                   setSkillBits    = 1;
                }
                oldchangeallangles = changeallangles;
            }
            break;



          // All Angles Radio Button Clicked on

          case IDD_THINGBOXALLANGLE:
            if (codeNotify == BN_CLICKED)              // clicked on All Angles
            {   // 1-10-97 bk
                //EnableWindow(GetDlgItem(hDlg, IDD_THINGBOXALLSKILL), FALSE);//just for now
                // 1-11-97 bk
                if (hTInstructDlg)
                {   DestroyWindow(hTInstructDlg);
                    hTInstructDlg = NULL;
                }

                if(Button_GetCheck(hwndCtl)           // all skill checked, Box back to BLACK
                && changeallangles == 0)              // not checked yet   3-1-97
                {
                   //Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXALLANGLE), 1);
                   GetCurrentThingSkill(TempList->objnum);                //   3-1-97
                   for (n=0; n < 11; n++)
                   {    //if (skillval[n]== 2)     skillval[n] = oldskillval[n];
                        oldskillval[n] = skillval[n]; // copy as original
                   }

                   SkillWindow(hDlg, TRUE); // Turn check marks & text ON
                   changeallangles = 1;
                   oldchangeallangles = changeallangles;
                   setSkillBits    = 0;

                   SetSkillCheck(hDlg);

                 }
                 else     //   3-1-97 NOT all angles
                 {  changeallangles = 0;
                    Button_SetCheck(GetDlgItem(hDlg, IDD_THINGBOXALLANGLE), 0);
                 }
            }
            break;


           ////////////////////////////////////////////////////////////////////
           //                                                                //
           //     start of Button Code -                                     //
           //                                                                //

           case psh1:                   // Thing Height
             if (GameVersion == 4)
             {
                 sprintf( szBuf, "%hd %-.22s", TempList->objnum , GetThingPrintName( level->Things[TempList->objnum].type) );

                 if (InputNumbers(hDlg, szBuf, -32000,32000,&OldHeight, PointerX, PointerY) )
                 {    for (cur = TempList; cur; cur = cur->next)
                      {
                          if(level->Things[ cur->objnum].height != OldHeight) //   3-1-97
                          {  level->Things[ cur->objnum].height= OldHeight;
                             level->MadeChanges++;
                          }
                      }
                 }
             }
             break;


           case psh2:                   // Poly ID
             if (GameVersion == 4)
              { if (!usedPolyId)      // this is not a poly object
                {   HelpMsg(hDlg,CENTER|HELPHELP, "Field not Valid",
                              " This Field is only valid",
                              " for HEXEN poly objects",
                              NULL);
                }
                else
                {  GetThingPolyIdNumber(hDlg,level,TempList); // in EDIT.CPP
                }
              }
             break;

          //   3-1-97 swithed to help
          //     RED  - SETS that Flag",
          //     BLUE - CLEARS that Flag",
          //     BLACK- NO CHANGE to the Flag",
          case IDHELP:
             HelpOpened = WinHelp(hDlg, HelpName, HELP_KEY,
                               (DWORD)"Edit Thing - Type and Flags");
             break;


          case IDD_CHANGETYPE:
             HxMode = 3;
				 HandleEditThingMenu(hDlg);   // Grabs the menu entries for THINGS

             //2-20-97 bk  Changed Focus to OK button after ChangeType !!
             SetFocus(GetDlgItem(hDlg, IDOK));     // Default Push Button 1
             Button_SetStyle(GetDlgItem(hDlg, IDOK), BS_DEFPUSHBUTTON, TRUE);
             return TRUE;                  // Returns below depending on Game Type


         	case IDOK: // 3 way radio button 0 - 2, White, Blue, Black
             if(hTInstructDlg)
             {  DestroyWindow(hTInstructDlg);
                hTInstructDlg = NULL;
             }
             GetWindowRect(hDlg, &rc);
             pThingDlgPos.x = rc.left;
             pThingDlgPos.y = rc.top;

             // Update skillvar according to below

             for(n=0;n<11;n++)         //  0 = Clear, 1 = Set,  2 = keep oldvalue
             {  if(setSkillBits)       // Keep old - same so setflag / clearflag
                {  if(skillval[n] == 2)
                      skillval[n] = oldskillval[n]; // doesn't change it
                   else
                   if(skillval[n] == 0 && oldskillval[n] == 0)
                      oldskillval[n] = 1;
                   else
                   if(skillval[n] == 1 && oldskillval[n] == 1)
                      oldskillval[n] = 0;
                }
                else   // if NOT set all skill
                {
                   ReadSkillCheckMarks(hDlg); // sets skillval according to ChkBox
                }
              }

             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXE)))   degree[0] = 1;
             else degree[0] = 0;
             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXNE)))  degree[1] = 1;
             else degree[1] = 0;
             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXN)))   degree[2] = 1;
             else degree[2] = 0;
             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXNW)))  degree[3] = 1;
             else degree[3] = 0;
             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXW)))   degree[4] = 1;
             else degree[4] = 0;
             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXSW)))  degree[5] = 1;
             else degree[5] = 0;
             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXS)))   degree[6] = 1;
             else degree[6] = 0;
             if (Button_GetCheck(GetDlgItem(hDlg, IDD_THINGBOXSE)))  degree[7] = 1;
             else degree[7] = 0;

	          for (NewDegree=0; NewDegree< 8 ; NewDegree++)
	          {    if( degree[NewDegree]) break;
	          }
	          angle = int2(NewDegree*45);

             // make new skill flag
	          NewFlag = 0;

             if (GameVersion == 4 )               // HEXEN
             {
	              for (n=0; n< 16; n++)
	              {   if (skillval[n])
	                  {   NewFlag  =int2( NewFlag ^ (0x01 << n) );
		               }
                 }
	          }
             else                        // For Not Change All Skills
             {                           // If any Skill Values are
                 if (GameVersion <=2
                 &&  BOOMSupport)
                 {
	                 for (n=0; n< 7; n++)  // set, then set the corresponding
	                 {   if (skillval[n])  // bit in NewFlag
	                     {   NewFlag  =int2( NewFlag ^ (0x01 << n) );
	                     }
                    }
                 }
                 else
	              for (n=0; n< 5; n++)     // set, then set the corresponding
	              {   if (skillval[n])     // bit in NewFlag
	                  {   NewFlag  =int2( NewFlag ^ (0x01 << n) );
	                  }
                 }
	          }

             // set angle only if polyid was not used
             if (!usedPolyId)
             {
                  if (level->Things[ TempList->objnum].angle!= angle)
                  {   level->Things[ TempList->objnum].angle= angle;  // for only 1 thing
	                   level->MadeChanges++;
                  }
             }

             clearflag = 0xffff;
             setflag   = 0;

             for (n=0; n < 11; n++)
             {
                if (oldskillval[n] != skillval[n] )  // diff
                {
                    if (skillval[n] == 1)           // BLUE
                    {   setflag   = int2( setflag | (0x01 << n) );       // set this bit
                    }
                    else                            // BLACK
                    {   clearflag = int2( clearflag ^ (0x01 << n) );    // clear this bit
                    }
                }

             }

	          for (cur = TempList; cur; cur = cur->next)
	          {    uint2 oldFlag;

                  if (!setSkillBits)
	               {   if(level->Things[ cur->objnum].when  != NewFlag)
                      {  level->Things[ cur->objnum].when  = NewFlag;    // replace
	                      level->MadeChanges++;
                      }
                  }
                  else
                  {   oldFlag = level->Things[ cur->objnum].when;
		                level->Things[ cur->objnum].when  |= setflag;   // set bit
		                level->Things[ cur->objnum].when  &= clearflag; // clear bit
	                   if(level->Things[ cur->objnum].when != oldFlag)
                      {  level->MadeChanges++;
                      }
                  }

		            if (changeallangles == 1   // change all angles
                  && !usedPolyId             // not is polyid
                  && !setSkillBits)          // not if bits safety
		            {   if(level->Things[ cur->objnum].angle != angle)
		                {  level->Things[ cur->objnum].angle = angle;
                         level->MadeChanges++;
                      }
		            }
	          }


             if(thingmenuval >= 0) // normal menu selected in all GameVersions
             {
                for (cur = TempList; cur; cur = cur->next)
	             {
                  newtype  = level->Things[cur->objnum].type;      // old type

	               if (newtype != menuval2)
                  {
	                  level->Things[ cur->objnum].type = menuval2;  // new type
       	            level->MadeChanges++;                         // made a change no need nodes

                     if( (GameVersion == 4) && ( newtype >=3000    // old a polyobject,
                                            &&  newtype <= 3002) ) // reset polyid# = new angle to 0
                     {  level->Things[ cur->objnum].angle = 0;     // reset to valid angle
                     }
	               }
	             }
             }

             //for (cur = TempList; cur; cur = cur->next) //   3-1-97 only do for 1 I think
             cur = TempList;
             if (cur)
	          {
                // Update Thing Position if changed ( Need to compare old pos ? )
                if (IsItCalculator(hDlg,edt1)) return TRUE;
                if (IsItCalculator(hDlg,edt2)) return TRUE;

                xpos = (int2)GetDlgItemInt(hDlg, edt1, NULL, TRUE);
                ypos = (int2)GetDlgItemInt(hDlg, edt2, NULL, TRUE);

                if(xpos > -32000 && xpos < 32000)
                {
                   if (level->Things[ cur->objnum].xpos!= xpos) //   3-1-97
                   {   level->Things[ cur->objnum].xpos= xpos;  //   3-1-97
       	              level->MadeChanges++;                    //
                   }
                }
                if(ypos > -32000 && ypos < 32000)
                {  if (level->Things[ cur->objnum].ypos!= ypos) //   3-1-97
                   {   level->Things[ cur->objnum].ypos= ypos;  //   3-1-97
       	              level->MadeChanges++;                    //
                   }
                }
	           }

             if (!SelectList)
             {   ForgetSelection( &TempList); // get rid of old list
             }
             else
             {  TempList = NULL;             // reset since this is Selectlist
             }

             oldchangeallangles = changeallangles;

             gd.DestroyModeless=FALSE;
             EndDialog( hDlg, TRUE );    	//  Cause DialogBoxParam to return TRUE
             //        hdc , RECT    , Erase Bk, Palette in
             RedrawMap(NULL, &gd.rcClient, ERASEYES, FALSE);

             SetCursorPos(EntryCurPos.x, EntryCurPos.y);//   12-16-96
             return TRUE;



            /////////////////////////////////////////////////////////////////
            //                                                             //
            //    Start of Thing Menu Display routines                     //
            //                                                             //

            // D O O M -------------------

         	case CM_TM1:                  // Enter thing Number
	           thingnum = level->Things[ TempList->objnum].type;
	           //if (! InputNumbers(hDlg, "Thing Type", 0,11111,&thingnum, PointerX, PointerY) )
              if (! InputThingType(hDlg, "Thing Type",&thingnum, PointerX, PointerY) )
		        {   thingmenuval=-1;                          // exited
              }
              else
              {  ShowMenuSelect(hDlg, thingnum, TRUE);
                 for (cur = TempList; cur; cur = cur->next)
	              {   if (level->Things[ cur->objnum].type != thingnum)
                     {   level->Things[ cur->objnum].type = thingnum;
                         level->MadeChanges++;       // 3-1-98
                     }
                 }
              }
              ThingType = level->Things[ TempList->objnum].type;
              OldType   = thingnum;
              break;

         	case CM_TM2:                  // Player Start
         	case CM_TM3:                  // Keys
         	case CM_TM4:                  // Equipment
         	case CM_TM5:                  // Weapons
         	case CM_TM6:                  // Ammo
         	case CM_TM7:                  // Enenmies
         	case CM_TM8:                  // Decorations
         	case CM_TM9:                  // Light sources
         	case CM_TM10:                 // Corpses
         	case CM_TM11:                 // Hanging Corpses
         	case CM_TM12:                 // BOOM stuff

	           //DisplayThingsMenu(hDlg, DoomThingList[id - CM_TM2].type);
	           DisplayThingsMenuX(hDlg, DoomThingList, LowordThingCommand);   // 3-1-98 because new DoomThingList has new entries
              break;

            // H E R E T I C ---------------------------------------------------

         	case CM_TMH1:                  // Enter thing Number
	           thingnum = level->Things[ TempList->objnum].type;

	           //if (! InputNumbers(hDlg, "Thing Type", 0,11111,&thingnum, PointerX, PointerY) )
              if (! InputThingType(hDlg, "Thing Type",&thingnum, PointerX, PointerY) )
		        {   thingmenuval=-1;                          // exited
              }
              else
              {  ShowMenuSelect(hDlg, thingnum, TRUE);
                 for (cur = TempList; cur; cur = cur->next)
	              {   if (level->Things[ cur->objnum].type != thingnum)
                     {   level->Things[ cur->objnum].type = thingnum;
                         level->MadeChanges++;       // 3-1-98
                     }
                 }
              }
              ThingType = level->Things[ TempList->objnum].type;
              OldType   = thingnum;
              break;
         	case CM_TMH2:                  // Player Start
         	case CM_TMH3:                  // Keys
         	case CM_TMH4:                  // Equipment
         	case CM_TMH5:                  // Weapons
         	case CM_TMH6:                  // Ammo
         	case CM_TMH7:                  // Enenmies
         	case CM_TMH8:                  // Decorations
         	case CM_TMH9:                  // Light sources
         	case CM_TMH10:                 // Corpses
         	case CM_TMH11:                 // Geology/Pods
         	case CM_TMH12:                 // Sounds
	           DisplayThingsMenu(hDlg, HereticThingList[LowordThingCommand - CM_TMH2].type);
              break;

            // HEXEN===========================================================

         	case CM_TMHX1:                  // Enter thing Number + TID
	           thingnum = level->Things[ TempList->objnum].type;
              tid      = level->Things[ TempList->objnum].tid;
              NextFreeTid = FindFreeTid();
              sprintf(prompt,"Tid (free-f%hd,last-u%hd",NextFreeTid,LastTidUsed );

              if (Input2Numbers(hDlg, prompt, "Thing (0-1111)", "Tid (0-1111)", 0,11111,&(int2)thingnum, 0,11111,&(int2)tid) )
	           {
                 for (cur = TempList; cur; cur = cur->next)
	              {   level->Things[ cur->objnum].type = thingnum;
                     level->Things[ cur->objnum].tid  = tid;
	              }
                 if (tid) LastTidUsed = tid; //   8-1-97 > 0
                 level->MadeChanges++;       // not F5 option screen
                 ShowMenuSelect(hDlg, thingnum, TRUE);
              }
              else
              {  thingmenuval=-1;              // exited
              }
              ThingType = level->Things[ TempList->objnum].type;
              OldType   = thingnum;
              SetThingDefArgs(ThingType);  // set arg names for THING   3-1-97 trying to fix exception may not be needed
              break;


         	case CM_TMHX2:                     // Displays Args
             InitThingCommand(TempList, level);// init special, type etc.
             EditThingCommand(hDlg,level, TempList,1); //rcMenu.right+20, rcMenu.top - 10,level,TempList,1);
             break;
         	case CM_TMHX3:                     // Displays Specials Menu
             InitThingCommand(TempList, level);
                                                                       //-10
             EditThingLineInfo(hDlg, rcThingMenu.right+20,rcThingMenu.top, TempList->objnum);
             break;

         	case CM_TMHX4:                  // Player Start
         	case CM_TMHX5:                  // Keys
         	case CM_TMHX6:                  // Artifacts
         	case CM_TMHX7:                  // Puzzle Items
         	case CM_TMHX8:                  // Weapons
         	case CM_TMHX9:                  // Health/Armor
         	case CM_TMHX10:                 // Enemies
         	case CM_TMHX11:                 // Gargoyle Statues
         	case CM_TMHX12:                 // Lights/Columns
         	case CM_TMHX13:                 // Bells/Pots/Mugs
         	case CM_TMHX14:                 // Corpses/Blood
         	case CM_TMHX15:                 // Fog/Stalacs/Icil
         	case CM_TMHX16:                 // Rocks/Moss
         	case CM_TMHX17:                 // Trees/Mushrooms
         	case CM_TMHX18:                 // Sounds

	           DisplayThingsMenu(hDlg, HexenThingList[LowordThingCommand - CM_TMHX4].type);
              break;

            // S T R I F E=====================================================

         	case CM_TMS1:                  // Enter thing Number
	          thingnum = level->Things[ TempList->objnum].type;
	          //if (! InputNumbers(hDlg, "Thing Type", 0,11111,&thingnum, PointerX, PointerY) )
             if (! InputThingType(hDlg, "Thing Type",&thingnum, PointerX, PointerY) )
		       {    thingmenuval=-1;                          // exited
             }
             else
              { ShowMenuSelect(hDlg, thingnum, TRUE);

                for (cur = TempList; cur; cur = cur->next)
	             {    if (level->Things[ cur->objnum].type != thingnum)
                     {   level->Things[ cur->objnum].type = thingnum;
                         level->MadeChanges++;       // 3-1-98
                     }
                }
              }
              break;

         	case CM_TMS2:                  // Player Start
         	case CM_TMS3:                  // Keys
         	case CM_TMS4:                  // Equipment
         	case CM_TMS5:                  // Equipment2
         	case CM_TMS6:                  // Weapons
         	case CM_TMS7:                  // Ammo
         	case CM_TMS8:                  // Enemies
         	case CM_TMS9:                  // Enemies2
         	case CM_TMS10:                 // Rebels
         	case CM_TMS11:                 // Beggars
         	case CM_TMS12:                 // Peasants
         	case CM_TMS13:                 // Shop Keepers
         	case CM_TMS14:                 // Decorations
         	case CM_TMS15:                 // Light Sources
            case CM_TMS16:                 // corpses
         	case CM_TMS17:                 // Geology
            case CM_TMS18:                 // trees
            case CM_TMS19:                 // pillars/statues
         	case CM_TMS20:                 // Hints
	           DisplayThingsMenu(hDlg, StrifeThingList[LowordThingCommand - CM_TMS2].type);
              break;



            //////////////////////////////////////////////////////
            //                                                  //
            //     Sub Menus for HEXEN  -  ThingLine, Spawn     //
            //////////////////////////////////////////////////////

            // Thing Line Menu H E X E N

            case CM_TLMHX1:                 // "Normal (no menu)"          // 2
               SetLineDefArgs(0,0);   // set arg names to null
               break;

            case CM_TLMHX2:                 // "All Doors",                // 3
            case CM_TLMHX3:                 //"Ceilings",                  // 4
            case CM_TLMHX4:                 //"Crushers",                  // 5
            case CM_TLMHX5:                 //"Floors Raise",              // 6
            case CM_TLMHX6:                 //"Floors Lower",              // 7
            case CM_TLMHX7:                 //"Stairs",                    // 8
            case CM_TLMHX8:                 //"Lifts & Pillars",           // 9
            case CM_TLMHX9:                 //"Lights",                    // 10
            case CM_TLMHX10:                //"Special",                   // 11
            case CM_TLMHX11:                //"Poly Objects",              // 12
            case CM_TLMHX12:                //"Thing Specials",            // 13
            case CM_TLMHX13:                //"Scripts",                   // 14

              HxMode = 2;                     // Set up Mode for return

	           DisplayLineDefTypeMenu(hDlg, rcThingMenu.left,rcThingMenu.top,
                                           TempList->objnum, //thingspecial,
                                           FALSE,  MenuLineDefListHexen[LowordThingCommand - CM_TLMHX2].type);
                       // MenuLineDefListHexen[id(wParam) - CM_TLMHX2].typeofname);
              break;

            // Spawn Menu H E X E N====================

            case CM_SPAWN1:       //"None",                   // 2
              // normal set to 0
              //menuval2 = 0;
              break;
            case CM_SPAWN2:       //"Keys",                   // 3
            case CM_SPAWN3:       //"Artifacts",              // 4
            case CM_SPAWN4:       //"Puzzle Items",           // 5
            case CM_SPAWN5:       //"Weapons",                // 6
            case CM_SPAWN6:       //"Health/Armor",           // 7
            case CM_SPAWN7:       //"Enemies",                // 8
            case CM_SPAWN8:       //"Glass/Rocks",            // 9
            case CM_SPAWN9:       //"Projectiles"  ,          // 10
            case CM_SPAWN10:      //"Miscellaneous",          // 11
              OldThingNames = ThingNames;             // save old name
              ThingNames = &HexenSpawnThingNames[0];  // switch to spawn names for FindWhichThing
	           DisplayThingsMenu(hDlg, HexenSpawnThingList[LowordThingCommand - CM_SPAWN2].type);
              ThingNames = OldThingNames;             // restore save old name   3-1-97
              break;

            // 40 odd menu selections get sent here from the Windows Menu code
            // Each Dialog or Window that display's these menus must handle the
            // resultant case's below to track the user's choice
            // When we create our own PopupMenu's :
            // Thing - Player, Keys, Weapons, Ammo
            // Line  - Door, Crushers,
            // Sector- Damage etc.
            // We initialize the menu structure with these ID's starting at 2001
            // An Odyssey
            case CM_1:
            case CM_2:
            case CM_3:
            case CM_4:
            case CM_5:
            case CM_6:
            case CM_7:
            case CM_8:
            case CM_9:
            case CM_10:
            case CM_11:
            case CM_12:
            case CM_13:
            case CM_14:
            case CM_15:
            case CM_16:
            case CM_17:
            case CM_18:
            case CM_19:
            case CM_20:
            case CM_21:
            case CM_22:
            case CM_23:
            case CM_24:
            case CM_25:
            case CM_26:
            case CM_27:
            case CM_28:
            case CM_29:
            case CM_30:
            case CM_31:
            case CM_32:
            case CM_33:
            case CM_34:
            case CM_35:
            case CM_36:
            case CM_37:
            case CM_38:
            case CM_39:
            case CM_40:
            case CM_41:                // 0-40 eg. 2001-2042 - 2001 =

            thingmenuval = int2(LowordThingCommand - CM_1);

            if(HxMode == 3) // otherwise our ThingSpawn routine will not find
            {  menuval2 = ThingIds[thingmenuval];         // actual thing #
               OldType = menuval2;                        //3-1-98
               ///Trace(NULL,10,4,"Old=%hd",OldType);
            }

            // After converting the case CM_1 - CM-41 to a proper 0 based number
            // check our various versions and update as neccessary
            // Most of this code is from EditThingCommand split up as required

            if(thingmenuval >= 0 && GameVersion == 4) // update as well as WM_MENUSELECT
            {
               if(HxMode == 1)         // Called from below
               {
                  special   = ThingIds[thingmenuval];        // return from ThingSpawnSpecial
                  menuval2  = OldType;                       // restore

                  //ThingNames= OldThingNames; // restore old name  ONLY from SpawnSpecial   3-1-97
                  //EditThingCommand(hDlg, rcThingMenu.right+20, rcThingMenu.top-10,level,TempList,2);
                  EditThingCommand(hDlg,level,TempList,2);
                  HxMode = 3;
               }
               else if(HxMode == 2)    // Called from DisplayLineDefType Menu
               {
                   ltag    = Ltag[thingmenuval];
                   larg[0] = Larg1[thingmenuval];
                   larg[1] = Larg2[thingmenuval];
                   larg[2] = Larg3[thingmenuval];
                   larg[3] = Larg4[thingmenuval];
                   larg[4] = Larg5[thingmenuval];
                   lflag   = Lflag[thingmenuval];

                   SetLineDefArgs(types[thingmenuval],larg[3]);      // set arg names

                   tspecial = types[thingmenuval];// return from LineMenu here with thing special

                   if (! (tspecial & 0x8000) )    // positive number since this is a uint cant say < 0
                   { HxMode = 1;                 // loop through again for the Special
                                                                                     //-10
                     if (ThingSpawnSpecial(hDlg, rcThingMenu.right+20,rcThingMenu.top,tspecial)== -2 ) //   3-1-97
                     {
                         special = -1; // no spawn special else return above to HxMode 1 1-25-97 bk
                         menuval2 = OldType;
                         HxMode = 3;
                         //ThingNames =OldThingNames; // restore old name  ONLY from SpawnSpecial   3-1-97
                         //EditThingCommand(hDlg, rcThingMenu.right + 20, rcThingMenu.top - 10,level,TempList,2);
                         EditThingCommand(hDlg,level,TempList,2);
                     }
                   }
               }
               else   // Normal Hexen menu selection
               {
                   if(SetThingDefArgs((uint2)menuval2) >=0 )                  // if have arguments
                   {
                      InitThingCommand(TempList, level);               // init values (sets old ThingType)
                      ThingType = menuval2;                            //   3-1-97 set now so next works
                      EditThingCommand(hDlg,level, TempList,0);        // specific args only
                   }                                                   // in Edit.cpp
               }
            }
            break;


          default:
            break;
       }  // end switch(LOWORD(wParam))  WM_COMMAND ID's

       if (TempList)
       {   UpdateObjectInfo(gd.hMainWindow, TempList->objnum);  //   3-1-97
           StatBarUpdate9();                                    //   3-1-97 level->MadeChanges status only in 1024
       }
       break;
   }                   // end switch(msg

  SetCursorPos(PriorCurPos.x, PriorCurPos.y);//   12-2-96
  return FALSE ;
}

///////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////
#pragma argsused
void TEdit_OnPaint(HWND hwnd)
{
   PAINTSTRUCT ps;
   RECT rc;
   HPALETTE hOldPal;

   BeginPaint(hwnd, &ps);
   GetClientRect(hwnd, &rc);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

   DisplayThingPic    (ps.hdc,int2(rc.left), int2(rc.top), int2(rc.right),
                              int2(rc.bottom),BigThingName,0,0,thingmagnify);
   /*
	 if (FindLumpPicSize(TxtrName,&xsize, &ysize, &xoffset,&yoffset) )
	  {
	   LocalMagnify = int2(4*1);//CurrentMagnify

	   magXadjust = int2((xsize-5)* LocalMagnify);
	   magYadjust = int2((ysize-5)* LocalMagnify);

	   // now adjust so it fits in the window (min magnify = 1)

	   while (magXadjust > rc.right || magYadjust > rc.bottom)
	   {      LocalMagnify--;
		  if (LocalMagnify == 1) break;
		  magXadjust = int2((xsize-5)* LocalMagnify);
		  magYadjust = int2((ysize-5)* LocalMagnify);
	   }
	   DisplayPic (ps.hdc,int2(rc.left), int2(rc.top), int2(rc.right),int2(rc.bottom),
      	NULL, TxtrName, 0,0, LocalMagnify, DARKGRAY, NOCENTER);
	  }
*/

	if(hOldPal) SelectPalette(ps.hdc, hOldPal, FALSE);
   EndPaint(hwnd, &ps);
}

////////////////////////////////////////////
//  The Deep Thing Edit Preview Window Procedure
/////////////////////////////////////////////
LRESULT CALLBACK TEditPrevWndProc(WINDOWS_PARAMS)
{
  switch(msg)
  {
	 HANDLE_MSG(hwnd, WM_PAINT, TEdit_OnPaint);
	 default:
		return TEdit_DefProc(hwnd, msg, wParam, lParam);
  }
}

////////////////////////////////////////////////////////////////////////////////
//																										//
//				E N D     Edit   Procedures													//
//																										//
////////////////////////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////
// WM_CTLCOLOR
/////////////////////////////////////////////////////////
#pragma argsused
HBRUSH I_OnCtlColor(HWND hwnd, HDC hdc, HWND hwndChild, int type)
{

 switch (type)
  {
    //case CTLCOLOR_DLG:     // For The background on the dialog box
    //return GetStockBrush(LTGRAY_BRUSH);

   case CTLCOLOR_BTN:
   case CTLCOLOR_STATIC:

    SetTextColor(hdc, PALETTERGB(0, 0, 0));

    SetBkMode(hdc, TRANSPARENT);

     if(hwndChild == GetDlgItem(hwnd, stc6) ) // RED Text
      { SetTextColor(hdc, PALETTERGB(255, 0, 0)); // clear
      }
     else if(hwndChild == GetDlgItem(hwnd, stc7) ) // BLUE
      { SetTextColor(hdc, PALETTERGB(0, 0, 255)); // clear
      }
     return GetStockBrush(NULL_BRUSH);
  }
  return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//  The Deep Thing/LineDef Flag Instruction Dialog  (was InstructionT)
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK InstructionFlagDlgProc(DIALOG_PARAMS)            //   3-1-97
{
  RECT rc, rc1;
  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

   switch (msg)
      { case WM_INITDIALOG:
        GetWindowRect(  GetParent(hDlg), &rc );
        GetClientRect(  hDlg, &rc1 );
        MoveWindow(hDlg, rc.left + 300, rc.top+4, rc1.right, rc1.bottom + 20, TRUE); //   3-1-97
        //MoveWindow(hDlg, rc.left + 300, rc.top+280, rc1.right, rc1.bottom + 20, TRUE);
        return TRUE;

      case WM_CTLCOLORSTATIC:
        return HANDLE_WM_CTLCOLORBTN(hDlg, wParam, lParam, I_OnCtlColor);

        default:
         break;
      }
   return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
//  The Deep Thing Mask Dialog Procedure
//
// 12-30-96 GRAY out all Hexen flags if NOT HEXEN
//
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK ThingMaskDlgProc(DIALOG_PARAMS)
{

 ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97
 
 switch(msg)
 {
	case WM_INITDIALOG:

	  if(ThingMask1)	// easy
        Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX1), 1);
	  if(ThingMask2)	// med.
        Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX2), 1);
	  if(ThingMask3)	// hard
        Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX3), 1);

     if(GameVersion == 4)
     {
		 if(ThingDeath)  // Network
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX4), 1);
		 if(ThingSingle)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX5), 1);
		 if(ThingCoop)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX6), 1);
		 if(ThingMaskDeaf)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX7), 1);
		 if(ThingMaskDormant)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX8), 1);
		 if(ThingFighter)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX9), 1);
		 if(ThingCleric)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX10), 1);
		 if(ThingMage)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX11), 1);
		 if(ThingMaskSpots)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX12), 1);
		 if(ThingMaskKeys)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX13), 1);
		 if(ThingMaskEquipment)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX14), 1);
		 if(ThingMaskWeapons)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX15), 1);
		 if(ThingMaskAmmunition)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX16), 1);
		 if(ThingMaskEnemies)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX17), 1);
		 if(ThingMaskPuzzle)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX18), 1);
		 if(ThingMaskOther)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX19), 1);
		 if(ThingMaskPoly)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX20), 1);
		 if(ThingNumberIds)
       Button_SetCheck(GetDlgItem(hDlg, chx1), 1);
     }
     else  // Doom
     {
		 if(ThingDeath)  // Network
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX4), 1);
		 if(ThingMaskKeys)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX13), 1);
		 if(ThingMaskEquipment)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX14), 1);
		 if(ThingMaskWeapons)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX15), 1);
		 if(ThingMaskAmmunition)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX16), 1);
		 if(ThingMaskEnemies)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX17), 1);
		 if(ThingMaskOther)
       Button_SetCheck(GetDlgItem(hDlg, IDC_CHECKBOX19), 1);

       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX5), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX6), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX7), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX8), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX9), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX10), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX11), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX12), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX18), FALSE);
       EnableWindow(GetDlgItem(hDlg, IDC_CHECKBOX20), FALSE);
       EnableWindow(GetDlgItem(hDlg, chx1), FALSE);

     }

     SetFocus(GetDlgItem(hDlg, IDC_CHECKBOX1));

     return FALSE;

   case WM_RBUTTONUP:
     PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97
     break;
   //   6-1-97
   case WM_LBUTTONUP:
     PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
     break;

	case WM_COMMAND:
	  if (LOWORD(wParam) == IDOK)
	  {
			if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX1))) ThingMask1=1;
         else  ThingMask1=0;
			if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX2))) ThingMask2=1;
         else  ThingMask2=0;
			if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX3))) ThingMask3=1;
         else  ThingMask3=0;

         if(GameVersion == 4)
         {
		   	if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX4))) ThingDeath=1;
            else  ThingDeath=0;
		     	if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX5))) ThingSingle=1;
            else ThingSingle=0;
		    	if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX6))) ThingCoop=1;
            else  ThingCoop=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX7))) ThingMaskDeaf=1;
            else  ThingMaskDeaf=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX8))) ThingMaskDormant=1;
            else  ThingMaskDormant=0;
		    	if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX9))) ThingFighter=1;
            else  ThingFighter=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX10))) ThingCleric=1;
            else  ThingCleric=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX11))) ThingMage=1;
            else  ThingMage=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX12))) ThingMaskSpots=1;
            else  ThingMaskSpots=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX13))) ThingMaskKeys=1;
            else  ThingMaskKeys=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX14))) ThingMaskEquipment=1;
            else  ThingMaskEquipment=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX15))) ThingMaskWeapons=1;
            else  ThingMaskWeapons=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX16))) ThingMaskAmmunition=1;
            else  ThingMaskAmmunition=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX17))) ThingMaskEnemies=1;
            else  ThingMaskEnemies=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX19))) ThingMaskOther=1;
            else  ThingMaskOther=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX18))) ThingMaskPuzzle=1;
            else  ThingMaskPuzzle=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX20))) ThingMaskPoly=1;
            else  ThingMaskPoly=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, chx1))) ThingNumberIds=1;
            else  ThingNumberIds=0;
         }
         else
         {
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX4))) ThingDeath=1;
            else  ThingDeath=0;
		    	if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX13))) ThingMaskKeys=1;
            else  ThingMaskKeys=0;
		    	if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX14))) ThingMaskEquipment=1;
            else  ThingMaskEquipment=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX15))) ThingMaskWeapons=1;
            else  ThingMaskWeapons=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX16))) ThingMaskAmmunition=1;
            else  ThingMaskAmmunition=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX17))) ThingMaskEnemies=1;
            else  ThingMaskEnemies=0;
			   if(Button_GetCheck(GetDlgItem(hDlg, IDC_CHECKBOX19))) ThingMaskOther=1;
            else  ThingMaskOther=0;
         }
			SetGameMask();

		   EndDialog(hDlg, TRUE);
         if (EditMode == OBJ_THINGS)
           //        hdc , RECT    , Erase Bk, Palette in
           RedrawMap(NULL, &gd.rcClient,ERASEYES, FALSE);
		   return TRUE;
		}

      if(LOWORD(wParam) == IDCANCEL)
		{
		   EndDialog(hDlg, FALSE);
		   return FALSE;
		}

      if (LOWORD(wParam) == IDHELP)
	   {
          HelpOpened = WinHelp(hDlg, HelpName, HELP_KEY,
                               (DWORD)"Thing Filter Mask");// index name in help needs changing
      }

		break;
  }
  return FALSE;
}

//////////////////////////////////////////////////////////////
//                                                          //
//			Choose  a WALL Texture   D I A L O G  PROC 			//
//																				//
//////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////
//	Preview Window Paint
//////////////////////////////////////////////////////
#pragma argsused
void ChooseTxtr_OnPaint(HWND hwnd)
{
   PAINTSTRUCT ps;
   RECT rc;
   HPALETTE hOldPal;
   int2 LocalMagnify;
   int2 magXadjust;
   int2 magYadjust;
   int2 xsize;         		// 2 width in pixels
   int2 ysize;         		// 2 height in pixels
   int2 xoffset;       		// 2 x offset for image itself
   int2 yoffset;       		// 2 y offset
   int2 oldcolor = InfoBoxColor; //   11-7-96

   BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(ps.hdc, gd.hDoomPal, FALSE);
  	RealizePalette(ps.hdc);

	GetClientRect(hwnd, &rc);

   InfoBoxColor = TextureBrowseColor; //  11-7-96
// FillRect(ps.hdc, &rc, gd.hBrushes[GRAY]); //can use if need proprietary color

   // textures

	if(BrowseMode == TEXTURES)
	{
		DisplayATexture(ps.hdc, int2(rc.left), int2(rc.top),
                              int2(rc.right),int2(rc.bottom),
                              0,0, TxtrName,"+");//+ignore
   }
   else
   if(BrowseMode == TEXTURECOMPOSITE)
	{
		DisplayCompositeTexture(ps.hdc, int2(rc.left), int2(rc.top),
                                      int2(rc.right),int2(rc.bottom),
                                      //0,0,
                                      TxtrName,"+");//+ignore
   }
   else
   // floors
   if(BrowseMode == FLOORS)
   {
		DisplayFloorTexture(ps.hdc,int2(rc.left), int2(rc.top),
                                 int2(rc.right),int2(rc.bottom), FloorName, 2);
   }
   else
   // sprites
   if(BrowseMode == SPRITES)
   {
	   if (FindLumpPicSize(SpriteName,&xsize, &ysize, &xoffset,&yoffset) )
	   {
	       LocalMagnify = 4;      //CurrentMagnify

	       magXadjust = (xsize-5)* LocalMagnify;
	       magYadjust = (ysize-5)* LocalMagnify;

	       // now adjust so it fits in the window (min magnify = 1)

	       while (magXadjust > rc.right || magYadjust > rc.bottom)
	       {     LocalMagnify--;
    	     	    if (LocalMagnify == 1) break;
		          magXadjust = (xsize-5)* LocalMagnify;
		          magYadjust = (ysize-5)* LocalMagnify;
	       }

	       DisplayPic (ps.hdc,int2(rc.left), int2(rc.top),
                             int2(rc.right),int2(rc.bottom),
                             NULL, SpriteName,
                             0,0, LocalMagnify, InfoBoxColor, NOCENTER);  //  11-7-96
	   }
   }

   if (hOldPal)  SelectPalette(ps.hdc, hOldPal, FALSE);
   InfoBoxColor = oldcolor;

   EndPaint(hwnd, &ps);
}

////////////////////////////////////////////////////////////////////////////////
//
//  Generic New List Box entry chosen
//  Global INDEX returns the index of chosen
//  Global hList is the Handle of the ListBox upon entry
//  Global hStatic if text displayed for Sub-Texture
//  Global FloorName,SpriteName,TxtrName depending on mode
////////////////////////////////////////////////////////////////////////////////
static void ListChange()
{
   WadFiles TextureWad;      // the texture directory (usually MasterWad)
   int2     xsize;           // width in pixels of texture
   int2     ysize;           // height in pixels of texture
   int2     patchnum;        // number of wall patches used to build this texture
   byte    *texofs;          // offset in the wad file to the texture data

	ListBoxIndex = (LRESULT)ListBox_GetCurSel(hList1);

   if(BrowseMode == TEXTURES)
   {  ListBox_GetText(hList1, ListBoxIndex, TxtrName);

      if (GetWallTextureSize( &TextureWad, &xsize, &ysize, &patchnum, &texofs, TxtrName) )
	   {   sprintf(gd.szTemp1, " %s , %hd x %hd , %hd patches ",TxtrName, xsize, ysize,patchnum);
	   	 Static_SetText(hStatic, gd.szTemp1);
	   }
  }
  else
  if (BrowseMode == FLOORS)
  {   ListBox_GetText(hList1, ListBoxIndex, FloorName);
  }
  else
  if (BrowseMode == SPRITES)
  {   ListBox_GetText(hList1, ListBoxIndex, SpriteName);	// SpriteName
  }
  //else
  //if(BrowseMode == TEXTURECOMPOSITE)    //   3-1-97 testing make sure it doesn't get here
  //{  ListBox_GetText(hList, ListBoxIndex, TxtrName);
  //   NotifyMsg(NULL,"composite");
  //}

  InvalidateRect(hTxtrPrev, NULL, TRUE);
}
///////////////////////////////////////////////////////////////////////////
//  Texture search
///////////////////////////////////////////////////////////////////////////

void FindClosestTxtrMatch()
{
  int4 i;

  if (NameChange)
  {
		TxtrName[lstrlen(EdTxt)] = '\0';

	   for(i=0; i < NumWTexture; i++)
      {
	      strncpy(TxtrName, WTexture[i], lstrlen(EdTxt));  // name entered
         if(!strcmp(TxtrName, EdTxt))
         {   ListBoxIndex = i;
             break;        //   12-2-96
         }
      }
  }

  ListBox_SetCurSel(hList1, ListBoxIndex);
  ListChange();
}

///////////////////////////////////////////////////////////////////////////
//  Floor search
///////////////////////////////////////////////////////////////////////////
void FindClosestFloorMatch()
{
 int4 i;

 if (NameChange)
 {
		FloorName[lstrlen(EdTxt)] = '\0';
	   //for(i = NumFTexture-1; i > 0; i--)
	   for(i =0; i< NumFTexture; i++)        //   12-2-96
      {
		  strncpy(FloorName, FTexture[i], lstrlen(EdTxt));
        if(!strcmp(FloorName, EdTxt))
        {   ListBoxIndex = i;
            break;      //   12-2-96
        }
      }
  }
  ListBox_SetCurSel(hList1, ListBoxIndex);
  ListChange();

}

//////////////////////////////////////////////////////////////////////////////
//
//	CHOOSE A TEXTURE DIALOG PROCEDURE
//
//////////////////////////////////////////////////////////////////////////////
static HWND hChooseTxtrDlg = NULL;
#pragma argsused
BOOL CALLBACK ChooseTxtrDlgProc(DIALOG_PARAMS)
{
  LPTXTR1 lptx;
  RECT    rc;
  int2 i;

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch(msg)
  {
	 case WM_INITDIALOG:
       hChooseTxtrDlg = hDlg;
	    NameChange = FALSE;

		 SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer

       //   12-16-96
       GetWindowRect(hDlg, &rc);
       MoveWindow(hDlg, pTextureSelectDlgPos.x,pTextureSelectDlgPos.y,
                        rc.right - rc.left, rc.bottom - rc.top, FALSE);
       GetWindowRect(hDlg, &rc);

       lptx = (LPTXTR1)lParam;				// grab it for our use

       hEdit 		= GetDlgItem( hDlg, IDD_TXTREDIT );
       hList1 		= GetDlgItem( hDlg, IDD_TXTRLIST );
       hTxtrPrev 	= GetDlgItem( hDlg, IDD_CHOOSETXTRPREVIEW );
       hStatic   	= GetDlgItem( hDlg, IDD_STATICTEXT );

       // Fill our list box with texture names

  	    for(i = 0; i < NumWTexture; i++)
       {
		    strncpy(TxtrName, WTexture[i], 8);
          ListBox_AddString(hList1, TxtrName);
          if(!strcmp(lptx->Txtr1, TxtrName))
          {
             ListBoxIndex = i;            // Highlight our current name
		       strncpy(EdTxt, TxtrName, 8);
          }
       }

	    gd.hParent = hDlg;		// store our calling process handle for   12-25-96

       // 1-15-97 bk
       // If we don't set focus and return TRUE the focus is set by
       // the order of the controls in the .rc file

	    strncpy(TxtrName, EdTxt, 8);
		 SendMessage(hList1, LB_SETCURSEL, ListBoxIndex, 0);

       //SetFocus(hList);

       InvalidateRect(hTxtrPrev, NULL, TRUE);
       Edit_SetText( hEdit, (LPSTR)lptx->Txtr1 );

       Static_SetText(GetDlgItem(hDlg,IDD_ST),(LPSTR)lptx->Txtr2);
       SetWindowText(hDlg, lptx->Txtr2);               //   8-1-97

       SetCursorPos(rc.left + 118, rc.top + 40);  // position it
       //SetFocus(GetDlgItem(hDlg, IDD_TXTREDIT));   playing
       //return FALSE;
       return TRUE;

    case WM_RBUTTONUP:
   	  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
        break;
    //   6-1-97  undid 8-1-97 causes probs large fonts only (weird again) and click on preview texture
    //    case WM_LBUTTONUP:
    //        PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
    //        break;

    case WM_COMMAND:
       lptx = (LPTXTR1)GetWindowLong(hDlg, DWL_USER);				// grab it for our use

       switch LOWORD(wParam)
		 {
           case IDD_TXTRLIST:		// Out list box was chosen in some fashion

					NameChange = FALSE;
            	switch HIWORD(wParam)
			   	{
					   case LBN_DBLCLK: // Post IDOK to Dialog ( use MAKEWPARAM MACRO )
					   	PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hTxtrPrev, GWL_ID)), (LPARAM)hTxtrPrev);
						   break;

						case LBN_SELCHANGE:
						   ListChange();
						   Edit_SetText(hEdit, TxtrName);
					    	break;

						default:
				 		   return FALSE;
               }
               break; // 3-1-97   missing
           case IDD_TXTREDIT:		// Out list box was chosen in some fashion
            	switch HIWORD(wParam)
			   	{
						case EN_CHANGE:
                     Edit_GetText(hEdit, EdTxt, 9);
                     FindClosestTxtrMatch();
				    		break;

						case EN_SETFOCUS:	// Must be IN the Edit Control to Find Match
							NameChange=TRUE;
				    		break;

						case EN_KILLFOCUS:
							NameChange=FALSE;
					    	break;

						default:
				 	    	return FALSE;
                }
		    	    break;

			  case IDOK:
               GetWindowRect(hDlg, &rc);           //   12-16-96
               pTextureSelectDlgPos.x = rc.left;   // save any new position
               pTextureSelectDlgPos.y = rc.top;
       		   strncpy(lptx->Txtr1, TxtrName, 8);
               hChooseTxtrDlg = NULL;
               EndDialog(hDlg, TRUE);
		  	      return TRUE;

			  case IDCANCEL:
               GetWindowRect(hDlg, &rc);           //   12-16-96
               pTextureSelectDlgPos.x = rc.left;   // save any new position
               pTextureSelectDlgPos.y = rc.top;
               hChooseTxtrDlg = NULL;
               EndDialog(hDlg, FALSE);
               break;

			  case IDBROWSE:		         // Lets go and Browse  instead
               Browsing = TRUE;			// So as not to redraw when the Dialog ends
               // gd.hParent = hDlg;		// store our calling process handle for
               TxtrBrowse(TxtrName);	// a proper return to below
               return TRUE;

	   		case WM_BROWSE_BACK:	      //After Browsing we return here PostMessage(hParent, WM_BROWSE...
				   //rather than rely on global vars' could include str in lParam ?

			      for(i = 0; i < NumWTexture; i++)
			      {
				      strncpy(EdTxt, WTexture[i], 8);
				      if(!strcmp(EdTxt, TxtrName))
				      {  ListBoxIndex = i;
                     break;           //   12-2-96
					  }
			      }
               //   3-1-97 fix list not updated correctly
			      SendMessage(hList1, LB_SETCURSEL, ListBoxIndex, 0);
			      ListBox_SetCurSel(hList1, ListBoxIndex);
      		   InvalidateRect(hTxtrPrev, NULL, TRUE);

      	      Edit_SetText( hEdit, TxtrName);
      	      SetFocus(hList1);
       	      return TRUE;
    }	// END WM_COMMAND Switch(WPARAM)    for ID's

	 return TRUE;
  }										// END switch(msg) WM_COMMAND, WM_INITDIALOG etc.
  return FALSE;
}


///////////////////////////////////////////////////////////////////////////
//  Used by Texture composite and Edit SelectTexture from a list
///////////////////////////////////////////////////////////////////////////
#pragma argsused
static void Txtr_OnLBDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
     if (BrowseMode == TEXTURES      //   1-5-97 all and commented out below
     ||  BrowseMode == TEXTURECOMPOSITE)
     {   Browsing = TRUE;			   // So as not to redraw when the Dialog ends
         TxtrBrowse(TxtrName);
     }
     else
     if (BrowseMode == FLOORS)
     {   Browsing = TRUE;			   // So as not to redraw when the Dialog ends
         FloorBrowse(FloorName);	   // a proper return to below
     }
}


//-- right button up is cancel
#pragma argsused
static void Txtr_OnRButtonUp(HWND hwnd, int x, int y, UINT keyFlags)
{
   if (hChooseTxtrDlg)
   {
       PostMessage(hChooseTxtrDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hChooseTxtrDlg, GWL_ID)), 0); // upper
   }
}


//////////////////////////////////////////////////////////////////////////////
//  Texture Preview Window Procedure (also used in Composite rct2)
//	 only called from Windows, : handles WM_PAINT and buttons as shown
//  used for double click browsing
//////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK TxtrPrevWndProc(WINDOWS_PARAMS)
{
  switch(msg)
  {
	 HANDLE_MSG(hwnd, WM_PAINT, 			ChooseTxtr_OnPaint);
	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN, 	Txtr_OnLBDown);         // browse
    HANDLE_MSG(hwnd, WM_RBUTTONUP,     Txtr_OnRButtonUp);      // cancel
	 default:
		return Txtr_DefProc(hwnd, msg, wParam, lParam);
  }
}

//////////////////////////////////////////////////////////////
//                                                          //
//			Choose  a  FLOOR  Texture   D I A L O G  PROC		//
//																				//
//////////////////////////////////////////////////////////////

////////////////////////////////////////////
//  The Callback for Choosing a new Floor Texture
/////////////////////////////////////////////

#pragma argsused
BOOL CALLBACK ChooseFloorDlgProc(DIALOG_PARAMS)
{
  LPTXTR1 lptx;
  RECT   rc;        //   12-2-96

  int2 i;
  static int4 x,y;    // save Cursor Position since BROWSE screws it up !

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch(msg)
  {
	 case WM_INITDIALOG:
	  	 NameChange = FALSE;

		 SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer
       //   12-16-96
       GetWindowRect(hDlg, &rc);
       MoveWindow(hDlg, pFloorSelectDlgPos.x,pFloorSelectDlgPos.y,
                        rc.right - rc.left, rc.bottom - rc.top, FALSE);
       GetWindowRect(hDlg, &rc);

       lptx = (LPTXTR1)lParam;				// grab it for our use

       hEdit  = GetDlgItem( hDlg, IDD_TXTREDIT );
       hList1 = GetDlgItem( hDlg, IDD_TXTRLIST );
       hTxtrPrev = GetDlgItem( hDlg, IDD_CHOOSETXTRPREVIEW );

       // Fill our list box with texture names

       strcpy(EdTxt, lptx->Txtr1);
       ListBoxIndex = 0;

	    for(i = 0; i < NumFTexture; i++)
       {
		   strncpy(FloorName, FTexture[i], 8);
         ListBox_AddString(hList1, FloorName);
         if (!strcmp(lptx->Txtr1, FloorName))
         {   ListBoxIndex = i;	// Highlight our current Map
		       strncpy(EdTxt, FloorName, 8);
         }
       }

	    strncpy(FloorName, EdTxt, 8);
		 SendMessage(hList1, LB_SETCURSEL, ListBoxIndex, 0);

       //SetFocus(hList); 1-15-97 bk
       InvalidateRect(hTxtrPrev, NULL, TRUE);
       Edit_SetText( hEdit, FloorName );

       Static_SetText(GetDlgItem(hDlg,IDD_ST), lptx->Txtr2);
       SetWindowText(hDlg, lptx->Txtr2);               //   8-1-97


	    gd.hParent = hDlg;		// store our calling process handle for
       x = pOldCurPos.x;
       y = pOldCurPos.y;

       SetCursorPos(rc.left + 118, rc.top + 40);  // position it
       return TRUE;  // 1-15-97 bk  not FALSE

    case WM_RBUTTONUP:
   	 PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
       break;
    //   6-1-97  undid 8-1-97 causes probs large fonts only (weird again) and click on preview texture
    //case WM_LBUTTONUP:
    //   PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
    //   break;

    case WM_COMMAND:

       lptx = (LPTXTR1)GetWindowLong(hDlg, DWL_USER);				// grab it for our use

       switch LOWORD(wParam)
		 {
            case IDD_TXTRLIST:		// Out list box was chosen in some fashion
					NameChange = FALSE;
            	switch HIWORD(wParam)
			   	 {
					   case LBN_DBLCLK: // Post IDOK to Dialog ( use MAKEWPARAM MACRO )
					   	PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hTxtrPrev, GWL_ID)), (LPARAM)hTxtrPrev);
						   break;

						case LBN_SELCHANGE:
						   ListChange();
						   Edit_SetText(hEdit, FloorName);
						   break;

						default:
				 		   return FALSE;
                }
                break; //   3-1-97 missing safety

            case IDD_TXTREDIT:		// Out list box was chosen in some fashion
            	switch HIWORD(wParam)
			   	{
						case EN_CHANGE:
                    Edit_GetText(hEdit, EdTxt, 9);
                    FindClosestFloorMatch();
					     break;
						case EN_SETFOCUS:	// Must be IN the Edit Control to Find Match
						  NameChange=TRUE;
					     break;
						case EN_KILLFOCUS:
						  NameChange=FALSE;
						  break;

						default:
				 		  return FALSE;
               }
		         break;

				case IDOK:
               strncpy(lptx->Txtr1, FloorName, 8);
               pOldCurPos.x = x;
               pOldCurPos.y = y;
               GetWindowRect(hDlg, &rc);           //   12-16-96
               pFloorSelectDlgPos.x = rc.left;
               pFloorSelectDlgPos.y = rc.top;
               EndDialog(hDlg, TRUE);
		  	      return TRUE;

				case IDCANCEL:
               GetWindowRect(hDlg, &rc);           //   12-16-96
               pFloorSelectDlgPos.x = rc.left;
               pFloorSelectDlgPos.y = rc.top;

               pOldCurPos.x = x;
               pOldCurPos.y = y;
               EndDialog(hDlg, FALSE);
               break;

				case IDBROWSE:			      // Lets go and Browse for a map instead
               Browsing = TRUE;	    	// So as not to redraw when the Dialog ends
               FloorBrowse(FloorName);	// a proper return to below
               return TRUE;

	   		case WM_BROWSE_BACK:		// After Browsing we return here
            								// PostMessage(hParent, WM_BROW...
			     for(i = 0; i < NumFTexture; i++)
				  {
				     strncpy(EdTxt, FTexture[i], 8);
				     if(!strcmp(EdTxt, FloorName))            // FloorName has chosen name
					  {  ListBoxIndex = i;
                    break;      //   12-2-96
				     }													 // used for pattern match
				  }
              //   3-1-97 fix to show correct entry
  		        SendMessage(hList1, LB_SETCURSEL, ListBoxIndex, 0);    //   12-25-96 missing butno diff? not required?
			     ListBox_SetCurSel(hList1, ListBoxIndex);
      		  InvalidateRect(hTxtrPrev, NULL, TRUE);

			     //strncpy(EdTxt, FloorName, 8);		         	// Backup our name   12-25-96already matched
      	     Edit_SetText( hEdit, FloorName );
      	     SetFocus(hList1);
      	     return TRUE;

       }	  // END WM_COMMAND Switch(WPARAM)    for ID's

		 return TRUE;
  }						// END switch(msg) WM_COMMAND, WM_INITDIALOG etc.
  return FALSE;
}



/////////////////////////////////////////////////////////////////////////////
//  The Deep Cross Reference Dialog
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK XRefDlgProc(DIALOG_PARAMS)
{
 LPDLG2OPTS lpd2;	// Our Long Pointer to Dialog Input 2 char strings
 int2       test1 ;
static int2 oldvalue;
static int4 low1,high1;

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
	  SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer

     CenterDialogAroundCursor(hDlg);            // center around cursor   12-16-96
     lpd2 = (LPDLG2OPTS)lParam;			       	// grab it for our use

     Static_SetText(GetDlgItem(hDlg, stc3), lpd2->sz3 );
     Static_SetText(GetDlgItem(hDlg, stc4), lpd2->sz4 );
     //Static_SetText(GetDlgItem(hDlg, stc5), lpd2->sz5 );

     SetDlgItemInt(hDlg, edt1, lpd2->i1, TRUE);
     SetFocus(GetDlgItem(hDlg, edt1));
     oldvalue = lpd2->i1;
     low1     = lpd2->low1;             // our initial values
     high1    = lpd2->high1;            //
     return TRUE;                       //set focus   8-1-97

    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
      break;
    //   6-1-97       ok here   7-1-97
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

    case WM_COMMAND:

       lpd2 = (LPDLG2OPTS)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer

       switch LOWORD(wParam) 						            	// handle of the control
       {
         case IDOK:
            test1 = GetDlgItemInt(hDlg, edt1, NULL, TRUE);  // no need for calculator

				if(test1 >= low1
            && test1 <= high1)
            {
              lpd2->i1 = test1;
              EndDialog( hDlg, TRUE );   //  Cause DialogBoxParam to return TRUE
              return TRUE;
            }
            else
            {
              lpd2->i1 = oldvalue;
              if (oldvalue >=0)         // value existed (not deleted
              {
                 //ErrorMsg(hDlg,"Please enter a number between %d  and  %d",low1,high1);
                 sprintf(gd.szTemp1,"Please enter a number between  %d and %d",low1,high1);
                 HelpMsg(hDlg,CENTER|HELPHELP,"Number Size Error",gd.szTemp1,NULL);
                 return TRUE;
              }
              else
              {  EndDialog( hDlg, FALSE );
                 return FALSE;
              }
            }

         case IDCANCEL:
            EndDialog( hDlg, FALSE );
            return TRUE;

		 }
       break;
  }
  return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//  The Deep Set Hexen Args Dialog
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK HexenArgsDlgProc(DIALOG_PARAMS)
{
   LPDLGSELECT lpsel;	// Our Long Pointer to struct
   LevelPtr level = &LevelWad.level;
   int4   i;
   uint2  type;
   int2   arg4;
   static SelPtr objlist;
   SelPtr cur;

   char heading[60];

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
	  SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer
     CenterDialogAroundCursor(hDlg);            // center around cursor   3-1-97

     lpsel = (LPDLGSELECT)lParam;				   // grab it for our use

     objlist = lpsel->sel;

     type = level->LineDefs[ objlist->objnum].type;
     arg4 = level->LineDefs[ objlist->objnum].arg4;

     SetLineDefArgs(type,arg4);     // set argument names

     sprintf(heading,"%s",LineDefTypeName( type, arg4) );

     for (i=0; i < 5; i++)
     {
        if (!strncmp(argdesc[i],"Tid",3) )           // Tid
        {   sprintf(argdesc[i], "Tid f%hd,u%hd",FindFreeTid(),LastTidUsed);
        }
        else
        if (!strncmp(argdesc[i],"Pol",3) )            // Poly Object
        {   sprintf(argdesc[i], "PolyId f%hd,u%hd",FindFreePolyTid(),LastPolyUsed);
        }
        else
        if (!strncmp(argdesc[i],"Tag",3) )            // Poly Object
        {   sprintf(argdesc[i], "Tag f%hd,u%hd",FindFreeTag(),LastTagUsed);
        }
        else
        if (!strncmp(argdesc[i],"Lineid",6) )         // lineid
        {   sprintf(argdesc[i], "Lineid f%hd,u%hd",FindFreeLineId(),LastLineIdUsed);
        }
     }

     Static_SetText(GetDlgItem(hDlg, IDD_ST), heading );

     Static_SetText(GetDlgItem(hDlg, stc1), argdesc[0]);
     Static_SetText(GetDlgItem(hDlg, stc2), argdesc[1]);
     Static_SetText(GetDlgItem(hDlg, stc3), argdesc[2]);
     Static_SetText(GetDlgItem(hDlg, stc4), argdesc[3]);
     Static_SetText(GetDlgItem(hDlg, stc5), argdesc[4]);

     SetDlgItemInt(hDlg, edt1, larg[0], TRUE);
     SetDlgItemInt(hDlg, edt2, larg[1], TRUE);
     SetDlgItemInt(hDlg, edt3, larg[2], TRUE);
     SetDlgItemInt(hDlg, edt4, larg[3], TRUE);
     SetDlgItemInt(hDlg, edt5, larg[4], TRUE);

     SetFocus(GetDlgItem(hDlg, edt1));
     return FALSE;

    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
      break;
    //   6-1-97
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

    case WM_COMMAND:

       //lpsel = (LPDLGSELECT)GetWindowLong(hDlg, DWL_USER);// grab our pointer

       switch LOWORD(wParam) 							          // handle of the control
       {
        case IDOK:
          // calc not required here
          larg[0] = (int2)GetDlgItemInt(hDlg, edt1, NULL, TRUE);
          larg[1] = (int2)GetDlgItemInt(hDlg, edt2, NULL, TRUE);
          larg[2] = (int2)GetDlgItemInt(hDlg, edt3, NULL, TRUE);
          larg[3] = (int2)GetDlgItemInt(hDlg, edt4, NULL, TRUE);
          larg[4] = (int2)GetDlgItemInt(hDlg, edt5, NULL, TRUE);

          for (cur = objlist; cur; cur = cur->next)
          {
             level->LineDefs[ cur->objnum].tag  = larg[0];
             level->LineDefs[ cur->objnum].arg2 = larg[1];
             level->LineDefs[ cur->objnum].arg3 = larg[2];
             level->LineDefs[ cur->objnum].arg4 = larg[3];
             level->LineDefs[ cur->objnum].arg5 = larg[4];
          }
          level->MadeChanges++;

          if (larg[0])   // only > 0   8-1-97
          {
             for (i=0; i < 5; i++)
             {
                if (!strncmp(argdesc[i],"Tid",3) )           // Tid
                {   LastTidUsed =larg[0];
                }
                else
                if (!strncmp(argdesc[i],"Pol",3) )           // Poly Object
                {   LastPolyUsed =larg[0];
                }
                else
                if (!strncmp(argdesc[i],"Tag",3) )           // Poly Object
                {   LastTagUsed =larg[0];
                }
             }
          }

          EndDialog( hDlg, TRUE );
          return TRUE;

        case IDCANCEL:
          EndDialog( hDlg, FALSE );                    // NEED for Escape Key
          return TRUE;
		 }

       break;
  }
 return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//  The Deep EDIT Hexen Args Dialog
//
// unlike the HexenArgsDlgProc which actually
// sets the args, this just returns the values
// for the prog to manipulate later - as in
// this instance - Search and Replace - FIND
//
//////////////////////////////////////////////////////////////////////////////

#pragma argsused
BOOL CALLBACK EditHexenArgsDlgProc(DIALOG_PARAMS)
{
   LPDLG2OPTS lpd2;	// Our Long Pointer to struct

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
	     SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer

        POINT CurPos;                          //   12-16-96
        RECT  rc;
        int  width,height;

        GetCursorPos( &CurPos );               //   12-16-96

        GetWindowRect(hDlg,&rc);
        //Trace(NULL,10,4,"%d,%d  %d,%d", rc.left, rc.right, rc.top,rc.bottom);
        width     = rc.right - rc.left;        // find Width
        height    = rc.bottom - rc.top;        // find Height
        rc.left   = CurPos.x- width/2;
        rc.top    = CurPos.y- height/2;
        MoveWindow(hDlg,rc.left, rc.top, width,height, FALSE);

        lpd2 = (LPDLG2OPTS)lParam;				// grab it for our use

        Static_SetText(GetDlgItem(hDlg, IDD_ST), lpd2->sz3 );

        Static_SetText(GetDlgItem(hDlg, stc1), lpd2->sz4);
        Static_SetText(GetDlgItem(hDlg, stc2), lpd2->sz5);
        Static_SetText(GetDlgItem(hDlg, stc3), lpd2->sz6);
        Static_SetText(GetDlgItem(hDlg, stc4), lpd2->sz7);
        Static_SetText(GetDlgItem(hDlg, stc5), lpd2->sz8);

        SetDlgItemInt(hDlg, edt1, lpd2->i1, FALSE);
        SetDlgItemInt(hDlg, edt2, lpd2->i2, FALSE);
        SetDlgItemInt(hDlg, edt3, lpd2->i3, FALSE);
        SetDlgItemInt(hDlg, edt4, lpd2->i4, FALSE);
        SetDlgItemInt(hDlg, edt5, lpd2->i5, FALSE);

        SetFocus(GetDlgItem(hDlg, edt1));
        return FALSE;

    case WM_RBUTTONUP:
   	  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
        break;
    //   6-1-97
    case WM_LBUTTONUP:
        PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
        break;

    case WM_COMMAND:
       lpd2 = (LPDLG2OPTS)GetWindowLong(hDlg, DWL_USER);// grab our pointer

       switch LOWORD(wParam) 							          // handle of the control
       {
        case IDOK:
          lpd2->i1 = (int2)GetDlgItemInt(hDlg, edt1, NULL, TRUE);
          lpd2->i2 = (int2)GetDlgItemInt(hDlg, edt2, NULL, TRUE);
          lpd2->i3 = (int2)GetDlgItemInt(hDlg, edt3, NULL, TRUE);
          lpd2->i4 = (int2)GetDlgItemInt(hDlg, edt4, NULL, TRUE);
          lpd2->i5 = (int2)GetDlgItemInt(hDlg, edt5, NULL, TRUE);
          //   3-1-97 limits
          if (lpd2->i1 < 0
          ||  lpd2->i2 < 0
          ||  lpd2->i3 < 0
          ||  lpd2->i4 < 0
          ||  lpd2->i5 < 0
          ||  lpd2->i1 > 255
          ||  lpd2->i2 > 255
          ||  lpd2->i3 > 255
          ||  lpd2->i4 > 255
          ||  lpd2->i5 > 255)
          {
              HelpMsg(hDlg,CENTER|HELPHELP,"Number Size Error",
                                  "You have entered an invalid number",
                                   "",
                                   "Argument values are from 0 to 255",
                                   NULL);
              //ErrorMsg(hDlg, "You have entered an invalid number\n\n"
              //                "Argument values are from 0 to 255");
          }
          else
          {    EndDialog( hDlg, TRUE );
          }
          return TRUE;
        case IDCANCEL:
          EndDialog( hDlg, FALSE );                    // NEED for Escape Key
          return TRUE;
		 }
       break;
  }
  return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
//  The Deep Split Sector Dialog  returns 1, 2 or 3 for Exit,split,2-sided
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK SplitOptionsDlgProc(DIALOG_PARAMS)
{
 LPDLG2OPTS lpd2;	// Our Long Pointer to Dialog Input Struct

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
	   SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer
      lpd2 = (LPDLG2OPTS)lParam;			         // grab it for our use

      if(lpd2->b1)                               // disable SplitSector button
      {  EnableWindow(GetDlgItem(hDlg, psh2), 0);//Split Sector button   3-1-97
      }
      //   EnableWindow(GetDlgItem(hDlg, IDCANCEL), 0);//Split Sector button
      return TRUE;

    //case WM_RBUTTONUP:  //   7-1-97 causes problems in drawing
    //	PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
    //  break;
    //   6-1-97
    //case WM_LBUTTONUP:
    //  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
    //  break;

    case WM_COMMAND:
      //lpd2 = (LPDLG2OPTS)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer

      switch LOWORD(wParam) 		// handle of the control
      {
         case IDCANCEL:          //  EXIT   3-1-97 and stuff below
            EndDialog( hDlg, 1);
            return 1;
         case psh1:              //  2- sided line
            EndDialog( hDlg, 2);
            return 2;
         case psh2:              //  split sector
            EndDialog( hDlg, 3);
            return 3;

		}
      break;
  }
 return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//
//  Search and Replace a % of Things
//
//  The Deep Find & Replace Dialog - enhanced
//
// todo: add visual choosing of things
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK ThingFindReplaceDlgProc(DIALOG_PARAMS)
{
 LPDLG2OPTS lpd2;
 //int2 l1,h1,l2,h2,
 int2 Find,Repl,Perc;                      // High and low for Find & Replace items

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch( msg )
  {
    case WM_INITDIALOG:
	   SetWindowLong(hDlg, DWL_USER, lParam);		// store our Pointer
      lpd2 = (LPDLG2OPTS)lParam;				      // grab it for our use

      if(lpd2->b1)                               // Not Registered so disable Percent Window
      {
        EnableWindow(GetDlgItem(hDlg, edt3), 0);
        Static_SetText(GetDlgItem(hDlg, stc4), "Register for Percent" );
      }
      else
      {
        SetDlgItemInt(hDlg, edt3, lpd2->i3, FALSE);
        Static_SetText(GetDlgItem(hDlg, stc4), lpd2->sz6 );
      }

      SetDlgItemInt(hDlg, edt1, lpd2->i1, FALSE);         // Find this
      SetDlgItemInt(hDlg, edt2, lpd2->i2, FALSE);         // Replace with this

      Static_SetText(GetDlgItem(hDlg, stc1), lpd2->sz3 ); // Heading  usually REPLACE

      Static_SetText(GetDlgItem(hDlg, stc2), lpd2->sz4 ); // Find . . .
      Static_SetText(GetDlgItem(hDlg, stc3), lpd2->sz5 ); // Replace . . .
      return TRUE;

    case WM_RBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
      break;
    //   6-1-97
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

    case WM_COMMAND:
      lpd2 = (LPDLG2OPTS)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer

      switch LOWORD(wParam)
      {
         case IDCANCEL:
         case IDOK:

          //l1 = lpd2->low1;
          //l2 = lpd2->low2;
          //h1 = lpd2->high1;
          //h2 = lpd2->high2;

          Find = (int2)GetDlgItemInt(hDlg, edt1, NULL, TRUE);
          Repl = (int2)GetDlgItemInt(hDlg, edt2, NULL, TRUE);
          Perc = (int2)GetDlgItemInt(hDlg, edt3, NULL, TRUE);

          //if(Find >= l1 && Find <= h1 && Repl >= l2 && Repl <= h2 && Perc > 0 && Perc <= 100)
          if(Find >= 1 && Repl >= 1 && Perc > 0 && Perc <= 100)
          {
             lpd2->i1 = (int2)GetDlgItemInt(hDlg, edt1, NULL, TRUE); // Find
             lpd2->i2 = (int2)GetDlgItemInt(hDlg, edt2, NULL, TRUE); // Replace

             if (lpd2->b1) lpd2->i3 = 100;
             else          lpd2->i3 = (int2)GetDlgItemInt(hDlg, edt3, NULL, TRUE);
          }
          else                     // Safety
          {  lpd2->i1 = 1;         // Find
             lpd2->i2 = 1;         // Replace

             if(lpd2->b1)  lpd2->i3 = 100;
             else          lpd2->i3 = Perc;
          }
          EndDialog( hDlg, IDOK );
          return IDOK;
		  }
    break;
  }
 return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//  The Deep Check options
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK CheckOptDlgProc(DIALOG_PARAMS)
{
  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch(msg)
  {
	 case WM_INITDIALOG:
		if(ChkUpperMissing)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKUPPER), 1);
		if(ChkNormalMissing)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKNORMAL), 1);
		if(ChkLowerMissing)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKLOWER), 1);
		if(ChkXoffset)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKX), 1);
		if(ChkYoffset)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKY), 1);
		if(ChkPatches)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKMULTI), 1);
		if(ChkClosed1)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKS1), 1);
		if(ChkClosed2)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKS2), 1);
		if(ChkThingSector)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKINSECTOR), 1);
		if(ChkThingOnTop)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKTOP), 1);
		if(ChkTags)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKTAGS), 1);
		if(ChkKeys)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKKEYS), 1);
		if(ChkDupSideDef)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKDUPSIDEDEF), 1);
      if(ChkShortLines)
        Button_SetCheck(GetDlgItem(hDlg, IDD_CHKSHORT),1) ;     // 3-1-98 forgot to put in

	 return TRUE; // or FALSE if we set our own focus

    case WM_RBUTTONUP:
     PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);//   6-1-97 was OK
     break;
    //   6-1-97
    case WM_LBUTTONUP:
      PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
      break;

	 case WM_COMMAND:

		switch LOWORD(wParam)
      {
        case IDOK:
    		if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKUPPER))) ChkUpperMissing = TRUE;
         else ChkUpperMissing = FALSE;
	    	if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKNORMAL))) ChkNormalMissing = TRUE;
         else ChkNormalMissing = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKLOWER))) ChkLowerMissing = TRUE;
         else ChkLowerMissing = FALSE;
	    	if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKX))) ChkXoffset = TRUE;
         else ChkXoffset = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKY))) ChkYoffset = TRUE;
         else ChkYoffset = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKMULTI))) ChkPatches = TRUE;
         else ChkPatches = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKS1))) ChkClosed1 = TRUE;
         else ChkClosed1 = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKS2))) ChkClosed2 = TRUE;
         else ChkClosed2 = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKINSECTOR))) ChkThingSector = TRUE;
         else ChkThingSector = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKTOP))) ChkThingOnTop = TRUE;
         else ChkThingOnTop = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKTAGS))) ChkTags = TRUE;
         else ChkTags = FALSE;
		   if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKKEYS))) ChkKeys = TRUE;
         else ChkKeys = FALSE;
	    	if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKDUPSIDEDEF))) ChkDupSideDef = TRUE;
         else ChkDupSideDef= FALSE;
    		if(Button_GetCheck(GetDlgItem(hDlg, IDD_CHKSHORT)))   ChkShortLines = TRUE;     // 3-1-98 forgot to put in
         else ChkShortLines = FALSE;

		  	EndDialog(hDlg, IDOK);
		   return TRUE;

        case IDCANCEL:
		   EndDialog(hDlg, IDCANCEL);
		   return FALSE;
      }
	   break;
  }
  return FALSE;
}



////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//        Subroutines used by the above Dialog Proc's  - mostly ThingEdit &   //
//                                                              LineDefEdit   //
//        InitThingCommand  setup up initial values                           //
//        EditThingCommand                                                    //
//        EditThingLineInfo                                                   //
//        ThingSpawnSpecial                                                   //
//        ShowThing                                                           //
//        ShowMenuSelect                                                      //
//        DisplayThingMenu                                                    //
//        FindWhichThingType                                                  //
//        FindWhichLineType                                                   //
//        FindWhichSectorType                                                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


//-----------------------------------------------------------------------//
//   Find which old value matches subdivision area
//-----------------------------------------------------------------------//

static int2 FindWhichThingType(int2 type)
{
   TypeThingPtr TempType =ThingNames;                 //&DoomThingNames[0];;

   int2 Curtype;
   if (GameVersion > 2)
   {   Curtype = 1;  // skip number
       if (GameVersion == 4) Curtype = 3;            // skip args and thing special
   }
   else
   {   Curtype = 0;  //
   }


   if (type > 0)
   {
     //for (;  TempType->thingname != NULL ; TempType+=1)
     for (;  TempType->type != 0xFFFFffff ; TempType+=1)
     {
         if ( TempType->type & 0xFFFF0000)//8000 )
         {   TempType++;
             if (TempType->thingname[0] != 'x')  // check next
             {   Curtype++;
             }
             TempType--;
         }
         else
         if  ( type == TempType->type
         &&   TempType->thingname[0] != 'x')
         {    return Curtype;
         }
     }
   }

   if (GameVersion > 2)
   {   Curtype = 3;// point to # choice
   }
   else
   {   Curtype = 1;// point to # choice
   }

   return Curtype;
}

//-----------------------------------------------------------------------//
//   Find which old LineDef value matches subdivision area
//-----------------------------------------------------------------------//

static uint2 FindWhichLineType(uint2 type)
{
   int2 Curtype = 0;

   TypeDescPtr TempType = TypeLineDef;//&DoomLineDefType[0];

   for (;  TempType->type!= 0xFFFFffff ; TempType+=1)
   {
        if  (TempType->type & 0xFFFF0000)//8000)
        {    TempType++;
             if (TempType->typelong[0] != 'x')
             {   Curtype++;
             }
             TempType--;
        }
        else
        if  (type == TempType->type
        &&   TempType->typelong[0] != 'x')
        {
             //Trace(NULL,10,4,"hit %hu %s",type,TempType->typelong);
             return Curtype;
        }
   }

   // no hits, add 1 for doom to skip BOOM selection

   if (GameVersion <= 2)
   {   Curtype++;          // points to BOOM linedef for DOOM
   }
   else
   {   Curtype+=2;         // type #  (skip separator)
   }

   return Curtype;
}


//-----------------------------------------------------------------------//
//   Find which old value matches subdivision area
//-----------------------------------------------------------------------//

uint2 FindWhichSectorType(uint2 special)   //objnum)
{
   int2 Curtype = 0;
   TypeDescPtr TempType = TypeSector;      //&DoomSectorType[0];

    for (; TempType->type != 0xFFFFffff ; TempType+=1)
    {   if  (TempType->type & 0xFFFF0000)  //8000)
        {    TempType++;
             if (TempType->typelong[0] != 'x')
             {   Curtype++;
             }
             TempType--;
        //{   Curtype++;
        }
        else
        if  (special == TempType->type
        &&   TempType->typelong[0] != 'x')
        {
             return Curtype;
             //break;
        }
   }
   //Trace(NULL,10,16,"sector category %hu for %hu",Curtype,special);
   if (GameVersion <=2
   &&  BOOMSupport)
   {   Curtype+=1;  // BOOM sector type
   }
   else
   {   Curtype+=2;  // skip separator, go to Number selection
   }

   return Curtype;
}


////////////////////////////////////////////////////////////////////////////
// Create line for popup menus
////////////////////////////////////////////////////////////////////////////

static void MakePopUpLine(HMENU  hMenu,int4 num, char *ch,char *name, int4 type)
{
     int4   CM1Plus1= CM_1+25;         // all commands based on this
     char   szWrk[80];

     if (DecimalTypes)
     {
         if( (num -CM_1) > 25)         // 26 letters in the alphabet, start at 1 ...
         {    sprintf(szWrk, "&%-hd    %-24s\t[ %-2hu ]",num - CM1Plus1,name,type);
         }
         else                          // use our char from A-Z
         {    sprintf(szWrk, "&%-.1s   %-24s\t[ %-2hu ]",ch,            name,type);
         }
     }
     else
     {
         if( (num -CM_1) > 25)         // 26 letters in the alphabet, start at 0 ...
         {    sprintf(szWrk, "&%-hd    %-24s\t[%04X]",num - CM1Plus1,name,type);
         }
         else                          // use our char from A-Z
         {    sprintf(szWrk, "&%-.1s   %-24s\t[%04X]",ch,            name,type);
         }
     }

     if  (type == TypeSEPARATOR)
     {
          AppendMenu(hMenu, MF_SEPARATOR, num,szWrk);
     }
     else
     {    AppendMenu(hMenu, MF_STRING, num, szWrk);
     }
}

//-----------------------------------------------------------------------//
//   display and execute a "things" menu
//
//   Appends subsequent 'found' strings of the correct type ( selectype )
//   to a floating, popup menu with ID's starting at 2001 ( CM_1 )so program
//   execution continues at those message points with the WM_COMMAND msg loop
//   in the ThingEditDlgProc
//
//-----------------------------------------------------------------------//


/////////////////////////////////////////////////////////
//                                                     //
// Displays a Pop Up menu with the Main Thing Menu     //
//                                                     //
// eg: Enter thing #, Player, Keys, Equip etc.         //
// 3-1-97   all rcMenu changed to rcThingMenu        //
/////////////////////////////////////////////////////////
static void DisplayThingsMenu(HWND hwnd, uint4 selectype)
{
   TypeThingPtr TempType;

   int4   len;

   int4   TotalHeight;
   int4   num   = CM_1;            //2001  CM_1 = our ID number for menu select start at 2001
   char   ch[2] = "A";             // Letters then number for quick access on menu's
   HMENU  hThingMenu;
   int2   menusize;

   int4   menuvalold=1;           // Highlight the previous selection   12-16-96
   int4   xMax,yMax;
   int4   xPos,yPos;

   //--------------------------------------------------------------

   //-----------find match in ThingNames for type of thing wanted

   TempType = ThingNames;                 //&DoomThingNames[0];

   PopupMenu = TRUE;
   hThingMenu = CreatePopupMenu();

   // Trace(NULL,40,4,"value=%04X",selectype);

   for (;  TempType->type != 0xFFFFffff ; TempType+=1)
   {
        if  ( TempType->type == selectype )
        {
            TempType+=1;

            for (;  num < (CM_1 + 41) && TempType->type != 0xFFFFffff ; TempType+=1)
            {  if  ( (TempType->type &0xFFFF0000) == 0xFFFF0000) break;    // switch type
               if  (  TempType->thingname[0] == 'x')continue;              // place holder 3-1-98

	             // skip '2' if this is Doom 1

               if (GameVersion == 1)
	            {  len = strlen( TempType->thingname);
		            if (TempType->thingname[len-1] == '2') continue;
	            }

               MakePopUpLine(hThingMenu,num,ch,TempType->thingname,TempType->type);

	            ThingIds[num -CM_1] = TempType->type;   // store type in table
	            num++;

	            if ( TempType->type == OldType)//level->Things[objnum].type)  suspect this needs OldThing instead
	            {    menuvalold= (num -CM_1);
	            }

               ch[0]++;      // our &1. &2. etc. for keyboard accel.
	         }
            break;
        }
   }

   if ((num -CM_1) > 0)        // created a menu
   {
     // display the menu -------------------------------------------------
 	  GetWindowRect(GetDlgItem(hwnd, IDD_THINGEDITPREV), &rcThingMenu);       //   3-1-97

     //Trace(gd.hMainWindow, 10,4, "oldtype=%hd", OldType);
     //     if( (num - 2001) > 10 )
     //         offset = (num-2011) * 10; // offset the menu so we KNOW where it is on the screen !
     //Trace(gd.hMainWindow, 200, 6, "val=%d", menuvalold-1);

     menusize = GetSystemMetrics(SM_CYMENUSIZE) -1;
     yMax     = GetSystemMetrics(SM_CYSCREEN);
     xMax     = GetSystemMetrics(SM_CXSCREEN);

     // make sure popup doesn't go below the bottom, otherwise cursor pos is off

     TotalHeight = menusize *( (num -CM_1)+1);                    // height of popup   12-16-96
     /*
     if ( (rcThingMenu.top + TotalHeight) >= yMax)
     {     rcThingMenu.top = yMax - TotalHeight;
           if (rcThingMenu.top <0 ) rcThingMenu.top= 0; //3-1-98
     }
     if ( rcThingMenu.right >= xMax)
     {    rcThingMenu.left = xMax - (rcThingMenu.right-rcThingMenu.left-10);
          if (rcThingMenu.left <0 ) rcThingMenu.left= 0;//3-1-98
     }*/
     xPos = rcThingMenu.right;
     yPos = rcThingMenu.top;
     if ( (yPos + TotalHeight) >= yMax)
     {     yPos = yMax - TotalHeight;
           if (yPos <0 ) yPos= 0; //3-1-98
     }
     if ( (xPos + 300) >= xMax)
     {     xPos = xMax -300;
     }


     SetCursorPos(xPos+30, yPos + (menusize / 2) + (menusize * (menuvalold-1)) );

     TrackPopupMenu(hThingMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
                    xPos+20, yPos, 0, hwnd, NULL); //   3-1-97

   }

   DestroyMenu(hThingMenu);
   PopupMenu = FALSE;          // Popup Menu Gone
}

//-----------------------------------------------------------------------//
//   display and execute a "thing" menu  (max 32  elements) (heading?)
//-----------------------------------------------------------------------//
#pragma argsused
static void DisplayThingsMenuX( HWND         hwnd,
                                POPupListPtr PopList,
                                uint4        commandID)
{
   TypeThingPtr TempType;

   int4   len;

   int4   TotalHeight;
   int4   num   = CM_1;            //2001  CM_1 = our ID number for menu select start at 2001
   char   ch[2] = "A";             // Letters then number for quick access on menu's
   HMENU  hThingMenu;
   int2   menusize;

   int4   menuvalold=1;           // Highlight the previous selection   12-16-96
   int4   xMax,yMax;
   int4   xPos,yPos;
   uint4  selectype=0;
// int4 rcwidth = (rcThingMenu.right-rcThingMenu.left);

   //--------------------------------------------------------------

   for ( ;PopList->name; PopList++)
   {
         if (PopList->commandID == commandID)
         {   selectype = PopList->type;
             break;
         }
   }
   //-----------find match in ThingNames for type of thing wanted

   TempType = ThingNames;                 //&DoomThingNames[0];

   PopupMenu = TRUE;
   hThingMenu = CreatePopupMenu();

   // Trace(NULL,40,4,"value=%04X",selectype);

   for (;  TempType->type != 0xFFFFffff ; TempType+=1)
   {
        if  ( TempType->type == selectype )
        {
            TempType+=1;

            for (;  num < (CM_1 + 41) && TempType->type != 0xFFFFffff ; TempType+=1)
            {  if  ( (TempType->type &0xFFFF0000) == 0xFFFF0000) break;    // switch type
               if  (  TempType->thingname[0] == 'x')continue;              // place holder 3-1-98

	             // skip '2' if this is Doom 1

               if (GameVersion == 1)
	            {  len = strlen( TempType->thingname);
		            if (TempType->thingname[len-1] == '2') continue;
	            }

               MakePopUpLine(hThingMenu,num,ch,TempType->thingname,TempType->type); // add a popup line

	            ThingIds[num -CM_1] = TempType->type;   // store type in table
	            num++;

	            if ( TempType->type == OldType)//level->Things[objnum].type)  suspect this needs OldThing instead
	            {    menuvalold= (num -CM_1);
	            }

               ch[0]++;      // our &1. &2. etc. for keyboard accel.
	         }
            break;
        }
   }

   if ((num -CM_1) > 0)        // created a menu
   {
     // display the menu -------------------------------------------------
 	  GetWindowRect(GetDlgItem(hwnd, IDD_THINGEDITPREV), &rcThingMenu);       //   3-1-97

     menusize = GetSystemMetrics(SM_CYMENUSIZE) -1;
     yMax     = GetSystemMetrics(SM_CYSCREEN);
     xMax     = GetSystemMetrics(SM_CXSCREEN);

     // make sure popup doesn't go below the bottom, otherwise cursor pos is off

     TotalHeight = menusize *( (num -CM_1)+1);           // height of popup   12-16-96
     xPos = rcThingMenu.right;
     yPos = rcThingMenu.top;
     if ( (yPos + TotalHeight) >= yMax)
     {     yPos = yMax - TotalHeight;
           if (yPos <0 ) yPos= 0; //3-1-98
     }
     if ( (xPos + 300) >= xMax)
     {     xPos = xMax -300;
     }

     /*
     if ( (rcThingMenu.top + TotalHeight) >= yMax)
     {     rcThingMenu.top = yMax - TotalHeight;
           if (rcThingMenu.top <0 ) rcThingMenu.top= 0; //3-1-98
     }
     if ( rcThingMenu.right >= xMax)
     {    rcThingMenu.left = xMax - rcwidth-10;
          if (rcThingMenu.left <0 ) rcThingMenu.left= 0; //3-1-98
          rcThingMenu.right= rcThingMenu.left+rcwidth;
          Trace(NULL,10,4,"width=%d (%d,%d)",rcwidth,rcThingMenu.right, rcThingMenu.top);
     }*/

     SetCursorPos(xPos+30, yPos + (menusize / 2) + (menusize * (menuvalold-1)) );

     TrackPopupMenu(hThingMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
                    xPos+20, yPos, 0, hwnd, NULL); //   3-1-97

   }

   DestroyMenu(hThingMenu);
   PopupMenu = FALSE;          // Popup Menu Gone
}

//-----------------------------------------------------------------------//
//   display and execute a "linedef type" menu  (max 32  elements) (heading?)
//-----------------------------------------------------------------------//
#pragma argsused
static void DisplayLineDefTypeMenu( HWND  hwnd,
                                    int2  x0, int2 y0,
                                    int2  objnum,         // or Special from thing
                                    Bool  fromlinedef,
                                    uint4 selectype)

{
   LevelPtr level=&LevelWad.level;

   int4   n;
   int4   num = CM_1;        //2001;
   uint2  tmptype;           // 3-1-98

   uint2  arg4;
   char   ch[2] = "A";       //dec 65
   int2   menusize;
   int2   menuEntries=0;
   int4   TotalHeight;
   int4   yMax;
   int2   oldloc;                     // rel value old stuff   linedeftypemenu
   Bool   hit;

   POINT  PriorCurPos;             //   12-16-96

   HMENU  hLineMenu;

   //-----------find match in TypeLineDef for type of linedef wanted

   //Trace(NULL,10,4,"x=%hd, y=%hd",x0,y0);
   //Trace(NULL,10,4,"type=%04X,",selectype);

   GetCursorPos( &PriorCurPos );   //   12-2-96

   hLineMenu = CreatePopupMenu();

   TypeDescPtr TempType = TypeLineDef;                    //&DoomLineDefType[0], etc;

   for (; TempType->type != 0xFFFFffff ; TempType+=1)
   {
      if  (TempType->type == selectype )                  // find type category
      {    TempType+=1;                                   // start of names

           //Trace(NULL,10,24,"found type=%04X,",selectype);
	        for (; num < CM_1 + 32 && TempType->type != 0xFFFFffff; TempType+=1)
	        {
              if ( (TempType->type & 0xFFFF0000)) break;   //end of types or separator

              if (  TempType->typelong[0] == 'x')continue; // place holder 3-1-98

              MakePopUpLine(hLineMenu,num,ch,TempType->typelong,TempType->type); // add a popup line
              //if ( TempType->type != TypeSEPARATOR)
              {
	                types  [num-CM_1] = TempType->type;             // type number
	                Ltag   [num-CM_1] = TempType->tag;
	                Larg1  [num-CM_1] = TempType->arg1;
	                Larg2  [num-CM_1] = TempType->arg2;
	                Larg3  [num-CM_1] = TempType->arg3;
	                Larg4  [num-CM_1] = TempType->arg4;
	                Larg5  [num-CM_1] = TempType->arg5;
	                Lflag  [num-CM_1] = TempType->flag;

                   // if HEXEN set default DOOR

                   if (GameVersion == 4)
                   {
                       if (types[num-CM_1] == 12)                  // door open
                       {   Larg2[num-CM_1] = DefaultDoorSpeed;
                           Larg3[num-CM_1] = DefaultDoorDelay;
                       }
                   }
	                num++;

                   if ( TempType->type != TypeSEPARATOR)
                        ch[0]++; // &A. &B. &1. etc. for quick keyboarding
              }
              menuEntries++;
	        }
           break;  //++10-18
      }
   }

   if (num -CM_1 <=0) return ;

   // display the menu -------------------------------------------------

   if ( fromlinedef)                              // linedef entry
   {   tmptype = level->LineDefs[objnum].type;
       arg4 = level->LineDefs[objnum].arg4;
   }
   else                                           // thing entry
   {   tmptype = level->Things[objnum].special;
       arg4 = level->Things[objnum].arg4;
   }

   ///Trace(0,0,"type %hd arg4 %hd",type,arg4);
   hit = FALSE;

   for (oldloc=0; oldloc < num-CM_1 ; oldloc++)
   {   if  (tmptype == types[oldloc])
       {
           if ( GameVersion == 4 )               // HEXEN
           {   // look for key match
	            for (n=oldloc; n < num-CM_1; n++)
	            {   if (tmptype == types[n] )
		             {   if (arg4 == Larg4[n] )     // same key
		                 {   oldloc = n;
			                  break;
		                 }
		             }
		         }
	        }
           hit= TRUE;
           break;
       }
   }

   if (!hit) oldloc = 0;

   // display the menu -------------------------------------------------

   //   if( (num - 2001) > 10)
   //        offset = (num-2011) * 10;    // offset the menu so we KNOW where it is on the screen !
   //Trace(gd.hMainWindow, 200, 6, "val=%d", menuvalold-1);

   menusize = GetSystemMetrics(SM_CYMENUSIZE) -1;
   yMax     = GetSystemMetrics(SM_CYSCREEN);

   TotalHeight = menusize * (menuEntries+1);//((num-CM_1)+1);  height of popup   3-1-98

   if ( (y0+TotalHeight) >= yMax )
   {     y0 = yMax - TotalHeight;
         if (y0 < 0) y0=0;  // 3-1-98
   }
   if( x0 < 0)   x0 = 0;

   PopupMenu = TRUE;                 // don't let exit on right mouse click

   SetCursorPos(x0 + 30, y0 + (menusize / 2) + (menusize * (oldloc)) );                          //   12-16-96

   TrackPopupMenu(hLineMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
                  x0, y0, 0, hwnd, NULL);//   12-16-96

   DestroyMenu(hLineMenu);
   PopupMenu = FALSE;          // Popup Menu Gone

   SetCursorPos( PriorCurPos.x,PriorCurPos.y );       //   12-2-96
}


//-----------------------------------------------------------------------//
//   display and execute a "linedef type" menu  (max 32  elements) (heading?)
//-----------------------------------------------------------------------//
#pragma argsused
static void DisplayLineDefTypeMenuX( HWND  hwnd,
                                    int2  x0, int2 y0,
                                    int2  objnum,         // or Special from thing
                                    Bool  fromlinedef,
                                    POPupListPtr PopList,
                                    uint4        commandID)

{
   LevelPtr level=&LevelWad.level;

   int4   n;
   int4   num = CM_1;        //2001;
   int4   menuEntries=0;
   int4   MenuYloc;
   uint2  tmptype;           // 3-1-98

   uint2  arg4;
   char   ch[2] = "A";       //dec 65
   int2   menusize;
   int4   TotalHeight;
   int4   yMax;
   int2   oldloc;                     // rel value old stuff   linedeftypemenu
   Bool   hit;
   uint4  selectype=0;

   POINT  PriorCurPos;             //   12-16-96

   HMENU  hLineMenu;

   //-----------find match in TypeLineDef for type of linedef wanted

   //Trace(NULL,10,4,"x=%hd, y=%hd",x0,y0);
   //Trace(NULL,10,4,"type=%04X,",selectype);

   GetCursorPos( &PriorCurPos );   //   12-2-96

   for ( ;PopList->name; PopList++)
   {
         if (PopList->commandID == commandID)
         {   selectype = PopList->type;
             break;
         }
   }

   hLineMenu = CreatePopupMenu();

   TypeDescPtr TempType = TypeLineDef;                    //&DoomLineDefType[0], etc;

   for (; TempType->type != 0xFFFFffff ; TempType+=1)
   {
      if  (TempType->type == selectype )                  // find type category
      {    TempType+=1;                                   // start of names

           //Trace(NULL,10,24,"found type=%04X,",selectype);
	        for (; num < CM_1 + 32 && TempType->type != 0xFFFFffff; TempType+=1)
	        {
              if ( (TempType->type & 0xFFFF0000)) break;   //end of types or separator

              if (  TempType->typelong[0] == 'x')continue; // place holder 3-1-98

              MakePopUpLine(hLineMenu,num,ch,TempType->typelong,TempType->type); // add a popup line

	           types  [num-CM_1] = TempType->type;             // type number
	           Ltag   [num-CM_1] = TempType->tag;
	           Larg1  [num-CM_1] = TempType->arg1;
	           Larg2  [num-CM_1] = TempType->arg2;
	           Larg3  [num-CM_1] = TempType->arg3;
	           Larg4  [num-CM_1] = TempType->arg4;
	           Larg5  [num-CM_1] = TempType->arg5;
	           Lflag  [num-CM_1] = TempType->flag;

              // if HEXEN set default DOOR

              if (GameVersion == 4)
              {
                   if (types[num-CM_1] == 12)                  // door open
                   {   Larg2[num-CM_1] = DefaultDoorSpeed;
                       Larg3[num-CM_1] = DefaultDoorDelay;
                   }
              }
	           num++;
              if ( TempType->type != TypeSEPARATOR)
              {    ch[0]++; // &A. &B. &1. etc. for quick keyboarding
              }
              menuEntries++;
	        }
           break;  //++10-18
      }
   }

   if (num -CM_1 <=0) return ;

   // display the menu -------------------------------------------------

   if ( fromlinedef)                              // linedef entry
   {   tmptype = level->LineDefs[objnum].type;
       arg4 = level->LineDefs[objnum].arg4;
   }
   else                                           // thing entry
   {   tmptype = level->Things[objnum].special;
       arg4 = level->Things[objnum].arg4;
   }

   ///Trace(0,0,"type %hd arg4 %hd",type,arg4);
   hit = FALSE;
   menusize = GetSystemMetrics(SM_CYMENUSIZE) -1;
   yMax     = GetSystemMetrics(SM_CYSCREEN);
   MenuYloc  = menusize / 2;                       // 1/2 way down menu

   for (oldloc=0; oldloc < num-CM_1 ; oldloc++)
   {
       if  (tmptype == types[oldloc])
       {
           if ( GameVersion == 4 )               // HEXEN
           {   // look for key match
	            for (n=oldloc; n < num-CM_1; n++)
	            {   if (tmptype == types[n] )
		             {   if (arg4 == Larg4[n] )     // same key
		                 {   //oldloc = n;
			                  break;
		                 }
		             }
		         }
	        }
           hit= TRUE;
           break;
       }

       if  (types[oldloc] == TypeSEPARATOR)
       {    MenuYloc += (menusize-7);
       }
       else
       {    MenuYloc +=  menusize;
       }
   }

   //if (!hit) oldloc = 0;
   if (!hit) MenuYloc = menusize/2;  // 3-1-98

   // display the menu -------------------------------------------------

   //   if( (num - 2001) > 10)
   //        offset = (num-2011) * 10;    // offset the menu so we KNOW where it is on the screen !
   //Trace(gd.hMainWindow, 200, 6, "val=%d", menuvalold-1);

   //   menusize = GetSystemMetrics(SM_CYMENUSIZE) -1;
   //   yMax     = GetSystemMetrics(SM_CYSCREEN);

   TotalHeight = menusize * (menuEntries+1);//((num-CM_1)+1);                               // height of popup   12-16-96

   if ( (y0+TotalHeight) >= yMax )
   {     y0 = yMax - TotalHeight;
         if (y0 <0 ) y0 = 0;
         //Trace(gd.hMainWindow, 10, 6, "popadjY=%d", y0);
   }
   if( x0 < 0)   x0 = 0;

   PopupMenu = TRUE;                 // don't let exit on right mouse click

//   SetCursorPos(x0 + 30, y0 + (menusize / 2) + (menusize * (oldloc)) );                          //   12-16-96
   SetCursorPos(x0 + 30, y0 + MenuYloc);  // 3-1-98

   TrackPopupMenu(hLineMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
                  x0, y0, 0, hwnd, NULL);//   12-16-96

   DestroyMenu(hLineMenu);
   PopupMenu = FALSE;          // Popup Menu Gone

   SetCursorPos( PriorCurPos.x,PriorCurPos.y );       //   12-2-96
}

//-----------------------------------------------------------------------//
//   display and execute a "Sector type" menu  (max 32  elements)
//-----------------------------------------------------------------------//
#pragma argsused
static void DisplaySectorTypeMenu(HWND hwnd, int2 x0, int2 y0, int2 objnum,uint4 selectype)
{
   int2   menusize;

   TypeDescPtr TempType = TypeSector;//&DoomSectorType[0];

   char   ch[2] = "A";
   int4   num = CM_1;             //2001 3-1-98

   HMENU  hSectorMenu;
   int4   menuvalold=1;           // Highlight the previous selection   12-16-96
   int4   TotalHeight;
   int4   yMax;

   hSectorMenu = CreatePopupMenu();


   //-----------find match in TypeSector for type of Sector type wanted

   for (; num < CM_1 + 32 && TempType->type!= 0xFFFFffff ; TempType+=1)
   {   if  (TempType->type == selectype)
       {  TempType+=1;                                   // start of names

    	    for (; num < CM_1 + 32 && TempType->type != 0xFFFFffff; TempType+=1)
	       {  if ( (TempType->type & 0xFFFF0000))break;//8000) )break;

             if (  TempType->typelong[0] == 'x')continue;       // place holder 3-1-98

             MakePopUpLine(hSectorMenu,num,ch,TempType->typelong,TempType->type);

	          types[num-CM_1] = TempType->type;
	          num++;

	          if ( TempType->type == OldType)       // find our Old Menu Selection here
	          {    menuvalold= (num -CM_1);
	          }

             ch[0]++;
	        }
           break;   //++10-18
       }
   }

   if (num -CM_1 <=0) return ;

   // display the menu -------------------------------------------------
   menusize = GetSystemMetrics(SM_CYMENUSIZE) - 1;

   TotalHeight = menusize * ((num -CM_1)+1);       // height of popup   12-16-96
   yMax        = GetSystemMetrics(SM_CYSCREEN);

   if ( (y0 + TotalHeight) >= yMax)
   {     y0 = yMax - TotalHeight;
         if (y0 < 0) y0=0;  //3-1-98
   }

   if (x0 < 0)  x0 = 0;

   PopupMenu = TRUE;                            // init offset + Height * menuvalue

   SetCursorPos(x0 + 10, y0 + (menusize / 2) + (menusize * (menuvalold-1)) );
   TrackPopupMenu(hSectorMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
                  x0, y0, 0, hwnd, NULL);

   DestroyMenu(hSectorMenu);
   PopupMenu = FALSE;          // Popup Menu Gone

   //return types[val];
}


//----------------------------------------------------------------------------
//  special linedef menu for HEXEN things
//----------------------------------------------------------------------------
#pragma argsused
static void EditThingLineInfo(HWND hwnd, int2 x0, int2 y0, int2 objnum)//thingspecial)
{
   POINT pMenu;
   int4   menuvalold;           // Highlight the previous selection   12-16-96

   pMenu.x = x0;
   pMenu.y = y0;

   LevelPtr level=&LevelWad.level;
   int2  thingspecial;

//------------------------------------------------------------------------------

  thingspecial = level->Things[objnum].special;
  menuvalold   = FindWhichLineType (thingspecial)+1;

//  GetWindowRect(GetDlgItem(hwnd, IDD_THINGEDITPREV), &rcMenu);
  //pMenu.x = rcMenu.right+20; // over 20 from the Thing Preview Window
  //pMenu.y = rcMenu.top;
  pMenu.x = x0; // over 20 from the Thing Preview Window
  pMenu.y = y0;

  if(pMenu.x < 0)  pMenu.x = 0;

  HandlePopupMenu(hwnd, IDS_MENULINETHINGHX, pMenu, TRUE, menuvalold-1 ); // Set Cursor Position
}

//---------------------special THING Spawn selection for HEXEN--------------
// used bylinedefs and things   argdesc[1] = Type
//--------------------------------------------------------------------------
#pragma argsused
static Bool ThingSpawnSpecial(HWND hwnd, int2 x0, int2 y0, int2 special)   // special - old val.
{
  POINT pMenu;
  int4  menuvalold;                  // Highlight the previous selection   12-16-96

  pMenu.x = x0;
  pMenu.y = y0;
  Bool val = -2;
  TypeThingPtr  OldThingNames ;      // temp save Hexen Spawn Names    3-1-97


  if (!strncmp(argdesc[1],"Type",4) )     // set the type now
  {
      OldThingNames = ThingNames;             // save old name
      ThingNames = &HexenSpawnThingNames[0];  // switch to spawn names for FindWhichThing

      menuvalold = FindWhichThingType (special);//

      ThingNames = OldThingNames;             // restore save old name   3-1-97

      pMenu.x = x0; //  3-1-97 pick up from parms
      pMenu.y = y0;

      val = 1;

      if(pMenu.x < 0)  pMenu.x = 0;
		HandlePopupMenu(hwnd, IDS_MENUTHINGSPAWN, pMenu, TRUE,menuvalold-1 ); // Set Cursor Position

  }
  return val;
}

//-------------------------------------------------------------------------
//    help for user   12-13-96 (don't use right now, since having
//    to click a button is a pain, need to save restore image or F1 help
//-------------------------------------------------------------------------
/*
#pragma argsused
void ShowAngleHelp(HWND hwnd)
{
   //MsgInfoBox(hwnd, "Arg Angle Values",

   InformationMsg (hwnd,CENTER|HELPINFO,&hAngleSaveBMP,
                   "Arg Angle Values",
                   "",
                   " 0 = E\t\t128 = W ",
                   "32 = NE\t160 = SW",
                   "64 = N \t192 = S ",
                   "96 = NW\t224 = SE",
                   NULL);
}  */
//-------------------special line for HEXEN -------------------------------
// direct access to special stuff
//-------------------------------------------------------------------------
static void EditLineCommand(HWND hwnd, LevelPtr level, SelPtr obj)
{
  SelPtr cur;

  int4  n;

  int2  NextFreeTag;
  int2  NextFreePolyId;
  int2  NextFreeTid;
  int2  NextFreeLineId;

  char* Adesc[5];    // argdesc[0]--4;

  char  prompt [60];
  char  Aprompt[20] = "none";
  HWND  hDlgModeless = NULL;

//--------------------------------------------------------------------------

  //Trace(0,0,"tag=arg0 %hd high %hd ",larg[0],HighTid);  //

  //special = ThingSpawnSpecial(larg[1]);     //special-only if arg2 = "Type"

  if (special == -2 ) return;        // it's a special, don't do   3-1-97

  // 1-25-97 bk ( getting much closer to DOS now but still don't like all this )
  // this was another part I was confused on - If I had to do it all over again
  // it sure wouldn't be like this !
  // 3-1-97  , Windows sort of stuffed the whole thing, major hard to follow now
  //
  lspecial = level->LineDefs[ obj->objnum].type;  // special (linedef type)
  larg[0]  = level->LineDefs[ obj->objnum].tag ;  // arg1
  larg[1]  = level->LineDefs[ obj->objnum].arg2;  //    2
  larg[2]  = level->LineDefs[ obj->objnum].arg3;  //    3
  larg[3]  = level->LineDefs[ obj->objnum].arg4;  //    4
  larg[4]  = level->LineDefs[ obj->objnum].arg5;  //    5
  // 1-25-97 bk

  //Trace(0,0,"tag=arg0 %hd high %hd ",larg[0],HighTid);  //

  SetLineDefArgs(lspecial, larg[3]);              // set arg names

  for (n=0; n < 5; n++)
  {
       Adesc[n] = argdesc[n];
       if ( !(strncmp(argdesc[n],"Ang",3) ) )
       {   // anglehelp
           hDlgModeless = CreateDialogParam(gd.hInst, "Angle", hwnd, AngleDlgProc, (DWORD)0); // bdk 12-16-96
       }

       if (*argdesc[n] == '\0')
       {   Adesc[n] = NULL;
           larg[n] = 0;
           //break;
       }
  }

  if (special >=0 )
  {   larg[1] = special;      // arg2 = special code
  }


  if (Adesc[0]!=NULL )
  {
      if (!strncmp(Adesc[0],"Tid",3) )           // Tid
      {
          NextFreeTid = FindFreeTid();

          sprintf(Aprompt,"Tid f%hd,u%hd)",NextFreeTid,LastTidUsed);

          if (larg[0] > HighTid
          ||  larg[0] <=0 )
          {   larg[0] = NextFreeTid;
          }
      }
      else
      if (!strncmp(Adesc[0],"Pol",3) )            // Poly Object
      {
          NextFreePolyId = FindFreePolyTid();

          sprintf(Aprompt,"PolyId f%hd,u%hd",NextFreePolyId,LastPolyUsed);

          if (larg[0] > HighPolyId
          ||  larg[0] <=0 )
          {   larg[0] = NextFreePolyId;
          }
      }
      else
      if (!strncmp(Adesc[0],"Tag",3) )            // Poly Object
      {
          NextFreeTag = FindFreeTag();

          sprintf(Aprompt,"Tag f%hd,u%hd",NextFreeTag,LastTagUsed);
          // Not Doors
          if (lspecial !=12 && lspecial !=13)
          {
             if (larg[0] > HighTag ||  larg[0] <=0 )
             {   larg[0] = NextFreeTag;
             }
          }
      }
      else
      if (!strncmp(Adesc[0],"Lineid",6) )            // Lineidentify
      {
          NextFreeLineId= FindFreeLineId();

          sprintf(Aprompt,"LineId f%hd,u%hd",NextFreeLineId,LastLineIdUsed);
          if (larg[0] > HighLineId
          ||  larg[0] <=0 )
          {   larg[0] = NextFreeLineId;
          }
      }
      else
      {   strcpy(Aprompt,Adesc[0]);
      }
  }

  sprintf(prompt,"%s",LineDefTypeName( lspecial,larg[3]) ); // linedef type (16 max)

  // get hexen args  (only hexen   12-2-96)

  if (InputHexenArgs(hwnd, prompt,   //"LineDef Args",
		   Aprompt,  &larg[0],         // Tag Adesc[0]
		   Adesc[1], &larg[1],         // special
		   Adesc[2], &larg[2],
		   Adesc[3], &larg[3],
		   Adesc[4], &larg[4]) )
  {
      for (cur = obj; cur; cur = cur->next)
      {
           level->LineDefs[ cur->objnum].type = lspecial;
           level->LineDefs[ cur->objnum].tag  = larg[0];
           level->LineDefs[ cur->objnum].arg2 = larg[1];
           level->LineDefs[ cur->objnum].arg3 = larg[2];
           level->LineDefs[ cur->objnum].arg4 = larg[3];
           level->LineDefs[ cur->objnum].arg5 = larg[4];
      }
      level->MadeChanges++;

      if (Adesc[0]!=NULL )
      {   if (larg[0] > 0)    // only > 0   8-1-97
          {
              if (!strncmp(Adesc[0],"Tid",3) )           // Tid
              {
                   LastTidUsed= larg[0];
              }
              else if (!strncmp(Adesc[0],"Pol",3) )            // Poly Object
              {
                   LastPolyUsed=larg[0];
              }
              else if (!strncmp(Adesc[0],"Tag",3) )            // Tag Object
              {
                   LastTagUsed =larg[0];
              }
              else if (!strncmp(Adesc[0],"Lineid",6) )         // lineid
              {
                   LastLineIdUsed =larg[0];
              }
          }
      }
   }

  if(hDlgModeless)
  {  DestroyWindow(hDlgModeless); // get rid of the dialog
  }

}

//------------------------------------------------------------------------

void InitThingCommand(SelPtr obj, LevelPtr level)
{

   ThingType= level->Things[ obj->objnum].type;
   OldPolyId= level->Things[ obj->objnum].angle  ;  // angle is really polyid
   tid      = level->Things[ obj->objnum].tid    ;
   tspecial = level->Things[ obj->objnum].special;
   targ[0]  = level->Things[ obj->objnum].arg1   ;
   targ[1]  = level->Things[ obj->objnum].arg2   ;   // special id
   targ[2]  = level->Things[ obj->objnum].arg3   ;
   targ[3]  = level->Things[ obj->objnum].arg4   ;
   targ[4]  = level->Things[ obj->objnum].arg5   ;

   SetThingDefArgs(ThingType);  // set arg names for THING   3-1-97 trying to fix exception may not be needed
}

//---------------------special THING edit for HEXEN-----------------------
//  get Tid
//      Polyid
//      all args
//------------------------------------------------------------------------
//
//#pragma argsused
//void EditThingCommand(HWND hwnd, int2 x0, int2 y0,LevelPtr level, SelPtr obj,
void EditThingCommand(HWND hwnd, LevelPtr level, SelPtr obj,
                      int2 mode) //0=only if args, 1=args only, 2=special
{
   SelPtr cur;
   int4   n;

   Bool  AskForArgs = TRUE;
   int2  NextFreeTag;
   int2  NextFreePolyId;
   int2  NextFreeTid;

static char Mode1[]    = "Special %s";   //Special %hd";
static char Mode2[]    = "%-18.18s";
       char prompt[36] = {0};
       char Aprompt[16]= "none";
       char* Adesc[5]={0};    // argdesc[0]--4;

       HWND  hDlgModeless = NULL;  // bdk 12-16-96
//------------------------------------------------------------------------

//    SetThingDefArgs(ThingType);    // set arg names for THING

   if (mode == 2)                 // set all args
   {
       // tspecial = EditThingLineInfo( x0, y0, obj->objnum);
       //EditThingLineInfo(hwnd, x0, y0, obj->objnum);
       if (tspecial == 13)
       {   targ[3] = larg[3];     // key value
       }
   }


   if (! (tspecial & 0x8000) )    // positive number since this is a uint cant say < 0
   {
       // copy values from thing linedef only if no values
       if (mode == 2)
       {  if ( !(targ[0]+targ[1]+targ[2]+targ[3]+targ[4]) )
          {
              targ[0] = larg[0];
              targ[1] = larg[1];
              targ[2] = larg[2];
              targ[3] = larg[3];
              targ[4] = larg[4];
           }

           // LineDef special for THING

           sprintf(prompt,Mode1,LineDefTypeName( tspecial, targ[3]) );   // 16 max

           //  special = ThingSpawnSpecial(hwnd, x0,y0,tspecial);   // Moved to dialog loop

           if (special == -2 ) return;

           if (special >=0 )
           {   targ[1] = special;                 // arg 2 = this special id
           }

           for (n=0; n < 5; n++)
           {   Adesc[n] = argdesc[n];
               if (*argdesc[n] == '\0')
               {   Adesc[n] = NULL;
                   targ[n]  = 0;
               }
           }
           if (Adesc[0] == NULL)                  //fixed 11-14 was '\0'
           {   Adesc[0] = "no args";
           }
       }
       else
       {   if ( SetThingDefArgs(ThingType) < 0     // set arg names for THING
            &&  mode == 0) return;                 // no args to prompt for

           sprintf (prompt,Mode2,GetThingPrintName(ThingType));
           for (n=0; n < 5; n++)
           {   Adesc[n] = argdesc[n];
               if (*Adesc[n] == '\0')
               {   if (mode != 0 )
                   {   sprintf(Adesc[n],"Arg%-d",n+1);
                   }
                   else
                   {   Adesc[n] = NULL;
                       break;
                   }
               }
           }
       }

       for (n=0; n < 5; n++)
       {   if (!strncmp(argdesc[n],"Ang",3) )
           {     // anglehelp
                hDlgModeless = CreateDialogParam(gd.hInst, "Angle", hwnd, AngleDlgProc, (DWORD)0); // bdk 12-16-96
           }
       }

       if (Adesc[0]!=NULL )
       {
          if (!strncmp(Adesc[0],"Tid",3) )           // Tid
          {
              NextFreeTid = FindFreeTid();

              sprintf(Aprompt,"Tid f%hd,u%hd)",NextFreeTid,LastTidUsed);

              if (tid > HighTid
              ||  tid <=0 )
              {   tid = NextFreeTid;
              }

              //if (InputNumbers(hwnd, prompt, 1,255,&tid) )
              tid = Input1Number(hwnd, prompt, Aprompt, 1, 255, tid);      // get tid
              if(tid)
              {
                 for (cur = obj; cur; cur = cur->next)
	              {    level->Things[ cur->objnum].tid  = tid;
	              }
                 LastTidUsed = tid;                      // moved   8-1-97
              }

              level->MadeChanges++;
              sprintf (prompt,Mode2,GetThingPrintName(ThingType));
              sprintf(Aprompt,"Arg1");                // reset if mode == 2 prompt
              if (mode == 0) AskForArgs  = FALSE;
          }
          else
          if (!strncmp(Adesc[0],"Pol",3) )            // Poly Object
          {
              NextFreePolyId = FindFreePolyTid();

              sprintf(Aprompt,"PolyId f%hd,u%hd",NextFreePolyId,LastPolyUsed);

              if (OldPolyId > HighPolyId
              ||  OldPolyId <=0 )
              {   OldPolyId = NextFreePolyId;
              }

             // if (InputNumbers(hwnd, prompt, Aprompt, 1,255,&OldPolyId) )
             OldPolyId = Input1Number(hwnd, prompt, Aprompt, 1, 255, OldPolyId); // get polyid
             if(OldPolyId)
             {
                 for (cur = obj; cur; cur = cur->next)
                 {    level->Things[ cur->objnum].angle= OldPolyId;
                 }

                 level->MadeChanges++;
                 LastPolyUsed = OldPolyId;
              }

              sprintf (prompt,Mode2,GetThingPrintName(ThingType));
              sprintf(Aprompt,"Arg1");               // reset if mode == 2 prompt
              if (mode == 0) AskForArgs = FALSE;
          }
          else
          if (!strncmp(Adesc[0],"Tag",3) )            // Tag Object (special only)
          {
              NextFreeTag = FindFreeTag();

              sprintf(Aprompt,"Tag f%hd,u%hd",NextFreeTag,LastTagUsed);
              if (targ[0] > HighTag
              ||  targ[0] <=0 )
              {   targ[0] = NextFreeTag;
              }
          }
          else
          {   strcpy(Aprompt,Adesc[0]);
          }
       }

       // get all args

       if ( AskForArgs &&  InputHexenArgs(hwnd, prompt,       //"Thing Special or Thing type
		                               Aprompt ,&targ[0],  // tid,polyid,tag
		                               Adesc[1],&targ[1],  // special(type)
		                               Adesc[2],&targ[2],
		                               Adesc[3],&targ[3],
		                               Adesc[4],&targ[4]) )
       {
          for (cur = obj; cur; cur = cur->next)
          {
               level->Things[ cur->objnum].special=tspecial;
               level->Things[ cur->objnum].arg1   =targ[0];
               level->Things[ cur->objnum].arg2   =targ[1];
               level->Things[ cur->objnum].arg3   =targ[2];
               level->Things[ cur->objnum].arg4   =targ[3];
               level->Things[ cur->objnum].arg5   =targ[4];
          }
          level->MadeChanges++;

          if (!strncmp(Adesc[0],"Tag",3) )            // Tag Object
          {
              if (targ[0]) LastTagUsed =targ[0];      //   8-1-97 only > 0
          }
       }

   }

   if(hDlgModeless)
   {  DestroyWindow(hDlgModeless); // get rid of the dialog bdk 12-16-96
   }
}


//-----------------------------------------------------------------------
// show  a picture of the thing (for thing menu)
//-----------------------------------------------------------------------
//                               mode: 2 = from outside call, display existing
//                                     0/1 from menu call
static void ShowThing (HWND hwnd,int2 menumode, int2 menuval)
{
  int2 thisthing;
  TypeThingPtr TempTypeThing;

//-----------------------------------------------------------------------

  if (menuval < 0) return;

    if (menumode !=2)        // 0,1 is from DisplayMenu, 2 is direct call
    {   thisthing = ThingIds[menuval];
    }
    else
    {   thisthing = menuval;
    }

    TempTypeThing = GetThingInfo (thisthing);

    if (TempTypeThing->type)
    {   BigThingName = TempTypeThing->picname;
        thingmagnify      = TempTypeThing->magnify;
        if (thingmagnify == 0) thingmagnify = 2;
    }
    else
    {   thingmagnify = 1;
        BigThingName = Unknown;
    }

    // show the big box if name changes
    if ( strcmp(oldBigThingName,BigThingName) )
    {
         InvalidateRect(hwnd, NULL, TRUE);

         oldBigThingName = BigThingName;

    }
}

//////////////////////////////////////////////////////////////////////////////
// We have a valid menu select, update levelwad and show pic
//
// also used to manually enter thing #
//////////////////////////////////////////////////////////////////////////////
static void ShowMenuSelect(HWND hDlg, int2 Id, Bool direct)
{
  int2 newtype;

  if(direct)   newtype = Id;           // direct thing # input
  else         newtype = ThingIds[Id];

  ShowThing (GetDlgItem(hDlg, IDD_THINGEDITPREV), 2, newtype );

}

///////////////////////////////////////////////////////////////////////////////
//
// Depending on the Gameversion, finds the proper ID
// from our string table for the menu to load and
// then calls the popup menu handler to display it
// program control then resumes at WM_COMMAND of hwnd with the ID
//
// NOTE: IDS_ id codes must be consecutive in windeep.h !
//
///////////////////////////////////////////////////////////////////////////////

static void HandleEditThingMenu(HWND hwnd)
{
   POINT pMenu;
   int   id;
// LevelPtr level = &LevelWad.level;
   int4   menuvalold;           // Highlight the previous selection   12-16-96

   //id = IDS_MENUTEDITD - 1 + GameVersion; //  1010 - 1 + (1-5)
   if (GameVersion == 3)
   {   id = IDS_MENUTEDITH;
   }
   else
   if (GameVersion == 4)
   {   id = IDS_MENUTEDITHX;
   }
   else
   if (GameVersion == 5)
   {   id = IDS_MENUTEDITS;
   }
   //else  DOOM
   //{
   //}

   pMenu.x = rcThingMenu.right+20; // over 20 from the Thing Preview Window
   pMenu.y = rcThingMenu.top;      //

   /*  3-1-98 popups adjust themselves
   if (GameVersion == 4            // make thing menu higher to fit for hexen
   &&  ScrMaxY < 680)              // 800 x 600 or less
   {   pMenu.y -= 90;
       if (ScrMaxY < 480)          // some more for 640
       {   pMenu.y -= 30;
       }
   }
   */
   menuvalold = FindWhichThingType(OldType);//level->Things[TempList->objnum].type);//  3-1-98

   if(pMenu.x < 0)  pMenu.x = 0;

	//HandlePopupMenu(hwnd, id, pMenu, TRUE, menuvalold-3 ); // Set Cursor Position
   if (GameVersion > 2)
   {   HandlePopupMenu(hwnd, id, pMenu, TRUE, menuvalold-3 ); // Set Cursor Position
   }
   else
   {   DisplayPopMenu(hwnd, pMenu, TRUE, DoomThingList, menuvalold-1);  // create dynamic popup
   }
}

////////////////////////////////////////////////////////////////////////
//  Similar to above, except for the Linemenu
////////////////////////////////////////////////////////////////////////
                                  // from linedef main, or linedef flags
static void HandleLineTypeMenu(HWND hwnd, int left, int top)//Bool fromline)
{
   POINT pMenu;
   int   id;
   POINT PriorCurPos;                //   12-2-96
   int4   menuvalold;                // Highlight the previous selection   12-16-96

   GetCursorPos( &PriorCurPos );     //   12-2-96

   menuvalold = FindWhichLineType(OldType);//

   if (GameVersion == 3)
   {   id = IDS_MENULINETYPEH;      //   3-1-98
   }
   else
   if (GameVersion == 4)
   {   id = IDS_MENULINETYPEHX;
   }
   else
   if (GameVersion == 5)
   {   id = IDS_MENULINETYPESTRIFE;  //   7-1-97
   }
   else
   {   //  id = IDS_MENULINETYPED;
       if (BOOMSupport)
       {   strncpy(DoomLineDefList[23].name+5,"BO",2);
       }
       else
       {   strncpy(DoomLineDefList[23].name+5,"xx",2);
       }

       if (menuvalold > 13)   // skip over middle separator for BOOM/NEW
       {   menuvalold++;      //
       }

   }

   pMenu.x = left;
   pMenu.y = top;

   if(pMenu.x < 0)  pMenu.x = 0;
   if(pMenu.y < 0)  pMenu.y = 0;     //   12-2-96 ??

   if (GameVersion > 2)
   {   HandlePopupMenu(hwnd, id, pMenu, TRUE, menuvalold-1 ); // Set Cursor Position
   }
   else
   {   DisplayPopMenu(hwnd, pMenu, TRUE, DoomLineDefList, menuvalold-1);  // create dynamic popup (can do all later)
   }

   SetCursorPos( PriorCurPos.x,PriorCurPos.y );           //   12-2-96

}

////////////////////////////////////////////////////////////////////////
//  Similar to above, except for the SectorMenu
////////////////////////////////////////////////////////////////////////

static void HandleSectorTypeMenu(HWND hwnd)
{
   POINT pMenu;
   int   id;
   int4   menuvalold;           // Highlight the previous selection   12-16-96
   //Trace(NULL,10,4,"old=%hd",OldType);
   menuvalold = FindWhichSectorType(OldType);        //

	//id = IDS_MENUSECTORTYPED;                         // doom & Doom2

	if (GameVersion == 3)  id = IDS_MENUSECTORTYPEH;  // Heretic
	if (GameVersion == 4)  id = IDS_MENUSECTORTYPEHX; // Hexen
	if (GameVersion == 5)  id = IDS_MENUSECTORTYPES;  // Strife

   pMenu.x = rcSectorMenu.left+44;       //   12-2-96
   pMenu.y = rcSectorMenu.top+4;         //   12-2-96

   if (GameVersion > 2)
   {   HandlePopupMenu(hwnd, id, pMenu, TRUE, menuvalold-1); // Set Cursor Position
   }
   else
   {
       if (BOOMSupport)
       {   strncpy(DoomSectorList[5].name+5,"BO",2);
       }
       else
       {   strncpy(DoomSectorList[5].name+5,"xx",2);
       }

      DisplayPopMenu(hwnd, pMenu, TRUE, DoomSectorList, menuvalold-1);  // create dynamic popup (can do all later)
   }
}
////////////////////////////////////////////////////////////////////////////////

static int2   gwhichside;
static SelPtr gsdlist = NULL;
static SelPtr gldlist = NULL;
HWND hAlignwnd;

int2 LineDefSort(SelPtr sidelist, int2 TotalSide); // this is in OBJECTS.C
SelPtr ReverseList(SelPtr list);

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//                     Texture   Align  Code for Dialogs & Preview            //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// shows the 3 Textures in the Preview Window with offset                     //
////////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------
static void ShowTextureAlignBoth (HDC hdc,char *ShowTexName1,char *ShowTexName2,char *ShowTexName3,
                                  int2 xvalue,// CHANGED THIS !!!!!!
                                  int2 yvalue)// used to be X or Y depending
{
//   int2   FrameXlocS ;
//   int2   FrameYlocS ;
   //---------------------------------------------------------------------

   XoffAlign = xvalue;
   YoffAlign = yvalue;

//   FrameXlocS = 0;           // X and Y start
//   FrameYlocS = 0;

   // top box                         // also set in Lbutton double click
   FrameXlocS1 = 0;//FrameXlocS;
   FrameYlocS1 = 0;//FrameYlocS;
   FrameXlocE1 =int2(FrameXlocS1+256);
   FrameYlocE1 =int2(FrameYlocS1+128);
   // middle box
   FrameYlocS2 =int2(FrameYlocE1+18);//FrameFontSize;
   FrameYlocE2 =int2(FrameYlocS2+128);
   // bottom box
   FrameYlocS3 =int2(FrameYlocE2+18);//FrameFontSize;
   FrameYlocE3 =int2(FrameYlocS3+128);
   //----------------------------------------------------------------

   if (FirstAlign)
   {   FirstAlign=FALSE;
       oldXoffAlign = ! XoffAlign;
       oldYoffAlign = ! YoffAlign;
   }

   // if aligment changes - redisplay them again
   if (oldXoffAlign != XoffAlign  ||  oldYoffAlign != YoffAlign)
   {   oldXoffAlign = XoffAlign;
       oldYoffAlign = YoffAlign;
   }

   //-----------------------Upper----------------------------------------------
     DisplayATexture( hdc, FrameXlocS1,FrameYlocS1, FrameXlocE1,FrameYlocE1,
                      XoffAlign,YoffAlign, ShowTexName1, NULL);  // UPPER
   //-----------------------Normal----------------------------------------------
     DisplayATexture( hdc,FrameXlocS1,FrameYlocS2, FrameXlocE1,FrameYlocE2,
                      XoffAlign,YoffAlign, ShowTexName3, NULL); // Normal
   //-----------------------Lower----------------------------------------------
     DisplayATexture( hdc, FrameXlocS1,FrameYlocS3, FrameXlocE1,FrameYlocE3,
                      XoffAlign,YoffAlign, ShowTexName2, NULL);  // LOWER
}


//------------------------------------------------------------------------
//  for Texture show all Align
//------------------------------------------------------------------------
static void ShowMultiTextureAlign(HDC hdc,int2 xstart,int2 ystart, int2 xend, int4 length,
                      char *ShowTexName1,char *ShowTexName2,char *ShowTexName3)
{
   WadFiles TextureWad;     // the texture directory (usually MasterWad)
   int2     xsize;          // width in pixels of texture
   int2     ysize;          // height in pixels of texture
   int2     patchnum;       // number of wall patches used to build this texture
   byte    *texofs;         // offset in the wad file to the texture data

   int2     Xwrksize;       // length of texture work
   int2     Ywrksize;       // height of texture work
   int2     XleftOver;      // length display texture work
   int2     YleftOver;      // height display texture work
   int2     XdrawLength;    // display box size
   int2     FrameXstart;

   int2     FrameXlocS ;
   int2     FrameXlocE ;
   int2     FrameYlocS ;

   //---------------------------------------------------------------------
   if (length <=0) return;

   // big box
   FrameXlocS = xstart;                        //
   FrameXlocE = xend;
   FrameYlocS = ystart;                             // 1
   // top box
   FrameYlocS1 =FrameYlocS;
   FrameYlocE1 =int2(FrameYlocS1+128);
   // middle box
   FrameYlocS2 =FrameYlocE1;
   FrameYlocE2 =int2(FrameYlocS2+128);
   // bottom box
   FrameYlocS3 =FrameYlocE2;
   FrameYlocE3 =int2(FrameYlocS3+128);

   // see what the maximum display length is
   if (length > 256)
   {   XdrawLength= 256;
   }
   else
   {   XdrawLength= int2(length);
   }

   if (FrameXlocS +XdrawLength > FrameXlocE )
   {   XdrawLength = int2(FrameXlocE - FrameXlocS);
   }

   //-----------------------Upper----------------------------------------------
   if (ShowTexName1[0] != '-'     //  text
   &&  GetWallTextureSize( &TextureWad, &xsize, &ysize,
  	                   &patchnum,   &texofs,ShowTexName1)
   &&  xsize > 0 && ysize > 0) // safety
   {
       // fill in till 256 covered or till length of line reached
       Xwrksize    = XdrawLength;      // max line (or this box)
       Ywrksize    = 128;              // fixed for now at this
       FrameXstart = FrameXlocS;       // where to start
       XleftOver   = xsize;
       YleftOver   = ysize;

       if  (XleftOver > XdrawLength)
       {    XleftOver = XdrawLength;
       }

       if  (YleftOver > 128)
       {    XleftOver = 128;
       }

       for ( ; Xwrksize > 0; Xwrksize -=xsize )
       {
             if (Xwrksize < XleftOver)
             {   XleftOver = Xwrksize;   // total space left to display
             }

             DisplayATexture( hdc,FrameXstart,      FrameYlocS1,
                              int2(FrameXstart+XleftOver),int2(FrameYlocS1+YleftOver),
                              XoffAlign,YoffAlign,
                              ShowTexName1,"+");  // UPPER -no info shown

             FrameXstart+=XleftOver;               // next offset
       }

       // now see if Y height has room left to show
       Ywrksize -=YleftOver;

       if (YleftOver < 128)
       {
           for (;Ywrksize > 0; Ywrksize -=ysize)
           {
              FrameYlocS1+=YleftOver;         // increment last amount displayed

              if (Ywrksize < YleftOver)
              {   YleftOver = Ywrksize;       // total space left to display
              }

              Xwrksize    = XdrawLength;      // max line (or this box)
              FrameXstart = FrameXlocS;       // where to start
              XleftOver   = xsize;

              if  (XleftOver > XdrawLength)
              {    XleftOver = XdrawLength;
              }

              for ( ; Xwrksize > 0; Xwrksize -=xsize)
              {
                  if (Xwrksize < XleftOver)
                  {   XleftOver = Xwrksize;   // total space left to display
                  }

                  DisplayATexture( hdc,FrameXstart,          FrameYlocS1,
                                   int2(FrameXstart+XleftOver),int2(FrameYlocS1+YleftOver),
                                   XoffAlign,YoffAlign,
                                   ShowTexName1,"+");  // UPPER -no info shown

                   FrameXstart+=XleftOver;               // next offset
              }

           }
       }
   }

   //-----------------------Normal----------------------------------------------

   if (ShowTexName3[0] != '-'   // text
   &&  GetWallTextureSize( &TextureWad, &xsize, &ysize,
    		           &patchnum,   &texofs,ShowTexName3)
   &&  xsize > 0 && ysize > 0) // safety
   {
        // fill in till 256 covered or till length of line reached
        Xwrksize    = XdrawLength;      // max line (or this box)
        Ywrksize    = 128;              // fixed for now at this
        FrameXstart = FrameXlocS;       // where to start
        XleftOver   = xsize;
        YleftOver   = ysize;

        if  (XleftOver > XdrawLength)
        {    XleftOver = XdrawLength;
        }
        if  (YleftOver > 128)
        {    XleftOver = 128;
        }

        for ( ; Xwrksize > 0; Xwrksize -=xsize)
        {
              if (Xwrksize < XleftOver)
              {   XleftOver = Xwrksize;   // total space left to display
              }

              DisplayATexture( hdc,FrameXstart,          FrameYlocS2,
                               int2(FrameXstart+XleftOver),int2(FrameYlocS2+YleftOver),
                               XoffAlign,YoffAlign,
                               ShowTexName3,"+");  // UPPER -no info shown

              FrameXstart+=XleftOver;               // next offset
        }

        // now see if Y height has room left to show
        Ywrksize -=YleftOver;

        if (YleftOver < 128)
        {
           for (;Ywrksize > 0; Ywrksize -=ysize)
           {
              FrameYlocS2+=YleftOver;         // increment last amount displayed

              if (Ywrksize < YleftOver)
              {   YleftOver = Ywrksize;       // total space left to display
              }

              Xwrksize    = XdrawLength;      // max line (or this box)
              FrameXstart = FrameXlocS;       // where to start
              XleftOver   = xsize;

              if  (XleftOver > XdrawLength)
              {    XleftOver = XdrawLength;
              }

              for ( ; Xwrksize > 0; Xwrksize -=xsize)
              {
                  if (Xwrksize < XleftOver)
                  {   XleftOver = Xwrksize;   // total space left to display
                  }

                  DisplayATexture( hdc,FrameXstart,          FrameYlocS2,
                                   int2(FrameXstart+XleftOver),int2(FrameYlocS2+YleftOver),
                                   XoffAlign,YoffAlign,
                                   ShowTexName3,"+");  // UPPER -no info shown

                  FrameXstart+=XleftOver;              // next offset
              }

           }
        }
   }

   //-----------------------Lower----------------------------------------------

   if (ShowTexName2[0] != '-'   // text
   &&  GetWallTextureSize( &TextureWad, &xsize, &ysize,
		           &patchnum,   &texofs,ShowTexName2)
   &&  xsize > 0 && ysize > 0) // safety
   {
        // fill in till 256 covered or till length of line reached
        Xwrksize    = XdrawLength;      // max line (or this box)
        Ywrksize    = 128;              // fixed for now at this
        FrameXstart = FrameXlocS;       // where to start
        XleftOver   = xsize;
        YleftOver   = ysize;

        if  (XleftOver > XdrawLength)
        {    XleftOver = XdrawLength;
        }

        if  (YleftOver > 128)
        {    XleftOver = 128;
        }

        for ( ; Xwrksize > 0; Xwrksize -=xsize)
        {
              if (Xwrksize < XleftOver)
              {   XleftOver = Xwrksize;   // total space left to display
              }

              DisplayATexture( hdc,FrameXstart,          FrameYlocS3,
                               int2(FrameXstart+XleftOver),int2(FrameYlocS3+YleftOver),
                               XoffAlign,YoffAlign,
                               ShowTexName2,"+");  // UPPER -no info shown

              FrameXstart+=XleftOver;               // next offset
        }

        // now see if Y height has room left to show
        Ywrksize -=YleftOver;

        if (YleftOver < 128)
        {
           for (;Ywrksize > 0; Ywrksize -=ysize)
           {
              FrameYlocS3+=YleftOver;         // increment last amount displayed

              if (Ywrksize < YleftOver)
              {   YleftOver = Ywrksize;       // total space left to display
              }

              Xwrksize    = XdrawLength;      // max line (or this box)
              FrameXstart = FrameXlocS;       // where to start
              XleftOver   = xsize;

              if  (XleftOver > XdrawLength)
              {    XleftOver = XdrawLength;
              }

              for ( ; Xwrksize > 0; Xwrksize -=xsize)
              {
                  if (Xwrksize < XleftOver)
                  {   XleftOver = Xwrksize;   // total space left to display
                  }

                  DisplayATexture( hdc,FrameXstart,          FrameYlocS3,
                                   int2(FrameXstart+XleftOver),int2(FrameYlocS3+YleftOver),
                                   XoffAlign,YoffAlign,
                                   ShowTexName2,"+");  // UPPER -no info shown

                  FrameXstart+=XleftOver;              // next offset
              }

           }
        }
   }
}

///////////////////  Alignment Window Routines  ////////////////////////////////
//                                                                            //


//////////////////////////////////////
// WM_CREATE
//////////////////////////////////////
#pragma argsused
static BOOL Align_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
   return TRUE;			// No, didn't create - so Windows won't display
}

  // both of these are from OBJECTS.C  (temp,move later)
   // this sorts linedefs in sequence


////////////////////////////////////
// Handle WM_PAINT: Paint
//////////////////////////////////////
static void Align_OnPaint(HWND hwnd)
{
 PAINTSTRUCT ps;
 HPALETTE hOldPal;
 HDC    hdc;
 int2   FrameXstart;
 int2   FrameXlocS ;
 int2   FrameXlocE ;
 int2   FrameYlocS ;
 int2   FrameYlocE ;
 char   msg[120]  = "LDs: ";
 char   wrkmsg[6];
 SelPtr newldlist= NULL;
 LevelPtr level = &LevelWad.level;
 LDPtr  ActiveLineDef;
 int2   tstart,tend;
 int4   dist;
 SelPtr cur1;
 SelPtr cur2;
 int2   sd1,sd2;
 HFONT  hOldFont;

   hdc = BeginPaint(hwnd, &ps);

  	hOldPal = SelectPalette(hdc, gd.hDoomPal, FALSE);
  	RealizePalette(hdc);

   // this reverses sequence so Side1 is in the right sequence
   if (gwhichside== 1)
   {   newldlist  = ReverseList(gldlist);
   }
   else
   {   newldlist = gldlist;
   }

   FrameXlocS = 0;
   FrameXlocE = (ScrMaxX-1);
   FrameYlocS = 0;                       // 8 = FrameFontSize ?
   FrameYlocE = (FrameYlocS+ (3*128) );  // for 3 pictures + 3 text x by y
   FrameXstart= (FrameXlocS);            // Room for the FRAME

   //for (cur1 = gsdlist, cur2 = gldlist; cur1 && cur2 ; cur1 = cur1->next, cur2 = cur2->next)
   for (cur2 = newldlist; cur2 ; cur2 = cur2->next)
   {    // match up sidedef to this linedef since sort can move it
        ActiveLineDef = &level->LineDefs[cur2->objnum];
        sd1    = ActiveLineDef->sidedef1;
        sd2    = ActiveLineDef->sidedef2;
        tstart = ActiveLineDef->start;
        tend   = ActiveLineDef->end;

        for (cur1 = gsdlist; cur1; cur1 = cur1->next)
        {    if (cur1->objnum == sd1
             ||  cur1->objnum == sd2)
             {   break;
             }
        }

        if (!cur1) continue;   // caused by -1 in sidedefs

	     strncpy( ShowTexName1, level->SideDefs[ cur1->objnum].tex1, 8); // upper
	     strncpy( ShowTexName3, level->SideDefs[ cur1->objnum].tex3, 8); // normal
	     strncpy( ShowTexName2, level->SideDefs[ cur1->objnum].tex2, 8); // lower

        XoffAlign =level->SideDefs[ cur1->objnum].xoff;
        YoffAlign =level->SideDefs[ cur1->objnum].yoff;

        dist = hypot( (double) (level->Vertexes[tend].x - level->Vertexes[tstart].x),
 		                (double) (level->Vertexes[tend].y - level->Vertexes[tstart].y));

        ShowMultiTextureAlign(hdc, FrameXstart, FrameYlocS, FrameXlocE, dist,
                           ShowTexName1,ShowTexName2,ShowTexName3);

        // shift over for next texture
        if (dist > 256)
        {   FrameXstart += (256);
        }
        else
        {   FrameXstart += (dist);
        }

        // see if enough room to store reference
        if ( strlen(msg)*8 < FrameYlocE-52)
        {    sprintf (wrkmsg,"%hd ",cur2->objnum);       // LineDef number
             strcat (msg,wrkmsg);
        }
        if (FrameXstart >= FrameXlocE-7) break;
   }

   if (gwhichside== 1)
   {   ForgetSelection(&newldlist);
   }

   SetBkMode(hdc, TRANSPARENT);
   hOldFont = SelectFont(hdc,  gd.hStockFont);//GetStockFont(ANSI_VAR_FONT) );
   DrawScreenTextOutline( hdc, int2(FrameXlocS+16), int2(FrameYlocE-12),0,MenuInfoColor,msg);

   if(hOldPal) SelectPalette(hdc, hOldPal, FALSE);
   SelectFont(hdc, hOldFont);
   EndPaint(hwnd, &ps);
}

//=======================================================================
#pragma argsused
static void Align_OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
	DestroyWindow(hwnd);
}
#pragma argsused
static void Align_OnLBDown(HWND hwnd, BOOL fdc, int x, int y, UINT kFlag)
{
	DestroyWindow(hwnd);
}
////////////////////////////////////////////////////////////////////////////
// AlignWndProc (deep.cpp uses_
////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK AlignWndProc(HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  switch(Msg)
  {
	 HANDLE_MSG(hwnd, WM_CREATE,     Align_OnCreate);
	 HANDLE_MSG(hwnd, WM_PAINT,      Align_OnPaint);
	 HANDLE_MSG(hwnd, WM_KEYDOWN,    Align_OnKey);
	 HANDLE_MSG(hwnd, WM_LBUTTONDOWN,Align_OnLBDown);

	 default:
		return Align_DefProc(hwnd, Msg, wParam,lParam);
  }
}

//-----------------------------------------------------------------------------------
//  show multiple selected linedef textures across screen (quickie)
//-----------------------------------------------------------------------------------
#pragma argsused
static void MultiAlignShow(HWND hwnd, SelPtr ldlist, SelPtr sdlist,int2 whichside)
{
   SelPtr cur2;
   int2   key;
   int2   TotalSideA=0;
   int2   TotalSideB;
   int    width;
   int    height;

   //---------------------------------------------------------------------------

   for ( cur2=ldlist; cur2; cur2=cur2->next ) TotalSideA++;   // count #selected

   TotalSideB = LineDefSort(ldlist,TotalSideA);

   if ( TotalSideA != TotalSideB )
   {
        key =  HelpMsg(hwnd,CENTER|HELPERROR, "Attention",
                               "LineDefs selected are not all",
                               "connected or are not all going",
                               "the same direction.",
                               " ",
                               "Continue display?",
                               NULL);
        //key =  MsgInfoBox(hwnd, "!! Attention !!",
        //             " "," ","LineDefs selected are not all",
        //                     "connected or are not all going",
        //                     "the same direction.",
        //             " ",    "Continue display?");

        if (key == FALSE) return;   //   3-1-97
   }

   //store our pointers globally for access by Paint
   gwhichside = whichside;
   gldlist    = ldlist;
   gsdlist    = sdlist;

   width  = GetSystemMetrics(SM_CXSCREEN)- 2;
   height = (128*3)+ 16;

   // Create our window                     // 56 is Center Y on 640x480
	hAlignwnd =	CreateWindow(szLoadString(IDS_ALIGNNAME),
                            szLoadString(IDS_ALIGNNAME),
                            WS_POPUP | WS_VISIBLE | WS_THICKFRAME | WS_CAPTION,
                            1,
                            56,
                            width,
                            height,
                            hwnd,
                            NULL,
                            gd.hInst,
                            NULL);

   SetFocus(hAlignwnd); // Need keyboard focus for DestroyWindow()

               // Continues above - Align_OnPaint
}



//////////////////////////////////////////////////////////////////////////////
//  The Deep Stair Type Dialog
//
//  Returns 1  for Staight Stairs
//  Returns 2  for Curved Stairs
//          3  for cancel
/////////////////////////////////////////////////////////////////////////////
#pragma argsused

// EndDialog(hDlg, RETURNCODE );
BOOL CALLBACK StairTypeDlgProc(DIALOG_PARAMS)
{
////Trace(NULL,10,4,"cmd = %d, wparam = %hd ",msg,LOWORD(wParam));

  ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

  switch(msg)
  {
	 case WM_INITDIALOG:
	   return FALSE; // or FALSE if we set our own focus

	 case WM_COMMAND:
		switch LOWORD(wParam)
      {
        case psh1:
		  	EndDialog(hDlg, psh1);
		   return TRUE;
        case psh2:
		  	EndDialog(hDlg, psh2);
		   return TRUE;
        case psh3:
		  	EndDialog(hDlg, psh3);
		   return TRUE;
      }
	   break;

	 case 260:                                 // whatever that is couldn't find
      if (LOWORD(wParam) == 27)               // escape   3-1-97
		{   EndDialog(hDlg, psh3);
		    return TRUE;
      }
  }
  return FALSE;
}




//////////////////////////////////////////////////////////////////////////////
//  The Deep angle help box modeless
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
static BOOL CALLBACK AngleDlgProc(DIALOG_PARAMS)
{
   ScreenSaverTimer = 0;                     // reset screensaver timer   8-1-97

   switch (msg)
   {
      case WM_INITDIALOG:

         RECT  rc;                                 //   12-16-96
         int  width,height;                        // and the rest
         GetWindowRect(hDlg,&rc);
         width     = rc.right - rc.left +1;        // find Width
         height    = rc.bottom - rc.top +1;        // find Height
         rc.left  -=(width+80);
         rc.top   -= height;
         MoveWindow(hDlg,rc.left, rc.top, width,height, FALSE);
      return TRUE;

   case WM_DESTROY:
      return TRUE;

   default:
      break;
      }
  return FALSE;
}
///////////////////////////////   end   ///////////////////////////////////////

